/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],R=0,L=K.length;R<L;R++)e[R]=Z[K[R]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function L(n){const w=[];for(let f in n)R.call(n,f)&&w.push(n[f]);return w}e.values=L;function D(n,w){for(let f in n)if(R.call(n,f)&&w({key:f,value:n[f]},function(){delete n[f]})===!1)return}e.forEach=D;function T(n,w){const f=Object.create(null);for(const d of n){const l=w(d);let y=f[l];y||(y=f[l]=[]),y.push(d)}return f}e.groupBy=T;function A(n){const w=Object.create(null);return n&&n.forEach((f,d)=>{w[d]=f}),w}e.fromMap=A;function P(n,w){const f=[],d=[];for(let l of n)w.has(l)||f.push(l);for(let l of w)n.has(l)||d.push(l);return{removed:f,added:d}}e.diffSets=P;function p(n,w){const f=[],d=[];for(let[l,y]of n)w.has(l)||f.push(y);for(let[l,y]of w)n.has(l)||d.push(y);return{removed:f,added:d}}e.diffMaps=p;class E{constructor(){this.map=new Map}add(w,f){let d=this.map.get(w);d||(d=new Set,this.map.set(w,d)),d.add(f)}delete(w,f){const d=this.map.get(w);!d||(d.delete(f),d.size===0&&this.map.delete(w))}forEach(w,f){const d=this.map.get(w);!d||d.forEach(f)}}e.SetMap=E}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(P,p,E)=>{let n=null,w=null;if(typeof E.value=="function"?(n="value",w=E.value):typeof E.get=="function"&&(n="get",w=E.get),!w)throw new Error("not supported");E[n]=A(w,p)}}e.createDecorator=R;function L(A,P,p){let E=null,n=null;if(typeof p.value=="function"?(E="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",n=p.get),!n)throw new Error("not supported");const w=`$memoize$${P}`;p[E]=function(...f){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,f)}),this[w]}}e.memoize=L;function D(A,P,p){return R((E,n)=>{const w=`$debounce$${n}`,f=`$debounce$result$${n}`;return function(...d){this[f]||(this[f]=p?p():void 0),clearTimeout(this[w]),P&&(this[f]=P(this[f],...d),d=[this[f]]),this[w]=setTimeout(()=>{E.apply(this,d),this[f]=p?p():void 0},A)}})}e.debounce=D;function T(A,P,p){return R((E,n)=>{const w=`$throttle$timer$${n}`,f=`$throttle$result$${n}`,d=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...y){if(this[f]||(this[f]=p?p():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...y)),this[l])return;const I=this[d]+A;I<=Date.now()?(this[d]=Date.now(),E.apply(this,[this[f]]),this[f]=p?p():void 0):(this[l]=!0,this[w]=setTimeout(()=>{this[l]=!1,this[d]=Date.now(),E.apply(this,[this[f]]),this[f]=p?p():void 0},I-Date.now()))}})}e.throttle=T}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=R,e.errorHandler=new R;function L(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=L;function D(o){p(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=D;function T(o){p(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=T;function A(o){if(o instanceof Error){let{name:t,message:r}=o;const i=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:i}}return o}e.transformErrorForSerialization=A;const P="Canceled";function p(o){return o instanceof Error&&o.name===P&&o.message===P}e.isPromiseCanceledError=p;class E extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=E;function n(){const o=new Error(P);return o.name=o.message,o}e.canceled=n;function w(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=w;function f(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=f;function d(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function l(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function y(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=y;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function v(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function s(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=s}),define(Z[23],ee([0,1,11]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(_,G=0){return _[_.length-(1+G)]}e.tail=L;function D(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=D;function T(_,G,B=(X,Q)=>X===Q){if(_===G)return!0;if(!_||!G||_.length!==G.length)return!1;for(let X=0,Q=_.length;X<Q;X++)if(!B(_[X],G[X]))return!1;return!0}e.equals=T;function A(_,G,B){let X=0,Q=_.length-1;for(;X<=Q;){const ie=(X+Q)/2|0,ne=B(_[ie],G);if(ne<0)X=ie+1;else if(ne>0)Q=ie-1;else return ie}return-(X+1)}e.binarySearch=A;function P(_,G){let B=0,X=_.length;if(X===0)return 0;for(;B<X;){const Q=Math.floor((B+X)/2);G(_[Q])?X=Q:B=Q+1}return B}e.findFirstInSorted=P;function p(_,G,B){if(_=_|0,_>=G.length)throw new TypeError("invalid index");let X=G[Math.floor(G.length*Math.random())],Q=[],ie=[],ne=[];for(let le of G){const fe=B(le,X);fe<0?Q.push(le):fe>0?ie.push(le):ne.push(le)}return _<Q.length?p(_,Q,B):_<Q.length+ne.length?ne[0]:p(_-(Q.length+ne.length),ie,B)}e.quickSelect=p;function E(_,G){const B=[];let X;for(const Q of _.slice(0).sort(G))!X||G(X[0],Q)!==0?(X=[Q],B.push(X)):X.push(Q);return B}e.groupBy=E;function n(_,G,B){const X=[];function Q(le,fe,ye){if(fe===0&&ye.length===0)return;const Se=X[X.length-1];Se&&Se.start+Se.deleteCount===le?(Se.deleteCount+=fe,Se.toInsert.push(...ye)):X.push({start:le,deleteCount:fe,toInsert:ye})}let ie=0,ne=0;for(;;){if(ie===_.length){Q(ie,0,G.slice(ne));break}if(ne===G.length){Q(ie,_.length-ie,[]);break}const le=_[ie],fe=G[ne],ye=B(le,fe);ye===0?(ie+=1,ne+=1):ye<0?(Q(ie,1,[]),ie+=1):ye>0&&(Q(ie,0,[fe]),ne+=1)}return X}e.sortedDiff=n;function w(_,G,B){const X=n(_,G,B),Q=[],ie=[];for(const ne of X)Q.push(..._.slice(ne.start,ne.start+ne.deleteCount)),ie.push(...ne.toInsert);return{removed:Q,added:ie}}e.delta=w;function f(_,G,B){if(B===0)return[];const X=_.slice(0,B).sort(G);return l(_,G,X,B,_.length),X}e.top=f;function d(_,G,B,X,Q){return B===0?Promise.resolve([]):new Promise((ie,ne)=>{(async()=>{const le=_.length,fe=_.slice(0,B).sort(G);for(let ye=B,Se=Math.min(B+X,le);ye<le;ye=Se,Se=Math.min(Se+X,le)){if(ye>B&&await new Promise(Pe=>setTimeout(Pe)),Q&&Q.isCancellationRequested)throw(0,R.canceled)();l(_,G,fe,ye,Se)}return fe})().then(ie,ne)})}e.topAsync=d;function l(_,G,B,X,Q){for(const ie=B.length;X<Q;X++){const ne=_[X];if(G(ne,B[ie-1])<0){B.pop();const le=P(B,fe=>G(ne,fe)<0);B.splice(le,0,ne)}}}function y(_){return _.filter(G=>!!G)}e.coalesce=y;function I(_){let G=0;for(let B=0;B<_.length;B++)_[B]&&(_[G]=_[B],G+=1);_.length=G}e.coalesceInPlace=I;function b(_,G,B){_.splice(B,0,_.splice(G,1)[0])}e.move=b;function C(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=C;function v(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=v;function s(_,G){if(!G)return _.filter((X,Q)=>_.indexOf(X)===Q);const B=Object.create(null);return _.filter(X=>{const Q=G(X);return B[Q]?!1:(B[Q]=!0,!0)})}e.distinct=s;function o(_){const G=new Set;return _.filter(B=>G.has(B)?!1:(G.add(B),!0))}e.distinctES6=o;function t(_){const G=Object.create(null);return B=>{const X=_(B);return G[X]?!1:(G[X]=!0,!0)}}e.uniqueFilter=t;function r(_,G){for(let B=_.length-1;B>=0;B--){const X=_[B];if(G(X))return B}return-1}e.lastIndex=r;function i(_,G){return _.length>0?_[0]:G}e.firstOrDefault=i;function a(_,G,B=(X,Q)=>X===Q){let X=0;for(let Q=0,ie=Math.min(_.length,G.length);Q<ie&&B(_[Q],G[Q]);Q++)X++;return X}e.commonPrefixLength=a;function h(_){return[].concat(..._)}e.flatten=h;function c(_,G){let B=typeof G=="number"?_:0;typeof G=="number"?B=_:(B=0,G=_);const X=[];if(B<=G)for(let Q=B;Q<G;Q++)X.push(Q);else for(let Q=B;Q>G;Q--)X.push(Q);return X}e.range=c;function u(_,G,B){return _.reduce((X,Q)=>(X[G(Q)]=B?B(Q):Q,X),Object.create(null))}e.index=u;function g(_,G){return _.push(G),()=>S(_,G)}e.insert=g;function S(_,G){const B=_.indexOf(G);if(B>-1)return _.splice(B,1),G}e.remove=S;function m(_,G,B){const X=_.slice(0,G),Q=_.slice(G);return X.concat(B,Q)}e.arrayInsert=m;function k(_,G){let B;if(typeof G=="number"){let X=G;B=()=>{const Q=Math.sin(X++)*179426549;return Q-Math.floor(Q)}}else B=Math.random;for(let X=_.length-1;X>0;X-=1){const Q=Math.floor(B()*(X+1)),ie=_[X];_[X]=_[Q],_[Q]=ie}}e.shuffle=k;function O(_,G){const B=_.indexOf(G);B>-1&&(_.splice(B,1),_.unshift(G))}e.pushToStart=O;function x(_,G){const B=_.indexOf(G);B>-1&&(_.splice(B,1),_.push(G))}e.pushToEnd=x;function z(_,G){return Array.isArray(_)?_.map(G):G(_)}e.mapArrayOrNot=z;function H(_){return Array.isArray(_)?_:[_]}e.asArray=H;function V(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=V;function U(_,G){for(const B of _){const X=G(B);if(X!==void 0)return X}}e.mapFind=U;function $(_,G,B){const X=N(_,G),Q=_.length,ie=B.length;_.length=Q+ie;for(let ne=Q-1;ne>=X;ne--)_[ne+ie]=_[ne];for(let ne=0;ne<ie;ne++)_[ne+X]=B[ne]}e.insertInto=$;function M(_,G,B,X){const Q=N(_,G),ie=_.splice(Q,B);return $(_,Q,X),ie}e.splice=M;function N(_,G){return G<0?Math.max(G+_.length,0):Math.min(G,_.length)}function q(_,G){let B=Number.MAX_SAFE_INTEGER,X=0;return _.forEach((Q,ie)=>{const ne=G(Q);ne<B&&(B=ne,X=ie)}),X}e.minIndex=q;function F(_,G){let B=Number.MIN_SAFE_INTEGER,X=0;return _.forEach((Q,ie)=>{const ne=G(Q);ne>B&&(B=ne,X=ie)}),X}e.maxIndex=F;class j{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let B=this.firstIdx;for(;B<this.items.length&&G(this.items[B]);)B++;const X=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,X}takeFromEndWhile(G){let B=this.lastIdx;for(;B>=0&&G(this.items[B]);)B--;const X=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,X}}e.ArrayQueue=j}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(L){const D=this;let T=!1,A;return function(){return T||(T=!0,A=L.apply(D,arguments)),A}}e.once=R}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}L.is=D;const T=Object.freeze([]);function A(){return T}L.empty=A;function*P(o){yield o}L.single=P;function p(o){return o||T}L.from=p;function E(o){return!o||o[Symbol.iterator]().next().done===!0}L.isEmpty=E;function n(o){return o[Symbol.iterator]().next().value}L.first=n;function w(o,t){for(const r of o)if(t(r))return!0;return!1}L.some=w;function f(o,t){for(const r of o)if(t(r))return r}L.find=f;function*d(o,t){for(const r of o)t(r)&&(yield r)}L.filter=d;function*l(o,t){let r=0;for(const i of o)yield t(i,r++)}L.map=l;function*y(...o){for(const t of o)for(const r of t)yield r}L.concat=y;function*I(o){for(const t of o)for(const r of t)yield r}L.concatNested=I;function b(o,t,r){let i=r;for(const a of o)i=t(i,a);return i}L.reduce=b;function*C(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}L.slice=C;function v(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const i=o[Symbol.iterator]();for(let a=0;a<t;a++){const h=i.next();if(h.done)return[r,L.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=v;function s(o,t,r=(i,a)=>i===a){const i=o[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const h=i.next(),c=a.next();if(h.done!==c.done)return!1;if(h.done)return!0;if(!r(h.value,c.value))return!1}}L.equals=s})(R=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,a=t.length,h="",c=0,u=16,g=0;function S(V){let U=0,$=0;for(;U<V;){const M=t.charCodeAt(i);if(M>=48&&M<=57)$=$*16+M-48;else if(M>=65&&M<=70)$=$*16+M-65+10;else if(M>=97&&M<=102)$=$*16+M-97+10;else break;i++,U++}return U<V&&($=-1),$}function m(V){i=V,h="",c=0,u=16,g=0}function k(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&E(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&E(t.charCodeAt(i)))for(i++;i<t.length&&E(t.charCodeAt(i));)i++;else return g=3,t.substring(V,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&E(t.charCodeAt(i))){for(i++;i<t.length&&E(t.charCodeAt(i));)i++;U=i}else g=3;return t.substring(V,U)}function O(){let V="",U=i;for(;;){if(i>=a){V+=t.substring(U,i),g=2;break}const $=t.charCodeAt(i);if($===34){V+=t.substring(U,i),i++;break}if($===92){if(V+=t.substring(U,i),i++,i>=a){g=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const N=S(4);N>=0?V+=String.fromCharCode(N):g=4;break;default:g=5}U=i;continue}if($>=0&&$<=31)if(p($)){V+=t.substring(U,i),g=2;break}else g=6;i++}return V}function x(){if(h="",g=0,c=i,i>=a)return c=a,u=17;let V=t.charCodeAt(i);if(P(V)){do i++,h+=String.fromCharCode(V),V=t.charCodeAt(i);while(P(V));return u=15}if(p(V))return i++,h+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,h+=`
`),u=14;switch(V){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,h=O(),u=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!p(t.charCodeAt(i));)i++;return h=t.substring(U,i),u=12}if(t.charCodeAt(i+1)===42){i+=2;const $=a-1;let M=!1;for(;i<$;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,M=!0;break}i++}return M||(i++,g=1),h=t.substring(U,i),u=13}return h+=String.fromCharCode(V),i++,u=16;case 45:if(h+=String.fromCharCode(V),i++,i===a||!E(t.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=k(),u=11;default:for(;i<a&&z(V);)i++,V=t.charCodeAt(i);if(c!==i){switch(h=t.substring(c,i),h){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return h+=String.fromCharCode(V),i++,u=16}}function z(V){if(P(V)||p(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let V;do V=x();while(V>=12&&V<=15);return V}return{setPosition:m,getPosition:()=>i,scan:r?H:x,getToken:()=>u,getTokenValue:()=>h,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>g}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function w(t,r){const i=[],a=new Object;let h;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(S,m,k,O){c.value=S,c.offset=m,c.length=k,c.type=O,c.colonOffset=void 0,h=c}try{v(t,{onObjectBegin:(S,m)=>{if(r<=S)throw a;h=void 0,u=r>S,i.push("")},onObjectProperty:(S,m,k)=>{if(r<m||(g(S,m,k,"property"),i[i.length-1]=S,r<=m+k))throw a},onObjectEnd:(S,m)=>{if(r<=S)throw a;h=void 0,i.pop()},onArrayBegin:(S,m)=>{if(r<=S)throw a;h=void 0,i.push(0)},onArrayEnd:(S,m)=>{if(r<=S)throw a;h=void 0,i.pop()},onLiteralValue:(S,m,k)=>{if(r<m||(g(S,m,k,o(S)),r<=m+k))throw a},onSeparator:(S,m,k)=>{if(r<=m)throw a;if(S===":"&&h&&h.type==="property")h.colonOffset=m,u=!1,h=void 0;else if(S===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(u=!0,i[i.length-1]=""),h=void 0}}})}catch(S){if(S!==a)throw S}return{path:i,previousNode:h,isAtPropertyKey:u,matches:S=>{let m=0;for(let k=0;m<S.length&&k<i.length;k++)if(S[m]===i[k]||S[m]==="*")m++;else if(S[m]!=="**")return!1;return m===S.length}}}e.getLocation=w;function f(t,r=[],i=T.DEFAULT){let a=null,h=[];const c=[];function u(S){Array.isArray(h)?h.push(S):a!==null&&(h[a]=S)}return v(t,{onObjectBegin:()=>{const S={};u(S),c.push(h),h=S,a=null},onObjectProperty:S=>{a=S},onObjectEnd:()=>{h=c.pop()},onArrayBegin:()=>{const S=[];u(S),c.push(h),h=S,a=null},onArrayEnd:()=>{h=c.pop()},onLiteralValue:u,onError:(S,m,k)=>{r.push({error:S,offset:m,length:k})}},i),h[0]}e.parse=f;function d(t,r=[],i=T.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(S){a.type==="property"&&(a.length=S-a.offset,a=a.parent)}function c(S){return a.children.push(S),S}v(t,{onObjectBegin:S=>{a=c({type:"object",offset:S,length:-1,parent:a,children:[]})},onObjectProperty:(S,m,k)=>{a=c({type:"property",offset:m,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:S,offset:m,length:k,parent:a})},onObjectEnd:(S,m)=>{a.length=S+m-a.offset,a=a.parent,h(S+m)},onArrayBegin:(S,m)=>{a=c({type:"array",offset:S,length:-1,parent:a,children:[]})},onArrayEnd:(S,m)=>{a.length=S+m-a.offset,a=a.parent,h(S+m)},onLiteralValue:(S,m,k)=>{c({type:o(S),offset:m,length:k,parent:a,value:S}),h(m+k)},onSeparator:(S,m,k)=>{a.type==="property"&&(S===":"?a.colonOffset=m:S===","&&h(m))},onError:(S,m,k)=>{r.push({error:S,offset:m,length:k})}},i);const g=a.children[0];return g&&delete g.parent,g}e.parseTree=d;function l(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let h=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===a){i=c.children[1],h=!0;break}if(!h)return}else{const h=a;if(i.type!=="array"||h<0||!Array.isArray(i.children)||h>=i.children.length)return;i=i.children[h]}return i}e.findNodeAtLocation=l;function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=y;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=I(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function C(t,r,i=!1){if(b(t,r,i)){const a=t.children;if(Array.isArray(a))for(let h=0;h<a.length&&a[h].offset<=r;h++){const c=C(a[h],r,i);if(c)return c}return t}}e.findNodeAtOffset=C;function v(t,r,i=T.DEFAULT){const a=A(t,!1);function h(B){return B?()=>B(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(B){return B?X=>B(X,a.getTokenOffset(),a.getTokenLength()):()=>!0}const u=h(r.onObjectBegin),g=c(r.onObjectProperty),S=h(r.onObjectEnd),m=h(r.onArrayBegin),k=h(r.onArrayEnd),O=c(r.onLiteralValue),x=c(r.onSeparator),z=h(r.onComment),H=c(r.onError),V=i&&i.disallowComments,U=i&&i.allowTrailingComma;function $(){for(;;){const B=a.scan();switch(a.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:V||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(B){case 12:case 13:V?M(10):z();break;case 16:M(1);break;case 15:case 14:break;default:return B}}}function M(B,X=[],Q=[]){if(H(B),X.length+Q.length>0){let ie=a.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){$();break}else if(Q.indexOf(ie)!==-1)break;ie=$()}}}function N(B){const X=a.getTokenValue();return B?O(X):g(X),$(),!0}function q(){switch(a.getToken()){case 11:let B=0;try{B=JSON.parse(a.getTokenValue()),typeof B!="number"&&(M(2),B=0)}catch(X){M(2)}O(B);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return $(),!0}function F(){return a.getToken()!==10?(M(3,[],[2,5]),!1):(N(!1),a.getToken()===6?(x(":"),$(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function j(){u(),$();let B=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(B||M(4,[],[]),x(","),$(),a.getToken()===2&&U)break}else B&&M(6,[],[]);F()||M(4,[],[2,5]),B=!0}return S(),a.getToken()!==2?M(7,[2],[]):$(),!0}function _(){m(),$();let B=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(B||M(4,[],[]),x(","),$(),a.getToken()===4&&U)break}else B&&M(6,[],[]);G()||M(4,[],[4,5]),B=!0}return k(),a.getToken()!==4?M(8,[4],[]):$(),!0}function G(){switch(a.getToken()){case 3:return _();case 1:return j();case 10:return N(!0);default:return q()}}return $(),a.getToken()===17?i.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(a.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=v;function s(t,r){let i=A(t),a=[],h,c=0,u;do switch(u=i.getPosition(),h=i.scan(),h){case 12:case 13:case 17:c!==u&&a.push(t.substring(c,u)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(h!==17);return a.join("")}e.stripComments=s;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(Z[47],ee([0,1,33]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(p,E,n){let w,f,d,l,y;if(E){for(l=E.offset,y=l+E.length,d=l;d>0&&!P(p,d-1);)d--;let c=y;for(;c<p.length&&!P(p,c);)c++;f=p.substring(d,c),w=T(f,n)}else f=p,w=0,d=0,l=0,y=p.length;const I=A(n,p);let b=!1,C=0,v;n.insertSpaces?v=D(" ",n.tabSize||4):v="	";const s=(0,R.createScanner)(f,!1);let o=!1;function t(){return I+D(v,w+C)}function r(){let c=s.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=s.scan();return o=c===16||s.getTokenError()!==0,c}const i=[];function a(c,u,g){!o&&u<y&&g>l&&p.substring(u,g)!==c&&i.push({offset:u,length:g-u,content:c})}let h=r();if(h!==17){const c=s.getTokenOffset()+d,u=D(v,w);a(u,d,c)}for(;h!==17;){let c=s.getTokenOffset()+s.getTokenLength()+d,u=r(),g="";for(;!b&&(u===12||u===13);){const m=s.getTokenOffset()+d;a(" ",c,m),c=s.getTokenOffset()+s.getTokenLength()+d,g=u===12?t():"",u=r()}if(u===2)h!==1&&(C--,g=t());else if(u===4)h!==3&&(C--,g=t());else{switch(h){case 3:case 1:C++,g=t();break;case 5:case 12:g=t();break;case 13:b?g=t():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(o=!0);break;case 16:o=!0;break}b&&(u===12||u===13)&&(g=t())}const S=s.getTokenOffset()+d;a(g,c,S),h=u}return i}e.format=L;function D(p,E){let n="";for(let w=0;w<E;w++)n+=p;return n}function T(p,E){let n=0,w=0;const f=E.tabSize||4;for(;n<p.length;){const d=p.charAt(n);if(d===" ")w++;else if(d==="	")w+=f;else break;n++}return Math.floor(w/f)}function A(p,E){for(let n=0;n<E.length;n++){const w=E.charAt(n);if(w==="\r")return n+1<E.length&&E.charAt(n+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=A;function P(p,E){return`\r
`.indexOf(p.charAt(E))!==-1}e.isEOL=P}),define(Z[43],ee([0,1,33,47]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(E,n,w){return T(E,n,void 0,w)}e.removeProperty=D;function T(E,n,w,f,d){const l=n.slice(),y=[],I=(0,R.parseTree)(E,y);let b,C;for(;l.length>0&&(C=l.pop(),b=(0,R.findNodeAtLocation)(I,l),b===void 0&&w!==void 0);)typeof C=="string"?w={[C]:w}:w=[w];if(b)if(b.type==="object"&&typeof C=="string"&&Array.isArray(b.children)){const v=(0,R.findNodeAtLocation)(b,[C]);if(v!==void 0)if(w===void 0){if(!v.parent)throw new Error("Malformed AST");const s=b.children.indexOf(v.parent);let o,t=v.parent.offset+v.parent.length;if(s>0){const r=b.children[s-1];o=r.offset+r.length}else o=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(E,{offset:o,length:t-o,content:""},f)}else return A(E,{offset:v.offset,length:v.length,content:JSON.stringify(w)},f);else{if(w===void 0)return[];const s=`${JSON.stringify(C)}: ${JSON.stringify(w)}`,o=d?d(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(o>0){const r=b.children[o-1];t={offset:r.offset+r.length,length:0,content:","+s}}else b.children.length===0?t={offset:b.offset+1,length:0,content:s}:t={offset:b.offset+1,length:0,content:s+","};return A(E,t,f)}}else if(b.type==="array"&&typeof C=="number"&&Array.isArray(b.children))if(w!==void 0){const v=`${JSON.stringify(w)}`;let s;if(b.children.length===0||C===0)s={offset:b.offset+1,length:0,content:b.children.length===0?v:v+","};else{const o=C===-1||C>b.children.length?b.children.length:C,t=b.children[o-1];s={offset:t.offset+t.length,length:0,content:","+v}}return A(E,s,f)}else{const v=C,s=b.children[v];let o;if(b.children.length===1)o={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===v){const t=b.children[v-1],r=t.offset+t.length,i=b.offset+b.length;o={offset:r,length:i-2-r,content:""}}else o={offset:s.offset,length:b.children[v+1].offset-s.offset,content:""};return A(E,o,f)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${b.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(w)},f)}}e.setProperty=T;function A(E,n,w){let f=P(E,n),d=n.offset,l=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;d>0&&!(0,L.isEOL)(f,d-1);)d--;for(;l<f.length&&!(0,L.isEOL)(f,l);)l++}const y=(0,L.format)(f,{offset:d,length:l-d},w);for(let b=y.length-1;b>=0;b--){const C=y[b];f=P(f,C),d=Math.min(d,C.offset),l=Math.max(l,C.offset+C.length),l+=C.content.length-C.length}const I=E.length-(f.length-l)-d;return[{offset:d,length:I,content:f.substring(d,l)}]}e.withFormatting=A;function P(E,n){return E.substring(0,n.offset)+n.content+E.substring(n.offset+n.length)}e.applyEdit=P;function p(E,n){let w=n.slice(0).sort((d,l)=>{const y=d.offset-l.offset;return y===0?d.length-l.length:y}),f=E.length;for(let d=w.length-1;d>=0;d--){let l=w[d];if(l.offset+l.length<=f)E=P(E,l);else throw new Error("Overlapping edit");f=l.offset}return E}e.applyEdits=p}),define(Z[2],ee([0,1,65,55]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let T=null;function A(i){T=i}if(e.setDisposableTracker=A,D){const i="__is_disposable_tracked__";A(new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[i]||console.log(h)},3e3)}setParent(a,h){if(a&&a!==C.None)try{a[i]=!0}catch{}}markAsDisposed(a){if(a&&a!==C.None)try{a[i]=!0}catch{}}markAsSingleton(a){}})}function P(i){return T?.trackDisposable(i),i}function p(i){T?.markAsDisposed(i)}function E(i,a){T?.setParent(i,a)}function n(i,a){if(!!T)for(const h of i)T.setParent(h,a)}function w(i){return T?.markAsSingleton(i),i}e.markAsSingleton=w;class f extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=f;function d(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=d;function l(i){if(L.Iterable.is(i)){let a=[];for(const h of i)if(h)try{h.dispose()}catch(c){a.push(c)}if(a.length===1)throw a[0];if(a.length>1)throw new f(a);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=l;function y(...i){const a=I(()=>l(i));return n(i,a),a}e.combinedDisposable=y;function I(i){const a=P({dispose:(0,R.once)(()=>{p(a),i()})});return a}e.toDisposable=I;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new b,P(this),E(this._store,this)}dispose(){p(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=v;class s{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class o{constructor(){this.references=new Map}acquire(a,...h){let c=this.references.get(a);c||(c={counter:0,object:this.createReferencedObject(a,...h)},this.references.set(a,c));const{object:u}=c,g=(0,R.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(a,c.object),this.references.delete(a))});return c.counter++,{object:u,dispose:g}}}e.ReferenceCollection=o;class t{constructor(a){this.referenceCollection=a}async acquire(a,...h){const c=this.referenceCollection.acquire(a,...h);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(u){throw c.dispose(),u}}}e.AsyncReferenceCollection=t;class r{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=r}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class L{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const A=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const P=new R(T);if(this._first===R.Undefined)this._first=P,this._last=P;else if(A){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function K(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function A(p){T.push(p,Date.now())}function P(){const p=[];for(let E=0;E<T.length;E+=2)p.push({name:T[E],startTime:T[E+1]});return p}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(D+A.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,D=!1,T=!1,A=!1,P=!1,p=!1,E=!1,n,w=R,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const y=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=y&&l?.sandboxed,typeof navigator=="object"&&!y)d=navigator.userAgent,L=d.indexOf("Windows")>=0,D=d.indexOf("Macintosh")>=0,E=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=d.indexOf("Linux")>=0,p=!0,n=navigator.language,w=n;else if(typeof l=="object"){L=l.platform==="win32",D=l.platform==="darwin",T=l.platform==="linux",A=T&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,n=R,w=R;const i=l.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),h=a.availableLanguages["*"];n=a.locale,w=h||R,f=a._translationsConfigFile}catch(a){}P=!0}else console.error("Unable to resolve platform.");var I;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let C=0;D?C=1:L?C=3:T&&(C=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=T,e.isLinuxSnap=A,e.isNative=P,e.isWeb=p,e.isIOS=E,e.platform=C,e.userAgent=d,e.language=w;var v;(function(i){function a(){return e.language}i.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function c(){return e.language==="en"}i.isDefault=c})(v=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let g=0,S=h.length;g<S;g++){const m=h[g];if(m.id===u.data.vscodeSetImmediateId){h.splice(g,1),m.callback();return}}});let c=0;return u=>{const g=++c;h.push({id:g,callback:u}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const a=Promise.resolve();return h=>a.then(h)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||E?2:L?1:3;let o=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,o=new Uint16Array(i.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=r}),define(Z[35],ee([0,1,4]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;L={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(T){return(0,R.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],ee([0,1,35]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,T=90,A=122,P=46,p=47,E=92,n=58,w=63;class f extends Error{constructor(s,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const i=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${i} ${r} of type ${o}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function d(v,s){if(typeof v!="string")throw new f(s,"string",v)}function l(v){return v===p||v===E}function y(v){return v===p}function I(v){return v>=L&&v<=T||v>=D&&v<=A}function b(v,s,o,t){let r="",i=0,a=-1,h=0,c=0;for(let u=0;u<=v.length;++u){if(u<v.length)c=v.charCodeAt(u);else{if(t(c))break;c=p}if(t(c)){if(!(a===u-1||h===1))if(h===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const g=r.lastIndexOf(o);g===-1?(r="",i=0):(r=r.slice(0,g),i=r.length-1-r.lastIndexOf(o)),a=u,h=0;continue}else if(r.length!==0){r="",i=0,a=u,h=0;continue}}s&&(r+=r.length>0?`${o}..`:"..",i=2)}else r.length>0?r+=`${o}${v.slice(a+1,u)}`:r=v.slice(a+1,u),i=u-a-1;a=u,h=0}else c===P&&h!==-1?++h:h=-1}return r}function C(v,s){if(s===null||typeof s!="object")throw new f("pathObject","Object",s);const o=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${t}`:`${o}${v}${t}`:t}e.win32={resolve(...v){let s="",o="",t=!1;for(let r=v.length-1;r>=-1;r--){let i;if(r>=0){if(i=v[r],d(i,"path"),i.length===0)continue}else s.length===0?i=R.cwd():(i=R.env[`=${s}`]||R.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${s}\\`));const a=i.length;let h=0,c="",u=!1;const g=i.charCodeAt(0);if(a===1)l(g)&&(h=1,u=!0);else if(l(g))if(u=!0,l(i.charCodeAt(1))){let S=2,m=S;for(;S<a&&!l(i.charCodeAt(S));)S++;if(S<a&&S!==m){const k=i.slice(m,S);for(m=S;S<a&&l(i.charCodeAt(S));)S++;if(S<a&&S!==m){for(m=S;S<a&&!l(i.charCodeAt(S));)S++;(S===a||S!==m)&&(c=`\\\\${k}\\${i.slice(m,S)}`,h=S)}}}else h=1;else I(g)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),h=2,a>2&&l(i.charCodeAt(2))&&(u=!0,h=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(t){if(s.length>0)break}else if(o=`${i.slice(h)}\\${o}`,t=u,u&&s.length>0)break}return o=b(o,!t,"\\",l),t?`${s}\\${o}`:`${s}${o}`||"."},normalize(v){d(v,"path");const s=v.length;if(s===0)return".";let o=0,t,r=!1;const i=v.charCodeAt(0);if(s===1)return y(i)?"\\":v;if(l(i))if(r=!0,l(v.charCodeAt(1))){let h=2,c=h;for(;h<s&&!l(v.charCodeAt(h));)h++;if(h<s&&h!==c){const u=v.slice(c,h);for(c=h;h<s&&l(v.charCodeAt(h));)h++;if(h<s&&h!==c){for(c=h;h<s&&!l(v.charCodeAt(h));)h++;if(h===s)return`\\\\${u}\\${v.slice(c)}\\`;h!==c&&(t=`\\\\${u}\\${v.slice(c,h)}`,o=h)}}}else o=1;else I(i)&&v.charCodeAt(1)===n&&(t=v.slice(0,2),o=2,s>2&&l(v.charCodeAt(2))&&(r=!0,o=3));let a=o<s?b(v.slice(o),!r,"\\",l):"";return a.length===0&&!r&&(a="."),a.length>0&&l(v.charCodeAt(s-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(v){d(v,"path");const s=v.length;if(s===0)return!1;const o=v.charCodeAt(0);return l(o)||s>2&&I(o)&&v.charCodeAt(1)===n&&l(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let s,o;for(let i=0;i<v.length;++i){const a=v[i];d(a,"path"),a.length>0&&(s===void 0?s=o=a:s+=`\\${a}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&l(o.charCodeAt(0))){++r;const i=o.length;i>1&&l(o.charCodeAt(1))&&(++r,i>2&&(l(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&l(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(v,s){if(d(v,"from"),d(s,"to"),v===s)return"";const o=e.win32.resolve(v),t=e.win32.resolve(s);if(o===t||(v=o.toLowerCase(),s=t.toLowerCase(),v===s))return"";let r=0;for(;r<v.length&&v.charCodeAt(r)===E;)r++;let i=v.length;for(;i-1>r&&v.charCodeAt(i-1)===E;)i--;const a=i-r;let h=0;for(;h<s.length&&s.charCodeAt(h)===E;)h++;let c=s.length;for(;c-1>h&&s.charCodeAt(c-1)===E;)c--;const u=c-h,g=a<u?a:u;let S=-1,m=0;for(;m<g;m++){const O=v.charCodeAt(r+m);if(O!==s.charCodeAt(h+m))break;O===E&&(S=m)}if(m!==g){if(S===-1)return t}else{if(u>g){if(s.charCodeAt(h+m)===E)return t.slice(h+m+1);if(m===2)return t.slice(h+m)}a>g&&(v.charCodeAt(r+m)===E?S=m:m===2&&(S=3)),S===-1&&(S=0)}let k="";for(m=r+S+1;m<=i;++m)(m===i||v.charCodeAt(m)===E)&&(k+=k.length===0?"..":"\\..");return h+=S,k.length>0?`${k}${t.slice(h,c)}`:(t.charCodeAt(h)===E&&++h,t.slice(h,c))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const s=e.win32.resolve(v);if(s.length<=2)return v;if(s.charCodeAt(0)===E){if(s.charCodeAt(1)===E){const o=s.charCodeAt(2);if(o!==w&&o!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(I(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===E)return`\\\\?\\${s}`;return v},dirname(v){d(v,"path");const s=v.length;if(s===0)return".";let o=-1,t=0;const r=v.charCodeAt(0);if(s===1)return l(r)?v:".";if(l(r)){if(o=t=1,l(v.charCodeAt(1))){let h=2,c=h;for(;h<s&&!l(v.charCodeAt(h));)h++;if(h<s&&h!==c){for(c=h;h<s&&l(v.charCodeAt(h));)h++;if(h<s&&h!==c){for(c=h;h<s&&!l(v.charCodeAt(h));)h++;if(h===s)return v;h!==c&&(o=t=h+1)}}}}else I(r)&&v.charCodeAt(1)===n&&(o=s>2&&l(v.charCodeAt(2))?3:2,t=o);let i=-1,a=!0;for(let h=s-1;h>=t;--h)if(l(v.charCodeAt(h))){if(!a){i=h;break}}else a=!1;if(i===-1){if(o===-1)return".";i=o}return v.slice(0,i)},basename(v,s){s!==void 0&&d(s,"ext"),d(v,"path");let o=0,t=-1,r=!0,i;if(v.length>=2&&I(v.charCodeAt(0))&&v.charCodeAt(1)===n&&(o=2),s!==void 0&&s.length>0&&s.length<=v.length){if(s===v)return"";let a=s.length-1,h=-1;for(i=v.length-1;i>=o;--i){const c=v.charCodeAt(i);if(l(c)){if(!r){o=i+1;break}}else h===-1&&(r=!1,h=i+1),a>=0&&(c===s.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=h))}return o===t?t=h:t===-1&&(t=v.length),v.slice(o,t)}for(i=v.length-1;i>=o;--i)if(l(v.charCodeAt(i))){if(!r){o=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":v.slice(o,t)},extname(v){d(v,"path");let s=0,o=-1,t=0,r=-1,i=!0,a=0;v.length>=2&&v.charCodeAt(1)===n&&I(v.charCodeAt(0))&&(s=t=2);for(let h=v.length-1;h>=s;--h){const c=v.charCodeAt(h);if(l(c)){if(!i){t=h+1;break}continue}r===-1&&(i=!1,r=h+1),c===P?o===-1?o=h:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||r===-1||a===0||a===1&&o===r-1&&o===t+1?"":v.slice(o,r)},format:C.bind(null,"\\"),parse(v){d(v,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return s;const o=v.length;let t=0,r=v.charCodeAt(0);if(o===1)return l(r)?(s.root=s.dir=v,s):(s.base=s.name=v,s);if(l(r)){if(t=1,l(v.charCodeAt(1))){let S=2,m=S;for(;S<o&&!l(v.charCodeAt(S));)S++;if(S<o&&S!==m){for(m=S;S<o&&l(v.charCodeAt(S));)S++;if(S<o&&S!==m){for(m=S;S<o&&!l(v.charCodeAt(S));)S++;S===o?t=S:S!==m&&(t=S+1)}}}}else if(I(r)&&v.charCodeAt(1)===n){if(o<=2)return s.root=s.dir=v,s;if(t=2,l(v.charCodeAt(2))){if(o===3)return s.root=s.dir=v,s;t=3}}t>0&&(s.root=v.slice(0,t));let i=-1,a=t,h=-1,c=!0,u=v.length-1,g=0;for(;u>=t;--u){if(r=v.charCodeAt(u),l(r)){if(!c){a=u+1;break}continue}h===-1&&(c=!1,h=u+1),r===P?i===-1?i=u:g!==1&&(g=1):i!==-1&&(g=-1)}return h!==-1&&(i===-1||g===0||g===1&&i===h-1&&i===a+1?s.base=s.name=v.slice(a,h):(s.name=v.slice(a,i),s.base=v.slice(a,h),s.ext=v.slice(i,h))),a>0&&a!==t?s.dir=v.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let s="",o=!1;for(let t=v.length-1;t>=-1&&!o;t--){const r=t>=0?v[t]:R.cwd();d(r,"path"),r.length!==0&&(s=`${r}/${s}`,o=r.charCodeAt(0)===p)}return s=b(s,!o,"/",y),o?`/${s}`:s.length>0?s:"."},normalize(v){if(d(v,"path"),v.length===0)return".";const s=v.charCodeAt(0)===p,o=v.charCodeAt(v.length-1)===p;return v=b(v,!s,"/",y),v.length===0?s?"/":o?"./":".":(o&&(v+="/"),s?`/${v}`:v)},isAbsolute(v){return d(v,"path"),v.length>0&&v.charCodeAt(0)===p},join(...v){if(v.length===0)return".";let s;for(let o=0;o<v.length;++o){const t=v[o];d(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(v,s){if(d(v,"from"),d(s,"to"),v===s||(v=e.posix.resolve(v),s=e.posix.resolve(s),v===s))return"";const o=1,t=v.length,r=t-o,i=1,a=s.length-i,h=r<a?r:a;let c=-1,u=0;for(;u<h;u++){const S=v.charCodeAt(o+u);if(S!==s.charCodeAt(i+u))break;S===p&&(c=u)}if(u===h)if(a>h){if(s.charCodeAt(i+u)===p)return s.slice(i+u+1);if(u===0)return s.slice(i+u)}else r>h&&(v.charCodeAt(o+u)===p?c=u:u===0&&(c=0));let g="";for(u=o+c+1;u<=t;++u)(u===t||v.charCodeAt(u)===p)&&(g+=g.length===0?"..":"/..");return`${g}${s.slice(i+c)}`},toNamespacedPath(v){return v},dirname(v){if(d(v,"path"),v.length===0)return".";const s=v.charCodeAt(0)===p;let o=-1,t=!0;for(let r=v.length-1;r>=1;--r)if(v.charCodeAt(r)===p){if(!t){o=r;break}}else t=!1;return o===-1?s?"/":".":s&&o===1?"//":v.slice(0,o)},basename(v,s){s!==void 0&&d(s,"ext"),d(v,"path");let o=0,t=-1,r=!0,i;if(s!==void 0&&s.length>0&&s.length<=v.length){if(s===v)return"";let a=s.length-1,h=-1;for(i=v.length-1;i>=0;--i){const c=v.charCodeAt(i);if(c===p){if(!r){o=i+1;break}}else h===-1&&(r=!1,h=i+1),a>=0&&(c===s.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=h))}return o===t?t=h:t===-1&&(t=v.length),v.slice(o,t)}for(i=v.length-1;i>=0;--i)if(v.charCodeAt(i)===p){if(!r){o=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":v.slice(o,t)},extname(v){d(v,"path");let s=-1,o=0,t=-1,r=!0,i=0;for(let a=v.length-1;a>=0;--a){const h=v.charCodeAt(a);if(h===p){if(!r){o=a+1;break}continue}t===-1&&(r=!1,t=a+1),h===P?s===-1?s=a:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||t===-1||i===0||i===1&&s===t-1&&s===o+1?"":v.slice(s,t)},format:C.bind(null,"/"),parse(v){d(v,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return s;const o=v.charCodeAt(0)===p;let t;o?(s.root="/",t=1):t=0;let r=-1,i=0,a=-1,h=!0,c=v.length-1,u=0;for(;c>=t;--c){const g=v.charCodeAt(c);if(g===p){if(!h){i=c+1;break}continue}a===-1&&(h=!1,a=c+1),g===P?r===-1?r=c:u!==1&&(u=1):r!==-1&&(u=-1)}if(a!==-1){const g=i===0&&o?1:i;r===-1||u===0||u===1&&r===a-1&&r===i+1?s.base=s.name=v.slice(g,a):(s.name=v.slice(g,r),s.base=v.slice(g,a),s.ext=v.slice(r,a))}return i>0?s.dir=v.slice(0,i-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:K)[L]=R[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function R(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return K[L].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=K,R.c=e,R.d=function(L,D,T){R.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:T})},R.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,D){if(1&D&&(L=R(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var A in L)R.d(T,A,function(P){return L[P]}.bind(null,A));return T},R.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(D,"a",D),D},R.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},R.p="",R(R.s=0)}([function(K,e,R){(function(L){var D;e=K.exports=Q,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],E=0,n=E++;p[n]="0|[1-9]\\d*";var w=E++;p[w]="[0-9]+";var f=E++;p[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=E++;p[d]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var l=E++;p[l]="("+p[w]+")\\.("+p[w]+")\\.("+p[w]+")";var y=E++;p[y]="(?:"+p[n]+"|"+p[f]+")";var I=E++;p[I]="(?:"+p[w]+"|"+p[f]+")";var b=E++;p[b]="(?:-("+p[y]+"(?:\\."+p[y]+")*))";var C=E++;p[C]="(?:-?("+p[I]+"(?:\\."+p[I]+")*))";var v=E++;p[v]="[0-9A-Za-z-]+";var s=E++;p[s]="(?:\\+("+p[v]+"(?:\\."+p[v]+")*))";var o=E++,t="v?"+p[d]+p[b]+"?"+p[s]+"?";p[o]="^"+t+"$";var r="[v=\\s]*"+p[l]+p[C]+"?"+p[s]+"?",i=E++;p[i]="^"+r+"$";var a=E++;p[a]="((?:<|>)?=?)";var h=E++;p[h]=p[w]+"|x|X|\\*";var c=E++;p[c]=p[n]+"|x|X|\\*";var u=E++;p[u]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[b]+")?"+p[s]+"?)?)?";var g=E++;p[g]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[C]+")?"+p[s]+"?)?)?";var S=E++;p[S]="^"+p[a]+"\\s*"+p[u]+"$";var m=E++;p[m]="^"+p[a]+"\\s*"+p[g]+"$";var k=E++;p[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;p[O]="(?:~>?)";var x=E++;p[x]="(\\s*)"+p[O]+"\\s+",P[x]=new RegExp(p[x],"g");var z=E++;p[z]="^"+p[O]+p[u]+"$";var H=E++;p[H]="^"+p[O]+p[g]+"$";var V=E++;p[V]="(?:\\^)";var U=E++;p[U]="(\\s*)"+p[V]+"\\s+",P[U]=new RegExp(p[U],"g");var $=E++;p[$]="^"+p[V]+p[u]+"$";var M=E++;p[M]="^"+p[V]+p[g]+"$";var N=E++;p[N]="^"+p[a]+"\\s*("+r+")$|^$";var q=E++;p[q]="^"+p[a]+"\\s*("+t+")$|^$";var F=E++;p[F]="(\\s*)"+p[a]+"\\s*("+r+"|"+p[u]+")",P[F]=new RegExp(p[F],"g");var j=E++;p[j]="^\\s*("+p[u]+")\\s+-\\s+("+p[u]+")\\s*$";var _=E++;p[_]="^\\s*("+p[g]+")\\s+-\\s+("+p[g]+")\\s*$";var G=E++;p[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)D(B,p[B]),P[B]||(P[B]=new RegExp(p[B]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>T||!(re?P[i]:P[o]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Q))return new Q(J,re);D("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[i]:P[o]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var me=+pe;if(me>=0&&me<A)return me}return pe}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return D("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],pe=J.prerelease[re];if(D("prerelease compare",re,se,pe),se===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(se===void 0)return-1;if(se!==pe)return ne(se,pe)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,pe){typeof se=="string"&&(pe=se,se=void 0);try{return new Q(J,se).inc(re,pe).version}catch(me){return null}},e.diff=function(J,re){if(Se(J,re))return null;var se=X(J),pe=X(re);if(se.prerelease.length||pe.prerelease.length){for(var me in se)if((me==="major"||me==="minor"||me==="patch")&&se[me]!==pe[me])return"pre"+me;return"prerelease"}for(var me in se)if((me==="major"||me==="minor"||me==="patch")&&se[me]!==pe[me])return me},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),pe=ie.test(re);return se&&pe&&(J=+J,re=+re),se&&!pe?-1:pe&&!se?1:J<re?-1:J>re?1:0}function le(J,re,se){return new Q(J,se).compare(new Q(re,se))}function fe(J,re,se){return le(J,re,se)>0}function ye(J,re,se){return le(J,re,se)<0}function Se(J,re,se){return le(J,re,se)===0}function Pe(J,re,se){return le(J,re,se)!==0}function Te(J,re,se){return le(J,re,se)>=0}function Ne(J,re,se){return le(J,re,se)<=0}function Oe(J,re,se,pe){var me;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),me=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),me=J!==se;break;case"":case"=":case"==":me=Se(J,se,pe);break;case"!=":me=Pe(J,se,pe);break;case">":me=fe(J,se,pe);break;case">=":me=Te(J,se,pe);break;case"<":me=ye(J,se,pe);break;case"<=":me=Ne(J,se,pe);break;default:throw new TypeError("Invalid operator: "+re)}return me}function Ae(J,re){if(J instanceof Ae){if(J.loose===re)return J;J=J.value}if(!(this instanceof Ae))return new Ae(J,re);D("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=le,e.compareLoose=function(J,re){return le(J,re,!0)},e.rcompare=function(J,re,se){return le(re,J,se)},e.sort=function(J,re){return J.sort(function(se,pe){return e.compare(se,pe,re)})},e.rsort=function(J,re){return J.sort(function(se,pe){return e.rcompare(se,pe,re)})},e.gt=fe,e.lt=ye,e.eq=Se,e.neq=Pe,e.gte=Te,e.lte=Ne,e.cmp=Oe,e.Comparator=Ae;var _e={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof Ae)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ke(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ye(J,re,se,pe,me,De,we,Re,be,Le,Ue,W,te){return((re=ke(se)?"":ke(pe)?">="+se+".0.0":ke(me)?">="+se+"."+pe+".0":">="+re)+" "+(Re=ke(be)?"":ke(Le)?"<"+(+be+1)+".0.0":ke(Ue)?"<"+be+"."+(+Le+1)+".0":W?"<="+be+"."+Le+"."+Ue+"-"+W:"<="+Re)).trim()}function Je(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(D(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var pe=J[se].semver;if(pe.major===re.major&&pe.minor===re.minor&&pe.patch===re.patch)return!0}return!1}return!0}function ze(J,re,se){try{re=new Ie(re,se)}catch(pe){return!1}return re.test(J)}function $e(J,re,se,pe){var me,De,we,Re,be;switch(J=new Q(J,pe),re=new Ie(re,pe),se){case">":me=fe,De=Ne,we=ye,Re=">",be=">=";break;case"<":me=ye,De=Te,we=fe,Re="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(J,re,pe))return!1;for(var Le=0;Le<re.set.length;++Le){var Ue=re.set[Le],W=null,te=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Ae(">=0.0.0")),W=W||ae,te=te||ae,me(ae.semver,W.semver,pe)?W=ae:we(ae.semver,te.semver,pe)&&(te=ae)}),W.operator===Re||W.operator===be||(!te.operator||te.operator===Re)&&De(J,te.semver)||te.operator===be&&we(J,te.semver))return!1}return!0}Ae.prototype.parse=function(J){var re=this.loose?P[N]:P[q],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},Ae.prototype.toString=function(){return this.value},Ae.prototype.test=function(J){return D("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new Q(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Ae.prototype.intersects=function(J,re){if(!(J instanceof Ae))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),ze(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),ze(J.semver,se,re);var pe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),De=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Re=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),be=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return pe||me||De&&we||Re||be},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),D("range",J,re);var se=re?P[_]:P[j];J=J.replace(se,Ye),D("hyphen replace",J),J=J.replace(P[F],"$1$2$3"),D("comparator trim",J,P[F]),J=(J=(J=J.replace(P[x],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var pe=re?P[N]:P[q],me=J.split(" ").map(function(De){return function(we,Re){return D("comp",we),we=function(be,Le){return be.trim().split(/\s+/).map(function(Ue){return function(W,te){D("caret",W,te);var ae=te?P[M]:P[$];return W.replace(ae,function(ce,oe,he,ge,ve){var ue;return D("caret",W,ce,oe,he,ge,ve),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=oe==="0"?">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+".0 <"+(+oe+1)+".0.0":ve?(D("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+ve+" <"+(+oe+1)+".0.0"):(D("no pr"),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+" <"+(+oe+1)+".0.0"),D("caret return",ue),ue})}(Ue,Le)}).join(" ")}(we,Re),D("caret",we),we=function(be,Le){return be.trim().split(/\s+/).map(function(Ue){return function(W,te){var ae=te?P[H]:P[z];return W.replace(ae,function(ce,oe,he,ge,ve){var ue;return D("tilde",W,ce,oe,he,ge,ve),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":ve?(D("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ue=">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+(+he+1)+".0"):ue=">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0",D("tilde return",ue),ue})}(Ue,Le)}).join(" ")}(we,Re),D("tildes",we),we=function(be,Le){return D("replaceXRanges",be,Le),be.split(/\s+/).map(function(Ue){return function(W,te){W=W.trim();var ae=te?P[m]:P[S];return W.replace(ae,function(ce,oe,he,ge,ve,ue){D("xRange",W,ce,oe,he,ge,ve,ue);var Ee=ke(he),Ce=Ee||ke(ge),Fe=Ce||ke(ve);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ce&&(ge=0),Fe&&(ve=0),oe===">"?(oe=">=",Ce?(he=+he+1,ge=0,ve=0):Fe&&(ge=+ge+1,ve=0)):oe==="<="&&(oe="<",Ce?he=+he+1:ge=+ge+1),ce=oe+he+"."+ge+"."+ve):Ce?ce=">="+he+".0.0 <"+(+he+1)+".0.0":Fe&&(ce=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),D("xRange return",ce),ce})}(Ue,Le)}).join(" ")}(we,Re),D("xrange",we),we=function(be,Le){return D("replaceStars",be,Le),be.trim().replace(P[G],"")}(we,Re),D("stars",we),we}(De,re)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(pe)})),me=me.map(function(De){return new Ae(De,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(pe){return J.set.some(function(me){return me.every(function(De){return pe.intersects(De,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],J))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(J,re,se){var pe=null,me=null;try{var De=new Ie(re,se)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(pe&&me.compare(we)!==-1||(me=new Q(pe=we,se)))}),pe},e.minSatisfying=function(J,re,se){var pe=null,me=null;try{var De=new Ie(re,se)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(pe&&me.compare(we)!==1||(me=new Q(pe=we,se)))}),pe},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return $e(J,re,"<",se)},e.gtr=function(J,re,se){return $e(J,re,">",se)},e.outside=$e,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(P[k]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,R(1))},function(K,e){var R,L,D=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(I){if(R===setTimeout)return setTimeout(I,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(I,0);try{return R(I,0)}catch(b){try{return R.call(null,I,0)}catch(C){return R.call(this,I,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch(I){R=T}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(I){L=A}})();var p,E=[],n=!1,w=-1;function f(){n&&p&&(n=!1,p.length?E=p.concat(E):w=-1,E.length&&d())}function d(){if(!n){var I=P(f);n=!0;for(var b=E.length;b;){for(p=E,E=[];++w<b;)p&&p[w].run();w=-1,b=E.length}p=null,n=!1,function(C){if(L===clearTimeout)return clearTimeout(C);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(C);try{L(C)}catch(v){try{return L.call(null,C)}catch(s){return L.call(this,C)}}}(I)}}function l(I,b){this.fun=I,this.array=b}function y(){}D.nextTick=function(I){var b=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)b[C-1]=arguments[C];E.push(new l(I,b)),E.length!==1||n||P(d)},l.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(I){return[]},D.binding=function(I){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(I){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[3],ee([0,1,11,65,2,91,92]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>D.Disposable.None;function s(V){return(U,$=null,M)=>{let N=!1,q;return q=V(F=>{if(!N)return q?q.dispose():N=!0,U.call($,F)},null,M),N&&q.dispose(),q}}v.once=s;function o(V,U){return c(($,M=null,N)=>V(q=>$.call(M,U(q)),null,N))}v.map=o;function t(V,U){return c(($,M=null,N)=>V(q=>{U(q),$.call(M,q)},null,N))}v.forEach=t;function r(V,U){return c(($,M=null,N)=>V(q=>U(q)&&$.call(M,q),null,N))}v.filter=r;function i(V){return V}v.signal=i;function a(...V){return(U,$=null,M)=>(0,D.combinedDisposable)(...V.map(N=>N(q=>U.call($,q),null,M)))}v.any=a;function h(V,U,$){let M=$;return o(V,N=>(M=U(M,N),M))}v.reduce=h;function c(V){let U;const $=new f({onFirstListenerAdd(){U=V($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function u(V,U,$=100,M=!1,N){let q,F,j,_=0;const G=new f({leakWarningThreshold:N,onFirstListenerAdd(){q=V(B=>{_++,F=U(F,B),M&&!j&&(G.fire(F),F=void 0),clearTimeout(j),j=setTimeout(()=>{const X=F;F=void 0,j=void 0,(!M||_>1)&&G.fire(X),_=0},$)})},onLastListenerRemove(){q.dispose()}});return G.event}v.debounce=u;function g(V,U=($,M)=>$===M){let $=!0,M;return r(V,N=>{const q=$||!U(N,M);return $=!1,M=N,q})}v.latch=g;function S(V,U){return[v.filter(V,U),v.filter(V,$=>!U($))]}v.split=S;function m(V,U=!1,$=[]){let M=$.slice(),N=V(j=>{M?M.push(j):F.fire(j)});const q=()=>{M&&M.forEach(j=>F.fire(j)),M=null},F=new f({onFirstListenerAdd(){N||(N=V(j=>F.fire(j)))},onFirstListenerDidAdd(){M&&(U?setTimeout(q):q())},onLastListenerRemove(){N&&N.dispose(),N=null}});return F.event}v.buffer=m;class k{constructor(U){this.event=U}map(U){return new k(o(this.event,U))}forEach(U){return new k(t(this.event,U))}filter(U){return new k(r(this.event,U))}reduce(U,$){return new k(h(this.event,U,$))}latch(){return new k(g(this.event))}debounce(U,$=100,M=!1,N){return new k(u(this.event,U,$,M,N))}on(U,$,M){return this.event(U,$,M)}once(U,$,M){return s(this.event)(U,$,M)}}function O(V){return new k(V)}v.chain=O;function x(V,U,$=M=>M){const M=(...j)=>F.fire($(...j)),N=()=>V.on(U,M),q=()=>V.removeListener(U,M),F=new f({onFirstListenerAdd:N,onLastListenerRemove:q});return F.event}v.fromNodeEventEmitter=x;function z(V,U,$=M=>M){const M=(...j)=>F.fire($(...j)),N=()=>V.addEventListener(U,M),q=()=>V.removeEventListener(U,M),F=new f({onFirstListenerAdd:N,onLastListenerRemove:q});return F.event}v.fromDOMEventEmitter=z;function H(V){return new Promise(U=>s(V)(U))}v.toPromise=H})(P=e.Event||(e.Event={}));class p{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${p._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let E=-1;function n(v){const s=E;return E=v,{dispose(){E=s}}}e.setGlobalLeakWarningThreshold=n;class w{constructor(s,o=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let o=E;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||s<o)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,a=0;for(const[h,c]of this._stacks)(!i||a<c)&&(i=h,a=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${a}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class f{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=E>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(s,o,t)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[s,o]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,o);const a=this._leakageMon?.check(this._listeners.size),h=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(h):Array.isArray(t)&&t.push(h),h}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){(0,R.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class d extends f{async fireAsync(s,o,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,s]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),a=[],h={...i,waitUntil:c=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),a.push(c)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(c){(0,R.onUnexpectedError)(c);continue}Object.freeze(a),await Promise.allSettled(a).then(c=>{for(const u of c)u.status==="rejected"&&(0,R.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=d;class l extends f{constructor(s){super(s);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=l;class y extends l{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=y;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const o={event:s,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const t=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(o=>this.emitter.fire(o))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class b{constructor(){this.buffers=[]}wrapEvent(s){return(o,t,r)=>s(i=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>o.call(t,i)):o.call(t,i)},void 0,r)}bufferEvents(s){const o=[];this.buffers.push(o);const t=s();return this.buffers.pop(),o.forEach(r=>r()),t}}e.EventBufferer=b;class C{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(Z[29],ee([0,1,3]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,p){const E=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(E)}}});var D;(function(P){function p(E){return E===P.None||E===P.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=A}),define(Z[48],ee([0,1,3]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(w){const f=this._icons.get(w.id);f?w.description?f.description=w.description:console.error(`Duplicate registration of codicon ${w.id}`):(this._icons.set(w.id,w),this._onDidRegister.fire(w))}get(w){return this._icons.get(w)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function T(n,w){return new P(n,w)}e.registerCodicon=T;function A(n){return n?n.replace(/\$\((.*?)\)/g,(w,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(w,f,d){this.id=w,this.definition=f,this.description=d,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function p(n,w){const f=["codicon","codicon-"+n];return w&&f.push("codicon-modifier-"+w),f}e.getClassNamesArray=p;var E;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const w=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function f(y){if(y instanceof P)return["codicon","codicon-"+y.id];const I=w.exec(y.id);if(!I)return f(P.error);let[,b,C]=I;const v=["codicon","codicon-"+b];return C&&v.push("codicon-modifier-"+C.substr(1)),v}n.asClassNameArray=f;function d(y){return f(y).join(" ")}n.asClassName=d;function l(y){return"."+f(y).join(".")}n.asCSSSelector=l})(E=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[49],ee([0,1,11,2]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(v){const s=v;return s?[s.on,s.pause,s.resume,s.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=D;function T(v){const s=v;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(v,s){return new P(v,s)}e.newWriteableStream=A;class P{constructor(s,o){this.reducer=s,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(o=>o(s))}emitError(s){this.listeners.error.length===0?(0,R.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(o=>o(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,o){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(s,o){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(v,s){const o=[];let t;for(;(t=v.read())!==null;)o.push(t);return s(o)}e.consumeReadable=p;function E(v,s,o){const t=[];let r;for(;(r=v.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return v.read()}}}e.peekReadable=E;function n(v,s){return new Promise((o,t)=>{const r=[];w(v,{onData:i=>{s&&r.push(i)},onError:i=>{s?t(i):o(void 0)},onEnd:()=>{o(s?s(r):void 0)}})})}e.consumeStream=n;function w(v,s){v.on("error",o=>s.onError(o)),v.on("end",()=>s.onEnd()),v.on("data",o=>s.onData(o))}e.listenStream=w;function f(v,s){return new Promise((o,t)=>{const r=new L.DisposableStore,i=[],a=u=>{if(i.push(u),i.length>s)return r.dispose(),v.pause(),o({stream:v,buffer:i,ended:!1})},h=u=>t(u),c=()=>o({stream:v,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>v.removeListener("error",h))),v.on("error",h),r.add((0,L.toDisposable)(()=>v.removeListener("end",c))),v.on("end",c),r.add((0,L.toDisposable)(()=>v.removeListener("data",a))),v.on("data",a)})}e.peekStream=f;function d(v,s){const o=A(s);return o.end(v),o}e.toStream=d;function l(){const v=A(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=l;function y(v){let s=!1;return{read:()=>s?null:(s=!0,v)}}e.toReadable=y;function I(v,s,o){const t=A(o);return w(v,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}e.transform=I;function b(v,s,o){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?o([v,r]):v)}}}e.prefixedReadable=b;function C(v,s,o){let t=!1;const r=A(o);return w(s,{onData:i=>t?r.write(i):(t=!0,r.write(o([v,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(v)),r.end()}}),r}e.prefixedStream=C}),define(Z[19],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=R;const L=/{(\d+)}/g;function D(W,...te){return te.length===0?W:W.replace(L,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=te.length?ae:te[oe]})}e.format=D;const T=/{([^}]+)}/g;function A(W,te){return W.replace(T,(ae,ce)=>te[ce]??ae)}e.format2=A;function P(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function p(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function E(W,te){let ae=0;const ce=te.charCodeAt(0);for(let oe=W.length-1;oe>=0;oe--)W.charCodeAt(oe)===ce&&ae++;return ae}e.count=E;function n(W,te,ae="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${ae}`}e.truncate=n;function w(W,te=" "){const ae=f(W,te);return d(ae,te)}e.trim=w;function f(W,te){if(!W||!te)return W;const ae=te.length;if(ae===0||W.length===0)return W;let ce=0;for(;W.indexOf(te,ce)===ce;)ce=ce+ae;return W.substring(ce)}e.ltrim=f;function d(W,te){if(!W||!te)return W;const ae=te.length,ce=W.length;if(ae===0||ce===0)return W;let oe=ce,he=-1;for(;he=W.lastIndexOf(te,oe-1),!(he===-1||he+ae!==oe);){if(he===0)return"";oe=he}return W.substring(0,oe)}e.rtrim=d;function l(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function y(W){return W.replace(/\*/g,"")}e.stripWildcards=y;function I(W,te,ae={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=p(W)),ae.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(W,ce)}e.createRegExp=I;function b(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function C(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function v(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=v;function s(W){return W.split(/\r\n|\r|\n/)}e.splitLines=s;function o(W){for(let te=0,ae=W.length;te<ae;te++){const ce=W.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=o;function t(W,te=0,ae=W.length){for(let ce=te;ce<ae;ce++){const oe=W.charCodeAt(ce);if(oe!==32&&oe!==9)return W.substring(te,ce)}return W.substring(te,ae)}e.getLeadingWhitespace=t;function r(W,te=W.length-1){for(let ae=te;ae>=0;ae--){const ce=W.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(W,te){return W<te?-1:W>te?1:0}e.compare=i;function a(W,te,ae=0,ce=W.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=W.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue<Ee)return-1;if(ue>Ee)return 1}const ge=ce-ae,ve=he-oe;return ge<ve?-1:ge>ve?1:0}e.compareSubstring=a;function h(W,te){return c(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=h;function c(W,te,ae=0,ce=W.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=W.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue===Ee)continue;const Ce=ue-Ee;if(!(Ce===32&&g(Ee))&&!(Ce===-32&&g(ue)))return u(ue)&&u(Ee)?Ce:a(W.toLowerCase(),te.toLowerCase(),ae,ce,oe,he)}const ge=ce-ae,ve=he-oe;return ge<ve?-1:ge>ve?1:0}e.compareSubstringIgnoreCase=c;function u(W){return W>=97&&W<=122}e.isLowerAsciiLetter=u;function g(W){return W>=65&&W<=90}e.isUpperAsciiLetter=g;function S(W){return u(W)||g(W)}function m(W,te){return W.length===te.length&&k(W,te)}e.equalsIgnoreCase=m;function k(W,te,ae=W.length){for(let ce=0;ce<ae;ce++){const oe=W.charCodeAt(ce),he=te.charCodeAt(ce);if(oe!==he){if(S(oe)&&S(he)){const ge=Math.abs(oe-he);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(he).toLowerCase())return!1}}return!0}function O(W,te){const ae=te.length;return te.length>W.length?!1:k(W,te,ae)}e.startsWithIgnoreCase=O;function x(W,te){let ae,ce=Math.min(W.length,te.length);for(ae=0;ae<ce;ae++)if(W.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=x;function z(W,te){let ae,ce=Math.min(W.length,te.length);const oe=W.length-1,he=te.length-1;for(ae=0;ae<ce;ae++)if(W.charCodeAt(oe-ae)!==te.charCodeAt(he-ae))return ae;return ce}e.commonSuffixLength=z;function H(W){return 55296<=W&&W<=56319}e.isHighSurrogate=H;function V(W){return 56320<=W&&W<=57343}e.isLowSurrogate=V;function U(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function $(W,te,ae){const ce=W.charCodeAt(ae);if(H(ce)&&ae+1<te){const oe=W.charCodeAt(ae+1);if(V(oe))return U(ce,oe)}return ce}e.getNextCodePoint=$;function M(W,te){const ae=W.charCodeAt(te-1);if(V(ae)&&te>1){const ce=W.charCodeAt(te-2);if(H(ce))return U(ce,ae)}return ae}function N(W,te){const ae=me.getInstance(),ce=te,oe=W.length,he=$(W,oe,te);te+=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te<oe;){const ve=$(W,oe,te),ue=ae.getGraphemeBreakType(ve);if(se(ge,ue))break;te+=ve>=65536?2:1,ge=ue}return te-ce}e.nextCharLength=N;function q(W,te){const ae=me.getInstance(),ce=te,oe=M(W,te);te-=oe>=65536?2:1;let he=ae.getGraphemeBreakType(oe);for(;te>0;){const ge=M(W,te),ve=ae.getGraphemeBreakType(ge);if(se(ve,he))break;te-=ge>=65536?2:1,he=ve}return ce-te}e.prevCharLength=q;function F(W,te){const ae=me.getInstance(),ce=W.length,oe=te,he=$(W,ce,te),ge=ae.getGraphemeBreakType(he);te+=he>=65536?2:1;let ve=ge;for(;te<ce;){const Ee=$(W,ce,te),Ce=ae.getGraphemeBreakType(Ee);if(se(ve,Ce))break;te+=Ee>=65536?2:1,ve=Ce}const ue=te;for(te=oe,ve=ge;te>0;){const Ee=M(W,te),Ce=ae.getGraphemeBreakType(Ee);if(se(Ce,ve))break;te-=Ee>=65536?2:1,ve=Ce}return[te,ue]}function j(W,te){return te>0&&V(W.charCodeAt(te))?F(W,te-1):F(W,te)}e.getCharContainingOffset=j;function _(W){const te=W.length;let ae=0,ce=0;for(;ce<te;){const ge=$(W,te,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let he=0;for(;ce<te;){const ge=$(W,te,ce);ce+=ge>=65536?2:1,ge<128?oe[he++]=ge:ge<2048?(oe[he++]=192|(ge&1984)>>>6,oe[he++]=128|(ge&63)>>>0):ge<65536?(oe[he++]=224|(ge&61440)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0):(oe[he++]=240|(ge&1835008)>>>18,oe[he++]=128|(ge&258048)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=_;function G(W){const te=W.byteLength,ae=[];let ce=0;for(;ce<te;){const oe=W[ce];let he;if(oe>=240&&ce+3<te?he=(W[ce++]&7)<<18>>>0|(W[ce++]&63)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=224&&ce+2<te?he=(W[ce++]&15)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=192&&ce+1<te?he=(W[ce++]&31)<<6>>>0|(W[ce++]&63)<<0>>>0:he=W[ce++],he>=0&&he<=55295||he>=57344&&he<=65535)ae.push(String.fromCharCode(he));else if(he>=65536&&he<=1114111){const ge=he-65536,ve=55296+((ge&1047552)>>>10),ue=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(ve)),ae.push(String.fromCharCode(ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=G;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(W){return B.test(W)}e.containsRTL=X;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(W){return Q.test(W)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function le(W){return ne.test(W)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=fe;function ye(W){for(let te=0,ae=W.length;te<ae;te++)if(Se(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ye;function Se(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=Se;function Pe(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=Pe;function Te(W,te){if(W.length<te)return W;const ae=/\b/g;let ce=0;for(;ae.test(W)&&!(W.length-ae.lastIndex<te);)ce=ae.lastIndex,ae.lastIndex+=1;return W.substring(ce).replace(/^\s/,"")}e.lcut=Te;const Ne=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function _e(W){return W&&(W=W.replace(Ne,""),W=W.replace(Oe,""),W=W.replace(Ae,"")),W}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function ke(W){return Ie(W)?W.substr(1):W}e.stripUTF8BOM=ke;function Ye(W,te){if(!W||!te||W.length<te.length)return!1;const ae=te.length,ce=W.toLowerCase();let oe=0,he=-1;for(;oe<ae;){const ge=ce.indexOf(te[oe],he+1);if(ge<0)return!1;he=ge,oe++}return!0}e.fuzzyContains=Ye;function Je(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Je;function ze(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=ze;function $e(W,te=1){if(te===0)return"";let ae=-1;do ae=W.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?W:(W[ae-1]==="\r"&&ae--,W.substr(0,ae))}e.getNLines=$e;function J(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=J;function re(W){return me.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=re;function se(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=se;var pe;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class me{constructor(){this._data=De()}static getInstance(){return me._INSTANCE||(me._INSTANCE=new me),me._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(te<ae[3*oe])oe=2*oe;else if(te>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}me._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(W,te){if(W===0)return 0;const ae=Re(W,te);if(ae!==void 0)return ae;const ce=M(te,W);return W-=be(ce),W}e.getLeftDeleteOffset=we;function Re(W,te){let ae=M(te,W);for(W-=be(ae);Le(ae)||ae===65039||ae===8419;){if(W===0)return;ae=M(te,W),W-=be(ae)}if(!!Pe(ae)){if(W>=0){const ce=M(te,W);ce===8205&&(W-=be(ce))}return W}}function be(W){return W>=65536?2:1}function Le(W){return 127995<=W&&W<=127999}var Ue;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(Z[25],ee([0,1,49,19]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,p;class E{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return D?new E(Buffer.allocUnsafe(u)):new E(new Uint8Array(u))}static wrap(u){return D&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new E(u)}static fromString(u,g){return!(g?.dontUseNodeBuffer||!1)&&D?new E(Buffer.from(u)):T?(P||(P=new TextEncoder),new E(P.encode(u))):new E(L.encodeUTF8(u))}static concat(u,g){if(typeof g=="undefined"){g=0;for(let k=0,O=u.length;k<O;k++)g+=u[k].byteLength}const S=E.alloc(g);let m=0;for(let k=0,O=u.length;k<O;k++){const x=u[k];S.set(x,m),m+=x.byteLength}return S}toString(){return D?this.buffer.toString():A?(p||(p=new TextDecoder),p.decode(this.buffer)):L.decodeUTF8(this.buffer)}slice(u,g){return new E(this.buffer.subarray(u,g))}set(u,g){u instanceof E?this.buffer.set(u.buffer,g):this.buffer.set(u,g)}readUInt32BE(u){return f(this.buffer,u)}writeUInt32BE(u,g){d(this.buffer,u,g)}readUInt32LE(u){return l(this.buffer,u)}writeUInt32LE(u,g){y(this.buffer,u,g)}readUInt8(u){return I(this.buffer,u)}writeUInt8(u,g){b(this.buffer,u,g)}}e.VSBuffer=E;function n(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=n;function w(c,u,g){c[g+0]=u&255,u=u>>>8,c[g+1]=u&255}e.writeUInt16LE=w;function f(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=f;function d(c,u,g){c[g+3]=u,u=u>>>8,c[g+2]=u,u=u>>>8,c[g+1]=u,u=u>>>8,c[g]=u}e.writeUInt32BE=d;function l(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=l;function y(c,u,g){c[g+0]=u&255,u=u>>>8,c[g+1]=u&255,u=u>>>8,c[g+2]=u&255,u=u>>>8,c[g+3]=u&255}e.writeUInt32LE=y;function I(c,u){return c[u]}e.readUInt8=I;function b(c,u,g){c[g]=u}e.writeUInt8=b;function C(c){return R.consumeReadable(c,u=>E.concat(u))}e.readableToBuffer=C;function v(c){return R.toReadable(c)}e.bufferToReadable=v;function s(c){return R.consumeStream(c,u=>E.concat(u))}e.streamToBuffer=s;async function o(c){return c.ended?E.concat(c.buffer):E.concat([...c.buffer,await s(c.stream)])}e.bufferedStreamToBuffer=o;function t(c){return R.toStream(c,u=>E.concat(u))}e.bufferToStream=t;function r(c){return R.transform(c,{data:u=>typeof u=="string"?E.fromString(u):E.wrap(u)},u=>E.concat(u))}e.streamToBufferReadableStream=r;function i(c){return R.newWriteableStream(u=>E.concat(u),c)}e.newWriteableBufferStream=i;function a(c,u){return R.prefixedReadable(c,u,g=>E.concat(g))}e.prefixedBufferReadable=a;function h(c,u){return R.prefixedStream(c,u,g=>E.concat(g))}e.prefixedBufferStream=h}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(u){return Array.isArray(u)}e.isArray=R;function L(u){return typeof u=="string"}e.isString=L;function D(u){return Array.isArray(u)&&u.every(g=>L(g))}e.isStringArray=D;function T(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=T;function A(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=A;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=P;function p(u){return u===!0||u===!1}e.isBoolean=p;function E(u){return typeof u=="undefined"}e.isUndefined=E;function n(u){return!w(u)}e.isDefined=n;function w(u){return E(u)||u===null}e.isUndefinedOrNull=w;function f(u,g){if(!u)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=f;function d(u){if(w(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=d;function l(...u){const g=[];for(let S=0;S<u.length;S++){const m=u[S];if(w(m))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);g.push(m)}return g}e.assertAllDefined=l;const y=Object.prototype.hasOwnProperty;function I(u){if(!T(u))return!1;for(let g in u)if(y.call(u,g))return!1;return!0}e.isEmptyObject=I;function b(u){return typeof u=="function"}e.isFunction=b;function C(...u){return u.length>0&&u.every(b)}e.areFunctions=C;function v(u,g){const S=Math.min(u.length,g.length);for(let m=0;m<S;m++)s(u[m],g[m])}e.validateConstraints=v;function s(u,g){if(L(g)){if(typeof u!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(b(g)){try{if(u instanceof g)return}catch{}if(!w(u)&&u.constructor===g||g.length===1&&g.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function o(u){let g=[],S=Object.getPrototypeOf(u);for(;Object.prototype!==S;)g=g.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return g}e.getAllPropertyNames=o;function t(u){const g=[];for(const S of o(u))typeof u[S]=="function"&&g.push(S);return g}e.getAllMethodNames=t;function r(u,g){const S=k=>function(){const O=Array.prototype.slice.call(arguments,0);return g(k,O)};let m={};for(const k of u)m[k]=S(k);return m}e.createProxyObject=r;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function a(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=a;function h(u){return class{constructor(){return new Proxy({},{get(g,S){if(g[S])return g[S];throw new Error(`Not Implemented: ${u}->${String(S)}`)}})}}}e.NotImplementedProxy=h;function c(u,g="Unreachable"){throw new Error(g)}e.assertNever=c}),define(Z[39],ee([0,1,8,4,19,16]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function P(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function p(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function E(i,a=R.posix.sep){if(!i)return"";const h=i.length,c=i.charCodeAt(0);if(A(c)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let g=3;const S=g;for(;g<h&&!A(i.charCodeAt(g));g++);if(S!==g&&!A(i.charCodeAt(g+1))){for(g+=1;g<h;g++)if(A(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,a)}}return a}else if(b(c)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<h;u++)if(A(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=E;function n(i){if(!L.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let h=2;const c=h;for(;h<i.length&&(a=i.charCodeAt(h),a!==92);h++);return!(c===h||(a=i.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=n;const w=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(i,a=L.isWindows){const h=a?w:f;return!(!i||i.length===0||/^\s+$/.test(i)||(h.lastIndex=0,h.test(i))||a&&d.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=l;function y(i,a,h){const c=i===a;return!h||c?c:!i||!a?!1:(0,D.equalsIgnoreCase)(i,a)}e.isEqual=y;function I(i,a,h,c=R.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(h){if(!(0,D.startsWithIgnoreCase)(i,a))return!1;if(a.length===i.length)return!0;let g=a.length;return a.charAt(a.length-1)===c&&g--,i.charAt(g)===c}return a.charAt(a.length-1)!==c&&(a+=c),i.indexOf(a)===0}e.isEqualOrParent=I;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function C(i,a){return L.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(a,i)),i=(0,R.normalize)(i),L.isWindows?(i=(0,D.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,D.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=C;function v(i){const a=(0,R.normalize)(i);return L.isWindows?i.length>3?!1:s(a)&&(i.length===2||a.charCodeAt(2)===92):a===R.posix.sep}e.isRootOrDriveLetter=v;function s(i){return L.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function o(i){return s(i)?i[0]:void 0}e.getDriveLetter=o;function t(i,a,h){return a.length>i.length?-1:i===a?0:(h&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=t;function r(i){const a=i.split(":");let h,c,u;if(a.forEach(g=>{const S=Number(g);(0,T.isNumber)(S)?c===void 0?c=S:u===void 0&&(u=S):h=h?[h,g].join(":"):g}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:c!==void 0?c:void 0,column:u!==void 0?u:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const I=Array.isArray(y)?[]:{};return Object.keys(y).forEach(b=>{y[b]&&typeof y[b]=="object"?I[b]=L(y[b]):I[b]=y[b]}),I}e.deepClone=L;function D(y){if(!y||typeof y!="object")return y;const I=[y];for(;I.length>0;){const b=I.shift();Object.freeze(b);for(const C in b)if(T.call(b,C)){const v=b[C];typeof v=="object"&&!Object.isFrozen(v)&&I.push(v)}}return y}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function A(y,I){return P(y,I,new Set)}e.cloneAndChange=A;function P(y,I,b){if((0,R.isUndefinedOrNull)(y))return y;const C=I(y);if(typeof C!="undefined")return C;if((0,R.isArray)(y)){const v=[];for(const s of y)v.push(P(s,I,b));return v}if((0,R.isObject)(y)){if(b.has(y))throw new Error("Cannot clone recursive data-structure");b.add(y);const v={};for(let s in y)T.call(y,s)&&(v[s]=P(y[s],I,b));return b.delete(y),v}return y}function p(y,I,b=!0){return(0,R.isObject)(y)?((0,R.isObject)(I)&&Object.keys(I).forEach(C=>{C in y?b&&((0,R.isObject)(y[C])&&(0,R.isObject)(I[C])?p(y[C],I[C],b):y[C]=I[C]):y[C]=I[C]}),y):I}e.mixin=p;function E(y,I){if(y===I)return!0;if(y==null||I===null||I===void 0||typeof y!=typeof I||typeof y!="object"||Array.isArray(y)!==Array.isArray(I))return!1;let b,C;if(Array.isArray(y)){if(y.length!==I.length)return!1;for(b=0;b<y.length;b++)if(!E(y[b],I[b]))return!1}else{const v=[];for(C in y)v.push(C);v.sort();const s=[];for(C in I)s.push(C);if(s.sort(),!E(v,s))return!1;for(b=0;b<v.length;b++)if(!E(y[v[b]],I[v[b]]))return!1}return!0}e.equals=E;function n(y){const I=new Set;return JSON.stringify(y,(b,C)=>{if((0,R.isObject)(C)||Array.isArray(C)){if(I.has(C))return"[Circular]";I.add(C)}return C})}e.safeStringify=n;function w(y,I,b){const C=I(y);return typeof C=="undefined"?b:C}e.getOrDefault=w;function f(y,I){const b=Object.create(null);return!y||!I||Object.keys(I).forEach(v=>{const s=y[v],o=I[v];E(s,o)||(b[v]=o)}),b}e.distinct=f;function d(y,I){const b=I.toLowerCase(),C=Object.keys(y).find(v=>v.toLowerCase()===b);return C?y[C]:y[I]}e.getCaseInsensitive=d;function l(y,I){const b=Object.create(null);for(const C of Object.keys(y))I(C,y[C])&&(b[C]=y[C]);return b}e.filter=l}),define(Z[5],ee([0,1,8,4]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function P(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,a){return!i&&!a?"file":i}function E(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==w&&(a=w+a):a=w;break}return a}const n="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(a,h,c,u,g,S=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=p(a,S),this.authority=h||n,this.path=E(this.scheme,c||n),this.query=u||n,this.fragment=g||n,P(this,S))}static isUri(a){return a instanceof d?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return v(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:c,path:u,query:g,fragment:S}=a;return h===void 0?h=this.scheme:h===null&&(h=n),c===void 0?c=this.authority:c===null&&(c=n),u===void 0?u=this.path:u===null&&(u=n),g===void 0?g=this.query:g===null&&(g=n),S===void 0?S=this.fragment:S===null&&(S=n),h===this.scheme&&c===this.authority&&u===this.path&&g===this.query&&S===this.fragment?this:new y(h,c,u,g,S)}static parse(a,h=!1){const c=f.exec(a);return c?new y(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),h):new y(n,n,n,n,n)}static file(a){let h=n;if(L.isWindows&&(a=a.replace(/\\/g,w)),a[0]===w&&a[1]===w){const c=a.indexOf(w,2);c===-1?(h=a.substring(2),a=w):(h=a.substring(2,c),a=a.substring(c)||w)}return new y("file",h,a,n,n)}static from(a){const h=new y(a.scheme,a.authority,a.path,a.query,a.fragment);return P(h,!0),h}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&a.scheme==="file"?c=d.file(R.win32.join(v(a,!0),...h)).path:c=R.posix.join(a.path,...h),a.with({path:c})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof d)return a;{const h=new y(a);return h._formatted=a.external,h._fsPath=a._sep===l?a.fsPath:null,h}}else return a}}e.URI=d;const l=L.isWindows?1:void 0;class y extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=l),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,a){let h,c=-1;for(let u=0;u<i.length;u++){const g=i.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47)c!==-1&&(h+=encodeURIComponent(i.substring(c,u)),c=-1),h!==void 0&&(h+=i.charAt(u));else{h===void 0&&(h=i.substr(0,u));const S=I[g];S!==void 0?(c!==-1&&(h+=encodeURIComponent(i.substring(c,u)),c=-1),h+=S):c===-1&&(c=u)}}return c!==-1&&(h+=encodeURIComponent(i.substring(c))),h!==void 0?h:i}function C(i){let a;for(let h=0;h<i.length;h++){const c=i.charCodeAt(h);c===35||c===63?(a===void 0&&(a=i.substr(0,h)),a+=I[c]):a!==void 0&&(a+=i[h])}return a!==void 0?a:i}function v(i,a){let h;return i.authority&&i.path.length>1&&i.scheme==="file"?h=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?h=i.path.substr(1):h=i.path[1].toLowerCase()+i.path.substr(2):h=i.path,L.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=v;function s(i,a){const h=a?C:b;let c="",{scheme:u,authority:g,path:S,query:m,fragment:k}=i;if(u&&(c+=u,c+=":"),(g||u==="file")&&(c+=w,c+=w),g){let O=g.indexOf("@");if(O!==-1){const x=g.substr(0,O);g=g.substr(O+1),O=x.indexOf(":"),O===-1?c+=h(x,!1):(c+=h(x.substr(0,O),!1),c+=":",c+=h(x.substr(O+1),!1)),c+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?c+=h(g,!1):(c+=h(g.substr(0,O),!1),c+=g.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}c+=h(S,!0)}return m&&(c+="?",c+=h(m,!1)),k&&(c+="#",c+=a?k:b(k,!1)),c}function o(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+o(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>o(a)):i}}),define(Z[93],ee([0,1,5]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(E){const n=E;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function D(E){const n=[];let w;try{const f=JSON.parse(E.arguments),d=f[f.length-1];d&&d.__$stack&&(f.pop(),w=d.__$stack),n.push(...f)}catch(f){n.push("Unable to log remote console arguments",E.arguments)}return{args:n,stack:w}}e.parse=D;function T(E){if(typeof E!="string")return T(D(E).stack);const n=E;if(n){const w=A(n),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(f&&f.length===4)return{uri:R.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(E){if(!E)return E;const n=E.indexOf(`
`);return n===-1?E:E.substring(0,n)}function P(E,n){const{args:w,stack:f}=D(E),d=typeof w[0]=="string"&&w.length===1;let l=A(f);l&&(l=`(${l.trim()})`);let y=[];if(typeof w[0]=="string"?l&&d?y=[`%c[${n}] %c${w[0]} %c${l}`,p("blue"),p(""),p("grey")]:y=[`%c[${n}] %c${w[0]}`,p("blue"),p(""),...w.slice(1)]:y=[`%c[${n}]%`,p("blue"),...w],l&&!d&&y.push(l),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,y)}e.log=P;function p(E){return`color: ${E}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,R,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!D:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(K,R):D?D.value=R:e.set(K,R),R},xe=this&&this.__classPrivateFieldGet||function(K,e,R,L){if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?L:R==="a"?L.call(K):L?L.value:e.get(K)};define(Z[40],ee([0,1,19,5]),function(K,e,R,L){"use strict";var D,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let a=t.get(r);return a===void 0&&(a=i,t.set(r,a)),a}e.getOrSet=P;function p(t){const r=[];return t.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function E(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=E;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return i-a}value(){return this._value[this._pos]}}e.StringIterator=n;class w{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class f{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class y{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new l(r))}static forPaths(){return new I(new f)}static forStrings(){return new I(new n)}static forConfigKeys(){return new I(new w)}clear(){this._root=void 0}set(r,i){const a=this._iter.reset(r);let h;for(this._root||(this._root=new y,this._root.segment=a.value()),h=this._root;;){const u=a.cmp(h.segment);if(u>0)h.left||(h.left=new y,h.left.segment=a.value()),h=h.left;else if(u<0)h.right||(h.right=new y,h.right.segment=a.value()),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new y,h.mid.segment=a.value()),h=h.mid;else break}const c=h.value;return h.value=i,h.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const h=i.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else break}return a}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const a=this._iter.reset(r),h=[];let c=this._root;for(;c;){const u=a.cmp(c.segment);if(u>0)h.push([1,c]),c=c.left;else if(u<0)h.push([-1,c]),c=c.right;else if(a.hasNext())a.next(),h.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;h.length>0&&c.isEmpty();){let[g,S]=h.pop();switch(g){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}c=S}break}}}findSubstr(r){const i=this._iter.reset(r);let a=this._root,h;for(;a;){const c=i.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(i.hasNext())i.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const h=i.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[i,a]of this)r(a,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const a=i.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&i.push(a.left),a.mid&&i.push(a.mid),a.right&&i.push(a.right))}}}e.TernarySearchTree=I;class b{constructor(r,i){this[D]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[a,h]of this.map)r(h,L.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var C;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class v{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const a=this._map.get(r);if(!!a)return i!==0&&this.touch(a,i),a.value}set(r,i,a=0){let h=this._map.get(r);if(h)h.value=i,a!==0&&this.touch(h,a);else{switch(h={key:r,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const a=this._state;let h=this._head;for(;h;){if(i?r.bind(i)(h.value,h.key,this):r(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,i=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.key,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return h}values(){const r=this,i=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.value,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return h}entries(){const r=this,i=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:[a.key,a.value],done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return h}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>r;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const a=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const a=r.next,h=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.LinkedMap=v;class s extends v{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class o{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return xe(this,A,"f").size}forEach(r,i){xe(this,A,"f").forEach(r,i)}get(r){return xe(this,A,"f").get(r)}has(r){return xe(this,A,"f").has(r)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=o}),define(Z[94],ee([0,1,25,19,5]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,p)}e.stringify=T;function A(n){let w=JSON.parse(n);return w=E(w),w}e.parse=A;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function p(n,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,L.regExpFlags)(w)}:w}function E(n,w=0){if(!n||w>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof R.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let f=0;f<n.length;++f)n[f]=E(n[f],w+1);else for(const f in n)Object.hasOwnProperty.call(n,f)&&(n[f]=E(n[f],w+1))}return n}e.revive=E}),define(Z[17],ee([0,1,4,5]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,E,n){this._hosts[p]=E,this._ports[p]=n}setConnectionToken(p,E){this._connectionTokens[p]=E}rewrite(p){if(this._delegate)return this._delegate(p);const E=p.authority;let n=this._hosts[E];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const w=this._ports[E],f=this._connectionTokens[E];let d=`path=${encodeURIComponent(p.path)}`;return typeof f=="string"&&(d+=`&tkn=${encodeURIComponent(f)}`),L.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${w}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class A{asBrowserUri(p,E){const n=this.toUri(p,E);return n.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:D.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(p,E){const n=this.toUri(p,E);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,E){return L.URI.isUri(p)?p:L.URI.parse(E.toUrl(p))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(Z[66],ee([0,1,40]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new R.LRUCache(1e4);function D(E){return p(E,"NFC",L)}e.normalizeNFC=D;const T=new R.LRUCache(1e4);function A(E){return p(E,"NFD",T)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function p(E,n,w){if(!E)return E;const f=w.get(E);if(f)return f;let d;return P.test(E)?d=E.normalize(n):d=E,w.set(E,d),d}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(n){return A(n).replace(E,"")}}()}),define(Z[15],ee([0,1,39,17,8,4,19,5]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=p;class E{constructor(l){this._ignorePathCasing=l}compare(l,y,I=!1){return l===y?0:(0,A.compare)(this.getComparisonKey(l,I),this.getComparisonKey(y,I))}isEqual(l,y,I=!1){return l===y?!0:!l||!y?!1:this.getComparisonKey(l,I)===this.getComparisonKey(y,I)}getComparisonKey(l,y=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,y,I=!1){if(l.scheme===y.scheme){if(l.scheme===L.Schemas.file)return R.isEqualOrParent(p(l),p(y),this._ignorePathCasing(l))&&l.query===y.query&&(I||l.fragment===y.fragment);if((0,e.isEqualAuthority)(l.authority,y.authority))return R.isEqualOrParent(l.path,y.path,this._ignorePathCasing(l),"/")&&l.query===y.query&&(I||l.fragment===y.fragment)}return!1}joinPath(l,...y){return P.URI.joinPath(l,...y)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return D.posix.basename(l.path)}extname(l){const y=D.posix.extname(l.path),I=y.indexOf("?");return I!==-1?y.substr(0,I):y}dirname(l){if(l.path.length===0)return l;let y;return l.scheme===L.Schemas.file?y=P.URI.file(D.dirname(p(l))).path:(y=D.posix.dirname(l.path),l.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),y="/")),l.with({path:y})}normalizePath(l){if(!l.path.length)return l;let y;return l.scheme===L.Schemas.file?y=P.URI.file(D.normalize(p(l))).path:y=D.posix.normalize(l.path),l.with({path:y})}relativePath(l,y){if(l.scheme!==y.scheme||!(0,e.isEqualAuthority)(l.authority,y.authority))return;if(l.scheme===L.Schemas.file){const C=D.relative(p(l),p(y));return T.isWindows?R.toSlashes(C):C}let I=l.path||"/",b=y.path||"/";if(this._ignorePathCasing(l)){let C=0;for(const v=Math.min(I.length,b.length);C<v&&!(I.charCodeAt(C)!==b.charCodeAt(C)&&I.charAt(C).toLowerCase()!==b.charAt(C).toLowerCase());C++);I=b.substr(0,C)+I.substr(C)}return D.posix.relative(I,b)}resolvePath(l,y){if(l.scheme===L.Schemas.file){const I=P.URI.file(D.resolve(p(l),y));return l.with({authority:I.authority,path:I.path})}return y=R.toPosixPath(y),l.with({path:D.posix.resolve(l.path,y)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,y){return l===y||(0,A.equalsIgnoreCase)(l,y)}hasTrailingPathSeparator(l,y=D.sep){if(l.scheme===L.Schemas.file){const I=p(l);return I.length>R.getRoot(I).length&&I[I.length-1]===y}else{const I=l.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,y=D.sep){return(0,e.hasTrailingPathSeparator)(l,y)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,y=D.sep){let I=!1;if(l.scheme===L.Schemas.file){const b=p(l);I=b!==void 0&&b.length===R.getRoot(b).length&&b[b.length-1]===y}else{y="/";const b=l.path;I=b.length===1&&b.charCodeAt(b.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(l,y)?l.with({path:l.path+"/"}):l}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(d=>d.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(d,l){const y=[];for(let I=0;I<d.length;I++){const b=l(d[I]);d.some((C,v)=>v===I?!1:(0,e.isEqualOrParent)(b,l(C)))||y.push(d[I])}return y}e.distinctParents=n;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function l(y){const I=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(v=>{const[s,o]=v.split(":");s&&o&&I.set(s,o)});const C=y.path.substring(0,y.path.indexOf(";"));return C&&I.set(d.META_DATA_MIME,C),I}d.parseMetaData=l})(w=e.DataUri||(e.DataUri={}));function f(d,l,y){if(l){let I=d.path;return I&&I[0]!==D.posix.sep&&(I=D.posix.sep+I),d.with({scheme:y,authority:l,path:I})}return d.with({scheme:y})}e.toLocalResource=f}),define(Z[6],ee([0,1,29,11,3,2,15]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P($){return!!$&&typeof $.then=="function"}e.isThenable=P;function p($){const M=new R.CancellationTokenSource,N=$(M.token),q=new Promise((F,j)=>{const _=M.token.onCancellationRequested(()=>{_.dispose(),M.dispose(),j((0,L.canceled)())});Promise.resolve(N).then(G=>{_.dispose(),M.dispose(),F(G)},G=>{_.dispose(),M.dispose(),j(G)})});return new class{cancel(){M.cancel()}then(F,j){return q.then(F,j)}catch(F){return this.then(void 0,F)}finally(F){return q.finally(F)}}}e.createCancelablePromise=p;function E($,M,N){return Promise.race([$,new Promise(q=>M.onCancellationRequested(()=>q(N)))])}e.raceCancellation=E;async function n($){let M=-1;const N=$.map((F,j)=>F.then(_=>(M=j,_))),q=await Promise.race(N);return $.forEach((F,j)=>{j!==M&&F.cancel()}),q}e.raceCancellablePromises=n;function w($,M,N){let q;const F=setTimeout(()=>{q?.(void 0),N?.()},M);return Promise.race([$.finally(()=>clearTimeout(F)),new Promise(j=>q=j)])}e.raceTimeout=w;function f($){return new Promise((M,N)=>{const q=$();P(q)?q.then(M,N):M(q)})}e.asPromise=f;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=M(),new Promise((N,q)=>{this.activePromise.then(F=>{this.activePromise=null,N(F)},F=>{this.activePromise=null,q(F)})})}}e.Throttler=d;class l{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=l;class y{constructor(){this.promiseMap=new Map}queue(M,N){const F=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(M)===F&&this.promiseMap.delete(M)});return this.promiseMap.set(M,F),F}}e.SequencerByKey=y;class I{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,N=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,F)=>{this.doResolve=q,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class b{constructor(M){this.delayer=new I(M),this.throttler=new d}trigger(M,N){return this.delayer.trigger(()=>this.throttler.queue(M),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class C{constructor(){this._isOpen=!1,this._promise=new Promise((M,N)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=C;class v extends C{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function s($,M){return M?new Promise((N,q)=>{const F=setTimeout(()=>{j.dispose(),N()},$),j=M.onCancellationRequested(()=>{clearTimeout(F),j.dispose(),q((0,L.canceled)())})}):p(N=>s($,N))}e.timeout=s;function o($,M=0){const N=setTimeout($,M);return(0,T.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=o;function t($){const M=[];let N=0;const q=$.length;function F(){return N<q?$[N++]():null}function j(_){_!=null&&M.push(_);const G=F();return G?G.then(j):Promise.resolve(M)}return Promise.resolve(null).then(j)}e.sequence=t;function r($,M=q=>!!q,N=null){let q=0;const F=$.length,j=()=>{if(q>=F)return Promise.resolve(N);const _=$[q++];return Promise.resolve(_()).then(B=>M(B)?Promise.resolve(B):j())};return j()}e.first=r;function i($,M=q=>!!q,N=null){if($.length===0)return Promise.resolve(N);let q=$.length;const F=()=>{q=-1;for(const j of $)j.cancel?.()};return new Promise((j,_)=>{for(const G of $)G.then(B=>{--q>=0&&M(B)?(F(),j(B)):q===0&&j(N)}).catch(B=>{--q>=0&&(F(),_(B))})})}e.firstParallel=i;class a{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:M,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const N=M.factory();N.then(M.c,M.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class h extends a{constructor(){super(1)}}e.Queue=h;class c{constructor(){this.queues=new Map}queueFor(M,N=A.extUri){const q=N.getComparisonKey(M);let F=this.queues.get(q);return F||(F=new h,D.Event.once(F.onFinished)(()=>{F?.dispose(),this.queues.delete(q)}),this.queues.set(q,F)),F}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=c;class u{constructor(M,N){this._token=-1,typeof M=="function"&&typeof N=="number"&&this.setIfNotSet(M,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},N)}setIfNotSet(M,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},N))}}e.TimeoutTimer=u;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,N){this.cancel(),this._token=setInterval(()=>{M()},N)}}e.IntervalTimer=g;class S{constructor(M,N){this.timeoutToken=-1,this.runner=M,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class m extends S{constructor(M,N){super(M,N);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=m;class k extends T.Disposable{constructor(M,N,q,F){super();this.maxWorkChunkSize=M,this.maxPendingWork=N,this.throttleDelay=q,this.handler=F,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const N=setTimeout(()=>M($));let q=!1;return{dispose(){q||(q=!0,clearTimeout(N))}}}}else e.runWhenIdle=($,M)=>{const N=requestIdleCallback($,typeof M=="number"?{timeout:M}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class O{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function x($,M,N){let q;for(let F=0;F<N;F++)try{return await $()}catch(j){q=j,await s(M)}throw q}e.retry=x;class z{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,N,q){return this._pending={taskId:M,cancel:()=>q?.(),promise:N},N.then(()=>this.donePending(M),()=>this.donePending(M)),N}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let N,q;const F=new Promise((j,_)=>{N=j,q=_});this._next={run:M,promise:F,promiseResolve:N,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,N)=>{this.completeCallback=M,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(N=>{this.completeCallback(M),this.resolved=!0,N()})}error(M){return new Promise(N=>{this.errorCallback(M),this.rejected=!0,N()})}cancel(){new Promise(M=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=V;var U;(function($){async function M(N){let q;const F=await Promise.all(N.map(j=>j.then(_=>_,_=>{q||(q=_)})));if(typeof q!="undefined")throw q;return F}$.settled=M})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,6,39,40,8,19]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const p="**",E="/",n="[/\\\\]",w="[^/\\\\]",f=/\//g;function d(F){switch(F){case 0:return"";case 1:return`${w}*?`;default:return`(?:${n}|${w}+${n}|${n}${w}+)*?`}}function l(F,j){if(!F)return[];const _=[];let G=!1,B=!1,X="";for(const Q of F){switch(Q){case j:if(!G&&!B){_.push(X),X="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":B=!0;break;case"]":B=!1;break}X+=Q}return X&&_.push(X),_}e.splitGlobAware=l;function y(F){if(!F)return"";let j="";const _=l(F,E);if(_.every(G=>G===p))j=".*";else{let G=!1;_.forEach((B,X)=>{if(B===p){G||(j+=d(2),G=!0);return}let Q=!1,ie="",ne=!1,le="";for(const fe of B){if(fe!=="}"&&Q){ie+=fe;continue}if(ne&&(fe!=="]"||!le)){let ye;fe==="-"?ye=fe:(fe==="^"||fe==="!")&&!le?ye="^":fe===E?ye="":ye=A.escapeRegExpCharacters(fe),le+=ye;continue}switch(fe){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":j+=`(?:${l(ie,",").map(Pe=>y(Pe)).join("|")})`,Q=!1,ie="";break;case"]":j+="["+le+"]",ne=!1,le="";break;case"?":j+=w;continue;case"*":j+=d(1);continue;default:j+=A.escapeRegExpCharacters(fe)}}X<_.length-1&&(_[X+1]!==p||X+2<_.length)&&(j+=n),G=!1})}return j}const I=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(F,j){if(!F)return i;let _;typeof F!="string"?_=F.pattern:_=F,_=_.trim();const G=`${_}_${!!j.trimForExclusions}`;let B=t.get(G);if(B)return h(B,F);let X;if(I.test(_)){const Q=_.substr(4);B=function(ie,ne){return typeof ie=="string"&&ie.endsWith(Q)?_:null}}else(X=b.exec(c(_,j)))?B=u(X[1],_):(j.trimForExclusions?v:C).test(_)?B=g(_,j):(X=s.exec(c(_,j)))?B=S(X[1].substr(1),_,!0):(X=o.exec(c(_,j)))?B=S(X[1],_,!1):B=m(_);return t.set(G,B),h(B,F)}function h(F,j){return typeof j=="string"?F:function(_,G){return L.isEqualOrParent(_,j.base)?F(T.relative(j.base,_),G):null}}function c(F,j){return j.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,j){const _=`/${F}`,G=`\\${F}`,B=function(Q,ie){return typeof Q!="string"?null:ie?ie===F?j:null:Q===F||Q.endsWith(_)||Q.endsWith(G)?j:null},X=[F];return B.basenames=X,B.patterns=[j],B.allBasenames=X,B}function g(F,j){const _=q(F.slice(1,-1).split(",").map(ie=>a(ie,j)).filter(ie=>ie!==i),F),G=_.length;if(!G)return i;if(G===1)return _[0];const B=function(ie,ne){for(let le=0,fe=_.length;le<fe;le++)if(_[le](ie,ne))return F;return null},X=_.find(ie=>!!ie.allBasenames);X&&(B.allBasenames=X.allBasenames);const Q=_.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(B.allPaths=Q),B}function S(F,j,_){const G=T.sep===T.posix.sep,B=G?F:F.replace(f,T.sep),X=T.sep+B,Q=T.posix.sep+F,ie=_?function(ne,le){return typeof ne=="string"&&(ne===B||ne.endsWith(X)||!G&&(ne===F||ne.endsWith(Q)))?j:null}:function(ne,le){return typeof ne=="string"&&(ne===B||!G&&ne===F)?j:null};return ie.allPaths=[(_?"*/":"./")+F],ie}function m(F){try{const j=new RegExp(`^${y(F)}$`);return function(_){return j.lastIndex=0,typeof _=="string"&&j.test(_)?F:null}}catch(j){return i}}function k(F,j,_){return!F||typeof j!="string"?!1:O(F)(j,void 0,_)}e.match=k;function O(F,j={}){if(!F)return r;if(typeof F=="string"||V(F)){const _=a(F,j);if(_===i)return r;const G=function(B,X){return!!_(B,X)};return _.allBasenames&&(G.allBasenames=_.allBasenames),_.allPaths&&(G.allPaths=_.allPaths),G}return M(F,j)}e.parse=O;function x(F){if(!F)return;let j;return _=>(j||(j=(F()||Promise.resolve([])).then(G=>G?H(G):{})),j.then(G=>!!G[_]))}e.hasSiblingPromiseFn=x;function z(F){if(!F)return;let j;return _=>{if(!j){const G=F();j=G?H(G):{}}return!!j[_]}}e.hasSiblingFn=z;function H(F){const j={};for(const _ of F)j[_]=!0;return j}function V(F){const j=F;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=V;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function $(F){return F.allPaths||[]}e.getPathTerms=$;function M(F,j){const _=q(Object.getOwnPropertyNames(F).map(ie=>N(ie,F[ie],j)).filter(ie=>ie!==i)),G=_.length;if(!G)return i;if(!_.some(ie=>!!ie.requiresSiblings)){if(G===1)return _[0];const ie=function(fe,ye){for(let Se=0,Pe=_.length;Se<Pe;Se++){const Te=_[Se](fe,ye);if(Te)return Te}return null},ne=_.find(fe=>!!fe.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const le=_.reduce((fe,ye)=>ye.allPaths?fe.concat(ye.allPaths):fe,[]);return le.length&&(ie.allPaths=le),ie}const B=function(ie,ne,le){let fe;for(let ye=0,Se=_.length;ye<Se;ye++){const Pe=_[ye];Pe.requiresSiblings&&le&&(ne||(ne=T.basename(ie)),fe||(fe=ne.substr(0,ne.length-T.extname(ie).length)));const Te=Pe(ie,ne,fe,le);if(Te)return Te}return null},X=_.find(ie=>!!ie.allBasenames);X&&(B.allBasenames=X.allBasenames);const Q=_.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(B.allPaths=Q),B}function N(F,j,_){if(j===!1)return i;const G=a(F,_);if(G===i)return i;if(typeof j=="boolean")return G;if(j){const B=j.when;if(typeof B=="string"){const X=(Q,ie,ne,le)=>{if(!le||!G(Q,ie))return null;const fe=B.replace("$(basename)",ne),ye=le(fe);return(0,R.isThenable)(ye)?ye.then(Se=>Se?F:null):ye?F:null};return X.requiresSiblings=!0,X}}return G}function q(F,j){const _=F.filter(ie=>!!ie.basenames);if(_.length<2)return F;const G=_.reduce((ie,ne)=>{const le=ne.basenames;return le?ie.concat(le):ie},[]);let B;if(j){B=[];for(let ie=0,ne=G.length;ie<ne;ie++)B.push(j)}else B=_.reduce((ie,ne)=>{const le=ne.patterns;return le?ie.concat(le):ie},[]);const X=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let fe;for(fe=ie.length;fe>0;fe--){const ye=ie.charCodeAt(fe-1);if(ye===47||ye===92)break}ne=ie.substr(fe)}const le=G.indexOf(ne);return le!==-1?B[le]:null};X.basenames=G,X.patterns=B,X.allBasenames=G;const Q=F.filter(ie=>!ie.basenames);return Q.push(X),Q}}),define(Z[95],ee([0,1,67,17,8,15,19]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let p=[],E=[],n=[];function w(r,i=!1){const a=f(r);p.push(a),a.userConfigured?n.push(a):E.push(a),i&&!a.userConfigured&&p.forEach(h=>{h.mime===a.mime||h.userConfigured||(a.extension&&h.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&h.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&h.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&h.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=w;function f(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(D.posix.sep)>=0:!1}}function d(r){r?(p=p.filter(i=>!i.userConfigured),n=[]):(p=[],E=[],n=[])}e.clearTextMimes=d;function l(r,i){let a;if(r)switch(r.scheme){case L.Schemas.file:a=r.fsPath;break;case L.Schemas.data:a=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:a=r.path}if(!a)return[P.unknown];a=a.toLowerCase();const h=(0,D.basename)(a),c=y(a,h,n);if(c)return[c,P.text];const u=y(a,h,E);if(u)return[u,P.text];if(i){const g=I(i);if(g)return[g,P.text]}return[P.unknown]}e.guessMimeTypes=l;function y(r,i,a){let h=null,c=null,u=null;for(let g=a.length-1;g>=0;g--){const S=a[g];if(i===S.filenameLowercase){h=S;break}if(S.filepattern&&(!c||S.filepattern.length>c.filepattern.length)){const m=S.filepatternOnPath?r:i;(0,R.match)(S.filepatternLowercase,m)&&(c=S)}S.extension&&(!u||S.extension.length>u.extension.length)&&i.endsWith(S.extensionLowercase)&&(u=S)}return h?h.mime:c?c.mime:u?u.mime:null}function I(r){if((0,A.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=p.length-1;i>=0;i--){const a=p[i];if(!a.firstline)continue;const h=r.match(a.firstline);if(h&&h.length>0)return a.mime}return null}function b(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function v(r){const i=(0,D.extname)(r);return C[i.toLowerCase()]}e.getMediaMime=v;function s(r){for(const i in C)if(C[i]===r)return i}e.getExtensionForMimeType=s;const o=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const a=o.exec(r);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[96],ee([0,1,5]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class D{constructor(w){this._uriTransformer=w}transformIncoming(w){const f=this._uriTransformer.transformIncoming(w);return f===w?w:L(R.URI.from(f))}transformOutgoing(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:L(R.URI.from(f))}transformOutgoingURI(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:R.URI.from(f)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,w,f){if(!n||f>200)return null;if(typeof n=="object"){if(n instanceof R.URI)return w.transformOutgoing(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const l=T(n[d],w,f+1);l!==null&&(n[d]=l)}}return null}function A(n,w){const f=T(n,w,0);return f===null?n:f}e.transformOutgoingURIs=A;function P(n,w,f,d){if(!n||d>200)return null;if(typeof n=="object"){if(n.$mid===1)return f?R.URI.revive(w.transformIncoming(n)):w.transformIncoming(n);for(let l in n)if(Object.hasOwnProperty.call(n,l)){const y=P(n[l],w,f,d+1);y!==null&&(n[l]=y)}}return null}function p(n,w){const f=P(n,w,!1,0);return f===null?n:f}e.transformIncomingURIs=p;function E(n,w){const f=P(n,w,!0,0);return f===null?n:f}e.transformAndReviveIncomingURIs=E}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(p){return R.test(p)}e.isUUID=L;const D=new Uint8Array(16),T=[];for(let p=0;p<256;p++)T.push(p.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let E=0;E<p.length;E++)p[E]=Math.floor(Math.random()*256);return p};function P(){A(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let p=0,E="";return E+=T[D[p++]],E+=T[D[p++]],E+=T[D[p++]],E+=T[D[p++]],E+="-",E+=T[D[p++]],E+=T[D[p++]],E+="-",E+=T[D[p++]],E+=T[D[p++]],E+="-",E+=T[D[p++]],E+=T[D[p++]],E+="-",E+=T[D[p++]],E+=T[D[p++]],E+=T[D[p++]],E+=T[D[p++]],E+=T[D[p++]],E+=T[D[p++]],E}e.generateUuid=P}),define(Z[68],ee([0,1,218]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new R.StringDecoder(T),this.remaining=null}write(T){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return A;let p=0,E,n=p;for(;n<P.length;)if(E=P.charCodeAt(n),E===13||E===10){if(A.push(P.substring(p,n)),n++,n<P.length){const w=E;E=P.charCodeAt(n),(w===13&&E===10||w===10&&E===13)&&n++}p=n}else n++;return this.remaining=p<P.length?P.substr(p):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(Z[97],ee([0,1,34]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const p=P.replace(/\-/g,":").toLowerCase();return!L.has(p)}function T(){return new Promise(async(P,p)=>{const E=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(n){p(n)}finally{clearTimeout(E)}})}e.getMac=T;function A(){return new Promise((P,p)=>{try{const E=(0,R.networkInterfaces)();for(let n in E){const w=E[n];if(w){for(const{mac:f}of w)if(D(f))return P(f)}}p("Unable to retrieve mac address (unexpected format)")}catch(E){p(E)}})}}),define(Z[98],ee([0,1,34,11,40,30,97]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,w=0;const f=(0,R.networkInterfaces)();for(let d in f){const l=f[d];if(l)for(const{mac:y,internal:I}of l)I||(w+=1,this._isVirtualMachineMacAdress(y.toUpperCase())&&(n+=1))}this._value=w>0?n/w:0}return this._value}};let P;async function p(){return P||(P=(async()=>await E()||T.generateUuid())()),P}e.getMachineId=p;async function E(){try{const n=await new Promise((f,d)=>{K(["crypto"],f,d)}),w=await(0,A.getMac)();return n.createHash("sha256").update(w,"utf8").digest("hex")}catch(n){L.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,50,34,219,6,39,66,8,4,15,5,30]),function(K,e,R,L,D,T,A,P,p,E,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(d=e.RimRafMode||(e.RimRafMode={}));async function l(U,$=d.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return $===d.UNLINK?I(U):y(U)}async function y(U){try{const $=(0,p.join)((0,L.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(U,$)}catch(M){return I(U)}I($).catch(M=>{})}catch($){if($.code!=="ENOENT")throw $}}async function I(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function C(U,$){return o(await($?v(U):(0,D.promisify)(R.readdir)(U)))}async function v(U){try{return await(0,D.promisify)(R.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],M=await C(U);for(const N of M){let q=!1,F=!1,j=!1;try{const _=await e.Promises.lstat((0,p.join)(U,N));q=_.isFile(),F=_.isDirectory(),j=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}$.push({name:N,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>j})}return $}function s(U){return o(R.readdirSync(U))}e.readdirSync=s;function o(U){return U.map($=>typeof $=="string"?E.isMacintosh?(0,P.normalizeNFC)($):$:($.name=E.isMacintosh?(0,P.normalizeNFC)($.name):$.name,$))}async function t(U){const $=await C(U),M=[];for(const N of $)await i.existsDirectory((0,p.join)(U,N))&&M.push(N);return M}function r(U,$=1e3){return new Promise(M=>{let N=!1;const q=setInterval(()=>{N||(N=!0,R.access(U,F=>{N=!1,F&&(clearInterval(q),M(void 0))}))},$)})}e.whenDeleted=r;var i;(function(U){async function $(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch(j){}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(E.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw _}throw j}}U.stat=$;async function M(q){try{const{stat:F,symbolicLink:j}=await U.stat(q);return F.isFile()&&j?.dangling!==!0}catch(F){}return!1}U.existsFile=M;async function N(q){try{const{stat:F,symbolicLink:j}=await U.stat(q);return F.isDirectory()&&j?.dangling!==!0}catch(F){}return!1}U.existsDirectory=N})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new T.ResourceQueue;function h(U,$,M){return a.queueFor(w.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const N=S(M);return new Promise((q,F)=>u(U,$,N,j=>j?F(j):q()))})}let c=!0;function u(U,$,M,N){if(!c)return R.writeFile(U,$,{mode:M.mode,flag:M.flag},N);R.open(U,M.flag,M.mode,(q,F)=>{if(q)return N(q);R.writeFile(F,$,j=>{if(j)return R.close(F,()=>N(j));R.fdatasync(F,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),c=!1),R.close(F,G=>N(G))))})})}function g(U,$,M){const N=S(M);if(!c)return R.writeFileSync(U,$,{mode:N.mode,flag:N.flag});const q=R.openSync(U,N.flag,N.mode);try{R.writeFileSync(q,$);try{R.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),c=!1}}finally{R.closeSync(q)}}e.writeFileSync=g;function S(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function m(U,$){if(U===$)return;async function M(N){try{const q=await e.Promises.lstat(N);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(N,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(U,$),await M($)}catch(N){if(U.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await k(U,$,{preserveSymlinks:!1}),await l(U,d.MOVE),await M($);else throw N}}async function k(U,$,M){return x(U,$,{root:{source:U,target:$},options:M,handledSourcePaths:new Set})}const O=511;async function x(U,$,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:N,symbolicLink:q}=await i.stat(U);if(q){if(M.options.preserveSymlinks)try{return await V(U,$,M)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return N.isDirectory()?z(U,$,N.mode&O,M):H(U,$,N.mode&O)}async function z(U,$,M,N){await e.Promises.mkdir($,{recursive:!0,mode:M});const q=await C(U);for(const F of q)await x((0,p.join)(U,F),(0,p.join)($,F),N)}async function H(U,$,M){await e.Promises.copyFile(U,$),await e.Promises.chmod($,M)}async function V(U,$,M){let N=await e.Promises.readlink(U);(0,A.isEqualOrParent)(N,M.root.source,!E.isLinux)&&(N=(0,p.join)(M.root.target,N.substr(M.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return l}get move(){return m}get copy(){return k}}}),define(Z[99],ee([0,1,50,8,19,18]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const w=(0,L.dirname)(n);if(n===w)return n;const f=((0,L.basename)(n)||n).toLowerCase();try{const l=(0,T.readdirSync)(w).filter(y=>y.toLowerCase()===f);if(l.length===1){const y=A(w);if(y)return(0,L.join)(y,l[0])}else if(l.length>1){const y=l.indexOf(f);if(y>=0){const I=A(w);if(I)return(0,L.join)(I,l[y])}}}catch(d){}return null}e.realcaseSync=A;async function P(n){try{return await T.Promises.realpath(n)}catch(w){const f=E(n);return await T.Promises.access(f,R.constants.R_OK),f}}e.realpath=P;function p(n){try{return R.realpathSync(n)}catch(w){const f=E(n);return R.accessSync(f,R.constants.R_OK),f}}e.realpathSync=p;function E(n){return(0,D.rtrim)((0,L.normalize)(n),L.sep)}}),define(Z[69],ee([0,1,34,8,18]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(p||(p={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class w{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:s=!1}={}){return s?E===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:s=!1,findPreview:o=!1}={}){const t=f({useAlternateBitness:s});if(!t)return null;const r=L.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const u of await D.Promises.readdir(r)){let g=-1;if(o){const m=u.indexOf("-");if(m<0)continue;const k=u.substring(0,m);if(!T.test(k)||u.substring(m+1)!=="preview")continue;g=parseInt(k,10)}else{if(!T.test(u))continue;g=parseInt(u,10)}if(g<=i)continue;const S=L.join(r,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(S)||(a=S,i=g)}if(!a)return null;const h=t.includes("x86")?" (x86)":"",c=o?" Preview":"";return new w(a,`PowerShell${c}${h}`,!0)}async function l({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const o=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(o))if(t.test(i)){const a=L.join(o,i,"pwsh.exe");return new w(a,r)}return null}function y(){const s=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new w(s,".NET Core PowerShell Global Tool")}function I(){const s=L.join(process.env.windir,E===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(s,"Windows PowerShell",!0)}async function*b(){let s=await d();s&&(yield s),s=await d({useAlternateBitness:!0}),s&&(yield s),s=await l(),s&&(yield s),s=y(),s&&(yield s),s=await d({findPreview:!0}),s&&(yield s),s=await l({findPreview:!0}),s&&(yield s),s=await d({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=I(),s&&(yield s)}async function*C(){for await(const s of b())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=C;async function v(){for await(const s of C())return s;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Z[100],ee([0,1,41,17]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(A){return new Promise((P,p)=>{let E;const n=new Map;function w(d,l,y,I,b){const C=n.get(l);if(d===A||C){const v={name:f(y),cmd:y,pid:d,ppid:l,load:I,mem:b};n.set(d,v),d===A&&(E=v),C&&(C.children||(C.children=[]),C.children.push(v),C.children.length>1&&(C.children=C.children.sort((s,o)=>s.pid-o.pid)))}}function f(d){const l=/--disable-blink-features=Auxclick/,y=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,b=/\\pipe\\winpty-control/,C=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(y.exec(d))return"watcherService ";if(I.exec(d))return"electron-crash-reporter";if(b.exec(d))return"winpty-process";if(C.exec(d))return"console-window-host (Windows internal process)";let s=v.exec(d);if(s&&s.length===2)return s[1]==="renderer"?l.exec(d)?"shared-process":"window":s[1];const o=/[a-zA-Z-]+\.js/g;let t="";do s=o.exec(d),s&&(t+=s+" ");while(s);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${t}`:d}if(process.platform==="win32"){const d=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substr(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substr(5):l;new Promise((l,y)=>{K(["windows-process-tree"],l,y)}).then(l=>{l.getProcessList(A,y=>{l.getProcessCpuUsage(y,I=>{const b=new Map;I.forEach(C=>{const v=d(C.commandLine||"");b.set(C.pid,{name:f(v),cmd:v,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),E=b.get(A),E?(b.forEach(C=>{const v=b.get(C.ppid);v&&(v.children||(v.children=[]),v.children.push(C))}),b.forEach(C=>{C.children&&(C.children=C.children.sort((v,s)=>v.pid-s.pid))}),P(E)):p(new Error(`Root process ${A} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let d=function(){let l=[E];const y=[];for(;l.length;){const b=l.shift();b&&(y.push(b.pid),b.children&&(l=l.concat(b.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);I+=" "+y.join(" "),(0,R.exec)(I,{},(b,C,v)=>{if(b||v)p(b||new Error(v.toString()));else{const s=C.toString().split(`
`);for(let o=0;o<y.length;o++){const t=n.get(y[o]);t.load=parseFloat(s[o])}if(!E){p(new Error(`Root process ${A} not found`));return}P(E)}})};(0,R.exec)("which ps",{},(l,y,I)=>{if(l||I)if(process.platform!=="linux")p(l||new Error(I.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,R.exec)(b,{},(C,v,s)=>{C||s?p(C||new Error(s.toString())):(T(v,w),d())})}else{const b=y.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${b} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,s,o)=>{v||o&&!o.includes("screen size is bogus")?p(v||new Error(o.toString())):(T(s,w),process.platform==="linux"?d():E?P(E):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=D;function T(A,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const n of E){const w=p.exec(n.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(Z[101],ee([0,1,50,39,2,66,8,4,18]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function E(f,d,l){return w({path:f,isDirectory:!1},d,l)}e.watchFile=E;function n(f,d,l){return w({path:f,isDirectory:!0},d,l)}e.watchFolder=n,e.CHANGE_BUFFER_DELAY=100;function w(f,d,l){if(P.isMacintosh&&(0,L.isEqualOrParent)(f.path,"/Volumes/"))return l(`Refusing to watch ${f.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const y=(0,A.basename)(f.path),I=new Map;let b=!1,C=[(0,D.toDisposable)(()=>{I.forEach(v=>(0,D.dispose)(v)),I.clear()})];try{const v=(0,R.watch)(f.path);C.push((0,D.toDisposable)(()=>{v.removeAllListeners(),v.close()}));const s=new Set;f.isDirectory&&p.Promises.readdir(f.path).then(o=>o.forEach(t=>s.add(t))),v.on("error",(o,t)=>{b||l(`Failed to watch ${f.path} for changes using fs.watch() (${o}, ${t})`)}),v.on("change",(o,t)=>{if(b)return;let r="";if(t&&(r=t.toString(),P.isMacintosh&&(r=(0,T.normalizeNFC)(r))),!r||o!=="change"&&o!=="rename")return;const i=f.isDirectory?(0,A.join)(f.path,r):f.path;if(f.isDirectory)if(o==="rename"){const a=I.get(i);a&&(0,D.dispose)(a);const h=setTimeout(async()=>{I.delete(i);const c=await p.Promises.exists(i);if(b)return;let u;c?s.has(r)?u="changed":(u="added",s.add(r)):(s.delete(r),u="deleted"),d(u,i)},e.CHANGE_BUFFER_DELAY);I.set(i,(0,D.toDisposable)(()=>clearTimeout(h)))}else{let a;s.has(r)?a="changed":(a="added",s.add(r)),d(a,i)}else if(o==="rename"||r!==y){const a=setTimeout(async()=>{const h=await p.Promises.exists(i);b||(h?(d("changed",i),C=[w(f,d,l)]):d("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,D.dispose)(C),C=[(0,D.toDisposable)(()=>clearTimeout(a))]}else d("changed",i)})}catch(v){p.Promises.exists(f.path).then(s=>{s&&!b&&l(`Failed to watch ${f.path} for changes using fs.watch() (${v.toString()})`)})}return(0,D.toDisposable)(()=>{b=!0,C=(0,D.dispose)(C)})}});var de=this&&this.__decorate||function(K,e,R,L){var D=arguments.length,T=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,R,L);else for(var P=K.length-1;P>=0;P--)(A=K[P])&&(T=(D<3?A(T):D>3?A(e,R,T):A(e,R))||T);return D>3&&T&&Object.defineProperty(e,R,T),T};define(Z[36],ee([0,1,23,6,25,29,64,11,3,2,94,19,16]),function(K,e,R,L,D,T,A,P,p,E,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var d;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(d=e.RequestType||(e.RequestType={}));function l(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function I(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));class C{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class v{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var s;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(s||(s={}));function o(q){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(q,0),F}function t(q){return q.read(4).readUInt32BE(0)}function r(q){const F=D.VSBuffer.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},a=typeof Buffer!="undefined";function h(q,F){if(typeof F=="undefined")q.write(i.Undefined);else if(typeof F=="string"){const j=D.VSBuffer.fromString(F);q.write(i.String),q.write(o(j.byteLength)),q.write(j)}else if(a&&Buffer.isBuffer(F)){const j=D.VSBuffer.wrap(F);q.write(i.Buffer),q.write(o(j.byteLength)),q.write(j)}else if(F instanceof D.VSBuffer)q.write(i.VSBuffer),q.write(o(F.byteLength)),q.write(F);else if(Array.isArray(F)){q.write(i.Array),q.write(o(F.length));for(const j of F)h(q,j)}else{const j=D.VSBuffer.fromString(JSON.stringify(F));q.write(i.Object),q.write(o(j.byteLength)),q.write(j)}}function c(q){switch(q.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return q.read(t(q)).toString();case s.Buffer:return q.read(t(q)).buffer;case s.VSBuffer:return q.read(t(q));case s.Array:{const j=t(q),_=[];for(let G=0;G<j;G++)_.push(c(q));return _}case s.Object:return JSON.parse(q.read(t(q)).toString())}}class u{constructor(F,j,_=null,G=1e3){this.protocol=F,this.ctx=j,this.logger=_,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger&&this.logger.logOutgoing(j,0,1,I(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(j,F.id,1,I(F.type),F.data);return}}}send(F,j=void 0){const _=new v;return h(_,F),h(_,j),this.sendBuffer(_.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onRawMessage(F){const j=new C(F),_=c(j),G=c(j),B=_[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(B)}: ${_[2]}.${_[3]}`,G),this.onPromise({type:B,id:_[1],channelName:_[2],name:_[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(B)}: ${_[2]}.${_[3]}`,G),this.onEventListen({type:B,id:_[1],channelName:_[2],name:_[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:_[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const _=new T.CancellationTokenSource;let G;try{G=j.call(this.ctx,F.name,F.arg,_.token)}catch(Q){G=Promise.reject(Q)}const B=F.id;G.then(Q=>{this.sendResponse({id:B,data:Q,type:201}),this.activeRequests.delete(F.id)},Q=>{Q instanceof Error?this.sendResponse({id:B,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:B,data:Q,type:203}),this.activeRequests.delete(F.id)});const X=(0,E.toDisposable)(()=>_.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const _=F.id,B=j.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:_,data:X,type:204}));this.activeRequests.set(F.id,B)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const _=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:_})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const _ of j)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=j}getChannel(F){const j=this;return{call(_,G,B){return j.isDisposed?Promise.reject(P.canceled()):j.requestPromise(F,_,G,B)},listen(_,G){return j.isDisposed?Promise.reject(P.canceled()):j.requestEvent(F,_,G)}}}requestPromise(F,j,_,G=T.CancellationToken.None){const B=this.lastRequestId++,Q={id:B,type:100,channelName:F,name:j,arg:_};if(G.isCancellationRequested)return Promise.reject(P.canceled());let ie;return new Promise((le,fe)=>{if(G.isCancellationRequested)return fe(P.canceled());const ye=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(B),le(Oe.data);break;case 202:this.handlers.delete(B);const Ae=new Error(Oe.data.message);Ae.stack=Oe.data.stack,Ae.name=Oe.data.name,fe(Ae);break;case 203:this.handlers.delete(B),fe(Oe.data);break}};this.handlers.set(B,Ne),this.sendRequest(Q)};let Se=null;this.state===b.Idle?ye():(Se=(0,L.createCancelablePromise)(Ne=>this.whenInitialized()),Se.then(()=>{Se=null,ye()}));const Pe=()=>{Se?(Se.cancel(),Se=null):this.sendRequest({id:B,type:101}),fe(P.canceled())},Te=G.onCancellationRequested(Pe);ie=(0,E.combinedDisposable)((0,E.toDisposable)(Pe),Te),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(F,j,_){const G=this.lastRequestId++,X={id:G,type:102,channelName:F,name:j,arg:_};let Q=null;const ie=new p.Emitter({onFirstListenerAdd:()=>{Q=(0,L.createCancelablePromise)(le=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:G,type:103}))}}),ne=le=>ie.fire(le.data);return this.handlers.set(G,ne),ie.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(j,F.id,0,`${l(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(j,F.id,0,l(F.type));return}}}send(F,j=void 0){const _=new v;return h(_,F),h(_,j),this.sendBuffer(_.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onBuffer(F){const j=new C(F),_=c(j),G=c(j),B=_[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,I(B)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],0,I(B),G),this.onResponse({type:_[0],id:_[1],data:G})}}onResponse(F){if(F.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(F.id);j&&j(F)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}de([A.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class m{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:_})=>{p.Event.once(j.onMessage)(B=>{const X=new C(B),Q=c(X),ie=new u(j,Q),ne=new S(j);this.channels.forEach((fe,ye)=>ie.registerChannel(ye,fe));const le={channelServer:ie,channelClient:ne,ctx:Q};this._connections.add(le),this._onDidAddConnection.fire(le),_(()=>{ie.dispose(),ne.dispose(),this._connections.delete(le),this._onDidRemoveConnection.fire(le)})})})}get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}getChannel(F,j){const _=this;return{call(G,B,X){let Q;if((0,f.isFunction)(j)){let ne=(0,R.getRandomElement)(_.connections.filter(j));Q=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(_.onDidAddConnection,j))}else Q=j.routeCall(_,G,B);const ie=Q.then(ne=>ne.channelClient.getChannel(F));return O(ie).call(G,B,X)},listen(G,B){if((0,f.isFunction)(j))return _.getMulticastEvent(F,j,G,B);const X=j.routeEvent(_,G,B).then(Q=>Q.channelClient.getChannel(F));return O(X).listen(G,B)}}}getMulticastEvent(F,j,_,G){const B=this;let X=new E.DisposableStore;const Q=new p.Emitter({onFirstListenerAdd:()=>{X=new E.DisposableStore;const ie=new p.EventMultiplexer,ne=new Map,le=ye=>{const Pe=ye.channelClient.getChannel(F).listen(_,G),Te=ie.add(Pe);ne.set(ye,Te)},fe=ye=>{const Se=ne.get(ye);!Se||(Se.dispose(),ne.delete(ye))};B.connections.filter(j).forEach(le),p.Event.filter(B.onDidAddConnection,j)(le,void 0,X),B.onDidRemoveConnection(fe,void 0,X),ie.event(Q.fire,Q,X),X.add(ie)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(_=>{_.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=m;class k{constructor(F,j,_=null){const G=new v;h(G,j),F.send(G.buffer),this.channelClient=new S(F,_),this.channelServer=new u(F,j,_)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function O(q){return{call(F,j,_){return q.then(G=>G.call(F,j,_))},listen(F,j){const _=new p.Relay;return q.then(G=>_.input=G.listen(F,j)),_.event}}}e.getDelayedChannel=O;function x(q){let F=!1;return{call(j,_,G){return F?q.call(j,_,G):(0,L.timeout)(0).then(()=>F=!0).then(()=>q.call(j,_,G))},listen(j,_){if(F)return q.listen(j,_);const G=new p.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>G.input=q.listen(j,_)),G.event}}}e.getNextTickChannel=x;class z{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await p.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=z;var H;(function(q){function F(G,B){const X=G,Q=B&&B.disableMarshalling,ie=new Map;for(const ne in X)_(ne)&&ie.set(ne,p.Event.buffer(X[ne],!0));return new class{listen(ne,le){const fe=ie.get(le);if(fe)return fe;throw new Error(`Event not found: ${le}`)}call(ne,le,fe){const ye=X[le];if(typeof ye=="function"){if(!Q&&Array.isArray(fe))for(let Se=0;Se<fe.length;Se++)fe[Se]=(0,n.revive)(fe[Se]);return ye.apply(X,fe)}throw new Error(`Method not found: ${le}`)}}}q.fromService=F;function j(G,B){const X=B&&B.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return B?.properties?.has(ie)?B.properties.get(ie):_(ie)?G.listen(ie):async function(...ne){let le;B&&!(0,f.isUndefinedOrNull)(B.context)?le=[B.context,...ne]:le=ne;const fe=await G.call(ie,le);return X?fe:(0,n.revive)(fe)};throw new Error(`Property not found: ${String(ie)}`)}})}q.toService=j;function _(G){return G[0]==="o"&&G[1]==="n"&&w.isUpperAsciiLetter(G.charCodeAt(2))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let F=q.toString();if(F!=="[object Object]")return F}return q}function $(q){return Array.isArray(q)?q.map(U):U(q)}function M(q,F,j,_,G,B,X){X=$(X);const Q=V[G],ie=Q[_%Q.length];let ne=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(B)?(ne=ne.concat(X),ne.push(")")):ne.push(X),console.log.apply(console,ne)}e.logWithColors=M;class N{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,_,G,B){this._totalOutgoing+=F,M(this._outgoingPrefix,this._totalOutgoing,F,j,_,G,B)}logIncoming(F,j,_,G,B){this._totalIncoming+=F,M(this._incomingPrefix,this._totalIncoming,F,j,_,G,B)}}e.IPCLogger=N}),define(Z[102],ee([0,1,25,3,36]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(p){this.port=p,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",E=>R.VSBuffer.wrap(E.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends D.IPCClient{constructor(p,E){const n=new T(p);super(n,E);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends D.IPCServer{static getOnDidClientConnect(){const p=L.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(E,n)=>n);return L.Event.map(p,E=>{const{port1:n,port2:w}=new MessageChannel,d={protocol:new T.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[w]),d})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[105],ee([0,1,25,11]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,p){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((n,w)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(E,P),E.responseType="arraybuffer",E.onerror=f=>w(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{n({res:{statusCode:E.status,headers:A(E)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>w(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),p.onCancellationRequested(()=>{E.abort(),w((0,L.canceled)())})})}e.request=D;function T(P,p){if(p.headers){e:for(let E in p.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,p.headers[E])}}}function A(P){const p=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const n=E.indexOf(":");p[E.substr(0,n).trim().toLowerCase()]=E.substr(n+1).trim()}return p}}),define(Z[70],ee([0,1,6,3,2,16]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class p extends D.Disposable{constructor(w,f=Object.create(null)){super();this.database=w,this.options=f,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((f,d)=>this.accept(d,f)),w.deleted?.forEach(f=>this.accept(f,void 0))}accept(w,f){if(this.state===P.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(f)?d=this.cache.delete(w):this.cache.get(w)!==f&&(this.cache.set(w,f),d=!0),d&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,f){const d=this.cache.get(w);return(0,T.isUndefinedOrNull)(d)?f:d}getBoolean(w,f){const d=this.get(w);return(0,T.isUndefinedOrNull)(d)?f:d==="true"}getNumber(w,f){const d=this.get(w);return(0,T.isUndefinedOrNull)(d)?f:parseInt(d,10)}async set(w,f){if(this.state===P.Closed)return;if((0,T.isUndefinedOrNull)(f))return this.delete(w);const d=String(f);if(this.cache.get(w)!==d)return this.cache.set(w,d),this.pendingInserts.set(w,d),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async delete(w){if(!(this.state===P.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(w){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert&&w.insert.forEach((f,d)=>this.items.set(d,f)),w.delete&&w.delete.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=E}),define(Z[106],ee([9,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,T=D*24,A=T*7,P=T*30,p=T*365;function E(w,f){typeof w!="number"&&(w=w.getTime());const d=Math.round((new Date().getTime()-w)/1e3);if(d<-30)return(0,R.localize)(0,null,E(new Date().getTime()+d*1e3,!1));if(d<30)return(0,R.localize)(1,null);let l;return d<L?(l=d,f?l===1?(0,R.localize)(2,null,l):(0,R.localize)(3,null,l):l===1?(0,R.localize)(4,null,l):(0,R.localize)(5,null,l)):d<D?(l=Math.floor(d/L),f?l===1?(0,R.localize)(6,null,l):(0,R.localize)(7,null,l):l===1?(0,R.localize)(8,null,l):(0,R.localize)(9,null,l)):d<T?(l=Math.floor(d/D),f?l===1?(0,R.localize)(10,null,l):(0,R.localize)(11,null,l):l===1?(0,R.localize)(12,null,l):(0,R.localize)(13,null,l)):d<A?(l=Math.floor(d/T),f?l===1?(0,R.localize)(14,null,l):(0,R.localize)(15,null,l):l===1?(0,R.localize)(16,null,l):(0,R.localize)(17,null,l)):d<P?(l=Math.floor(d/A),f?l===1?(0,R.localize)(18,null,l):(0,R.localize)(19,null,l):l===1?(0,R.localize)(20,null,l):(0,R.localize)(21,null,l)):d<p?(l=Math.floor(d/P),f?l===1?(0,R.localize)(22,null,l):(0,R.localize)(23,null,l):l===1?(0,R.localize)(24,null,l):(0,R.localize)(25,null,l)):(l=Math.floor(d/p),f?l===1?(0,R.localize)(26,null,l):(0,R.localize)(27,null,l):l===1?(0,R.localize)(28,null,l):(0,R.localize)(29,null,l))}e.fromNow=E;function n(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[107],ee([9,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,23,16,107]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,n){return n&&(E.stack||E.stacktrace)?D.localize(0,null,P(E),A(E.stack)||A(E.stacktrace)):P(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function p(E=null,n=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const w=R.coalesce(E),f=p(w[0],n);return w.length>1?D.localize(4,null,f,w.length):f}if(L.isString(E))return E;if(E.detail){const w=E.detail;if(w.error)return T(w.error,n);if(w.exception)return T(w.exception,n)}return E.stack?T(E,n):E.message?E.message:D.localize(5,null)}e.toErrorMessage=p}),define(Z[108],ee([9,10]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,41,39,17,26,8,4,35,16,68,18,108]),function(K,e,R,L,D,T,A,P,p,E,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(s,o){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};o&&(t.cwd=o);const r=R.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,h)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?d(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{R.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,a,h)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function y(s=p.env){return s.comspec||"cmd.exe"}e.getWindowsShell=y;class I{constructor(o,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=o,this.args=t,this.shell=r,this.options=i;else{const a=o;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(p.env).forEach(h=>{a[h]=p.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const t=o.lastIndexOf(A.sep);return t!==-1&&(o=o.substring(t+1)),I.WellKnowCommands[o]?o:"other"}start(o){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(p.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((h,c)=>{r=h,i=c});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=R.exec(h,this.options,(c,u,g)=>{this.childProcess=null;const S=c;S&&S.killed?i({killed:this.terminateRequested,stdout:u.toString(),stderr:g.toString()}):this.handleExec(r,o,c,u,g)})}else{let h=null;const c=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,r,o,i);const g={terminated:this.terminateRequested};E.isNumber(u)&&(g.cmdCode=u),r(g)};if(this.shell&&P.isWindows){const u=T.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let g=!1,S=!1;const m=[];let k=this.ensureQuotes(this.cmd);m.push(k.value),g=k.quoted,this.args&&this.args.forEach(x=>{k=this.ensureQuotes(x),m.push(k.value),S=S&&k.quoted});const O=["/s","/c"];g?S?O.push('"'+m.join(" ")+'"'):m.length>1?O.push('"'+m[0]+'" '+m.slice(1).join(" ")):O.push('"'+m[0]+'"'):O.push(m.join(" ")),h=R.spawn(y(),O,u)}else this.cmd&&(h=R.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(E.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",u=>{this.childProcess=null,i({terminated:this.terminateRequested,error:u})}),h.pid&&(this.childProcess.on("close",c),this.handleSpawn(h,r,o,i,!0)))}return a})}handleClose(o,t,r,i){}ensureQuotes(o){return I.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,l(o,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!P.isWindows)return o(!1);const t=R.spawn(y(),["/s","/c"]);t.on("error",r=>o(!0)),t.on("exit",r=>o(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class b extends I{constructor(o,t,r,i){super(o,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,t,r,i,a){[i,a].forEach((h,c)=>{const u=new n.LineDecoder;u.write(h).forEach(m=>{t({line:m,source:c===0?0:1})});const S=u.end();S&&t({line:S,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,t,r,i,a){const h=new n.LineDecoder,c=new n.LineDecoder;o.stdout.on("data",u=>{h.write(u).forEach(S=>r({line:S,source:0}))}),o.stderr.on("data",u=>{c.write(u).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=c}handleClose(o,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=b;function C(s){let o=[],t=!1;const r=function(i){if(t){o.push(i);return}(!s.send(i,h=>{if(h&&console.error(h),t=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(u=>r(u))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=C;var v;(function(s){async function o(t,r,i){if(A.isAbsolute(t))return t;if(r===void 0&&(r=p.cwd()),A.dirname(t)!=="."||(i===void 0&&E.isString(p.env.PATH)&&(i=p.env.PATH.split(A.delimiter)),i===void 0||i.length===0))return A.join(r,t);async function h(c){return await w.Promises.exists(c)?!(await w.Promises.stat(c)).isDirectory():!1}for(let c of i){let u;if(A.isAbsolute(c)?u=A.join(c,t):u=A.join(r,c,t),await h(u))return u;let g=u+".com";if(await h(g)||(g=u+".exe",await h(g)))return g}return A.join(r,t)}s.findExecutable=o})(v=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,34,4,69,71]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(d,l){return d===1?L.isWindows?w():T.getWindowsShell(l):E(d,l)}e.getSystemShell=A;function P(d,l){return d===1?L.isWindows?f(l):T.getWindowsShell(l):E(d,l)}e.getSystemShellSync=P;let p=null;function E(d,l){if(L.isLinux&&d===2||L.isMacintosh&&d===3)return"/bin/bash";if(!p){let y;if(L.isWindows)y="/bin/bash";else{if(y=l.SHELL,!y)try{y=(0,R.userInfo)().shell}catch(I){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}p=y}return p}let n=null;async function w(){return n||(n=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),n}function f(d){if(n)return n;const l=L.isWindows&&parseFloat((0,R.release)())>=10,y=d.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${d.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?I:T.getWindowsShell(d)}}),define(Z[51],ee([0,1,41,6,25,29,93,11,3,2,26,4,71,36]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class l extends d.ChannelServer{constructor(b){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(v){}},onMessage:p.Event.fromNodeEventEmitter(process,"message",C=>D.VSBuffer.wrap(Buffer.from(C,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=l;class y{constructor(b,C){this.modulePath=b,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(b){const C=this;return{call(v,s,o){return C.requestPromise(b,v,s,o)},listen(v,s){return C.requestEvent(b,v,s)}}}requestPromise(b,C,v,s=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(b),t=(0,L.createCancelablePromise)(a=>o.call(C,v,a)),r=s.onCancellationRequested(()=>t.cancel()),i=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,C,v){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let s;const o=new p.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(C,v)(o.fire,o),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),w.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,R.fork)(this.modulePath,b,C);const v=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,A.isRemoteConsoleLog)(h)){(0,A.log)(h,`IPC Library: ${this.options.serverName}`);return}v.fire(D.VSBuffer.wrap(Buffer.from(h,"base64")))});const o=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&o.send(h.buffer.toString("base64")),r=v.event,i={send:t,onMessage:r};this._client=new d.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,c)=>{process.removeListener("exit",a),this.activeRequests.forEach(u=>(0,E.dispose)(u)),this.activeRequests.clear(),h!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:c})})}return this._client}getCachedChannel(b){let C=this.channels.get(b);return C||(C=this.client.getChannel(b),this.channels.set(b,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(Z[110],ee([9,10]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([9,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([9,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([9,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([9,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([9,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([9,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,56,64,17,8,35,15,5]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(l,y,I){this._args=l,this.paths=y,this.productService=I}get appRoot(){return(0,T.dirname)(D.FileAccess.asFileUri("",K).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(p.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return p.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return p.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=A.env.VSCODE_PORTABLE;return l?p.URI.file((0,T.join)(l,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,T.resolve)(l):(0,T.normalize)((0,T.join)(D.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,T.resolve)(l):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,T.resolve)(l);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const I=A.env.VSCODE_PORTABLE;return I?(0,T.join)(I,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(y=>/^[^:/?#]+?:\/\//.test(y)?p.URI.parse(y):p.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?p.URI.parse(l):p.URI.file((0,T.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return p.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],E.prototype,"appRoot",null),de([L.memoize],E.prototype,"userHome",null),de([L.memoize],E.prototype,"userDataPath",null),de([L.memoize],E.prototype,"appSettingsHome",null),de([L.memoize],E.prototype,"tmpDir",null),de([L.memoize],E.prototype,"userRoamingDataHome",null),de([L.memoize],E.prototype,"settingsResource",null),de([L.memoize],E.prototype,"userDataSyncHome",null),de([L.memoize],E.prototype,"userDataSyncLogResource",null),de([L.memoize],E.prototype,"sync",null),de([L.memoize],E.prototype,"machineSettingsResource",null),de([L.memoize],E.prototype,"globalStorageHome",null),de([L.memoize],E.prototype,"workspaceStorageHome",null),de([L.memoize],E.prototype,"keybindingsResource",null),de([L.memoize],E.prototype,"keyboardLayoutResource",null),de([L.memoize],E.prototype,"argvResource",null),de([L.memoize],E.prototype,"snippetsHome",null),de([L.memoize],E.prototype,"isExtensionDevelopment",null),de([L.memoize],E.prototype,"untitledWorkspacesHome",null),de([L.memoize],E.prototype,"installSourcePath",null),de([L.memoize],E.prototype,"builtinExtensionsPath",null),de([L.memoize],E.prototype,"extensionsPath",null),de([L.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],E.prototype,"extensionDevelopmentKind",null),de([L.memoize],E.prototype,"extensionTestsLocationURI",null),de([L.memoize],E.prototype,"debugExtensionHost",null),de([L.memoize],E.prototype,"serviceMachineIdResource",null),de([L.memoize],E.prototype,"telemetryLogResource",null),de([L.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function n(d,l){return f(d["inspect-extensions"],d["inspect-brk-extensions"],5870,l,d.debugId)}e.parseExtensionHostPort=n;function w(d,l){return f(d["inspect-search"],d["inspect-brk-search"],5876,l)}e.parseSearchPort=w;function f(d,l,y,I,b){const v=Number(l||d)||(I?null:y),s=v?Boolean(!!l):!1;return{port:v,break:s,debugId:b}}}),define(Z[135],ee([0,1,220,4,112]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(l,y,I=A){const b={},C=[],v=[];for(let r in y){const i=y[r];i.alias&&(b[r]=i.alias),i.type==="string"||i.type==="string[]"?(C.push(r),i.deprecates&&C.push(i.deprecates)):i.type==="boolean"&&(v.push(r),i.deprecates&&v.push(i.deprecates))}const s=R(l,{string:C,boolean:v,alias:b}),o={},t=s;o._=s._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in y){const i=y[r];i.alias&&delete t[i.alias];let a=t[r];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(a||(a=t[i.deprecates]),delete t[i.deprecates]),typeof a!="undefined"&&(i.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):i.type==="string"&&Array.isArray(a)&&(a=a.pop(),I.onMultipleValues(r,a)),o[r]=a),delete t[r]}for(let r in t)I.onUnknownOption(r);return o}e.parseArgs=P;function p(l,y){let I="";return y.args&&(Array.isArray(y.args)?I=` <${y.args.join("> <")}>`:I=` <${y.args}>`),y.alias?`-${y.alias} --${l}${I}`:`--${l}${I}`}function E(l,y){let I=0,b=[];for(const o in l){const t=l[o],r=p(o,t);I=Math.max(I,r.length),b.push([r,t.description])}let C=I+2+1;if(y-C<25)return b.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=y-C-1,s=[];for(const o of b){let t=o[0],r=w(o[1],v),i=n(C-t.length-2);s.push("  "+t+i+r[0]);for(let a=1;a<r.length;a++)s.push(n(C)+r[a])}return s}e.formatOptions=E;function n(l){return" ".repeat(l)}function w(l,y){let I=[];for(;l.length;){let b=l.length<y?l.length:l.lastIndexOf(" ",y),C=l.slice(0,b).trim();l=l.slice(b),I.push(C)}return I}function f(l,y,I,b,C=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let s=[`${l} ${I}`];s.push(""),s.push(`${(0,D.localize)(32,null)}: ${y} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),s.push(""),C&&(L.isWindows?s.push((0,D.localize)(35,null,y)):s.push((0,D.localize)(36,null,y)),s.push(""));const o={};for(const t in b){const r=b[t];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[t]=r}}for(let t in o){const r=t;let i=o[r];i&&(s.push(T[r]),s.push(...E(i,v)),s.push(""))}return s.join(`
`)}e.buildHelpMessage=f;function d(l,y){return`${l||(0,D.localize)(37,null)}
${y||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=d}),function(){"use strict";function K(e,R,L,D){function T(P){const p=A(P),E=[p];return e.isAbsolute(p)||E.unshift(D),e.resolve(...E)}function A(P){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,L);const n=P["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(w,"AppData","Roaming")}break;case"darwin":E=e.join(R.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,L)}return{getUserDataPath:T}}if(typeof define=="function")define(Z[136],ee([0,137,34,17,15,35]),function(e,R,L,D,T,A){const P=T.dirname(D.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return K(R,L,p.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),L=require("os");module.exports=K(R,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,34,134,136]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},p)}}e.NativeEnvironmentService=T}),define(Z[139],ee([0,1,5]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(I){const b=I.match(A);return b?b[1]:null}function n(I){if(I.indexOf("://")===-1){const b=I.match(L);return b?E(b[2]):null}try{const b=R.URI.parse(I);if(b.authority)return E(b.authority)}catch(b){}return null}function w(I,b){const C=new Set;let v;for(;v=P.exec(I);){const o=n(v[1]);o&&C.add(o)}const s=new Set(b);return Array.from(C).map(o=>s.has(o)?o:o.replace(p,"a"))}e.getDomainsOfRemotes=w;function f(I){const b=I.match(T);return b?b[2]:null}function d(I,b,C){return I&&b?(C&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${I}${b}`:`${I}/${b}`):null}function l(I,b){if(I.indexOf("://")===-1){const C=I.match(D);if(C)return d(C[2],C[3],b)}try{const C=R.URI.parse(I);if(C.authority)return d(f(C.authority),C.path,b)}catch(C){}return null}function y(I,b=!1){const C=[];let v;for(;v=P.exec(I);){const s=l(v[1],b);s&&C.push(s)}return C}e.getRemotes=y}),define(Z[140],ee([0,1,3,2,26,5,96]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(l,y){return T.URI.revive(y?y.transformIncoming(l):l)}function p(l,y){return y?y.transformOutgoingURI(l):l}function E(l,y){y=y||A.DefaultURITransformer;const I=l.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...l,manifest:void 0},y),manifest:I}}function n(l,y){return y?(0,D.cloneAndChange)(l,I=>I instanceof T.URI?y.transformOutgoingURI(I):void 0):l}class w{constructor(y,I){this.service=y,this.getUriTransformer=I,this.onInstallExtension=R.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,I){const b=this.getUriTransformer(y);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,C=>C.map(v=>({...v,local:v.local?n(v.local,b):v.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,I,b){const C=this.getUriTransformer(y);switch(I){case"zip":return this.service.zip(E(b[0],C)).then(v=>p(v,C));case"unzip":return this.service.unzip(P(b[0],C));case"install":return this.service.install(P(b[0],C),b[1]);case"getManifest":return this.service.getManifest(P(b[0],C));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(E(b[0],C),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(E(b[0],C));case"getInstalled":return this.service.getInstalled(b[0]).then(v=>v.map(s=>n(s,C)));case"updateMetadata":return this.service.updateMetadata(E(b[0],C),b[1]).then(v=>n(v,C));case"updateExtensionScope":return this.service.updateExtensionScope(E(b[0],C),b[1]).then(v=>n(v,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=w;class f extends L.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire({identifier:I.identifier,source:this.isUriComponents(I.source)?T.URI.revive(I.source):I.source}))),this._register(this.channel.listen("onDidInstallExtensions")(I=>this._onDidInstallExtensions.fire(I.map(b=>({...b,local:b.local?E(b.local,null):b.local,source:this.isUriComponents(b.source)?T.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(I=>T.URI.revive(I)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,I){return Promise.resolve(this.channel.call("install",[y,I])).then(b=>E(b,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}async canInstall(y){return!0}installFromGallery(y,I){return Promise.resolve(this.channel.call("installFromGallery",[y,I])).then(b=>E(b,null))}uninstall(y,I){return Promise.resolve(this.channel.call("uninstall",[y,I]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(I=>I.map(b=>E(b,null)))}updateMetadata(y,I){return Promise.resolve(this.channel.call("updateMetadata",[y,I])).then(b=>E(b,null))}updateExtensionScope(y,I){return Promise.resolve(this.channel.call("updateExtensionScope",[y,I])).then(b=>E(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class d{constructor(y){this.service=y}listen(y,I){throw new Error("Invalid listen")}call(y,I,b){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(Z[141],ee([0,1,26]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(T,A){const P=p=>{if(typeof p!="string")return;const E=L.exec(p);if(!E)return;const n=A[E[1]]??p;return typeof n=="string"?n:typeof n.message=="string"?n.message:p};return(0,R.cloneAndChange)(T,P)}e.localizeManifest=D}),define(Z[142],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,P,p){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,P,p])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class L{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[72],ee([0,1,120]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||L.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=f.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=A;function P(f){if(!f)return null;let d=f.majorBase,l=f.majorMustEqual,y=f.minorBase,I=f.minorMustEqual,b=f.patchBase,C=f.patchMustEqual;f.hasCaret&&(d===0||(I=!1),C=!1);let v=0;if(f.preRelease){const s=D.exec(f.preRelease);if(s){const[,o,t,r]=s;v=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:d,majorMustEqual:l,minorBase:y,minorMustEqual:I,patchBase:b,patchMustEqual:C,isMinimum:f.hasGreaterEquals,notBefore:v}}e.normalizeVersion=P;function p(f,d,l){let y;typeof f=="string"?y=P(A(f)):y=f;let I;d instanceof Date?I=d.getTime():typeof d=="string"&&(I=new Date(d).getTime());let b;if(typeof l=="string"?b=P(A(l)):b=l,!y||!b)return!1;let C=y.majorBase,v=y.minorBase,s=y.patchBase,o=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,a=b.majorMustEqual,h=b.minorMustEqual,c=b.patchMustEqual;return b.isMinimum?C>o?!0:C<o?!1:v>t?!0:v<t||I&&I<i?!1:s>=r:(C===1&&o===0&&(!a||!h||!c)&&(o=1,t=0,r=0,a=!0,h=!1,c=!1),C<o?!1:C>o?!a:v<t?!1:v>t?!h:s<r?!1:s>r?!c:!(I&&I<i))}e.isValidVersion=p;function E(f,d,l,y){return l.isBuiltin||typeof l.main=="undefined"?!0:w(f,d,l.engines.vscode,y)}e.isValidExtensionVersion=E;function n(f,d,l){return f==="*"||w(d,l,f)}e.isEngineValid=n;function w(f,d,l,y=[]){let I=P(A(l));if(!I)return y.push(R.localize(0,null,l)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return y.push(R.localize(1,null,l)),!1}else if(!I.majorMustEqual)return y.push(R.localize(2,null,l)),!1;return p(f,d,I)?!0:(y.push(R.localize(3,null,f,l)),!1)}}),define(Z[143],ee([0,1,2,17,36,51]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends R.Disposable{constructor(p,E,n,w){super();this.folders=p,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[144],ee([0,1,2,17,36,51]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends R.Disposable{constructor(p,E,n,w,f={}){super();this.folders=p,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=w,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[145],ee([0,1,41,67,17,68]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(p,E,n,w,f){this.watchedFolder=p,this.eventCallback=n,this.logCallback=w,this.verboseLogging=f,this.restartCounter=0,Array.isArray(E)?this.ignored=E.map(d=>(0,L.parse)(d)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${E.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,R.spawn)(D.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,p);const E=new T.LineDecoder;this.handle.stdout.on("data",n=>{const w=[];for(const f of E.write(n)){const d=f.split("|");if(d.length===2){const l=Number(d[0]),y=d[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(I=>I(y))){this.verboseLogging&&this.log(y);continue}w.push({type:A.changeTypeMap[l],path:y})}else this.log(d[1])}}w.length>0&&this.eventCallback(w)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,w)=>this.onExit(n,w))}onError(p){this.error("process error: "+p.toString())}onExit(p,E){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${E})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[146],ee([0,1,8,19,145]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,p,E,n){this.onDidFilesChange=p,this.onLogMessage=E,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new D.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,T=[],A=!1){this.ctor=D,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(Z[147],ee([0,1,52]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(A,P,p){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],p)),L.push([A,P])}e.registerSingleton=D;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const P=this.lookupOrInsertNode(T),p=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),p),p.incoming.set(this._hashFn(T),P)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let P=this._nodes.get(A);return P||(P=new R(T),this._nodes.set(A,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,P]of this._nodes)T.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const P=new Set([T]),p=this._findCycle(A,P);if(p)return p}}_findCycle(T,A){for(let[P,p]of T.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const E=this._findCycle(p,A);if(E)return E;A.delete(P)}}}e.Graph=L}),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function p(E){return E[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=p})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(P,p,E,n){p[R.DI_TARGET]===p?p[R.DI_DEPENDENCIES].push({id:P,index:E,optional:n}):(p[R.DI_DEPENDENCIES]=[{id:P,index:E,optional:n}],p[R.DI_TARGET]=p)}function D(P){if(R.serviceIds.has(P))return R.serviceIds.get(P);const p=function(E,n,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(p,E,w,!1)};return p.toString=()=>P,R.serviceIds.set(P,p),p}e.createDecorator=D;function T(P){return P}e.refineServiceDecorator=T;function A(P){return function(p,E,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,p,n,!0)}}e.optional=A}),define(Z[149],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(Z[150],ee([0,1,4,19,7]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=R.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",R.isMacintosh),A.set("isLinux",R.isLinux),A.set("isWindows",R.isWindows),A.set("isWeb",R.isWeb),A.set("isMacNative",R.isMacintosh&&!R.isWeb),A.set("isEdge",T.indexOf("Edg/")>=0),A.set("isFirefox",T.indexOf("Firefox")>=0),A.set("isChrome",T.indexOf("Chrome")>=0),A.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var p;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return w.INSTANCE}static true(){return f.INSTANCE}static has(m){return d.create(m)}static equals(m,k){return l.create(m,k)}static notEquals(m,k){return b.create(m,k)}static regex(m,k){return r.create(m,k)}static in(m,k){return y.create(m,k)}static not(m){return C.create(m)}static and(...m){return a.create(m)}static or(...m){return h.create(m)}static greater(m,k){return v.create(m,k)}static less(m,k){return o.create(m,k)}static deserialize(m,k=!1){if(!!m)return this._deserializeOrExpression(m,k)}static _deserializeOrExpression(m,k){let O=m.split("||");return h.create(O.map(x=>this._deserializeAndExpression(x,k)))}static _deserializeAndExpression(m,k){let O=m.split("&&");return a.create(O.map(x=>this._deserializeOne(x,k)))}static _deserializeOne(m,k){if(m=m.trim(),m.indexOf("!=")>=0){let O=m.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],k))}if(m.indexOf("==")>=0){let O=m.split("==");return l.create(O[0].trim(),this._deserializeValue(O[1],k))}if(m.indexOf("=~")>=0){let O=m.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],k))}if(m.indexOf(" in ")>=0){let O=m.split(" in ");return y.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const O=m.split(">=");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const O=m.split(">");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const O=m.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const O=m.split("<");return o.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(m)?C.create(m.substr(1).trim()):d.create(m)}static _deserializeValue(m,k){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let O=/^'([^']*)'$/.exec(m);return O?O[1].trim():m}static _deserializeRegexValue(m,k){if((0,L.isFalsyOrWhitespace)(m)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=m.indexOf("/"),x=m.lastIndexOf("/");if(O===x||O<0){if(k)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let z=m.slice(O+1,x),H=m[x+1]==="i"?"i":"";try{return new RegExp(z,H)}catch(V){if(k)throw new Error(`bad regexp-value '${m}', parse error: ${V}`);return console.warn(`bad regexp-value '${m}', parse error: ${V}`),null}}}e.ContextKeyExpr=E;function n(S,m){return S.cmp(m)}class w{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class f{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class d{constructor(m){this.key=m,this.type=2}static create(m){const k=A.get(m);return typeof k=="boolean"?k?f.INSTANCE:w.INSTANCE:new d(m)}cmp(m){return m.type!==this.type?this.type-m.type:u(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return C.create(this.key)}}e.ContextKeyDefinedExpr=d;class l{constructor(m,k){this.key=m,this.value=k,this.type=4}static create(m,k){if(typeof k=="boolean")return k?d.create(m):C.create(m);const O=A.get(m);return typeof O=="boolean"?k===(O?"true":"false")?f.INSTANCE:w.INSTANCE:new l(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class y{constructor(m,k){this.key=m,this.valueKey=k,this.type=10}static create(m,k){return new y(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const k=m.getValue(this.valueKey),O=m.getValue(this.key);return Array.isArray(k)?k.indexOf(O)>=0:typeof O=="string"&&typeof k=="object"&&k!==null?P.call(k,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return I.create(this)}}e.ContextKeyInExpr=y;class I{constructor(m){this._actual=m,this.type=11}static create(m){return new I(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new I(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class b{constructor(m,k){this.key=m,this.value=k,this.type=5}static create(m,k){if(typeof k=="boolean")return k?C.create(m):d.create(m);const O=A.get(m);return typeof O=="boolean"?k===(O?"true":"false")?w.INSTANCE:f.INSTANCE:new b(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class C{constructor(m){this.key=m,this.type=3}static create(m){const k=A.get(m);return typeof k=="boolean"?k?w.INSTANCE:f.INSTANCE:new C(m)}cmp(m){return m.type!==this.type?this.type-m.type:u(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=C;class v{constructor(m,k){this.key=m,this.value=k,this.type=12}static create(m,k){return new v(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class s{constructor(m,k){this.key=m,this.value=k,this.type=13}static create(m,k){return new s(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class o{constructor(m,k){this.key=m,this.value=k,this.type=14}static create(m,k){return new o(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(m,k){this.key=m,this.value=k,this.type=15}static create(m,k){return new t(m,k)}cmp(m){return m.type!==this.type?this.type-m.type:g(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(m,k){this.key=m,this.regexp=k,this.type=7}static create(m,k){return new r(m,k)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const k=this.regexp?this.regexp.source:"",O=m.regexp?m.regexp.source:"";return k<O?-1:k>O?1:0}equals(m){if(m.type===this.type){const k=this.regexp?this.regexp.source:"",O=m.regexp?m.regexp.source:"";return this.key===m.key&&k===O}return!1}evaluate(m){let k=m.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(m){this._actual=m,this.type=8}static create(m){return new i(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new i(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(m){this.expr=m,this.type=6}static create(m){return a._normalizeArr(m)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const x=n(this.expr[k],m.expr[k]);if(x!==0)return x}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(m.expr[k]))return!1;return!0}return!1}evaluate(m){for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].evaluate(m))return!1;return!0}static _normalizeArr(m){const k=[];let O=!1;for(const x of m)if(!!x){if(x.type===1){O=!0;continue}if(x.type===0)return w.INSTANCE;if(x.type===6){k.push(...x.expr);continue}k.push(x)}if(k.length===0&&O)return f.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(n);k.length>1;){const x=k[k.length-1];if(x.type!==9)break;k.pop();const z=k.pop(),H=h.create(x.expr.map(V=>a.create([V,z])));H&&(k.push(H),k.sort(n))}return k.length===1?k[0]:new a(k)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let k of this.expr)m.push(...k.keys());return m}map(m){return new a(this.expr.map(k=>k.map(m)))}negate(){let m=[];for(let k of this.expr)m.push(k.negate());return h.create(m)}}e.ContextKeyAndExpr=a;class h{constructor(m){this.expr=m,this.type=9}static create(m){const k=h._normalizeArr(m);if(k.length!==0)return k.length===1?k[0]:new h(k)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const x=n(this.expr[k],m.expr[k]);if(x!==0)return x}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(m.expr[k]))return!1;return!0}return!1}evaluate(m){for(let k=0,O=this.expr.length;k<O;k++)if(this.expr[k].evaluate(m))return!0;return!1}static _normalizeArr(m){let k=[],O=!1;if(m){for(let x=0,z=m.length;x<z;x++){const H=m[x];if(!!H){if(H.type===0){O=!0;continue}if(H.type===1)return[f.INSTANCE];if(H.type===9){k=k.concat(H.expr);continue}k.push(H)}}if(k.length===0&&O)return[w.INSTANCE];k.sort(n)}return k}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let k of this.expr)m.push(...k.keys());return m}map(m){return new h(this.expr.map(k=>k.map(m)))}negate(){let m=[];for(let O of this.expr)m.push(O.negate());const k=O=>O.type===9?O.expr:[O];for(;m.length>1;){const O=m.shift(),x=m.shift(),z=[];for(const H of k(O))for(const V of k(x))z.push(E.and(H,V));m.unshift(E.or(...z))}return m[0]}}e.ContextKeyOrExpr=h;class c extends d{constructor(m,k,O){super(m);this._defaultValue=k,typeof O=="object"?c._info.push({...O,key:m}):O!==!0&&c._info.push({key:m,description:O,type:k!=null?typeof k:void 0})}static all(){return c._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return E.not(this.key)}isEqualTo(m){return E.equals(this.key,m)}notEqualsTo(m){return E.notEquals(this.key,m)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(S,m){return S<m?-1:S>m?1:0}function g(S,m,k,O){return S<k?-1:S>k?1:m<O?-1:m>O?1:0}}),define(Z[73],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[74],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(Z[12],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,17,115,7]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=T;var A;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=5]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var p;(function(w){w.Install="install",w.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var E;(function(w){w[w.None=0]="None",w[w.Install=1]="Install",w[w.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(f,d){super(f);this.code=d,this.name=d}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(R,L){e(R,L,K)}};define(Z[151],ee([0,1,2,27]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=de([Y(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(Z[75],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,19,7]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,f){if(typeof w=="undefined"||w===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof w=="string"||typeof f=="string"){let d=typeof w=="string"?w:w.value,l=typeof f=="string"?f:f.value;return R.equalsIgnoreCase(d,l)}return w._lower===f._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=P;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function E(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,19,76]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(l,y){return l.uuid&&y.uuid?l.uuid===y.uuid:l.id===y.id?!0:(0,R.compareIgnoreCase)(l.id,y.id)===0}e.areSameExtensions=D;class T{constructor(y,I){this.version=I,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof T?D(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(l,y){return`${l}.${y}`}e.getExtensionId=A;function P(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function p(l,y){return P(A(l,y))}e.getGalleryExtensionId=p;function E(l,y){const I=[],b=C=>{for(const v of I)if(v.some(s=>D(y(s),y(C))))return v;return null};for(const C of l){const v=b(C);v?v.push(C):I.push([C])}return I}e.groupByExtension=E;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function w(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function f(l){const y=new Set;for(const I of l)I.malicious&&y.add(I.id.id);return y}e.getMaliciousExtensionsSet=f;function d(l,y){const I=[],b=y.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const C=b.shift();if(C&&I.every(v=>!D(v.identifier,{id:C}))){const v=l.filter(s=>D(s.identifier,{id:C}));v.length===1&&(I.push(v[0]),b.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=d}),define(Z[152],ee([0,1,2,8,18,76]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(p,E){super();this.environmentService=p,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(E.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(p){p.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[13],ee([0,1,40,8,19,16,5,122,7]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var w;(function(U){U[U.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=d;function l(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=l;function y(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function I(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=I;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor($,M){super($);this.code=M}}e.FileSystemProviderError=C;function v(U,$){const M=new C(U.toString(),$);return o(M,$),M}e.createFileSystemProviderError=v;function s(U){return U||v((0,P.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function o(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=o;function t(U){if(!U)return b.Unknown;if(U instanceof C)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return b.Unknown;switch($[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof g)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor($,M,N){this.resource=$,this.operation=M,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=R.TernarySearchTree.forUris(()=>M)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=R.TernarySearchTree.forUris(()=>M)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=R.TernarySearchTree.forUris(()=>M)),this.deleted.set(N.resource,N);break}}contains($,...M){return this.doContains($,{includeChildren:!1},...M)}affects($,...M){return this.doContains($,{includeChildren:!0},...M)}doContains($,M,...N){if(!$)return!1;const q=N.length>0;return!!((!q||N.includes(1))&&(this.added?.get($)||M.includeChildren&&this.added?.findSuperstr($))||(!q||N.includes(0))&&(this.updated?.get($)||M.includeChildren&&this.updated?.findSuperstr($))||(!q||N.includes(2))&&(this.deleted?.findSubstr($)||M.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function u(U,$,M){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),M?(0,D.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=u;class g extends Error{constructor($,M,N){super($);this.fileOperationResult=M,this.options=N}}e.FileOperationError=g;class S extends g{constructor($,M,N){super($,2,N);this.stat=M}}e.NotModifiedSinceFileOperationError=S;var m;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(m=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function x(U,$){if(!$.canHandleResource(A.URI.from({scheme:U.scheme})))return new Promise(M=>{const N=$.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(N.dispose(),M())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize($){return(0,T.isNumber)($)||($=0),$<z.KB?(0,P.localize)(1,null,$.toFixed(0)):$<z.MB?(0,P.localize)(2,null,($/z.KB).toFixed(2)):$<z.GB?(0,P.localize)(3,null,($/z.MB).toFixed(2)):$<z.TB?(0,P.localize)(4,null,($/z.GB).toFixed(2)):(0,P.localize)(5,null,($/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var H;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function V(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=V}),define(Z[153],ee([0,1,154,49,13]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(p,E)=>{const n=(0,R.createHash)("md5"),w=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(w,{onData:f=>n.update(f.buffer),onError:f=>E(f),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};T=de([Y(0,D.IFileService)],T),e.ChecksumService=T}),define(Z[155],ee([0,1,221,113,135,13]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,d){const l={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,b)=>{console.warn((0,L.localize)(1,null,I,b))}},y=(0,D.parseArgs)(f,D.OPTIONS,d?l:void 0);return y.goto&&y._.forEach(I=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),y["max-memory"]&&R(parseInt(y["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function P(f){const d=f.findIndex(l=>!/^-/.test(l));if(d>-1)return[...f.slice(0,d),...f.slice(d+1)]}function p(f){let[,...d]=f;process.env.VSCODE_DEV&&(d=P(d)||[]);const l=!w(process.env);return A(d,l)}e.parseMainProcessArgv=p;function E(f){const[,,...d]=f;return A(d,!0)}e.parseCLIProcessArgv=E;function n(f,...d){const l=f.indexOf("--");return l===-1?f.push(...d):f.splice(l,0,...d),f}e.addArg=n;function w(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),define(Z[156],ee([0,1,41,137,29,37,11,4,30,109,155]),function(K,e,R,L,D,T,A,P,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function w(l,y,I){return y["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,n.isLaunchedFromCli)(I)&&!y["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,n.isLaunchedFromCli)(I)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async b=>{const C=new D.CancellationTokenSource,v=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),C.dispose(!0),b({})},1e4);try{const s=await d(l,C.token);b(s)}catch(s){(0,A.isPromiseCanceledError)(s)||l.error(`[resolve shell env] Unable to resolve shell environment (${s}). Proceeding without shell environment...`),b({})}finally{clearTimeout(v),C.dispose()}})),f)}e.resolveShellEnv=w;let f;async function d(l,y){const I=new Promise(async(b,C)=>{const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",s);const o=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",r);const i=await(0,E.getSystemShell)(P.OS,r);if(l.trace("getUnixShellEnvironment#shell",i),y.isCancellationRequested)return C(A.canceled);const a=L.basename(i);let h,c;/^pwsh(-preview)?$/.test(a)?(h=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,c=["-Login","-Command"]):(h=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,c=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),h);const u=(0,R.spawn)(i,[...c,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});y.onCancellationRequested(()=>(u.kill(),C(A.canceled))),u.on("error",m=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(m)),b({})});const g=[];u.stdout.on("data",m=>g.push(m));const S=[];u.stderr.on("data",m=>S.push(m)),u.on("close",(m,k)=>{const O=Buffer.concat(g).toString("utf8");l.trace("getUnixShellEnvironment#raw",O);const x=Buffer.concat(S).toString("utf8");if(x.trim()&&l.trace("getUnixShellEnvironment#stderr",x),m||k)return C(new Error(`Failed to get environment (code ${m}, signal ${k})`));const z=t.exec(O),H=z?z[1]:"{}";try{const V=JSON.parse(H);v?V.ELECTRON_RUN_AS_NODE=v:delete V.ELECTRON_RUN_AS_NODE,s?V.ELECTRON_NO_ATTACH_CONSOLE=s:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",V),b(V)}catch(V){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(V)),C(V)}})});try{return await I}catch(b){return l.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(b)),{}}}}),define(Z[77],ee([0,1,4,5,13]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(p){return p.map(E=>({type:E.type,resource:L.URI.file(E.path)}))}e.toFileChanges=T;function A(p){const E=new P;for(const n of p)E.processEvent(n);return E.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(E){const n=this.mapPathToChange.get(E.path);if(n){const w=n.type,f=E.type;w===1&&f===2?(this.mapPathToChange.delete(E.path),this.normalized.splice(this.normalized.indexOf(n),1)):w===2&&f===1?n.type=0:w===1&&f===0||(n.type=f)}else this.normalized.push(E),this.mapPathToChange.set(E.path,E)}normalize(){const E=[],n=[];return this.normalized.filter(w=>w.type!==2?(E.push(w),!1):!0).sort((w,f)=>w.path.length-f.path.length).filter(w=>n.some(f=>(0,D.isParent)(w.path,f,!R.isLinux))?!1:(n.push(w.path),!0)).concat(E)}}}),define(Z[157],ee([0,1,6,2,8,99,18,101,77]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends L.Disposable{constructor(w,f,d,l){super();this.path=w,this.onDidFilesChange=f,this.onLogMessage=d,this.verboseLogging=l,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(w){this.verboseLogging=w}async startWatching(){try{const{stat:w,symbolicLink:f}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let d=this.path;if(f)try{d=await(0,T.realpath)(d)}catch(l){if(this.onError(l),f.dangling)return}w.isDirectory()?this._register((0,P.watchFolder)(d,(l,y)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(y))})},l=>this.onError(l))):this._register((0,P.watchFile)(d,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(w){w.code!=="ENOENT"&&this.onError(w)}}onFileChange(w){this.fileChangesBuffer.push(w),this.verboseLogging&&this.onVerbose(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,p.normalizeFileChanges)(f);if(this.verboseLogging)for(const l of d)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);d.length>0&&this.onDidFilesChange(d)})}onError(w){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${w}`})}onVerbose(w){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[T,A]of D)this.set(T,A)}set(D,T){const A=this._entries.get(D);return this._entries.set(D,T),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(Z[158],ee([0,1,6,11,52,148,7,78]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class E extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class n{constructor(l=new P.ServiceCollection,y=!1,I){this._activeInstantiations=new Set,this._services=l,this._strict=y,this._parent=I,this._services.set(A.IInstantiationService,this)}createChild(l){return new n(l,this._strict,this)}invokeFunction(l,...y){let I=f.traceInvocation(l),b=!1;try{return l({get:(v,s)=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(v,I);if(!o&&s!==A.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return o}},...y)}finally{b=!0,I.stop()}}createInstance(l,...y){let I,b;return l instanceof D.SyncDescriptor?(I=f.traceCreation(l.ctor),b=this._createInstance(l.ctor,l.staticArguments.concat(y),I)):(I=f.traceCreation(l),b=this._createInstance(l,y,I)),I.stop(),b}_createInstance(l,y=[],I){let b=A._util.getServiceDependencies(l).sort((s,o)=>s.index-o.index),C=[];for(const s of b){let o=this._getOrCreateServiceInstance(s.id,I);if(!o&&this._strict&&!s.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${s.id}.`);C.push(o)}let v=b.length>0?b[0].index:y.length;if(y.length!==v){console.warn(`[createInstance] First service dependency of ${l.name} at position ${v+1} conflicts with ${y.length} static arguments`);let s=v-y.length;s>0?y=y.concat(new Array(s)):y=y.slice(0,v)}return new l(...[...y,...C])}_setServiceInstance(l,y){if(this._services.get(l)instanceof D.SyncDescriptor)this._services.set(l,y);else if(this._parent)this._parent._setServiceInstance(l,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let y=this._services.get(l);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):y}_getOrCreateServiceInstance(l,y){let I=this._getServiceInstanceOrDescriptor(l);return I instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,I,y.branch(l,!0)):(y.branch(l,!1),I)}_safeCreateAndCacheServiceInstance(l,y,I){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,y,I)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,y,I){const b=new T.Graph(s=>s.id.toString());let C=0;const v=[{id:l,desc:y,_trace:I}];for(;v.length;){const s=v.pop();if(b.lookupOrInsertNode(s),C++>1e3)throw new E(b);for(let o of A._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${l} depends on ${o.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};b.insertEdge(s,r),v.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new E(b);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}b.removeNode(o)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,y,I=[],b,C){if(this._services.get(l)instanceof D.SyncDescriptor)return this._createServiceInstance(y,I,b,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,y,I,b,C);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(l,y=[],I,b){if(I){const C=new R.IdleValue(()=>this._createInstance(l,y,b));return new Proxy(Object.create(null),{get(v,s){if(s in v)return v[s];let o=C.value,t=o[s];return typeof t!="function"||(t=t.bind(o),v[s]=t),t},set(v,s,o){return C.value[s]=o,!0}})}else return this._createInstance(l,y,b)}}e.InstantiationService=n;var w;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(w||(w={}));class f{constructor(l,y){this.type=l,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return p?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return p?new f(0,l.name):f._None}branch(l,y){let I=new f(2,l.toString());return this._dep.push([l,y,I]),I}stop(){let l=Date.now()-this._start;f._totals+=l;let y=!1;function I(C,v){let s=[],o=new Array(C+1).join("	");for(const[t,r,i]of v._dep)if(r&&i){y=!0,s.push(`${o}CREATES -> ${t}`);let a=I(C+1,i);a&&s.push(a)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||y)&&console.log(b.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,T){this.server=D,this.router=T}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,T){this.server.registerChannel(D,T)}}e.MessagePortMainProcessService=R}),define(Z[160],ee([0,1,36,52,147,7]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(d,l,y){const I=y.getChannel(d);return P(l)?new l.channelClientCtor(I):R.ProxyChannel.toService(I,l?.proxyOptions)}}function P(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let p=class extends A{constructor(d,l,y){super(d,l,y)}};p=de([Y(2,e.IMainProcessService)],p);function E(f,d,l){(0,D.registerSingleton)(f,new L.SyncDescriptor(p,[d,l],l?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let n=class extends A{constructor(d,l,y){super(d,l,y)}};n=de([Y(2,e.ISharedProcessService)],n);function w(f,d,l){(0,D.registerSingleton)(f,new L.SyncDescriptor(n,[d,l],l?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(Z[57],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const T of D.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[161],ee([0,1,2,57]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=de([Y(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(Z[14],ee([0,1,37,3,2,4,7]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class E extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class n extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let a=t[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(h){}r+=(i>0?" ":"")+a}return r}}e.AbstractMessageLogger=n;class w extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class f extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class d extends E{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class l extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class y extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=y;class I extends D.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class b{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function C(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const t=v(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function v(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=v;function s(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=s}),define(Z[162],ee([0,1,6,11,2,8,18,12,14]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends D.Disposable{constructor(w,f){super();this.environmentService=w,this.logService=f,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),y=(await A.Promises.readdir(f)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==w),I=y.slice(0,Math.max(0,y.length-9));I.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${I.join(", ")}'`),await Promise.all(I.map(b=>A.Promises.rm((0,T.join)(f,b)))))}catch(w){(0,L.onUnexpectedError)(w)}}};E=de([Y(0,P.IEnvironmentService),Y(1,p.ILogService)],E),e.LogsDataCleaner=E}),define(Z[163],ee([0,1,6,11,2,8,18,12,14]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class lt extends D.Disposable{constructor(w,f,d){super();this.backupWorkspacesPath=w,this.environmentService=f,this.logService=d,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),d=JSON.parse(w).emptyWorkspaceInfos.map(y=>y.backupFolder),l=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(l.map(async y=>{y.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&d.indexOf(y)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${y}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(w){(0,L.onUnexpectedError)(w)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=de([Y(1,P.INativeEnvironmentService),Y(2,p.ILogService)],E),e.StorageDataCleaner=E}),define(Z[164],ee([0,1,6,11,2,4,15,58,5,30,18,12,27,31,13,14]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends D.Disposable{constructor(v,s,o,t){super();this.fileService=s,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=p.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,s){await this.cleanUpPromise;const o=this.getName(v),t=(0,A.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(a){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(v){}async rename(v,s,o){try{await n.Promises.rename(v.fsPath,s.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${v} to ${s} with 'EPERM' error. Trying again...`),this.rename(v,s,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const s=[],o=[];for(const i of v.children){const a=this.parse(i.name);a&&o.push([a,i])}const t=(0,d.groupByExtension)(o,([i])=>i),r=[];for(const i of t)i.sort((a,h)=>P.rcompare(a[0].version,h[0].version)),s.push(...i.slice(1).map(a=>a[1].resource)),r.push(i[0][1]);r.sort((i,a)=>i.mtime-a.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await R.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new d.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,E.generateUuid)()}parse(v){const s=I.exec(v);return s&&s[1]&&s[2]?new d.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};b=de([Y(0,w.INativeEnvironmentService),Y(1,l.IFileService),Y(2,f.IExtensionGalleryService),Y(3,y.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[165],ee([0,1,41,6,37,3,2,17,8,18,12,14]),function(K,e,R,L,D,T,A,P,p,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(l,y){super();this.environmentService=l,this.logService=y,this.processesLimiter=new L.Limiter(5)}async postUninstall(l){const y=this.parseScript(l,"uninstall");return y&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${I}`)))),E.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(l,y){const I=`vscode:${y}`;if(l.location.scheme===P.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[I]=="string"){const b=l.manifest.scripts[I].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${I} should be a node script`),null):{script:(0,p.join)(l.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(l,y,I,b,C){return new Promise((v,s)=>{const o=this.start(l,y,I,C);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?s(i):v(void 0)};o.on("error",i=>{r((0,D.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,a)=>{r(i?`post-${y} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,o.kill(),s("timed out")},5e3))})}start(l,y,I,b){const C={silent:!0,execArgv:void 0},v=(0,R.fork)(l,[`--type=extension-post-${y}`,...I],C);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const s=T.Event.fromNodeEventEmitter(v.stdout,"data"),o=T.Event.fromNodeEventEmitter(v.stderr,"data");s(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${y}`,i)),o(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${y}`,i));const t=T.Event.any(T.Event.map(s,i=>({data:`%c${i}`,format:[""]})),T.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}getExtensionStoragePath(l){return(0,p.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};f=de([Y(0,n.IEnvironmentService),Y(1,w.ILogService)],f),e.ExtensionsLifecycle=f}),define(Z[166],ee([0,1,3,2,15,5,12,31,13,14]),function(K,e,R,L,D,T,A,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends L.Disposable{constructor(f,d,l,y){super();this.extensionsManagementService=f,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(C=>this.onInstallExtension(C))),this._register(f.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(f.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const I=T.URI.file(l.extensionsPath),b=new D.ExtUri(C=>!d.hasCapability(C,1024));this._register(d.watch(I)),this._register(R.Event.filter(d.onDidChangeFilesRaw,C=>C.changes.some(v=>this.doesChangeAffects(v,I,b)))(()=>this.onDidChange()))}doesChangeAffects(f,d,l){return l.isEqual(l.dirname(f.resource),d)?l.isEqual(f.resource,l.joinPath(d,".obsolete"))?!0:!(f.type!==1&&f.type!==2||l.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const d of f)this.removeInstallingExtension(d.identifier),d.local&&this.addInstalledExtension(d.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(d=>!(0,P.areSameExtensions)(d,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(d=>!(0,P.areSameExtensions)(d,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),d=f.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,P.areSameExtensions)(I,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),l=this.installedExtensions.filter(y=>this.installingExtensions.some(I=>(0,P.areSameExtensions)(I,y))?!1:f.every(I=>!(0,P.areSameExtensions)(I.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=f.map(y=>y.identifier),(d.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:d,removed:l})}}};n=de([Y(1,p.IFileService),Y(2,A.INativeEnvironmentService),Y(3,E.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[167],ee([0,1,154,23,6,2,17,8,18,12,27,31,57,14]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let l=class extends T.Disposable{constructor(b,C,v){super();this.extensionManagementService=b,this.logService=v,this.cache=this._register(new y(C,v)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),C=["en",...Object.keys(b)];return(0,L.distinct)(C)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const C=await this.cache.getLanguagePacks();Object.keys(C).some(v=>C[v]&&C[v].extensions.some(s=>(0,w.areSameExtensions)(s.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,C]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(C);return!(0,L.equals)(Object.keys(b),Object.keys(v))}};l=de([Y(0,n.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,d.ILogService)],l),e.LocalizationsService=l;let y=class extends T.Disposable{constructor(b,C){super();this.logService=C,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(C=>{Object.keys(C).forEach(v=>delete C[v]),this.createLanguagePacksFromExtensions(C,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...C){for(const v of C)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,v);Object.keys(b).forEach(v=>this.updateHash(b[v]))}createLanguagePacksFromExtension(b,C){const v=C.identifier,s=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const o of s)if(C.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(o)){let t=b[o.languageId];t||(t={hash:"",extensions:[],translations:{}},b[o.languageId]=t);let r=t.extensions.filter(i=>(0,w.areSameExtensions)(i.extensionIdentifier,v))[0];r?r.version=C.manifest.version:t.extensions.push({extensionIdentifier:v,version:C.manifest.version});for(const i of o.translations)t.translations[i.id]=(0,P.join)(C.location.fsPath,i.path)}}updateHash(b){if(b){const C=(0,R.createHash)("md5");for(const v of b.extensions)C.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);b.hash=C.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let C=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(s){return{}}}).then(v=>(C=b(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.languagePacks=v,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),p.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>C,v=>this.logService.error(v))})}};y=de([Y(0,E.INativeEnvironmentService),Y(1,d.ILogService)],y)}),define(Z[79],ee([0,1,3,5,14]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=R.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(f,d,l){switch(d){case"setLevel":return this.service.setLevel(l)}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,d){return f.call("setLevel",d)}}e.LogLevelChannelClient=A;class P{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,d){throw new Error(`Event not found: ${d}`)}async call(f,d,l){switch(d){case"createLogger":this.createLogger(L.URI.revive(l[0]),l[1]);return;case"log":return this.log(L.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1])}throw new Error(`Call not found: ${d}`)}createLogger(f,d){this.loggers.set(f.toString(),this.loggerService.createLogger(f,d))}consoleLog(f,d){let l=console.log;switch(f){case D.LogLevel.Error:l=console.error;break;case D.LogLevel.Warning:l=console.warn;break;case D.LogLevel.Info:l=console.info;break}l.call(console,...d)}log(f,d){const l=this.loggers.get(f.toString());if(!l)throw new Error("Create the logger before logging");for(const[y,I]of d)switch(y){case D.LogLevel.Trace:l.trace(I);break;case D.LogLevel.Debug:l.debug(I);break;case D.LogLevel.Info:l.info(I);break;case D.LogLevel.Warning:l.warn(I);break;case D.LogLevel.Error:l.error(I);break;case D.LogLevel.Critical:l.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class p extends D.AbstractLoggerService{constructor(f,d,l){super(f,d);this.channel=l}createConsoleMainLogger(){return new D.AdapterLogger({log:(f,d)=>{this.channel.call("consoleLog",[f,d])}})}doCreateLogger(f,d,l){return new E(this.channel,f,d,l)}}e.LoggerChannelClient=p;class E extends D.AbstractMessageLogger{constructor(f,d,l,y){super(y?.always);this.channel=f,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[d,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,d){const l=[[f,d]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(f){this.channel.call("log",[this.file,f])}}class n extends D.LogService{constructor(f,d){super(d);this.parent=f,this._register(f.onDidChangeLogLevel(l=>d.setLevel(l)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=n}),define(Z[59],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,4,35,15]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,T.dirname)(R.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const p=K.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:p.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[80],ee([0,1,25,11,123,13,44]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(w,f,d,l,y,I){let b;try{await p(w,f,d,l,y,I)}catch(C){b=C}finally{b&&y.errorTransformer&&(b=y.errorTransformer(b)),typeof b!="undefined"&&d.error(b),d.end()}}e.readFileIntoStream=P;async function p(w,f,d,l,y,I){E(I);const b=await w.open(f,{create:!1});try{E(I);let C=0,v=0,s=y&&typeof y.length=="number"?y.length:void 0,o=R.VSBuffer.alloc(Math.min(y.bufferSize,typeof s=="number"?s:y.bufferSize)),t=y&&typeof y.position=="number"?y.position:0,r=0;do v=await w.read(b,t,o.buffer,r,o.byteLength-r),t+=v,r+=v,C+=v,typeof s=="number"&&(s-=v),r===o.byteLength&&(await d.write(l(o)),o=R.VSBuffer.alloc(Math.min(y.bufferSize,typeof s=="number"?s:y.bufferSize)),r=0);while(v>0&&(typeof s!="number"||s>0)&&E(I)&&n(C,y));if(r>0){let i=r;typeof s=="number"&&(i=Math.min(r,s)),d.write(l(o.slice(0,i)))}}catch(C){throw(0,T.ensureFileSystemProviderError)(C)}finally{await w.close(b)}}function E(w){if(w.isCancellationRequested)throw(0,L.canceled)();return!0}function n(w,f){if(f?.limits){if(typeof f.limits.memory=="number"&&w>f.limits.memory)throw(0,T.createFileSystemProviderError)((0,D.localize)(0,null,A.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&w>f.limits.size)throw(0,T.createFileSystemProviderError)((0,D.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,23,6,25,29,3,55,2,40,17,169,15,49,121,13,80,14]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class qe extends p.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new y.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new y.FileChangesEvent(o,!0)))),this.watchedResources=E.TernarySearchTree.forUris(o=>{const t=this.getProvider(o.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(s,o){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:o});const t=new p.DisposableStore;return t.add(o.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(o)))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:s}))),typeof o.onDidErrorOccur=="function"&&t.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:o}),this.provider.delete(s),(0,p.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){o.push(t)}}),!this.provider.has(s)&&await L.Promises.settled(o)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,o){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return P.Iterable.map(this.provider,([s,o])=>({scheme:s,capabilities:o.capabilities}))}async withProvider(s){if(!(0,f.isAbsolutePath)(s))throw new y.FileOperationError((0,l.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const o=this.provider.get(s.scheme);if(!o){const t=new Error;throw t.name="ENOPRO",t.message=(0,l.localize)(1,null,s.toString()),t}return o}async withReadProvider(s){const o=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasReadWriteCapability)(o)||(0,y.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const o=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,o){try{return await this.doResolveFile(s,o)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,l.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(s,o){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),i=o?.resolveTo,a=o?.resolveSingleChildDescendants,h=o?.resolveMetadata,c=await t.stat(s);let u;return this.toFileStat(t,s,c,void 0,!!h,(g,S)=>(u||(u=E.TernarySearchTree.forUris(()=>!r),u.set(s,!0),(0,R.isNonEmptyArray)(i)&&i.forEach(m=>u.set(m,!0))),Boolean(u.findSuperstr(g.resource)||u.get(g.resource))?!0:g.isDirectory&&a?S===1:!1))}async toFileStat(s,o,t,r,i,a){const{providerExtUri:h}=this.getExtUri(s),c={resource:o,name:h.basename(o),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&a(c,r)){try{const u=await s.readdir(o),g=await L.Promises.settled(u.map(async([S,m])=>{try{const k=h.joinPath(o,S),O=i?await s.stat(k):{type:m};return await this.toFileStat(s,k,O,u.length,i,a)}catch(k){return this.logService.trace(k),null}}));c.children=(0,R.coalesce)(g)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(s){return L.Promises.settled(s.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const o=await this.withProvider(s);try{return!!await o.stat(s)}catch(t){return!1}}async canCreateFile(s,o){try{await this.doValidateCreateFile(s,o)}catch(t){return t}return!0}async doValidateCreateFile(s,o){if(!o?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,l.localize)(3,null,this.resourceForError(s)),3,o)}async createFile(s,o=D.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,o);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,r)),r}async writeFile(s,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,i.dirname(s));let h;if((0,y.hasReadWriteCapability)(r)&&!(o instanceof D.VSBuffer))if((0,d.isReadableStream)(o)){const c=await(0,d.peekStream)(o,3);c.ended?h=D.VSBuffer.concat(c.buffer):h=c}else h=(0,d.peekReadable)(o,c=>D.VSBuffer.concat(c),3);else h=o;!(0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)&&h instanceof D.VSBuffer?await this.doWriteUnbuffered(r,s,t,h):await this.doWriteBuffered(r,s,t,h instanceof D.VSBuffer?(0,D.bufferToReadable)(h):h)}catch(a){throw new y.FileOperationError((0,l.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(a).toString()),(0,y.toFileOperationResult)(a),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,o,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(o)));let i;try{i=await s.stat(o)}catch(a){return}if((i.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,l.localize)(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:i.size}))throw new y.FileOperationError((0,l.localize)(7,null),3,t);return i}async readFile(s,o){const t=await this.withReadProvider(s);return o?.atomic?this.doReadFileAtomic(t,s,o):this.doReadFile(t,s,o)}async doReadFileAtomic(s,o,t){return new Promise((r,i)=>{this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,o,t);r(a)}catch(a){i(a)}})})}async doReadFile(s,o,t){const r=await this.doReadFileStream(s,o,{...t,preferUnbuffered:!0});return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(s,o){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,o)}async doReadFileStream(s,o,t){const r=new T.CancellationTokenSource,i=this.validateReadFile(o,t).then(h=>h,h=>{throw r.cancel(),h});let a;try{return t&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await i,!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&t?.preferUnbuffered?a=this.readFileUnbuffered(s,o,t):(0,y.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,o,r.token,t):a=this.readFileBuffered(s,o,r.token,t),{...await i,value:a}}catch(h){a&&await(0,d.consumeStream)(a);const c=(0,l.localize)(8,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(h).toString());throw h instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(c,h.stat,t):new y.FileOperationError(c,(0,y.toFileOperationResult)(h),t)}}readFileStreamed(s,o,t,r=Object.create(null)){const i=s.readFileStream(o,r,t);return(0,d.transform)(i,{data:a=>a instanceof D.VSBuffer?a:D.VSBuffer.wrap(a),error:a=>new y.FileOperationError((0,l.localize)(9,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(a).toString()),(0,y.toFileOperationResult)(a),r)},a=>D.VSBuffer.concat(a))}readFileBuffered(s,o,t,r=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,I.readFileIntoStream)(s,o,i,a=>a,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new y.FileOperationError((0,l.localize)(10,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(a).toString()),(0,y.toFileOperationResult)(a),r)},t),i}readFileUnbuffered(s,o,t){const r=(0,d.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(o);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(o,i.byteLength,t),r.end(D.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,o){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,l.localize)(11,null,this.resourceForError(s)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==y.ETAG_DISABLED&&o.etag===t.etag)throw new y.NotModifiedSinceFileOperationError((0,l.localize)(12,null),t,o);return this.validateReadFileLimits(s,t.size,o),t}validateReadFileLimits(s,o,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&o>t.limits.size&&(r=7),typeof r=="number")throw new y.FileOperationError((0,l.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,o,t){return this.doCanMoveCopy(s,o,"move",t)}async canCopy(s,o,t){return this.doCanMoveCopy(s,o,"copy",t)}async doCanMoveCopy(s,o,t,r){if(s.toString()!==o.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,s,a,o,t,r)}catch(i){return i}return!0}async move(s,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(r,s,i,o,"move",!!t),h=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,a==="move"?2:3,h)),h}async copy(s,o,t){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(r,s,i,o,"copy",!!t),h=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,a==="copy"?3:2,h)),h}async doMoveCopy(s,o,t,r,i,a){if(o.toString()===r.toString())return i;const{exists:h,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,o,t,r,i,a);if(h&&!c&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(s===t&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(o,r,{overwrite:a});else{const u=await this.resolve(o);u.isDirectory?await this.doCopyFolder(s,u,t,r):await this.doCopyFile(s,o,t,r)}return i}else return s===t?(await s.rename(o,r,{overwrite:a}),i):(await this.doMoveCopy(s,o,t,r,"copy",a),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(s,o,t,r){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,o,t,r);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,o,t,r);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,o,t,r);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,o,t,r)}async doCopyFolder(s,o,t,r){await t.mkdir(r),Array.isArray(o.children)&&await L.Promises.settled(o.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),t,a):this.doCopyFile(s,i.resource,t,a)}))}async doValidateMoveCopy(s,o,t,r,i,a){let h=!1;if(s===t){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(s);if(g||(h=u.isEqual(o,r)),h&&i==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!h&&u.isEqualOrParent(r,o))throw new Error((0,l.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!h){if(!a)throw new y.FileOperationError((0,l.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(s===t){const{providerExtUri:u}=this.getExtUri(s);if(u.isEqualOrParent(o,r))throw new Error((0,l.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:h}}getExtUri(s){const o=this.isPathCaseSensitive(s);return{providerExtUri:o?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(o,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,t)),t}async mkdirp(s,o){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(o,r.dirname(o));)try{if(((await s.stat(o)).type&y.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,y.toFileSystemProviderErrorCode)(i)!==y.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(o)),o=r.dirname(o)}for(let i=t.length-1;i>=0;i--){o=r.joinPath(o,t[i]);try{await s.mkdir(o)}catch(a){if((0,y.toFileSystemProviderErrorCode)(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(s,o){try{await this.doValidateDelete(s,o)}catch(t){return t}return!0}async doValidateDelete(s,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(s)));let i;try{i=await t.stat(s)}catch(h){}if(i)this.throwIfFileIsReadonly(s,i);else throw new y.FileOperationError((0,l.localize)(20,null,this.resourceForError(s)),1);if(!!!o?.recursive){const h=await this.resolve(s);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(s)))}return t}async del(s,o){const t=await this.doValidateDelete(s,o),r=!!o?.useTrash,i=!!o?.recursive;await t.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}onDidChangeFile(s,o){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const i of s)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new y.FileChangesEvent(t,!o))}if(r){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,o={recursive:!1,excludes:[]}){const t=new p.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,p.toDisposable)(()=>i())),this.doWatch(s,o).then(a=>{r?(0,p.dispose)(a):i=()=>(0,p.dispose)(a)},a=>this.logService.error(a))}return o.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add((0,p.toDisposable)(()=>{const r=this.watchedResources.get(s);typeof r=="number"&&(r<=1?this.watchedResources.delete(s):this.watchedResources.set(s,r-1))}))),t}async doWatch(s,o){const t=await this.withProvider(s),r=this.toWatchKey(t,s,o),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,o)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,p.toDisposable)(()=>{i.count--,i.count===0&&((0,p.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,o,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(o),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,p.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,d.isReadableStream)(r)||(0,d.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,o,t){let r=0,i;if((0,d.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=D.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,o,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,h)=>{(0,d.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(s,o,c,c.byteLength,r,0)}catch(u){return h(u)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>h(c),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(s,o,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(s,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,o,t,r,i,a){let h=0;for(;h<r;)h+=await s.write(o,i+h,t.buffer,a+h,r-h)}async doWriteUnbuffered(s,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,o,t,r))}async doWriteUnbufferedQueued(s,o,t,r){let i;r instanceof D.VSBuffer?i=r:(0,d.isReadableStream)(r)?i=await(0,D.streamToBuffer)(r):(0,d.isReadableBufferedStream)(r)?i=await(0,D.bufferedStreamToBuffer)(r):i=(0,D.readableToBuffer)(r),await s.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,o,t,r))}async doPipeBufferedQueued(s,o,t,r){let i,a;try{i=await s.open(o,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const h=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,g=0;do g=await s.read(i,c,h.buffer,u,h.byteLength-u),await this.doWriteBuffer(t,a,h,g,c,u),c+=g,u+=g,u===h.byteLength&&(u=0);while(g>0)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await L.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(s,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,o,t,r))}async doPipeUnbufferedQueued(s,o,t,r){return t.writeFile(r,await s.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,o,t,r))}async doPipeUnbufferedToBufferedQueued(s,o,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const a=await s.readFile(o);await this.doWriteBuffer(t,i,D.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(s,o,t,r){const i=await(0,D.streamToBuffer)(this.readFileBuffered(s,o,T.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(s,o){if(s.capabilities&2048)throw new y.FileOperationError((0,l.localize)(22,null,this.resourceForError(o)),6);return s}throwIfFileIsReadonly(s,o){if((o.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,l.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===n.Schemas.file?s.fsPath:s.toString(!0)}};C.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},C=de([Y(0,b.ILogService)],C),e.FileService=C}),define(Z[170],ee([0,1,23,6,25,3,39,2,8,4,15,49,18,124,13,80,157,143,144,77,146,14]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends P.Disposable{constructor(i,a){super();this.logService=i,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:h}=await f.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,h),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await f.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),h=[];return await Promise.all(a.map(async c=>{try{let u;c.isSymbolicLink()?u=(await this.stat((0,n.joinPath)(i,c.name))).type:u=this.toType(c),h.push([c.name,u])}catch(u){this.logService.trace(u)}})),h}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let h;return a?.dangling?h=l.FileType.Unknown:i.isFile()?h=l.FileType.File:i.isDirectory()?h=l.FileType.Directory:h=l.FileType.Unknown,a&&(h|=l.FileType.SymbolicLink),h}async readFile(i){try{const a=this.toFilePath(i);return await f.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,h){const c=(0,w.newWriteableStream)(u=>D.VSBuffer.concat(u.map(g=>D.VSBuffer.wrap(g))).buffer);return(0,y.readFileIntoStream)(this,i,c,u=>u.buffer,{...a,bufferSize:this.BUFFER_SIZE},h),c}async writeFile(i,a,h){let c;try{const u=this.toFilePath(i);if(!h.create||!h.overwrite){if(await f.Promises.exists(u)){if(!h.overwrite)throw(0,l.createFileSystemProviderError)((0,d.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,l.createFileSystemProviderError)((0,d.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:h.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof c=="number"&&await this.close(c)}}async open(i,a){try{const h=this.toFilePath(i);if((0,l.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:g}=await f.SymlinkSupport.stat(h);g.mode&128||await f.Promises.chmod(h,g.mode|128)}catch(g){this.logService.trace(g)}let c;if((0,l.isFileOpenForWriteOptions)(a)){if(E.isWindows)try{await f.Promises.truncate(h,0),c="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}c||(c="w")}else c="r";const u=await f.Promises.open(h,c);return this.mapHandleToPos.set(u,0),(0,l.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(u,i),u}catch(h){throw(0,l.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await f.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await f.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,h,c,u){const g=this.normalizePos(i,a);let S=null;try{const m=await f.Promises.read(i,h,c,u,g);return typeof m=="number"?S=m:S=m.bytesRead,S}catch(m){throw this.toFileSystemProviderError(m)}finally{this.updatePos(i,g,S)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,h){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof a=="number"||(typeof h=="number"?this.mapHandleToPos.set(i,c+h):this.mapHandleToPos.delete(i)))}async write(i,a,h,c,u){return(0,L.retry)(()=>this.doWrite(i,a,h,c,u),100,3)}async doWrite(i,a,h,c,u){const g=this.normalizePos(i,a);let S=null;try{const m=await f.Promises.write(i,h,c,u,g);return typeof m=="number"?S=m:S=m.bytesWritten,S}catch(m){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),m)}finally{this.updatePos(i,g,S)}}async mkdir(i){try{await f.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const h=this.toFilePath(i);await this.doDelete(h,a)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(i,a){a.recursive?await f.Promises.rm(i,f.RimRafMode.MOVE):await f.Promises.unlink(i)}async rename(i,a,h){const c=this.toFilePath(i),u=this.toFilePath(a);if(c!==u)try{await this.validateTargetDeleted(i,a,"move",h.overwrite),await f.Promises.move(c,u)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,d.localize)(2,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(u)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,a,h){const c=this.toFilePath(i),u=this.toFilePath(a);if(c!==u)try{await this.validateTargetDeleted(i,a,"copy",h.overwrite),await f.Promises.copy(c,u,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,d.localize)(3,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(u)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,a,h,c){const u=this.toFilePath(i),g=this.toFilePath(a);let S=!1;if(!!(this.capabilities&1024)||(S=(0,A.isEqual)(u,g,!0)),S&&h==="copy")throw(0,l.createFileSystemProviderError)((0,d.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!S&&await f.Promises.exists(g)){if(!c)throw(0,l.createFileSystemProviderError)((0,d.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a.excludes):this.watchNonRecursive(i)}watchRecursive(i,a){const h={path:this.toFilePath(i),excludes:a},c=(0,R.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,a;this.options?.watcher?.usePolling?(i=C.FileWatcher,a=this.options?.watcher):this.recursiveFoldersToWatch.length===1?E.isWindows?i=s.FileWatcher:i=C.FileWatcher:i=b.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,v.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===o.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new I.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire((0,v.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===o.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)});return(0,P.combinedDisposable)(a,h)}toFilePath(i){return(0,p.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof l.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=l.FileSystemProviderErrorCode.NoPermissions;break;default:a=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let h=this.toFileSystemProviderError(a);if(i&&h.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(h=(0,l.createFileSystemProviderError)(a,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return h}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(Z[171],ee([0,1,6,11,2,8,18,14,28]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends D.Disposable{constructor(w,f,d){super();this.productService=f,this.logService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),d=(0,T.dirname)(w),l=(0,T.basename)(w),y=await A.Promises.readdir(d);await Promise.all(y.map(async I=>{if(I===l)return;const b=(0,T.join)(d,I),C=await A.Promises.stat(b);if(C.isDirectory()&&f-C.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${I}.`),A.Promises.rm(b)}))}catch(f){(0,L.onUnexpectedError)(f)}}};E=de([Y(1,p.IProductService),Y(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(Z[172],ee([0,1,6,11,2,8,18,12,14,28]),function(K,e,R,L,D,T,A,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends D.Disposable{constructor(f,d,l){super();this.environmentService=f,this.logService=d,this.productService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),d=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let C of Object.keys(d)){const v=d[C];f[`${v.hash}.${C}`]=!0}const l=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(l))return;const I=await A.Promises.readdir(l);for(const C of I){if(f[C]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await A.Promises.rm((0,T.join)(l,C))}const b=Date.now();for(const C of Object.keys(f)){const v=(0,T.join)(l,C),s=await A.Promises.readdir(v);for(const o of s){if(o==="tcf.json")continue;const t=(0,T.join)(v,o),r=await A.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(C,o)}`),await A.Promises.rm(t))}}}catch(f){(0,L.onUnexpectedError)(f)}}};n=de([Y(0,P.INativeEnvironmentService),Y(1,p.ILogService),Y(2,E.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[32],ee([0,1,90,16]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,P){R.ok(L.isString(A)),R.ok(L.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(Z[81],ee([0,1,3,32]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,E){this.schemasById[D(p)]=E,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;L.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[38],ee([0,1,3,16,111,81,32]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=A.Registry.as(T.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,v=!0){this.registerConfigurations([C],v)}registerConfigurations(C,v=!0){const s=[];C.forEach(o=>{s.push(...this.validateAndRegisterProperties(o,v,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(C){const v=[],s=o=>{if(o.properties)for(const t in o.properties)v.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,o.properties[t]);o.allOf&&o.allOf.forEach(t=>s(t))};for(const o of C){s(o);const t=this.configurationContributors.indexOf(o);t!==-1&&this.configurationContributors.splice(t,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(C){const v=[],s=[];for(const o of C)for(const t in o)if(v.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...o[t]};const r={type:"object",default:this.defaultValues[t],description:D.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};s.push(f(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=o[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(C){const v=[];for(const s of C)for(const o in s)if(v.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const v of C)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,v=!0,s,o=3){o=L.isUndefinedOrNull(C.scope)?o:C.scope;let t=[],r=C.properties;if(r)for(let a in r){if(v&&y(a)){delete r[a];continue}const h=r[a];if(this.updatePropertyDefaultValue(a,h),e.OVERRIDE_PROPERTY_PATTERN.test(a)?h.scope=void 0:(h.scope=L.isUndefinedOrNull(h.scope)?o:h.scope,h.restricted=L.isUndefinedOrNull(h.restricted)?!!s?.restrictedConfigurations?.includes(a):h.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let i=C.allOf;if(i)for(let a of i)t.push(...this.validateAndRegisterProperties(a,v,s,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const v=s=>{let o=s.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let t=s.allOf;t&&t.forEach(v)};v(C)}updateSchema(C,v){switch(e.allSettings.properties[C]=v,v.scope){case 1:e.applicationSettings.properties[C]=v;break;case 2:e.machineSettings.properties[C]=v;break;case 6:e.machineOverridableSettings.properties[C]=v;break;case 3:e.windowSettings.properties[C]=v;break;case 4:e.resourceSettings.properties[C]=v;break;case 5:e.resourceSettings.properties[C]=v,this.resourceLanguageSettingsSchema.properties[C]=v;break}}removeFromSchema(C,v){switch(delete e.allSettings.properties[C],v.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const v=`[${C}]`,s={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,s),e.allSettings.properties[v]=s,e.applicationSettings.properties[v]=s,e.machineSettings.properties[v]=s,e.machineOverridableSettings.properties[v]=s,e.windowSettings.properties[v]=s,e.resourceSettings.properties[v]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,v){let s=this.defaultValues[C];L.isUndefined(s)&&(s=v.default),L.isUndefined(s)&&(s=d(v.type)),v.default=s}}const w="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(w);function f(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=f;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const l=new n;A.Registry.add(e.Extensions.Configuration,l);function y(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?D.localize(5,null,b):l.getConfigurationProperties()[b]!==void 0?D.localize(6,null,b):null:D.localize(4,null)}e.validateProperty=y;function I(){const b=[],C=l.getConfigurationProperties();for(const v of Object.keys(C))b.push([v,C[v].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=I}),define(Z[24],ee([0,1,26,16,5,38,7,32]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=p;var E;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function w(r,i){const a=i?r?i.keys.filter(k=>r.keys.indexOf(k)===-1):[...i.keys]:[],h=r?i?r.keys.filter(k=>i.keys.indexOf(k)===-1):[...r.keys]:[],c=[];if(i&&r){for(const k of r.keys)if(i.keys.indexOf(k)!==-1){const O=b(r.contents,k),x=b(i.contents,k);R.equals(O,x)||c.push(k)}}const u=[],g=k=>{const O={};for(const x of k)for(const z of x.identifiers)O[o(z)]=x;return O},S=i?g(i.overrides):{},m=r?g(r.overrides):{};if(Object.keys(S).length)for(const k of a){const O=S[k];O&&u.push([(0,T.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(m).length)for(const k of h){const O=m[k];O&&u.push([(0,T.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(S).length&&Object.keys(m).length)for(const k of c){const O=m[k],x=S[k];if(O&&x){const z=w({contents:O.contents,keys:O.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});u.push([(0,T.overrideIdentifierFromKey)(k),[...z.added,...z.removed,...z.updated]])}}return{added:a,removed:h,updated:c,overrides:u}}e.compare=w;function f(r,i){const a=[];for(const h of Object.keys(r))if(T.OVERRIDE_PROPERTY_PATTERN.test(h)){const c={};for(const u in r[h])c[u]=r[h][u];a.push({identifiers:[(0,T.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(c),contents:d(c,i)})}return a}e.toOverrides=f;function d(r,i){const a=Object.create(null);for(let h in r)l(a,h,r[h],i);return a}e.toValuesTree=d;function l(r,i,a,h){const c=i.split("."),u=c.pop();let g=r;for(let S=0;S<c.length;S++){let m=c[S],k=g[m];switch(typeof k){case"undefined":k=g[m]=Object.create(null);break;case"object":break;default:h(`Ignoring ${i} as ${c.slice(0,S+1).join(".")} is ${JSON.stringify(k)}`);return}g=k}if(typeof g=="object"&&g!==null)try{g[u]=a}catch(S){h(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(g)}`)}else h(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=l;function y(r,i){const a=i.split(".");I(r,a)}e.removeFromValueTree=y;function I(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const h=r[a];typeof h=="object"&&!Array.isArray(h)&&(I(h,i),Object.keys(h).length===0&&delete r[a])}}function b(r,i,a){function h(g,S){let m=g;for(const k of S){if(typeof m!="object"||m===null)return;m=m[k]}return m}const c=i.split("."),u=h(r,c);return typeof u=="undefined"?a:u}e.getConfigurationValue=b;function C(r,i,a){Object.keys(i).forEach(h=>{h!=="__proto__"&&(h in r?L.isObject(r[h])&&L.isObject(i[h])?C(r[h],i[h],a):a&&(r[h]=i[h]):r[h]=i[h])})}e.merge=C;function v(){const r=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=v;function s(){const r=Object.create(null),i=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let a in i){let h=i[a].default;l(r,a,h,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=s;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,i,a){const h=r.inspect(i),c=r.inspect(a);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,23,3,33,2,40,26,16,5,24,38,32]),function(K,e,R,L,D,T,A,P,p,E,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,n.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[a],c=r[a];c&&(typeof h=="object"&&typeof c=="object"?(h=P.deepClone(h),this.mergeContents(h,c)):h=c),i[a]=h}return new d(i,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),i=P.deepClone(this.overrides),a=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const c of h.overrides){const[u]=i.filter(g=>R.equals(g.identifiers,c.identifiers));u?this.mergeContents(u.contents,c.contents):i.push(P.deepClone(c))}for(const c of h.keys)a.indexOf(c)===-1&&a.push(c)}return new d(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&p.isObject(t[i])&&p.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=P.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class l extends d{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),i=[];for(const a of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[(0,w.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,n.toValuesTree)(t[a],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,i)}}e.DefaultConfigurationModel=l;class y{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!p.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:a,overrides:h,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new d(i,a,h),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,a=[],h=[],c=[];function u(S){Array.isArray(a)?a.push(S):i!==null&&(a[i]=S)}let g={onObjectBegin:()=>{let S={};u(S),h.push(a),a=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let S=[];u(S),h.push(a),a=S,i=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:u,onError:(S,m,k)=>{c.push({error:S,offset:m,length:k})}};if(t)try{D.visit(t,g),r=a[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const i=f.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,i,!0,r);t=a.raw;const h=(0,n.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),c=Object.keys(t),u=(0,n.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:h,keys:c,overrides:u,restricted:a.restricted}}filter(t,r,i,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[]};const h={},c=[];for(let u in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const g=this.filter(t[u],r,!1,a);h[u]=g.raw,c.push(...g.restricted)}else{const g=r[u],S=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&c.push(u),(S===void 0||a.scopes===void 0||a.scopes.includes(S))&&(a.skipRestricted&&g?.restricted||(h[u]=t[u]))}return{raw:h,restricted:c}}}e.ConfigurationModelParser=y;class I extends T.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class b{constructor(t,r,i=new d,a=new d,h=new A.ResourceMap,c=new d,u=new A.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=c,this._memoryConfigurationByResource=u,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new d,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),h=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,u=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),m=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,x=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),z=a.getValue(t),H=R.distinct(R.flatten(a.overrides.map(V=>V.identifiers))).filter(V=>a.getOverrideValue(t,V)!==void 0);return{defaultValue:u,userValue:g,userLocalValue:S,userRemoteValue:m,workspaceValue:k,workspaceFolderValue:O,memoryValue:x,value:z,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:h?.freeze().getValue(t),override:r.overrideIdentifier?h?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>w.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const h=(0,w.overrideIdentifierFromKey)(a),c=this._defaultConfiguration.getKeysForOverrideIdentifier(h),u=t.getKeysForOverrideIdentifier(h),g=[...u.filter(S=>c.indexOf(S)===-1),...c.filter(S=>u.indexOf(S)===-1),...c.filter(S=>!P.equals(this._defaultConfiguration.override(h).getValue(S),t.override(h).getValue(S)))];return[h,g]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:h}=(0,n.compare)(this.localUserConfiguration,t),c=[...r,...i,...a];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:h}=(0,n.compare)(this.remoteUserConfiguration,t);let c=[...r,...i,...a];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:h}=(0,n.compare)(this.workspaceConfiguration,t);let c=[...r,...i,...a];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:h,removed:c,overrides:u}=(0,n.compare)(i,r);let g=[...a,...h,...c];return(g.length||!i)&&this.updateFolderConfiguration(t,r),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:h,overrides:c}=(0,n.compare)(r,void 0);return{keys:[...i,...a,...h],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const h=this._memoryConfigurationByResource.get(t);h&&(i=i.merge(h))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((c,u)=>(c.set(E.URI.revive(u[0]),this.parseConfigurationModel(u[1])),c),new A.ResourceMap);return new b(r,i,new d,a,h,new d,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function C(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const a of o)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,c])=>{const u=(0,A.getOrSet)(r,h,new Set);c.forEach(g=>u.add(g))});const i=[];return r.forEach((a,h)=>i.push([h,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=C;class v{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(u=>h.add(u)),t.overrides.forEach(([,u])=>u.forEach(g=>h.add(g))),this.affectedKeys=[...h.values()];const c=new d;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(i,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,n.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=v;class s extends v{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=s}),define(Z[174],ee([0,1,6,3,2,15,24,173,38,32]),function(K,e,R,L,D,T,A,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends D.Disposable{constructor(f,d){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,d)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,d){const l=typeof f=="string"?f:void 0,y=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(l,y,void 0)}updateValue(f,d,l,y){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const d=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(l,d,1)}onDidDefaultConfigurationChange(f){const d=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,f);this.trigger(l,d,6)}trigger(f,d,l){const y=new P.ConfigurationChangeEvent(f,{data:d},this.configuration);y.source=l,y.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[175],ee([0,1,105,24,14]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,p){this.configurationService=P,this.logService=p}request(P,p){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,p)}async resolveProxy(P){}};T=de([Y(0,L.IConfigurationService),Y(1,D.ILogService)],T),e.RequestService=T}),define(Z[42],ee([0,1,25,125,38,7,32]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}e.isSuccess=P;function p(l){return l.res.statusCode===204}async function E(l){if(!P(l))throw new Error("Server returned "+l.res.statusCode);return p(l)?null:(await(0,R.streamToBuffer)(l.stream)).toString()}e.asText=E;async function n(l){if(!P(l))throw new Error("Server returned "+l.res.statusCode);if(p(l))return null;const I=(await(0,R.streamToBuffer)(l.stream)).toString();try{return JSON.parse(I)}catch(b){throw b.message+=`:
`+I,b}}e.asJson=n;function w(l){d(l)}e.updateProxyConfigurationsScope=w;let f;function d(l){const y=A.Registry.as(D.Extensions.Configuration);f&&y.deregisterConfigurations([f]),f={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},y.registerConfiguration(f)}d(2)}),define(Z[176],ee([0,1,29,17,13,42]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(p,E){this.requestService=p,this.fileService=E}async download(p,E,n=R.CancellationToken.None){if(p.scheme===L.Schemas.file||p.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(p,E);return}const w={type:"GET",url:p.toString()},f=await this.requestService.request(w,n);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const d=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${d}`)}}};A=de([Y(0,T.IRequestService),Y(1,D.IFileService)],A),e.DownloadService=A}),define(Z[177],ee([0,1,23,29,63,2,15,139,13,14,28,42]),function(K,e,R,L,D,T,A,P,p,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(l,y,I,b){super();this.fileService=l,this.productService=y,this.requestService=I,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:C})=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(l){return this.getValidConfigBasedTips(l)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(l){const y=[];for(const[I,b]of this.allConfigBasedTips)try{const C=await this.fileService.readFile((0,A.joinPath)(l,I)),v=new Map;(0,D.forEach)(b.recommendations,({key:o,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const r of t.remotes)v.set(r,{extensionId:o,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else y.push({extensionId:o,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,P.getDomainsOfRemotes)(C.value.toString(),[...v.keys()]);for(const o of s){const t=v.get(o);t&&y.push(t)}}catch(C){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const l=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(l.res.statusCode!==200)return[];const y=await(0,w.asJson)(l);return y?y.workspaceRecommendations||[]:[]}catch(l){return this.logService.error(l),[]}}};f=de([Y(0,p.IFileService),Y(1,n.IProductService),Y(2,w.IRequestService),Y(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(Z[45],ee([0,1,25,30]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(T,A,P){let p=P&&P.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await A.readFile(T.serviceMachineIdResource)).value.toString();p=(0,L.isUUID)(n)?n:null}catch(E){p=null}if(!p){p=(0,L.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(p))}catch(E){}}return P&&P.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=D}),define(Z[20],ee([0,1,6,3,2,16,70,7]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var E;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var w;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));class f extends D.Disposable{constructor(I={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,b){b===p?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:b,target:this.getKeyTargets(I)[b]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,b,C){return this.getStorage(b)?.get(I,C)}getBoolean(I,b,C){return this.getStorage(b)?.getBoolean(I,C)}getNumber(I,b,C){return this.getStorage(b)?.getNumber(I,C)}store(I,b,C,v){if((0,T.isUndefinedOrNull)(b)){this.remove(I,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,C,v),this.getStorage(C)?.set(I,b)})}remove(I,b){this.withPausedEmitters(()=>{this.updateKeyTarget(I,b,void 0),this.getStorage(b)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,b){const C=[],v=this.getKeyTargets(I);for(const s of Object.keys(v))v[s]===b&&C.push(s);return C}updateKeyTarget(I,b,C){const v=this.getKeyTargets(b);typeof C=="number"?v[I]!==C&&(v[I]=C,this.getStorage(b)?.set(p,JSON.stringify(v))):typeof v[I]=="number"&&(delete v[I],this.getStorage(b)?.set(p,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const b=this.get(p,I);if(b)try{return JSON.parse(b)}catch(C){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=E.NONE){this._onWillSaveState.fire({reason:I}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return l(I,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends f{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=d;async function l(y,I,b,C){const v=h=>{try{return JSON.parse(h)}catch(c){return h}},s=new Map,o=new Map;y.forEach((h,c)=>{s.set(c,h),o.set(c,v(h))});const t=new Map,r=new Map;I.forEach((h,c)=>{t.set(c,h),r.set(c,v(h))}),console.group(`Storage: Global (path: ${b})`);let i=[];s.forEach((h,c)=>{i.push({key:c,value:h})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${C})`);let a=[];t.forEach((h,c)=>{a.push({key:c,value:h})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=l}),define(Z[178],ee([0,1,3,2,16,27,31,20]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends L.Disposable{constructor(w){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(w)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(w,f){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:f}),!0):!1}async disableExtension(w,f){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){let f=this.getDisabledExtensions();return f.every(d=>!(0,A.areSameExtensions)(d,w))?(f.push(w),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(w){let f=this.getDisabledExtensions();for(let d=0;d<f.length;d++){const l=f[d];if((0,A.areSameExtensions)(l,w))return f.splice(d,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(w){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,f){this.storageManger.set(w,f,0)}};p=de([Y(0,P.IStorageService)],p),e.GlobalExtensionEnablementService=p;class E extends L.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(w,f){let d;return f===0?((0,D.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,f)),d=this.storage[w]):d=this._get(w,f),JSON.parse(d)}set(w,f,d){let l=JSON.stringify(f.map(({id:I,uuid:b})=>({id:I,uuid:b})));this._get(w,d)!==l&&(d===0&&(f.length?this.storage[w]=l:delete this.storage[w]),this._set(w,f.length?l:void 0,d))}onDidStorageChange(w){if(w.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const d=this.get(w.key,w.scope);delete this.storage[w.key];const l=this.get(w.key,w.scope),y=d.filter(b=>!l.some(C=>(0,A.areSameExtensions)(b,C))),I=l.filter(b=>!d.some(C=>(0,A.areSameExtensions)(C,b)));(y.length||I.length)&&this._onDidChange.fire([...y,...I])}}_get(w,f){return this.storageService.get(w,f,"[]")}_set(w,f,d){f?this.storageService.store(w,f,d,1):this.storageService.remove(w,d)}}e.StorageManager=E}),define(Z[179],ee([0,1,3,2]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n}async getItems(){const E={workspace:this.workspace},n=await this.channel.call("getItems",E);return new Map(n)}updateItems(E){const n={workspace:this.workspace};return E.insert&&(n.insert=Array.from(E.insert.entries())),E.delete&&(n.delete=Array.from(E.delete.values())),this.channel.call("updateItems",n)}}class T extends D{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends D{constructor(E,n){super(E,n);this.onDidChangeItemsExternal=R.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class P extends L.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[180],ee([0,1,6,2,169,15,70,20,179]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends P.AbstractStorageService{constructor(w,f,d){super();this.mainProcessService=f,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(w)}createGlobalStorage(){const w=new p.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),f=new A.Storage(w.globalStorage);return this._register(f.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),f}createWorkspaceStorage(w){const f=new p.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),w);if(f.workspaceStorage){const d=new A.Storage(f.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(l=>this.emitDidChangeValue(1,l)),this.workspaceStorageId=w?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,D.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,D.mark)("code/didInitStorage")}}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(w){const f=this.workspaceStorage,d=f?.items??new Map;f&&(await f.close(),f.dispose()),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init();for(const[l,y]of d)this.workspaceStorage.set(l,y)}}e.NativeStorageService=E}),define(Z[181],ee([0,1,4,35,5,30]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(R.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,n,w,f,d,l,y,I,b,C){const v=Object.create(null);v["common.machineId"]=y,v.sessionID=(0,T.generateUuid)()+Date.now(),v.commitHash=d,v.version=l,v["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,R.PlatformToString)(R.platform),v["common.nodePlatform"]=L.platform,v["common.nodeArch"]=f,v["common.product"]=C||"desktop";const s=p(I||[]);s&&(v["common.msftInternal"]=s);let o=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),R.isLinuxSnap&&(v["common.snap"]="true");const r=A(w);r&&(v["common.platformDetail"]=r);try{const i=await E.readFile(D.URI.file(b));v["common.source"]=i.value.toString().slice(0,30)}catch(i){}return v}e.resolveCommonProperties=P;function p(E){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const w=n.toLowerCase();return E.some(f=>w===f)}e.verifyMicrosoftInternalDomain=p}),define(Z[21],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[182],ee([0,1,34,55,33,17,8,4,5,98,18,100,73,13,28,21]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(o,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,a=new Map,h=2e4;function c(S,m,k,O){const x=m.substring(S.length+1);return new Promise(async z=>{let H;try{H=await n.Promises.readdir(m,{withFileTypes:!0})}catch($){z();return}if(O.count>=h){O.count+=H.length,O.maxReached=!0,z();return}let V=H.length;if(V===0){z();return}let U=H;O.count+H.length>h&&(O.maxReached=!0,V=h-O.count,U=H.slice(0,V)),O.count+=H.length;for(const $ of U)if($.isDirectory()){if(k.includes($.name)||await c(S,(0,A.join)(m,$.name),k,O),--V==0){z();return}}else{const M=$.name.lastIndexOf(".");if(M>=0){const N=$.name.substring(M+1);N&&i.set(N,(i.get(N)??0)+1)}for(const N of r)N.relativePathPattern?.test(x)!==!1&&N.filePattern.test($.name)&&a.set(N.tag,(a.get(N.tag)??0)+1);if(--V==0){z();return}}})}const u={count:0,maxReached:!1};await c(o,o,t,u);const g=await v(o);return{configFiles:b(a),fileTypes:b(i),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=I;function b(o){return[...L.Iterable.map(o.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function C(){const o={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=C;async function v(o){try{const t=new Map,r=(0,A.join)(o,".vscode","launch.json"),i=await n.Promises.readFile(r),a=[],h=(0,D.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,D.getNodeType)(h)==="object"&&h.configurations)for(const c of h.configurations){const u=c.type;u&&(t.has(u)?t.set(u,t.get(u)+1):t.set(u,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let s=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const i=R.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${R.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,w.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[a,h]=i,c=this.formatProcessList(t,a);return r.forEach(u=>{if((0,f.isRemoteDiagnosticError)(u))c+=`
${u.errorMessage}`,h+=`
${u.errorMessage}`;else if(c+=`

Remote: ${u.hostName}`,u.processes&&(c+=`
${this.formatProcessList(t,u.processes)}`),u.workspaceMetadata){h+=`
|  Remote: ${u.hostName}`;for(const g of Object.keys(u.workspaceMetadata)){const S=u.workspaceMetadata[g];let m=`${S.fileCount} files`;S.maxFilesReached&&(m=`more than ${m}`),h+=`|    Folder (${g}): ${m}`,h+=this.formatWorkspaceStats(S)}}}),{processInfo:c,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:i,vmHint:a,os:h,cpus:c}=C(),u={os:h,memory:i,cpus:c,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(u.load=`${R.loadavg().map(g=>Math.round(g)).join(", ")}`),P.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(t,r){const i=[];return(0,w.listProcesses)(t.mainPID).then(async a=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,a)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if((0,f.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const c of Object.keys(h.workspaceMetadata)){const u=h.workspaceMetadata[c];let g=`${u.fileCount} files`;u.maxFilesReached&&(g=`more than ${g}`),i.push(`Folder (${c}): ${g}`),i.push(this.formatWorkspaceStats(u))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let a=0;const h=(S,m)=>{const k=` ${S}(${m})`;a+k.length>i?(r.push(c),c="|                 ",a=c.length):a+=k.length,c+=k};let c="|      File types:";const u=10;let g=t.fileTypes.length>u?u:t.fileTypes.length;for(let S=0;S<g;S++){const m=t.fileTypes[S];h(m.name,m.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",a=0,t.configFiles.forEach(S=>{h(S.name,S.count)}),r.push(c)),t.launchConfigFiles.length>0){let S="|      Launch Configs:";t.launchConfigFiles.forEach(m=>{S+=m.count>1?` ${m.name}(${m.count})`:` ${m.name}`}),r.push(S)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(h=>{const c=p.URI.revive(h);if(c.scheme===T.Schemas.file){const u=c.fsPath;i.push(I(u,["node_modules",".git"]).then(g=>{let S=`${g.fileCount} files`;g.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,A.basename)(u)}): ${S}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${g.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(h=>i.set(h.pid,h.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,a,r,0),a.join(`
`)}formatProcessItem(t,r,i,a,h){const c=h===0;let u;c?u=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(h)} ${a.name}`,a.name==="window"&&(u=`${u} (${r.get(a.pid)})`));const g=process.platform==="win32"?a.mem:R.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(g/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(a.children)&&a.children.forEach(S=>this.formatProcessItem(t,r,i,S,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=p.URI.revive(r);if(i.scheme!==T.Schemas.file)continue;const a=i.fsPath;try{const h=await I(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),h.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),h.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};s=de([Y(0,y.ITelemetryService),Y(1,l.IProductService)],s),e.DiagnosticsService=s}),define(Z[183],ee([0,1,6,29,11,3,2,4,5,114,27,31,14,44,21]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let y=class extends A.Disposable{constructor(s,o,t){super();this.galleryService=s,this.telemetryService=o,this.logService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,A.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,o={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s)}catch(r){throw this.logService.error((0,D.getErrorMessage)(r)),b(this.telemetryService,"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(s),void 0,r),r}if(!await this.canInstall(s)){const r=new n.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",s.identifier.id,r.message),b(this.telemetryService,"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(s),void 0,r),r}const t=await this.galleryService.getManifest(s,L.CancellationToken.None);if(t===null){const r=new n.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,r.message),b(this.telemetryService,"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(s),void 0,r),r}return this.installExtension(t,s,o)}async uninstall(s,o={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,o)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const o=await this.findGalleryExtension(s);if(!o)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,o,t){if(!p.URI.isUri(o)){let c=this.installingExtensions.get(new w.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(c)return this.logService.info("Extensions is already requested to install",o.identifier.id),c.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],a=this.createInstallExtensionTask(s,o,t);p.URI.isUri(o)||this.installingExtensions.set(new w.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:o}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:s});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const u=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!t.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:g,manifest:S}of u)if(h=h||!!S.extensionDependencies?.some(m=>(0,w.areSameExtensions)({id:m},a.identifier)),this.installingExtensions.has(new w.ExtensionIdentifierWithVersion(g.identifier,g.version).key()))this.logService.info("Extension is already requested to install",g.identifier.id);else{const m=this.createInstallExtensionTask(S,g,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new w.ExtensionIdentifierWithVersion(m.identifier,S.version).key(),m),this._onInstallExtension.fire({identifier:m.identifier,source:g}),this.logService.info("Installing extension:",m.identifier.id),r.push({task:m,manifest:S})}}catch(u){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(u),u}const c=r.reduce((u,{task:g,manifest:S})=>(u.set(g.identifier.id.toLowerCase(),{task:g,manifest:S}),u),new Map);for(;c.size;){let u;const g=[...c.values()].filter(({manifest:S})=>!S.extensionDependencies?.some(m=>c.has(m.toLowerCase())));g.length?u=c.size===1?g:g.filter(({task:S})=>!(S===a&&!h)):(this.logService.info("Found extensions with circular dependencies",g.map(({task:S})=>S.identifier.id)),u=[...c.values()]),await this.joinAllSettled(u.map(async({task:S})=>{const m=new Date().getTime();try{const k=await S.run();if(await this.joinAllSettled(this.participants.map(O=>O.postInstall(k,S.source,t,L.CancellationToken.None))),!p.URI.isUri(S.source)&&(b(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-m,void 0),P.isWeb&&S.operation===1))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch(O){}i.push({local:k,identifier:S.identifier,operation:S.operation,source:S.source})}catch(k){throw p.URI.isUri(S.source)||b(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-m,k),this.logService.error("Error while installing the extension:",S.identifier.id),this.logService.error(k),k}finally{c.delete(S.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:u})=>this.logService.info("Extension installed successfully:",u.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:u})=>(0,w.areSameExtensions)(u,a.identifier))[0].local}catch(c){if(r.forEach(({task:u})=>u.cancel()),i.length)try{const u=await Promise.allSettled(i.map(({local:g})=>this.createUninstallExtensionTask(g,{versionOnly:!0}).run()));for(let g=0;g<u.length;g++){const S=u[g],{identifier:m}=i[g];S.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",m.id):this.logService.warn("Rollback: Error while uninstalling extension",m.id,(0,D.getErrorMessage)(S.reason))}}catch(u){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(u),i.map(({identifier:g})=>g.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,D.getErrorMessage)(c)),this._onDidInstallExtensions.fire(r.map(({task:u})=>({identifier:u.identifier,operation:1,source:u.source}))),c instanceof Error&&(c.name=c&&c.code?c.code:e.ERROR_UNKNOWN),c}finally{for(const{task:c,manifest:u}of r)if(!p.URI.isUri(c.source)){const g=new w.ExtensionIdentifierWithVersion(c.identifier,u.version).key();this.installingExtensions.delete(g)||this.logService.warn("Installation task is not found in the cache",g)}}}async joinAllSettled(s){const o=[],t=[],r=await Promise.allSettled(s);for(const i of r)i.status==="fulfilled"?o.push(i.value):t.push(i.reason);if(t.length)throw I(t);return o}async getAllDepsAndPackExtensionsToInstall(s,o,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[s,...r.map(c=>c.identifier)],a=[],h=async(c,u)=>{const g=u.extensionDependencies||[];if(u.extensionPack){const S=t?r.find(m=>(0,w.areSameExtensions)(m.identifier,c)):void 0;for(const m of u.extensionPack)S&&S.manifest.extensionPack&&S.manifest.extensionPack.some(k=>(0,w.areSameExtensions)({id:k},{id:m}))||g.every(k=>!(0,w.areSameExtensions)({id:k},{id:m}))&&g.push(m)}if(g.length){const S=[...i,...a.map(k=>k.gallery.identifier)],m=g.filter(k=>S.every(O=>!(0,w.areSameExtensions)(O,{id:k})));if(m.length){const k=await this.galleryService.query({names:m,pageSize:g.length},L.CancellationToken.None);for(const O of k.firstPage){if(S.find(H=>(0,w.areSameExtensions)(H,O.identifier)))continue;const x=await this.checkAndGetCompatibleVersion(O);if(!await this.canInstall(x)){this.logService.info("Skipping the extension as it cannot be installed",x.identifier.id);continue}const z=await this.galleryService.getManifest(x,L.CancellationToken.None);if(z===null)throw new n.ExtensionManagementError(`Missing manifest for extension ${x.identifier.id}`,e.INSTALL_ERROR_VALIDATING);a.push({gallery:x,manifest:z}),await h(x.identifier,z)}}}};return await h(s,o),r=await this.getInstalled(),a.filter(c=>!r.some(u=>(0,w.areSameExtensions)(u.identifier,c.gallery.identifier)))}async checkAndGetCompatibleVersion(s){if(await this.isMalicious(s))throw new n.ExtensionManagementError(E.localize(3,null,s.identifier.id),n.INSTALL_ERROR_MALICIOUS);const o=await this.galleryService.getCompatibleExtension(s);if(!o)throw new n.ExtensionManagementError(E.localize(4,null,s.identifier.id,d.default.version),n.INSTALL_ERROR_INCOMPATIBLE);return o}async isMalicious(s){const o=await this.getExtensionsReport();return(0,w.getMaliciousExtensionsSet)(o).has(s.identifier.id)}async unininstallExtension(s,o){const t=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),t.waitUntilTaskIsFinished();const r=(c,u)=>{const g=this.createUninstallExtensionTask(c,u);return this.uninstallingExtensions.set(g.extension.identifier.id.toLowerCase(),g),this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier),g},i=(c,u)=>{u?this.logService.error("Failed to uninstall extension:",c.identifier.id,u.message):this.logService.info("Successfully uninstalled extension:",c.identifier.id),b(this.telemetryService,"extensionGallery:uninstall",(0,w.getLocalExtensionTelemetryData)(c),void 0,u),this._onDidUninstallExtension.fire({identifier:c.identifier,error:u?.code})},a=[],h=[];try{a.push(r(s,{}));const c=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const u=this.getAllPackExtensionsToUninstall(s,c);for(const g of u)this.uninstallingExtensions.has(g.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",g.identifier.id):a.push(r(g,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(u=>u.extension),c,s),await this.joinAllSettled(a.map(async u=>{try{if(await u.run(),await this.joinAllSettled(this.participants.map(g=>g.postUninstall(u.extension,o,L.CancellationToken.None))),u.extension.identifier.uuid)try{await this.galleryService.reportStatistic(u.extension.manifest.publisher,u.extension.manifest.name,u.extension.manifest.version,"uninstall")}catch(g){}i(u.extension)}catch(g){const S=g instanceof n.ExtensionManagementError?g:new n.ExtensionManagementError((0,D.getErrorMessage)(g),e.ERROR_UNKNOWN);throw i(u.extension,S),S}finally{h.push(u)}}))}catch(c){const u=c instanceof n.ExtensionManagementError?c:new n.ExtensionManagementError((0,D.getErrorMessage)(c),e.ERROR_UNKNOWN);for(const g of a){try{g.cancel()}catch(S){}h.includes(g)||i(g.extension,u)}throw u}finally{for(const c of a)this.uninstallingExtensions.delete(c.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",c.extension.identifier.id)}}checkForDependents(s,o,t){for(const r of s){const i=this.getDependents(r,o);if(i.length){const a=i.filter(h=>s.indexOf(h)===-1);if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,t))}}}getDependentsErrorMessage(s,o,t){return t===s?o.length===1?E.localize(5,null,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(6,null,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(7,null,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(s,o,t=[]){if(t.indexOf(s)!==-1)return[];t.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const i=o.filter(h=>!h.isBuiltin&&r.some(c=>(0,w.areSameExtensions)({id:c},h.identifier))),a=[];for(const h of i)a.push(...this.getAllPackExtensionsToUninstall(h,o,t));return[...i,...a]}return[]}getDependents(s,o){return o.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,w.areSameExtensions)({id:r},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const o=await this.findGalleryExtensionById(s.identifier.uuid);return o||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=de([Y(0,n.IExtensionGalleryService),Y(1,l.ITelemetryService),Y(2,f.ILogService)],y),e.AbstractExtensionManagementService=y;function I(v){const s=Array.isArray(v)?v:[v];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,t)=>new Error(`${o.message}${o.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=I;function b(v,s,o,t,r){const i=r?r instanceof n.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;v.publicLogError(s,{...o,success:!r,duration:t,errorcode:i})}e.reportTelemetry=b;class C{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(s=>new Promise((o,t)=>{const r=s.onCancellationRequested(()=>{r.dispose(),t((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=C}),define(Z[184],ee([0,1,29,11,26,4,5,12,27,31,72,13,7,14,28,42,45,20,21]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var v;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(v||(v={}));function s(...M){return String(M.reduce((N,q)=>N|q,0))}var o;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class h{constructor(N=a){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new h({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const F=[...this.state.criteria,...q.length?q.map(j=>({filterType:N,value:j})):[{filterType:N}]];return new h({...this.state,criteria:F})}withSortBy(N){return new h({...this.state,sortBy:N})}withSortOrder(N){return new h({...this.state,sortOrder:N})}withFlags(...N){return new h({...this.state,flags:N.reduce((q,F)=>q|F,0)})}withAssetTypes(...N){return new h({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:F,sortBy:j,sortOrder:_,flags:G,assetTypes:B}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:F,sortBy:j,sortOrder:_}],assetTypes:B,flags:G}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===o.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(M,N){const q=(M||[]).filter(F=>F.statisticName===N)[0];return q?q.value:0}function u(M){const N="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(F=>F.assetType.indexOf(N)===0).reduce((F,j)=>{const _=k(M,j.assetType);return _&&F.push([j.assetType.substring(N.length),_]),F},[])}function g(M){if(M.properties){const N=M.properties.filter(j=>j.key===t.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=N.filter(j=>q.test(j.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return k(M,t.Repository)}function S(M){return{uri:`${M.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${t.VSIX}`}}function m(M){const N=k(M,t.Icon);if(N)return N;const q=p.DefaultIconPath;return{uri:q,fallbackUri:q}}function k(M,N){return M.files.filter(F=>F.assetType===N)[0]?{uri:`${M.assetUri}/${N}`,fallbackUri:`${M.fallbackAssetUri}/${N}`}:null}function O(M,N){const q=M.properties?M.properties.filter(j=>j.key===N):[],F=q.length>0&&q[0].value;return F?F.split(",").map(j=>(0,E.adoptToGalleryExtensionId)(j)):[]}function x(M){const N=M.properties?M.properties.filter(q=>q.key===r.Engine):[];return N.length>0&&N[0].value||""}function z(M){const N=M.properties?M.properties.filter(F=>F.key===r.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function H(M){return M.indexOf("preview")!==-1}function V(M,N,q,F,j){const _={manifest:k(N,t.Manifest),readme:k(N,t.Details),changelog:k(N,t.Changelog),license:k(N,t.License),repository:g(N),download:S(N),icon:m(N),coreTranslations:u(N)};return{identifier:{id:(0,E.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:N.version,date:N.lastUpdated,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:c(M.statistics,"install"),rating:c(M.statistics,"averagerating"),ratingCount:c(M.statistics,"ratingcount"),assetUri:A.URI.parse(N.assetUri),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(p.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:G})=>G),assets:_,properties:{dependencies:O(N,r.Dependency),extensionPack:O(N,r.ExtensionPack),engine:x(N),localizedLanguages:z(N)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+q,querySource:j},preview:H(M.flags)}}let U=class{constructor(N,q,F,j,_,G,B){this.requestService=N,this.logService=q,this.environmentService=F,this.telemetryService=j,this.fileService=_,this.productService=G;const X=G.extensionsGallery;this.extensionsGalleryUrl=X&&X.serviceUrl,this.extensionsControlUrl=X&&X.controlUrl,this.commonHeadersPromise=$(G.version,this.environmentService,this.fileService,B)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q){const F=[];let{total:j,firstPage:_,getPage:G}=await this.query({names:N,pageSize:N.length},q);F.push(..._);for(let B=1;F.length<j&&(_=await G(B,q),_.length);B++)F.push(..._);return F}async getCompatibleExtension(N,q){return this.getCompatibleExtensionByEngine(N,q)}async getCompatibleExtensionByEngine(N,q){const F=(0,p.isIExtensionIdentifier)(N)?null:N;if(F&&F.properties.engine&&(0,n.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:j,uuid:_}=F?F.identifier:N;let G=new h().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");_?G=G.withFilter(o.ExtensionId,_):G=G.withFilter(o.ExtensionName,j);const{galleryExtensions:B}=await this.queryGallery(G,R.CancellationToken.None),[X]=B;if(!X||!X.versions.length)return null;if(q){const ie=X.versions.filter(ne=>ne.version===q)[0];if(ie){const ne=V(X,ie,0,G);if(ne.properties.engine&&(0,n.isEngineValid)(ne.properties.engine,this.productService.version,this.productService.date))return ne}return null}const Q=await this.getLastValidExtensionVersion(X,X.versions);return Q?V(X,Q,0,G):null}async query(N,q){const F=R.CancellationToken.isCancellationToken(N)?{}:N,j=R.CancellationToken.isCancellationToken(N)?N:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=F.text||"";const G=(0,D.getOrDefault)(F,le=>le.pageSize,50);let B=new h().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,G).withFilter(o.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,fe,ye)=>(B=B.withFilter(o.Category,ye||fe),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,fe,ye)=>(B=B.withFilter(o.Tag,ye||fe),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(o.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),B=B.withFilter(o.SearchText,_)),B=B.withSortBy(0)):F.ids?B=B.withFilter(o.ExtensionId,...F.ids):F.names?B=B.withFilter(o.ExtensionName,...F.names):B=B.withSortBy(4),typeof F.sortBy=="number"&&(B=B.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(B=B.withSortOrder(F.sortOrder));const{galleryExtensions:X,total:Q}=await this.queryGallery(B,j),ie=X.map((le,fe)=>V(le,le.versions[0],fe,B,F.source)),ne=async(le,fe)=>{if(fe.isCancellationRequested)throw(0,L.canceled)();const ye=B.withPage(le+1),{galleryExtensions:Se}=await this.queryGallery(ye,fe);return Se.map((Pe,Te)=>V(Pe,Pe.versions[0],Te,ye,F.source))};return{firstPage:ie,total:Q,pageSize:B.pageSize,getPage:ne}}async queryGallery(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,v.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,s(v.Unpublished));const F=await this.commonHeadersPromise,j=JSON.stringify(N.raw),_={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(j.length)},G=new Date().getTime();let B,X,Q=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:j,headers:_},q),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:Q};const ie=await(0,y.asJson)(B);if(ie){const ne=ie.results[0],le=ne.extensions,fe=ne.resultMetadata&&ne.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return Q=fe&&fe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:Q}}return{galleryExtensions:[],total:Q}}catch(ie){throw X=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(j.length),duration:new Date().getTime()-G,success:!!B&&(0,y.isSuccess)(B),responseBodySize:B?.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:X?(0,L.isPromiseCanceledError)(X)?"canceled":(0,L.getErrorMessage)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(N,q,F,j){if(!this.isEnabled())return;const _=T.isWeb?this.api(`/itemName/${N}.${q}/version/${F}/statType/${j==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${F}/stats?statType=${j}`),G=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.commonHeadersPromise,Accept:G};try{await this.requestService.request({type:"POST",url:_,headers:X},R.CancellationToken.None)}catch(Q){}}async download(N,q,F){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const j=(0,E.getGalleryExtensionTelemetryData)(N),_=new Date().getTime(),G=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...j,duration:ie}),B=F===1?"install":F===2?"update":"",X=B?{uri:`${N.assets.download.uri}&${B}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${B}=true`}:N.assets.download,Q=await this.getAsset(X);await this.fileService.writeFile(q,Q.stream),G(new Date().getTime()-_)}async getReadme(N,q){if(N.assets.readme){const F=await this.getAsset(N.assets.readme,{},q);return await(0,y.asText)(F)||""}return""}async getManifest(N,q){if(N.assets.manifest){const F=await this.getAsset(N.assets.manifest,{},q),j=await(0,y.asText)(F);return j?JSON.parse(j):null}return null}async getCoreTranslation(N,q){const F=N.assets.coreTranslations.filter(j=>j[0]===q.toUpperCase())[0];if(F){const j=await this.getAsset(F[1]),_=await(0,y.asText)(j);return _?JSON.parse(_):null}return null}async getChangelog(N,q){if(N.assets.changelog){const F=await this.getAsset(N.assets.changelog,{},q);return await(0,y.asText)(F)||""}return""}async getAllVersions(N,q){let F=new h().withFlags(v.IncludeVersions,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?F=F.withFilter(o.ExtensionId,N.identifier.uuid):F=F.withFilter(o.ExtensionName,N.identifier.id);const j=[],{galleryExtensions:_}=await this.queryGallery(F,R.CancellationToken.None);return _.length&&(q?await Promise.all(_[0].versions.map(async G=>{let B;try{B=await this.getEngine(G)}catch(X){}B&&(0,n.isEngineValid)(B,this.productService.version,this.productService.date)&&j.push({version:G.version,date:G.lastUpdated})})):j.push(..._[0].versions.map(G=>({version:G.version,date:G.lastUpdated})))),j}async getAsset(N,q={},F=R.CancellationToken.None){const j=await this.commonHeadersPromise,_={type:"GET"},G={...j,...q.headers||{}};q={...q,..._,headers:G};const B=N.uri,X=N.fallbackUri,Q={...q,url:B};try{const ie=await this.requestService.request(Q,F);if(ie.res.statusCode===200)return ie;const ne=await(0,y.asText)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${ne}`)}catch(ie){if((0,L.isPromiseCanceledError)(ie))throw ie;const ne=(0,L.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ne});const le={...q,url:X};return this.requestService.request(le,F)}}async getLastValidExtensionVersion(N,q){const F=this.getLastValidExtensionVersionFromProperties(N,q);return F||this.getLastValidExtensionVersionRecursively(N,q)}getLastValidExtensionVersionFromProperties(N,q){for(const F of q){const j=x(F);if(!j)return null;if((0,n.isEngineValid)(j,this.productService.version,this.productService.date))return F}return null}async getEngine(N){const q=x(N);if(q)return q;const F=k(N,t.Manifest);if(!F)throw new Error("Manifest was not found");const j={"Accept-Encoding":"gzip"},_=await this.getAsset(F,{headers:j}),G=await(0,y.asJson)(_);if(G)return G.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,q){if(!q.length)return null;const F=q[0],j=await this.getEngine(F);return(0,n.isEngineValid)(j,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:r.Engine,value:j}]}:this.getLastValidExtensionVersionRecursively(N,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,y.asJson)(N),F=new Map;if(q)for(const j of q.malicious){const _=F.get(j)||{id:{id:j},malicious:!0,slow:!1};_.malicious=!0,F.set(j,_)}return[...F.values()]}};U=de([Y(0,y.IRequestService),Y(1,d.ILogService),Y(2,P.IEnvironmentService),Y(3,C.ITelemetryService),Y(4,w.IFileService),Y(5,l.IProductService),Y(6,(0,f.optional)(b.IStorageService))],U),e.ExtensionGalleryService=U;async function $(M,N,q,F){const j={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},_=await(0,I.getServiceMachineId)(N,q,F);return j["X-Market-User-Id"]=_,j}e.resolveMarketplaceHeaders=$}),define(Z[185],ee([0,1,23,6,63,3,8,4,35,5,116,12,27,177,75,13,14,59,28,42,20,21]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends d.ExtensionTipsService{constructor(h,c,u,g,S,m,k,O,x,z){super(k,O,x,z);this.environmentService=h,this.telemetryService=c,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=S,this.extensionRecommendationNotificationService=m,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,D.forEach)(O.exeBasedExtensionTips,({key:H,value:V})=>{const U=[],$=[],M=[];(0,D.forEach)(V.recommendations,({key:N,value:q})=>{q.important?V.important?U.push({extensionId:N,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):$.push({extensionId:N,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):M.push({extensionId:N,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:U}),$.length&&this.mediumImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:$}),M.length&&this.allOtherExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:M})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...h,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(h,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,u)}groupImportantTipsByExe(h,c){const u=new Map;h.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:S}=this.groupByInstalled([...u.keys()],c);for(const O of g){const x=u.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:x.exeName})}for(const O of S){const x=u.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:x.exeName})}const m=this.getPromptedExecutableTips(),k=new Map;for(const O of S){const x=u.get(O);if(x&&(!m[x.exeName]||!m[x.exeName].includes(x.extensionId))){let z=k.get(x.exeName);z||(z=[],k.set(x.exeName,z)),z.push(x)}}return k}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[h,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(h);break;case"incompatibleWindow":const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const S=this._register((0,L.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const h=this.getLastPromptedMediumExeTime(),c=Date.now()-h,u=7*24*60*60*1e3;if(c<u){const m=this._register((0,L.disposableTimeout)(()=>{m.dispose(),this.promptMediumImportanceExeBasedTip()},u-c));return}const[g,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(m=>{switch(m){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(S[0].exeName,S);const k=this._register((0,L.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const x=this._register((0,L.disposableTimeout)(()=>{x.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(h){const c=h.map(({extensionId:g})=>g.toLowerCase()),u=(0,n.localize)(0,null,h[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,u,`@exe:"${h[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let h=this.storageService.getNumber(r,0);return h||(h=Date.now(),this.updateLastPromptedMediumExeTime(h)),h}updateLastPromptedMediumExeTime(h){this.storageService.store(r,h,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(h,c){const u=this.getPromptedExecutableTips();u[h]=c.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(h,c){const u=[],g=[],S=c.reduce((m,k)=>(m.add(k.identifier.id.toLowerCase()),m),new Set);return h.forEach(m=>{S.has(m.toLowerCase())?u.push(m):g.push(m)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(h){const c=[],u=new Map;for(const g of h.keys()){const S=h.get(g);if(!S||!(0,R.isNonEmptyArray)(S.recommendations))continue;const m=[];P.isWindows?S.windowsPath&&m.push(S.windowsPath.replace("%USERPROFILE%",p.env.USERPROFILE).replace("%ProgramFiles(x86)%",p.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",p.env.ProgramFiles).replace("%APPDATA%",p.env.APPDATA).replace("%WINDIR%",p.env.WINDIR)):(m.push((0,A.join)("/usr/local/bin",g)),m.push((0,A.join)("/usr/bin",g)),m.push((0,A.join)(this.environmentService.userHome.fsPath,g)));for(const k of m){let O=u.get(k);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(k)),u.set(k,O)),O)for(const{extensionId:x,extensionName:z,isExtensionPack:H}of S.recommendations)c.push({extensionId:x,extensionName:z,isExtensionPack:H,exeName:g,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return c}};i=de([Y(0,w.INativeEnvironmentService),Y(1,o.ITelemetryService),Y(2,f.IExtensionManagementService),Y(3,s.IStorageService),Y(4,b.INativeHostService),Y(5,l.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,C.IProductService),Y(8,v.IRequestService),Y(9,I.ILogService)],i),e.ExtensionTipsService=i}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appender=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:P,data:p}){return this.appender.log(P,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class L{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[83],ee([0,1,2,26,19,126,24,38,7,44,32]),function(K,e,R,L,D,T,A,P,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(l,y){this._configurationService=y,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const b=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(l,y){this._experimentProperties[l]=y}setEnabled(l){this._enabled=l}_updateUserOptIn(){const l=this._configurationService?.getValue(f);this._userOptIn=l?l.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let y=l.sessionID,I=l["common.instanceId"],b=l["common.machineId"],C=l["common.firstSessionDate"],v=l["common.msftInternal"];return{sessionId:y,instanceId:I,machineId:b,firstSessionDate:C,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(l,y,I){return this.isOptedIn?this._commonProperties.then(b=>{y=(0,L.mixin)(y,b),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,C=>{if(typeof C=="string")return this._cleanupInfo(C,I)}),this._appender.log(l,y)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(l,y,I){return this.publicLog(l,y,I)}publicLogError(l,y){return this.sendErrorTelemetry?this.publicLog(l,y,!0):Promise.resolve(void 0)}publicLogError2(l,y){return this.publicLogError(l,y)}_cleanupInfo(l,y){let I=l;if(y){const b=[];for(let o of this._cleanupPatterns)for(;;){const t=o.exec(l);if(!t)break;b.push([t.index,o.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(I="";;){const o=v.exec(l);if(!o)break;!C.test(o[0])&&b.every(([t,r])=>o.index<t||o.index>=r)&&(I+=l.substring(s,o.index)+"<REDACTED: user-file-path>",s=v.lastIndex)}s<l.length&&(I+=l.substr(s))}for(let b of this._cleanupPatterns)I=I.replace(b,"");return I}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=de([Y(1,(0,p.optional)(A.IConfigurationService))],w),e.TelemetryService=w;const f="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:f,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,T.localize)(2,null,E.default.nameLong,E.default.privacyStatementUrl):(0,T.localize)(1,null,E.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[53],ee([0,1,6,26,16,24]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(l,y){return Promise.resolve(void 0)}publicLog2(l,y){return this.publicLog(l,y)}publicLogError(l,y){return Promise.resolve(void 0)}publicLogError2(l,y){return this.publicLogError(l,y)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(y,I,b){}async publicLogError(y,I,b){}}e.NullEndpointTelemetryService=A;function P(...l){return{log:(y,I)=>l.forEach(b=>b.log(y,I)),flush:()=>R.Promises.settled(l.map(y=>y.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(l,y){return y.onDidChangeConfiguration(I=>{I.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(I.source),configurationKeys:f(I.sourceConfig)})})}e.configurationTelemetry=p;function E(l){const y=Object.create(null),I=Object.create(null),b=Object.create(null);w(l,b);for(let C in b){C=C.length>150?C.substr(C.length-149):C;const v=b[C];typeof v=="number"?I[C]=v:typeof v=="boolean"?I[C]=v?1:0:typeof v=="string"?y[C]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(y[C]=v)}return{properties:y,measurements:I}}e.validateTelemetryData=E;function n(l){if(!l)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{l.indexOf(`${b}+`)===0&&(y=b)}),y}e.cleanRemoteAuthority=n;function w(l,y,I=0,b){if(!!l)for(let C of Object.getOwnPropertyNames(l)){const v=l[C],s=b?b+C:C;Array.isArray(v)?y[s]=(0,L.safeStringify)(v):v instanceof Date?y[s]=v.toISOString():(0,D.isObject)(v)?I<2?w(v,y,I+1,s+"."):y[s]=(0,L.safeStringify)(v):y[s]=v}}function f(l){if(!l)return[];const y=[];return d(y,"",l),y}function d(l,y,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(b=>d(l,y?`${y}.${b}`:b,I[b])):l.push(y)}}),define(Z[84],ee([0,1,2,12,14,53]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(p,E,n=""){super();this.prefix=n;const w=p.getLogger(E.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(p.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(p,E){this.logger.trace(`${this.prefix}telemetry/${p}`,(0,T.validateTelemetryData)(E))}};A=de([Y(0,D.ILoggerService),Y(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[186],ee([0,1,11,26,53]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const p=await new Promise((n,w)=>{K(["applicationinsights"],n,w)});let E;return p.defaultClient?(E=new p.TelemetryClient(P),E.channel.setUseDiskRetryCaching(!0)):(p.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=p.defaultClient),P.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class A{constructor(p,E,n){this._eventPrefix=p,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(E=>{p(E)},E=>{(0,R.onUnexpectedError)(E),console.error(E)})}}log(p,E){!this._aiClient||(E=(0,L.mixin)(E,this._defaultData),E=(0,D.validateTelemetryData)(E),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[187],ee([0,1,17,51,24,12,14,21,82,84,83,53]),function(K,e,R,L,D,T,A,P,p,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(l,y,I,b){this.configurationService=l,this.telemetryService=y,this.loggerService=I,this.environmentService=b,this.customTelemetryServices=new Map}async getCustomTelemetryService(l){if(!this.customTelemetryServices.has(l.id)){const{machineId:y,sessionId:I}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=y,b["common.vscodesessionid"]=I;const C=[l.id,JSON.stringify(b),l.aiKey],s=new L.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:C,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),o=(0,w.combinedAppender)(new p.TelemetryAppenderClient(s),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${l.id}] `));this.customTelemetryServices.set(l.id,new n.TelemetryService({appender:o,sendErrorTelemetry:l.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(l.id)}async publicLog(l,y,I){await(await this.getCustomTelemetryService(l)).publicLog(y,I)}async publicLogError(l,y,I){await(await this.getCustomTelemetryService(l)).publicLogError(y,I)}};f=de([Y(0,D.IConfigurationService),Y(1,P.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService)],f),e.CustomEndpointTelemetryService=f}),define(Z[188],ee([0,1,6,29,3,2,14]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(E,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((n,w)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,n),this._onCreateRequest.fire({requestId:f,...E});const d=new L.CancellationTokenSource;(0,R.timeout)(this._timeout,d.token).then(()=>w(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>d.cancel())])})}acceptReply(E,n){const w=this._pendingRequests.get(E);w?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),w(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=de([Y(1,A.ILogService)],P),e.RequestStore=P}),define(Z[85],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.TitleMode="terminal.integrated.titleMode",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var p;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(d){d.TerminalView="view",d.Editor="editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var w;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(w=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,7]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,34,26,8,4,35,16,18]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let f=0;return w&&w.length===4&&(f=parseInt(w[3])),f}e.getWindowsBuildNumber=E;async function n(w,f,d,l=A.env,y=p.Promises.exists){if(D.isAbsolute(w))return await y(w)?w:void 0;if(f===void 0&&(f=A.cwd()),D.dirname(w)!=="."){const v=D.join(f,w);return await y(v)?v:void 0}const b=(0,L.getCaseInsensitive)(l,"PATH");if(d===void 0&&(0,P.isString)(b)&&(d=b.split(D.delimiter)),d===void 0||d.length===0){const v=D.join(f,w);return await y(v)?v:void 0}for(let v of d){let s;if(D.isAbsolute(v)?s=D.join(v,w):s=D.join(f,v,w),await y(s))return s;if(T.isWindows){let o=s+".com";if(await y(o)||(o=s+".exe",await y(o)))return o}}const C=D.join(f,w);return await y(C)?C:void 0}e.findExecutable=n}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,48,3,2,7,32,191]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var p;(function(I){function b(C){return C&&typeof C=="object"&&typeof C.id=="string"}I.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function E(I){return{id:I}}e.themeColorFromId=E;var n;(function(I){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}I.isThemeIcon=b;const C=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function v(r){const i=C.exec(r);if(!i)return;let[,a]=i;return{id:a}}I.fromString=v;function s(r,i){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}I.modify=s;function o(r,i){return r.id===i.id&&r.color?.id===i.color?.id}I.isEqual=o;function t(r,i){return{id:r.id,color:i?E(i):void 0}}I.asThemeIcon=t,I.asClassNameArray=R.CSSIcon.asClassNameArray,I.asClassName=R.CSSIcon.asClassName,I.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function w(I){switch(I){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,D.toDisposable)(()=>{const C=this.themingParticipants.indexOf(b);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new f;A.Registry.add(e.Extensions.ThemingContribution,d);function l(I){return d.onColorThemeChange(I)}e.registerThemingParticipant=l;class y extends D.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,C){let v=this.theme.getColor(b);return v&&C&&(v=C(v,this.theme)),v?v.toString():null}}e.Themable=y}),define(Z[192],ee([0,1,48,86]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function D(P,p){const E=P.map(n=>({name:n.profileName,description:T(n)}));return p&&E.push(...p.map(n=>({name:n.title,description:A(n)}))),{values:E.map(n=>n.name),markdownDescriptions:E.map(n=>n.description)}}e.createProfileSchemaEnums=D;function T(P){let p=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?p+=`
- args: "${P.args}"`:p+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(p+=`
- overrideName: ${P.overrideName}`),P.color&&(p+=`
- color: ${P.color}`),P.env&&(p+=`
- env: ${JSON.stringify(P.env)}`),p}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[193],ee([0,1,48,127,38,32,192]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,I=>I.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,I=>`$(${I.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(36,null),type:"boolean",default:!0}}};function d(){T.Registry.as(D.Extensions.Configuration).registerConfiguration(f),y()}e.registerTerminalPlatformConfiguration=d;let l;function y(I,b){const C=T.Registry.as(D.Extensions.Configuration);l&&C.deregisterConfigurations([l]);let v;I&&(v=(0,A.createProfileSchemaEnums)(I?.profiles,b)),l={id:"terminal",order:100,title:(0,L.localize)(37,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(38,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:I?.os===3?v?.values:void 0,markdownEnumDescriptions:I?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:I?.os===2?v?.values:void 0,markdownEnumDescriptions:I?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:I?.os===1?v?.values:void 0,markdownEnumDescriptions:I?.os===1?v?.markdownDescriptions:void 0}}},C.registerConfiguration(l)}e.registerTerminalDefaultProfileConfiguration=y}),define(Z[194],ee([0,1,41,48,8,4,18,69,190,86]),function(K,e,R,L,D,T,A,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function w(t,r,i,a,h=process.env,c,u,g,S){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?f(i,c,h,u,a.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),S,g):v(c,u,i,t&&typeof t=="object"?{...t}:a.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),S,g,h)}e.detectAvailableProfiles=w;async function f(t,r,i,a,h,c,u,g,S){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),k=`${process.env.windir}\\${m?"Sysnative":"System32"}`;let O=!1;(0,p.getWindowsBuildNumber)()>=16299&&(O=!0),await y(g);const x=new Map;t&&(x.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),x.set("Windows PowerShell",{path:`${k}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),x.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),x.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),x.set("Command Prompt",{path:`${k}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),s(c,x);const z=await d(x.entries(),u,r,i,a,S);if(t||!t&&h)try{const H=await b(`${k}\\${O?"wsl":"bash"}.exe`,u);for(const V of H)(!c||!(V.profileName in c))&&z.push(V)}catch(H){a?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function d(t,r,i,a=process.env,h,c){const u=[];for(const[g,S]of t){if(S===null)continue;let m,k,O;if("source"in S){const H=n?.get(S.source);if(!H)continue;m=H.paths,k=S.args||H.args,S.icon?O=l(S.icon):H.icon&&(O=H.icon)}else m=Array.isArray(S.path)?S.path:[S.path],k=T.isWindows||Array.isArray(S.args)?S.args:void 0,O=l(S.icon)||void 0;const x=await c?.(m)||m.slice(),z=await o(g,r,x,i,a,k,S.env,S.overrideName,S.isAutoDetected,h);z?(z.isAutoDetected=S.isAutoDetected,z.icon=O,z.color=S.color,u.push(z)):h?.trace("profile not validated",g,m)}return u}function l(t){return typeof t=="string"?{id:t}:t}async function y(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await I(),icon:E.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function I(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],a=await new Promise((u,g)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le"},(S,m)=>{if(S)return g("Problem occurred when getting wsl distros");u(m)})});if(!a)return[];const h=new RegExp(/[\r?\n]/),c=a.split(h).filter(u=>u.trim().length>0&&u!=="");for(const u of c){if(u===""||u.startsWith("docker-desktop"))continue;const g=`${u} (WSL)`,S={profileName:g,path:t,args:["-d",`${u}`],isDefault:g===r,icon:C(u)};i.push(S)}return i}function C(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function v(t,r,i,a,h,c,u,g){const S=new Map;if(i){const m=(await t.readFile("/etc/shells")).toString(),k=c||m.split(`
`).filter(x=>x.trim().indexOf("#")!==0&&x.trim().length>0),O=new Map;for(const x of k){let z=(0,D.basename)(x),H=O.get(z)||0;H++,H>1&&(z=`${z} (${H})`),O.set(z,H),S.set(z,{path:x,isAutoDetected:!0})}}return s(a,S),await d(S.entries(),h,t,g,r,u)}function s(t,r){if(!!t)for(const[i,a]of Object.entries(t))a===null||!("path"in a)&&!("source"in a)?r.delete(i):r.set(i,a)}async function o(t,r,i,a,h,c,u,g,S,m){if(i.length===0)return Promise.resolve(void 0);const k=i.shift();if(k==="")return o(t,r,i,a,h,c,u,g,S);const O={profileName:t,path:k,args:c,env:u,overrideName:g,isAutoDetected:S,isDefault:t===r};if((0,D.basename)(k)===k){const z=h.PATH?h.PATH.split(D.delimiter):void 0;return await(0,p.findExecutable)(k,void 0,z,void 0,a.existsFile)?O:o(t,r,i,a,h,c)}return await a.existsFile((0,D.normalize)(k))?O:o(t,r,i,a,h,c,u,g,S)}}),define(Z[195],ee([0,1,3,2,17,4,36,51,24,156,14,79,21,188,85,193,194]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var b;(function(s){s[s.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let C=0,v=class extends L.Disposable{constructor(o,t,r,i){super();this._reconnectConstants=o,this._configurationService=t,this._logService=r,this._telemetryService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new R.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new R.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new R.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new R.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new R.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,E.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const o=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),A.ProxyChannel.toService(o.getChannel(l.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(o.onDidProcessExit(a=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=b.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const r=o.getChannel(l.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const i=A.ProxyChannel.toService(o.getChannel(l.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(a=>this._onProcessData.fire(a))),this._register(i.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(i.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(i.onProcessTitleChanged(a=>this._onProcessTitleChanged.fire(a))),this._register(i.onProcessShellTypeChanged(a=>this._onProcessShellTypeChanged.fire(a))),this._register(i.onProcessOverrideDimensions(a=>this._onProcessOverrideDimensions.fire(a))),this._register(i.onProcessResolvedShellLaunchConfig(a=>this._onProcessResolvedShellLaunchConfig.fire(a))),this._register(i.onProcessDidChangeHasChildProcesses(a=>this._onProcessDidChangeHasChildProcesses.fire(a))),this._register(i.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(i.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(i.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[o,i]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,t,r,i,a,h,c,u,g,S){const m=setTimeout(()=>this._handleUnresponsiveCreateProcess(),l.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(o,t,r,i,a,h,c,u,g,S);return clearTimeout(m),C=Math.max(C,k),k}updateTitle(o,t,r){return this._proxy.updateTitle(o,t,r)}updateIcon(o,t,r){return this._proxy.updateIcon(o,t,r)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,t){return this._proxy.shutdown(o,t)}input(o,t){return this._proxy.input(o,t)}processBinary(o,t){return this._proxy.processBinary(o,t)}resize(o,t,r){return this._proxy.resize(o,t,r)}acknowledgeDataEvent(o,t){return this._proxy.acknowledgeDataEvent(o,t)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,t,r,i=!1){const a=await this._shellEnv;return(0,I.detectAvailableProfiles)(t,r,i,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,t){return this._proxy.requestDetachInstance(o,t)}async acceptDetachInstanceReply(o,t){return this._proxy.acceptDetachInstanceReply(o,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier+l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${l.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:t})}async acceptPtyHostResolvedVariables(o,t){this._resolveVariablesRequestStore.acceptReply(o,t)}};v=de([Y(1,p.IConfigurationService),Y(2,n.ILogService),Y(3,f.ITelemetryService)],v),e.PtyHostService=v}),define(Z[54],ee([0,1,43]),function(K,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,p,E){const n=(0,R.setProperty)(A,P,p,E)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function D(A,P,p){let E=p;for(;E>=0;){if(A.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&A.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=D;function T(A,P,p){let E=p;for(;E>=0;)if(A.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&A.charAt(E)===P.charAt(1)))return E;return A.length-1}e.getLineEndOffset=T}),define(Z[196],ee([0,1,26,58]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(w,f,d,l,y){const I=[],b=[],C=[];if(!f){const k=w.filter(({identifier:O})=>y.every(x=>x.toLowerCase()!==O.id.toLowerCase()));return{local:{added:I,removed:b,updated:C},remote:k.length>0?{added:k,updated:[],removed:[],all:k}:null}}w=w.map(E),f=f.map(E),d=d?d.map(E):null;const v=new Map,s=k=>{k.uuid&&v.set(k.id.toLowerCase(),k.uuid)};w.forEach(({identifier:k})=>s(k)),f.forEach(({identifier:k})=>s(k)),d&&d.forEach(({identifier:k})=>s(k));const o=k=>{const O=k.identifier.uuid||v.get(k.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${k.identifier.id.toLowerCase()}`},t=(k,O)=>(k.set(o(O),O),k),r=w.reduce(t,new Map),i=f.reduce(t,new Map),a=f.reduce((k,O)=>{const x=o(O);O=(0,R.deepClone)(O);const z=r.get(x);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(k,O)},new Map),h=d?d.reduce(t,new Map):null,c=l.reduce(t,new Map),u=y.reduce((k,O)=>{const x=v.get(O.toLowerCase());return k.add(x?`uuid:${x}`:`id:${O.toLowerCase()}`)},new Set),g=T(r,i,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const k=T(h,r,u),O=T(h,i,u),x=(z,H)=>{const V=r.get(z);if(V){const U=i.get(z);return{...H?U:V,version:(U.version&&L.gt(U.version,V.version),V.version),state:A(V,U,h?.get(z))}}};for(const z of O.removed.values()){const H=r.get(z);H&&b.push(H.identifier)}for(const z of O.added.values())if(k.added.has(z)){if(g.updated.has(z)){const H=x(z,!0);H&&(C.push(n(H,z)),a.set(z,H))}}else{const H=i.get(z);H.installed&&I.push(n(H,z))}for(const z of O.updated.values()){const H=x(z,!0);H&&(C.push(n(H,z)),a.set(z,H))}for(const z of k.added.values())O.added.has(z)||a.set(z,r.get(z));for(const z of k.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const H=x(z,!1);H&&(a.get(z)?.installed&&(H.installed=!0),a.set(z,H))}for(const z of k.removed.values())!c.has(z)&&!O.updated.has(z)&&h?.get(z)?.installed&&a.delete(z)}const S=[],m=T(i,a,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(m.added.size>0||m.updated.size>0||m.removed.size>0)&&a.forEach((k,O)=>S.push(n(k,O))),{local:{added:I,removed:b,updated:C},remote:S.length?{added:[...m.added].map(k=>a.get(k)),updated:[...m.updated].map(k=>a.get(k)),removed:[...m.removed].map(k=>i.get(k)),all:S}:null}}e.merge=D;function T(w,f,d,{checkInstalledProperty:l,checkVersionProperty:y}={checkInstalledProperty:!1,checkVersionProperty:!1}){const I=w?[...w.keys()].filter(o=>!d.has(o)):[],b=[...f.keys()].filter(o=>!d.has(o)),C=b.filter(o=>I.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),v=I.filter(o=>b.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),s=new Set;for(const o of I){if(v.has(o))continue;const t=w.get(o),r=f.get(o);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||y&&t.version!==r.version||l&&t.installed!==r.installed)&&s.add(o)}return{added:C,removed:v,updated:s}}function A(w,f,d){const l=w.state,y=f.state,I=d?.state;if(!f.version||l&&L.gt(w.version,f.version))return l;if(y&&L.gt(f.version,w.version)||!l)return y;if(!y)return l;const b=(0,R.deepClone)(l),C=I?P(I,y):{added:Object.keys(y).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},v=I?P(I,l):{added:Object.keys(l).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...C.added.values(),...C.updated.values()])b[s]=y[s];for(const s of C.removed.values())v.updated.has(s)||delete b[s];return b}function P(w,f){const d=Object.keys(w),l=Object.keys(f),y=l.filter(C=>d.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),I=d.filter(C=>l.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),b=new Set;for(const C of d){if(I.has(C))continue;const v=w[C],s=f[C];(0,R.equals)(v,s)||b.add(C)}return{added:y,removed:I,updated:b}}function p(w={},f={}){const{added:d,removed:l,updated:y}=P(w,f);return d.size===0&&l.size===0&&y.size===0}function E(w){return{...w,disabled:!!w.disabled,installed:!!w.installed}}function n(w,f){const d={identifier:{id:w.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return w.version&&(d.version=w.version),w.disabled&&(d.disabled=!0),w.installed&&(d.installed=!0),w.state&&(d.state=w.state),d}}),define(Z[87],ee([0,1,23,3,2,31,7,28,20]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends D.Disposable{constructor(f,d){super();this.storageService=f,this.productService=d,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(l=>this.onDidChangeStorageValue(l)))}static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const d=E.exec(f);if(d&&d[1])return{id:d[1],version:d[2]}}initialize(){const f=this.storageService.keys(0,1);for(const d of f){const l=Ze.fromKey(d);l&&this.extensionsWithKeysForSync.add(l.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const d=Ze.fromKey(f.key);if(d){this.extensionsWithKeysForSync.add(d.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,d){this.storageService.store(Ze.toKey(f),JSON.stringify(d),0,1)}getKeysForSync(f){const d=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],l=this.storageService.get(Ze.toKey(f),0),y=l?JSON.parse(l):void 0;return y&&d?(0,R.distinct)([...y,...d]):y||d}};n=de([Y(0,p.IStorageService),Y(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[88],ee([0,1,23,24,7]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,p){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==P&&n!==`-${P}`),p&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(P,p){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==P&&n!==`-${P}`),p&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(P){const p=P.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),n=[],w=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?w.push(f.substring(1)):n.push(f);return(0,R.distinct)([...p,...n].filter(f=>w.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};T=de([Y(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(Z[197],ee([0,1,23,33,26,150,54]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(s){return(0,L.parse)(s)||[]}e.parseKeybindings=P;async function p(s,o,t,r,i){const a=P(s),h=P(o),c=t?P(t):null,u=[...a,...h,...c||[]].map($=>$.key),g=await i.resolveUserBindings(u);let S=n(a,h,c,g);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const m=f(a),k=f(h),O=c?f(c):null,x=l(m,k,g),z=O?l(O,m,g):{added:[...m.keys()].reduce(($,M)=>($.add(M),$),new Set),removed:new Set,updated:new Set},H=O?l(O,k,g):{added:[...k.keys()].reduce(($,M)=>($.add(M),$),new Set),removed:new Set,updated:new Set},V=E(x,z,H);let U=s;for(const $ of V.removed.values())V.conflicts.has($)||(U=C(U,$,r));for(const $ of V.added.values()){if(V.conflicts.has($))continue;const M=k.get($);if(M.some(N=>N.command!==`-${$}`&&S.conflicts.has(g[N.key]))){V.conflicts.add($);continue}U=b(U,M,r)}for(const $ of V.updated.values()){if(V.conflicts.has($))continue;const M=k.get($);if(M.some(N=>N.command!==`-${$}`&&S.conflicts.has(g[N.key]))){V.conflicts.add($);continue}U=v(U,$,M,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=p;function E(s,o,t){const r=new Set,i=new Set,a=new Set,h=new Set;for(const c of o.removed.values())t.updated.has(c)&&h.add(c);for(const c of t.removed.values())h.has(c)||(o.updated.has(c)?h.add(c):i.add(c));for(const c of o.added.values())h.has(c)||t.added.has(c)&&s.updated.has(c)&&h.add(c);for(const c of t.added.values())h.has(c)||(o.added.has(c)?s.updated.has(c)&&h.add(c):r.add(c));for(const c of o.updated.values())h.has(c)||t.updated.has(c)&&s.updated.has(c)&&h.add(c);for(const c of t.updated.values())h.has(c)||(o.updated.has(c)?s.updated.has(c)&&h.add(c):a.add(c));return{added:r,removed:i,updated:a,conflicts:h}}function n(s,o,t,r){const i=new Set,a=w(s,r),h=w(o,r),c=t?w(t,r):null,u=d(a,h);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const g=c?d(c,a):{added:[...a.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const S=c?d(c,h):{added:[...h.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:m,removed:k,updated:O,conflicts:x}=E(u,g,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:m,removed:k,updated:O,conflicts:x}}function w(s,o){const t=new Map;for(const r of s){const i=o[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function f(s){const o=new Map;for(const t of s){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=o.get(r);i||(i=[],o.set(r,i)),i.push(t)}return o}function d(s,o){const t=[...s.keys()],r=[...o.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),a=t.filter(c=>r.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),h=new Set;for(const c of t){if(a.has(c))continue;const u=s.get(c).map(S=>({...S,key:c})),g=o.get(c).map(S=>({...S,key:c}));(0,R.equals)(u,g,(S,m)=>I(S,m))||h.add(c)}return{added:i,removed:a,updated:h}}function l(s,o,t){const r=[...s.keys()],i=[...o.keys()],a=i.filter(u=>r.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),h=r.filter(u=>i.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),c=new Set;for(const u of r){if(h.has(u))continue;const g=s.get(u).map(m=>({...m,key:t[m.key]})),S=o.get(u).map(m=>({...m,key:t[m.key]}));y(g,S)||c.add(u)}return{added:a,removed:h,updated:c}}function y(s,o){return!(!(0,R.equals)(s.filter(({command:t})=>t[0]!=="-"),o.filter(({command:t})=>t[0]!=="-"),(t,r)=>I(t,r))||!(0,R.equals)(s.filter(({command:t})=>t[0]==="-"),o.filter(({command:t})=>t[0]==="-"),(t,r)=>I(t,r)))}function I(s,o){if(s.command!==o.command||s.key!==o.key)return!1;const t=T.ContextKeyExpr.deserialize(s.when),r=T.ContextKeyExpr.deserialize(o.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!D.equals(s.args,o.args))}function b(s,o,t){for(const r of o)s=A.edit(s,[-1],r,t);return s}function C(s,o,t){const r=P(s);for(let i=r.length-1;i>=0;i--)(r[i].command===o||r[i].command===`-${o}`)&&(s=A.edit(s,[i],void 0,t));return s}function v(s,o,t,r){const i=P(s),a=i.findIndex(h=>h.command===o||h.command===`-${o}`);for(let h=i.length-1;h>=0;h--)(i[h].command===o||i[h].command===`-${o}`)&&(s=A.edit(s,[h],void 0,r));for(let h=t.length-1;h>=0;h--)s=A.edit(s,[a],t[h],r);return s}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,A,P){const p={},E={},n=new Set;if(!A)return{local:{added:p,updated:E,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const w=L(T,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:p,updated:E,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=L(P,T),d=L(P,A),l={},y={},I=new Set,b=new Set;for(const C of f.removed.values())d.updated.has(C)?p[C]=A[C]:I.add(C);for(const C of d.removed.values())b.has(C)||(f.updated.has(C)?b.add(C):n.add(C));for(const C of f.updated.values())b.has(C)||(d.updated.has(C)?w.updated.has(C)&&b.add(C):y[C]=T[C]);for(const C of d.updated.values())b.has(C)||(f.updated.has(C)?w.updated.has(C)&&b.add(C):T[C]!==void 0&&(E[C]=A[C]));for(const C of f.added.values())b.has(C)||(d.added.has(C)?w.updated.has(C)&&b.add(C):l[C]=T[C]);for(const C of d.added.values())b.has(C)||(f.added.has(C)?w.updated.has(C)&&b.add(C):p[C]=A[C]);return{local:{added:p,removed:[...n.values()],updated:E},remote:{added:l,removed:[...I.values()],updated:y},conflicts:[...b.values()]}}e.merge=R;function L(T,A){const P=T?Object.keys(T):[],p=A?Object.keys(A):[],E=p.filter(f=>P.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),n=P.filter(f=>p.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),w=new Set;for(const f of P){if(n.has(f))continue;const d=T[f],l=A[f];d!==l&&w.add(f)}return{added:E,removed:n,updated:w}}function D(T,A){const{added:P,removed:p,updated:E}=L(T,A);return P.size===0&&p.size===0&&E.size===0}e.areSame=D}),define(Z[22],ee([0,1,23,15,16,132,38,27,7,81,32]),function(K,e,R,L,D,T,A,P,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const c=n.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(u=>!!c[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function f(){const c=n.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c).filter(m=>!!c[m].ignoreSync),g=Object.keys(c).filter(m=>c[m].scope===2||c[m].scope===6),S=w();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...S])}e.getDefaultIgnoredSettings=f;function d(){const c="vscode://schemas/ignoredSettings",u=n.Registry.as(A.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=n.Registry.as(E.Extensions.JSONContribution),S=()=>{const m=w(),k=f().filter(H=>H!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(H=>k.indexOf(H)===-1),x=k.filter(H=>m.indexOf(H)===-1),z={items:{type:"string",enum:[...O,...x.map(H=>`-${H}`)]}};g.registerSchema(c,z)};return u.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=d;function l(c){return c&&(0,D.isObject)(c)&&(0,D.isString)(c.id)&&(0,D.isArray)(c.scopes)}e.isAuthenticationProvider=l;var y;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function I(c,u,g){return g.joinPath(u.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=I,e.IUserDataSyncStoreManagementService=(0,p.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,p.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,p.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(c){const u={};return u[e.HEADER_EXECUTION_ID]=c,u}e.createSyncHeaders=b;var C;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(u,g,S,m){super(u);this.code=g,this.resource=S,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class s extends v{constructor(u,g,S,m,k){super(u,S,void 0,k);this.url=g,this.serverCode=m}}e.UserDataSyncStoreError=s;class o extends v{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=o,function(c){function u(g){if(g instanceof c)return g;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(S&&S[1]){const m=S[2]==="unknown"?void 0:S[2],k=S[3]==="unknown"?void 0:S[3];return new c(g.message,S[1],m,k)}return new c(g.message,"Unknown")}c.toUserDataSyncError=u}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(c){return`sync.enable.${c}`}e.getEnablementKey=a,e.IUserDataSyncResourceEnablementService=(0,p.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,p.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,p.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,p.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,p.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,p.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function h(c,u){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,L.isEqualOrParent)(c,(0,L.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=h}),define(Z[46],ee([0,1,23,6,25,29,3,33,2,15,19,16,5,128,24,12,13,45,20,21,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=o;let t=class extends p.Disposable{constructor(c,u,g,S,m,k,O,x,z,H){super();this.resource=c,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=m,this.userDataSyncBackupStoreService=k,this.userDataSyncResourceEnablementService=O,this.telemetryService=x,this.logService=z,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,s.PREVIEW_DIR_NAME),this.lastSyncResource=(0,s.getLastSyncResourceUri)(c,g,this.extUri),this.currentMachineIdPromise=(0,b.getServiceMachineId)(g,u,S)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,T.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const u=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,u={}){await this._sync(c,!0,u)}async preview(c,u={}){return this._sync(c,!1,u)}async apply(c,u={}){try{this.syncHeaders={...u};const g=await this.doApply(c);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,u,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let S="idle";try{const m=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(c,m);return S=await this.performSync(k,m,u),S==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):S==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(S)}}finally{this.syncHeaders={}}}async replace(c){const u=await this.resolveContent(c);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const S=await this.getLastSyncUserData(),m=await this.getLatestRemoteUserData(null,S),k=await this.isRemoteDataFromCurrentMachine(m),O=await this.generateSyncPreview({ref:m.ref,syncData:g},S,k,T.CancellationToken.None),x=[];for(const z of O){const H=await this.getAcceptResult(z,z.remoteResource,void 0,T.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,T.CancellationToken.None);x.push([z,{...H,remoteChange:V!==0?V:2}])}await this.applyResult(m,S,x,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const u=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===u}async getLatestRemoteUserData(c,u){if(u){const g=c&&c.latest?c.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(c,u,g){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new s.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,u,g)}catch(S){if(S instanceof s.UserDataSyncError)switch(S.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,u,g);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(c,u,g)}throw S}}async doSync(c,u,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(m=>this.doGenerateSyncResourcePreview(c,u,g,m)));const S=await this.syncPreviewPromise;return this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(S){throw this.syncPreviewPromise=null,S}}async merge(c){return await this.updateSyncResourcePreview(c,async u=>{const g=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(g?.content||""));const S=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=S,u.mergeState=g.hasConflicts?"conflict":S?"accepted":"preview",u.localChange=S?S.localChange:g.localChange,u.remoteChange=S?S.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(c,u){return await this.updateSyncResourcePreview(c,async g=>{const S=await this.getAcceptResult(g,c,u,T.CancellationToken.None);return g.acceptResult=S,g.mergeState="accepted",g.localChange=S.localChange,g.remoteChange=S.remoteChange,g}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async u=>{const g=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(c,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const S=g.resourcePreviews.findIndex(({localResource:m,remoteResource:k,previewResource:O})=>this.extUri.isEqual(m,c)||this.extUri.isEqual(k,c)||this.extUri.isEqual(O,c));S!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async m=>{const k=[...g.resourcePreviews];return k[S]=await u(k[S]),{...g,resourcePreviews:k}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:m})=>m==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const u=c.filter(({mergeState:g})=>g==="conflict");(0,R.equals)(this._conflicts,u,(g,S)=>this.extUri.isEqual(g.previewResource,S.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(c){return f.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return f.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(c){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(c,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(c){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,c))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,c))return g.remoteContent;if(this.extUri.isEqual(g.localResource,c))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,u,g,S){const m=await this.isRemoteDataFromCurrentMachine(c),k=await this.generateSyncPreview(c,u,m,S),O=[];for(const x of k){const z=x.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)O.push({...x,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=g?await this.getMergeResult(x,S):void 0;if(S.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,D.VSBuffer.fromString(H?.content||""));const V=H&&!H.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,S):void 0;O.push({...x,acceptResult:V,mergeState:H?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:H?H.localChange:x.localChange,remoteChange:V?V.remoteChange:H?H.remoteChange:x.remoteChange})}}return{remoteUserData:c,lastSyncUserData:u,resourcePreviews:O,isLastSyncFromCurrentMachine:m}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(c.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const S=u;if(S.content===null)return{ref:u.ref,syncData:null};const m=JSON.parse(S.content);if(o(m))return{...u,syncData:m,content:void 0}}catch(c){c instanceof I.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),S={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(S)))}async getRemoteUserData(c){const{ref:u,content:g}=await this.getUserData(c);let S=null;return g!==null&&(S=this.parseSyncData(g)),{ref:u,syncData:S}}parseSyncData(c){try{const u=JSON.parse(c);if(o(u))return u}catch(u){this.logService.error(u)}throw new s.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,w.isString)(c)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:u}}else{const u=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(c,u){const g=await this.currentMachineIdPromise,S={version:this.version,machineId:g,content:c};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(S),u,this.syncHeaders),{ref:u,syncData:S}}async backupLocal(c){const u={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([Y(1,I.IFileService),Y(2,y.IEnvironmentService),Y(3,C.IStorageService),Y(4,s.IUserDataSyncStoreService),Y(5,s.IUserDataSyncBackupStoreService),Y(6,s.IUserDataSyncResourceEnablementService),Y(7,v.ITelemetryService),Y(8,s.IUserDataSyncLogService),Y(9,l.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,u,g,S,m,k,O,x,z,H,V){super(u,g,S,m,k,O,x,z,H,V);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,u,g){try{u?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(c),g?void 0:u):await this.fileService.createFile(this.file,D.VSBuffer.fromString(c),{overwrite:g})}catch(S){throw S instanceof I.FileOperationError&&S.fileOperationResult===1||S instanceof I.FileOperationError&&S.fileOperationResult===3?new s.UserDataSyncError(S.message,"LocalPreconditionFailed"):S}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=de([Y(2,I.IFileService),Y(3,y.IEnvironmentService),Y(4,C.IStorageService),Y(5,s.IUserDataSyncStoreService),Y(6,s.IUserDataSyncBackupStoreService),Y(7,s.IUserDataSyncResourceEnablementService),Y(8,v.ITelemetryService),Y(9,s.IUserDataSyncLogService),Y(10,l.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,u,g,S,m,k,O,x,z,H,V,U){super(c,u,g,S,m,k,O,x,z,H,U);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(c){const u=[];return(0,P.parse)(c,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([Y(2,I.IFileService),Y(3,y.IEnvironmentService),Y(4,C.IStorageService),Y(5,s.IUserDataSyncStoreService),Y(6,s.IUserDataSyncBackupStoreService),Y(7,s.IUserDataSyncResourceEnablementService),Y(8,v.ITelemetryService),Y(9,s.IUserDataSyncLogService),Y(10,s.IUserDataSyncUtilService),Y(11,l.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let a=class{constructor(c,u,g,S){this.resource=c,this.environmentService=u,this.logService=g,this.fileService=S,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,s.getLastSyncResourceUri)(this.resource,u,E.extUri)}async initialize({ref:c,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:g})}catch(m){this.logService.error(m)}}parseSyncData(c){try{const u=JSON.parse(c);if(o(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,u={}){const g={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(g)))}};a=de([Y(1,y.IEnvironmentService),Y(2,s.IUserDataSyncLogService),Y(3,I.IFileService)],a),e.AbstractInitializer=a}),define(Z[199],ee([0,1,6,11,3,43,47,19,5,24,12,27,31,13,20,21,46,196,87,88,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function o(h,c){const u=JSON.parse(h.content);if(h.version===1||h.version===2){const g=(await c.getInstalled(0)).filter(S=>S.isBuiltin);for(const S of u)h.version===1&&(S.enabled===!1&&(S.disabled=!0),delete S.enabled),h.version===2&&g.every(m=>!(0,f.areSameExtensions)(m.identifier,S.identifier))&&(S.installed=!0)}return u}function t(h,c,u){const g=u.get((0,f.getExtensionId)(h,c),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=t;function r(h,c,u,g){g.store((0,f.getExtensionId)(h,c),JSON.stringify(u),0,1)}e.storeExtensionStorageState=r;let i=class at extends I.AbstractSynchroniser{constructor(c,u,g,S,m,k,O,x,z,H,V,U,$,M){super("extensions",u,c,g,S,m,U,$,z,V);this.storageService=g,this.extensionManagementService=k,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=x,this.extensionGalleryService=H,this.extensionsStorageSyncService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.debounce(D.Event.any(D.Event.filter(this.extensionManagementService.onDidInstallExtensions,N=>N.some(({local:q})=>!!q)),D.Event.filter(this.extensionManagementService.onDidUninstallExtension,N=>!N.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,u){const g=c.syncData?await o(c.syncData,this.extensionManagementService):null,S=u?.skippedExtensions||[],m=u?.syncData?await o(u.syncData,this.extensionManagementService):null,k=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(k),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(k);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:H}=(0,b.merge)(O,g,m,S,x),V={local:z,remote:H,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:S,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,u,g,S){const m=[...u,...g],k=new Set,O=x=>{k.add(x.id.toLowerCase()),x.uuid&&k.add(x.uuid)};m.forEach(({identifier:x})=>O(x)),S.forEach(O);for(const x of c)k.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&k.has(x.identifier.uuid)||m.push(x);return this.format(m)}async getMergeResult(c,u){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,u,g,S){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(u,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(c){const u=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),S=(0,b.merge)(c.localExtensions,null,null,c.skippedExtensions,g),{local:m,remote:k}=S;return{content:c.localContent,local:m,remote:k,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(c){const u=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),S=c.remoteContent?JSON.parse(c.remoteContent):null;if(S!==null){const m=(0,b.merge)(c.localExtensions,S,c.localExtensions,[],g),{local:k,remote:O}=m;return{content:c.remoteContent,local:k,remote:O,localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,u,g,S){let{skippedExtensions:m,localExtensions:k}=g[0][0],{local:O,remote:x,localChange:z,remoteChange:H}=g[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(k)),m=await this.updateLocalExtensions(O.added,O.removed,O.updated,m)),x){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(x.all);c=await this.updateRemoteUserData(V,S?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(U=>U.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(U=>U.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(U=>U.identifier.id))}.`:""}`)}u?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:m}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${m.length?` Skipped: ${JSON.stringify(m.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),m=this.getLocalExtensions(g).filter(k=>!S.some(O=>(0,f.areSameExtensions)({id:O},k.identifier)));return this.format(m)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let u=await super.resolveContent(c);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(c)),u){const g=this.parseSyncData(u);if(g)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(c){c.sort((S,m)=>!S.identifier.uuid&&m.identifier.uuid?-1:S.identifier.uuid&&!m.identifier.uuid?1:(0,P.compare)(S.identifier.id,m.identifier.id));const u=JSON.stringify(c),g=(0,A.format)(u,void 0,{});return(0,T.applyEdits)(u,g)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(g=>g.installed||g.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,u,g,S){const m=[],k=[],O=await this.extensionManagementService.getInstalled();if(u.length){const z=O.filter(({identifier:H,isBuiltin:V})=>!V&&u.some(U=>(0,f.areSameExtensions)(H,U)));await R.Promises.settled(z.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),m.push(H.identifier)}))}(c.length||g.length)&&await R.Promises.settled([...c,...g].map(async z=>{const H=O.find(U=>(0,f.areSameExtensions)(U.identifier,z.identifier));if(H&&H.isBuiltin){z.state&&H.manifest.version===z.version&&this.updateExtensionState(z.state,H.manifest.publisher,H.manifest.name,H.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),m.push(z.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(H?H.manifest.version===z.version:!!V)){const U=H?H.manifest.publisher:V.publisher,$=H?H.manifest.name:V.name;this.updateExtensionState(z.state,U,$,H?.manifest.version)}if(V)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,V.version)),H||(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,V.version),m.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),k.push(z)))}catch(U){k.push(z),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),k.push(z)}));const x=[];for(const z of S)m.some(H=>(0,f.areSameExtensions)(H,z.identifier))||x.push(z);for(const z of k)x.some(H=>(0,f.areSameExtensions)(H.identifier,z.identifier))||x.push(z);return x}updateExtensionState(c,u,g,S){const m=t(u,g,this.storageService),k=S?this.extensionsStorageSyncService.getKeysForSync({id:(0,f.getGalleryExtensionId)(u,g),version:S}):void 0;k?k.forEach(O=>{m[O]=c[O]}):Object.keys(c).forEach(O=>m[O]=c[O]),r(u,g,m,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const u=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:g,isBuiltin:S,manifest:m})=>{const k={identifier:g,version:m.version};u.some(O=>(0,f.areSameExtensions)(O,g))&&(k.disabled=!0),S||(k.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:m.version});if(O){const x=t(m.publisher,m.name,this.storageService);k.state=Object.keys(x).reduce((z,H)=>(O.includes(H)&&(z[H]=x[H]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(O))}return k})}};i.EXTENSIONS_DATA_URI=p.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,n.IEnvironmentService),Y(1,d.IFileService),Y(2,l.IStorageService),Y(3,s.IUserDataSyncStoreService),Y(4,s.IUserDataSyncBackupStoreService),Y(5,w.IExtensionManagementService),Y(6,w.IGlobalExtensionEnablementService),Y(7,v.IIgnoredExtensionsManagementService),Y(8,s.IUserDataSyncLogService),Y(9,w.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,s.IUserDataSyncResourceEnablementService),Y(12,y.ITelemetryService),Y(13,C.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends I.AbstractInitializer{constructor(c,u,g,S,m){super("extensions",S,m,g);this.extensionManagementService=c,this.ignoredExtensionsManagementService=u}async parseExtensions(c){return c.syncData?await o(c.syncData,this.extensionManagementService):null}generatePreview(c,u){const g=[],S=[],m=[];for(const k of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(k.identifier.id))continue;const O=u.find(x=>(0,f.areSameExtensions)(x.identifier,k.identifier));O?(g.push(O),k.disabled&&m.push(k.identifier)):k.installed&&(S.push(k.identifier),k.disabled&&m.push(k.identifier))}return{installedExtensions:g,newExtensions:S,disabledExtensions:m,remoteExtensions:c}}};a=de([Y(0,w.IExtensionManagementService),Y(1,v.IIgnoredExtensionsManagementService),Y(2,d.IFileService),Y(3,n.IEnvironmentService),Y(4,s.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(Z[200],ee([0,1,26,22]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,p,E,n,w){if(!p)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=T(P,p);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const d=E?T(E,p):{added:Object.keys(p).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},l=E?T(E,P):{added:Object.keys(P).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},I=R.deepClone(p),b=!E;for(const C of l.added.values())C!==L.SYNC_SERVICE_URL_TYPE&&b&&d.added.has(C)||(I[C]=P[C]);for(const C of l.updated.values())I[C]=P[C];for(const C of l.removed.values())n.unregistered.includes(C)||delete I[C];for(const C of d.added.values()){const v=p[C];if(n.machine.includes(C)){w.info(`GlobalState: Skipped adding ${C} in local storage because it is declared as machine scoped.`);continue}if(E&&l.added.has(C))continue;const s=P[C];s&&s.value===v.value||C===L.SYNC_SERVICE_URL_TYPE&&b&&l.added.has(C)||(s?y.updated[C]=v:y.added[C]=v)}for(const C of d.updated.values()){const v=p[C];if(n.machine.includes(C)){w.info(`GlobalState: Skipped updating ${C} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(C)||l.removed.has(C))continue;const s=P[C];s&&s.value===v.value||(y.updated[C]=v)}for(const C of d.removed.values()){if(n.machine.includes(C)){w.trace(`GlobalState: Skipped removing ${C} in local storage because it is declared as machine scoped.`);continue}l.updated.has(C)||l.removed.has(C)||y.removed.push(C)}return{local:y,remote:A(I,p)?null:I}}e.merge=D;function T(P,p){const E=Object.keys(P),n=Object.keys(p),w=n.filter(l=>E.indexOf(l)===-1).reduce((l,y)=>(l.add(y),l),new Set),f=E.filter(l=>n.indexOf(l)===-1).reduce((l,y)=>(l.add(y),l),new Set),d=new Set;for(const l of E){if(f.has(l))continue;const y=P[l],I=p[l];R.equals(y,I)||d.add(l)}return{added:w,removed:f,updated:d}}function A(P,p){const{added:E,removed:n,updated:w}=T(P,p);return E.size===0&&n.size===0&&w.size===0}}),define(Z[201],ee([0,1,25,3,33,43,47,4,5,30,24,12,13,14,45,20,21,46,54,200,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",t=["locale"];function r(u){const g=u.storage?Object.keys(u.storage).sort():[],S={};g.forEach(O=>S[O]=u.storage[O]),u.storage=S;const m=JSON.stringify(u),k=(0,A.format)(m,void 0,{});return(0,T.applyEdits)(m,k)}const i=1;let a=class ot extends b.AbstractSynchroniser{constructor(g,S,m,k,O,x,z,H,V){super("globalState",g,O,V,S,m,x,z,k,H);this.storageService=V,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(V.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:V.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,S,m,k){const O=g.syncData?JSON.parse(g.syncData.content):null;S=S===null&&m?g:S;const x=S&&S.syncData?JSON.parse(S.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=this.getStorageKeys(x),{local:V,remote:U}=(0,v.merge)(z.storage,O?O.storage:null,x?x.storage:null,H,this.logService),$={content:null,local:V,remote:U,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async getMergeResult(g,S){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,S,m,k){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(S,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const S=JSON.parse(g.remoteContent),{local:m,remote:k}=(0,v.merge)(g.localUserData.storage,S.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:m,remote:k,localChange:Object.keys(m.added).length>0||Object.keys(m.updated).length>0||m.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,S,m,k){let{localUserData:O}=m[0][0],{local:x,remote:z,localChange:H,remoteChange:V}=m[0][1];if(H===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(x),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:z});g=await this.updateRemoteUserData(U,k?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}S?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ot.GLOBAL_STATE_DATA_URI)){const m=await this.getLocalGlobalState();return r(m)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let S=await super.resolveContent(g);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(g)),S){const m=this.parseSyncData(S);if(m)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(m.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${o}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},S=await this.getLocalArgvContent(),m=(0,D.parse)(S);for(const k of t)m[k]!==void 0&&(g[`${o}${k}`]={version:1,value:m[k]});for(const k of this.storageService.keys(0,0)){const O=this.storageService.get(k,0);O&&(g[k]={version:1,value:O})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:S,updated:m}){const k={},O={},x=(H,V)=>{for(const U of H){if(U.startsWith(o)){k[U.substring(o.length)]=V?V[U].value:void 0;continue}if(V){const $=V[U];$.value!==String(this.storageService.get(U,0))&&(O[U]=$.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(x(Object.keys(g),g),x(Object.keys(m),m),x(S),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(O))this.storageService.store(H,O[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(g){const S=await this.getLocalArgvContent();let m=S;for(const k of Object.keys(g))m=(0,C.edit)(m,[k],g[k],{});S!==m&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(m)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const S=this.storageService.keys(0,0),m=this.storageService.keys(0,1),k=[...S,...m],O=g?.storage?Object.keys(g.storage).filter(x=>!x.startsWith(o)&&!k.includes(x)&&this.storageService.get(x,0)!==void 0):[];if(!P.isWeb){const x=[...s.ALL_SYNC_RESOURCES.map(z=>(0,s.getEnablementKey)(z)),s.SYNC_SERVICE_URL_TYPE];O.push(...x),m.push(...x)}return{user:S,machine:m,unregistered:O}}};a.GLOBAL_STATE_DATA_URI=p.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([Y(0,f.IFileService),Y(1,s.IUserDataSyncStoreService),Y(2,s.IUserDataSyncBackupStoreService),Y(3,s.IUserDataSyncLogService),Y(4,w.IEnvironmentService),Y(5,s.IUserDataSyncResourceEnablementService),Y(6,I.ITelemetryService),Y(7,n.IConfigurationService),Y(8,y.IStorageService)],a),e.GlobalStateSynchroniser=a;let h=class extends b.AbstractInitializer{constructor(g,S,m,k){super("globalState",m,k,S);this.storageService=g}async doInitialize(g){const S=g.syncData?JSON.parse(g.syncData.content):null;if(!S){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const m={},k={};for(const O of Object.keys(S.storage))O.startsWith(o)?m[O.substring(o.length)]=S.storage[O].value:this.storageService.get(O,0)===void 0&&(k[O]=S.storage[O].value);if(Object.keys(m).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(x){}for(const x of Object.keys(m))O=(0,C.edit)(O,[x],m[x],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O))}if(Object.keys(k).length)for(const O of Object.keys(k))this.storageService.store(O,k[O],0,0)}};h=de([Y(0,y.IStorageService),Y(1,f.IFileService),Y(2,w.IEnvironmentService),Y(3,s.IUserDataSyncLogService)],h),e.GlobalStateInitializer=h;let c=class{constructor(g,S,m,k,O){this.userDataSyncStoreClient=g,this.storageService=S,this.environmentService=m,this.fileService=k,this.logService=O}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[s.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const S=(0,s.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(g,S)}catch(m){if(m instanceof s.UserDataSyncError)switch(m.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,S)}throw m}}async doSync(g,S){const m=await this.userDataSyncStoreClient.read("globalState",null,S),k=this.parseGlobalState(m)||{storage:{}};k.storage[s.SYNC_SERVICE_URL_TYPE]={value:g,version:i};const O=await(0,l.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),x={version:i,machineId:O,content:r(k)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(x),m.ref,S)}parseGlobalState({content:g}){if(!g)return null;const S=JSON.parse(g);if((0,b.isSyncData)(S))return S?JSON.parse(S.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,y.IStorageService),Y(2,w.IEnvironmentService),Y(3,f.IFileService),Y(4,d.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[202],ee([0,1,23,25,3,33,4,16,129,24,12,13,20,21,46,197,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(s,o){const t=JSON.parse(s);if(!o)return(0,P.isUndefined)(t.all)?null:t.all;switch(A.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let C=class extends l.AbstractJsonFileSynchroniser{constructor(o,t,r,i,a,h,c,u,g,S){super(c.keybindingsResource,"keybindings",h,c,u,o,t,a,S,r,g,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,m=>m.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,r,i){const a=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;t=t===null&&r?o:t;const h=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),u=await this.getFormattingOptions();let g=null,S=!1,m=!1,k=!1;if(a){let x=c?c.value.toString():"[]";if(x=x||"[]",this.hasErrors(x))throw new I.UserDataSyncError((0,p.localize)(0,null),"LocalInvalidContent",this.resource);if(!h||h!==x||h!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,y.merge)(x,a,h,u,this.userDataSyncUtilService);z.hasChanges&&(g=z.mergeContent,k=z.hasConflicts,S=k||z.mergeContent!==x,m=k||z.mergeContent!==a)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=c.value.toString(),m=!0);const O={content:g,localChange:S?c?2:1:0,remoteChange:m?2:0,hasConflicts:k};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,i){const{fileContent:a}=r[0][0];let{content:h,localChange:c,remoteChange:u}=r[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),h!==null&&(h=h.trim(),h=h||"[]",this.hasErrors(h)))throw new I.UserDataSyncError((0,p.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(h||"[]",a,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(h||"[]",o.syncData?.content);o=await this.updateRemoteUserData(g,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(g){}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,T.parse)(o.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(o)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(o.syncData.content)}getKeybindingsContentFromSyncContent(o){try{return b(o,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(o,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=o,A.OS){case 2:r.mac=o;break;case 3:r.linux=o;break;case 1:r.windows=o;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let o=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return o!==void 0||(o=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,o!==void 0)?o:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};C=de([Y(0,I.IUserDataSyncStoreService),Y(1,I.IUserDataSyncBackupStoreService),Y(2,I.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,I.IUserDataSyncResourceEnablementService),Y(5,w.IFileService),Y(6,n.IEnvironmentService),Y(7,f.IStorageService),Y(8,I.IUserDataSyncUtilService),Y(9,d.ITelemetryService)],C),e.KeybindingsSynchroniser=C;let v=class extends l.AbstractInitializer{constructor(o,t,r){super("keybindings",t,r,o)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(o.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return b(o,!0)}catch(t){return this.logService.error(t),null}}};v=de([Y(0,w.IFileService),Y(1,n.IEnvironmentService),Y(2,I.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(Z[203],ee([0,1,23,33,43,47,26,54,22]),function(K,e,R,L,D,T,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(c,u,g){let S=[];g?S=w(g):S=n(u);const m=[],k=[...(0,p.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const O of S)O.startsWith("-")?k.push(O.substring(1)):m.push(O);return(0,R.distinct)([...c,...m].filter(O=>k.indexOf(O)===-1))}e.getIgnoredSettings=E;function n(c){let u=c.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=c.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:c.getValue("settingsSync.ignoredSettings")||[]}function w(c){const u=(0,L.parse)(c);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function f(c,u,g,S){if(g.length){const m=h(u),k=(0,L.parse)(u),O=(0,L.parse)(c),x=[];for(const z of g){const H=k[z],V=O[z];H===void 0?c=P.edit(c,[z],void 0,S):V!==void 0?c=P.edit(c,[z],H,S):x.push(o(z,m))}x.sort((z,H)=>z.startOffset-H.startOffset),x.forEach(z=>c=b(z.setting.key,u,c,S))}return c}e.updateIgnoredSettings=f;function d(c,u,g,S,m,k){const O=f(c,u,S,k),x=g!==O,z=g!==u;if(!x&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!x)return{conflictsSettings:[],localContent:f(u,c,S,k),remoteContent:null,hasConflicts:!1};if(g===null&&y(c)){const ne=l(c,u,S)?null:f(u,c,S,k);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let H=c,V=u;const U=(0,L.parse)(c),$=(0,L.parse)(u),M=g?(0,L.parse)(g):null,N=S.reduce((ne,le)=>(ne.add(le),ne),new Set),q=I(U,$,N),F=I(M,U,N),j=I(M,$,N),_=new Map,G=new Set,B=ne=>{G.add(ne);const le=m.filter(({key:fe})=>fe===ne)[0];le?(H=P.edit(H,[ne],le.value,k),V=P.edit(V,[ne],le.value,k)):_.set(ne,{key:ne,localValue:U[ne],remoteValue:$[ne]})};for(const ne of F.removed.values())j.updated.has(ne)?B(ne):V=P.edit(V,[ne],void 0,k);for(const ne of j.removed.values())G.has(ne)||(F.updated.has(ne)?B(ne):H=P.edit(H,[ne],void 0,k));for(const ne of F.updated.values())G.has(ne)||(j.updated.has(ne)?q.updated.has(ne)&&B(ne):V=P.edit(V,[ne],U[ne],k));for(const ne of j.updated.values())G.has(ne)||(F.updated.has(ne)?q.updated.has(ne)&&B(ne):H=P.edit(H,[ne],$[ne],k));for(const ne of F.added.values())G.has(ne)||(j.added.has(ne)?q.updated.has(ne)&&B(ne):V=b(ne,H,V,k));for(const ne of j.added.values())G.has(ne)||(F.added.has(ne)?q.updated.has(ne)&&B(ne):H=b(ne,V,H,k));const X=_.size>0||!l(H,V,S),Q=X||!l(H,c,[]),ie=X||!l(V,u,[]);return{localContent:Q?H:null,remoteContent:ie?V:null,conflictsSettings:[..._.values()],hasConflicts:X}}e.merge=d;function l(c,u,g){if(c===u)return!0;const S=(0,L.parse)(c),m=(0,L.parse)(u),k=g.reduce((z,H)=>(z.add(H),z),new Set),O=h(c).filter(z=>!(z.setting&&k.has(z.setting.key))),x=h(u).filter(z=>!(z.setting&&k.has(z.setting.key)));if(O.length!==x.length)return!1;for(let z=0;z<O.length;z++){const H=O[z],V=x[z];if(H.setting&&V.setting){if(H.setting.key!==V.setting.key||!A.equals(S[H.setting.key],m[H.setting.key]))return!1}else if(!H.setting&&!V.setting){if(H.value!==V.value)return!1}else return!1}return!0}e.areSame=l;function y(c){return c?h(c).length===0:!0}e.isEmpty=y;function I(c,u,g){const S=c?Object.keys(c).filter(z=>!g.has(z)):[],m=Object.keys(u).filter(z=>!g.has(z)),k=m.filter(z=>S.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),O=S.filter(z=>m.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),x=new Set;if(c)for(const z of S){if(O.has(z))continue;const H=c[z],V=u[z];A.equals(H,V)||x.add(z)}return{added:k,removed:O,updated:x}}function b(c,u,g,S){const m=(0,L.parse)(u),k=h(u),O=h(g),x=C(c,k,O);return v(g,c,m[c],x,O,S)}e.addSetting=b;function C(c,u,g){const S=u.findIndex(k=>k.setting?.key===c),m=u[S-1];if(m){if(m.setting){const O=o(m.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=t(S,u);if(O){const x=o(O.setting.key,g);if(x){const z=r(g.indexOf(x),g),H=i(u,O,u[S]);if(z){const V=i(g,x,z),U=a(H,V);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.indexOf(z),insertAfter:!1}}else{const V=i(g,x,g[g.length-1]),U=a(H,V);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const k=u[S+1];if(k)if(k.setting){const O=o(k.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=r(S,u);if(O){const x=o(O.setting.key,g);if(x){const z=t(g.indexOf(x),g),H=i(u,u[S],O);if(z){const V=i(g,z,x),U=a(H.reverse(),V.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:g.indexOf(z),insertAfter:!0}}else{const V=i(g,g[0],x),U=a(H.reverse(),V.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function v(c,u,g,S,m,k){let O;return S.index===-1?O=(0,D.setProperty)(c,[u],g,k):O=s(c,u,g,S,m,k).map(x=>(0,D.withFormatting)(c,x,k)[0]),(0,D.applyEdits)(c,O)}function s(c,u,g,S,m,k){const O=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,x=(0,T.getEOL)(k,c),z=m[S.index];if(S.insertAfter){const H=[];if(z.setting)H.push({offset:z.endOffset,length:0,content:","+O});else{const V=r(S.index,m),U=t(S.index,m),$=U?.setting?.commaOffset;U&&$===void 0&&H.push({offset:U.endOffset,length:0,content:","});const M=$!==void 0&&$>z.endOffset;H.push({offset:M?$+1:z.endOffset,length:0,content:V?x+O+",":x+O})}return H}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const H=(m[S.index-1]&&!m[S.index-1].setting?x:"")+O+(r(S.index,m)?",":"")+x;return[{offset:z.startOffset,length:0,content:H}]}}function o(c,u){return u.filter(g=>g.setting?.key===c)[0]}function t(c,u){for(let g=c-1;g>=0;g--)if(u[g].setting)return u[g]}function r(c,u){for(let g=c+1;g<u.length;g++)if(u[g].setting)return u[g]}function i(c,u,g){const S=c.indexOf(u),m=c.indexOf(g);return c.filter((k,O)=>S<O&&O<m)}function a(c,u){if(c.length&&u.length){let g=0;for(;g<u.length&&g<c.length;g++)if(c[g].value!==u[g].value)return u[g-1];return u[g-1]}}function h(c){const u=[];let g=-1,S,m;const k={onObjectBegin:O=>{g++},onObjectProperty:(O,x,z)=>{g===0&&(S=x,m=O)},onObjectEnd:(O,x)=>{g--,g===0&&u.push({startOffset:S,endOffset:O+x,value:c.substring(S,O+x),setting:{key:m,commaOffset:void 0}})},onArrayBegin:(O,x)=>{g++},onArrayEnd:(O,x)=>{g--,g===0&&u.push({startOffset:S,endOffset:O+x,value:c.substring(S,O+x),setting:{key:m,commaOffset:void 0}})},onLiteralValue:(O,x,z)=>{g===0&&u.push({startOffset:S,endOffset:x+z,value:c.substring(S,x+z),setting:{key:m,commaOffset:void 0}})},onSeparator:(O,x,z)=>{if(g===0&&O===","){let H=u.length-1;for(;H>=0&&!u[H].setting;H--);const V=u[H];V&&u.splice(H,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:x}})}},onComment:(O,x)=>{g===0&&u.push({startOffset:O,endOffset:O+x,value:c.substring(O,O+x)})}};return(0,L.visit)(c,k),u}}),define(Z[204],ee([0,1,25,3,43,130,24,12,27,13,20,21,46,54,203,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function I(o){return o&&o.settings&&typeof o.settings=="string"&&Object.keys(o).length===1}function b(o){const t=JSON.parse(o);return I(t)?t:{settings:o}}e.parseSettingsSyncContent=b;let C=class extends f.AbstractJsonFileSynchroniser{constructor(t,r,i,a,h,c,u,g,S,m,k){super(r.settingsResource,"settings",t,r,i,a,h,S,m,c,u,g);this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,a){const h=await this.getLocalFileContent(),c=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const g=r?this.getSettingsSyncContent(r):null,S=await this.getIgnoredSettings();let m=null,k=!1,O=!1,x=!1;if(u){let H=h?h.value.toString().trim():"{}";H=H||"{}",this.validateContent(H),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,l.merge)(H,u.settings,g?g.settings:null,S,[],c);m=V.localContent||V.remoteContent,k=V.localContent!==null,O=V.remoteContent!==null,x=V.hasConflicts}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=h.value.toString(),O=!0);const z={content:m,localChange:k?2:0,remoteChange:O?2:0,hasConflicts:x};return[{fileContent:h,localResource:this.localResource,localContent:h?h.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,l.updateIgnoredSettings)(t.previewResult.content,"{}",a,i):null}}async getAcceptResult(t,r,i,a){const h=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,l.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,h):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,l.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,h):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,l.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",c,h):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:h}=i[0][0];let{content:c,localChange:u,remoteChange:g}=i[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),h&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(h.value.toString()))),await this.updateLocalFileContent(c,h,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const S=await this.getFormattingOptions(),m=this.getSettingsSyncContent(t),k=await this.getIgnoredSettings(c);c=(0,l.updateIgnoredSettings)(c,m?m.settings:"{}",k,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(S){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,d.edit)(t.value.toString(),[y.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,l.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,l.updateIgnoredSettings)(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:h})=>!!h)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,l.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new y.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!s(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const h=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const u=(0,D.setProperty)(a,[c],r[c],h);u.length&&(a=(0,D.applyEdits)(a,u))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(a))}catch(t){}}};C=de([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,n.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,y.IUserDataSyncUtilService),Y(7,A.IConfigurationService),Y(8,y.IUserDataSyncResourceEnablementService),Y(9,w.ITelemetryService),Y(10,p.IExtensionManagementService)],C),e.SettingsSynchroniser=C;let v=class extends f.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,l.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};v=de([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,y.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function s(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&o.machineId!==void 0&&typeof o.machineId=="string")}}),define(Z[205],ee([0,1,25,3,26,24,12,13,20,21,46,198,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends n.AbstractSynchroniser{constructor(I,b,C,v,s,o,t,r,i){super("snippets",b,I,C,v,s,r,i,o,t);this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,b,C,v){const s=await this.getSnippetsFileContents(),o=this.toSnippetsContents(s),t=I.syncData?this.parseSnippets(I.syncData):null;b=b===null&&C?I:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,w.merge)(o,t,r);return this.getResourcePreviews(i,s,t||{})}async getMergeResult(I,b){return I.previewResult}async getAcceptResult(I,b,C,v){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return C===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:C,localChange:C===null?I.fileContent!==null?3:0:2,remoteChange:C===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(I,b,C,v){const s=C.map(([o,t])=>({...o,acceptResult:t}));s.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,v)),s.some(({remoteChange:o})=>o!==0)&&(I=await this.updateRemoteSnippets(s,I,v)),b?.ref!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of s)try{await this.fileService.del(o)}catch(t){}}getResourcePreviews(I,b,C){const v=new Map;for(const s of Object.keys(I.local.added)){const o={content:I.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};v.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.local.updated)){const o={content:I.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.local.removed){const o={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.remote.added)){const o={content:I.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.remote.updated)){const o={content:I.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.remote.removed){const o={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.conflicts){const o={content:b[s]?b[s].value.toString():null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:C[s]?2:1};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(b))if(!v.has(s)){const o={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:I}){let b=await super.resolveContent(I);if(b){const C=this.parseSyncData(b);if(C){const v=this.parseSnippets(C),s=[];for(const o of Object.keys(v)){const t=this.extUri.joinPath(I,o),r=this.extUri.joinPath(this.snippetsFolder,o),i=await this.fileService.exists(r);s.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(I){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(I);let b=await super.resolveContent(I);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(I)),b){const C=this.parseSyncData(b);if(C)return this.parseSnippets(C)[this.extUri.basename(I)]||null}return null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch(I){}return!1}async updateLocalBackup(I){const b={};for(const C of I)C.fileContent&&(b[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(I,b){for(const{fileContent:C,acceptResult:v,localResource:s,remoteResource:o,localChange:t}of I)if(t!==0){const r=o?this.extUri.basename(o):this.extUri.basename(s),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,R.VSBuffer.fromString(v.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,R.VSBuffer.fromString(v.content),b?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(I,b,C){const v=b.syncData?this.parseSnippets(b.syncData):{},s=(0,D.deepClone)(v);for(const{acceptResult:o,localResource:t,remoteResource:r,remoteChange:i}of I)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete s[a]:s[a]=o.content}return(0,w.areSame)(v,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),C?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(I){return JSON.parse(I.content)}toSnippetsContents(I){const b={};for(const C of Object.keys(I))b[C]=I[C].value.toString();return b}async getSnippetsFileContents(){const I={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof P.FileOperationError&&C.fileOperationResult===1)return I;throw C}for(const C of b.children||[]){const v=C.resource,s=this.extUri.extname(v);if(s===".json"||s===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);I[o]=t}}return I}};d=de([Y(0,A.IEnvironmentService),Y(1,P.IFileService),Y(2,p.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncBackupStoreService),Y(5,f.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,f.IUserDataSyncResourceEnablementService),Y(8,E.ITelemetryService)],d),e.SnippetsSynchroniser=d;let l=class extends n.AbstractInitializer{constructor(I,b,C){super("snippets",b,C,I)}async doInitialize(I){const b=I.syncData?JSON.parse(I.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(b)){const s=b[v];if(s){const o=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(o,R.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(I)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===1}}};l=de([Y(0,P.IFileService),Y(1,A.IEnvironmentService),Y(2,f.IUserDataSyncLogService)],l),e.SnippetsInitializer=l}),define(Z[60],ee([0,1,3,2,7,22]),function(K,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};A=de([Y(0,T.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[206],ee([0,1,6,25,56,2,15,24,12,13,22]),function(K,e,R,L,D,T,A,P,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends T.Disposable{constructor(d,l,y,I){super();this.environmentService=d,this.fileService=l,this.configurationService=y,this.logService=I,n.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(d){const l=(0,A.joinPath)(this.environmentService.userDataSyncHome,d),y=await this.fileService.resolve(l);return y.children?y.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(d,l){if(!l){const y=await this.getAllRefs(d);y.length&&(l=y[y.length-1].ref)}if(l){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,d,l);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(d,l){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,d),I=(0,A.joinPath)(y,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(I,L.VSBuffer.fromString(l))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(d)}catch(b){}}async cleanUpBackup(d){const l=(0,A.joinPath)(this.environmentService.userDataSyncHome,d);try{try{if(!await this.fileService.exists(l))return}catch(I){return}const y=await this.fileService.resolve(l);if(y.children){const I=y.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let C=I.filter(s=>Date.now()-this.getCreationTime(s)>b);const v=I.length-C.length;v<10&&(C=C.slice(10-v)),await R.Promises.settled(C.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};w=de([Y(0,p.IEnvironmentService),Y(1,E.IFileService),Y(2,P.IConfigurationService),Y(3,n.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(Z[207],ee([0,1,2,5]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(f){this.service=f}listen(f,d){switch(d){case"onError":return this.service.onError}throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"triggerSync":return this.service.triggerSync(l[0],l[1],l[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(l[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class T{constructor(f){this.service=f}listen(f,d){throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(l[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(l[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(f){this.service=f}listen(f,d){switch(d){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${d}`)}async call(f,d,l){switch(d){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(l[0],l[1]);case"setEnablement":return this.service.setEnablement(l[0],l[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class p{constructor(f){this.service=f}listen(f,d){switch(d){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(l)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class E{constructor(f){this.service=f}listen(f,d){switch(d){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"switch":return this.service.switch(l[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class n extends R.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:L.URI.revive(f.url),type:f.type,defaultUrl:L.URI.revive(f.defaultUrl),insidersUrl:L.URI.revive(f.insidersUrl),stableUrl:L.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[208],ee([0,1,12,14]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends L.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};D=de([Y(0,L.ILoggerService),Y(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(Z[61],ee([0,1,3,2,4,19,133,12,13,7,28,45,20,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const l="sync.currentMachineName";let y=class Ke extends L.Disposable{constructor(b,C,v,s,o,t){super();this.storageService=v,this.userDataSyncStoreService=s,this.logService=o,this.productService=t,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(b,C,v)}async getMachines(b){const C=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(s=>({...s,isCurrent:s.id===C}))}async addCurrentMachine(b){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(b);v.machines.some(({id:s})=>s===C)||(v.machines.push({id:C,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(b){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(b),s=v.machines.filter(({id:o})=>o!==C);s.length!==v.machines.length&&(v.machines=s,await this.writeMachinesData(v))}async renameMachine(b,C,v){const s=await this.currentMachineIdPromise,o=await this.readMachinesData(v),t=o.machines.find(({id:r})=>r===b);t&&(t.name=C,await this.writeMachinesData(o),o.machines.some(({id:r})=>r===s)&&this.storageService.store(l,C,0,1))}async setEnablement(b,C){const v=await this.readMachinesData(),s=v.machines.find(({id:o})=>o===b);s&&(s.disabled=C?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(b){const C=this.storageService.get(l,0);if(C)return C;const v=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let o=0;for(const t of b){const r=s.exec(t.name),i=r?parseInt(r[1]):0;o=i>o?i:o}return`${v} #${o+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const C=this.parse(this.userData);if(C.version!==Ke.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return C}async writeMachinesData(b){const C=JSON.stringify(b),v=await this.userDataSyncStoreService.write(Ke.RESOURCE,C,this.userData?.ref||null);this.userData={ref:v,content:C},this._onDidChange.fire()}async readUserData(b){if(this.userData){const C=b&&b.latest?b.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===C)return this.userData;if(C===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(C){this.logService.error(C)}return{version:Ke.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=de([Y(0,P.IEnvironmentService),Y(1,p.IFileService),Y(2,f.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncLogService),Y(5,n.IProductService)],y),e.UserDataSyncMachinesService=y}),define(Z[89],ee([0,1,6,56,37,11,3,2,4,15,5,131,12,28,20,21,22,60,61]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",s="sync.disableMachineEventually",o="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let i=class extends P.Disposable{constructor(u,g,S){super();this.storageService=u,this.environmentService=g,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(m=>this.onDidStorageChange(m)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(v,u,0,1)}onDidStorageChange(u){if(u.scope===0&&v===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=de([Y(0,l.IStorageService),Y(1,f.IEnvironmentService),Y(2,I.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let a=class extends P.Disposable{constructor(u,g,S,m,k,O,x,z,H,V,U){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=m,this.userDataSyncService=k,this.logService=O,this.userDataSyncAccountService=x,this.telemetryService=z,this.userDataSyncMachinesService=H,this.storageService=V,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(x.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(k.onDidChangeLocal,($,M)=>$?[...$,M]:[M],1e3)($=>this.triggerSync($,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(u){u?this.storageService.store(r,u,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:u,message:g}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new h(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,g,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(m){if(g)this.logService.error(m),this.updateEnablement(!1);else throw m}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(v,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const g=I.UserDataSyncError.toUserDataSyncError(u);g instanceof I.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?p.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(s,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(s,0,!1)}stopDisableMachineEventually(){this.storageService.remove(s,0)}async triggerSync(u,g,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};a=de([Y(0,d.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncResourceEnablementService),Y(4,I.IUserDataSyncService),Y(5,I.IUserDataSyncLogService),Y(6,b.IUserDataSyncAccountService),Y(7,y.ITelemetryService),Y(8,C.IUserDataSyncMachinesService),Y(9,l.IStorageService),Y(10,I.IUserDataAutoSyncEnablementService)],a),e.UserDataAutoSyncService=a;class h extends P.Disposable{constructor(u,g,S,m,k,O,x,z){super();this.lastSyncUrl=u,this.interval=g,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=m,this.userDataSyncService=k,this.userDataSyncMachinesService=O,this.logService=x,this.storageService=z,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(h.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(h.INTERVAL_SYNCING,!1),this.interval)}sync(u,g){const S=(0,R.createCancelablePromise)(async m=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(k){if((0,T.isPromiseCanceledError)(k))return}return this.doSync(u,g,m)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!u&&(!(0,E.isEqual)(g.defaultUrl,u.defaultUrl)||!(0,E.isEqual)(g.insidersUrl,u.insidersUrl)||!(0,E.isEqual)(g.stableUrl,u.stableUrl))}async doSync(u,g,S){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let m;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),S.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const k=this.storageService.get(o,0);if(k&&this.manifest&&k!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(S.isCancellationRequested)return;const x=O.find(z=>z.isCurrent);if(x?.disabled)throw new I.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(z){throw new I.UserDataAutoSyncError((0,D.toErrorMessage)(z),z instanceof I.UserDataSyncError?z.code:"Unknown")}if(this.manifest&&this.manifest.session!==k&&this.storageService.store(o,this.manifest.session,0,1),S.isCancellationRequested)return;x||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(k){this.logService.error(k),m=k}this._onDidFinishSync.fire(m)}register(u){return super._register(u)}}h.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,3,2,4,20,21,22]),function(K,e,R,L,D,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends L.Disposable{constructor(n,w){super();this.storageService=n,this.telemetryService=w,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(n){return this.storageService.getBoolean((0,P.getEnablementKey)(n),0,!0)}setResourceEnablement(n,w){if(this.isResourceEnabled(n)!==w){const f=(0,P.getEnablementKey)(n);this.telemetryService.publicLog2(f,{enabled:w}),this.storeResourceEnablement(f,w)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,w){this.storageService.store(n,w,0,D.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const w=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===n.key)[0];if(w){this._onDidChangeResourceEnablement.fire([w,this.isResourceEnabled(w)]);return}}}};p=de([Y(0,T.IStorageService),Y(1,A.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(Z[210],ee([0,1,23,6,37,11,3,2,15,30,7,20,21,199,201,202,204,205,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let s=class extends P.Disposable{constructor(i,a,h,c,u,g){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=h,this.logService=c,this.telemetryService=u,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(b.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(l.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(d.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeLocal,()=>S.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,a){await this.checkEnablement();const h=(0,E.generateUuid)();try{const S=(0,C.createSyncHeaders)(h);a&&(S["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,S)}catch(S){const m=C.UserDataSyncError.toUserDataSyncError(S);throw this.reportUserDataSyncError(m,h),m}let c=!1;const u=this;let g;return{manifest:i,run(){if(c)throw new Error("Can run a task only once");return g=(0,L.createCancelablePromise)(S=>u.sync(i,h,S)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,E.generateUuid)(),a=(0,C.createSyncHeaders)(i);let h;try{h=await this.userDataSyncStoreService.manifest(null,a)}catch(c){const u=C.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(u,i),u}return new o(i,h,a,this.synchronisers,this.logService)}async sync(i,a,h){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),h.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,C.createSyncHeaders)(a);for(const g of this.synchronisers){if(h.isCancellationRequested)return;try{await g.sync(i,u)}catch(S){let m=!1;if(S instanceof C.UserDataSyncError)switch(S.code){case"TooLarge":S=new C.UserDataSyncError(S.message,S.code,g.resource),m=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":m=!0;break}const k=C.UserDataSyncError.toUserDataSyncError(S);if(this.reportUserDataSyncError(k,a),m)throw k;this.logService.error(S),this.logService.error(`${g.resource}: ${(0,D.toErrorMessage)(S)}`),this._syncErrors.push([g.resource,k])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(u){const g=C.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,a),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,h,c){await this.checkEnablement();const u=this.getSynchroniser(i);await u.accept(a,h),c&&await u.apply(!1,(0,C.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(i){for(const a of this.synchronisers){const h=await a.resolveContent(i);if(h)return h}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${(0,D.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,R.equals)(this._conflicts,i,([a,h],[c,u])=>a===a&&(0,R.equals)(h,u,(g,S)=>(0,p.isEqual)(g.previewResource,S.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof C.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof C.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=de([Y(0,C.IUserDataSyncStoreService),Y(1,C.IUserDataSyncStoreManagementService),Y(2,n.IInstantiationService),Y(3,C.IUserDataSyncLogService),Y(4,f.ITelemetryService),Y(5,w.IStorageService)],s),e.UserDataSyncService=s;class o extends P.Disposable{constructor(i,a,h,c,u){super();this.id=i,this.manifest=a,this.syncHeaders=h,this.synchronisers=c,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,h=>h.accept(i,a))}catch(h){throw this.logService.error(h),h}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const h of a.resourcePreviews)h.mergeState==="conflict"&&i.push(h.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(g=>g.resource===a);for(const g of h.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await c.merge(g.previewResource);const u=await c.apply(!1,this.syncHeaders);u&&i.push(this.toSyncResourcePreview(c.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(c=>c.resource===i);for(const c of a.resourcePreviews)await h.accept(c.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(c=>c.resource===i);for(const c of a.resourcePreviews)await h.accept(c.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){(0,T.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:z,previewResource:H,remoteResource:V})=>(0,p.isEqual)(i,z)||(0,p.isEqual)(i,H)||(0,p.isEqual)(i,V)));if(h===-1)return this.previews;const[c,u]=this.previews[h],g=u.resourcePreviews.find(({localResource:x,remoteResource:z,previewResource:H})=>(0,p.isEqual)(x,i)||(0,p.isEqual)(z,i)||(0,p.isEqual)(H,i));if(!g)return this.previews;let S=this.synchronizingResources.find(x=>x[0]===c);S||(S=[c,[]],this.synchronizingResources.push(S)),S[1].some(x=>(0,p.isEqual)(x,g.localResource))||(S[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const m=this.synchronisers.find(x=>x.resource===this.previews[h][0]),k=await a(m);k?this.previews.splice(h,1,this.toSyncResourcePreview(m.resource,k)):this.previews.splice(h,1);const O=this.synchronizingResources.findIndex(x=>x[0]===c);return this.synchronizingResources[O][1].splice(S[1].findIndex(x=>(0,p.isEqual)(x,g.localResource)),1),S[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(g=>g.resource===a);let u=h;for(const g of h.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(u=await c.merge(g.previewResource));u&&i.push(this.toSyncResourcePreview(c.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[];for(const h of this.synchronisers){if(i.isCancellationRequested)return[];const c=await h.preview(this.manifest,this.syncHeaders);c&&a.push(this.toSyncResourcePreview(h.resource,c))}return a}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[211],ee([0,1,3,2,16,5,22]),function(K,e,R,L,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(w,f){this.service=w,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(w,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(w,f,d){try{return await this._call(w,f,d)}catch(l){throw this.logService.error(l),l}}async _call(w,f,d){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(d[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(d[0],T.URI.revive(d[1]),d[2],d[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(d[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(d[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(d[0]);case"getAssociatedResources":return this.service.getAssociatedResources(d[0],{created:d[1].created,uri:T.URI.revive(d[1].uri)});case"getMachineId":return this.service.getMachineId(d[0],{created:d[1].created,uri:T.URI.revive(d[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const l=f.substring("manualSync/".length),y=d[0],I=this.getManualSyncTask(y);switch(d=d.slice(1),l){case"preview":return I.preview();case"accept":return I.accept(T.URI.revive(d[0]),d[1]);case"merge":return I.merge(T.URI.revive(d[0]));case"discard":return I.discard(T.URI.revive(d[0]));case"discardConflicts":return I.discardConflicts();case"apply":return I.apply();case"pull":return I.pull();case"push":return I.push();case"stop":return I.stop();case"_getStatus":return I.status;case"dispose":return this.disposeManualSyncTask(I)}}throw new Error("Invalid call")}getManualSyncTask(w){const f=this.manualSyncTasks.get(this.createKey(w));if(!f)throw new Error(`Manual sync taks not found: ${w}`);return f.manualSyncTask}async createManualSyncTask(){const w=new L.DisposableStore,f=w.add(await this.service.createManualSyncTask());return w.add(f.onSynchronizeResources(d=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:d}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:w}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(w){w.dispose();const f=this.createKey(w.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(w){return`manualSyncTask-${w}`}}e.UserDataSyncChannel=P;class p extends L.Disposable{constructor(w){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,d,l){return w.call(f,d,l).then(null,y=>{throw A.UserDataSyncError.toUserDataSyncError(y)})},listen(f,d){return w.listen(f,d)}},this.channel.call("_getInitialData").then(([f,d,l])=>{this.updateStatus(f),this.updateConflicts(d),l&&this.updateLastSyncTime(l),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([d,l])=>[d,A.UserDataSyncError.toUserDataSyncError(l)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:w,manifest:f,status:d}=await this.channel.call("createManualSyncTask"),l=this,y=new E(w,f,d,{async call(I,b,C){return l.channel.call(`manualSync/${I}`,[w,...(0,D.isArray)(b)?b:[b]],C)},listen(I,b){return R.Event.map(R.Event.filter(l.channel.listen(`manualSync/${I}`,b),C=>!y.isDiposed()&&C.manualSyncTaskId===w),C=>C.data)}});return y}replace(w){return this.channel.call("replace",[w])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(w,f,d,l){return this.channel.call("accept",[w,f,d,l])}resolveContent(w){return this.channel.call("resolveContent",[w])}async getLocalSyncResourceHandles(w){return(await this.channel.call("getLocalSyncResourceHandles",[w])).map(({created:d,uri:l})=>({created:d,uri:T.URI.revive(l)}))}async getRemoteSyncResourceHandles(w){return(await this.channel.call("getRemoteSyncResourceHandles",[w])).map(({created:d,uri:l})=>({created:d,uri:T.URI.revive(l)}))}async getAssociatedResources(w,f){return(await this.channel.call("getAssociatedResources",[w,f])).map(({resource:l,comparableResource:y})=>({resource:T.URI.revive(l),comparableResource:T.URI.revive(y)}))}async getMachineId(w,f){return this.channel.call("getMachineId",[w,f])}async updateStatus(w){this._status=w,this._onDidChangeStatus.fire(w)}async updateConflicts(w){this._conflicts=w.map(([f,d])=>[f,d.map(l=>({...l,localResource:T.URI.revive(l.localResource),remoteResource:T.URI.revive(l.remoteResource),previewResource:T.URI.revive(l.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(w){this._lastSyncTime!==w&&(this._lastSyncTime=w,this._onDidChangeLastSyncTime.fire(w))}}e.UserDataSyncChannelClient=p;class E extends L.Disposable{constructor(w,f,d,l){super();this.id=w,this.manifest=f,this._disposed=!1,this._status=d;const y=this;this.channel={async call(I,b,C){try{const v=await l.call(I,b,C);return y.isDiposed()||(y._status=await l.call("_getStatus")),v}catch(v){throw A.UserDataSyncError.toUserDataSyncError(v)}},listen(I,b){return l.listen(I,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const w=await this.channel.call("preview");return this.deserializePreviews(w)}async accept(w,f){const d=await this.channel.call("accept",[w,f]);return this.deserializePreviews(d)}async merge(w){const f=await this.channel.call("merge",[w]);return this.deserializePreviews(f)}async discard(w){const f=await this.channel.call("discard",[w]);return this.deserializePreviews(f)}async discardConflicts(){const w=await this.channel.call("discardConflicts");return this.deserializePreviews(w)}async apply(){const w=await this.channel.call("apply");return this.deserializePreviews(w)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(w){return w.map(([f,d])=>[f,{isLastSyncFromCurrentMachine:d.isLastSyncFromCurrentMachine,resourcePreviews:d.resourcePreviews.map(l=>({...l,localResource:T.URI.revive(l.localResource),remoteResource:T.URI.revive(l.remoteResource),previewResource:T.URI.revive(l.previewResource),acceptedResource:T.URI.revive(l.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,6,29,11,3,2,95,4,15,16,5,30,24,12,13,28,42,45,20,22]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,h=1e3*60*5;let c=class extends A.Disposable{constructor(O,x,z){super();this.productService=O,this.configurationService=x,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(z.onDidChangeValue,H=>H.key===s.SYNC_SERVICE_URL_TYPE&&H.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(s.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(s.SYNC_SERVICE_URL_TYPE,O,0,p.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[s.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(s.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,x){O=p.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...x||{}};if(z&&(0,n.isString)(z.url)&&(0,n.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(H=>(0,n.isArray)(z.authenticationProviders[H].scopes))){const H=z,V=!!H.canSwitch&&!x?.url,U=H.url===H.insidersUrl?"insiders":"stable",$=(V?this.userDataSyncStoreType:void 0)||U,M=x?.url||($==="insiders"?H.insidersUrl:$==="stable"?H.stableUrl:H.url);return{url:w.URI.parse(M),type:$,defaultType:U,defaultUrl:w.URI.parse(H.url),stableUrl:w.URI.parse(H.stableUrl),insidersUrl:w.URI.parse(H.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(H.authenticationProviders).reduce((N,q)=>(N.push({id:q,scopes:H.authenticationProviders[q].scopes}),N),[])}}}};c=de([Y(0,I.IProductService),Y(1,d.IConfigurationService),Y(2,v.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let u=class extends c{constructor(O,x,z){super(O,x,z);const H=this.storageService.get(o,0);H&&(this.previousConfigurationSyncStore=JSON.parse(H));const V=this.productService[s.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(o,JSON.stringify(V),0,1):this.storageService.remove(o,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([Y(0,I.IProductService),Y(1,d.IConfigurationService),Y(2,v.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends A.Disposable{constructor(O,x,z,H,V,U,$){super();this.requestService=z,this.logService=H,this.storageService=$,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,C.getServiceMachineId)(V,U,$).then(M=>{const N={"X-Client-Name":`${x.applicationName}${p.isWeb?"-web":""}`,"X-Client-Version":x.version,"X-Machine-Id":M};return x.commit&&(N["X-Client-Commit"]=x.commit),N}),this.session=new m(a,h,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,x){this.authToken={token:O,type:x}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(x=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),x).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,x=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},H=await this.request(x.toString(),{type:"GET",headers:z},[],L.CancellationToken.None);return(await(0,b.asJson)(H)||[]).map(({url:U,created:$})=>({ref:(0,E.relativePath)(x,x.with({path:U})),created:$*1e3}))}async resolveContent(O,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,x).toString(),H={};H["Cache-Control"]="no-cache";const V=await this.request(z,{type:"GET",headers:H},[],L.CancellationToken.None);return await(0,b.asText)(V)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(x,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async read(O,x,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",x&&(z["If-None-Match"]=x.ref);const V=await this.request(H,{type:"GET",headers:z},[304],L.CancellationToken.None);let U=null;if(V.res.statusCode===304&&(U=x),U===null){const $=V.res.headers.etag;if(!$)throw new s.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",V.res.statusCode,V.res.headers[s.HEADER_OPERATION_ID]);const M=await(0,b.asText)(V);if(!M&&V.res.statusCode===304)throw new s.UserDataSyncStoreError("Empty response",H,"EmptyResponse",V.res.statusCode,V.res.headers[s.HEADER_OPERATION_ID]);U={ref:$,content:M}}return U}async write(O,x,z,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();H={...H},H["Content-Type"]=P.Mimes.text,z&&(H["If-Match"]=z);const U=await this.request(V,{type:"POST",data:x,headers:H},[],L.CancellationToken.None),$=U.res.headers.etag;if(!$)throw new s.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",U.res.statusCode,U.res.headers[s.HEADER_OPERATION_ID]);return $}async manifest(O,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();x={...x},x["Content-Type"]="application/json",O&&(x["If-None-Match"]=O.ref);const H=await this.request(z,{type:"GET",headers:x},[304],L.CancellationToken.None);let V=null;if(H.res.statusCode===304&&(V=O),!V){const $=H.res.headers.etag;if(!$)throw new s.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[s.HEADER_OPERATION_ID]);const M=await(0,b.asText)(H);if(!M&&H.res.statusCode===304)throw new s.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[s.HEADER_OPERATION_ID]);M&&(V={...JSON.parse(M),ref:$})}const U=this.storageService.get(r,0);return U&&V&&U!==V.session&&this.clearSession(),V===null&&U&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),x={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:x},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,x,z,H){if(!this.authToken)throw new s.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;x.headers={...x.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(x.headers),this.logService.trace("Sending request to server",{url:O,type:x.type,headers:{...x.headers,authorization:void 0}});let U;try{U=await this.session.request(O,x,H)}catch(q){if(!(q instanceof s.UserDataSyncStoreError)){let F="RequestFailed";const j=(0,D.getErrorMessage)(q).toLowerCase();j.includes("xhr timeout")?F="RequestTimeout":j.includes("protocol")&&j.includes("not supported")?F="RequestProtocolNotSupported":j.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":j.includes("headers must be an object")?F="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(q)&&(F="RequestCanceled"),q=new s.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,F,void 0,void 0)}throw this.logService.info("Request failed",O),q}const $=U.res.headers[s.HEADER_OPERATION_ID],M={url:O,status:U.res.statusCode,"execution-id":x.headers[s.HEADER_EXECUTION_ID],"operation-id":$},N=(0,b.isSuccess)(U)||U.res.statusCode&&z.indexOf(U.res.statusCode)!==-1;if(N?this.logService.trace("Request succeeded",M):this.logService.info("Request failed",M),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new s.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,$);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,$);if(U.res.statusCode===410)throw new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,$);if(U.res.statusCode===412)throw new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,$);if(U.res.statusCode===413)throw new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,$);if(U.res.statusCode===426)throw new s.UserDataSyncStoreError(`${x.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,$);if(U.res.statusCode===429){const q=U.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,$)):new s.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,$)}if(!N)throw new s.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,$);return U}addSessionHeaders(O){let x=this.storageService.get(i,0);x===void 0&&(x=(0,f.generateUuid)(),this.storageService.store(i,x,0,1)),O["X-Machine-Session-Id"]=x;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};g=de([Y(1,I.IProductService),Y(2,b.IRequestService),Y(3,s.IUserDataSyncLogService),Y(4,l.IEnvironmentService),Y(5,y.IFileService),Y(6,v.IStorageService)],g),e.UserDataSyncStoreClient=g;let S=class extends g{constructor(O,x,z,H,V,U,$){super(O.userDataSyncStore?.url,x,z,H,V,U,$);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};S=de([Y(0,s.IUserDataSyncStoreManagementService),Y(1,I.IProductService),Y(2,b.IRequestService),Y(3,s.IUserDataSyncLogService),Y(4,l.IEnvironmentService),Y(5,y.IFileService),Y(6,v.IStorageService)],S),e.UserDataSyncStoreService=S;class m{constructor(O,x,z,H){this.limit=O,this.interval=x,this.requestService=z,this.logService=H,this.requests=[],this.startTime=void 0}request(O,x,z){if(this.isExpired()&&this.reset(),x.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new s.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(x,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=m}),define(Z[213],ee([0,1,3,59,28,20,21,89,22,60,61]),function(K,e,R,L,D,T,A,P,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(d,l,y,I,b,C,v,s,o,t,r,i){super(d,l,y,I,b,v,s,o,t,r,i);this._register(R.Event.debounce(R.Event.any(R.Event.map(C.onDidFocusWindow,()=>"windowFocus"),R.Event.map(C.onDidOpenWindow,()=>"windowOpen")),(a,h)=>a?[...a,h]:[h],1e3)(a=>this.triggerSync(a,!0,!1)))}};w=de([Y(0,D.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncResourceEnablementService),Y(4,p.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,p.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,n.IUserDataSyncMachinesService),Y(10,T.IStorageService),Y(11,p.IUserDataAutoSyncEnablementService)],w),e.UserDataAutoSyncService=w}),define(Z[214],ee([0,1,6,3,2]),function(K,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:p,getActiveWindowId:E}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(P,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>E()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch(w){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(Z[62],ee([0,1,50,6,8,16,18,110,222,223]),function(K,e,R,L,D,T,A,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function w(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function f(o){if(o instanceof n)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new n(t,o)}function d(o,t,r,i,a,h){const c=D.dirname(t),u=D.join(i,c);if(!u.startsWith(i))return Promise.reject(new Error(P.localize(0,null,t)));const g=D.join(i,t);let S;return h.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((m,k)=>{if(!h.isCancellationRequested)try{S=(0,R.createWriteStream)(g,{mode:r}),S.once("close",()=>m()),S.once("error",k),o.once("error",k),o.pipe(S)}catch(O){k(O)}}))}function l(o,t,r,i){let a=(0,L.createCancelablePromise)(()=>Promise.resolve()),h=0;return i.onCancellationRequested(()=>{a.cancel(),o.close()}),new Promise((c,u)=>{const g=new L.Sequencer,S=m=>{m.isCancellationRequested||(h++,o.readEntry())};o.once("error",u),o.once("close",()=>a.then(()=>{i.isCancellationRequested||o.entryCount===h?c():u(new n("Incomplete",new Error(P.localize(1,null,h,o.entryCount))))},u)),o.readEntry(),o.on("entry",m=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(m.fileName)){S(i);return}const k=m.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(k)){const z=D.join(t,k);a=(0,L.createCancelablePromise)(H=>A.Promises.mkdir(z,{recursive:!0}).then(()=>S(H)).then(void 0,u));return}const O=I(o,m),x=w(m);a=(0,L.createCancelablePromise)(z=>g.queue(()=>O.then(H=>d(H,k,x,t,r,z).then(()=>S(z)))).then(null,u))})})}function y(o,t=!1){return new Promise((r,i)=>{(0,p.open)(o,t?{lazyEntries:!0}:void 0,(a,h)=>{a?i(f(a)):r((0,T.assertIsDefined)(h))})})}function I(o,t){return new Promise((r,i)=>{o.openReadStream(t,(a,h)=>{a?i(f(a)):r((0,T.assertIsDefined)(h))})})}function b(o,t){return new Promise((r,i)=>{const a=new E.ZipFile;t.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const h=(0,R.createWriteStream)(o);a.outputStream.pipe(h),a.outputStream.once("error",i),h.once("error",i),h.once("finish",()=>r(o))})}e.zip=b;function C(o,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let h=y(o,!0);return r.overwrite&&(h=h.then(c=>A.Promises.rm(t).then(()=>c))),h.then(c=>l(c,t,{sourcePathRegex:a},i))}e.extract=C;function v(o,t){return y(o).then(r=>new Promise((i,a)=>{r.on("entry",h=>{h.fileName===t&&I(r,h).then(c=>i(c),c=>a(c))}),r.once("close",()=>a(new Error(P.localize(2,null,t))))}))}function s(o,t){return v(o,t).then(r=>new Promise((i,a)=>{const h=[];r.once("error",a),r.on("data",c=>h.push(c)),r.on("end",()=>i(Buffer.concat(h)))}))}e.buffer=s}),define(Z[215],ee([0,1,62,118]),function(K,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(T){return(0,R.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(Z[216],ee([0,1,23,6,11,2,17,8,4,15,58,5,30,18,62,119,12,27,31,141,13,14,28]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",a="extracting",h="deleting",c="renaming";let u=class extends T.Disposable{constructor(S,m,k,O,x){super();this.beforeRemovingExtension=S,this.fileService=m,this.logService=k,this.environmentService=O,this.productService=x,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(S){const m=[];(S===null||S===0)&&m.push(this.scanSystemExtensions().then(null,k=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(k).message,r)))),(S===null||S===1)&&m.push(this.scanUserExtensions(!0).then(null,k=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(k).message,i))));try{const k=await Promise.all(m);return(0,R.flatten)(k)}catch(k){throw this.joinErrors(k)}}async scanUserExtensions(S){this.logService.trace("Started scanning user extensions");let[m,k]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return k=k.filter(O=>!m[new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),S&&(k=(0,C.groupByExtension)(k,x=>x.identifier).map(x=>x.sort((z,H)=>n.rcompare(z.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",k.length),k}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(S,m,k){const O=S.key(),x=P.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),z=P.join(this.extensionsPath,O);try{await d.Promises.rm(z)}catch(V){try{await d.Promises.rm(z)}catch(U){}throw new b.ExtensionManagementError((0,y.localize)(0,null,z,S.id),h)}await this.extractAtLocation(S,m,x,k);let H=await this.scanExtension(w.URI.file(x),1);if(!H)throw new Error((0,y.localize)(1,null,x));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(S,x,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(V){try{await d.Promises.rm(x)}catch(U){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",S.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(V)}. Deleted from extracted location`,x),V}try{H=await this.scanExtension(w.URI.file(z),1)}catch(V){}if(H)return H;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(S,m){return this.setMetadata(S,m),await this.storeMetadata(S,{...m,installedTimestamp:S.installedTimestamp}),S}async storeMetadata(S,m){m.isMachineScoped=m.isMachineScoped||void 0,m.isBuiltin=m.isBuiltin||void 0,m.installedTimestamp=m.installedTimestamp||void 0;const k=P.join(S.location.fsPath,"package.json"),O=await d.Promises.readFile(k,"utf8"),{manifest:x}=await this.parseManifest(O);return x.__metadata=m,await d.Promises.writeFile(k,JSON.stringify(x,null,"	")),S}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...S){const m=S.map(k=>new C.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version));await this.withUninstalledExtensions(k=>{m.forEach(O=>k[O.key()]=!0)})}async setInstalled(S){await this.withUninstalledExtensions(O=>delete O[S.key()]);const k=(await this.scanExtensions(1)).find(O=>new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(S))||null;return k?(await this.storeMetadata(k,{installedTimestamp:Date.now()}),this.scanExtension(k.location,1)):null}async withUninstalledExtensions(S){return this.uninstalledFileLimiter.queue(async()=>{let m;try{m=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let k={};if(m)try{k=JSON.parse(m)}catch(O){}return S&&(S(k),Object.keys(k).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(k)):await d.Promises.rm(this.uninstalledPath)),k})}async removeExtension(S,m){this.logService.trace(`Deleting ${m} extension from disk`,S.identifier.id,S.location.fsPath),await d.Promises.rm(S.location.fsPath),this.logService.info("Deleted from disk",S.identifier.id,S.location.fsPath)}async removeUninstalledExtension(S){await this.removeExtension(S,"uninstalled"),await this.withUninstalledExtensions(m=>delete m[new C.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()])}async extractAtLocation(S,m,k,O){this.logService.trace(`Started extracting the extension from ${m} to ${k}`);try{await d.Promises.rm(k)}catch(x){throw new b.ExtensionManagementError(this.joinErrors(x).message,h)}try{await(0,l.extract)(m,k,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${k}:`,S.id)}catch(x){try{await d.Promises.rm(k)}catch(z){}throw new b.ExtensionManagementError(x.message,x instanceof l.ExtractError&&x.type?x.type:a)}}async rename(S,m,k,O){try{await d.Promises.rename(m,k)}catch(x){if(p.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${m} to ${k} with 'EPERM' error. Trying again...`,S.id),this.rename(S,m,k,O);throw new b.ExtensionManagementError(x.message||(0,y.localize)(3,null,m,k),x.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const S=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return S;const m=this.scanDevSystemExtensions(),[k,O]=await Promise.all([S,m]);return[...k,...O]}async scanExtensionsInDir(S,m){const k=new L.Limiter(10),O=await this.fileService.resolve(w.URI.file(S));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>k.queue(async()=>m===1&&(0,E.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,m))))).filter(z=>z&&z.identifier):[]}async scanExtension(S,m){try{const k=await this.fileService.resolve(S);if(k.children){const{manifest:O,metadata:x}=await this.readManifest(S.fsPath),z=k.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,H=k.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource,V={id:(0,C.getGalleryExtensionId)(O.publisher,O.name)},U={type:m,identifier:V,manifest:O,location:S,readmeUrl:z,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:m===0};return x&&(this.setMetadata(U,x),U.installedTimestamp=x.installedTimestamp),U}}catch(k){m!==0&&this.logService.trace(k)}return null}async scanDefaultSystemExtensions(){const S=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",S.length),S}async scanDevSystemExtensions(){const S=this.getDevSystemExtensionsList();if(S.length){const m=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",m.length),m.filter(k=>S.some(O=>(0,C.areSameExtensions)(k.identifier,{id:O})))}else return[]}setMetadata(S,m){S.publisherDisplayName=m.publisherDisplayName||null,S.publisherId=m.publisherId||null,S.identifier.uuid=m.id,S.isMachineScoped=!!m.isMachineScoped,S.isBuiltin=S.type===0||!!m.isBuiltin}async removeUninstalledExtensions(){const S=await this.getUninstalledExtensions(),m=await this.scanAllUserExtensions(),k=new Set;for(const z of m)S[new C.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||k.add(z.identifier.id.toLowerCase());const O=(0,C.groupByExtension)(m,z=>z.identifier);await L.Promises.settled(O.map(async z=>{const H=z.sort((V,U)=>n.rcompare(V.manifest.version,U.manifest.version))[0];k.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const x=m.filter(z=>S[new C.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await L.Promises.settled(x.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const S=await this.scanAllUserExtensions(),m=[],k=(0,C.groupByExtension)(S,O=>O.identifier);m.push(...(0,R.flatten)(k.map(O=>O.sort((x,z)=>n.rcompare(x.manifest.version,z.manifest.version)).slice(1)))),await L.Promises.settled(m.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(S=>S.name)}joinErrors(S){const m=Array.isArray(S)?S:[S];return m.length===1?m[0]instanceof Error?m[0]:new Error(m[0]):m.reduce((k,O)=>new Error(`${k.message}${k.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(S){const m=[d.Promises.readFile(P.join(S,"package.json"),"utf8").then(z=>this.parseManifest(z)),d.Promises.readFile(P.join(S,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:k,metadata:O},x]=await Promise.all(m);return{manifest:(0,v.localizeManifest)(k,x),metadata:O}}parseManifest(S){return new Promise((m,k)=>{try{const O=JSON.parse(S),x=O.__metadata||null;m({manifest:O,metadata:x})}catch(O){k(new Error((0,y.localize)(4,null)))}})}};u=de([Y(1,s.IFileService),Y(2,o.ILogService),Y(3,I.INativeEnvironmentService),Y(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(Z[217],ee([0,1,37,17,8,4,15,58,5,30,18,62,117,74,12,183,27,31,164,165,215,152,216,166,72,13,7,14,44,21]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s,o,t,r,i,a,h,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const S="unsetUninstalled",m="downloading";let k=class extends y.AbstractExtensionManagementService{constructor(U,$,M,N,q,F,j){super(U,$,M);this.environmentService=N,this.downloadService=q;const _=this._register(F.createInstance(v.ExtensionsLifecycle));this.extensionsScanner=this._register(F.createInstance(t.ExtensionsScanner,B=>_.postUninstall(B))),this.manifestCache=this._register(new o.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(F.createInstance(C.ExtensionsDownloader));const G=this._register(new r.ExtensionsWatcher(this,j,N,M));this._register(G.onDidChangeExtensionsByAnotherSource(({added:B,removed:X})=>{B.length&&this._onDidInstallExtensions.fire(B.map(Q=>({identifier:Q.identifier,operation:0,local:Q}))),X.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const $=await this.collectFiles(U),M=await(0,w.zip)((0,A.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,$);return p.URI.file(M)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const $=await this.downloadVsix(U),M=D.resolve($.fsPath);return(0,s.getManifest)(M)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,$={}){this.logService.trace("ExtensionManagementService#install",U.toString());const M=await this.downloadVsix(U),N=await(0,s.getManifest)(D.resolve(M.fsPath));if(N.engines&&N.engines.vscode&&!(0,i.isEngineValid)(N.engines.vscode,u.default.version,u.default.date))throw new Error(f.localize(0,null,(0,b.getGalleryExtensionId)(N.publisher,N.name),u.default.version));return this.installExtension(N,M,$)}async updateMetadata(U,$){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const $=(0,A.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,$),$}createInstallExtensionTask(U,$,M){return p.URI.isUri($)?new z(U,$,M,this.galleryService,this.extensionsScanner,this.logService):new x($,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,$){return new H(U,$,this.extensionsScanner)}async collectFiles(U){const $=async N=>{let q=await n.Promises.readdir(N);q=q.map(_=>D.join(N,_));const F=await Promise.all(q.map(_=>n.Promises.stat(_)));let j=Promise.resolve([]);return F.forEach((_,G)=>{const B=q[G];_.isFile()&&(j=j.then(X=>[...X,B])),_.isDirectory()&&(j=j.then(X=>$(B).then(Q=>[...X,...Q])))}),j};return(await $(U.location.fsPath)).map(N=>({path:`extension/${D.relative(U.location.fsPath,N)}`,localPath:N}))}};k=de([Y(0,I.IExtensionGalleryService),Y(1,g.ITelemetryService),Y(2,c.ILogService),Y(3,l.INativeEnvironmentService),Y(4,(0,h.optional)(d.IDownloadService)),Y(5,h.IInstantiationService),Y(6,a.IFileService)],k),e.ExtensionManagementService=k;class O extends y.AbstractExtensionTask{constructor(U,$,M,N){super();this.identifier=U,this.source=$,this.extensionsScanner=M,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(U,$){try{const M=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(M)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,U.metadata):M}catch(M){throw T.isMacintosh?new I.ExtensionManagementError(f.localize(1,null),S):new I.ExtensionManagementError(f.localize(2,null),S)}return this.extract(U,$)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const M=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),M}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:$,metadata:M},N){let q=await this.extensionsScanner.extractUserExtension($,U,N);return this.logService.info("Extracting completed.",$.id),M&&(q=await this.extensionsScanner.saveMetadataForLocalExtension(q,M)),q}}class x extends O{constructor(U,$,M,N,q){super(U.identifier,U,N,q);this.gallery=U,this.options=$,this.extensionsDownloader=M}async doRun(U){const M=(await this.extensionsScanner.scanExtensions(null)).find(F=>(0,b.areSameExtensions)(F.identifier,this.gallery.identifier));M&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;const q=await this.installExtension(N,U);M&&P.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M);try{await this.extensionsDownloader.delete(p.URI.file(N.zipPath))}catch(F){}return q}async downloadInstallableExtension(U,$){const M={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",U.identifier.id),N=(await this.extensionsDownloader.downloadExtension(U,$)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,N)}catch(q){throw new I.ExtensionManagementError((0,y.joinErrors)(q).message,m)}try{const q=await(0,s.getManifest)(N);return{zipPath:N,identifierWithVersion:new b.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:M}}catch(q){throw new I.ExtensionManagementError((0,y.joinErrors)(q).message,y.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(U,$,M,N,q,F){super({id:(0,b.getGalleryExtensionId)(U.publisher,U.name)},$,q,F);this.manifest=U,this.location=$,this.options=M,this.galleryService=N}async doRun(U){const $=new b.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(F=>(0,b.areSameExtensions)(this.identifier,F.identifier)),q=await this.getMetadata(this.identifier.id,U);if(N)if(q.isMachineScoped=this.options.isMachineScoped||N.isMachineScoped,q.isBuiltin=this.options.isBuiltin||N.isBuiltin,this._operation=2,$.equals(new b.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(F){throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else P.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const F=await this.unsetUninstalledAndGetLocal($);if(F)try{await this.extensionsScanner.removeExtension(F,"existing")}catch(j){throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:$,metadata:q},U)}async getMetadata(U,$){try{const M=(await this.galleryService.query({names:[U],pageSize:1},$)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class H extends y.AbstractExtensionTask{constructor(U,$,M){super();this.extension=U,this.options=$,this.extensionsScanner=M}async doRun(U){const $=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new b.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...M.filter(q=>N.equals(new b.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else $.push(...M.filter(N=>(0,b.areSameExtensions)(N.identifier,this.extension.identifier)));if(!$.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const N of $)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(q){throw new Error(f.localize(6,null,(0,R.toErrorMessage)(q)))}}}}),define(Z[224],ee([0,1,104,50,225,34,37,11,2,17,15,5,36,103,171,151,172,161,162,163,149,153,24,174,73,182,74,176,12,138,178,184,27,140,185,217,75,142,13,168,170,52,7,158,78,159,160,57,167,14,79,59,44,28,175,42,20,180,181,21,82,84,83,53,186,187,85,189,195,87,88,89,22,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,R,L,D,T,A,P,p,E,n,w,f,d,l,y,I,b,C,v,s,o,t,r,i,a,h,c,u,g,S,m,k,O,x,z,H,V,U,$,M,N,q,F,j,_,G,B,X,Q,ie,ne,le,fe,ye,Se,Pe,Te,Ne,Oe,Ae,_e,Ie,ke,Ye,Je,ze,$e,J,re,se,pe,me,De,we,Re,be,Le,Ue,W,te,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class he extends p.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new d.Server),(0,D.gracefulify)(L),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,me.registerConfiguration)(),ue.invokeFunction(Ee=>{const Ce=Ee.get(Q.ILogService);Ce.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ce)}),this._register((0,p.combinedDisposable)(ue.createInstance(l.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(I.LanguagePackCachedDataCleaner),ue.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(C.LogsDataCleaner),ue.createInstance(b.LocalizationsUpdater),ue.createInstance(y.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new j.ServiceCollection,Ee={_serviceBrand:void 0,...le.default};ue.set(fe.IProductService,Ee);const Ce=new f.StaticRouter(We=>We==="main"),Fe=new _.MessagePortMainProcessService(this.server,Ce);ue.set(G.IMainProcessService,Fe);const Me=new g.NativeEnvironmentService(this.configuration.args,Ee);ue.set(u.INativeEnvironmentService,Me);const et=new ie.LogLevelChannelClient(this.server.getChannel("logLevel",Ce)),Be=new ie.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));ue.set(Q.ILoggerService,Be);const nt=this._register(new Q.MultiplexLogService([this._register(new Q.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,n.joinPath)(w.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new ie.FollowerLogService(et,nt));ue.set(Q.ILogService,Ve);const He=this._register(new $.FileService(Ve));ue.set(U.IFileService,He);const it=this._register(new M.DiskFileSystemProvider(Ve));He.registerProvider(E.Schemas.file,it);const je=this._register(new r.ConfigurationService(Me.settingsResource,He));ue.set(t.IConfigurationService,je),await je.initialize();const Xe=new Te.NativeStorageService(void 0,Fe,Me);ue.set(Pe.IStorageService,Xe),await Xe.initialize(),this._register((0,p.toDisposable)(()=>Xe.flush())),ue.set(Se.IRequestService,new N.SyncDescriptor(ye.RequestService)),ue.set(s.IChecksumService,new N.SyncDescriptor(o.ChecksumService));const tt=f.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(ne.INativeHostService,tt),ue.set(h.IDownloadService,new N.SyncDescriptor(c.DownloadService));const rt=this._register(new oe.ActiveWindowManager(tt)),ht=new f.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));ue.set(H.IExtensionRecommendationNotificationService,new V.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Ee.enableTelemetry){Ge=new _e.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new Ye.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,p.toDisposable)(()=>ct.flush())),Ge=(0,ke.combinedAppender)(ct,Ge)}Qe=new Ie.TelemetryService({appender:Ge,commonProperties:(0,Ne.resolveCommonProperties)(He,(0,T.release)(),(0,T.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},je)}else Qe=ke.NullTelemetryService,Ge=ke.NullAppender;this.server.registerChannel("telemetryAppender",new Ae.TelemetryAppenderChannel(Ge)),ue.set(Oe.ITelemetryService,Qe);const ft=new Je.CustomEndpointTelemetryService(je,Qe,Be,Me);return ue.set(Oe.ICustomEndpointTelemetryService,ft),ue.set(k.IExtensionManagementService,new N.SyncDescriptor(z.ExtensionManagementService)),ue.set(k.IExtensionGalleryService,new N.SyncDescriptor(m.ExtensionGalleryService)),ue.set(k.IExtensionTipsService,new N.SyncDescriptor(x.ExtensionTipsService)),ue.set(B.ILocalizationsService,new N.SyncDescriptor(X.LocalizationsService)),ue.set(i.IDiagnosticsService,new N.SyncDescriptor(a.DiagnosticsService)),ue.set(De.IUserDataSyncAccountService,new N.SyncDescriptor(De.UserDataSyncAccountService)),ue.set(me.IUserDataSyncLogService,new N.SyncDescriptor(be.UserDataSyncLogService)),ue.set(me.IUserDataSyncUtilService,new Re.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ue.set(k.IGlobalExtensionEnablementService,new N.SyncDescriptor(S.GlobalExtensionEnablementService)),ue.set(se.IIgnoredExtensionsManagementService,new N.SyncDescriptor(se.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new N.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(me.IUserDataSyncStoreManagementService,new N.SyncDescriptor(ae.UserDataSyncStoreManagementService)),ue.set(me.IUserDataSyncStoreService,new N.SyncDescriptor(ae.UserDataSyncStoreService)),ue.set(Le.IUserDataSyncMachinesService,new N.SyncDescriptor(Le.UserDataSyncMachinesService)),ue.set(me.IUserDataSyncBackupStoreService,new N.SyncDescriptor(we.UserDataSyncBackupStoreService)),ue.set(me.IUserDataAutoSyncEnablementService,new N.SyncDescriptor(pe.UserDataAutoSyncEnablementService)),ue.set(me.IUserDataSyncResourceEnablementService,new N.SyncDescriptor(Ue.UserDataSyncResourceEnablementService)),ue.set(me.IUserDataSyncService,new N.SyncDescriptor(W.UserDataSyncService)),ue.set($e.ILocalPtyService,this._register(new J.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},je,Ve,Qe))),new F.InstantiationService(ue)}initChannels(ue){const Ee=new O.ExtensionManagementChannel(ue.get(k.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ce=f.ProxyChannel.fromService(ue.get(B.ILocalizationsService));this.server.registerChannel("localizations",Ce);const Fe=f.ProxyChannel.fromService(ue.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new O.ExtensionTipsChannel(ue.get(k.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=f.ProxyChannel.fromService(ue.get(s.IChecksumService));this.server.registerChannel("checksum",et);const Be=new Re.UserDataSyncMachinesServiceChannel(ue.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=f.ProxyChannel.fromService(ue.get(Oe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new Re.UserDataSyncAccountServiceChannel(ue.get(De.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new Re.UserDataSyncStoreManagementServiceChannel(ue.get(me.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new te.UserDataSyncChannel(ue.get(me.IUserDataSyncService),ue.get(Q.ILogService));this.server.registerChannel("userDataSync",it);const je=this._register(ue.get(q.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),Xe=new Re.UserDataAutoSyncChannel(je);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get($e.ILocalPtyService),rt=f.ProxyChannel.fromService(tt);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ee=>{(0,P.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ee=>{const Ce=(0,A.toErrorMessage)(Ee,!0);!Ce||ue.error(`[uncaught exception in sharedProcess]: ${Ce}`)})}}async function ge(ve){const ue=new he(ve);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/49af1cbe00271ac2ea36cfc5f7352fe31a7b0094/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
