/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/extpath","fs","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(V){for(var e=[],v=0,L=V.length;v<L;v++)e[v]=J[V[v]];return e};define(J[102],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(J[46],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(I){return(n,f,m)=>{let t=null,b=null;if(typeof m.value=="function"?(t="value",b=m.value):typeof m.get=="function"&&(t="get",b=m.get),!b)throw new Error("not supported");m[t]=I(b,f)}}e.createDecorator=v;function L(I,n,f){let m=null,t=null;if(typeof f.value=="function"?(m="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(m="get",t=f.get),!t)throw new Error("not supported");const b=`$memoize$${n}`;f[m]=function(...E){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,E)}),this[b]}}e.memoize=L;function k(I,n,f){return v((m,t)=>{const b=`$debounce$${t}`,E=`$debounce$result$${t}`;return function(...y){this[E]||(this[E]=f?f():void 0),clearTimeout(this[b]),n&&(this[E]=n(this[E],...y),y=[this[E]]),this[b]=setTimeout(()=>{m.apply(this,y),this[E]=f?f():void 0},I)}})}e.debounce=k;function M(I,n,f){return v((m,t)=>{const b=`$throttle$timer$${t}`,E=`$throttle$result$${t}`,y=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...g){if(this[E]||(this[E]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[E]=n(this[E],...g)),this[d])return;const P=this[y]+I;P<=Date.now()?(this[y]=Date.now(),m.apply(this,[this[E]]),this[E]=f?f():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),m.apply(this,[this[E]]),this[E]=f?f():void 0},P-Date.now()))}})}e.throttle=M}),define(J[16],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function L(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=L;function k(l){f(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function M(l){f(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=M;function I(l){if(l instanceof Error){let{name:i,message:s}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:r}}return l}e.transformErrorForSerialization=I;const n="Canceled";function f(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=f;class m extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=m;function t(){const l=new Error(n);return l.name=l.message,l}e.canceled=t;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=E;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class P extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=P;class S extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=S;class h extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=h;function u(l){const i=l;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=u;function o(l,i=Object.create(null)){const s=new Error(l);return i.actions&&(s.actions=i.actions),s}e.createErrorWithActions=o}),define(J[36],Z([0,1,16]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(T,A=0){return T[T.length-(1+A)]}e.tail=L;function k(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=k;function M(T,A,O=(j,Y)=>j===Y){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let j=0,Y=T.length;j<Y;j++)if(!O(T[j],A[j]))return!1;return!0}e.equals=M;function I(T,A,O){let j=0,Y=T.length-1;for(;j<=Y;){const q=(j+Y)/2|0,X=O(T[q],A);if(X<0)j=q+1;else if(X>0)Y=q-1;else return q}return-(j+1)}e.binarySearch=I;function n(T,A){let O=0,j=T.length;if(j===0)return 0;for(;O<j;){const Y=Math.floor((O+j)/2);A(T[Y])?j=Y:O=Y+1}return O}e.findFirstInSorted=n;function f(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let j=A[Math.floor(A.length*Math.random())],Y=[],q=[],X=[];for(let ie of A){const se=O(ie,j);se<0?Y.push(ie):se>0?q.push(ie):X.push(ie)}return T<Y.length?f(T,Y,O):T<Y.length+X.length?X[0]:f(T-(Y.length+X.length),q,O)}e.quickSelect=f;function m(T,A){const O=[];let j;for(const Y of T.slice(0).sort(A))!j||A(j[0],Y)!==0?(j=[Y],O.push(j)):j.push(Y);return O}e.groupBy=m;function t(T,A,O){const j=[];function Y(ie,se,ae){if(se===0&&ae.length===0)return;const de=j[j.length-1];de&&de.start+de.deleteCount===ie?(de.deleteCount+=se,de.toInsert.push(...ae)):j.push({start:ie,deleteCount:se,toInsert:ae})}let q=0,X=0;for(;;){if(q===T.length){Y(q,0,A.slice(X));break}if(X===A.length){Y(q,T.length-q,[]);break}const ie=T[q],se=A[X],ae=O(ie,se);ae===0?(q+=1,X+=1):ae<0?(Y(q,1,[]),q+=1):ae>0&&(Y(q,0,[se]),X+=1)}return j}e.sortedDiff=t;function b(T,A,O){const j=t(T,A,O),Y=[],q=[];for(const X of j)Y.push(...T.slice(X.start,X.start+X.deleteCount)),q.push(...X.toInsert);return{removed:Y,added:q}}e.delta=b;function E(T,A,O){if(O===0)return[];const j=T.slice(0,O).sort(A);return d(T,A,j,O,T.length),j}e.top=E;function y(T,A,O,j,Y){return O===0?Promise.resolve([]):new Promise((q,X)=>{(async()=>{const ie=T.length,se=T.slice(0,O).sort(A);for(let ae=O,de=Math.min(O+j,ie);ae<ie;ae=de,de=Math.min(de+j,ie)){if(ae>O&&await new Promise(re=>setTimeout(re)),Y&&Y.isCancellationRequested)throw(0,v.canceled)();d(T,A,se,ae,de)}return se})().then(q,X)})}e.topAsync=y;function d(T,A,O,j,Y){for(const q=O.length;j<Y;j++){const X=T[j];if(A(X,O[q-1])<0){O.pop();const ie=n(O,se=>A(X,se)<0);O.splice(ie,0,X)}}}function g(T){return T.filter(A=>!!A)}e.coalesce=g;function P(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=P;function S(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=S;function h(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=h;function u(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=u;function o(T,A){if(!A)return T.filter((j,Y)=>T.indexOf(j)===Y);const O=Object.create(null);return T.filter(j=>{const Y=A(j);return O[Y]?!1:(O[Y]=!0,!0)})}e.distinct=o;function l(T){const A=new Set;return T.filter(O=>A.has(O)?!1:(A.add(O),!0))}e.distinctES6=l;function i(T){const A=Object.create(null);return O=>{const j=T(O);return A[j]?!1:(A[j]=!0,!0)}}e.uniqueFilter=i;function s(T,A){for(let O=T.length-1;O>=0;O--){const j=T[O];if(A(j))return O}return-1}e.lastIndex=s;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function a(T,A,O=(j,Y)=>j===Y){let j=0;for(let Y=0,q=Math.min(T.length,A.length);Y<q&&O(T[Y],A[Y]);Y++)j++;return j}e.commonPrefixLength=a;function c(T){return[].concat(...T)}e.flatten=c;function p(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const j=[];if(O<=A)for(let Y=O;Y<A;Y++)j.push(Y);else for(let Y=O;Y>A;Y--)j.push(Y);return j}e.range=p;function w(T,A,O){return T.reduce((j,Y)=>(j[A(Y)]=O?O(Y):Y,j),Object.create(null))}e.index=w;function D(T,A){return T.push(A),()=>R(T,A)}e.insert=D;function R(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=R;function _(T,A,O){const j=T.slice(0,A),Y=T.slice(A);return j.concat(O,Y)}e.arrayInsert=_;function C(T,A){let O;if(typeof A=="number"){let j=A;O=()=>{const Y=Math.sin(j++)*179426549;return Y-Math.floor(Y)}}else O=Math.random;for(let j=T.length-1;j>0;j-=1){const Y=Math.floor(O()*(j+1)),q=T[j];T[j]=T[Y],T[Y]=q}}e.shuffle=C;function G(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=G;function x(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=x;function ne(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ne;function K(T){return Array.isArray(T)?T:[T]}e.asArray=K;function Q(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=Q;function U(T,A){for(const O of T){const j=A(O);if(j!==void 0)return j}}e.mapFind=U;function $(T,A,O){const j=N(T,A),Y=T.length,q=O.length;T.length=Y+q;for(let X=Y-1;X>=j;X--)T[X+q]=T[X];for(let X=0;X<q;X++)T[X+j]=O[X]}e.insertInto=$;function W(T,A,O,j){const Y=N(T,A),q=T.splice(Y,O);return $(T,Y,j),q}e.splice=W;function N(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function B(T,A){let O=Number.MAX_SAFE_INTEGER,j=0;return T.forEach((Y,q)=>{const X=A(Y);X<O&&(O=X,j=q)}),j}e.minIndex=B;function F(T,A){let O=Number.MIN_SAFE_INTEGER,j=0;return T.forEach((Y,q)=>{const X=A(Y);X>O&&(O=X,j=q)}),j}e.maxIndex=F;class z{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const j=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,j}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const j=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,j}}e.ArrayQueue=z}),define(J[43],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const k=this;let M=!1,I;return function(){return M||(M=!0,I=L.apply(k,arguments)),I}}e.once=v}),define(J[63],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function k(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function I(){return M}L.empty=I;function*n(l){yield l}L.single=n;function f(l){return l||M}L.from=f;function m(l){return!l||l[Symbol.iterator]().next().done===!0}L.isEmpty=m;function t(l){return l[Symbol.iterator]().next().value}L.first=t;function b(l,i){for(const s of l)if(i(s))return!0;return!1}L.some=b;function E(l,i){for(const s of l)if(i(s))return s}L.find=E;function*y(l,i){for(const s of l)i(s)&&(yield s)}L.filter=y;function*d(l,i){let s=0;for(const r of l)yield i(r,s++)}L.map=d;function*g(...l){for(const i of l)for(const s of i)yield s}L.concat=g;function*P(l){for(const i of l)for(const s of i)yield s}L.concatNested=P;function S(l,i,s){let r=s;for(const a of l)r=i(r,a);return r}L.reduce=S;function*h(l,i,s=l.length){for(i<0&&(i+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);i<s;i++)yield l[i]}L.slice=h;function u(l,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,l];const r=l[Symbol.iterator]();for(let a=0;a<i;a++){const c=r.next();if(c.done)return[s,L.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=u;function o(l,i,s=(r,a)=>r===a){const r=l[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const c=r.next(),p=a.next();if(c.done!==p.done)return!1;if(c.done)return!0;if(!s(c.value,p.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function I(i,s=!1){let r=0,a=i.length,c="",p=0,w=16,D=0;function R(Q){let U=0,$=0;for(;U<Q;){const W=i.charCodeAt(r);if(W>=48&&W<=57)$=$*16+W-48;else if(W>=65&&W<=70)$=$*16+W-65+10;else if(W>=97&&W<=102)$=$*16+W-97+10;else break;r++,U++}return U<Q&&($=-1),$}function _(Q){r=Q,c="",p=0,w=16,D=0}function C(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&m(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&m(i.charCodeAt(r)))for(r++;r<i.length&&m(i.charCodeAt(r));)r++;else return D=3,i.substring(Q,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&m(i.charCodeAt(r))){for(r++;r<i.length&&m(i.charCodeAt(r));)r++;U=r}else D=3;return i.substring(Q,U)}function G(){let Q="",U=r;for(;;){if(r>=a){Q+=i.substring(U,r),D=2;break}const $=i.charCodeAt(r);if($===34){Q+=i.substring(U,r),r++;break}if($===92){if(Q+=i.substring(U,r),r++,r>=a){D=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const N=R(4);N>=0?Q+=String.fromCharCode(N):D=4;break;default:D=5}U=r;continue}if($>=0&&$<=31)if(f($)){Q+=i.substring(U,r),D=2;break}else D=6;r++}return Q}function x(){if(c="",D=0,p=r,r>=a)return p=a,w=17;let Q=i.charCodeAt(r);if(n(Q)){do r++,c+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(n(Q));return w=15}if(f(Q))return r++,c+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,c+=`
`),w=14;switch(Q){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,c=G(),w=10;case 47:const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<a&&!f(i.charCodeAt(r));)r++;return c=i.substring(U,r),w=12}if(i.charCodeAt(r+1)===42){r+=2;const $=a-1;let W=!1;for(;r<$;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,D=1),c=i.substring(U,r),w=13}return c+=String.fromCharCode(Q),r++,w=16;case 45:if(c+=String.fromCharCode(Q),r++,r===a||!m(i.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=C(),w=11;default:for(;r<a&&ne(Q);)r++,Q=i.charCodeAt(r);if(p!==r){switch(c=i.substring(p,r),c){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return c+=String.fromCharCode(Q),r++,w=16}}function ne(Q){if(n(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let Q;do Q=x();while(Q>=12&&Q<=15);return Q}return{setPosition:_,getPosition:()=>r,scan:s?K:x,getToken:()=>w,getTokenValue:()=>c,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>D}}e.createScanner=I;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function b(i,s){const r=[],a=new Object;let c;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function D(R,_,C,G){p.value=R,p.offset=_,p.length=C,p.type=G,p.colonOffset=void 0,c=p}try{u(i,{onObjectBegin:(R,_)=>{if(s<=R)throw a;c=void 0,w=s>R,r.push("")},onObjectProperty:(R,_,C)=>{if(s<_||(D(R,_,C,"property"),r[r.length-1]=R,s<=_+C))throw a},onObjectEnd:(R,_)=>{if(s<=R)throw a;c=void 0,r.pop()},onArrayBegin:(R,_)=>{if(s<=R)throw a;c=void 0,r.push(0)},onArrayEnd:(R,_)=>{if(s<=R)throw a;c=void 0,r.pop()},onLiteralValue:(R,_,C)=>{if(s<_||(D(R,_,C,l(R)),s<=_+C))throw a},onSeparator:(R,_,C)=>{if(s<=_)throw a;if(R===":"&&c&&c.type==="property")c.colonOffset=_,w=!1,c=void 0;else if(R===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(w=!0,r[r.length-1]=""),c=void 0}}})}catch(R){if(R!==a)throw R}return{path:r,previousNode:c,isAtPropertyKey:w,matches:R=>{let _=0;for(let C=0;_<R.length&&C<r.length;C++)if(R[_]===r[C]||R[_]==="*")_++;else if(R[_]!=="**")return!1;return _===R.length}}}e.getLocation=b;function E(i,s=[],r=M.DEFAULT){let a=null,c=[];const p=[];function w(R){Array.isArray(c)?c.push(R):a!==null&&(c[a]=R)}return u(i,{onObjectBegin:()=>{const R={};w(R),p.push(c),c=R,a=null},onObjectProperty:R=>{a=R},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const R=[];w(R),p.push(c),c=R,a=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:w,onError:(R,_,C)=>{s.push({error:R,offset:_,length:C})}},r),c[0]}e.parse=E;function y(i,s=[],r=M.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(R){a.type==="property"&&(a.length=R-a.offset,a=a.parent)}function p(R){return a.children.push(R),R}u(i,{onObjectBegin:R=>{a=p({type:"object",offset:R,length:-1,parent:a,children:[]})},onObjectProperty:(R,_,C)=>{a=p({type:"property",offset:_,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:R,offset:_,length:C,parent:a})},onObjectEnd:(R,_)=>{a.length=R+_-a.offset,a=a.parent,c(R+_)},onArrayBegin:(R,_)=>{a=p({type:"array",offset:R,length:-1,parent:a,children:[]})},onArrayEnd:(R,_)=>{a.length=R+_-a.offset,a=a.parent,c(R+_)},onLiteralValue:(R,_,C)=>{p({type:l(R),offset:_,length:C,parent:a,value:R}),c(_+C)},onSeparator:(R,_,C)=>{a.type==="property"&&(R===":"?a.colonOffset=_:R===","&&c(_))},onError:(R,_,C)=>{s.push({error:R,offset:_,length:C})}},r);const D=a.children[0];return D&&delete D.parent,D}e.parseTree=y;function d(i,s){if(!i)return;let r=i;for(let a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===a){r=p.children[1],c=!0;break}if(!c)return}else{const c=a;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const s=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}e.getNodePath=g;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":const s=Object.create(null);for(let r of i.children){const a=r.children[1];a&&(s[r.children[0].value]=P(a))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function S(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}e.contains=S;function h(i,s,r=!1){if(S(i,s,r)){const a=i.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=s;c++){const p=h(a[c],s,r);if(p)return p}return i}}e.findNodeAtOffset=h;function u(i,s,r=M.DEFAULT){const a=I(i,!1);function c(O){return O?()=>O(a.getTokenOffset(),a.getTokenLength()):()=>!0}function p(O){return O?j=>O(j,a.getTokenOffset(),a.getTokenLength()):()=>!0}const w=c(s.onObjectBegin),D=p(s.onObjectProperty),R=c(s.onObjectEnd),_=c(s.onArrayBegin),C=c(s.onArrayEnd),G=p(s.onLiteralValue),x=p(s.onSeparator),ne=c(s.onComment),K=p(s.onError),Q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function $(){for(;;){const O=a.scan();switch(a.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:Q||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(O){case 12:case 13:Q?W(10):ne();break;case 16:W(1);break;case 15:case 14:break;default:return O}}}function W(O,j=[],Y=[]){if(K(O),j.length+Y.length>0){let q=a.getToken();for(;q!==17;){if(j.indexOf(q)!==-1){$();break}else if(Y.indexOf(q)!==-1)break;q=$()}}}function N(O){const j=a.getTokenValue();return O?G(j):D(j),$(),!0}function B(){switch(a.getToken()){case 11:let O=0;try{O=JSON.parse(a.getTokenValue()),typeof O!="number"&&(W(2),O=0)}catch(j){W(2)}G(O);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return $(),!0}function F(){return a.getToken()!==10?(W(3,[],[2,5]),!1):(N(!1),a.getToken()===6?(x(":"),$(),A()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function z(){w(),$();let O=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(O||W(4,[],[]),x(","),$(),a.getToken()===2&&U)break}else O&&W(6,[],[]);F()||W(4,[],[2,5]),O=!0}return R(),a.getToken()!==2?W(7,[2],[]):$(),!0}function T(){_(),$();let O=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(O||W(4,[],[]),x(","),$(),a.getToken()===4&&U)break}else O&&W(6,[],[]);A()||W(4,[],[4,5]),O=!0}return C(),a.getToken()!==4?W(8,[4],[]):$(),!0}function A(){switch(a.getToken()){case 3:return T();case 1:return z();case 10:return N(!0);default:return B()}}return $(),a.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):A()?(a.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=u;function o(i,s){let r=I(i),a=[],c,p=0,w;do switch(w=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:p!==w&&a.push(i.substring(p,w)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),p=r.getPosition();break}while(c!==17);return a.join("")}e.stripComments=o;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(J[103],Z([0,1,40]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,m,t){let b,E,y,d,g;if(m){for(d=m.offset,g=d+m.length,y=d;y>0&&!n(f,y-1);)y--;let p=g;for(;p<f.length&&!n(f,p);)p++;E=f.substring(y,p),b=M(E,t)}else E=f,b=0,y=0,d=0,g=f.length;const P=I(t,f);let S=!1,h=0,u;t.insertSpaces?u=k(" ",t.tabSize||4):u="	";const o=(0,v.createScanner)(E,!1);let l=!1;function i(){return P+k(u,b+h)}function s(){let p=o.scan();for(S=!1;p===15||p===14;)S=S||p===14,p=o.scan();return l=p===16||o.getTokenError()!==0,p}const r=[];function a(p,w,D){!l&&w<g&&D>d&&f.substring(w,D)!==p&&r.push({offset:w,length:D-w,content:p})}let c=s();if(c!==17){const p=o.getTokenOffset()+y,w=k(u,b);a(w,y,p)}for(;c!==17;){let p=o.getTokenOffset()+o.getTokenLength()+y,w=s(),D="";for(;!S&&(w===12||w===13);){const _=o.getTokenOffset()+y;a(" ",p,_),p=o.getTokenOffset()+o.getTokenLength()+y,D=w===12?i():"",w=s()}if(w===2)c!==1&&(h--,D=i());else if(w===4)c!==3&&(h--,D=i());else{switch(c){case 3:case 1:h++,D=i();break;case 5:case 12:D=i();break;case 13:S?D=i():D=" ";break;case 6:D=" ";break;case 10:if(w===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?D=" ":w!==5&&w!==17&&(l=!0);break;case 16:l=!0;break}S&&(w===12||w===13)&&(D=i())}const R=o.getTokenOffset()+y;a(D,p,R),c=w}return r}e.format=L;function k(f,m){let t="";for(let b=0;b<m;b++)t+=f;return t}function M(f,m){let t=0,b=0;const E=m.tabSize||4;for(;t<f.length;){const y=f.charAt(t);if(y===" ")b++;else if(y==="	")b+=E;else break;t++}return Math.floor(b/E)}function I(f,m){for(let t=0;t<m.length;t++){const b=m.charAt(t);if(b==="\r")return t+1<m.length&&m.charAt(t+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=I;function n(f,m){return`\r
`.indexOf(f.charAt(m))!==-1}e.isEOL=n}),define(J[76],Z([0,1,40,103]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,t,b){return M(m,t,void 0,b)}e.removeProperty=k;function M(m,t,b,E,y){const d=t.slice(),g=[],P=(0,v.parseTree)(m,g);let S,h;for(;d.length>0&&(h=d.pop(),S=(0,v.findNodeAtLocation)(P,d),S===void 0&&b!==void 0);)typeof h=="string"?b={[h]:b}:b=[b];if(S)if(S.type==="object"&&typeof h=="string"&&Array.isArray(S.children)){const u=(0,v.findNodeAtLocation)(S,[h]);if(u!==void 0)if(b===void 0){if(!u.parent)throw new Error("Malformed AST");const o=S.children.indexOf(u.parent);let l,i=u.parent.offset+u.parent.length;if(o>0){const s=S.children[o-1];l=s.offset+s.length}else l=S.offset+1,S.children.length>1&&(i=S.children[1].offset);return I(m,{offset:l,length:i-l,content:""},E)}else return I(m,{offset:u.offset,length:u.length,content:JSON.stringify(b)},E);else{if(b===void 0)return[];const o=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,l=y?y(S.children.map(s=>s.children[0].value)):S.children.length;let i;if(l>0){const s=S.children[l-1];i={offset:s.offset+s.length,length:0,content:","+o}}else S.children.length===0?i={offset:S.offset+1,length:0,content:o}:i={offset:S.offset+1,length:0,content:o+","};return I(m,i,E)}}else if(S.type==="array"&&typeof h=="number"&&Array.isArray(S.children))if(b!==void 0){const u=`${JSON.stringify(b)}`;let o;if(S.children.length===0||h===0)o={offset:S.offset+1,length:0,content:S.children.length===0?u:u+","};else{const l=h===-1||h>S.children.length?S.children.length:h,i=S.children[l-1];o={offset:i.offset+i.length,length:0,content:","+u}}return I(m,o,E)}else{const u=h,o=S.children[u];let l;if(S.children.length===1)l={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===u){const i=S.children[u-1],s=i.offset+i.length,r=S.offset+S.length;l={offset:s,length:r-2-s,content:""}}else l={offset:o.offset,length:S.children[u+1].offset-o.offset,content:""};return I(m,l,E)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${S.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return I(m,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(b)},E)}}e.setProperty=M;function I(m,t,b){let E=n(m,t),y=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;y>0&&!(0,L.isEOL)(E,y-1);)y--;for(;d<E.length&&!(0,L.isEOL)(E,d);)d++}const g=(0,L.format)(E,{offset:y,length:d-y},b);for(let S=g.length-1;S>=0;S--){const h=g[S];E=n(E,h),y=Math.min(y,h.offset),d=Math.max(d,h.offset+h.length),d+=h.content.length-h.length}const P=m.length-(E.length-d)-y;return[{offset:y,length:P,content:E.substring(y,d)}]}e.withFormatting=I;function n(m,t){return m.substring(0,t.offset)+t.content+m.substring(t.offset+t.length)}e.applyEdit=n;function f(m,t){let b=t.slice(0).sort((y,d)=>{const g=y.offset-d.offset;return g===0?y.length-d.length:g}),E=m.length;for(let y=b.length-1;y>=0;y--){let d=b[y];if(d.offset+d.length<=E)m=n(m,d);else throw new Error("Overlapping edit");E=d.offset}return m}e.applyEdits=f}),define(J[57],Z([0,1,16]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(h){h[h.DependsOnKbLayout=-1]="DependsOnKbLayout",h[h.Unknown=0]="Unknown",h[h.Backspace=1]="Backspace",h[h.Tab=2]="Tab",h[h.Enter=3]="Enter",h[h.Shift=4]="Shift",h[h.Ctrl=5]="Ctrl",h[h.Alt=6]="Alt",h[h.PauseBreak=7]="PauseBreak",h[h.CapsLock=8]="CapsLock",h[h.Escape=9]="Escape",h[h.Space=10]="Space",h[h.PageUp=11]="PageUp",h[h.PageDown=12]="PageDown",h[h.End=13]="End",h[h.Home=14]="Home",h[h.LeftArrow=15]="LeftArrow",h[h.UpArrow=16]="UpArrow",h[h.RightArrow=17]="RightArrow",h[h.DownArrow=18]="DownArrow",h[h.Insert=19]="Insert",h[h.Delete=20]="Delete",h[h.KEY_0=21]="KEY_0",h[h.KEY_1=22]="KEY_1",h[h.KEY_2=23]="KEY_2",h[h.KEY_3=24]="KEY_3",h[h.KEY_4=25]="KEY_4",h[h.KEY_5=26]="KEY_5",h[h.KEY_6=27]="KEY_6",h[h.KEY_7=28]="KEY_7",h[h.KEY_8=29]="KEY_8",h[h.KEY_9=30]="KEY_9",h[h.KEY_A=31]="KEY_A",h[h.KEY_B=32]="KEY_B",h[h.KEY_C=33]="KEY_C",h[h.KEY_D=34]="KEY_D",h[h.KEY_E=35]="KEY_E",h[h.KEY_F=36]="KEY_F",h[h.KEY_G=37]="KEY_G",h[h.KEY_H=38]="KEY_H",h[h.KEY_I=39]="KEY_I",h[h.KEY_J=40]="KEY_J",h[h.KEY_K=41]="KEY_K",h[h.KEY_L=42]="KEY_L",h[h.KEY_M=43]="KEY_M",h[h.KEY_N=44]="KEY_N",h[h.KEY_O=45]="KEY_O",h[h.KEY_P=46]="KEY_P",h[h.KEY_Q=47]="KEY_Q",h[h.KEY_R=48]="KEY_R",h[h.KEY_S=49]="KEY_S",h[h.KEY_T=50]="KEY_T",h[h.KEY_U=51]="KEY_U",h[h.KEY_V=52]="KEY_V",h[h.KEY_W=53]="KEY_W",h[h.KEY_X=54]="KEY_X",h[h.KEY_Y=55]="KEY_Y",h[h.KEY_Z=56]="KEY_Z",h[h.Meta=57]="Meta",h[h.ContextMenu=58]="ContextMenu",h[h.F1=59]="F1",h[h.F2=60]="F2",h[h.F3=61]="F3",h[h.F4=62]="F4",h[h.F5=63]="F5",h[h.F6=64]="F6",h[h.F7=65]="F7",h[h.F8=66]="F8",h[h.F9=67]="F9",h[h.F10=68]="F10",h[h.F11=69]="F11",h[h.F12=70]="F12",h[h.F13=71]="F13",h[h.F14=72]="F14",h[h.F15=73]="F15",h[h.F16=74]="F16",h[h.F17=75]="F17",h[h.F18=76]="F18",h[h.F19=77]="F19",h[h.NumLock=78]="NumLock",h[h.ScrollLock=79]="ScrollLock",h[h.US_SEMICOLON=80]="US_SEMICOLON",h[h.US_EQUAL=81]="US_EQUAL",h[h.US_COMMA=82]="US_COMMA",h[h.US_MINUS=83]="US_MINUS",h[h.US_DOT=84]="US_DOT",h[h.US_SLASH=85]="US_SLASH",h[h.US_BACKTICK=86]="US_BACKTICK",h[h.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",h[h.US_BACKSLASH=88]="US_BACKSLASH",h[h.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",h[h.US_QUOTE=90]="US_QUOTE",h[h.OEM_8=91]="OEM_8",h[h.OEM_102=92]="OEM_102",h[h.NUMPAD_0=93]="NUMPAD_0",h[h.NUMPAD_1=94]="NUMPAD_1",h[h.NUMPAD_2=95]="NUMPAD_2",h[h.NUMPAD_3=96]="NUMPAD_3",h[h.NUMPAD_4=97]="NUMPAD_4",h[h.NUMPAD_5=98]="NUMPAD_5",h[h.NUMPAD_6=99]="NUMPAD_6",h[h.NUMPAD_7=100]="NUMPAD_7",h[h.NUMPAD_8=101]="NUMPAD_8",h[h.NUMPAD_9=102]="NUMPAD_9",h[h.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",h[h.NUMPAD_ADD=104]="NUMPAD_ADD",h[h.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",h[h.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",h[h.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",h[h.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",h[h.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",h[h.ABNT_C1=110]="ABNT_C1",h[h.ABNT_C2=111]="ABNT_C2",h[h.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,o){this._keyCodeToStr[u]=o,this._strToKeyCode[o.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const M=new k,I=new k,n=new k;(function(){function h(u,o,l=o,i=l){M.define(u,o),I.define(u,l),n.define(u,i)}h(0,"unknown"),h(1,"Backspace"),h(2,"Tab"),h(3,"Enter"),h(4,"Shift"),h(5,"Ctrl"),h(6,"Alt"),h(7,"PauseBreak"),h(8,"CapsLock"),h(9,"Escape"),h(10,"Space"),h(11,"PageUp"),h(12,"PageDown"),h(13,"End"),h(14,"Home"),h(15,"LeftArrow","Left"),h(16,"UpArrow","Up"),h(17,"RightArrow","Right"),h(18,"DownArrow","Down"),h(19,"Insert"),h(20,"Delete"),h(21,"0"),h(22,"1"),h(23,"2"),h(24,"3"),h(25,"4"),h(26,"5"),h(27,"6"),h(28,"7"),h(29,"8"),h(30,"9"),h(31,"A"),h(32,"B"),h(33,"C"),h(34,"D"),h(35,"E"),h(36,"F"),h(37,"G"),h(38,"H"),h(39,"I"),h(40,"J"),h(41,"K"),h(42,"L"),h(43,"M"),h(44,"N"),h(45,"O"),h(46,"P"),h(47,"Q"),h(48,"R"),h(49,"S"),h(50,"T"),h(51,"U"),h(52,"V"),h(53,"W"),h(54,"X"),h(55,"Y"),h(56,"Z"),h(57,"Meta"),h(58,"ContextMenu"),h(59,"F1"),h(60,"F2"),h(61,"F3"),h(62,"F4"),h(63,"F5"),h(64,"F6"),h(65,"F7"),h(66,"F8"),h(67,"F9"),h(68,"F10"),h(69,"F11"),h(70,"F12"),h(71,"F13"),h(72,"F14"),h(73,"F15"),h(74,"F16"),h(75,"F17"),h(76,"F18"),h(77,"F19"),h(78,"NumLock"),h(79,"ScrollLock"),h(80,";",";","OEM_1"),h(81,"=","=","OEM_PLUS"),h(82,",",",","OEM_COMMA"),h(83,"-","-","OEM_MINUS"),h(84,".",".","OEM_PERIOD"),h(85,"/","/","OEM_2"),h(86,"`","`","OEM_3"),h(110,"ABNT_C1"),h(111,"ABNT_C2"),h(87,"[","[","OEM_4"),h(88,"\\","\\","OEM_5"),h(89,"]","]","OEM_6"),h(90,"'","'","OEM_7"),h(91,"OEM_8"),h(92,"OEM_102"),h(93,"NumPad0"),h(94,"NumPad1"),h(95,"NumPad2"),h(96,"NumPad3"),h(97,"NumPad4"),h(98,"NumPad5"),h(99,"NumPad6"),h(100,"NumPad7"),h(101,"NumPad8"),h(102,"NumPad9"),h(103,"NumPad_Multiply"),h(104,"NumPad_Add"),h(105,"NumPad_Separator"),h(106,"NumPad_Subtract"),h(107,"NumPad_Decimal"),h(108,"NumPad_Divide")})();var f;(function(h){function u(r){return M.keyCodeToStr(r)}h.toString=u;function o(r){return M.strToKeyCode(r)}h.fromString=o;function l(r){return I.keyCodeToStr(r)}h.toUserSettingsUS=l;function i(r){return n.keyCodeToStr(r)}h.toUserSettingsGeneral=i;function s(r){return I.strToKeyCode(r)||n.strToKeyCode(r)}h.fromUserSettings=s})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(h){h[h.CtrlCmd=2048]="CtrlCmd",h[h.Shift=1024]="Shift",h[h.Alt=512]="Alt",h[h.WinCtrl=256]="WinCtrl",h[h.KeyCode=255]="KeyCode"})(m||(m={}));var t;(function(h){h[h.CtrlCmd=2048]="CtrlCmd",h[h.Shift=1024]="Shift",h[h.Alt=512]="Alt",h[h.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function b(h,u){const o=(u&65535)<<16>>>0;return(h|o)>>>0}e.KeyChord=b;function E(h,u){if(h===0)return null;const o=(h&65535)>>>0,l=(h&4294901760)>>>16;return l!==0?new g([y(o,u),y(l,u)]):new g([y(o,u)])}e.createKeybinding=E;function y(h,u){const o=!!(h&2048),l=!!(h&256),i=u===2?l:o,s=!!(h&1024),r=!!(h&512),a=u===2?o:l,c=h&255;return new d(i,s,r,a,c)}e.createSimpleKeybinding=y;class d{constructor(u,o,l,i,s){this.ctrlKey=u,this.shiftKey=o,this.altKey=l,this.metaKey=i,this.keyCode=s}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",l=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${u}${o}${l}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(u){if(u.length===0)throw(0,v.illegalArgument)("parts");this.parts=u}getHashCode(){let u="";for(let o=0,l=this.parts.length;o<l;o++)o!==0&&(u+=";"),u+=this.parts[o].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(u.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class P{constructor(u,o,l,i,s,r){this.ctrlKey=u,this.shiftKey=o,this.altKey=l,this.metaKey=i,this.keyLabel=s,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class S{}e.ResolvedKeybinding=S}),define(J[2],Z([0,1,43,63]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function I(r){M=r}if(e.setDisposableTracker=I,k){const r="__is_disposable_tracked__";I(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==h.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==h.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function n(r){return M?.trackDisposable(r),r}function f(r){M?.markAsDisposed(r)}function m(r,a){M?.setParent(r,a)}function t(r,a){if(!!M)for(const c of r)M.setParent(c,a)}function b(r){return M?.markAsSingleton(r),r}e.markAsSingleton=b;class E extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=E;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function d(r){if(L.Iterable.is(r)){let a=[];for(const c of r)if(c)try{c.dispose()}catch(p){a.push(p)}if(a.length===1)throw a[0];if(a.length>1)throw new E(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function g(...r){const a=P(()=>d(r));return t(r,a),a}e.combinedDisposable=g;function P(r){const a=n({dispose:(0,v.once)(()=>{f(a),r()})});return a}e.toDisposable=P;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return m(a,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new S,n(this),m(this._store,this)}dispose(){f(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&m(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&m(a,null),a}}e.MutableDisposable=u;class o{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class l{constructor(){this.references=new Map}acquire(a,...c){let p=this.references.get(a);p||(p={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,p));const{object:w}=p,D=(0,v.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(a,p.object),this.references.delete(a))});return p.counter++,{object:w,dispose:D}}}e.ReferenceCollection=l;class i{constructor(a){this.referenceCollection=a}async acquire(a,...c){const p=this.referenceCollection.acquire(a,...c);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(w){throw p.dispose(),w}}}e.AsyncReferenceCollection=i;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s}),define(J[104],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const I=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=I}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,I){const n=new v(M);if(this._first===v.Undefined)this._first=n,this._last=n;else if(I){const m=this._last;this._last=n,n.prev=m,m.next=n}else{const m=this._first;this._first=n,n.next=m,m.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const I=M.prev;I.next=M.next,M.next.prev=I}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function V(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function I(f){M.push(f,Date.now())}function n(){const f=[];for(let m=0;m<M.length;m+=2)f.push({name:M[m],startTime:M[m+1]});return f}return{mark:I,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const I of performance.getEntriesByType("mark"))M.push({name:I.name,startTime:Math.round(k+I.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(J[3],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let L=!1,k=!1,M=!1,I=!1,n=!1,f=!1,m=!1,t,b=v,E,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)y=navigator.userAgent,L=y.indexOf("Windows")>=0,k=y.indexOf("Macintosh")>=0,m=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=y.indexOf("Linux")>=0,f=!0,t=navigator.language,b=t;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",M=d.platform==="linux",I=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=v,b=v;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),c=a.availableLanguages["*"];t=a.locale,b=c||v,E=a._translationsConfigFile}catch(a){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let h=0;k?h=1:L?h=3:M&&(h=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=I,e.isNative=n,e.isWeb=f,e.isIOS=m,e.platform=h,e.userAgent=y,e.language=b;var u;(function(r){function a(){return e.language}r.value=a;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=c;function p(){return e.language==="en"}r.isDefault=p})(u=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=E,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let D=0,R=c.length;D<R;D++){const _=c[D];if(_.id===w.data.vscodeSetImmediateId){c.splice(D,1),_.callback();return}}});let p=0;return w=>{const D=++p;c.push({id:D,callback:w}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const a=Promise.resolve();return c=>a.then(c)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||m?2:L?1:3;let l=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s}),define(J[33],Z([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,v.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return(0,v.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[8],Z([0,1,33]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,I=122,n=46,f=47,m=92,t=58,b=63;class E extends Error{constructor(o,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${s} of type ${l}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function y(u,o){if(typeof u!="string")throw new E(o,"string",u)}function d(u){return u===f||u===m}function g(u){return u===f}function P(u){return u>=L&&u<=M||u>=k&&u<=I}function S(u,o,l,i){let s="",r=0,a=-1,c=0,p=0;for(let w=0;w<=u.length;++w){if(w<u.length)p=u.charCodeAt(w);else{if(i(p))break;p=f}if(i(p)){if(!(a===w-1||c===1))if(c===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==n||s.charCodeAt(s.length-2)!==n){if(s.length>2){const D=s.lastIndexOf(l);D===-1?(s="",r=0):(s=s.slice(0,D),r=s.length-1-s.lastIndexOf(l)),a=w,c=0;continue}else if(s.length!==0){s="",r=0,a=w,c=0;continue}}o&&(s+=s.length>0?`${l}..`:"..",r=2)}else s.length>0?s+=`${l}${u.slice(a+1,w)}`:s=u.slice(a+1,w),r=w-a-1;a=w,c=0}else p===n&&c!==-1?++c:c=-1}return s}function h(u,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const l=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return l?l===o.root?`${l}${i}`:`${l}${u}${i}`:i}e.win32={resolve(...u){let o="",l="",i=!1;for(let s=u.length-1;s>=-1;s--){let r;if(s>=0){if(r=u[s],y(r,"path"),r.length===0)continue}else o.length===0?r=v.cwd():(r=v.env[`=${o}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let c=0,p="",w=!1;const D=r.charCodeAt(0);if(a===1)d(D)&&(c=1,w=!0);else if(d(D))if(w=!0,d(r.charCodeAt(1))){let R=2,_=R;for(;R<a&&!d(r.charCodeAt(R));)R++;if(R<a&&R!==_){const C=r.slice(_,R);for(_=R;R<a&&d(r.charCodeAt(R));)R++;if(R<a&&R!==_){for(_=R;R<a&&!d(r.charCodeAt(R));)R++;(R===a||R!==_)&&(p=`\\\\${C}\\${r.slice(_,R)}`,c=R)}}}else c=1;else P(D)&&r.charCodeAt(1)===t&&(p=r.slice(0,2),c=2,a>2&&d(r.charCodeAt(2))&&(w=!0,c=3));if(p.length>0)if(o.length>0){if(p.toLowerCase()!==o.toLowerCase())continue}else o=p;if(i){if(o.length>0)break}else if(l=`${r.slice(c)}\\${l}`,i=w,w&&o.length>0)break}return l=S(l,!i,"\\",d),i?`${o}\\${l}`:`${o}${l}`||"."},normalize(u){y(u,"path");const o=u.length;if(o===0)return".";let l=0,i,s=!1;const r=u.charCodeAt(0);if(o===1)return g(r)?"\\":u;if(d(r))if(s=!0,d(u.charCodeAt(1))){let c=2,p=c;for(;c<o&&!d(u.charCodeAt(c));)c++;if(c<o&&c!==p){const w=u.slice(p,c);for(p=c;c<o&&d(u.charCodeAt(c));)c++;if(c<o&&c!==p){for(p=c;c<o&&!d(u.charCodeAt(c));)c++;if(c===o)return`\\\\${w}\\${u.slice(p)}\\`;c!==p&&(i=`\\\\${w}\\${u.slice(p,c)}`,l=c)}}}else l=1;else P(r)&&u.charCodeAt(1)===t&&(i=u.slice(0,2),l=2,o>2&&d(u.charCodeAt(2))&&(s=!0,l=3));let a=l<o?S(u.slice(l),!s,"\\",d):"";return a.length===0&&!s&&(a="."),a.length>0&&d(u.charCodeAt(o-1))&&(a+="\\"),i===void 0?s?`\\${a}`:a:s?`${i}\\${a}`:`${i}${a}`},isAbsolute(u){y(u,"path");const o=u.length;if(o===0)return!1;const l=u.charCodeAt(0);return d(l)||o>2&&P(l)&&u.charCodeAt(1)===t&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let o,l;for(let r=0;r<u.length;++r){const a=u[r];y(a,"path"),a.length>0&&(o===void 0?o=l=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++s;const r=l.length;r>1&&d(l.charCodeAt(1))&&(++s,r>2&&(d(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&d(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(u,o){if(y(u,"from"),y(o,"to"),u===o)return"";const l=e.win32.resolve(u),i=e.win32.resolve(o);if(l===i||(u=l.toLowerCase(),o=i.toLowerCase(),u===o))return"";let s=0;for(;s<u.length&&u.charCodeAt(s)===m;)s++;let r=u.length;for(;r-1>s&&u.charCodeAt(r-1)===m;)r--;const a=r-s;let c=0;for(;c<o.length&&o.charCodeAt(c)===m;)c++;let p=o.length;for(;p-1>c&&o.charCodeAt(p-1)===m;)p--;const w=p-c,D=a<w?a:w;let R=-1,_=0;for(;_<D;_++){const G=u.charCodeAt(s+_);if(G!==o.charCodeAt(c+_))break;G===m&&(R=_)}if(_!==D){if(R===-1)return i}else{if(w>D){if(o.charCodeAt(c+_)===m)return i.slice(c+_+1);if(_===2)return i.slice(c+_)}a>D&&(u.charCodeAt(s+_)===m?R=_:_===2&&(R=3)),R===-1&&(R=0)}let C="";for(_=s+R+1;_<=r;++_)(_===r||u.charCodeAt(_)===m)&&(C+=C.length===0?"..":"\\..");return c+=R,C.length>0?`${C}${i.slice(c,p)}`:(i.charCodeAt(c)===m&&++c,i.slice(c,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const o=e.win32.resolve(u);if(o.length<=2)return u;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const l=o.charCodeAt(2);if(l!==b&&l!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return u},dirname(u){y(u,"path");const o=u.length;if(o===0)return".";let l=-1,i=0;const s=u.charCodeAt(0);if(o===1)return d(s)?u:".";if(d(s)){if(l=i=1,d(u.charCodeAt(1))){let c=2,p=c;for(;c<o&&!d(u.charCodeAt(c));)c++;if(c<o&&c!==p){for(p=c;c<o&&d(u.charCodeAt(c));)c++;if(c<o&&c!==p){for(p=c;c<o&&!d(u.charCodeAt(c));)c++;if(c===o)return u;c!==p&&(l=i=c+1)}}}}else P(s)&&u.charCodeAt(1)===t&&(l=o>2&&d(u.charCodeAt(2))?3:2,i=l);let r=-1,a=!0;for(let c=o-1;c>=i;--c)if(d(u.charCodeAt(c))){if(!a){r=c;break}}else a=!1;if(r===-1){if(l===-1)return".";r=l}return u.slice(0,r)},basename(u,o){o!==void 0&&y(o,"ext"),y(u,"path");let l=0,i=-1,s=!0,r;if(u.length>=2&&P(u.charCodeAt(0))&&u.charCodeAt(1)===t&&(l=2),o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let a=o.length-1,c=-1;for(r=u.length-1;r>=l;--r){const p=u.charCodeAt(r);if(d(p)){if(!s){l=r+1;break}}else c===-1&&(s=!1,c=r+1),a>=0&&(p===o.charCodeAt(a)?--a==-1&&(i=r):(a=-1,i=c))}return l===i?i=c:i===-1&&(i=u.length),u.slice(l,i)}for(r=u.length-1;r>=l;--r)if(d(u.charCodeAt(r))){if(!s){l=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":u.slice(l,i)},extname(u){y(u,"path");let o=0,l=-1,i=0,s=-1,r=!0,a=0;u.length>=2&&u.charCodeAt(1)===t&&P(u.charCodeAt(0))&&(o=i=2);for(let c=u.length-1;c>=o;--c){const p=u.charCodeAt(c);if(d(p)){if(!r){i=c+1;break}continue}s===-1&&(r=!1,s=c+1),p===n?l===-1?l=c:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||s===-1||a===0||a===1&&l===s-1&&l===i+1?"":u.slice(l,s)},format:h.bind(null,"\\"),parse(u){y(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const l=u.length;let i=0,s=u.charCodeAt(0);if(l===1)return d(s)?(o.root=o.dir=u,o):(o.base=o.name=u,o);if(d(s)){if(i=1,d(u.charCodeAt(1))){let R=2,_=R;for(;R<l&&!d(u.charCodeAt(R));)R++;if(R<l&&R!==_){for(_=R;R<l&&d(u.charCodeAt(R));)R++;if(R<l&&R!==_){for(_=R;R<l&&!d(u.charCodeAt(R));)R++;R===l?i=R:R!==_&&(i=R+1)}}}}else if(P(s)&&u.charCodeAt(1)===t){if(l<=2)return o.root=o.dir=u,o;if(i=2,d(u.charCodeAt(2))){if(l===3)return o.root=o.dir=u,o;i=3}}i>0&&(o.root=u.slice(0,i));let r=-1,a=i,c=-1,p=!0,w=u.length-1,D=0;for(;w>=i;--w){if(s=u.charCodeAt(w),d(s)){if(!p){a=w+1;break}continue}c===-1&&(p=!1,c=w+1),s===n?r===-1?r=w:D!==1&&(D=1):r!==-1&&(D=-1)}return c!==-1&&(r===-1||D===0||D===1&&r===c-1&&r===a+1?o.base=o.name=u.slice(a,c):(o.name=u.slice(a,r),o.base=u.slice(a,c),o.ext=u.slice(r,c))),a>0&&a!==i?o.dir=u.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let o="",l=!1;for(let i=u.length-1;i>=-1&&!l;i--){const s=i>=0?u[i]:v.cwd();y(s,"path"),s.length!==0&&(o=`${s}/${o}`,l=s.charCodeAt(0)===f)}return o=S(o,!l,"/",g),l?`/${o}`:o.length>0?o:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===f,l=u.charCodeAt(u.length-1)===f;return u=S(u,!o,"/",g),u.length===0?o?"/":l?"./":".":(l&&(u+="/"),o?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===f},join(...u){if(u.length===0)return".";let o;for(let l=0;l<u.length;++l){const i=u[l];y(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(u,o){if(y(u,"from"),y(o,"to"),u===o||(u=e.posix.resolve(u),o=e.posix.resolve(o),u===o))return"";const l=1,i=u.length,s=i-l,r=1,a=o.length-r,c=s<a?s:a;let p=-1,w=0;for(;w<c;w++){const R=u.charCodeAt(l+w);if(R!==o.charCodeAt(r+w))break;R===f&&(p=w)}if(w===c)if(a>c){if(o.charCodeAt(r+w)===f)return o.slice(r+w+1);if(w===0)return o.slice(r+w)}else s>c&&(u.charCodeAt(l+w)===f?p=w:w===0&&(p=0));let D="";for(w=l+p+1;w<=i;++w)(w===i||u.charCodeAt(w)===f)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(r+p)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===f;let l=-1,i=!0;for(let s=u.length-1;s>=1;--s)if(u.charCodeAt(s)===f){if(!i){l=s;break}}else i=!1;return l===-1?o?"/":".":o&&l===1?"//":u.slice(0,l)},basename(u,o){o!==void 0&&y(o,"ext"),y(u,"path");let l=0,i=-1,s=!0,r;if(o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let a=o.length-1,c=-1;for(r=u.length-1;r>=0;--r){const p=u.charCodeAt(r);if(p===f){if(!s){l=r+1;break}}else c===-1&&(s=!1,c=r+1),a>=0&&(p===o.charCodeAt(a)?--a==-1&&(i=r):(a=-1,i=c))}return l===i?i=c:i===-1&&(i=u.length),u.slice(l,i)}for(r=u.length-1;r>=0;--r)if(u.charCodeAt(r)===f){if(!s){l=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":u.slice(l,i)},extname(u){y(u,"path");let o=-1,l=0,i=-1,s=!0,r=0;for(let a=u.length-1;a>=0;--a){const c=u.charCodeAt(a);if(c===f){if(!s){l=a+1;break}continue}i===-1&&(s=!1,i=a+1),c===n?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===l+1?"":u.slice(o,i)},format:h.bind(null,"/"),parse(u){y(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const l=u.charCodeAt(0)===f;let i;l?(o.root="/",i=1):i=0;let s=-1,r=0,a=-1,c=!0,p=u.length-1,w=0;for(;p>=i;--p){const D=u.charCodeAt(p);if(D===f){if(!c){r=p+1;break}continue}a===-1&&(c=!1,a=p+1),D===n?s===-1?s=p:w!==1&&(w=1):s!==-1&&(w=-1)}if(a!==-1){const D=r===0&&l?1:r;s===-1||w===0||w===1&&s===a-1&&s===r+1?o.base=o.name=u.slice(D,a):(o.name=u.slice(D,s),o.base=u.slice(D,a),o.ext=u.slice(s,a))}return r>0?o.dir=u.slice(0,r-1):l&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...I){const n=I.reduce((t,b)=>(t[b]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let b=0;b<f.length;b++)if(t.search(f[b])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(J[77],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class I{constructor(f,m,t,b,E){this.ctrlKey=f,this.shiftKey=m,this.altKey=t,this.metaKey=b,this.scanCode=E}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=I,function(){function n(f,m){L[f]=m,k[m]=f,M[m.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,m){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=m,m!==0&&m!==3&&m!==5&&m!==4&&m!==6&&m!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[m]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,77]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(I){I=I.toLowerCase().trim();let n=!1,f=!1,m=!1,t=!1,b;do b=!1,/^ctrl(\+|\-)/.test(I)&&(n=!0,I=I.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(I)&&(f=!0,I=I.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(I)&&(m=!0,I=I.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(I)&&(t=!0,I=I.substr("meta-".length),b=!0),/^win(\+|\-)/.test(I)&&(t=!0,I=I.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(I)&&(t=!0,I=I.substr("cmd-".length),b=!0);while(b);let E;const y=I.indexOf(" ");return y>0?(E=I.substring(0,y),I=I.substring(y)):(E=I,I=""),{remains:I,ctrl:n,shift:f,alt:m,meta:t,key:E}}static parseSimpleKeybinding(I){const n=this._readModifiers(I),f=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(I,n){if(!I)return null;const f=[];let m;do[m,I]=this.parseSimpleKeybinding(I),f.push(m);while(I.length>0);return new v.ChordKeybinding(f)}static parseSimpleUserBinding(I){const n=this._readModifiers(I),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],b=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,b),n.remains]}const m=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,m),n.remains]}static parseUserBinding(I){if(!I)return[];const n=[];let f;for(;I.length>0;)[f,I]=this.parseSimpleUserBinding(I),n.push(f);return n}}e.KeybindingParser=k}),define(J[107],Z([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(I){this._highResolution=L&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new k(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[5],Z([0,1,16,43,2,104,107]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(u){u.None=()=>k.Disposable.None;function o(Q){return(U,$=null,W)=>{let N=!1,B;return B=Q(F=>{if(!N)return B?B.dispose():N=!0,U.call($,F)},null,W),N&&B.dispose(),B}}u.once=o;function l(Q,U){return p(($,W=null,N)=>Q(B=>$.call(W,U(B)),null,N))}u.map=l;function i(Q,U){return p(($,W=null,N)=>Q(B=>{U(B),$.call(W,B)},null,N))}u.forEach=i;function s(Q,U){return p(($,W=null,N)=>Q(B=>U(B)&&$.call(W,B),null,N))}u.filter=s;function r(Q){return Q}u.signal=r;function a(...Q){return(U,$=null,W)=>(0,k.combinedDisposable)(...Q.map(N=>N(B=>U.call($,B),null,W)))}u.any=a;function c(Q,U,$){let W=$;return l(Q,N=>(W=U(W,N),W))}u.reduce=c;function p(Q){let U;const $=new E({onFirstListenerAdd(){U=Q($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function w(Q,U,$=100,W=!1,N){let B,F,z,T=0;const A=new E({leakWarningThreshold:N,onFirstListenerAdd(){B=Q(O=>{T++,F=U(F,O),W&&!z&&(A.fire(F),F=void 0),clearTimeout(z),z=setTimeout(()=>{const j=F;F=void 0,z=void 0,(!W||T>1)&&A.fire(j),T=0},$)})},onLastListenerRemove(){B.dispose()}});return A.event}u.debounce=w;function D(Q,U=($,W)=>$===W){let $=!0,W;return s(Q,N=>{const B=$||!U(N,W);return $=!1,W=N,B})}u.latch=D;function R(Q,U){return[u.filter(Q,U),u.filter(Q,$=>!U($))]}u.split=R;function _(Q,U=!1,$=[]){let W=$.slice(),N=Q(z=>{W?W.push(z):F.fire(z)});const B=()=>{W&&W.forEach(z=>F.fire(z)),W=null},F=new E({onFirstListenerAdd(){N||(N=Q(z=>F.fire(z)))},onFirstListenerDidAdd(){W&&(U?setTimeout(B):B())},onLastListenerRemove(){N&&N.dispose(),N=null}});return F.event}u.buffer=_;class C{constructor(U){this.event=U}map(U){return new C(l(this.event,U))}forEach(U){return new C(i(this.event,U))}filter(U){return new C(s(this.event,U))}reduce(U,$){return new C(c(this.event,U,$))}latch(){return new C(D(this.event))}debounce(U,$=100,W=!1,N){return new C(w(this.event,U,$,W,N))}on(U,$,W){return this.event(U,$,W)}once(U,$,W){return o(this.event)(U,$,W)}}function G(Q){return new C(Q)}u.chain=G;function x(Q,U,$=W=>W){const W=(...z)=>F.fire($(...z)),N=()=>Q.on(U,W),B=()=>Q.removeListener(U,W),F=new E({onFirstListenerAdd:N,onLastListenerRemove:B});return F.event}u.fromNodeEventEmitter=x;function ne(Q,U,$=W=>W){const W=(...z)=>F.fire($(...z)),N=()=>Q.addEventListener(U,W),B=()=>Q.removeEventListener(U,W),F=new E({onFirstListenerAdd:N,onLastListenerRemove:B});return F.event}u.fromDOMEventEmitter=ne;function K(Q){return new Promise(U=>o(Q)(U))}u.toPromise=K})(n=e.Event||(e.Event={}));class f{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${f._idPool++}`}start(o){this._stopWatch=new I.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let m=-1;function t(u){const o=m;return m=u,{dispose(){m=o}}}e.setGlobalLeakWarningThreshold=t;class b{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let l=m;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||o<l)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(i)||0;if(this._stacks.set(i,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let r,a=0;for(const[c,p]of this._stacks)(!r||a<p)&&(r=c,a=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(i)||0;this._stacks.set(i,r-1)}}}class E{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=m>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(o,l,i)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(l?[o,l]:o);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const a=this._leakageMon?.check(this._listeners.size),c=(0,k.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(c):Array.isArray(i)&&i.push(c),c}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,i]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,i):l[0].call(l[1],i)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=E;class y extends E{async fireAsync(o,l,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],c={...r,waitUntil:p=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");i&&(p=i(p,typeof s=="function"?s:s[0])),a.push(p)}};try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(p){(0,v.onUnexpectedError)(p);continue}Object.freeze(a),await Promise.allSettled(a).then(p=>{for(const w of p)w.status==="rejected"&&(0,v.onUnexpectedError)(w.reason)})}}}}e.AsyncEmitter=y;class d extends E{constructor(o){super(o);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class g extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=g;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const i=()=>{this.hasListeners&&this.unhook(l);const s=this.events.indexOf(l);this.events.splice(s,1)};return(0,k.toDisposable)((0,L.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class S{constructor(){this.buffers=[]}wrapEvent(o){return(l,i,s)=>o(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>l.call(i,r)):l.call(i,r)},void 0,s)}bufferEvents(o){const l=[];this.buffers.push(l);const i=o();return this.buffers.pop(),l.forEach(s=>s()),i}}e.EventBufferer=S;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(J[25],Z([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const m=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(m)}}});var k;(function(n){function f(m){return m===n.None||m===n.Cancelled||m instanceof M?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=I}),define(J[108],Z([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(b){const E=this._icons.get(b.id);E?b.description?E.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(t,b){return new n(t,b)}e.registerCodicon=M;function I(t){return t?t.replace(/\$\((.*?)\)/g,(b,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=I;class n{constructor(b,E,y){this.id=b,this.definition=E,this.description=y,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,b){const E=["codicon","codicon-"+t];return b&&E.push("codicon-modifier-"+b),E}e.getClassNamesArray=f;var m;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function E(g){if(g instanceof n)return["codicon","codicon-"+g.id];const P=b.exec(g.id);if(!P)return E(n.error);let[,S,h]=P;const u=["codicon","codicon-"+S];return h&&u.push("codicon-modifier-"+h.substr(1)),u}t.asClassNameArray=E;function y(g){return E(g).join(" ")}t.asClassName=y;function d(g){return"."+E(g).join(".")}t.asCSSSelector=d})(m=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=k;function M(u){const o=u;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function I(u,o){return new n(u,o)}e.newWriteableStream=I;class n{constructor(o,l){this.reducer=o,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(l=>l(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(l=>l(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,l){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(o,l){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(l);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(u,o){const l=[];let i;for(;(i=u.read())!==null;)l.push(i);return o(l)}e.consumeReadable=f;function m(u,o,l){const i=[];let s;for(;(s=u.read())!==null&&i.length<l;)i.push(s);return s===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return u.read()}}}e.peekReadable=m;function t(u,o){return new Promise((l,i)=>{const s=[];b(u,{onData:r=>{o&&s.push(r)},onError:r=>{o?i(r):l(void 0)},onEnd:()=>{l(o?o(s):void 0)}})})}e.consumeStream=t;function b(u,o){u.on("error",l=>o.onError(l)),u.on("end",()=>o.onEnd()),u.on("data",l=>o.onData(l))}e.listenStream=b;function E(u,o){return new Promise((l,i)=>{const s=new L.DisposableStore,r=[],a=w=>{if(r.push(w),r.length>o)return s.dispose(),u.pause(),l({stream:u,buffer:r,ended:!1})},c=w=>i(w),p=()=>l({stream:u,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>u.removeListener("error",c))),u.on("error",c),s.add((0,L.toDisposable)(()=>u.removeListener("end",p))),u.on("end",p),s.add((0,L.toDisposable)(()=>u.removeListener("data",a))),u.on("data",a)})}e.peekStream=E;function y(u,o){const l=I(o);return l.end(u),l}e.toStream=y;function d(){const u=I(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=d;function g(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}e.toReadable=g;function P(u,o,l){const i=I(l);return b(u,{onData:s=>i.write(o.data(s)),onError:s=>i.error(o.error?o.error(s):s),onEnd:()=>i.end()}),i}e.transform=P;function S(u,o,l){let i=!1;return{read:()=>{const s=o.read();return i?s:(i=!0,s!==null?l([u,s]):u)}}}e.prefixedReadable=S;function h(u,o,l){let i=!1;const s=I(l);return b(o,{onData:r=>i?s.write(r):(i=!0,s.write(l([u,r]))),onError:r=>s.error(r),onEnd:()=>{i||(i=!0,s.write(u)),s.end()}}),s}e.prefixedStream=h}),define(J[23],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function k(H,...te){return te.length===0?H:H.replace(L,function(oe,le){const fe=parseInt(le,10);return isNaN(fe)||fe<0||fe>=te.length?oe:te[fe]})}e.format=k;const M=/{([^}]+)}/g;function I(H,te){return H.replace(M,(oe,le)=>te[le]??oe)}e.format2=I;function n(H){return H.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=n;function f(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function m(H,te){let oe=0;const le=te.charCodeAt(0);for(let fe=H.length-1;fe>=0;fe--)H.charCodeAt(fe)===le&&oe++;return oe}e.count=m;function t(H,te,oe="\u2026"){return H.length<=te?H:`${H.substr(0,te)}${oe}`}e.truncate=t;function b(H,te=" "){const oe=E(H,te);return y(oe,te)}e.trim=b;function E(H,te){if(!H||!te)return H;const oe=te.length;if(oe===0||H.length===0)return H;let le=0;for(;H.indexOf(te,le)===le;)le=le+oe;return H.substring(le)}e.ltrim=E;function y(H,te){if(!H||!te)return H;const oe=te.length,le=H.length;if(oe===0||le===0)return H;let fe=le,Se=-1;for(;Se=H.lastIndexOf(te,fe-1),!(Se===-1||Se+oe!==fe);){if(Se===0)return"";fe=Se}return H.substring(0,fe)}e.rtrim=y;function d(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(H){return H.replace(/\*/g,"")}e.stripWildcards=g;function P(H,te,oe={}){if(!H)throw new Error("Cannot create regex from empty string");te||(H=f(H)),oe.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(H,le)}e.createRegExp=P;function S(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function h(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function u(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=u;function o(H){return H.split(/\r\n|\r|\n/)}e.splitLines=o;function l(H){for(let te=0,oe=H.length;te<oe;te++){const le=H.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=l;function i(H,te=0,oe=H.length){for(let le=te;le<oe;le++){const fe=H.charCodeAt(le);if(fe!==32&&fe!==9)return H.substring(te,le)}return H.substring(te,oe)}e.getLeadingWhitespace=i;function s(H,te=H.length-1){for(let oe=te;oe>=0;oe--){const le=H.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function r(H,te){return H<te?-1:H>te?1:0}e.compare=r;function a(H,te,oe=0,le=H.length,fe=0,Se=te.length){for(;oe<le&&fe<Se;oe++,fe++){let ue=H.charCodeAt(oe),ge=te.charCodeAt(fe);if(ue<ge)return-1;if(ue>ge)return 1}const Pe=le-oe,We=Se-fe;return Pe<We?-1:Pe>We?1:0}e.compareSubstring=a;function c(H,te){return p(H,te,0,H.length,0,te.length)}e.compareIgnoreCase=c;function p(H,te,oe=0,le=H.length,fe=0,Se=te.length){for(;oe<le&&fe<Se;oe++,fe++){let ue=H.charCodeAt(oe),ge=te.charCodeAt(fe);if(ue===ge)continue;const we=ue-ge;if(!(we===32&&D(ge))&&!(we===-32&&D(ue)))return w(ue)&&w(ge)?we:a(H.toLowerCase(),te.toLowerCase(),oe,le,fe,Se)}const Pe=le-oe,We=Se-fe;return Pe<We?-1:Pe>We?1:0}e.compareSubstringIgnoreCase=p;function w(H){return H>=97&&H<=122}e.isLowerAsciiLetter=w;function D(H){return H>=65&&H<=90}e.isUpperAsciiLetter=D;function R(H){return w(H)||D(H)}function _(H,te){return H.length===te.length&&C(H,te)}e.equalsIgnoreCase=_;function C(H,te,oe=H.length){for(let le=0;le<oe;le++){const fe=H.charCodeAt(le),Se=te.charCodeAt(le);if(fe!==Se){if(R(fe)&&R(Se)){const Pe=Math.abs(fe-Se);if(Pe!==0&&Pe!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function G(H,te){const oe=te.length;return te.length>H.length?!1:C(H,te,oe)}e.startsWithIgnoreCase=G;function x(H,te){let oe,le=Math.min(H.length,te.length);for(oe=0;oe<le;oe++)if(H.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return le}e.commonPrefixLength=x;function ne(H,te){let oe,le=Math.min(H.length,te.length);const fe=H.length-1,Se=te.length-1;for(oe=0;oe<le;oe++)if(H.charCodeAt(fe-oe)!==te.charCodeAt(Se-oe))return oe;return le}e.commonSuffixLength=ne;function K(H){return 55296<=H&&H<=56319}e.isHighSurrogate=K;function Q(H){return 56320<=H&&H<=57343}e.isLowSurrogate=Q;function U(H,te){return(H-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function $(H,te,oe){const le=H.charCodeAt(oe);if(K(le)&&oe+1<te){const fe=H.charCodeAt(oe+1);if(Q(fe))return U(le,fe)}return le}e.getNextCodePoint=$;function W(H,te){const oe=H.charCodeAt(te-1);if(Q(oe)&&te>1){const le=H.charCodeAt(te-2);if(K(le))return U(le,oe)}return oe}function N(H,te){const oe=Ce.getInstance(),le=te,fe=H.length,Se=$(H,fe,te);te+=Se>=65536?2:1;let Pe=oe.getGraphemeBreakType(Se);for(;te<fe;){const We=$(H,fe,te),ue=oe.getGraphemeBreakType(We);if(je(Pe,ue))break;te+=We>=65536?2:1,Pe=ue}return te-le}e.nextCharLength=N;function B(H,te){const oe=Ce.getInstance(),le=te,fe=W(H,te);te-=fe>=65536?2:1;let Se=oe.getGraphemeBreakType(fe);for(;te>0;){const Pe=W(H,te),We=oe.getGraphemeBreakType(Pe);if(je(We,Se))break;te-=Pe>=65536?2:1,Se=We}return le-te}e.prevCharLength=B;function F(H,te){const oe=Ce.getInstance(),le=H.length,fe=te,Se=$(H,le,te),Pe=oe.getGraphemeBreakType(Se);te+=Se>=65536?2:1;let We=Pe;for(;te<le;){const ge=$(H,le,te),we=oe.getGraphemeBreakType(ge);if(je(We,we))break;te+=ge>=65536?2:1,We=we}const ue=te;for(te=fe,We=Pe;te>0;){const ge=W(H,te),we=oe.getGraphemeBreakType(ge);if(je(we,We))break;te-=ge>=65536?2:1,We=we}return[te,ue]}function z(H,te){return te>0&&Q(H.charCodeAt(te))?F(H,te-1):F(H,te)}e.getCharContainingOffset=z;function T(H){const te=H.length;let oe=0,le=0;for(;le<te;){const Pe=$(H,te,le);le+=Pe>=65536?2:1,Pe<128?oe+=1:Pe<2048?oe+=2:Pe<65536?oe+=3:oe+=4}const fe=new Uint8Array(oe);le=0;let Se=0;for(;le<te;){const Pe=$(H,te,le);le+=Pe>=65536?2:1,Pe<128?fe[Se++]=Pe:Pe<2048?(fe[Se++]=192|(Pe&1984)>>>6,fe[Se++]=128|(Pe&63)>>>0):Pe<65536?(fe[Se++]=224|(Pe&61440)>>>12,fe[Se++]=128|(Pe&4032)>>>6,fe[Se++]=128|(Pe&63)>>>0):(fe[Se++]=240|(Pe&1835008)>>>18,fe[Se++]=128|(Pe&258048)>>>12,fe[Se++]=128|(Pe&4032)>>>6,fe[Se++]=128|(Pe&63)>>>0)}return fe}e.encodeUTF8=T;function A(H){const te=H.byteLength,oe=[];let le=0;for(;le<te;){const fe=H[le];let Se;if(fe>=240&&le+3<te?Se=(H[le++]&7)<<18>>>0|(H[le++]&63)<<12>>>0|(H[le++]&63)<<6>>>0|(H[le++]&63)<<0>>>0:fe>=224&&le+2<te?Se=(H[le++]&15)<<12>>>0|(H[le++]&63)<<6>>>0|(H[le++]&63)<<0>>>0:fe>=192&&le+1<te?Se=(H[le++]&31)<<6>>>0|(H[le++]&63)<<0>>>0:Se=H[le++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)oe.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const Pe=Se-65536,We=55296+((Pe&1047552)>>>10),ue=56320+((Pe&1023)>>>0);oe.push(String.fromCharCode(We)),oe.push(String.fromCharCode(ue))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=A;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function j(H){return O.test(H)}e.containsRTL=j;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function q(H){return Y.test(H)}e.containsEmoji=q;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(H){return X.test(H)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=se;function ae(H){for(let te=0,oe=H.length;te<oe;te++)if(de(H.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ae;function de(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=de;function re(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=re;function ce(H,te){if(H.length<te)return H;const oe=/\b/g;let le=0;for(;oe.test(H)&&!(H.length-oe.lastIndex<te);)le=oe.lastIndex,oe.lastIndex+=1;return H.substring(le).replace(/^\s/,"")}e.lcut=ce;const Ee=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Te(H){return H&&(H=H.replace(Ee,""),H=H.replace(ve,""),H=H.replace(be,"")),H}e.removeAnsiEscapeCodes=Te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function pe(H){return ye(H)?H.substr(1):H}e.stripUTF8BOM=pe;function Ie(H,te){if(!H||!te||H.length<te.length)return!1;const oe=te.length,le=H.toLowerCase();let fe=0,Se=-1;for(;fe<oe;){const Pe=le.indexOf(te[fe],Se+1);if(Pe<0)return!1;Se=Pe,fe++}return!0}e.fuzzyContains=Ie;function Le(H,te=!1){return H?(te&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=Le;function Fe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Fe;function Ue(H,te=1){if(te===0)return"";let oe=-1;do oe=H.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?H:(H[oe-1]==="\r"&&oe--,H.substr(0,oe))}e.getNLines=Ue;function Ne(H){const te=90-65+1;return H=H%(2*te),H<te?String.fromCharCode(97+H):String.fromCharCode(65+H-te)}e.singleLetterHash=Ne;function Ge(H){return Ce.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Ge;function je(H,te){return H===0?te!==5&&te!==7:H===2&&te===3?!1:H===4||H===2||H===3||te===4||te===2||te===3?!0:!(H===8&&(te===8||te===9||te===11||te===12)||(H===11||H===9)&&(te===9||te===10)||(H===12||H===10)&&te===10||te===5||te===13||te===7||H===1||H===13&&te===14||H===6&&te===6)}e.breakBetweenGraphemeBreakType=je;var nt;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(nt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=rt()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,le=oe.length/3;let fe=1;for(;fe<=le;)if(te<oe[3*fe])fe=2*fe;else if(te>oe[3*fe+1])fe=2*fe+1;else return oe[3*fe+2];return 0}}Ce._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function lt(H,te){if(H===0)return 0;const oe=ct(H,te);if(oe!==void 0)return oe;const le=W(te,H);return H-=Ve(le),H}e.getLeftDeleteOffset=lt;function ct(H,te){let oe=W(te,H);for(H-=Ve(oe);ut(oe)||oe===65039||oe===8419;){if(H===0)return;oe=W(te,H),H-=Ve(oe)}if(!!re(oe)){if(H>=0){const le=W(te,H);le===8205&&(H-=Ve(le))}return H}}function Ve(H){return H>=65536?2:1}function ut(H){return 127995<=H&&H<=127999}var Ye;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={}))}),define(J[17],Z([0,1,64,23]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",M=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let n,f;class m{constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}static alloc(w){return k?new m(Buffer.allocUnsafe(w)):new m(new Uint8Array(w))}static wrap(w){return k&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new m(w)}static fromString(w,D){return!(D?.dontUseNodeBuffer||!1)&&k?new m(Buffer.from(w)):M?(n||(n=new TextEncoder),new m(n.encode(w))):new m(L.encodeUTF8(w))}static concat(w,D){if(typeof D=="undefined"){D=0;for(let C=0,G=w.length;C<G;C++)D+=w[C].byteLength}const R=m.alloc(D);let _=0;for(let C=0,G=w.length;C<G;C++){const x=w[C];R.set(x,_),_+=x.byteLength}return R}toString(){return k?this.buffer.toString():I?(f||(f=new TextDecoder),f.decode(this.buffer)):L.decodeUTF8(this.buffer)}slice(w,D){return new m(this.buffer.subarray(w,D))}set(w,D){w instanceof m?this.buffer.set(w.buffer,D):this.buffer.set(w,D)}readUInt32BE(w){return E(this.buffer,w)}writeUInt32BE(w,D){y(this.buffer,w,D)}readUInt32LE(w){return d(this.buffer,w)}writeUInt32LE(w,D){g(this.buffer,w,D)}readUInt8(w){return P(this.buffer,w)}writeUInt8(w,D){S(this.buffer,w,D)}}e.VSBuffer=m;function t(p,w){return p[w+0]<<0>>>0|p[w+1]<<8>>>0}e.readUInt16LE=t;function b(p,w,D){p[D+0]=w&255,w=w>>>8,p[D+1]=w&255}e.writeUInt16LE=b;function E(p,w){return p[w]*2**24+p[w+1]*2**16+p[w+2]*2**8+p[w+3]}e.readUInt32BE=E;function y(p,w,D){p[D+3]=w,w=w>>>8,p[D+2]=w,w=w>>>8,p[D+1]=w,w=w>>>8,p[D]=w}e.writeUInt32BE=y;function d(p,w){return p[w+0]<<0>>>0|p[w+1]<<8>>>0|p[w+2]<<16>>>0|p[w+3]<<24>>>0}e.readUInt32LE=d;function g(p,w,D){p[D+0]=w&255,w=w>>>8,p[D+1]=w&255,w=w>>>8,p[D+2]=w&255,w=w>>>8,p[D+3]=w&255}e.writeUInt32LE=g;function P(p,w){return p[w]}e.readUInt8=P;function S(p,w,D){p[D]=w}e.writeUInt8=S;function h(p){return v.consumeReadable(p,w=>m.concat(w))}e.readableToBuffer=h;function u(p){return v.toReadable(p)}e.bufferToReadable=u;function o(p){return v.consumeStream(p,w=>m.concat(w))}e.streamToBuffer=o;async function l(p){return p.ended?m.concat(p.buffer):m.concat([...p.buffer,await o(p.stream)])}e.bufferedStreamToBuffer=l;function i(p){return v.toStream(p,w=>m.concat(w))}e.bufferToStream=i;function s(p){return v.transform(p,{data:w=>typeof w=="string"?m.fromString(w):m.wrap(w)},w=>m.concat(w))}e.streamToBufferReadableStream=s;function r(p){return v.newWriteableStream(w=>m.concat(w),p)}e.newWriteableBufferStream=r;function a(p,w){return v.prefixedReadable(p,w,D=>m.concat(D))}e.prefixedBufferReadable=a;function c(p,w){return v.prefixedStream(p,w,D=>m.concat(D))}e.prefixedBufferStream=c}),define(J[78],Z([0,1,23]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(S){return k(S,0)}e.hash=L;function k(S,h){switch(typeof S){case"object":return S===null?M(349,h):Array.isArray(S)?f(S,h):m(S,h);case"string":return n(S,h);case"boolean":return I(S,h);case"number":return M(S,h);case"undefined":return M(937,h);default:return M(617,h)}}e.doHash=k;function M(S,h){return(h<<5)-h+S|0}function I(S,h){return M(S?433:863,h)}function n(S,h){h=M(149417,h);for(let u=0,o=S.length;u<o;u++)h=M(S.charCodeAt(u),h);return h}e.stringHash=n;function f(S,h){return h=M(104579,h),S.reduce((u,o)=>k(o,u),h)}function m(S,h){return h=M(181387,h),Object.keys(S).sort().reduce((u,o)=>(u=n(o,u),k(S[o],u)),h)}class t{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=k(h,this._value),this._value}}e.Hasher=t;var b;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function E(S,h,u=32){const o=u-h,l=~((1<<o)-1);return(S<<h|(l&S)>>>o)>>>0}function y(S,h=0,u=S.byteLength,o=0){for(let l=0;l<u;l++)S[h+l]=o}function d(S,h,u="0"){for(;S.length<h;)S=u+S;return S}function g(S,h=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((S>>>0).toString(16),h/4)}e.toHexString=g;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const u=h.length;if(u===0)return;const o=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,s,r;for(i!==0?(s=i,r=-1,i=0):(s=h.charCodeAt(0),r=0);;){let a=s;if(v.isHighSurrogate(s))if(r+1<u){const c=h.charCodeAt(r+1);v.isLowSurrogate(c)?(r++,a=v.computeCodePoint(s,c)):a=65533}else{i=s;break}else v.isLowSurrogate(s)&&(a=65533);if(l=this._push(o,l,a),r++,r<u)s=h.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(h,u,o){return o<128?h[u++]=o:o<2048?(h[u++]=192|(o&1984)>>>6,h[u++]=128|(o&63)>>>0):o<65536?(h[u++]=224|(o&61440)>>>12,h[u++]=128|(o&4032)>>>6,h[u++]=128|(o&63)>>>0):(h[u++]=240|(o&1835008)>>>18,h[u++]=128|(o&258048)>>>12,h[u++]=128|(o&4032)>>>6,h[u++]=128|(o&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=P._bigBlock32,u=this._buffDV;for(let w=0;w<64;w+=4)h.setUint32(w,u.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)h.setUint32(w,E(h.getUint32(w-12,!1)^h.getUint32(w-32,!1)^h.getUint32(w-56,!1)^h.getUint32(w-64,!1),1),!1);let o=this._h0,l=this._h1,i=this._h2,s=this._h3,r=this._h4,a,c,p;for(let w=0;w<80;w++)w<20?(a=l&i|~l&s,c=1518500249):w<40?(a=l^i^s,c=1859775393):w<60?(a=l&i|l&s|i&s,c=2400959708):(a=l^i^s,c=3395469782),p=E(o,5)+a+r+c+h.getUint32(w*4,!1)&4294967295,r=s,s=i,i=E(l,30),l=o,o=p;this._h0=this._h0+o&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(w){return Array.isArray(w)}e.isArray=v;function L(w){return typeof w=="string"}e.isString=L;function k(w){return Array.isArray(w)&&w.every(D=>L(D))}e.isStringArray=k;function M(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=M;function I(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=I;function n(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=n;function f(w){return w===!0||w===!1}e.isBoolean=f;function m(w){return typeof w=="undefined"}e.isUndefined=m;function t(w){return!b(w)}e.isDefined=t;function b(w){return m(w)||w===null}e.isUndefinedOrNull=b;function E(w,D){if(!w)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=E;function y(w){if(b(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=y;function d(...w){const D=[];for(let R=0;R<w.length;R++){const _=w[R];if(b(_))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);D.push(_)}return D}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function P(w){if(!M(w))return!1;for(let D in w)if(g.call(w,D))return!1;return!0}e.isEmptyObject=P;function S(w){return typeof w=="function"}e.isFunction=S;function h(...w){return w.length>0&&w.every(S)}e.areFunctions=h;function u(w,D){const R=Math.min(w.length,D.length);for(let _=0;_<R;_++)o(w[_],D[_])}e.validateConstraints=u;function o(w,D){if(L(D)){if(typeof w!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(S(D)){try{if(w instanceof D)return}catch{}if(!b(w)&&w.constructor===D||D.length===1&&D.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function l(w){let D=[],R=Object.getPrototypeOf(w);for(;Object.prototype!==R;)D=D.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return D}e.getAllPropertyNames=l;function i(w){const D=[];for(const R of l(w))typeof w[R]=="function"&&D.push(R);return D}e.getAllMethodNames=i;function s(w,D){const R=C=>function(){const G=Array.prototype.slice.call(arguments,0);return D(C,G)};let _={};for(const C of w)_[C]=R(C);return _}e.createProxyObject=s;function r(w){return w===null?void 0:w}e.withNullAsUndefined=r;function a(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=a;function c(w){return class{constructor(){return new Proxy({},{get(D,R){if(D[R])return D[R];throw new Error(`Not Implemented: ${w}->${String(R)}`)}})}}}e.NotImplementedProxy=c;function p(w,D="Unreachable"){throw new Error(D)}e.assertNever=p}),define(J[29],Z([0,1,8,3,23,13]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(r){return r===47||r===92}e.isPathSeparator=I;function n(r){return r.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function m(r,a=v.posix.sep){if(!r)return"";const c=r.length,p=r.charCodeAt(0);if(I(p)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let D=3;const R=D;for(;D<c&&!I(r.charCodeAt(D));D++);if(R!==D&&!I(r.charCodeAt(D+1))){for(D+=1;D<c;D++)if(I(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,a)}}return a}else if(S(p)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<c;w++)if(I(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=m;function t(r){if(!L.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let c=2;const p=c;for(;c<r.length&&(a=r.charCodeAt(c),a!==92);c++);return!(p===c||(a=r.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=t;const b=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=L.isWindows){const c=a?b:E;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||a&&y.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,a,c){const p=r===a;return!c||p?p:!r||!a?!1:(0,k.equalsIgnoreCase)(r,a)}e.isEqual=g;function P(r,a,c,p=v.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let D=a.length;return a.charAt(a.length-1)===p&&D--,r.charAt(D)===p}return a.charAt(a.length-1)!==p&&(a+=p),r.indexOf(a)===0}e.isEqualOrParent=P;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function h(r,a){return L.isWindows&&r.endsWith(":")&&(r+=v.sep),(0,v.isAbsolute)(r)||(r=(0,v.join)(a,r)),r=(0,v.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,v.sep),r.endsWith(":")&&(r+=v.sep)):(r=(0,k.rtrim)(r,v.sep),r||(r=v.sep)),r}e.sanitizeFilePath=h;function u(r){const a=(0,v.normalize)(r);return L.isWindows?r.length>3?!1:o(a)&&(r.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=u;function o(r){return L.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function l(r){return o(r)?r[0]:void 0}e.getDriveLetter=l;function i(r,a,c){return a.length>r.length?-1:r===a?0:(c&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function s(r){const a=r.split(":");let c,p,w;if(a.forEach(D=>{const R=Number(D);(0,M.isNumber)(R)?p===void 0?p=R:w===void 0&&(w=R):c=c?[c,D].join(":"):D}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:p!==void 0?p:void 0,column:w!==void 0?w:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(J[44],Z([0,1,13]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const P=Array.isArray(g)?[]:{};return Object.keys(g).forEach(S=>{g[S]&&typeof g[S]=="object"?P[S]=L(g[S]):P[S]=g[S]}),P}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const P=[g];for(;P.length>0;){const S=P.shift();Object.freeze(S);for(const h in S)if(M.call(S,h)){const u=S[h];typeof u=="object"&&!Object.isFrozen(u)&&P.push(u)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function I(g,P){return n(g,P,new Set)}e.cloneAndChange=I;function n(g,P,S){if((0,v.isUndefinedOrNull)(g))return g;const h=P(g);if(typeof h!="undefined")return h;if((0,v.isArray)(g)){const u=[];for(const o of g)u.push(n(o,P,S));return u}if((0,v.isObject)(g)){if(S.has(g))throw new Error("Cannot clone recursive data-structure");S.add(g);const u={};for(let o in g)M.call(g,o)&&(u[o]=n(g[o],P,S));return S.delete(g),u}return g}function f(g,P,S=!0){return(0,v.isObject)(g)?((0,v.isObject)(P)&&Object.keys(P).forEach(h=>{h in g?S&&((0,v.isObject)(g[h])&&(0,v.isObject)(P[h])?f(g[h],P[h],S):g[h]=P[h]):g[h]=P[h]}),g):P}e.mixin=f;function m(g,P){if(g===P)return!0;if(g==null||P===null||P===void 0||typeof g!=typeof P||typeof g!="object"||Array.isArray(g)!==Array.isArray(P))return!1;let S,h;if(Array.isArray(g)){if(g.length!==P.length)return!1;for(S=0;S<g.length;S++)if(!m(g[S],P[S]))return!1}else{const u=[];for(h in g)u.push(h);u.sort();const o=[];for(h in P)o.push(h);if(o.sort(),!m(u,o))return!1;for(S=0;S<u.length;S++)if(!m(g[u[S]],P[u[S]]))return!1}return!0}e.equals=m;function t(g){const P=new Set;return JSON.stringify(g,(S,h)=>{if((0,v.isObject)(h)||Array.isArray(h)){if(P.has(h))return"[Circular]";P.add(h)}return h})}e.safeStringify=t;function b(g,P,S){const h=P(g);return typeof h=="undefined"?S:h}e.getOrDefault=b;function E(g,P){const S=Object.create(null);return!g||!P||Object.keys(P).forEach(u=>{const o=g[u],l=P[u];m(o,l)||(S[u]=l)}),S}e.distinct=E;function y(g,P){const S=P.toLowerCase(),h=Object.keys(g).find(u=>u.toLowerCase()===S);return h?g[h]:g[P]}e.getCaseInsensitive=y;function d(g,P){const S=Object.create(null);for(const h of Object.keys(g))P(h,g[h])&&(S[h]=g[h]);return S}e.filter=d}),define(J[7],Z([0,1,8,3]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,I=/^\/\//;function n(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,a){return!r&&!a?"file":r}function m(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const t="",b="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(a,c,p,w,D,R=!1){typeof a=="object"?(this.scheme=a.scheme||t,this.authority=a.authority||t,this.path=a.path||t,this.query=a.query||t,this.fragment=a.fragment||t):(this.scheme=f(a,R),this.authority=c||t,this.path=m(this.scheme,p||t),this.query=w||t,this.fragment=D||t,n(this,R))}static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:p,path:w,query:D,fragment:R}=a;return c===void 0?c=this.scheme:c===null&&(c=t),p===void 0?p=this.authority:p===null&&(p=t),w===void 0?w=this.path:w===null&&(w=t),D===void 0?D=this.query:D===null&&(D=t),R===void 0?R=this.fragment:R===null&&(R=t),c===this.scheme&&p===this.authority&&w===this.path&&D===this.query&&R===this.fragment?this:new g(c,p,w,D,R)}static parse(a,c=!1){const p=E.exec(a);return p?new g(p[2]||t,s(p[4]||t),s(p[5]||t),s(p[7]||t),s(p[9]||t),c):new g(t,t,t,t,t)}static file(a){let c=t;if(L.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const p=a.indexOf(b,2);p===-1?(c=a.substring(2),a=b):(c=a.substring(2,p),a=a.substring(p)||b)}return new g("file",c,a,t,t)}static from(a){const c=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return n(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return L.isWindows&&a.scheme==="file"?p=y.file(v.win32.join(u(a,!0),...c)).path:p=v.posix.join(a.path,...c),a.with({path:p})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const c=new g(a);return c._formatted=a.external,c._fsPath=a._sep===d?a.fsPath:null,c}}else return a}}e.URI=y;const d=L.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(r,a){let c,p=-1;for(let w=0;w<r.length;w++){const D=r.charCodeAt(w);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||a&&D===47)p!==-1&&(c+=encodeURIComponent(r.substring(p,w)),p=-1),c!==void 0&&(c+=r.charAt(w));else{c===void 0&&(c=r.substr(0,w));const R=P[D];R!==void 0?(p!==-1&&(c+=encodeURIComponent(r.substring(p,w)),p=-1),c+=R):p===-1&&(p=w)}}return p!==-1&&(c+=encodeURIComponent(r.substring(p))),c!==void 0?c:r}function h(r){let a;for(let c=0;c<r.length;c++){const p=r.charCodeAt(c);p===35||p===63?(a===void 0&&(a=r.substr(0,c)),a+=P[p]):a!==void 0&&(a+=r[c])}return a!==void 0?a:r}function u(r,a){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=u;function o(r,a){const c=a?h:S;let p="",{scheme:w,authority:D,path:R,query:_,fragment:C}=r;if(w&&(p+=w,p+=":"),(D||w==="file")&&(p+=b,p+=b),D){let G=D.indexOf("@");if(G!==-1){const x=D.substr(0,G);D=D.substr(G+1),G=x.indexOf(":"),G===-1?p+=c(x,!1):(p+=c(x.substr(0,G),!1),p+=":",p+=c(x.substr(G+1),!1)),p+="@"}D=D.toLowerCase(),G=D.indexOf(":"),G===-1?p+=c(D,!1):(p+=c(D.substr(0,G),!1),p+=D.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}p+=c(R,!0)}return _&&(p+="?",p+=c(_,!1)),C&&(p+="#",p+=a?C:S(C,!1)),p}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(i)?r.replace(i,a=>l(a)):r}}),define(J[109],Z([0,1,7]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(m){const t=m;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(m){const t=[];let b;try{const E=JSON.parse(m.arguments),y=E[E.length-1];y&&y.__$stack&&(E.pop(),b=y.__$stack),t.push(...E)}catch(E){t.push("Unable to log remote console arguments",m.arguments)}return{args:t,stack:b}}e.parse=k;function M(m){if(typeof m!="string")return M(k(m).stack);const t=m;if(t){const b=I(t),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=M;function I(m){if(!m)return m;const t=m.indexOf(`
`);return t===-1?m:m.substring(0,t)}function n(m,t){const{args:b,stack:E}=k(m),y=typeof b[0]=="string"&&b.length===1;let d=I(E);d&&(d=`(${d.trim()})`);let g=[];if(typeof b[0]=="string"?d&&y?g=[`%c[${t}] %c${b[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:g=[`%c[${t}]%`,f("blue"),...b],d&&!y&&g.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}e.log=n;function f(m){return`color: ${m}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,v,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!k:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(V,v):k?k.value=v:e.set(V,v),v},He=this&&this.__classPrivateFieldGet||function(V,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(V):L?L.value:e.get(V)};define(J[37],Z([0,1,23,7]),function(V,e,v,L){"use strict";var k,M,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(i,s,r){let a=i.get(s);return a===void 0&&(a=r,i.set(s,a)),a}e.getOrSet=n;function f(i){const s=[];return i.forEach((r,a)=>{s.push(`${a} => ${r}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.mapToString=f;function m(i){const s=[];return i.forEach(r=>{s.push(r)}),`Set(${i.size}) {${s.join(", ")}}`}e.setToString=m;class t{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=t;class b{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,v.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class E{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,v.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var y;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,v.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,v.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,v.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,v.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new d(s))}static forPaths(){return new P(new E)}static forStrings(){return new P(new t)}static forConfigKeys(){return new P(new b)}clear(){this._root=void 0}set(s,r){const a=this._iter.reset(s);let c;for(this._root||(this._root=new g,this._root.segment=a.value()),c=this._root;;){const w=a.cmp(c.segment);if(w>0)c.left||(c.left=new g,c.left.segment=a.value()),c=c.left;else if(w<0)c.right||(c.right=new g,c.right.segment=a.value()),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new g,c.mid.segment=a.value()),c=c.mid;else break}const p=c.value;return c.value=r,c.key=s,p}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let a=this._root;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const a=this._iter.reset(s),c=[];let p=this._root;for(;p;){const w=a.cmp(p.segment);if(w>0)c.push([1,p]),p=p.left;else if(w<0)c.push([-1,p]),p=p.right;else if(a.hasNext())a.next(),c.push([0,p]),p=p.mid;else{for(r?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;c.length>0&&p.isEmpty();){let[D,R]=c.pop();switch(D){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}p=R}break}}}findSubstr(s){const r=this._iter.reset(s);let a=this._root,c;for(;a;){const p=r.cmp(a.segment);if(p>0)a=a.left;else if(p<0)a=a.right;else if(r.hasNext())r.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(s){const r=this._iter.reset(s);let a=this._root;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(s){for(const[r,a]of this)s(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const a=r.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&r.push(a.left),a.mid&&r.push(a.mid),a.right&&r.push(a.right))}}}e.TernarySearchTree=P;class S{constructor(s,r){this[k]="ResourceMap",s instanceof S?(this.map=new Map(s.map),this.toKey=r??S.defaultToKey):(this.map=new Map,this.toKey=s??S.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[a,c]of this.map)s(c,L.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield L.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[L.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[L.URI.parse(s[0]),s[1]]}}e.ResourceMap=S,S.defaultToKey=i=>i.toString();var h;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class u{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const a=this._map.get(s);if(!!a)return r!==0&&this.touch(a,r),a.value}set(s,r,a=0){let c=this._map.get(s);if(c)c.value=r,a!==0&&this.touch(c,a);else{switch(c={key:s,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(s,c),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const a=this._state;let c=this._head;for(;c;){if(r?s.bind(r)(c.value,c.key,this):s(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const s=this,r=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.key,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return c}values(){const s=this,r=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.value,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return c}entries(){const s=this,r=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:[a.key,a.value],done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return c}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>s;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,a=s.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const a=s.next,c=s.previous;s===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const a=s.next,c=s.previous;s===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,a)=>{s.push([a,r])}),s}fromJSON(s){this.clear();for(const[r,a]of s)this.set(r,a)}}e.LinkedMap=u;class o extends u{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(s){I.set(this,void 0),bt(this,I,s,"f")}get size(){return He(this,I,"f").size}forEach(s,r){He(this,I,"f").forEach(s,r)}get(s){return He(this,I,"f").get(s)}has(s){return He(this,I,"f").has(s)}entries(){return He(this,I,"f").entries()}keys(){return He(this,I,"f").keys()}values(){return He(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return He(this,I,"f").entries()}}e.ReadonlyMapView=l}),define(J[110],Z([0,1,17,23,7]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function I(t){let b=JSON.parse(t);return b=m(b),b}e.parse=I;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,L.regExpFlags)(b)}:b}function m(t,b=0){if(!t||b>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof v.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let E=0;E<t.length;++E)t[E]=m(t[E],b+1);else for(const E in t)Object.hasOwnProperty.call(t,E)&&(t[E]=m(t[E],b+1))}return t}e.revive=m}),define(J[10],Z([0,1,3,7]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,m,t){this._hosts[f]=m,this._ports[f]=t}setConnectionToken(f,m){this._connectionTokens[f]=m}rewrite(f){if(this._delegate)return this._delegate(f);const m=f.authority;let t=this._hosts[m];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const b=this._ports[m],E=this._connectionTokens[m];let y=`path=${encodeURIComponent(f.path)}`;return typeof E=="string"&&(y+=`&tkn=${encodeURIComponent(E)}`),L.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new M;class I{asBrowserUri(f,m){const t=this.toUri(f,m);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${k.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,m){const t=this.toUri(f,m);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==I.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,m){return L.URI.isUri(f)?f:L.URI.parse(m.toUrl(f))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(J[65],Z([0,1,37]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function k(m){return f(m,"NFC",L)}e.normalizeNFC=k;const M=new v.LRUCache(1e4);function I(m){return f(m,"NFD",M)}e.normalizeNFD=I;const n=/[^\u0000-\u0080]/;function f(m,t,b){if(!m)return m;const E=b.get(m);if(E)return E;let y;return n.test(m)?y=m.normalize(t):y=m,b.set(m,y),y}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(t){return I(t).replace(m,"")}}()}),define(J[15],Z([0,1,29,10,8,3,23,7]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,n.uriToFsPath)(y,!0)}e.originalFSPath=f;class m{constructor(d){this._ignorePathCasing=d}compare(d,g,P=!1){return d===g?0:(0,I.compare)(this.getComparisonKey(d,P),this.getComparisonKey(g,P))}isEqual(d,g,P=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,P)===this.getComparisonKey(g,P)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,P=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return v.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(P||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return v.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(P||d.fragment===g.fragment)}return!1}joinPath(d,...g){return n.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){const g=k.posix.extname(d.path),P=g.indexOf("?");return P!==-1?g.substr(0,P):g}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.dirname(f(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.normalize(f(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const h=k.relative(f(d),f(g));return M.isWindows?v.toSlashes(h):h}let P=d.path||"/",S=g.path||"/";if(this._ignorePathCasing(d)){let h=0;for(const u=Math.min(P.length,S.length);h<u&&!(P.charCodeAt(h)!==S.charCodeAt(h)&&P.charAt(h).toLowerCase()!==S.charAt(h).toLowerCase());h++);P=S.substr(0,h)+P.substr(h)}return k.posix.relative(P,S)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const P=n.URI.file(k.resolve(f(d),g));return d.with({authority:P.authority,path:P.path})}return g=v.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,I.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const P=f(d);return P.length>v.getRoot(P).length&&P[P.length-1]===g}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let P=!1;if(d.scheme===L.Schemas.file){const S=f(d);P=S!==void 0&&S.length===v.getRoot(S).length&&S[S.length-1]===g}else{g="/";const S=d.path;P=S.length===1&&S.charCodeAt(S.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(y=>y.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(y,d){const g=[];for(let P=0;P<y.length;P++){const S=d(y[P]);y.some((h,u)=>u===P?!1:(0,e.isEqualOrParent)(S,d(h)))||g.push(y[P])}return g}e.distinctParents=t;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(g){const P=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[o,l]=u.split(":");o&&l&&P.set(o,l)});const h=g.path.substring(0,g.path.indexOf(";"));return h&&P.set(y.META_DATA_MIME,h),P}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function E(y,d,g){if(d){let P=y.path;return P&&P[0]!==k.posix.sep&&(P=k.posix.sep+P),y.with({scheme:g,authority:d,path:P})}return y.with({scheme:g})}e.toLocalResource=E}),define(J[9],Z([0,1,25,16,5,2,15]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n($){return!!$&&typeof $.then=="function"}e.isThenable=n;function f($){const W=new v.CancellationTokenSource,N=$(W.token),B=new Promise((F,z)=>{const T=W.token.onCancellationRequested(()=>{T.dispose(),W.dispose(),z((0,L.canceled)())});Promise.resolve(N).then(A=>{T.dispose(),W.dispose(),F(A)},A=>{T.dispose(),W.dispose(),z(A)})});return new class{cancel(){W.cancel()}then(F,z){return B.then(F,z)}catch(F){return this.then(void 0,F)}finally(F){return B.finally(F)}}}e.createCancelablePromise=f;function m($,W,N){return Promise.race([$,new Promise(B=>W.onCancellationRequested(()=>B(N)))])}e.raceCancellation=m;async function t($){let W=-1;const N=$.map((F,z)=>F.then(T=>(W=z,T))),B=await Promise.race(N);return $.forEach((F,z)=>{z!==W&&F.cancel()}),B}e.raceCancellablePromises=t;function b($,W,N){let B;const F=setTimeout(()=>{B?.(void 0),N?.()},W);return Promise.race([$.finally(()=>clearTimeout(F)),new Promise(z=>B=z)])}e.raceTimeout=b;function E($){return new Promise((W,N)=>{const B=$();n(B)?B.then(W,N):W(B)})}e.asPromise=E;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(N,N).then(B)})}return new Promise((N,B)=>{this.queuedPromise.then(N,B)})}return this.activePromise=W(),new Promise((N,B)=>{this.activePromise.then(F=>{this.activePromise=null,N(F)},F=>{this.activePromise=null,B(F)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(W,N){const F=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(W)===F&&this.promiseMap.delete(W)});return this.promiseMap.set(W,F),F}}e.SequencerByKey=g;class P{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,N=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,F)=>{this.doResolve=B,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class S{constructor(W){this.delayer=new P(W),this.throttler=new y}trigger(W,N){return this.delayer.trigger(()=>this.throttler.queue(W),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class h{constructor(){this._isOpen=!1,this._promise=new Promise((W,N)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class u extends h{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o($,W){return W?new Promise((N,B)=>{const F=setTimeout(()=>{z.dispose(),N()},$),z=W.onCancellationRequested(()=>{clearTimeout(F),z.dispose(),B((0,L.canceled)())})}):f(N=>o($,N))}e.timeout=o;function l($,W=0){const N=setTimeout($,W);return(0,M.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=l;function i($){const W=[];let N=0;const B=$.length;function F(){return N<B?$[N++]():null}function z(T){T!=null&&W.push(T);const A=F();return A?A.then(z):Promise.resolve(W)}return Promise.resolve(null).then(z)}e.sequence=i;function s($,W=B=>!!B,N=null){let B=0;const F=$.length,z=()=>{if(B>=F)return Promise.resolve(N);const T=$[B++];return Promise.resolve(T()).then(O=>W(O)?Promise.resolve(O):z())};return z()}e.first=s;function r($,W=B=>!!B,N=null){if($.length===0)return Promise.resolve(N);let B=$.length;const F=()=>{B=-1;for(const z of $)z.cancel?.()};return new Promise((z,T)=>{for(const A of $)A.then(O=>{--B>=0&&W(O)?(F(),z(O)):B===0&&z(N)}).catch(O=>{--B>=0&&(F(),T(O))})})}e.firstParallel=r;class a{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((N,B)=>{this.outstandingPromises.push({factory:W,c:N,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const N=W.factory();N.then(W.c,W.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class c extends a{constructor(){super(1)}}e.Queue=c;class p{constructor(){this.queues=new Map}queueFor(W,N=I.extUri){const B=N.getComparisonKey(W);let F=this.queues.get(B);return F||(F=new c,k.Event.once(F.onFinished)(()=>{F?.dispose(),this.queues.delete(B)}),this.queues.set(B,F)),F}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=p;class w{constructor(W,N){this._token=-1,typeof W=="function"&&typeof N=="number"&&this.setIfNotSet(W,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},N)}setIfNotSet(W,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},N))}}e.TimeoutTimer=w;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,N){this.cancel(),this._token=setInterval(()=>{W()},N)}}e.IntervalTimer=D;class R{constructor(W,N){this.timeoutToken=-1,this.runner=W,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class _ extends R{constructor(W,N){super(W,N);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class C extends M.Disposable{constructor(W,N,B,F){super();this.maxWorkChunkSize=W,this.maxPendingWork=N,this.throttleDelay=B,this.handler=F,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=C,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=W=>{const N=setTimeout(()=>W($));let B=!1;return{dispose(){B||(B=!0,clearTimeout(N))}}}}else e.runWhenIdle=($,W)=>{const N=requestIdleCallback($,typeof W=="number"?{timeout:W}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(N))}}}}();class G{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=G;async function x($,W,N){let B;for(let F=0;F<N;F++)try{return await $()}catch(z){B=z,await o(W)}throw B}e.retry=x;class ne{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,N,B){return this._pending={taskId:W,cancel:()=>B?.(),promise:N},N.then(()=>this.donePending(W),()=>this.donePending(W)),N}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let N,B;const F=new Promise((z,T)=>{N=z,B=T});this._next={run:W,promise:F,promiseResolve:N,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=ne;class K{constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,N)=>{this.completeCallback=W,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(N=>{this.completeCallback(W),this.resolved=!0,N()})}error(W){return new Promise(N=>{this.errorCallback(W),this.rejected=!0,N()})}cancel(){new Promise(W=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=Q;var U;(function($){async function W(N){let B;const F=await Promise.all(N.map(z=>z.then(T=>T,T=>{B||(B=T)})));if(typeof B!="undefined")throw B;return F}$.settled=W})(U=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,9,29,37,8,23]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",m="/",t="[/\\\\]",b="[^/\\\\]",E=/\//g;function y(F){switch(F){case 0:return"";case 1:return`${b}*?`;default:return`(?:${t}|${b}+${t}|${t}${b}+)*?`}}function d(F,z){if(!F)return[];const T=[];let A=!1,O=!1,j="";for(const Y of F){switch(Y){case z:if(!A&&!O){T.push(j),j="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":O=!0;break;case"]":O=!1;break}j+=Y}return j&&T.push(j),T}e.splitGlobAware=d;function g(F){if(!F)return"";let z="";const T=d(F,m);if(T.every(A=>A===f))z=".*";else{let A=!1;T.forEach((O,j)=>{if(O===f){A||(z+=y(2),A=!0);return}let Y=!1,q="",X=!1,ie="";for(const se of O){if(se!=="}"&&Y){q+=se;continue}if(X&&(se!=="]"||!ie)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!ie?ae="^":se===m?ae="":ae=I.escapeRegExpCharacters(se),ie+=ae;continue}switch(se){case"{":Y=!0;continue;case"[":X=!0;continue;case"}":z+=`(?:${d(q,",").map(re=>g(re)).join("|")})`,Y=!1,q="";break;case"]":z+="["+ie+"]",X=!1,ie="";break;case"?":z+=b;continue;case"*":z+=y(1);continue;default:z+=I.escapeRegExpCharacters(se)}}j<T.length-1&&(T[j+1]!==f||j+2<T.length)&&(z+=t),A=!1})}return z}const P=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(F,z){if(!F)return r;let T;typeof F!="string"?T=F.pattern:T=F,T=T.trim();const A=`${T}_${!!z.trimForExclusions}`;let O=i.get(A);if(O)return c(O,F);let j;if(P.test(T)){const Y=T.substr(4);O=function(q,X){return typeof q=="string"&&q.endsWith(Y)?T:null}}else(j=S.exec(p(T,z)))?O=w(j[1],T):(z.trimForExclusions?u:h).test(T)?O=D(T,z):(j=o.exec(p(T,z)))?O=R(j[1].substr(1),T,!0):(j=l.exec(p(T,z)))?O=R(j[1],T,!1):O=_(T);return i.set(A,O),c(O,F)}function c(F,z){return typeof z=="string"?F:function(T,A){return L.isEqualOrParent(T,z.base)?F(M.relative(z.base,T),A):null}}function p(F,z){return z.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function w(F,z){const T=`/${F}`,A=`\\${F}`,O=function(Y,q){return typeof Y!="string"?null:q?q===F?z:null:Y===F||Y.endsWith(T)||Y.endsWith(A)?z:null},j=[F];return O.basenames=j,O.patterns=[z],O.allBasenames=j,O}function D(F,z){const T=B(F.slice(1,-1).split(",").map(q=>a(q,z)).filter(q=>q!==r),F),A=T.length;if(!A)return r;if(A===1)return T[0];const O=function(q,X){for(let ie=0,se=T.length;ie<se;ie++)if(T[ie](q,X))return F;return null},j=T.find(q=>!!q.allBasenames);j&&(O.allBasenames=j.allBasenames);const Y=T.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return Y.length&&(O.allPaths=Y),O}function R(F,z,T){const A=M.sep===M.posix.sep,O=A?F:F.replace(E,M.sep),j=M.sep+O,Y=M.posix.sep+F,q=T?function(X,ie){return typeof X=="string"&&(X===O||X.endsWith(j)||!A&&(X===F||X.endsWith(Y)))?z:null}:function(X,ie){return typeof X=="string"&&(X===O||!A&&X===F)?z:null};return q.allPaths=[(T?"*/":"./")+F],q}function _(F){try{const z=new RegExp(`^${g(F)}$`);return function(T){return z.lastIndex=0,typeof T=="string"&&z.test(T)?F:null}}catch(z){return r}}function C(F,z,T){return!F||typeof z!="string"?!1:G(F)(z,void 0,T)}e.match=C;function G(F,z={}){if(!F)return s;if(typeof F=="string"||Q(F)){const T=a(F,z);if(T===r)return s;const A=function(O,j){return!!T(O,j)};return T.allBasenames&&(A.allBasenames=T.allBasenames),T.allPaths&&(A.allPaths=T.allPaths),A}return W(F,z)}e.parse=G;function x(F){if(!F)return;let z;return T=>(z||(z=(F()||Promise.resolve([])).then(A=>A?K(A):{})),z.then(A=>!!A[T]))}e.hasSiblingPromiseFn=x;function ne(F){if(!F)return;let z;return T=>{if(!z){const A=F();z=A?K(A):{}}return!!z[T]}}e.hasSiblingFn=ne;function K(F){const z={};for(const T of F)z[T]=!0;return z}function Q(F){const z=F;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}e.isRelativePattern=Q;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function $(F){return F.allPaths||[]}e.getPathTerms=$;function W(F,z){const T=B(Object.getOwnPropertyNames(F).map(q=>N(q,F[q],z)).filter(q=>q!==r)),A=T.length;if(!A)return r;if(!T.some(q=>!!q.requiresSiblings)){if(A===1)return T[0];const q=function(se,ae){for(let de=0,re=T.length;de<re;de++){const ce=T[de](se,ae);if(ce)return ce}return null},X=T.find(se=>!!se.allBasenames);X&&(q.allBasenames=X.allBasenames);const ie=T.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return ie.length&&(q.allPaths=ie),q}const O=function(q,X,ie){let se;for(let ae=0,de=T.length;ae<de;ae++){const re=T[ae];re.requiresSiblings&&ie&&(X||(X=M.basename(q)),se||(se=X.substr(0,X.length-M.extname(q).length)));const ce=re(q,X,se,ie);if(ce)return ce}return null},j=T.find(q=>!!q.allBasenames);j&&(O.allBasenames=j.allBasenames);const Y=T.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return Y.length&&(O.allPaths=Y),O}function N(F,z,T){if(z===!1)return r;const A=a(F,T);if(A===r)return r;if(typeof z=="boolean")return A;if(z){const O=z.when;if(typeof O=="string"){const j=(Y,q,X,ie)=>{if(!ie||!A(Y,q))return null;const se=O.replace("$(basename)",X),ae=ie(se);return(0,v.isThenable)(ae)?ae.then(de=>de?F:null):ae?F:null};return j.requiresSiblings=!0,j}}return A}function B(F,z){const T=F.filter(q=>!!q.basenames);if(T.length<2)return F;const A=T.reduce((q,X)=>{const ie=X.basenames;return ie?q.concat(ie):q},[]);let O;if(z){O=[];for(let q=0,X=A.length;q<X;q++)O.push(z)}else O=T.reduce((q,X)=>{const ie=X.patterns;return ie?q.concat(ie):q},[]);const j=function(q,X){if(typeof q!="string")return null;if(!X){let se;for(se=q.length;se>0;se--){const ae=q.charCodeAt(se-1);if(ae===47||ae===92)break}X=q.substr(se)}const ie=A.indexOf(X);return ie!==-1?O[ie]:null};j.basenames=A,j.patterns=O,j.allBasenames=A;const Y=F.filter(q=>!q.basenames);return Y.push(j),Y}}),define(J[31],Z([0,1,29,10,8,3,15,23,7]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(a,c,p){if(typeof a=="string"&&(a=f.URI.file(a)),p){const D=p.getWorkspaceFolder(a);if(D){const R=p.getWorkspace().folders.length>1;let _;if((0,I.isEqual)(D.uri,a)?_="":_=(0,I.relativePath)(D.uri,a),R){const C=D.name?D.name:(0,I.basename)(D.uri);_=_?C+" \u2022 "+_:C}return _}}if(a.scheme!==L.Schemas.file&&a.scheme!==L.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(a.fsPath))return(0,k.normalize)(b(a.fsPath));let w=(0,k.normalize)(a.fsPath);return!M.isWindows&&c?.userHome&&(w=y(w,c.userHome.fsPath)),w}e.getPathLabel=m;function t(a){if(!a)return;typeof a=="string"&&(a=f.URI.file(a));const c=(0,I.basename)(a)||(a.scheme===L.Schemas.file?a.fsPath:a.path);return M.isWindows&&(0,v.isRootOrDriveLetter)(c)?b(c):c}e.getBaseLabel=t;function b(a){return(0,v.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=b;let E=Object.create(null);function y(a,c){if(M.isWindows||!a||!c)return a;let p=E.original===c?E.normalized:void 0;return p||(p=`${(0,n.rtrim)(c,k.posix.sep)}${k.posix.sep}`,E={original:c,normalized:p}),(M.isLinux?a.startsWith(p):(0,n.startsWithIgnoreCase)(a,p))&&(a=`~/${a.substr(p.length)}`),a}e.tildify=y;function d(a,c){return a.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=d;const g="\u2026",P="\\\\",S="~";function h(a,c=k.sep){const p=new Array(a.length);let w=!1;for(let D=0;D<a.length;D++){let R=a[D];if(R===""){p[D]=`.${c}`;continue}if(!R){p[D]=R;continue}w=!0;let _="";R.indexOf(P)===0?(_=R.substr(0,R.indexOf(P)+P.length),R=R.substr(R.indexOf(P)+P.length)):R.indexOf(c)===0?(_=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(S)===0&&(_=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length));const C=R.split(c);for(let G=1;w&&G<=C.length;G++)for(let x=C.length-G;w&&x>=0;x--){w=!1;let ne=C.slice(x,x+G).join(c);for(let K=0;!w&&K<a.length;K++)if(K!==D&&a[K]&&a[K].indexOf(ne)>-1){const Q=x+G===C.length,U=x>0&&a[K].indexOf(c)>-1?c+ne:ne,$=a[K].endsWith(U);w=!Q||$}if(!w){let K="";(C[0].endsWith(":")||_!=="")&&(x===1&&(x=0,G++,ne=C[0]+c+ne),x>0&&(K=C[0]+c),K=_+K),x>0&&(K=K+g+c),K=K+ne,x+G<C.length&&(K=K+c+g),p[D]=K}}w&&(p[D]=R)}return p}e.shorten=h;var u;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function o(a,c=Object.create(null)){const p=[];let w=!1,D="";for(const R of a)if(R==="$"||w&&R==="{")D&&p.push({value:D,type:u.TEXT}),D="",w=!0;else if(R==="}"&&w){const _=c[D];if(typeof _=="string")_.length&&p.push({value:_,type:u.VARIABLE});else if(_){const C=p[p.length-1];(!C||C.type!==u.SEPARATOR)&&p.push({value:_.label,type:u.SEPARATOR})}D="",w=!1}else D+=R;return D&&!w&&p.push({value:D,type:u.TEXT}),p.filter((R,_)=>{if(R.type===u.SEPARATOR){const C=p[_-1],G=p[_+1];return[C,G].every(x=>x&&(x.type===u.VARIABLE||x.type===u.TEXT)&&x.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function l(a,c){return M.isMacintosh||c?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):a.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function i(a,c){return M.isMacintosh||c?a.replace(/\(&&\w\)|&&/g,""):M.isWindows?a.replace(/&&|&/g,p=>p==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const c=a.indexOf("/")!==-1?k.posix:k.win32,p=c.basename(a),w=c.dirname(a);return p.length?{name:p,parentPath:w}:{name:w,parentPath:""}}e.splitName=r}),define(J[28],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return v.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(f){for(let m=0;m<f.length;m++)f[m]=Math.floor(Math.random()*256);return f};function n(){I(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,m="";return m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m}e.generateUuid=n}),define(J[112],Z([0,1,58,30,43]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(I,n){if(await new Promise((t,b)=>{const E=L.createReadStream(I),y=v.createHash("sha1");E.pipe(y);const d=(0,k.once)((g,P)=>{E.removeAllListeners(),y.removeAllListeners(),g?b(g):t(P)});E.once("error",d),E.once("end",d),y.once("error",d),y.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(J[79],Z([0,1,239]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new v.StringDecoder(M),this.remaining=null}write(M){const I=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return I;let f=0,m,t=f;for(;t<n.length;)if(m=n.charCodeAt(t),m===13||m===10){if(I.push(n.substring(f,t)),t++,t<n.length){const b=m;m=n.charCodeAt(t),(b===13&&m===10||b===10&&m===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,I}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const m=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await I())}catch(t){f(t)}finally{clearTimeout(m)}})}e.getMac=M;function I(){return new Promise((n,f)=>{try{const m=(0,v.networkInterfaces)();for(let t in m){const b=m[t];if(b){for(const{mac:E}of b)if(k(E))return n(E)}}f("Unable to retrieve mac address (unexpected format)")}catch(m){f(m)}})}}),define(J[66],Z([0,1,26,16,37,28,113]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,b=0;const E=(0,v.networkInterfaces)();for(let y in E){const d=E[y];if(d)for(const{mac:g,internal:P}of d)P||(b+=1,this._isVirtualMachineMacAdress(g.toUpperCase())&&(t+=1))}this._value=b>0?t/b:0}return this._value}};let n;async function f(){return n||(n=(async()=>await m()||M.generateUuid())()),n}e.getMachineId=f;async function m(){try{const t=await new Promise((E,y)=>{V(["crypto"],E,y)}),b=await(0,I.getMac)();return t.createHash("sha256").update(b,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(J[18],Z([0,1,30,26,114,9,29,65,8,3,15,7,28]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(U,$=y.UNLINK){if((0,I.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return $===y.UNLINK?P(U):g(U)}async function g(U){try{const $=(0,f.join)((0,L.tmpdir)(),(0,E.generateUuid)());try{await e.Promises.rename(U,$)}catch(W){return P(U)}P($).catch(W=>{})}catch($){if($.code!=="ENOENT")throw $}}async function P(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function S(U){if((0,I.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(U,{recursive:!0})}e.rimrafSync=S;async function h(U,$){return l(await($?u(U):(0,k.promisify)(v.readdir)(U)))}async function u(U){try{return await(0,k.promisify)(v.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],W=await h(U);for(const N of W){let B=!1,F=!1,z=!1;try{const T=await e.Promises.lstat((0,f.join)(U,N));B=T.isFile(),F=T.isDirectory(),z=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}$.push({name:N,isFile:()=>B,isDirectory:()=>F,isSymbolicLink:()=>z})}return $}function o(U){return l(v.readdirSync(U))}e.readdirSync=o;function l(U){return U.map($=>typeof $=="string"?m.isMacintosh?(0,n.normalizeNFC)($):$:($.name=m.isMacintosh?(0,n.normalizeNFC)($.name):$.name,$))}async function i(U){const $=await h(U),W=[];for(const N of $)await r.existsDirectory((0,f.join)(U,N))&&W.push(N);return W}function s(U,$=1e3){return new Promise(W=>{let N=!1;const B=setInterval(()=>{N||(N=!0,v.access(U,F=>{N=!1,F&&(clearInterval(B),W(void 0))}))},$)})}e.whenDeleted=s;var r;(function(U){async function $(B){let F;try{if(F=await e.Promises.lstat(B),!F.isSymbolicLink())return{stat:F}}catch(z){}try{return{stat:await e.Promises.stat(B),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(m.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw T}throw z}}U.stat=$;async function W(B){try{const{stat:F,symbolicLink:z}=await U.stat(B);return F.isFile()&&z?.dangling!==!0}catch(F){}return!1}U.existsFile=W;async function N(B){try{const{stat:F,symbolicLink:z}=await U.stat(B);return F.isDirectory()&&z?.dangling!==!0}catch(F){}return!1}U.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new M.ResourceQueue;function c(U,$,W){return a.queueFor(b.URI.file(U),t.extUriBiasedIgnorePathCase).queue(()=>{const N=R(W);return new Promise((B,F)=>w(U,$,N,z=>z?F(z):B()))})}let p=!0;function w(U,$,W,N){if(!p)return v.writeFile(U,$,{mode:W.mode,flag:W.flag},N);v.open(U,W.flag,W.mode,(B,F)=>{if(B)return N(B);v.writeFile(F,$,z=>{if(z)return v.close(F,()=>N(z));v.fdatasync(F,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),p=!1),v.close(F,A=>N(A))))})})}function D(U,$,W){const N=R(W);if(!p)return v.writeFileSync(U,$,{mode:N.mode,flag:N.flag});const B=v.openSync(U,N.flag,N.mode);try{v.writeFileSync(B,$);try{v.fdatasyncSync(B)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),p=!1}}finally{v.closeSync(B)}}e.writeFileSync=D;function R(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function _(U,$){if(U===$)return;async function W(N){try{const B=await e.Promises.lstat(N);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(N,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(U,$),await W($)}catch(N){if(U.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await C(U,$,{preserveSymlinks:!1}),await d(U,y.MOVE),await W($);else throw N}}async function C(U,$,W){return x(U,$,{root:{source:U,target:$},options:W,handledSourcePaths:new Set})}const G=511;async function x(U,$,W){if(W.handledSourcePaths.has(U))return;W.handledSourcePaths.add(U);const{stat:N,symbolicLink:B}=await r.stat(U);if(B){if(W.options.preserveSymlinks)try{return await Q(U,$,W)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(B.dangling)return}return N.isDirectory()?ne(U,$,N.mode&G,W):K(U,$,N.mode&G)}async function ne(U,$,W,N){await e.Promises.mkdir($,{recursive:!0,mode:W});const B=await h(U);for(const F of B)await x((0,f.join)(U,F),(0,f.join)($,F),N)}async function K(U,$,W){await e.Promises.copyFile(U,$),await e.Promises.chmod($,W)}async function Q(U,$,W){let N=await e.Promises.readlink(U);(0,I.isEqualOrParent)(N,W.root.source,!m.isLinux)&&(N=(0,f.join)(W.root.target,N.substr(W.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(0,k.promisify)(v.read)}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(0,k.promisify)(v.write)}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return i}get writeFile(){return c}get rm(){return d}get move(){return _}get copy(){return C}}}),define(J[80],Z([0,1,30,8,23,18]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(t){const b=(0,L.dirname)(t);if(t===b)return t;const E=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,M.readdirSync)(b).filter(g=>g.toLowerCase()===E);if(d.length===1){const g=I(b);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(E);if(g>=0){const P=I(b);if(P)return(0,L.join)(P,d[g])}}}catch(y){}return null}e.realcaseSync=I;async function n(t){try{return await M.Promises.realpath(t)}catch(b){const E=m(t);return await M.Promises.access(E,v.constants.R_OK),E}}e.realpath=n;function f(t){try{return v.realpathSync(t)}catch(b){const E=m(t);return v.accessSync(E,v.constants.R_OK),E}}e.realpathSync=f;function m(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(J[115],Z([0,1,59]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,m){let t=!1;return new Promise(b=>{const E=setTimeout(()=>{if(!t)return t=!0,b(0)},m);k(n,f,y=>{if(!t)return t=!0,clearTimeout(E),b(y)})})}e.findFreePort=L;function k(n,f,m){if(f===0)return m(0);const t=new v.Socket;t.once("connect",()=>(I(t),k(n+1,f-1,m))),t.once("data",()=>{}),t.once("error",b=>(I(t),b.code!=="ECONNREFUSED"?k(n+1,f-1,m):m(n))),t.connect(n,"127.0.0.1")}function M(n,f,m){let t=!1,b,E=1;const y=v.createServer({pauseOnConnect:!0});function d(g,P){t||(t=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),P(g))}return new Promise(g=>{b=setTimeout(()=>{d(0,g)},m),y.on("listening",()=>{d(n,g)}),y.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&E<f?(n++,E++,y.listen(n,"127.0.0.1")):d(0,g)}),y.on("close",()=>{d(0,g)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function I(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(J[116],Z([0,1,26,8,18]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,I=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class b{constructor(l,i,s){this.exePath=l,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?m===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:l=!1}={}){const i=E({useAlternateBitness:o});if(!i)return null;const s=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let r=-1,a=null;for(const w of await k.Promises.readdir(s)){let D=-1;if(l){const _=w.indexOf("-");if(_<0)continue;const C=w.substring(0,_);if(!M.test(C)||w.substring(_+1)!=="preview")continue;D=parseInt(C,10)}else{if(!M.test(w))continue;D=parseInt(w,10)}if(D<=r)continue;const R=L.join(s,w,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(a=R,r=D)}if(!a)return null;const c=i.includes("x86")?" (x86)":"",p=l?" Preview":"";return new b(a,`PowerShell${p}${c}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const l=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(l))if(i.test(r)){const a=L.join(l,r,"pwsh.exe");return new b(a,s)}return null}function g(){const o=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new b(o,".NET Core PowerShell Global Tool")}function P(){const o=L.join(process.env.windir,m===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(o,"Windows PowerShell",!0)}async function*S(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=g(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=P(),o&&(yield o)}async function*h(){for await(const o of S())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=h;async function u(){for await(const o of h())return o;return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[81],Z([0,1,41,10]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(I){return new Promise((n,f)=>{let m;const t=new Map;function b(y,d,g,P,S){const h=t.get(d);if(y===I||h){const u={name:E(g),cmd:g,pid:y,ppid:d,load:P,mem:S};t.set(y,u),y===I&&(m=u),h&&(h.children||(h.children=[]),h.children.push(u),h.children.length>1&&(h.children=h.children.sort((o,l)=>o.pid-l.pid)))}}function E(y){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,S=/\\pipe\\winpty-control/,h=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"watcherService ";if(P.exec(y))return"electron-crash-reporter";if(S.exec(y))return"winpty-process";if(h.exec(y))return"console-window-host (Windows internal process)";let o=u.exec(y);if(o&&o.length===2)return o[1]==="renderer"?d.exec(y)?"shared-process":"window":o[1];const l=/[a-zA-Z-]+\.js/g;let i="";do o=l.exec(y),o&&(i+=o+" ");while(o);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{V(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(I,g=>{d.getProcessCpuUsage(g,P=>{const S=new Map;P.forEach(h=>{const u=y(h.commandLine||"");S.set(h.pid,{name:E(u),cmd:u,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),m=S.get(I),m?(S.forEach(h=>{const u=S.get(h.ppid);u&&(u.children||(u.children=[]),u.children.push(h))}),S.forEach(h=>{h.children&&(h.children=h.children.sort((u,o)=>u.pid-o.pid))}),n(m)):f(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[m];const g=[];for(;d.length;){const S=d.shift();S&&(g.push(S.pid),S.children&&(d=d.concat(S.children)))}let P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);P+=" "+g.join(" "),(0,v.exec)(P,{},(S,h,u)=>{if(S||u)f(S||new Error(u.toString()));else{const o=h.toString().split(`
`);for(let l=0;l<g.length;l++){const i=t.get(g[l]);i.load=parseFloat(o[l])}if(!m){f(new Error(`Root process ${I} not found`));return}n(m)}})};(0,v.exec)("which ps",{},(d,g,P)=>{if(d||P)if(process.platform!=="linux")f(d||new Error(P.toString()));else{const S=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,v.exec)(S,{},(h,u,o)=>{h||o?f(h||new Error(o.toString())):(M(u,b),y())})}else{const S=g.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${S} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,o,l)=>{u||l&&!l.includes("screen size is bogus")?f(u||new Error(l.toString())):(M(o,b),process.platform==="linux"?y():m?n(m):f(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=k;function M(I,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=I.toString().split(`
`);for(const t of m){const b=f.exec(t.trim());b&&b.length===6&&n(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(J[117],Z([0,1,30,29,2,65,8,3,18]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function m(E,y,d){return b({path:E,isDirectory:!1},y,d)}e.watchFile=m;function t(E,y,d){return b({path:E,isDirectory:!0},y,d)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function b(E,y,d){if(n.isMacintosh&&(0,L.isEqualOrParent)(E.path,"/Volumes/"))return d(`Refusing to watch ${E.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=(0,I.basename)(E.path),P=new Map;let S=!1,h=[(0,k.toDisposable)(()=>{P.forEach(u=>(0,k.dispose)(u)),P.clear()})];try{const u=(0,v.watch)(E.path);h.push((0,k.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const o=new Set;E.isDirectory&&f.Promises.readdir(E.path).then(l=>l.forEach(i=>o.add(i))),u.on("error",(l,i)=>{S||d(`Failed to watch ${E.path} for changes using fs.watch() (${l}, ${i})`)}),u.on("change",(l,i)=>{if(S)return;let s="";if(i&&(s=i.toString(),n.isMacintosh&&(s=(0,M.normalizeNFC)(s))),!s||l!=="change"&&l!=="rename")return;const r=E.isDirectory?(0,I.join)(E.path,s):E.path;if(E.isDirectory)if(l==="rename"){const a=P.get(r);a&&(0,k.dispose)(a);const c=setTimeout(async()=>{P.delete(r);const p=await f.Promises.exists(r);if(S)return;let w;p?o.has(s)?w="changed":(w="added",o.add(s)):(o.delete(s),w="deleted"),y(w,r)},e.CHANGE_BUFFER_DELAY);P.set(r,(0,k.toDisposable)(()=>clearTimeout(c)))}else{let a;o.has(s)?a="changed":(a="added",o.add(s)),y(a,r)}else if(l==="rename"||s!==g){const a=setTimeout(async()=>{const c=await f.Promises.exists(r);S||(c?(y("changed",r),h=[b(E,y,d)]):y("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(h),h=[(0,k.toDisposable)(()=>clearTimeout(a))]}else y("changed",r)})}catch(u){f.Promises.exists(E.path).then(o=>{o&&!S&&d(`Failed to watch ${E.path} for changes using fs.watch() (${u.toString()})`)})}return(0,k.toDisposable)(()=>{S=!0,h=(0,k.dispose)(h)})}}),define(J[118],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,13,118]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){v.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,m,t,b)=>{const E=I(n,t,m);E.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{E&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function I(n,f,m){const t=new v.Menu;return m.forEach(b=>{let E;b.type==="separator"?E=new v.MenuItem({type:b.type}):Array.isArray(b.submenu)?E=new v.MenuItem({submenu:I(n,f,b.submenu),label:b.label}):E=new v.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,d,g)=>n.sender.send(f,b.id,g)}),t.append(E)}),t}});var he=this&&this.__decorate||function(V,e,v,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,v,L);else for(var n=V.length-1;n>=0;n--)(I=V[n])&&(M=(k<3?I(M):k>3?I(e,v,M):I(e,v))||M);return k>3&&M&&Object.defineProperty(e,v,M),M};define(J[34],Z([0,1,36,9,17,25,46,16,5,2,110,23,13]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function P(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(S||(S={}));class h{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class u{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(o||(o={}));function l(B){const F=k.VSBuffer.alloc(4);return F.writeUInt32BE(B,0),F}function i(B){return B.read(4).readUInt32BE(0)}function s(B){const F=k.VSBuffer.alloc(1);return F.writeUInt8(B,0),F}const r={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},a=typeof Buffer!="undefined";function c(B,F){if(typeof F=="undefined")B.write(r.Undefined);else if(typeof F=="string"){const z=k.VSBuffer.fromString(F);B.write(r.String),B.write(l(z.byteLength)),B.write(z)}else if(a&&Buffer.isBuffer(F)){const z=k.VSBuffer.wrap(F);B.write(r.Buffer),B.write(l(z.byteLength)),B.write(z)}else if(F instanceof k.VSBuffer)B.write(r.VSBuffer),B.write(l(F.byteLength)),B.write(F);else if(Array.isArray(F)){B.write(r.Array),B.write(l(F.length));for(const z of F)c(B,z)}else{const z=k.VSBuffer.fromString(JSON.stringify(F));B.write(r.Object),B.write(l(z.byteLength)),B.write(z)}}function p(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(i(B)).toString();case o.Buffer:return B.read(i(B)).buffer;case o.VSBuffer:return B.read(i(B));case o.Array:{const z=i(B),T=[];for(let A=0;A<z;A++)T.push(p(B));return T}case o.Object:return JSON.parse(B.read(i(B)).toString())}}class w{constructor(F,z,T=null,A=1e3){this.protocol=F,this.ctx=z,this.logger=T,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger&&this.logger.logOutgoing(z,0,1,P(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(z,F.id,1,P(F.type),F.data);return}}}send(F,z=void 0){const T=new u;return c(T,F),c(T,z),this.sendBuffer(T.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(z){return 0}}onRawMessage(F){const z=new h(F),T=p(z),A=p(z),O=T[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,A),this.onPromise({type:O,id:T[1],channelName:T[2],name:T[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,A),this.onEventListen({type:O,id:T[1],channelName:T[2],name:T[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const T=new M.CancellationTokenSource;let A;try{A=z.call(this.ctx,F.name,F.arg,T.token)}catch(Y){A=Promise.reject(Y)}const O=F.id;A.then(Y=>{this.sendResponse({id:O,data:Y,type:201}),this.activeRequests.delete(F.id)},Y=>{Y instanceof Error?this.sendResponse({id:O,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:O,data:Y,type:203}),this.activeRequests.delete(F.id)});const j=(0,m.toDisposable)(()=>T.cancel());this.activeRequests.set(F.id,j)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const T=F.id,O=z.listen(this.ctx,F.name,F.arg)(j=>this.sendResponse({id:T,data:j,type:204}));this.activeRequests.set(F.id,O)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const T=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:T})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const T of z)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=z}getChannel(F){const z=this;return{call(T,A,O){return z.isDisposed?Promise.reject(n.canceled()):z.requestPromise(F,T,A,O)},listen(T,A){return z.isDisposed?Promise.reject(n.canceled()):z.requestEvent(F,T,A)}}}requestPromise(F,z,T,A=M.CancellationToken.None){const O=this.lastRequestId++,Y={id:O,type:100,channelName:F,name:z,arg:T};if(A.isCancellationRequested)return Promise.reject(n.canceled());let q;return new Promise((ie,se)=>{if(A.isCancellationRequested)return se(n.canceled());const ae=()=>{const Ee=ve=>{switch(ve.type){case 201:this.handlers.delete(O),ie(ve.data);break;case 202:this.handlers.delete(O);const be=new Error(ve.data.message);be.stack=ve.data.stack,be.name=ve.data.name,se(be);break;case 203:this.handlers.delete(O),se(ve.data);break}};this.handlers.set(O,Ee),this.sendRequest(Y)};let de=null;this.state===S.Idle?ae():(de=(0,L.createCancelablePromise)(Ee=>this.whenInitialized()),de.then(()=>{de=null,ae()}));const re=()=>{de?(de.cancel(),de=null):this.sendRequest({id:O,type:101}),se(n.canceled())},ce=A.onCancellationRequested(re);q=(0,m.combinedDisposable)((0,m.toDisposable)(re),ce),this.activeRequests.add(q)}).finally(()=>{this.activeRequests.delete(q)})}requestEvent(F,z,T){const A=this.lastRequestId++,j={id:A,type:102,channelName:F,name:z,arg:T};let Y=null;const q=new f.Emitter({onFirstListenerAdd:()=>{Y=(0,L.createCancelablePromise)(ie=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(q),this.sendRequest(j)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(q),this.sendRequest({id:A,type:103}))}}),X=ie=>q.fire(ie.data);return this.handlers.set(A,X),q.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(z,F.id,0,`${d(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(z,F.id,0,d(F.type));return}}}send(F,z=void 0){const T=new u;return c(T,F),c(T,z),this.sendBuffer(T.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(z){return 0}}onBuffer(F){const z=new h(F),T=p(z),A=p(z),O=T[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,P(O)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,T[1],0,P(O),A),this.onResponse({type:T[0],id:T[1],data:A})}}onResponse(F){if(F.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(F.id);z&&z(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}he([I.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class _{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:T})=>{f.Event.once(z.onMessage)(O=>{const j=new h(O),Y=p(j),q=new w(z,Y),X=new R(z);this.channels.forEach((se,ae)=>q.registerChannel(ae,se));const ie={channelServer:q,channelClient:X,ctx:Y};this._connections.add(ie),this._onDidAddConnection.fire(ie),T(()=>{q.dispose(),X.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}getChannel(F,z){const T=this;return{call(A,O,j){let Y;if((0,E.isFunction)(z)){let X=(0,v.getRandomElement)(T.connections.filter(z));Y=X?Promise.resolve(X):f.Event.toPromise(f.Event.filter(T.onDidAddConnection,z))}else Y=z.routeCall(T,A,O);const q=Y.then(X=>X.channelClient.getChannel(F));return G(q).call(A,O,j)},listen(A,O){if((0,E.isFunction)(z))return T.getMulticastEvent(F,z,A,O);const j=z.routeEvent(T,A,O).then(Y=>Y.channelClient.getChannel(F));return G(j).listen(A,O)}}}getMulticastEvent(F,z,T,A){const O=this;let j=new m.DisposableStore;const Y=new f.Emitter({onFirstListenerAdd:()=>{j=new m.DisposableStore;const q=new f.EventMultiplexer,X=new Map,ie=ae=>{const re=ae.channelClient.getChannel(F).listen(T,A),ce=q.add(re);X.set(ae,ce)},se=ae=>{const de=X.get(ae);!de||(de.dispose(),X.delete(ae))};O.connections.filter(z).forEach(ie),f.Event.filter(O.onDidAddConnection,z)(ie,void 0,j),O.onDidRemoveConnection(se,void 0,j),q.event(Y.fire,Y,j),j.add(q)},onLastListenerRemove:()=>{j.dispose()}});return Y.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach(T=>{T.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class C{constructor(F,z,T=null){const A=new u;c(A,z),F.send(A.buffer),this.channelClient=new R(F,T),this.channelServer=new w(F,z,T)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function G(B){return{call(F,z,T){return B.then(A=>A.call(F,z,T))},listen(F,z){const T=new f.Relay;return B.then(A=>T.input=A.listen(F,z)),T.event}}}e.getDelayedChannel=G;function x(B){let F=!1;return{call(z,T,A){return F?B.call(z,T,A):(0,L.timeout)(0).then(()=>F=!0).then(()=>B.call(z,T,A))},listen(z,T){if(F)return B.listen(z,T);const A=new f.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>A.input=B.listen(z,T)),A.event}}}e.getNextTickChannel=x;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await f.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ne;var K;(function(B){function F(A,O){const j=A,Y=O&&O.disableMarshalling,q=new Map;for(const X in j)T(X)&&q.set(X,f.Event.buffer(j[X],!0));return new class{listen(X,ie){const se=q.get(ie);if(se)return se;throw new Error(`Event not found: ${ie}`)}call(X,ie,se){const ae=j[ie];if(typeof ae=="function"){if(!Y&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,t.revive)(se[de]);return ae.apply(j,se)}throw new Error(`Method not found: ${ie}`)}}}B.fromService=F;function z(A,O){const j=O&&O.disableMarshalling;return new Proxy({},{get(Y,q){if(typeof q=="string")return O?.properties?.has(q)?O.properties.get(q):T(q)?A.listen(q):async function(...X){let ie;O&&!(0,E.isUndefinedOrNull)(O.context)?ie=[O.context,...X]:ie=X;const se=await A.call(q,ie);return j?se:(0,t.revive)(se)};throw new Error(`Property not found: ${String(q)}`)}})}B.toService=z;function T(A){return A[0]==="o"&&A[1]==="n"&&b.isUpperAsciiLetter(A.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let F=B.toString();if(F!=="[object Object]")return F}return B}function $(B){return Array.isArray(B)?B.map(U):U(B)}function W(B,F,z,T,A,O,j){j=$(j);const Y=Q[A],q=Y[T%Y.length];let X=[`%c[${B}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(O)?(X=X.concat(j),X.push(")")):X.push(j),console.log.apply(console,X)}e.logWithColors=W;class N{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,T,A,O){this._totalOutgoing+=F,W(this._outgoingPrefix,this._totalOutgoing,F,z,T,A,O)}logIncoming(F,z,T,A,O){this._totalIncoming+=F,W(this._incomingPrefix,this._totalIncoming,F,z,T,A,O)}}e.IPCLogger=N}),define(J[120],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(J[121],Z([0,1,17,5,34]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class I extends k.IPCClient{constructor(f,m){const t=new M(f);super(t,m);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=I}),define(J[82],Z([0,1,17,5,2,3,33,34]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function t(){return m||(m=v.VSBuffer.alloc(0)),m}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,c){if(a===0)return t();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const R=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=a),R}if(this._chunks[0].byteLength>a){const R=this._chunks[0].slice(0,a);return c&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),R}let p=v.VSBuffer.alloc(a),w=0,D=0;for(;a>0;){const R=this._chunks[D];if(R.byteLength>a){const _=R.slice(0,a);p.set(_,w),w+=a,c&&(this._chunks[D]=R.slice(a),this._totalLength-=a),a-=a}else p.set(R,w),w+=R.byteLength,c?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,a-=R.byteLength}return p}}e.ChunkStream=b;var E;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(a,c,p,w){this.type=a,this.id=c,this.ack=p,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(a){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const p=this._state.messageType,w=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(p,w,D,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=v.VSBuffer.alloc(13);c.writeUInt8(a.type,0),c.writeUInt32BE(a.id,1),c.writeUInt32BE(a.ack,5),c.writeUInt32BE(a.data.byteLength,9),this._writeSoon(c,a.data)}_bufferAdd(a,c){const p=this._totalLength===0;return this._data.push(a,c),this._totalLength+=a.byteLength+c.byteLength,p}_bufferTake(){const a=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,c){this._bufferAdd(a,c)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends k.Disposable{constructor(a){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new d(1,0,0,a))}}e.Protocol=S;class h extends n.IPCClient{constructor(a,c,p=null){super(a,c,p);this.protocol=a}static fromSocket(a,c){return new h(new S(a),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=h;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class o{constructor(a){this.data=a,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],c=0,p=this._first;for(;p;)a[c++]=p.data,p=p.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const c=new o(a);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class i{constructor(){this.lastRuns=[];const a=Date.now();for(let c=0;c<i._HISTORY_LENGTH;c++)this.lastRuns[c]=a-1e3*c;setInterval(()=>{for(let c=i._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const a=Date.now(),c=(1+i._HISTORY_LENGTH)*1e3;let p=0;for(let w=0;w<i._HISTORY_LENGTH;w++)a-this.lastRuns[w]<=c&&p++;return 1-p/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class s{constructor(a,c=null){this._loadEstimator=i.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new d(5,0,0,t());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const c=new d(4,0,0,t());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let c=0,p=a.length;c<p;c++)this._socketWriter.write(a[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const c=this._outgoingUnackMsg.toArray();for(let p=0,w=c.length;p<w;p++)this._socketWriter.write(c[p]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new d(1,c,this._incomingAckId,a);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(a){const c=new d(2,0,0,a);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const a=this._outgoingUnackMsg.peek(),c=Date.now()-a.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new d(3,0,this._incomingAckId,t());this._socketWriter.write(a)}}e.PersistentProtocol=s}),define(J[122],Z([0,1,14,17,5,2,34,120]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,b){const E=k.Event.fromNodeEventEmitter(v.ipcMain,b,(d,g)=>({event:d,message:g})),y=k.Event.filter(E,({event:d})=>d.sender.id===t);return k.Event.map(y,({message:d})=>d&&L.VSBuffer.wrap(d))}class m extends I.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const b=k.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return k.Event.map(b,E=>{const y=E.id,d=m.Clients.get(y);d&&d.dispose();const g=new k.Emitter;m.Clients.set(y,(0,M.toDisposable)(()=>g.fire()));const P=f(y,"vscode:message"),S=k.Event.any(k.Event.signal(f(y,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(E,P),onDidClientDisconnect:S}})}}e.Server=m,m.Clients=new Map}),define(J[83],Z([0,1,14,5,28,121]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends M.Client{constructor(m,t){super({addEventListener:(b,E)=>m.addListener(b,E),removeEventListener:(b,E)=>m.removeListener(b,E),postMessage:b=>m.postMessage(b),start:()=>m.start(),close:()=>m.close()},t)}}e.Client=I;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",m);const t=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,y)=>({nonce:y,port:E.ports[0]})),{port:b}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,E=>E.nonce===m)));return b}e.connect=n}),define(J[84],Z([0,1,9,5,2,13]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var I;(function(t){t[t.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));var n;(function(t){t[t.None=0]="None",t[t.Initialized=1]="Initialized",t[t.Closed=2]="Closed"})(n||(n={}));class f extends k.Disposable{constructor(b,E=Object.create(null)){super();this.database=b,this.options=E,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((E,y)=>this.accept(y,E)),b.deleted?.forEach(E=>this.accept(E,void 0))}accept(b,E){if(this.state===n.Closed)return;let y=!1;(0,M.isUndefinedOrNull)(E)?y=this.cache.delete(b):this.cache.get(b)!==E&&(this.cache.set(b,E),y=!0),y&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,E){const y=this.cache.get(b);return(0,M.isUndefinedOrNull)(y)?E:y}getBoolean(b,E){const y=this.get(b);return(0,M.isUndefinedOrNull)(y)?E:y==="true"}getNumber(b,E){const y=this.get(b);return(0,M.isUndefinedOrNull)(y)?E:parseInt(y,10)}async set(b,E){if(this.state===n.Closed)return;if((0,M.isUndefinedOrNull)(E))return this.delete(b);const y=String(E);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===n.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((E,y)=>this.items.set(y,E)),b.delete&&b.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=m}),define(J[123],Z([0,1,9,5,37,8,18]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,b=Object.create(null)){this.path=t,this.options=b,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,b=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(y=>b.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(t){const b=await this.whenConnected;return this.doUpdateItems(b,t)}doUpdateItems(t,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,k.mapToString)(b.insert):"0"}), delete(${b.delete?(0,k.setToString)(b.delete):"0"})`),this.transaction(t,()=>{const E=b.insert,y=b.delete;if(E&&E.size>0){const d=[];d.push([]);let g=0;E.forEach((P,S)=>{let h=d[g];h.length>n.MAX_HOST_PARAMETERS&&(g++,h=[],d.push(h)),h.push(S,P)}),d.forEach(P=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,S=>S.run(P),()=>{const S=[];let h=0;return E.forEach((u,o)=>{S.push(o),h+=u.length}),`Keys: ${S.join(", ")} Length: ${h}`})})}if(y&&y.size){const d=[];d.push([]);let g=0;y.forEach(P=>{let S=d[g];S.length>n.MAX_HOST_PARAMETERS&&(g++,S=[],d.push(S)),S.push(P)}),d.forEach(P=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,S=>S.run(P),()=>{const S=[];return y.forEach(h=>{S.push(h)}),`Keys: ${S.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,t)}doClose(t,b){return new Promise((E,y)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?E():!t.isErroneous&&!t.isInMemory?this.backup().then(E,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),E())):typeof b=="function"?I.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const P=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:b()}).then(()=>P(),S=>(P(),Promise.reject(S)))})).then(E,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return I.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const b=await this.whenConnected,E=await this.get(b,t?"PRAGMA integrity_check":"PRAGMA quick_check"),y=t?E.integrity_check:E.quick_check;return b.isErroneous?`${y} (last error: ${b.lastError})`:b.isInMemory?`${y} (in-memory!)`:y}async connect(t,b=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${b})`);try{return await this.doConnect(t)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&b)return await(0,v.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await I.Promises.unlink(t);try{await I.Promises.rename(this.toBackupPath(t),t)}catch(y){}return await this.doConnect(t)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,b){t.isErroneous=!0,t.lastError=b,this.logger.error(b)}doConnect(t){return new Promise((b,E)=>{new Promise((y,d)=>{V(["vscode-sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(t,g=>g?d.db?d.db.close(()=>E(g)):E(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),P=>d.db.close(()=>E(P)))),isInMemory:t===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},E)})}exec(t,b){return new Promise((E,y)=>{t.db.exec(b,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),y(d)):E())})}get(t,b){return new Promise((E,y)=>{t.db.get(b,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),y(d)):E(g))})}all(t,b){return new Promise((E,y)=>{t.db.all(b,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),y(d)):E(g))})}transaction(t,b){return new Promise((E,y)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),b(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),y(d)):E())})})}prepare(t,b,E,y){const d=t.db.prepare(b),g=P=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${P} (${b}). Details: ${y()}`)};d.on("error",g),E(d),d.finalize(P=>{P&&g(P),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,I=M*7,n=M*30,f=M*365;function m(b,E){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,v.localize)(0,null,m(new Date().getTime()+y*1e3,!1));if(y<30)return(0,v.localize)(1,null);let d;return y<L?(d=y,E?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):y<k?(d=Math.floor(y/L),E?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):y<M?(d=Math.floor(y/k),E?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):y<I?(d=Math.floor(y/M),E?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):y<n?(d=Math.floor(y/I),E?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):y<f?(d=Math.floor(y/n),E?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(y/f),E?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=m;function t(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(J[126],Z([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,36,13,126]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(m,t){return t&&(m.stack||m.stacktrace)?k.localize(0,null,n(m),I(m.stack)||I(m.stacktrace)):n(m)}function I(m){return Array.isArray(m)?m.join(`
`):m}function n(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?k.localize(1,null,m.message):m.message||k.localize(2,null)}function f(m=null,t=!1){if(!m)return k.localize(3,null);if(Array.isArray(m)){const b=v.coalesce(m),E=f(b[0],t);return b.length>1?k.localize(4,null,E,b.length):E}if(L.isString(m))return m;if(m.detail){const b=m.detail;if(b.error)return M(b.error,t);if(b.exception)return M(b.exception,t)}return m.stack?M(m,t):m.message?m.message:k.localize(5,null)}e.toErrorMessage=f}),define(J[127],Z([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(I,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(I,n,f){if(n.length===0)return null;const m=[];for(let t=0,b=n.length;t<b;t++){const E=n[t],y=f(E);if(y===null)return null;m[t]=k(E,y,this.modifierLabels[I])}return m.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,I,n){if(I===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),I!==""&&f.push(I),f.join(n.separator)}}),define(J[129],Z([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,41,29,10,44,8,3,33,13,79,18,129]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(n.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};l&&(i.cwd=l);const s=v.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{s.once("error",a=>{r({success:!1,error:a})}),s.once("exit",(a,c)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?y(i.status):1})}else if(n.isLinux||n.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(s=>{v.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,c)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class P{constructor(l,i,s,r){if(i!==void 0&&s!==void 0&&r!==void 0)this.cmd=l,this.args=i,this.shell=s,this.options=r;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(f.env).forEach(c=>{a[c]=f.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const i=l.lastIndexOf(I.sep);return i!==-1&&(l=l.substring(i+1)),P.WellKnowCommands[l]?l:"other"}start(l){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(i=>{let s,r;const a=new Promise((c,p)=>{s=c,r=p});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=v.exec(c,this.options,(p,w,D)=>{this.childProcess=null;const R=p;R&&R.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:D.toString()}):this.handleExec(s,l,p,w,D)})}else{let c=null;const p=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,s,l,r);const D={terminated:this.terminateRequested};m.isNumber(w)&&(D.cmdCode=w),s(D)};if(this.shell&&n.isWindows){const w=M.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let D=!1,R=!1;const _=[];let C=this.ensureQuotes(this.cmd);_.push(C.value),D=C.quoted,this.args&&this.args.forEach(x=>{C=this.ensureQuotes(x),_.push(C.value),R=R&&C.quoted});const G=["/s","/c"];D?R?G.push('"'+_.join(" ")+'"'):_.length>1?G.push('"'+_[0]+'" '+_.slice(1).join(" ")):G.push('"'+_[0]+'"'):G.push(_.join(" ")),c=v.spawn(g(),G,w)}else this.cmd&&(c=v.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(m.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),c.pid&&(this.childProcess.on("close",p),this.handleSpawn(c,s,l,r,!0)))}return a})}handleClose(l,i,s,r){}ensureQuotes(l){return P.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!n.isWindows)return l(!1);const i=v.spawn(g(),["/s","/c"]);i.on("error",s=>l(!0)),i.on("exit",s=>l(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class S extends P{constructor(l,i,s,r){super(l,i,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,i,s,r,a){[r,a].forEach((c,p)=>{const w=new t.LineDecoder;w.write(c).forEach(_=>{i({line:_,source:p===0?0:1})});const R=w.end();R&&i({line:R,source:p===0?0:1})}),l({terminated:this.terminateRequested,error:s})}handleSpawn(l,i,s,r,a){const c=new t.LineDecoder,p=new t.LineDecoder;l.stdout.on("data",w=>{c.write(w).forEach(R=>s({line:R,source:0}))}),l.stderr.on("data",w=>{p.write(w).forEach(R=>s({line:R,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=p}handleClose(l,i,s,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&s({line:c,source:1})}}e.LineProcess=S;function h(o){let l=[],i=!1;const s=function(r){if(i){l.push(r);return}(!o.send(r,c=>{if(c&&console.error(c),i=!1,l.length>0){const p=l.slice(0);l=[],p.forEach(w=>s(w))}})||n.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=h;var u;(function(o){async function l(i,s,r){if(I.isAbsolute(i))return i;if(s===void 0&&(s=f.cwd()),I.dirname(i)!=="."||(r===void 0&&m.isString(f.env.PATH)&&(r=f.env.PATH.split(I.delimiter)),r===void 0||r.length===0))return I.join(s,i);async function c(p){return await b.Promises.exists(p)?!(await b.Promises.stat(p)).isDirectory():!1}for(let p of r){let w;if(I.isAbsolute(p)?w=I.join(p,i):w=I.join(s,p,i),await c(w))return w;let D=w+".com";if(await c(D)||(D=w+".exe",await c(D)))return D}return I.join(s,i)}o.findExecutable=l})(u=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(y,d){return y===1?L.isWindows?b():M.getWindowsShell(d):m(y,d)}e.getSystemShell=I;function n(y,d){return y===1?L.isWindows?E(d):M.getWindowsShell(d):m(y,d)}e.getSystemShellSync=n;let f=null;function m(y,d){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,v.userInfo)().shell}catch(P){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function b(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function E(y){if(t)return t;const d=L.isWindows&&parseFloat((0,v.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:M.getWindowsShell(y)}}),define(J[85],Z([0,1,41,9,17,25,109,16,5,2,44,3,68,34]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(S){super({send:h=>{try{process.send&&process.send(h.buffer.toString("base64"))}catch(u){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>k.VSBuffer.wrap(Buffer.from(h,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(S,h){this.modulePath=S,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new L.Delayer(u),this.child=null,this._client=null}getChannel(S){const h=this;return{call(u,o,l){return h.requestPromise(S,u,o,l)},listen(u,o){return h.requestEvent(S,u,o)}}}requestPromise(S,h,u,o=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(S),i=(0,L.createCancelablePromise)(a=>l.call(h,u,a)),s=o.onCancellationRequested(()=>i.cancel()),r=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(S,h,u){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const l=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(S).listen(h,u)(l.fire,l),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),b.isMacintosh&&h.env&&delete h.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,S,h);const u=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,I.isRemoteConsoleLog)(c)){(0,I.log)(c,`IPC Library: ${this.options.serverName}`);return}u.fire(k.VSBuffer.wrap(Buffer.from(c,"base64")))});const l=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,i=c=>this.child&&this.child.connected&&l.send(c.buffer.toString("base64")),s=u.event,r={send:i,onMessage:s};this._client=new y.ChannelClient(r);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,p)=>{process.removeListener("exit",a),this.activeRequests.forEach(w=>(0,m.dispose)(w)),this.activeRequests.clear(),c!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:p})})}return this._client}getCachedChannel(S){let h=this.channels.get(S);return h||(h=this.client.getChannel(S),this.channels.set(S,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(J[131],Z([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,f,m){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(n,f,m){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,m){this.channel.call("attach",[n,f,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,m){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},m])}}e.ExtensionHostDebugChannelClient=M}),define(J[155],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(I){this.driver=I}listen(I,n){throw new Error(`No event found: ${n}`)}call(I,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class L{constructor(I){this.channel=I}click(I,n,f){return this.channel.call("click",[I,n,f])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,n){return this.channel.call("setValue",[I,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,n){return this.channel.call("getElements",[I,n])}getElementXY(I,n,f){return this.channel.call("getElementXY",[I,n,f])}typeInEditor(I,n){return this.channel.call("typeInEditor",[I,n])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,n){return this.channel.call("writeInTerminal",[I,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=k}),define(J[156],Z([0,1,125,46,10,8,33,15,7]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(d,g,P){this._args=d,this.paths=g,this.productService=P}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=I.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.join)(d,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,M.resolve)(d):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const g=I.env.VSCODE_EXTENSIONS;if(g)return g;const P=I.env.VSCODE_PORTABLE;return P?(0,M.join)(P,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],m.prototype,"appRoot",null),he([L.memoize],m.prototype,"userHome",null),he([L.memoize],m.prototype,"userDataPath",null),he([L.memoize],m.prototype,"appSettingsHome",null),he([L.memoize],m.prototype,"tmpDir",null),he([L.memoize],m.prototype,"userRoamingDataHome",null),he([L.memoize],m.prototype,"settingsResource",null),he([L.memoize],m.prototype,"userDataSyncHome",null),he([L.memoize],m.prototype,"userDataSyncLogResource",null),he([L.memoize],m.prototype,"sync",null),he([L.memoize],m.prototype,"machineSettingsResource",null),he([L.memoize],m.prototype,"globalStorageHome",null),he([L.memoize],m.prototype,"workspaceStorageHome",null),he([L.memoize],m.prototype,"keybindingsResource",null),he([L.memoize],m.prototype,"keyboardLayoutResource",null),he([L.memoize],m.prototype,"argvResource",null),he([L.memoize],m.prototype,"snippetsHome",null),he([L.memoize],m.prototype,"isExtensionDevelopment",null),he([L.memoize],m.prototype,"untitledWorkspacesHome",null),he([L.memoize],m.prototype,"installSourcePath",null),he([L.memoize],m.prototype,"builtinExtensionsPath",null),he([L.memoize],m.prototype,"extensionsPath",null),he([L.memoize],m.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],m.prototype,"extensionDevelopmentKind",null),he([L.memoize],m.prototype,"extensionTestsLocationURI",null),he([L.memoize],m.prototype,"debugExtensionHost",null),he([L.memoize],m.prototype,"serviceMachineIdResource",null),he([L.memoize],m.prototype,"telemetryLogResource",null),he([L.memoize],m.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=m;function t(y,d){return E(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId)}e.parseExtensionHostPort=t;function b(y,d){return E(y["inspect-search"],y["inspect-brk-search"],5876,d)}e.parseSearchPort=b;function E(y,d,g,P,S){const u=Number(d||y)||(P?null:g),o=u?Boolean(!!d):!1;return{port:u,break:o,debugId:S}}}),define(J[86],Z([0,1,240,3,134]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,P=I){const S={},h=[],u=[];for(let s in g){const r=g[s];r.alias&&(S[s]=r.alias),r.type==="string"||r.type==="string[]"?(h.push(s),r.deprecates&&h.push(r.deprecates)):r.type==="boolean"&&(u.push(s),r.deprecates&&u.push(r.deprecates))}const o=v(d,{string:h,boolean:u,alias:S}),l={},i=o;l._=o._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(let s in g){const r=g[s];r.alias&&delete i[r.alias];let a=i[s];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(a||(a=i[r.deprecates]),delete i[r.deprecates]),typeof a!="undefined"&&(r.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):r.type==="string"&&Array.isArray(a)&&(a=a.pop(),P.onMultipleValues(s,a)),l[s]=a),delete i[s]}for(let s in i)P.onUnknownOption(s);return l}e.parseArgs=n;function f(d,g){let P="";return g.args&&(Array.isArray(g.args)?P=` <${g.args.join("> <")}>`:P=` <${g.args}>`),g.alias?`-${g.alias} --${d}${P}`:`--${d}${P}`}function m(d,g){let P=0,S=[];for(const l in d){const i=d[l],s=f(l,i);P=Math.max(P,s.length),S.push([s,i.description])}let h=P+2+1;if(g-h<25)return S.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let u=g-h-1,o=[];for(const l of S){let i=l[0],s=b(l[1],u),r=t(h-i.length-2);o.push("  "+i+r+s[0]);for(let a=1;a<s.length;a++)o.push(t(h)+s[a])}return o}e.formatOptions=m;function t(d){return" ".repeat(d)}function b(d,g){let P=[];for(;d.length;){let S=d.length<g?d.length:d.lastIndexOf(" ",g),h=d.slice(0,S).trim();d=d.slice(S),P.push(h)}return P}function E(d,g,P,S,h=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${P}`];o.push(""),o.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),o.push(""),h&&(L.isWindows?o.push((0,k.localize)(35,null,g)):o.push((0,k.localize)(36,null,g)),o.push(""));const l={};for(const i in S){const s=S[i];if(s.description&&s.cat){let r=l[s.cat];r||(l[s.cat]=r={}),r[i]=s}}for(let i in l){const s=i;let r=l[s];r&&(o.push(M[s]),o.push(...m(r,u)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function y(d,g){return`${d||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[157],Z([0,1,59,154,86]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,m){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1],m[2]):super.call(n,f,m)}async openExtensionDevelopmentHostWindow(n,f,m){const t=(0,k.parseArgs)(n,k.OPTIONS);t.debugRenderer=m;const b=t.extensionDevelopmentPath;if(!b)return{success:!1};let E;const y=Object.keys(f);for(let u of y){let o=f[u];o===null||(E||(E=Object.create(null)),E[u]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:t,userEnv:E});if(!m)return{success:!0};const g=d.win;if(!g)return{success:!0};const P=g.webContents.debugger;let S=P.isAttached()?Infinity:0;const h=(0,v.createServer)(u=>{S++==0&&P.attach();let o=!1;const l=r=>{o||u.write(JSON.stringify(r)+"\0")},i=(r,a,c,p)=>l({method:a,params:c,sessionId:p});g.on("close",()=>{P.removeListener("message",i),u.end(),o=!0}),P.addListener("message",i);let s=Buffer.alloc(0);u.on("data",r=>{s=Buffer.concat([s,r]);for(let a=s.indexOf(0);a!==-1;a=s.indexOf(0)){let c;try{const p=s.slice(0,a).toString("utf8");s=s.slice(a+1),c=JSON.parse(p)}catch(p){console.error("error reading cdp line",p)}P.sendCommand(c.method,c.params,c.sessionId).then(p=>l({id:c.id,sessionId:c.sessionId,result:p})).catch(p=>l({id:c.id,sessionId:c.sessionId,error:{code:0,message:p.message}}))}}),u.on("error",r=>{console.error("error on cdp pipe:",r)}),u.on("close",()=>{o=!0,--S==0&&P.detach()})});return await new Promise(u=>h.listen(0,u)),g.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function V(e,v,L,k){function M(n){const f=I(n),m=[f];return e.isAbsolute(f)||m.unshift(k),e.resolve(...m)}function I(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(b,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,L)}return{getUserDataPath:M}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,33]),function(e,v,L,k,M,I){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return V(v,L,f.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=V(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,156,158]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(J[161],Z([0,1,30,26,8]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(I){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),I&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){I&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(J[162],Z([0,1,137]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(E){return E=E.trim(),E==="*"||L.test(E)}e.isValidVersionStr=M;function I(E){if(!M(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=E.match(L);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=I;function n(E){if(!E)return null;let y=E.majorBase,d=E.majorMustEqual,g=E.minorBase,P=E.minorMustEqual,S=E.patchBase,h=E.patchMustEqual;E.hasCaret&&(y===0||(P=!1),h=!1);let u=0;if(E.preRelease){const o=k.exec(E.preRelease);if(o){const[,l,i,s]=o;u=Date.UTC(Number(l),Number(i)-1,Number(s))}}return{majorBase:y,majorMustEqual:d,minorBase:g,minorMustEqual:P,patchBase:S,patchMustEqual:h,isMinimum:E.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function f(E,y,d){let g;typeof E=="string"?g=n(I(E)):g=E;let P;y instanceof Date?P=y.getTime():typeof y=="string"&&(P=new Date(y).getTime());let S;if(typeof d=="string"?S=n(I(d)):S=d,!g||!S)return!1;let h=g.majorBase,u=g.minorBase,o=g.patchBase,l=S.majorBase,i=S.minorBase,s=S.patchBase,r=S.notBefore,a=S.majorMustEqual,c=S.minorMustEqual,p=S.patchMustEqual;return S.isMinimum?h>l?!0:h<l?!1:u>i?!0:u<i||P&&P<r?!1:o>=s:(h===1&&l===0&&(!a||!c||!p)&&(l=1,i=0,s=0,a=!0,c=!1,p=!1),h<l?!1:h>l?!a:u<i?!1:u>i?!c:o<s?!1:o>s?!p:!(P&&P<r))}e.isValidVersion=f;function m(E,y,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:b(E,y,d.engines.vscode,g)}e.isValidExtensionVersion=m;function t(E,y,d){return E==="*"||b(y,d,E)}e.isEngineValid=t;function b(E,y,d,g=[]){let P=n(I(d));if(!P)return g.push(v.localize(0,null,d)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return g.push(v.localize(1,null,d)),!1}else if(!P.majorMustEqual)return g.push(v.localize(2,null,d)),!1;return f(E,y,P)?!0:(g.push(v.localize(3,null,E,d)),!1)}}),define(J[163],Z([0,1,2,10,34,85]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,m,t,b){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=t,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(J[164],Z([0,1,2,10,34,85]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,m,t,b,E={}){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=t,this.verboseLogging=b,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,111,10,79]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(f,m,t,b,E){this.watchedFolder=f,this.eventCallback=t,this.logCallback=b,this.verboseLogging=E,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(y=>(0,L.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${m.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,v.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",V).fsPath,f);const m=new M.LineDecoder;this.handle.stdout.on("data",t=>{const b=[];for(const E of m.write(t)){const y=E.split("|");if(y.length===2){const d=Number(y[0]),g=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(g))){this.verboseLogging&&this.log(g);continue}b.push({type:I.changeTypeMap[d],path:g})}else this.log(y[1])}}b.length>0&&this.eventCallback(b)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,b)=>this.onExit(t,b))}onError(f){this.error("process error: "+f.toString())}onExit(f,m){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${m})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,8,23,165]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,m,t){this.onDidFilesChange=f,this.onLogMessage=m,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(v.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,v.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(J[69],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,M=[],I=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=v}),define(J[167],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=v;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let I of this._nodes.values())I.outgoing.size===0&&M.push(I);return M}insertEdge(M,I){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(I);n.outgoing.set(this._hashFn(I),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const I=this._hashFn(M);this._nodes.delete(I);for(let n of this._nodes.values())n.outgoing.delete(I),n.incoming.delete(I)}lookupOrInsertNode(M){const I=this._hashFn(M);let n=this._nodes.get(I);return n||(n=new v(M),this._nodes.set(I,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[I,n]of this._nodes)M.push(`${I}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,I]of this._nodes){const n=new Set([M]),f=this._findCycle(I,n);if(f)return f}}_findCycle(M,I){for(let[n,f]of M.outgoing){if(I.has(n))return[...I,n].join(" -> ");I.add(n);const m=this._findCycle(f,I);if(m)return m;I.delete(n)}}}e.Graph=L}),define(J[4],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(m){return m[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,m,t){f[v.DI_TARGET]===f?f[v.DI_DEPENDENCIES].push({id:n,index:m,optional:t}):(f[v.DI_DEPENDENCIES]=[{id:n,index:m,optional:t}],f[v.DI_TARGET]=f)}function k(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const f=function(m,t,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,m,b,!1)};return f.toString=()=>n,v.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function I(n){return function(f,m,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=I}),define(J[70],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(J[87],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,I)=>V(["vscode-encrypt"],M,I))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(I){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(I){return M}}}e.EncryptionMainService=L}),define(J[47],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,10,136,4]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function M(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=M;var I;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=5]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var n;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var f;(function(b){b.Install="install",b.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var m;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class t extends Error{constructor(E,y){super(E);this.code=y,this.name=y}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,23,4]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class n{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,E){if(typeof b=="undefined"||b===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof b=="string"||typeof E=="string"){let y=typeof b=="string"?b:b.value,d=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(y,d)}return b._lower===E._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function m(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=m,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,23,170]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,v.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,P){this.version=P,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function I(d,g){return`${d}.${g}`}e.getExtensionId=I;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,g){return n(I(d,g))}e.getGalleryExtensionId=f;function m(d,g){const P=[],S=h=>{for(const u of P)if(u.some(o=>k(g(o),g(h))))return u;return null};for(const h of d){const u=S(h);u?u.push(h):P.push([h])}return P}e.groupByExtension=m;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function b(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function E(d){const g=new Set;for(const P of d)P.malicious&&g.add(P.id.id);return g}e.getMaliciousExtensionsSet=E;function y(d,g){const P=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const h=S.shift();if(h&&P.every(u=>!k(u.identifier,{id:h}))){const u=d.filter(o=>k(o.identifier,{id:h}));u.length===1&&(P.push(u[0]),S.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=y}),define(J[88],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(J[172],Z([0,1,41,10,8,3,105,18,68,138,88]),function(V,e,v,L,k,M,I,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=m.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(o,l){return this.spawnTerminal(v,o,f.getWindowsShell(),l)}spawnTerminal(o,l,i,s){const r=l.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=k.basename(r).toLowerCase();if(a==="cmder"||a==="cmder.exe")return o.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return r.indexOf(" ")>=0&&c.push('""'),c.push(r),(a==="wt"||a==="wt.exe")&&c.push("-d ."),new Promise((p,w)=>{const D=P(process),R=o.spawn(i,c,{cwd:s,env:D});R.on("error",w),R.on("exit",()=>p())})}runInTerminal(o,l,i,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((c,p)=>{const w=`"${l} - ${b}"`,D=`""${i.join('" "')}" & pause"`,R=["/c","start",w,"/wait",a,"/c",D],_=Object.assign({},P(process),s);Object.keys(_).filter(x=>_[x]===null).forEach(x=>delete _[x]);const C={cwd:l,env:_,windowsVerbatimArguments:!0};v.spawn(y.CMD,R,C).on("error",x=>{p(S(x))}),c(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends E{openTerminal(o,l){return this.spawnTerminal(v,o,l)}runInTerminal(o,l,i,s,r){const a=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((c,p)=>{if(a===t.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const w=a===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,V).fsPath,"-t",o||b,"-w",l];for(let G of i)R.push("-a"),R.push(G);if(s){const G=Object.assign({},P(process),s);for(let x in G){const ne=G[x];ne===null?(R.push("-u"),R.push(x)):(R.push("-e"),R.push(`${x}=${ne}`))}}let _="";const C=v.spawn(d.OSASCRIPT,R);C.on("error",G=>{p(S(G))}),C.stderr.on("data",G=>{_+=G.toString()}),C.on("exit",G=>{if(G===0)c(void 0);else if(_){const x=_.split(`
`,1);p(new Error(x[0]))}else p(new Error(m.localize(1,null,w,G)))})}else p(new Error(m.localize(2,null,a)))})}spawnTerminal(o,l,i){const s=l.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const c=["-a",s];i&&c.push(i);const p=P(process),w=o.spawn("/usr/bin/open",c,{cwd:i,env:p});w.on("error",a),w.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends E{openTerminal(o,l){return this.spawnTerminal(v,o,l)}runInTerminal(o,l,i,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((c,p)=>{let w=[];a.then(D=>{D.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const R=`${h(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;w.push(`''${R}''`);const _=Object.assign({},P(process),s);Object.keys(_).filter(ne=>_[ne]===null).forEach(ne=>delete _[ne]);const C={cwd:l,env:_};let G="";const x=v.spawn(D,w,C);x.on("error",ne=>{p(S(ne))}),x.stderr.on("data",ne=>{G+=ne.toString()}),x.on("exit",ne=>{if(ne===0)c(void 0);else if(G){const K=G.split(`
`,1);p(new Error(K[0]))}else p(new Error(m.localize(4,null,D,ne)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,l,i){const s=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(c=>{const p=P(process),w=o.spawn(c,[],{cwd:i,env:p});w.on("error",a),w.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=m.localize(3,null);function P(u){const o={...u.env};return(0,I.sanitizeProcessEnvironment)(o),o}function S(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(m.localize(5,null,u.path)):u}function h(u){let o="";for(let l of u)l.indexOf(" ")>=0?o+='"'+l+'"':o+=l,o+=" ";return o}}),define(J[19],Z([0,1,37,8,23,13,7,140,4]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function m(U){return U.create===!0}e.isFileOpenForWriteOptions=m;var t;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;var S;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor($,W){super($);this.code=W}}e.FileSystemProviderError=h;function u(U,$){const W=new h(U.toString(),$);return l(W,$),W}e.createFileSystemProviderError=u;function o(U){return U||u((0,n.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=o;function l(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function i(U){if(!U)return S.Unknown;if(U instanceof h)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return S.Unknown;switch($[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=i;function s(U){if(U instanceof D)return U.fileOperationResult;switch(i(U)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor($,W,N){this.resource=$,this.operation=W,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var c;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class p{constructor($,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>W)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>W)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>W)),this.deleted.set(N.resource,N);break}}contains($,...W){return this.doContains($,{includeChildren:!1},...W)}affects($,...W){return this.doContains($,{includeChildren:!0},...W)}doContains($,W,...N){if(!$)return!1;const B=N.length>0;return!!((!B||N.includes(1))&&(this.added?.get($)||W.includeChildren&&this.added?.findSuperstr($))||(!B||N.includes(0))&&(this.updated?.get($)||W.includeChildren&&this.updated?.findSuperstr($))||(!B||N.includes(2))&&(this.deleted?.findSubstr($)||W.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function w(U,$,W){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),W?(0,k.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=w;class D extends Error{constructor($,W,N){super($);this.fileOperationResult=W,this.options=N}}e.FileOperationError=D;class R extends D{constructor($,W,N){super($,2,N);this.stat=W}}e.NotModifiedSinceFileOperationError=R;var _;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=G;async function x(U,$){if(!$.canHandleResource(I.URI.from({scheme:U.scheme})))return new Promise(W=>{const N=$.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===U.scheme&&B.added&&(N.dispose(),W())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize($){return(0,M.isNumber)($)||($=0),$<ne.KB?(0,n.localize)(1,null,$.toFixed(0)):$<ne.MB?(0,n.localize)(2,null,($/ne.KB).toFixed(2)):$<ne.GB?(0,n.localize)(3,null,($/ne.MB).toFixed(2)):$<ne.TB?(0,n.localize)(4,null,($/ne.GB).toFixed(2)):(0,n.localize)(5,null,($/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var K;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function Q(U){return{maxFileSize:U===0?300*ne.MB:16*ne.GB,maxHeapSize:U===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,135,86,19]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(E,y){const d={onUnknownOption:P=>{console.warn((0,L.localize)(0,null,P))},onMultipleValues:(P,S)=>{console.warn((0,L.localize)(1,null,P,S))}},g=(0,k.parseArgs)(E,k.OPTIONS,y?d:void 0);return g.goto&&g._.forEach(P=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,L.localize)(2,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(E){const y=E.findIndex(d=>!/^-/.test(d));if(y>-1)return[...E.slice(0,y),...E.slice(y+1)]}function f(E){let[,...y]=E;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!b(process.env);return I(y,d)}e.parseMainProcessArgv=f;function m(E){const[,,...y]=E;return I(y,!0)}e.parseCLIProcessArgv=m;function t(E,...y){const d=E.indexOf("--");return d===-1?E.push(...y):E.splice(d,0,...y),E}e.addArg=t;function b(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(J[89],Z([0,1,41,159,25,67,16,3,28,130,54]),function(V,e,v,L,k,M,I,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function b(d,g,P){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(P)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(P)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=new Promise(async S=>{const h=new k.CancellationTokenSource,u=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),h.dispose(!0),S({})},1e4);try{const o=await y(d,h.token);S(o)}catch(o){(0,I.isPromiseCanceledError)(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),S({})}finally{clearTimeout(u),h.dispose()}})),E)}e.resolveShellEnv=b;let E;async function y(d,g){const P=new Promise(async(S,h)=>{const u=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",u);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const l=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",s);const r=await(0,m.getSystemShell)(n.OS,s);if(d.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return h(I.canceled);const a=L.basename(r);let c,p;/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,p=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,p=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),c);const w=(0,v.spawn)(r,[...p,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(w.kill(),h(I.canceled))),w.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(_)),S({})});const D=[];w.stdout.on("data",_=>D.push(_));const R=[];w.stderr.on("data",_=>R.push(_)),w.on("close",(_,C)=>{const G=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const x=Buffer.concat(R).toString("utf8");if(x.trim()&&d.trace("getUnixShellEnvironment#stderr",x),_||C)return h(new Error(`Failed to get environment (code ${_}, signal ${C})`));const ne=i.exec(G),K=ne?ne[1]:"{}";try{const Q=JSON.parse(K);u?Q.ELECTRON_RUN_AS_NODE=u:delete Q.ELECTRON_RUN_AS_NODE,o?Q.ELECTRON_NO_ATTACH_CONSOLE=o:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Q),S(Q)}catch(Q){d.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(Q)),h(Q)}})});try{return await P}catch(S){return d.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(S)),{}}}}),define(J[90],Z([0,1,3,7,19]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(m=>({type:m.type,resource:L.URI.file(m.path)}))}e.toFileChanges=M;function I(f){const m=new n;for(const t of f)m.processEvent(t);return m.normalize()}e.normalizeFileChanges=I;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const t=this.mapPathToChange.get(m.path);if(t){const b=t.type,E=m.type;b===1&&E===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(t),1)):b===2&&E===1?t.type=0:b===1&&E===0||(t.type=E)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],t=[];return this.normalized.filter(b=>b.type!==2?(m.push(b),!1):!0).sort((b,E)=>b.path.length-E.path.length).filter(b=>t.some(E=>(0,k.isParent)(b.path,E,!v.isLinux))?!1:(t.push(b.path),!0)).concat(m)}}}),define(J[173],Z([0,1,9,2,8,80,18,117,90]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class m extends L.Disposable{constructor(b,E,y,d){super();this.path=b,this.onDidFilesChange=E,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:E}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(E)try{y=await(0,M.realpath)(y)}catch(d){if(this.onError(d),E.dangling)return}b.isDirectory()?this._register((0,n.watchFolder)(y,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},d=>this.onError(d))):this._register((0,n.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,f.normalizeFileChanges)(E);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=m}),define(J[71],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[M,I]of k)this.set(M,I)}set(k,M){const I=this._entries.get(k);return this._entries.set(k,M),I}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(J[174],Z([0,1,9,16,69,167,4,71]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class m extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new n.ServiceCollection,g=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=P,this._services.set(I.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...g){let P=E.traceInvocation(d),S=!1;try{return d({get:(u,o)=>{if(S)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(u,P);if(!l&&o!==I.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return l}},...g)}finally{S=!0,P.stop()}}createInstance(d,...g){let P,S;return d instanceof k.SyncDescriptor?(P=E.traceCreation(d.ctor),S=this._createInstance(d.ctor,d.staticArguments.concat(g),P)):(P=E.traceCreation(d),S=this._createInstance(d,g,P)),P.stop(),S}_createInstance(d,g=[],P){let S=I._util.getServiceDependencies(d).sort((o,l)=>o.index-l.index),h=[];for(const o of S){let l=this._getOrCreateServiceInstance(o.id,P);if(!l&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);h.push(l)}let u=S.length>0?S[0].index:g.length;if(g.length!==u){console.warn(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${g.length} static arguments`);let o=u-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,u)}return new d(...[...g,...h])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,g.branch(d,!0)):(g.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,g,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,P){const S=new M.Graph(o=>o.id.toString());let h=0;const u=[{id:d,desc:g,_trace:P}];for(;u.length;){const o=u.pop();if(S.lookupOrInsertNode(o),h++>1e3)throw new m(S);for(let l of I._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(l.id);if(!i&&!l.optional&&console.warn(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const s={id:l.id,desc:i,_trace:o._trace.branch(l.id,!0)};S.insertEdge(o,s),u.push(s)}}}for(;;){const o=S.roots();if(o.length===0){if(!S.isEmpty())throw new m(S);break}for(const{data:l}of o){if(this._getServiceInstanceOrDescriptor(l.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}S.removeNode(l)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,P=[],S,h){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,P,S,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,P,S,h);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],P,S){if(P){const h=new v.IdleValue(()=>this._createInstance(d,g,S));return new Proxy(Object.create(null),{get(u,o){if(o in u)return u[o];let l=h.value,i=l[o];return typeof i!="function"||(i=i.bind(l),u[o]=i),i},set(u,o,l){return h.value[o]=l,!0}})}else return this._createInstance(d,g,S)}}e.InstantiationService=t;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class E{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return f?new E(0,d.name):E._None}branch(d,g){let P=new E(2,d.toString());return this._dep.push([d,g,P]),P}stop(){let d=Date.now()-this._start;E._totals+=d;let g=!1;function P(h,u){let o=[],l=new Array(h+1).join("	");for(const[i,s,r]of u._dep)if(s&&r){g=!0,o.push(`${l}CREATES -> ${i}`);let a=P(h+1,r);a&&o.push(a)}else o.push(`${l}uses -> ${i}`);return o.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(S.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(J[175],Z([0,1,16,128,57]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(J[176],Z([0,1,57,175]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(I,n){super(n,I.parts)}_keyCodeToUILabel(I){if(this._os===2)switch(I){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(I)}_getLabel(I){return I.isDuplicateModifierCase()?"":this._keyCodeToUILabel(I.keyCode)}_getAriaLabel(I){return I.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(I.keyCode)}_keyCodeToElectronAccelerator(I){if(I>=93&&I<=108)return null;switch(I){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(I)}_getElectronAccelerator(I){return I.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(I.keyCode)}_getUserSettingsLabel(I){if(I.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(I.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(I){return k.getDispatchStr(I)}static getDispatchStr(I){if(I.isModifierKey())return null;let n="";return I.ctrlKey&&(n+="ctrl+"),I.shiftKey&&(n+="shift+"),I.altKey&&(n+="alt+"),I.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(I.keyCode),n}_getSingleModifierDispatchPart(I){return I.keyCode===5&&!I.shiftKey&&!I.altKey&&!I.metaKey?"ctrl":I.keyCode===4&&!I.ctrlKey&&!I.altKey&&!I.metaKey?"shift":I.keyCode===6&&!I.ctrlKey&&!I.shiftKey&&!I.metaKey?"alt":I.keyCode===57&&!I.ctrlKey&&!I.shiftKey&&!I.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(J[177],Z([0,1,9]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const I=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&I.push(f.then(m=>{m&&(n=!0)},m=>{M(m),n=!0}))}return v.Promises.settled(I).then(()=>n)}e.handleVetos=L}),define(J[6],Z([0,1,67,5,2,3,4]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class m extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class t extends m{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...s]))}debug(i,...s){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...s]))}info(i,...s){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...s]))}warn(i,...s){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...s]))}error(i,...s){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...s]))}critical(i,...s){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...s]))}flush(){}format(i){let s="";for(let r=0;r<i.length;r++){let a=i[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(c){}s+=(r>0?" ":"")+a}return s}}e.AbstractMessageLogger=t;class b extends m{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...s){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}debug(i,...s){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}info(i,...s){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}warn(i,...s){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...s):console.warn(`[main ${n()}]`,i,...s))}error(i,...s){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...s):console.error(`[main ${n()}]`,i,...s))}critical(i,...s){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...s):console.error(`[main ${n()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class E extends m{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=E;class y extends m{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends m{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const r of this.logServices)r.trace(i,...s)}debug(i,...s){for(const r of this.logServices)r.debug(i,...s)}info(i,...s){for(const r of this.logServices)r.info(i,...s)}warn(i,...s){for(const r of this.logServices)r.warn(i,...s)}error(i,...s){for(const r of this.logServices)r.error(i,...s)}critical(i,...s){for(const r of this.logServices)r.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=g;class P extends k.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,s?.always?f.Trace:this.logLevel,s),this.loggers.set(i.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class S{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=S;function h(l){if(l.verbose)return f.Trace;if(typeof l.logLevel=="string"){const i=u(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function u(l){switch(l){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=u;function o(l){switch(l){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var ee=this&&this.__param||function(V,e){return function(v,L){e(v,L,V)}};define(J[178],Z([0,1,9,17,40,76,47,19,4,6]),function(V,e,v,L,k,M,I,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(E){E.ERROR_INVALID_FILE="ERROR_INVALID_FILE",E.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(y,d,g){this.environmentService=y,this.fileService=d,this.logService=g,this.queue=new v.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:P,mtime:S,etag:h}=await this.fileService.readFile(y,{atomic:!0});let u=P.toString();const o=[];if((0,k.parse)(u,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(d,u,g)[0];if(l){u=u.substring(0,l.offset)+l.content+u.substring(l.offset+l.length);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(u),{etag:h,mtime:S})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},g,P){return d.length?(0,M.setProperty)(g,d,y,P):[{content:JSON.stringify(y,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:g.length,offset:0}]}};b=he([ee(0,I.IEnvironmentService),ee(1,n.IFileService),ee(2,m.ILogService)],b),e.UserConfigurationFileService=b}),define(J[91],Z([0,1,6]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,I){switch(I){case v.LogLevel.Trace:return M.trace;case v.LogLevel.Debug:return M.debug;case v.LogLevel.Info:return M.info;case v.LogLevel.Warning:return M.warn;case v.LogLevel.Error:return M.error;case v.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(I=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(I){this._logger=I;for(const{level:n,args:f}of this.buffer)L(I,n).apply(I,f);this.buffer=[]}_log(I,...n){this._logger?L(this._logger,I).apply(this._logger,n):this.getLevel()<=I&&this.buffer.push({level:I,args:n})}trace(I,...n){this._log(v.LogLevel.Trace,I,...n)}debug(I,...n){this._log(v.LogLevel.Debug,I,...n)}info(I,...n){this._log(v.LogLevel.Info,I,...n)}warn(I,...n){this._log(v.LogLevel.Warning,I,...n)}error(I,...n){this._log(v.LogLevel.Error,I,...n)}critical(I,...n){this._log(v.LogLevel.Critical,I,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(J[179],Z([0,1,9,17,15,19,4,91,6]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(y,d,g,P,S){super();this.name=y,this.resource=d,this.donotUseFormatters=P,this.fileService=S,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>m&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let g=0;g<y.length;g++){let P=y[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch(S){}d+=(g>0?" ":"")+P}return d}};t=he([ee(4,M.IFileService)],t),e.FileLogger=t;let b=class extends f.AbstractLoggerService{constructor(y,d,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(y,d,g){const P=new n.BufferLogService(d);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>P.logger=this.instantiationService.createInstance(t,(0,k.basename)(y),y,P.getLevel(),!!g?.donotUseFormatters)),P}};b=he([ee(0,f.ILogService),ee(1,I.IInstantiationService),ee(2,M.IFileService)],b),e.FileLoggerService=b}),define(J[180],Z([0,1,5,7,6]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(E){this.service=E,this.onDidChangeLogLevel=v.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(E,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=M;class I{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){I.setLevel(this.channel,E)}static setLevel(E,y){return E.call("setLevel",y)}}e.LogLevelChannelClient=I;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,y){throw new Error(`Event not found: ${y}`)}async call(E,y,d){switch(y){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(E,y){this.loggers.set(E.toString(),this.loggerService.createLogger(E,y))}consoleLog(E,y){let d=console.log;switch(E){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(E,y){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,P]of y)switch(g){case k.LogLevel.Trace:d.trace(P);break;case k.LogLevel.Debug:d.debug(P);break;case k.LogLevel.Info:d.info(P);break;case k.LogLevel.Warning:d.warn(P);break;case k.LogLevel.Error:d.error(P);break;case k.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(E,y,d){super(E,y);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(E,y)=>{this.channel.call("consoleLog",[E,y])}})}doCreateLogger(E,y,d){return new m(this.channel,E,y,d)}}e.LoggerChannelClient=f;class m extends k.AbstractMessageLogger{constructor(E,y,d,g){super(g?.always);this.channel=E,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,y){const d=[[E,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class t extends k.LogService{constructor(E,y){super(y);this.parent=E,this._register(E.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=t}),define(J[92],Z([0,1,19,6]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,m,t,b){try{const E=await new Promise((y,d)=>{V(["spdlog"],y,d)});return E.setFlushOn(L.LogLevel.Trace),E.createAsyncRotatingLogger(f,m,t,b)}catch(E){console.error(E)}return null}function M(f,m,t,b){const E=V.__$__nodeRequire("spdlog");return E.setFlushOn(L.LogLevel.Trace),E.createRotatingLogger(f,m,t,b)}e.createRotatingLogger=M;function I(f,m,t){switch(m){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(m,t,b,E){super();this.name=m,this.filepath=t,this.rotating=b,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const m=this.rotating?6:1,t=30/m*v.ByteSize.MB;return k(this.name,this.filepath,t,m).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:E,message:y}of this.buffer)I(this._logger,E,y);this.buffer=[]}})}log(m,t){this._logger?I(this._logger,m,t):this.getLevel()<=m&&this.buffer.push({level:m,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[181],Z([0,1,10,15,28,19,179,6,92]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends n.AbstractLoggerService{constructor(b,E){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=E}doCreateLogger(b,E,y){if(b.scheme===v.Schemas.file){const d=new f.SpdLogLogger(y?.name||(0,k.generateUuid)(),b.fsPath,!y?.donotRotate,E);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new I.FileLogger(y?.name??(0,L.basename)(b),b,E,!!y?.donotUseFormatters,this.fileService)}};m=he([ee(0,n.ILogService),ee(1,M.IFileService)],m),e.LoggerService=m}),define(J[182],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(I){return!v(I)&&!L(I)&&!k(I)}e.isMenubarMenuItemAction=M}),define(J[48],Z([0,1,10,3,33,15]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)I=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,M.dirname)(v.FileAccess.asFileUri("",V));I=V.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=V.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:f.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(J[93],Z([0,1,17,16,141,19,48]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(b,E,y,d,g,P){let S;try{await f(b,E,y,d,g,P)}catch(h){S=h}finally{S&&g.errorTransformer&&(S=g.errorTransformer(S)),typeof S!="undefined"&&y.error(S),y.end()}}e.readFileIntoStream=n;async function f(b,E,y,d,g,P){m(P);const S=await b.open(E,{create:!1});try{m(P);let h=0,u=0,o=g&&typeof g.length=="number"?g.length:void 0,l=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,s=0;do u=await b.read(S,i,l.buffer,s,l.byteLength-s),i+=u,s+=u,h+=u,typeof o=="number"&&(o-=u),s===l.byteLength&&(await y.write(d(l)),l=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),s=0);while(u>0&&(typeof o!="number"||o>0)&&m(P)&&t(h,g));if(s>0){let r=s;typeof o=="number"&&(r=Math.min(s,o)),y.write(d(l.slice(0,r)))}}catch(h){throw(0,M.ensureFileSystemProviderError)(h)}finally{await b.close(S)}}function m(b){if(b.isCancellationRequested)throw(0,L.canceled)();return!0}function t(b,E){if(E?.limits){if(typeof E.limits.memory=="number"&&b>E.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,I.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&b>E.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,36,9,17,25,5,63,2,37,10,72,15,64,139,19,93,6]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class qe extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new I.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new g.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new g.FileChangesEvent(l,!0)))),this.watchedResources=m.TernarySearchTree.forUris(l=>{const i=this.getProvider(l.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,l){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:l});const i=new f.DisposableStore;return i.add(l.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(l)))),i.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:o}))),typeof l.onDidErrorOccur=="function"&&i.add(l.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:l}),this.provider.delete(o),(0,f.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){l.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(l)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,l){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&l)}listCapabilities(){return n.Iterable.map(this.provider,([o,l])=>({scheme:o,capabilities:l.capabilities}))}async withProvider(o){if(!(0,E.isAbsolutePath)(o))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const l=this.provider.get(o.scheme);if(!l){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,o.toString()),i}return l}async withReadProvider(o){const l=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)||(0,g.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const l=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,l){try{return await this.doResolveFile(o,l)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(o,l){const i=await this.withProvider(o),s=this.isPathCaseSensitive(i),r=l?.resolveTo,a=l?.resolveSingleChildDescendants,c=l?.resolveMetadata,p=await i.stat(o);let w;return this.toFileStat(i,o,p,void 0,!!c,(D,R)=>(w||(w=m.TernarySearchTree.forUris(()=>!s),w.set(o,!0),(0,v.isNonEmptyArray)(r)&&r.forEach(_=>w.set(_,!0))),Boolean(w.findSuperstr(D.resource)||w.get(D.resource))?!0:D.isDirectory&&a?R===1:!1))}async toFileStat(o,l,i,s,r,a){const{providerExtUri:c}=this.getExtUri(o),p={resource:l,name:c.basename(l),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(p.isDirectory&&a(p,s)){try{const w=await o.readdir(l),D=await L.Promises.settled(w.map(async([R,_])=>{try{const C=c.joinPath(l,R),G=r?await o.stat(C):{type:_};return await this.toFileStat(o,C,G,w.length,r,a)}catch(C){return this.logService.trace(C),null}}));p.children=(0,v.coalesce)(D)}catch(w){this.logService.trace(w),p.children=[]}return p}return p}async resolveAll(o){return L.Promises.settled(o.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const l=await this.withProvider(o);try{return!!await l.stat(o)}catch(i){return!1}}async canCreateFile(o,l){try{await this.doValidateCreateFile(o,l)}catch(i){return i}return!0}async doValidateCreateFile(o,l){if(!l?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,l)}async createFile(o,l=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const s=await this.writeFile(o,l);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,s)),s}async writeFile(o,l,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,o,i)||await this.mkdirp(s,r.dirname(o));let c;if((0,g.hasReadWriteCapability)(s)&&!(l instanceof k.VSBuffer))if((0,y.isReadableStream)(l)){const p=await(0,y.peekStream)(l,3);p.ended?c=k.VSBuffer.concat(p.buffer):c=p}else c=(0,y.peekReadable)(l,p=>k.VSBuffer.concat(p),3);else c=l;!(0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(s,o,i,c):await this.doWriteBuffered(s,o,i,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c)}catch(a){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(a).toString()),(0,g.toFileOperationResult)(a),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,l,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(l)));let r;try{r=await o.stat(l)}catch(a){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(l)),0,i);if(this.throwIfFileIsReadonly(l,r),i&&typeof i.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:r.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,i);return r}async readFile(o,l){const i=await this.withReadProvider(o);return l?.atomic?this.doReadFileAtomic(i,o,l):this.doReadFile(i,o,l)}async doReadFileAtomic(o,l,i){return new Promise((s,r)=>{this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,l,i);s(a)}catch(a){r(a)}})})}async doReadFile(o,l,i){const s=await this.doReadFileStream(o,l,{...i,preferUnbuffered:!0});return{...s,value:await(0,k.streamToBuffer)(s.value)}}async readFileStream(o,l){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,l)}async doReadFileStream(o,l,i){const s=new M.CancellationTokenSource,r=this.validateReadFile(l,i).then(c=>c,c=>{throw s.cancel(),c});let a;try{return i&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&i?.preferUnbuffered?a=this.readFileUnbuffered(o,l,i):(0,g.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,l,s.token,i):a=this.readFileBuffered(o,l,s.token,i),{...await r,value:a}}catch(c){a&&await(0,y.consumeStream)(a);const p=(0,d.localize)(8,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(c).toString());throw c instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(p,c.stat,i):new g.FileOperationError(p,(0,g.toFileOperationResult)(c),i)}}readFileStreamed(o,l,i,s=Object.create(null)){const r=o.readFileStream(l,s,i);return(0,y.transform)(r,{data:a=>a instanceof k.VSBuffer?a:k.VSBuffer.wrap(a),error:a=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(a).toString()),(0,g.toFileOperationResult)(a),s)},a=>k.VSBuffer.concat(a))}readFileBuffered(o,l,i,s=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,l,r,a=>a,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(a).toString()),(0,g.toFileOperationResult)(a),s)},i),r}readFileUnbuffered(o,l,i){const s=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(l);i&&typeof i.position=="number"&&(r=r.slice(i.position)),i&&typeof i.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(l,r.byteLength,i),s.end(k.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(o,l){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==g.ETAG_DISABLED&&l.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,l);return this.validateReadFileLimits(o,i.size,l),i}validateReadFileLimits(o,l,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&l>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&l>i.limits.size&&(s=7),typeof s=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),s)}}async canMove(o,l,i){return this.doCanMoveCopy(o,l,"move",i)}async canCopy(o,l,i){return this.doCanMoveCopy(o,l,"copy",i)}async doCanMoveCopy(o,l,i,s){if(o.toString()!==l.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,o,a,l,i,s)}catch(r){return r}return!0}async move(o,l,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(s,o,r,l,"move",!!i),c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,a==="move"?2:3,c)),c}async copy(o,l,i){const s=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(s,o,r,l,"copy",!!i),c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,a==="copy"?3:2,c)),c}async doMoveCopy(o,l,i,s,r,a){if(l.toString()===s.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(o,l,i,s,r,a);if(c&&!p&&a&&await this.del(s,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s)),r==="copy"){if(o===i&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(l,s,{overwrite:a});else{const w=await this.resolve(l);w.isDirectory?await this.doCopyFolder(o,w,i,s):await this.doCopyFile(o,l,i,s)}return r}else return o===i?(await o.rename(l,s,{overwrite:a}),r):(await this.doMoveCopy(o,l,i,s,"copy",a),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(o,l,i,s){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,l,i,s);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,l,i,s);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,l,i,s);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,l,i,s)}async doCopyFolder(o,l,i,s){await i.mkdir(s),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async r=>{const a=this.getExtUri(i).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),i,a):this.doCopyFile(o,r.resource,i,a)}))}async doValidateMoveCopy(o,l,i,s,r,a){let c=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(c=w.isEqual(l,s)),c&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(l),this.resourceForError(s)));if(!c&&w.isEqualOrParent(s,l))throw new Error((0,d.localize)(15,null,this.resourceForError(l),this.resourceForError(s)))}const p=await this.exists(s);if(p&&!c){if(!a)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(l),this.resourceForError(s)),4);if(o===i){const{providerExtUri:w}=this.getExtUri(o);if(w.isEqualOrParent(l,s))throw new Error((0,d.localize)(17,null,this.resourceForError(l),this.resourceForError(s)))}}return{exists:p,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const l=this.isPathCaseSensitive(o);return{providerExtUri:l?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(l,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,i)),i}async mkdirp(o,l){const i=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(l,s.dirname(l));)try{if(((await o.stat(l)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(s.basename(l)),l=s.dirname(l)}for(let r=i.length-1;r>=0;r--){l=s.joinPath(l,i[r]);try{await o.mkdir(l)}catch(a){if((0,g.toFileSystemProviderErrorCode)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,l){try{await this.doValidateDelete(o,l)}catch(i){return i}return!0}async doValidateDelete(o,l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!l?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let r;try{r=await i.stat(o)}catch(c){}if(r)this.throwIfFileIsReadonly(o,r);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!l?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return i}async del(o,l){const i=await this.doValidateDelete(o,l),s=!!l?.useTrash,r=!!l?.recursive;await i.delete(o,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,l){this._onDidChangeFilesRaw.fire({changes:o});let i,s;{for(const r of o)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(s||(s=[]),s.push(r));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!l))}if(s){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,l={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let s=!1,r=()=>{s=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(o,l).then(a=>{s?(0,f.dispose)(a):r=()=>(0,f.dispose)(a)},a=>this.logService.error(a))}return l.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,f.toDisposable)(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),i}async doWatch(o,l){const i=await this.withProvider(o),s=this.toWatchKey(i,o,l),r=this.activeWatchers.get(s)||{count:0,disposable:i.watch(o,l)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(o,l,i){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(l),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,l,i,s){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(l,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(s)||(0,y.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(o,r,s):await this.doWriteReadableBufferedQueued(o,r,s)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,l,i){let s=0,r;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,l,a,a.byteLength,s,0),s+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(a,c)=>{(0,y.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(o,l,p,p.byteLength,s,0)}catch(w){return c(w)}s+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>c(p),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,l,i){let s=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(o,l,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(o,l,i,s,r,a){let c=0;for(;c<s;)c+=await o.write(l,r+c,i.buffer,a+c,s-c)}async doWriteUnbuffered(o,l,i,s){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,l,i,s))}async doWriteUnbufferedQueued(o,l,i,s){let r;s instanceof k.VSBuffer?r=s:(0,y.isReadableStream)(s)?r=await(0,k.streamToBuffer)(s):(0,y.isReadableBufferedStream)(s)?r=await(0,k.bufferedStreamToBuffer)(s):r=(0,k.readableToBuffer)(s),await o.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,l,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,l,i,s))}async doPipeBufferedQueued(o,l,i,s){let r,a;try{r=await o.open(l,{create:!1}),a=await i.open(s,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,w=0,D=0;do D=await o.read(r,p,c.buffer,w,c.byteLength-w),await this.doWriteBuffer(i,a,c,D,p,w),p+=D,w+=D,w===c.byteLength&&(w=0);while(D>0)}catch(c){throw(0,g.ensureFileSystemProviderError)(c)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,l,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,l,i,s))}async doPipeUnbufferedQueued(o,l,i,s){return i.writeFile(s,await o.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,l,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,l,i,s))}async doPipeUnbufferedToBufferedQueued(o,l,i,s){const r=await i.open(s,{create:!0,unlock:!1});try{const a=await o.readFile(l);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(o,l,i,s){const r=await(0,k.streamToBuffer)(this.readFileBuffered(o,l,M.CancellationToken.None));await this.doWriteUnbuffered(i,s,void 0,r)}throwIfFileSystemIsReadonly(o,l){if(o.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(l)),6);return o}throwIfFileIsReadonly(o,l){if((l.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};h.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},h=he([ee(0,S.ILogService)],h),e.FileService=h}),define(J[184],Z([0,1,36,9,17,5,29,2,8,3,15,64,18,142,19,93,173,163,164,90,166,6]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends n.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,m.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:c}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async p=>{try{let w;p.isSymbolicLink()?w=(await this.stat((0,t.joinPath)(r,p.name))).type:w=this.toType(p),c.push([p.name,w])}catch(w){this.logService.trace(w)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let c;return a?.dangling?c=d.FileType.Unknown:r.isFile()?c=d.FileType.File:r.isDirectory()?c=d.FileType.Directory:c=d.FileType.Unknown,a&&(c|=d.FileType.SymbolicLink),c}async readFile(r){try{const a=this.toFilePath(r);return await E.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,c){const p=(0,b.newWriteableStream)(w=>k.VSBuffer.concat(w.map(D=>k.VSBuffer.wrap(D))).buffer);return(0,g.readFileIntoStream)(this,r,p,w=>w.buffer,{...a,bufferSize:this.BUFFER_SIZE},c),p}async writeFile(r,a,c){let p;try{const w=this.toFilePath(r);if(!c.create||!c.overwrite){if(await E.Promises.exists(w)){if(!c.overwrite)throw(0,d.createFileSystemProviderError)((0,y.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,d.createFileSystemProviderError)((0,y.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:c.unlock}),await this.write(p,0,a,0,a.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(r,w)}finally{typeof p=="number"&&await this.close(p)}}async open(r,a){try{const c=this.toFilePath(r);if((0,d.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:D}=await E.SymlinkSupport.stat(c);D.mode&128||await E.Promises.chmod(c,D.mode|128)}catch(D){this.logService.trace(D)}let p;if((0,d.isFileOpenForWriteOptions)(a)){if(m.isWindows)try{await E.Promises.truncate(c,0),p="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}p||(p="w")}else p="r";const w=await E.Promises.open(c,p);return this.mapHandleToPos.set(w,0),(0,d.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(w,r),w}catch(c){throw(0,d.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,c):this.toFileSystemProviderError(c)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await E.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await E.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,c,p,w){const D=this.normalizePos(r,a);let R=null;try{const _=await E.Promises.read(r,c,p,w,D);return typeof _=="number"?R=_:R=_.bytesRead,R}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,D,R)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,c){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(r,p+c):this.mapHandleToPos.delete(r)))}async write(r,a,c,p,w){return(0,L.retry)(()=>this.doWrite(r,a,c,p,w),100,3)}async doWrite(r,a,c,p,w){const D=this.normalizePos(r,a);let R=null;try{const _=await E.Promises.write(r,c,p,w,D);return typeof _=="number"?R=_:R=_.bytesWritten,R}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,D,R)}}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const c=this.toFilePath(r);await this.doDelete(c,a)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(r,a){a.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}async rename(r,a,c){const p=this.toFilePath(r),w=this.toFilePath(a);if(p!==w)try{await this.validateTargetDeleted(r,a,"move",c.overwrite),await E.Promises.move(p,w)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,y.localize)(2,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(w)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(r,a,c){const p=this.toFilePath(r),w=this.toFilePath(a);if(p!==w)try{await this.validateTargetDeleted(r,a,"copy",c.overwrite),await E.Promises.copy(p,w,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,y.localize)(3,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(w)),D.toString()))),this.toFileSystemProviderError(D)}}async validateTargetDeleted(r,a,c,p){const w=this.toFilePath(r),D=this.toFilePath(a);let R=!1;if(!!(this.capabilities&1024)||(R=(0,I.isEqual)(w,D,!0)),R&&c==="copy")throw(0,d.createFileSystemProviderError)((0,y.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!R&&await E.Promises.exists(D)){if(!p)throw(0,d.createFileSystemProviderError)((0,y.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a.excludes):this.watchNonRecursive(r)}watchRecursive(r,a){const c={path:this.toFilePath(r),excludes:a},p=(0,v.insert)(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;this.options?.watcher?.usePolling?(r=h.FileWatcher,a=this.options?.watcher):this.recursiveFoldersToWatch.length===1?m.isWindows?r=o.FileWatcher:r=h.FileWatcher:r=S.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,c=>this._onDidChangeFile.fire((0,u.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===l.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new P.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire((0,u.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===l.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)});return(0,n.combinedDisposable)(a,c)}toFilePath(r){return(0,f.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof d.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=d.FileSystemProviderErrorCode.NoPermissions;break;default:a=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let c=this.toFileSystemProviderError(a);if(r&&c.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await E.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(c=(0,d.createFileSystemProviderError)(a,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return c}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(J[20],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(J[185],Z([0,1,58,6,20]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(f);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,b]=m;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=y.slice(0,6),g=y.readUIntBE(0,6),P=Date.now()-g;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const S=y.slice(6),h=v.createVerify("SHA256");h.write(d),h.write(Buffer.from(t)),h.end();for(let u=0;u<E.length;u++){let o=E[u];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[u]=o}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,l),E[u]=null;continue}if(h.verify(o,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=he([ee(0,k.IProductService),ee(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(J[55],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(J[186],Z([0,1,14,2,37,10,3,15,7,28,47,6]),function(V,e,v,L,k,M,I,n,f,m,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!I.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=v.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,P)=>this.handleResourceRequest(g,P)),d.protocol.interceptFileProtocol(M.Schemas.file,(g,P)=>this.handleFileRequest(g,P)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const P=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const P=f.URI.parse(d.url),S=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(S)?g({path:S.fsPath}):this.validExtensions.has((0,n.extname)(S))?g({path:S.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),P=g.toString(),S=async()=>d;return v.ipcMain.handle(P,S),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:g,update:h=>d=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),v.ipcMain.removeHandler(P)}}}};E=he([ee(0,t.INativeEnvironmentService),ee(1,b.ILogService)],E),e.ProtocolMainService=E}),define(J[38],Z([0,1,102,13]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(I,n){v.ok(L.isString(I)),v.ok(L.isObject(n)),v.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,n)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new k}),define(J[187],Z([0,1,5,38]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,m){this.schemasById[k(f)]=m,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new M;L.Registry.add(e.Extensions.JSONContribution,I)}),define(J[49],Z([0,1,5,13,132,187,38]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=I.Registry.as(M.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new v.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new v.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,u=!0){this.registerConfigurations([h],u)}registerConfigurations(h,u=!0){const o=[];h.forEach(l=>{o.push(...this.validateAndRegisterProperties(l,u,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(h){const u=[],o=l=>{if(l.properties)for(const i in l.properties)u.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,l.properties[i]);l.allOf&&l.allOf.forEach(i=>o(i))};for(const l of h){o(l);const i=this.configurationContributors.indexOf(l);i!==-1&&this.configurationContributors.splice(i,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}registerDefaultConfigurations(h){const u=[],o=[];for(const l of h)for(const i in l)if(u.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...l[i]};const s={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};o.push(E(i)),this.configurationProperties[i]=s,this.defaultLanguageConfigurationOverridesNode.properties[i]=s}else{this.defaultValues[i]=l[i];const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterDefaultConfigurations(h){const u=[];for(const o of h)for(const l in o)if(u.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const i=this.configurationProperties[l];i&&(this.updatePropertyDefaultValue(l,i),this.updateSchema(l,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const u of h)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(h,u=!0,o,l=3){l=L.isUndefinedOrNull(h.scope)?l:h.scope;let i=[],s=h.properties;if(s)for(let a in s){if(u&&g(a)){delete s[a];continue}const c=s[a];if(this.updatePropertyDefaultValue(a,c),e.OVERRIDE_PROPERTY_PATTERN.test(a)?c.scope=void 0:(c.scope=L.isUndefinedOrNull(c.scope)?l:c.scope,c.restricted=L.isUndefinedOrNull(c.restricted)?!!o?.restrictedConfigurations?.includes(a):c.restricted),s[a].hasOwnProperty("included")&&!s[a].included){this.excludedConfigurationProperties[a]=s[a],delete s[a];continue}else this.configurationProperties[a]=s[a];!s[a].deprecationMessage&&s[a].markdownDeprecationMessage&&(s[a].deprecationMessage=s[a].markdownDeprecationMessage),i.push(a)}let r=h.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,u,o,l));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const u=o=>{let l=o.properties;if(l)for(const s in l)this.updateSchema(s,l[s]);let i=o.allOf;i&&i.forEach(u)};u(h)}updateSchema(h,u){switch(e.allSettings.properties[h]=u,u.scope){case 1:e.applicationSettings.properties[h]=u;break;case 2:e.machineSettings.properties[h]=u;break;case 6:e.machineOverridableSettings.properties[h]=u;break;case 3:e.windowSettings.properties[h]=u;break;case 4:e.resourceSettings.properties[h]=u;break;case 5:e.resourceSettings.properties[h]=u,this.resourceLanguageSettingsSchema.properties[h]=u;break}}removeFromSchema(h,u){switch(delete e.allSettings.properties[h],u.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const u=`[${h}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,o),e.allSettings.properties[u]=o,e.applicationSettings.properties[u]=o,e.machineSettings.properties[u]=o,e.machineOverridableSettings.properties[u]=o,e.windowSettings.properties[u]=o,e.resourceSettings.properties[u]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,u){let o=this.defaultValues[h];L.isUndefined(o)&&(o=u.default),L.isUndefined(o)&&(o=y(u.type)),u.default=o}}const b="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function E(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=E;function y(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const d=new t;I.Registry.add(e.Extensions.Configuration,d);function g(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?k.localize(5,null,S):d.getConfigurationProperties()[S]!==void 0?k.localize(6,null,S):null:k.localize(4,null)}e.validateProperty=g;function P(){const S=[],h=d.getConfigurationProperties();for(const u of Object.keys(h))S.push([u,h[u].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=P}),define(J[21],Z([0,1,44,13,7,49,4,38]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function f(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=f;var m;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(m=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function b(s,r){const a=r?s?r.keys.filter(C=>s.keys.indexOf(C)===-1):[...r.keys]:[],c=s?r?s.keys.filter(C=>r.keys.indexOf(C)===-1):[...s.keys]:[],p=[];if(r&&s){for(const C of s.keys)if(r.keys.indexOf(C)!==-1){const G=S(s.contents,C),x=S(r.contents,C);v.equals(G,x)||p.push(C)}}const w=[],D=C=>{const G={};for(const x of C)for(const ne of x.identifiers)G[l(ne)]=x;return G},R=r?D(r.overrides):{},_=s?D(s.overrides):{};if(Object.keys(R).length)for(const C of a){const G=R[C];G&&w.push([(0,M.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(_).length)for(const C of c){const G=_[C];G&&w.push([(0,M.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(R).length&&Object.keys(_).length)for(const C of p){const G=_[C],x=R[C];if(G&&x){const ne=b({contents:G.contents,keys:G.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});w.push([(0,M.overrideIdentifierFromKey)(C),[...ne.added,...ne.removed,...ne.updated]])}}return{added:a,removed:c,updated:p,overrides:w}}e.compare=b;function E(s,r){const a=[];for(const c of Object.keys(s))if(M.OVERRIDE_PROPERTY_PATTERN.test(c)){const p={};for(const w in s[c])p[w]=s[c][w];a.push({identifiers:[(0,M.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(p),contents:y(p,r)})}return a}e.toOverrides=E;function y(s,r){const a=Object.create(null);for(let c in s)d(a,c,s[c],r);return a}e.toValuesTree=y;function d(s,r,a,c){const p=r.split("."),w=p.pop();let D=s;for(let R=0;R<p.length;R++){let _=p[R],C=D[_];switch(typeof C){case"undefined":C=D[_]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${p.slice(0,R+1).join(".")} is ${JSON.stringify(C)}`);return}D=C}if(typeof D=="object"&&D!==null)try{D[w]=a}catch(R){c(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(D)}`)}else c(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(s,r){const a=r.split(".");P(s,a)}e.removeFromValueTree=g;function P(s,r){const a=r.shift();if(r.length===0){delete s[a];return}if(Object.keys(s).indexOf(a)!==-1){const c=s[a];typeof c=="object"&&!Array.isArray(c)&&(P(c,r),Object.keys(c).length===0&&delete s[a])}}function S(s,r,a){function c(D,R){let _=D;for(const C of R){if(typeof _!="object"||_===null)return;_=_[C]}return _}const p=r.split("."),w=c(s,p);return typeof w=="undefined"?a:w}e.getConfigurationValue=S;function h(s,r,a){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in s?L.isObject(s[c])&&L.isObject(r[c])?h(s[c],r[c],a):a&&(s[c]=r[c]):s[c]=r[c])})}e.merge=h;function u(){const s=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=u;function o(){const s=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let a in r){let c=r[a].default;d(s,a,c,p=>console.error(`Conflict in default settings: ${p}`))}return s}e.getDefaultValues=o;function l(s){return`[${s}]`}e.keyFromOverrideIdentifier=l;function i(s,r,a){const c=s.inspect(r),p=s.inspect(a);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:c.defaultValue}e.getMigratedSettingValue=i}),define(J[188],Z([0,1,36,5,40,2,37,44,13,7,21,49,38]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},s=[],r=[]){this._contents=i,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const r=this.getContentsForOverrideIdentifer(s);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const a of v.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[a],p=s[a];p&&(typeof c=="object"&&typeof p=="object"?(c=n.deepClone(c),this.mergeContents(c,p)):c=p),r[a]=c}return new y(r,this.keys,this.overrides)}merge(...i){const s=n.deepClone(this.contents),r=n.deepClone(this.overrides),a=[...this.keys];for(const c of i){this.mergeContents(s,c.contents);for(const p of c.overrides){const[w]=r.filter(D=>v.equals(D.identifiers,p.identifiers));w?this.mergeContents(w.contents,p.contents):r.push(n.deepClone(p))}for(const p of c.keys)a.indexOf(p)===-1&&a.push(p)}return new y(s,a,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,s){for(const r of Object.keys(s)){if(r in i&&f.isObject(i[r])&&f.isObject(s[r])){this.mergeContents(i[r],s[r]);continue}i[r]=n.deepClone(s[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,t.addToValueTree)(this.contents,i,s,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let r=0;r<s;r++)i.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const i=(0,t.getDefaultValues)(),s=(0,t.getConfigurationKeys)(),r=[];for(const a of Object.keys(i))b.OVERRIDE_PROPERTY_PATTERN.test(a)&&r.push({identifiers:[(0,b.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(i[a]),contents:(0,t.toValuesTree)(i[a],c=>console.error(`Conflict in default settings file: ${c}`))});super(i,s,r)}}e.DefaultConfigurationModel=d;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:r,keys:a,overrides:c,restricted:p}=this.doParseRaw(i,s);this._configurationModel=new y(r,a,c),this._restrictedConfigurations=p||[]}doParseContent(i){let s={},r=null,a=[],c=[],p=[];function w(R){Array.isArray(a)?a.push(R):r!==null&&(a[r]=R)}let D={onObjectBegin:()=>{let R={};w(R),c.push(a),a=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let R=[];w(R),c.push(a),a=R,r=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:w,onError:(R,_,C)=>{p.push({error:R,offset:_,length:C})}};if(i)try{k.visit(i,D),s=a[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(i,s){const r=E.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),a=this.filter(i,r,!0,s);i=a.raw;const c=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),p=Object.keys(i),w=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:p,overrides:w,restricted:a.restricted}}filter(i,s,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[]};const c={},p=[];for(let w in i)if(b.OVERRIDE_PROPERTY_PATTERN.test(w)&&r){const D=this.filter(i[w],s,!1,a);c[w]=D.raw,p.push(...D.restricted)}else{const D=s[w],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&p.push(w),(R===void 0||a.scopes===void 0||a.scopes.includes(R))&&(a.skipRestricted&&D?.restricted||(c[w]=i[w]))}return{raw:c,restricted:p}}}e.ConfigurationModelParser=g;class P extends M.Disposable{constructor(i,s,r,a){super();this.userSettingsResource=i,this.scopes=s,this.fileService=a,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class S{constructor(i,s,r=new y,a=new y,c=new I.ResourceMap,p=new y,w=new I.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=p,this._memoryConfigurationByResource=w,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(i,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(i)}updateValue(i,s,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new y,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,s===void 0?a.removeValue(i):a.setValue(i,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,r){const a=this.getConsolidateConfigurationModel(s,r),c=this.getFolderConfigurationModelForResource(s.resource,r),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,w=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),_=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,G=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,x=s.overrideIdentifier?p.override(s.overrideIdentifier).getValue(i):p.getValue(i),ne=a.getValue(i),K=v.distinct(v.flatten(a.overrides.map(Q=>Q.identifiers))).filter(Q=>a.getOverrideValue(i,Q)!==void 0);return{defaultValue:w,userValue:D,userLocalValue:R,userRemoteValue:_,workspaceValue:C,workspaceFolderValue:G,memoryValue:x,value:ne,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:c?.freeze().getValue(i),override:s.overrideIdentifier?c?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:p.getValue(i),override:s.overrideIdentifier?p.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const r=s.filter(a=>b.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const c=(0,b.overrideIdentifierFromKey)(a),p=this._defaultConfiguration.getKeysForOverrideIdentifier(c),w=i.getKeysForOverrideIdentifier(c),D=[...w.filter(R=>p.indexOf(R)===-1),...p.filter(R=>w.indexOf(R)===-1),...p.filter(R=>!n.equals(this._defaultConfiguration.override(c).getValue(R),i.override(c).getValue(R)))];return[c,D]});return this.updateDefaultConfiguration(i),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:r,removed:a,overrides:c}=(0,t.compare)(this.localUserConfiguration,i),p=[...s,...r,...a];return p.length&&this.updateLocalUserConfiguration(i),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:r,removed:a,overrides:c}=(0,t.compare)(this.remoteUserConfiguration,i);let p=[...s,...r,...a];return p.length&&this.updateRemoteUserConfiguration(i),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:r,removed:a,overrides:c}=(0,t.compare)(this.workspaceConfiguration,i);let p=[...s,...r,...a];return p.length&&this.updateWorkspaceConfiguration(i),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(i,s){const r=this.folderConfigurations.get(i),{added:a,updated:c,removed:p,overrides:w}=(0,t.compare)(r,s);let D=[...a,...c,...p];return(D.length||!r)&&this.updateFolderConfiguration(i,s),{keys:D,overrides:w}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:c,overrides:p}=(0,t.compare)(s,void 0);return{keys:[...r,...a,...c],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let r=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const a=s.getFolder(i);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const c=this._memoryConfigurationByResource.get(i);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(i);a?(s=r.merge(a),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=r}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const r=s.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:r,overrides:a,keys:c}=this._folderConfigurations.get(s);return i.push([s,{contents:r,overrides:a,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>s.add(a))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((p,w)=>(p.set(m.URI.revive(w[0]),this.parseConfigurationModel(w[1])),p),new I.ResourceMap);return new S(s,r,new y,a,c,new y,new I.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function h(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,s=new Map;for(const a of l)a.keys.forEach(c=>i.add(c)),a.overrides.forEach(([c,p])=>{const w=(0,I.getOrSet)(s,c,new Set);p.forEach(D=>w.add(D))});const r=[];return s.forEach((a,c)=>r.push([c,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=h;class u{constructor(i,s,r,a){this.change=i,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(w=>c.add(w)),i.overrides.forEach(([,w])=>w.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const p=new y;this.affectedKeys.forEach(w=>p.setValue(w,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!n.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let r=(0,t.toValuesTree)({[s]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(i=i[a],!i)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=u;class o extends u{constructor(i,s,r,a){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(J[189],Z([0,1,9,5,2,15,21,188,49,38]),function(V,e,v,L,k,M,I,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(E,y){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,y)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,y){const d=typeof E=="string"?E:void 0,g=(0,I.isConfigurationOverrides)(E)?E:(0,I.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,g,void 0)}updateValue(E,y,d,g){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,y,1)}onDidDefaultConfigurationChange(E){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,E);this.trigger(d,y,6)}trigger(E,y,d){const g=new n.ConfigurationChangeEvent(E,{data:y},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(J[190],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(I,n=L.Unknown,f){super(I);this._message=I,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===L.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===L.NoResolverFound}static isHandled(I){return I instanceof k&&I.isHandled}}e.RemoteAuthorityResolverError=k}),define(J[191],Z([0,1,9,17,25,16,5,2,28,82,190]),function(V,e,v,L,k,M,I,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var E;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function y(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const A=new k.CancellationTokenSource;return setTimeout(()=>A.cancel(),T),A.token}function g(T,A){if(T.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return T.onCancellationRequested(()=>O.cancel()),A.onCancellationRequested(()=>O.cancel()),O.token}class P{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((O,j)=>{this._resolvePromise=O,this._rejectPromise=j}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function S(T,A){const O=new P(A);return O.registerDisposable(T.onControlMessage(j=>{const Y=JSON.parse(j.toString()),q=W(Y);q?O.reject(q):O.resolve(Y)})),O.promise}function h(T,A,O,j,Y,q){const X=new P(q);return A.connect(O,j,Y,(ie,se)=>{X.didTimeout?(ie&&T.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function u(T,A){const O=new P(A);return T.then(j=>{O.didTimeout||O.resolve(j)},j=>{O.didTimeout||O.reject(j)}),O.promise}async function o(T,A,O,j){const Y=F(T,A);T.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let q;try{q=await h(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,j)}catch(ae){throw T.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ae),ae}T.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let X,ie;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(q,null),X=T.reconnectionProtocol,ie=!1):(X=new m.PersistentProtocol(q,null),ie=!0),T.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:T.connectionToken||"00000000000000000000"};X.sendControl(L.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await S(X,g(j,d(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ce=new Error("Unexpected handshake message");throw ce.code="VSCODE_CONNECTION_ERROR",ce}T.logService.trace(`${Y} 4/6. received SignRequest control message.`);const de=await u(T.signService.sign(ae.data),j),re={type:"connectionType",commit:T.commit,signedData:de,desiredConnectionType:A};return O&&(re.args=O),T.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(L.VSBuffer.fromString(JSON.stringify(re))),{protocol:X,ownsProtocol:ie}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(T.logService.error(`${Y} the handshake timed out. Error:`),T.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${Y} received error control message when negotiating connection. Error:`),T.logService.error(ae)),ie&&$(X),ae}}async function l(T,A,O,j){const Y=Date.now(),q=F(T,A),{protocol:X,ownsProtocol:ie}=await o(T,A,O,j),se=new P(j);return se.registerDisposable(X.onControlMessage(ae=>{const de=JSON.parse(ae.toString()),re=W(de);re?(T.logService.error(`${q} received error control message when negotiating connection. Error:`),T.logService.error(re),ie&&$(X),se.reject(re)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${z(Y)}!`),se.resolve({protocol:X,firstMessage:de}))})),se.promise}async function i(T,A){const{protocol:O}=await l(T,1,void 0,A);return{protocol:O}}async function s(T,A,O){const{protocol:j,firstMessage:Y}=await l(T,2,A,O),q=Y&&Y.debugPort;return{protocol:j,debugPort:q}}async function r(T,A,O){const j=Date.now(),Y=F(T,3),{protocol:q}=await o(T,3,A,O);return T.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${z(j)}!`),q}async function a(T,A,O){const{host:j,port:Y,connectionToken:q}=await T.addressProvider.getAddress();return{commit:T.commit,host:j,port:Y,connectionToken:q,reconnectionToken:A,reconnectionProtocol:O,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function c(T,A,O){try{const j=(0,f.generateUuid)(),Y=await a(T,j,null),{protocol:q}=await i(Y,k.CancellationToken.None);return new Q(T,A,O,j,q)}catch(j){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(j),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(j)),j}}e.connectRemoteAgentManagement=c;async function p(T,A){try{const O=(0,f.generateUuid)(),j=await a(T,O,null),{protocol:Y,debugPort:q}=await s(j,A,k.CancellationToken.None);return new U(T,A,O,Y,q)}catch(O){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(O),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=p;async function w(T,A){const O=await a(T,(0,f.generateUuid)(),null);return await r(O,{port:A},k.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function D(T){return(0,v.createCancelablePromise)(A=>new Promise((O,j)=>{const Y=setTimeout(O,T*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),O()})}))}var R;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(A,O){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=_;class C{constructor(A,O,j,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.durationSeconds=j,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class G{constructor(A,O,j){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=G;class x{constructor(A,O,j){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=j,this.type=4}}e.ConnectionGainEvent=x;class ne{constructor(A,O,j,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=j,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class K extends n.Disposable{constructor(A,O,j,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=j,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(q=>{const X=B(this._connectionType,this.reconnectionToken,!0);q?q.type===0?(this._options.logService.info(`${X} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${X} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${X} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const q=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${q} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(A,O,j){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=O,this._permanentFailureHandled=j,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const A=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const Y=j<O.length?O[j]:O[O.length-1];try{if(Y>0){const X=D(Y);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,X)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await X}catch{}}if(K._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this._options.logService.info(`${A} resolving connection...`);const q=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,d(b)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,M.isPromiseCanceledError)(q)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,t.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(A,O,j){this._onDidStateChange.fire(new ne(this.reconnectionToken,A,O,j)),$(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class Q extends K{constructor(A,O,j,Y,q){super(1,A,Y,q);this.client=this._register(new m.Client(q,{remoteAuthority:O,clientId:j},A.ipcLogger))}async _reconnect(A,O){await i(A,O)}}e.ManagementPersistentConnection=Q;class U extends K{constructor(A,O,j,Y,q){super(2,A,j,Y);this._startArguments=O,this.debugPort=q}async _reconnect(A,O){await s(A,this._startArguments,O)}}e.ExtensionHostPersistentConnection=U;function $(T){try{T.acceptDisconnect();const A=T.getSocket();T.dispose(),A.dispose()}catch(A){(0,M.onUnexpectedError)(A)}}function W(T){if(T&&T.type==="error"){const A=new Error(`Connection error: ${T.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function N(T,A){for(;T.length<A;)T+=" ";return T}function B(T,A,O){return`[remote-connection][${N(y(T),13)}][${A.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function F(T,A){return`${B(A,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function z(T){return`${Date.now()-T} ms`}}),define(J[73],Z([0,1,10]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=L;function k(m){if(!m)return;const t=m.indexOf("+");return t<0?m:m.substr(0,t)}e.getRemoteName=k;function M(m){return m.scheme!==v.Schemas.file&&m.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=M;function I(m){if(m.folders.length)return m.folders.every(t=>M(t.uri))?m.folders[0].uri:void 0;if(m.configuration&&M(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=I;function n(m){return I(m)?.scheme}e.getVirtualWorkspaceScheme=n;function f(m){return I(m)!==void 0}e.isVirtualWorkspace=f}),define(J[94],Z([0,1,5,3,4,6]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var I;(function(y){y.Http="http",y.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=m,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=t;function b(y,d){return d?d!==1&&y<1024:!L.isWindows&&y<1024}e.isPortPrivileged=b;let E=class{constructor(d){this.logService=d,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],P=Array.from(this._tunnels.values());for(let S of P){const h=Array.from(S.values());for(let u of h){const o=await u.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,P,S,h=!1,u=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${P} on local port ${S}.`),!d)return;g||(g="localhost");const l=this.retainOrCreateTunnel(d,g,P,S,h,u,o);return l?l.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const P=g.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,g,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const S=P.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),S}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const P=this._tunnels.get(d);if(P&&P.has(g)){const S=P.get(g);S.refcount=0,await this.tryDisposeTunnel(d,g,S)}}addTunnelToMap(d,g,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,g){const P=this._tunnels.get(d);P&&(await P.get(g)||P.delete(g),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let P=[d];m(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):t(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const S=P.map(h=>this._tunnels.get(h));for(const h of S){const u=h?.get(g);if(u)return u}}canTunnel(d){return!!f(d)}createWithProvider(d,g,P,S,h,u,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${P} on local port ${S}.`);const i={elevationRequired:h?b(S===void 0?P:S):!1},s={remoteAddress:{host:g,port:P},localAddressPort:S,public:u,protocol:o},r=d.forwardPort(s,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,P,r),r}};E=he([ee(0,M.ILogService)],E),e.AbstractTunnelService=E}),define(J[50],Z([0,1,17,146,49,4,38]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function m(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,v.streamToBuffer)(d.stream)).toString()}e.asText=m;async function t(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const P=(await(0,v.streamToBuffer)(d.stream)).toString();try{return JSON.parse(P)}catch(S){throw S.message+=`:
`+P,S}}e.asJson=t;function b(d){y(d)}e.updateProxyConfigurationsScope=b;let E;function y(d){const g=I.Registry.as(k.Extensions.Configuration);E&&g.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.registerConfiguration(E)}y(2)}),define(J[192],Z([0,1,193,13]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(I,n){return I.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:I.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(I,n,f={}){const m=(0,v.parse)(I),t=f.proxyUrl||k(m,n);if(!t)return null;const b=(0,v.parse)(t);if(!/^https?:$/.test(b.protocol||""))return null;const E={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((y,d)=>{V(["http-proxy-agent"],y,d)}))(E):new(await new Promise((y,d)=>{V(["https-proxy-agent"],y,d)}))(E)}e.getProxyAgent=M}),define(J[194],Z([0,1,17,28]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,I,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await I.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(m){f=null}if(!f){f=(0,L.generateUuid)();try{await I.writeFile(M.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch(m){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(J[74],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,M)=>V(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),I=new M.signer;if(I)return I.sign(k)}catch(M){}return k}}e.SignService=v}),define(J[39],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,9,5,2,3,33,13,4,177,6,39]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class ot extends M.Disposable{constructor(P,S){super();this.logService=P,this.stateMainService=S,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ot.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ot.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",P);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",S),v.app.once("will-quit",h=>{this.logService.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",P),v.app.removeListener("window-all-closed",S),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(S){P.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(P)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let S=this.phaseWhen.get(P);S||(S=new L.Barrier,this.phaseWhen.set(P,S)),await S.wait()}registerWindow(P){const S=new M.DisposableStore;this.windowCounter++,S.add(P.onWillLoad(u=>this._onWillLoadWindow.fire({window:P,workspace:u.workspace,reason:u.reason})));const h=(0,f.assertIsDefined)(P.win);h.on("close",u=>{const o=P.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),u.preventDefault(),this.unload(P,1).then(l=>{if(l){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(P),P.close()})}),h.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,S){await this.unload(P,3)||P.reload(S)}async unload(P,S){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const h=this._quitRequested?2:S;let u=await this.onBeforeUnloadWindowInRenderer(P,h);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(P,h),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,h),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,S){return new Promise(h=>{const u=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${u}`,l=`vscode:cancel${u}`;v.ipcMain.once(o,()=>{h(!1)}),v.ipcMain.once(l,()=>{h(!0)}),P.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:l,reason:S})})}onBeforeUnloadWindowInMain(P,S){const h=[];return this._onBeforeUnloadWindow.fire({reason:S,window:P,veto(u){h.push(u)}}),(0,t.handleVetos)(h,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(P,S){return new Promise(h=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>h()),P.send("vscode:onWillUnload",{replyChannel:o,reason:S})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(ot.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(P?.addArgs&&S.push(...P.addArgs),P?.removeArgs)for(const o of P.removeArgs){const l=S.indexOf(o);l>=0&&S.splice(l,1)}const h=()=>{try{if(I.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:S})};v.app.once("quit",h),await this.quit(!0)&&v.app.removeListener("quit",h)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const S of v.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let h;S.webContents&&!S.webContents.isDestroyed()?h=new Promise(u=>S.once("closed",u)):h=Promise.resolve(),S.destroy(),await h}})()]),v.app.exit(P)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=he([ee(0,b.ILogService),ee(1,E.IStateMainService)],d),e.LifecycleMainService=d}),define(J[196],Z([0,1,5,2,4,22]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let I=class extends L.Disposable{constructor(m){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((t,b)=>{V(["native-keymap"],t,b)});this._keyboardLayoutData=n(m),m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=he([ee(0,M.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function n(f){const m=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:t}}}),define(J[95],Z([0,1,9,5,2,13,84,4]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class E extends k.Disposable{constructor(P={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,S){S===f?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:S,target:this.getKeyTargets(P)[S]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,S,h){return this.getStorage(S)?.get(P,h)}getBoolean(P,S,h){return this.getStorage(S)?.getBoolean(P,h)}getNumber(P,S,h){return this.getStorage(S)?.getNumber(P,h)}store(P,S,h,u){if((0,M.isUndefinedOrNull)(S)){this.remove(P,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,h,u),this.getStorage(h)?.set(P,S)})}remove(P,S){this.withPausedEmitters(()=>{this.updateKeyTarget(P,S,void 0),this.getStorage(S)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,S){const h=[],u=this.getKeyTargets(P);for(const o of Object.keys(u))u[o]===S&&h.push(o);return h}updateKeyTarget(P,S,h){const u=this.getKeyTargets(S);typeof h=="number"?u[P]!==h&&(u[P]=h,this.getStorage(S)?.set(f,JSON.stringify(u))):typeof u[P]=="number"&&(delete u[P],this.getStorage(S)?.set(f,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const S=this.get(f,P);if(S)try{return JSON.parse(S)}catch(h){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(P=m.NONE){this._onWillSaveState.fire({reason:P}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(P,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends E{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=y;async function d(g,P,S,h){const u=c=>{try{return JSON.parse(c)}catch(p){return c}},o=new Map,l=new Map;g.forEach((c,p)=>{o.set(p,c),l.set(p,u(c))});const i=new Map,s=new Map;P.forEach((c,p)=>{i.set(p,c),s.set(p,u(c))}),console.group(`Storage: Global (path: ${S})`);let r=[];o.forEach((c,p)=>{r.push({key:p,value:c})}),console.table(r),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${h})`);let a=[];i.forEach((c,p)=>{a.push({key:p,value:c})}),console.table(a),console.groupEnd(),console.log(s)}e.logStorage=d}),define(J[197],Z([0,1,3,33,7,28]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function n(m,t,b,E,y,d,g,P,S,h){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,M.generateUuid)()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,v.PlatformToString)(v.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=E,u["common.product"]=h||"desktop";const o=f(P||[]);o&&(u["common.msftInternal"]=o);let l=0;const i=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(u["common.snap"]="true");const s=I(b);s&&(u["common.platformDetail"]=s);try{const r=await m.readFile(k.URI.file(S));u["common.source"]=r.value.toString().slice(0,30)}catch(r){}return u}e.resolveCommonProperties=n;function f(m){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const b=t.toLowerCase();return m.some(E=>b===E)}e.verifyMicrosoftInternalDomain=f}),define(J[32],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,63,40,10,8,3,7,66,18,81,70,19,20,32]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(l,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,a=new Map,c=2e4;function p(R,_,C,G){const x=_.substring(R.length+1);return new Promise(async ne=>{let K;try{K=await t.Promises.readdir(_,{withFileTypes:!0})}catch($){ne();return}if(G.count>=c){G.count+=K.length,G.maxReached=!0,ne();return}let Q=K.length;if(Q===0){ne();return}let U=K;G.count+K.length>c&&(G.maxReached=!0,Q=c-G.count,U=K.slice(0,Q)),G.count+=K.length;for(const $ of U)if($.isDirectory()){if(C.includes($.name)||await p(R,(0,I.join)(_,$.name),C,G),--Q==0){ne();return}}else{const W=$.name.lastIndexOf(".");if(W>=0){const N=$.name.substring(W+1);N&&r.set(N,(r.get(N)??0)+1)}for(const N of s)N.relativePathPattern?.test(x)!==!1&&N.filePattern.test($.name)&&a.set(N.tag,(a.get(N.tag)??0)+1);if(--Q==0){ne();return}}})}const w={count:0,maxReached:!1};await p(l,l,i,w);const D=await u(l);return{configFiles:S(a),fileTypes:S(r),fileCount:w.count,maxFilesReached:w.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=P;function S(l){return[...L.Iterable.map(l.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function h(){const l={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=h;async function u(l){try{const i=new Map,s=(0,I.join)(l,".vscode","launch.json"),r=await t.Promises.readFile(s),a=[],c=(0,k.parse)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const p of c.configurations){const w=p.type;w&&(i.has(w)?i.set(w,i.get(w)+1):i.set(w,1))}return S(i)}catch(i){return[]}}e.collectLaunchConfigs=u;let o=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const r=v.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,b.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[a,c]=r,p=this.formatProcessList(i,a);return s.forEach(w=>{if((0,E.isRemoteDiagnosticError)(w))p+=`
${w.errorMessage}`,c+=`
${w.errorMessage}`;else if(p+=`

Remote: ${w.hostName}`,w.processes&&(p+=`
${this.formatProcessList(i,w.processes)}`),w.workspaceMetadata){c+=`
|  Remote: ${w.hostName}`;for(const D of Object.keys(w.workspaceMetadata)){const R=w.workspaceMetadata[D];let _=`${R.fileCount} files`;R.maxFilesReached&&(_=`more than ${_}`),c+=`|    Folder (${D}): ${_}`,c+=this.formatWorkspaceStats(R)}}}),{processInfo:p,workspaceInfo:c}})}async getSystemInfo(i,s){const{memory:r,vmHint:a,os:c,cpus:p}=h(),w={os:c,memory:r,cpus:p,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(w.load=`${v.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(i,s){const r=[];return(0,b.listProcesses)(i.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),s.forEach(c=>{if((0,E.isRemoteDiagnosticError)(c))r.push(`
${c.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${c.hostName}`),r.push(this.formatMachineInfo(c.machineInfo)),c.processes&&r.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const p of Object.keys(c.workspaceMetadata)){const w=c.workspaceMetadata[p];let D=`${w.fileCount} files`;w.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${p}): ${D}`),r.push(this.formatWorkspaceStats(w))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const s=[],r=60;let a=0;const c=(R,_)=>{const C=` ${R}(${_})`;a+C.length>r?(s.push(p),p="|                 ",a=p.length):a+=C.length,p+=C};let p="|      File types:";const w=10;let D=i.fileTypes.length>w?w:i.fileTypes.length;for(let R=0;R<D;R++){const _=i.fileTypes[R];c(_.name,_.count)}if(s.push(p),i.configFiles.length>=0&&(p="|      Conf files:",a=0,i.configFiles.forEach(R=>{c(R.name,R.count)}),s.push(p)),i.launchConfigFiles.length>0){let R="|      Launch Configs:";i.launchConfigFiles.forEach(_=>{R+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],r=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const p=f.URI.revive(c);if(p.scheme===M.Schemas.file){const w=p.fsPath;r.push(P(w,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,I.basename)(w)}): ${R}`),s.push(this.formatWorkspaceStats(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${w} (${D.toString()})`)}))}else s.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,s){const r=new Map;i.windows.forEach(c=>r.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,r,a,s,0),a.join(`
`)}formatProcessItem(i,s,r,a,c){const p=c===0;let w;p?w=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(w=`${w} (${s.get(a.pid)})`));const D=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(a.children)&&a.children.forEach(R=>this.formatProcessItem(i,s,r,R,c+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const r=f.URI.revive(s);if(r.scheme!==M.Schemas.file)continue;const a=r.fsPath;try{const c=await P(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})}),c.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})}),c.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};o=he([ee(0,g.ITelemetryService),ee(1,d.IProductService)],o),e.DiagnosticsService=o}),define(J[199],Z([0,1,25,16,44,3,7,47,168,171,162,19,4,6,20,50,194,95,32]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(u||(u={}));function o(...W){return String(W.reduce((N,B)=>N|B,0))}var l;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class c{constructor(N=a){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,B=this.state.pageSize){return new c({...this.state,pageNumber:N,pageSize:B})}withFilter(N,...B){const F=[...this.state.criteria,...B.length?B.map(z=>({filterType:N,value:z})):[{filterType:N}]];return new c({...this.state,criteria:F})}withSortBy(N){return new c({...this.state,sortBy:N})}withSortOrder(N){return new c({...this.state,sortOrder:N})}withFlags(...N){return new c({...this.state,flags:N.reduce((B,F)=>B|F,0)})}withAssetTypes(...N){return new c({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:B,pageSize:F,sortBy:z,sortOrder:T,flags:A,assetTypes:O}=this.state;return{filters:[{criteria:N,pageNumber:B,pageSize:F,sortBy:z,sortOrder:T}],assetTypes:O,flags:A}}get searchText(){const N=this.state.criteria.filter(B=>B.filterType===l.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function p(W,N){const B=(W||[]).filter(F=>F.statisticName===N)[0];return B?B.value:0}function w(W){const N="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(F=>F.assetType.indexOf(N)===0).reduce((F,z)=>{const T=C(W,z.assetType);return T&&F.push([z.assetType.substring(N.length),T]),F},[])}function D(W){if(W.properties){const N=W.properties.filter(z=>z.key===i.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=N.filter(z=>B.test(z.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return C(W,i.Repository)}function R(W){return{uri:`${W.fallbackAssetUri}/${i.VSIX}?redirect=true`,fallbackUri:`${W.fallbackAssetUri}/${i.VSIX}`}}function _(W){const N=C(W,i.Icon);if(N)return N;const B=f.DefaultIconPath;return{uri:B,fallbackUri:B}}function C(W,N){return W.files.filter(F=>F.assetType===N)[0]?{uri:`${W.assetUri}/${N}`,fallbackUri:`${W.fallbackAssetUri}/${N}`}:null}function G(W,N){const B=W.properties?W.properties.filter(z=>z.key===N):[],F=B.length>0&&B[0].value;return F?F.split(",").map(z=>(0,m.adoptToGalleryExtensionId)(z)):[]}function x(W){const N=W.properties?W.properties.filter(B=>B.key===s.Engine):[];return N.length>0&&N[0].value||""}function ne(W){const N=W.properties?W.properties.filter(F=>F.key===s.LocalizedLanguages):[],B=N.length>0&&N[0].value||"";return B?B.split(","):[]}function K(W){return W.indexOf("preview")!==-1}function Q(W,N,B,F,z){const T={manifest:C(N,i.Manifest),readme:C(N,i.Details),changelog:C(N,i.Changelog),license:C(N,i.License),repository:D(N),download:R(N),icon:_(N),coreTranslations:w(N)};return{identifier:{id:(0,m.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:N.version,date:N.lastUpdated,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,description:W.shortDescription||"",installCount:p(W.statistics,"install"),rating:p(W.statistics,"averagerating"),ratingCount:p(W.statistics,"ratingcount"),assetUri:I.URI.parse(N.assetUri),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),webExtension:!!W.tags?.includes(f.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:A})=>A),assets:T,properties:{dependencies:G(N,s.Dependency),extensionPack:G(N,s.ExtensionPack),engine:x(N),localizedLanguages:ne(N)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+B,querySource:z},preview:K(W.flags)}}let U=class{constructor(N,B,F,z,T,A,O){this.requestService=N,this.logService=B,this.environmentService=F,this.telemetryService=z,this.fileService=T,this.productService=A;const j=A.extensionsGallery;this.extensionsGalleryUrl=j&&j.serviceUrl,this.extensionsControlUrl=j&&j.controlUrl,this.commonHeadersPromise=$(A.version,this.environmentService,this.fileService,O)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,B){const F=[];let{total:z,firstPage:T,getPage:A}=await this.query({names:N,pageSize:N.length},B);F.push(...T);for(let O=1;F.length<z&&(T=await A(O,B),T.length);O++)F.push(...T);return F}async getCompatibleExtension(N,B){return this.getCompatibleExtensionByEngine(N,B)}async getCompatibleExtensionByEngine(N,B){const F=(0,f.isIExtensionIdentifier)(N)?null:N;if(F&&F.properties.engine&&(0,t.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:z,uuid:T}=F?F.identifier:N;let A=new c().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");T?A=A.withFilter(l.ExtensionId,T):A=A.withFilter(l.ExtensionName,z);const{galleryExtensions:O}=await this.queryGallery(A,v.CancellationToken.None),[j]=O;if(!j||!j.versions.length)return null;if(B){const q=j.versions.filter(X=>X.version===B)[0];if(q){const X=Q(j,q,0,A);if(X.properties.engine&&(0,t.isEngineValid)(X.properties.engine,this.productService.version,this.productService.date))return X}return null}const Y=await this.getLastValidExtensionVersion(j,j.versions);return Y?Q(j,Y,0,A):null}async query(N,B){const F=v.CancellationToken.isCancellationToken(N)?{}:N,z=v.CancellationToken.isCancellationToken(N)?N:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let T=F.text||"";const A=(0,k.getOrDefault)(F,ie=>ie.pageSize,50);let O=new c().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,A).withFilter(l.Target,"Microsoft.VisualStudio.Code");T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,ae)=>(O=O.withFilter(l.Category,ae||se),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,ae)=>(O=O.withFilter(l.Tag,ae||se),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(O=O.withFilter(l.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),O=O.withFilter(l.SearchText,T)),O=O.withSortBy(0)):F.ids?O=O.withFilter(l.ExtensionId,...F.ids):F.names?O=O.withFilter(l.ExtensionName,...F.names):O=O.withSortBy(4),typeof F.sortBy=="number"&&(O=O.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(O=O.withSortOrder(F.sortOrder));const{galleryExtensions:j,total:Y}=await this.queryGallery(O,z),q=j.map((ie,se)=>Q(ie,ie.versions[0],se,O,F.source)),X=async(ie,se)=>{if(se.isCancellationRequested)throw(0,L.canceled)();const ae=O.withPage(ie+1),{galleryExtensions:de}=await this.queryGallery(ae,se);return de.map((re,ce)=>Q(re,re.versions[0],ce,ae,F.source))};return{firstPage:q,total:Y,pageSize:O.pageSize,getPage:X}}async queryGallery(N,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,u.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,o(u.Unpublished));const F=await this.commonHeadersPromise,z=JSON.stringify(N.raw),T={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(z.length)},A=new Date().getTime();let O,j,Y=0;try{if(O=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:z,headers:T},B),O.res.statusCode&&O.res.statusCode>=400&&O.res.statusCode<500)return{galleryExtensions:[],total:Y};const q=await(0,g.asJson)(O);if(q){const X=q.results[0],ie=X.extensions,se=X.resultMetadata&&X.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Y=se&&se.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:ie,total:Y}}return{galleryExtensions:[],total:Y}}catch(q){throw j=q,q}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(z.length),duration:new Date().getTime()-A,success:!!O&&(0,g.isSuccess)(O),responseBodySize:O?.res.headers["Content-Length"],statusCode:O?String(O.res.statusCode):void 0,errorCode:j?(0,L.isPromiseCanceledError)(j)?"canceled":(0,L.getErrorMessage)(j).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Y)})}}async reportStatistic(N,B,F,z){if(!this.isEnabled())return;const T=M.isWeb?this.api(`/itemName/${N}.${B}/version/${F}/statType/${z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${B}/${F}/stats?statType=${z}`),A=M.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",j={...await this.commonHeadersPromise,Accept:A};try{await this.requestService.request({type:"POST",url:T,headers:j},v.CancellationToken.None)}catch(Y){}}async download(N,B,F){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const z=(0,m.getGalleryExtensionTelemetryData)(N),T=new Date().getTime(),A=q=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...z,duration:q}),O=F===1?"install":F===2?"update":"",j=O?{uri:`${N.assets.download.uri}&${O}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${O}=true`}:N.assets.download,Y=await this.getAsset(j);await this.fileService.writeFile(B,Y.stream),A(new Date().getTime()-T)}async getReadme(N,B){if(N.assets.readme){const F=await this.getAsset(N.assets.readme,{},B);return await(0,g.asText)(F)||""}return""}async getManifest(N,B){if(N.assets.manifest){const F=await this.getAsset(N.assets.manifest,{},B),z=await(0,g.asText)(F);return z?JSON.parse(z):null}return null}async getCoreTranslation(N,B){const F=N.assets.coreTranslations.filter(z=>z[0]===B.toUpperCase())[0];if(F){const z=await this.getAsset(F[1]),T=await(0,g.asText)(z);return T?JSON.parse(T):null}return null}async getChangelog(N,B){if(N.assets.changelog){const F=await this.getAsset(N.assets.changelog,{},B);return await(0,g.asText)(F)||""}return""}async getAllVersions(N,B){let F=new c().withFlags(u.IncludeVersions,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?F=F.withFilter(l.ExtensionId,N.identifier.uuid):F=F.withFilter(l.ExtensionName,N.identifier.id);const z=[],{galleryExtensions:T}=await this.queryGallery(F,v.CancellationToken.None);return T.length&&(B?await Promise.all(T[0].versions.map(async A=>{let O;try{O=await this.getEngine(A)}catch(j){}O&&(0,t.isEngineValid)(O,this.productService.version,this.productService.date)&&z.push({version:A.version,date:A.lastUpdated})})):z.push(...T[0].versions.map(A=>({version:A.version,date:A.lastUpdated})))),z}async getAsset(N,B={},F=v.CancellationToken.None){const z=await this.commonHeadersPromise,T={type:"GET"},A={...z,...B.headers||{}};B={...B,...T,headers:A};const O=N.uri,j=N.fallbackUri,Y={...B,url:O};try{const q=await this.requestService.request(Y,F);if(q.res.statusCode===200)return q;const X=await(0,g.asText)(q);throw new Error(`Expected 200, got back ${q.res.statusCode} instead.

${X}`)}catch(q){if((0,L.isPromiseCanceledError)(q))throw q;const X=(0,L.getErrorMessage)(q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:O,message:X});const ie={...B,url:j};return this.requestService.request(ie,F)}}async getLastValidExtensionVersion(N,B){const F=this.getLastValidExtensionVersionFromProperties(N,B);return F||this.getLastValidExtensionVersionRecursively(N,B)}getLastValidExtensionVersionFromProperties(N,B){for(const F of B){const z=x(F);if(!z)return null;if((0,t.isEngineValid)(z,this.productService.version,this.productService.date))return F}return null}async getEngine(N){const B=x(N);if(B)return B;const F=C(N,i.Manifest);if(!F)throw new Error("Manifest was not found");const z={"Accept-Encoding":"gzip"},T=await this.getAsset(F,{headers:z}),A=await(0,g.asJson)(T);if(A)return A.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,B){if(!B.length)return null;const F=B[0],z=await this.getEngine(F);return(0,t.isEngineValid)(z,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:s.Engine,value:z}]}:this.getLastValidExtensionVersionRecursively(N,B.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},v.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,g.asJson)(N),F=new Map;if(B)for(const z of B.malicious){const T=F.get(z)||{id:{id:z},malicious:!0,slow:!1};T.malicious=!0,F.set(z,T)}return[...F.values()]}};U=he([ee(0,g.IRequestService),ee(1,y.ILogService),ee(2,n.IEnvironmentService),ee(3,h.ITelemetryService),ee(4,b.IFileService),ee(5,d.IProductService),ee(6,(0,E.optional)(S.IStorageService))],U),e.ExtensionGalleryService=U;async function $(W,N,B,F){const z={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W}`},T=await(0,P.getServiceMachineId)(N,B,F);return z["X-Market-User-Id"]=T,z}e.resolveMarketplaceHeaders=$}),define(J[200],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(M){this.appender=M}listen(M,I){throw new Error(`Event not found: ${I}`)}call(M,I,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(M){this.channel=M}log(M,I){return this.channel.call("log",{eventName:M,data:I}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[201],Z([0,1,2,44,23,147,21,49,4,48,38]),function(V,e,v,L,k,M,I,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const S=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!S})}))}setExperimentProperty(d,g){this._experimentProperties[d]=g}setEnabled(d){this._enabled=d}_updateUserOptIn(){const d=this._configurationService?.getValue(E);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,P=d["common.instanceId"],S=d["common.machineId"],h=d["common.firstSessionDate"],u=d["common.msftInternal"];return{sessionId:g,instanceId:P,machineId:S,firstSessionDate:h,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(d,g,P){return this.isOptedIn?this._commonProperties.then(S=>{g=(0,L.mixin)(g,S),g=(0,L.mixin)(g,this._experimentProperties),g=(0,L.cloneAndChange)(g,h=>{if(typeof h=="string")return this._cleanupInfo(h,P)}),this._appender.log(d,g)},S=>{console.error(S)}):Promise.resolve(void 0)}publicLog2(d,g,P){return this.publicLog(d,g,P)}publicLogError(d,g){return this.sendErrorTelemetry?this.publicLog(d,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_cleanupInfo(d,g){let P=d;if(g){const S=[];for(let l of this._cleanupPatterns)for(;;){const i=l.exec(d);if(!i)break;S.push([i.index,l.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const l=u.exec(d);if(!l)break;!h.test(l[0])&&S.every(([i,s])=>l.index<i||l.index>=s)&&(P+=d.substring(o,l.index)+"<REDACTED: user-file-path>",o=u.lastIndex)}o<d.length&&(P+=d.substr(o))}for(let S of this._cleanupPatterns)P=P.replace(S,"");return P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=he([ee(1,(0,f.optional)(I.IConfigurationService))],b),e.TelemetryService=b;const E="telemetry";t.Registry.as(n.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,M.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,M.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[96],Z([0,1,9,44,13,21]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,g){return Promise.resolve(void 0)}publicLog2(d,g){return this.publicLog(d,g)}publicLogError(d,g){return Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class I{async publicLog(g,P,S){}async publicLogError(g,P,S){}}e.NullEndpointTelemetryService=I;function n(...d){return{log:(g,P)=>d.forEach(S=>S.log(g,P)),flush:()=>v.Promises.settled(d.map(g=>g.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(d,g){return g.onDidChangeConfiguration(P=>{P.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:E(P.sourceConfig)})})}e.configurationTelemetry=f;function m(d){const g=Object.create(null),P=Object.create(null),S=Object.create(null);b(d,S);for(let h in S){h=h.length>150?h.substr(h.length-149):h;const u=S[h];typeof u=="number"?P[h]=u:typeof u=="boolean"?P[h]=u?1:0:typeof u=="string"?g[h]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(g[h]=u)}return{properties:g,measurements:P}}e.validateTelemetryData=m;function t(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{d.indexOf(`${S}+`)===0&&(g=S)}),g}e.cleanRemoteAuthority=t;function b(d,g,P=0,S){if(!!d)for(let h of Object.getOwnPropertyNames(d)){const u=d[h],o=S?S+h:h;Array.isArray(u)?g[o]=(0,L.safeStringify)(u):u instanceof Date?g[o]=u.toISOString():(0,k.isObject)(u)?P<2?b(u,g,P+1,o+"."):g[o]=(0,L.safeStringify)(u):g[o]=u}}function E(d){if(!d)return[];const g=[];return y(g,"",d),g}function y(d,g,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(S=>y(d,g?`${g}.${S}`:S,P[S])):d.push(g)}}),define(J[202],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,108,5,2,4,38,202]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(P){function S(h){return h&&typeof h=="object"&&typeof h.id=="string"}P.isThemeColor=S})(f=e.ThemeColor||(e.ThemeColor={}));function m(P){return{id:P}}e.themeColorFromId=m;var t;(function(P){function S(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||f.isThemeColor(s.color))}P.isThemeIcon=S;const h=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const r=h.exec(s);if(!r)return;let[,a]=r;return{id:a}}P.fromString=u;function o(s,r){let a=s.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),r&&(a=`${a}~${r}`),{id:a}}P.modify=o;function l(s,r){return s.id===r.id&&s.color?.id===r.color?.id}P.isEqual=l;function i(s,r){return{id:s.id,color:r?m(r):void 0}}P.asThemeIcon=i,P.asClassNameArray=v.CSSIcon.asClassNameArray,P.asClassName=v.CSSIcon.asClassName,P.asCSSSelector=v.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function b(P){switch(P){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,k.toDisposable)(()=>{const h=this.themingParticipants.indexOf(S);this.themingParticipants.splice(h,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new E;I.Registry.add(e.Extensions.ThemingContribution,y);function d(P){return y.onColorThemeChange(P)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(h=>this.onThemeChange(h)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,h){let u=this.theme.getColor(S);return u&&h&&(u=h(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(J[60],Z([0,1,14,3,4,39]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",n="#1E1E1E",f="#000000",m="theme",t="themeBackground",b="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let E=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(m,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?I:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:m,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:b,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const P of v.BrowserWindow.getAllWindows())if(P.id===d){P.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};E=he([ee(0,M.IStateMainService)],E),e.ThemeMainService=E}),define(J[42],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,I)=>({type:"idle",updateType:M,error:I}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(J[204],Z([0,1,3,148,49,38]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,5,42]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,m){switch(f){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(J[97],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(J[206],Z([0,1,7]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,m){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,m,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(m){const b=v.URI.revive(m);if(b&&b.query){const E=/\bwindowId=(\d+)/.exec(b.query);if(E){const y=E[1],d=new RegExp(`window:${y}`),g=n.connections.find(P=>d.test(P.ctx));if(g)return g}}}return this.next.routeCall(n,f,m,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(J[207],Z([0,1,9,2,7,20]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,t){const b=[...this.handlers.values()];return(0,v.first)(b.map(E=>()=>E.handleURL(m,t)),void 0,!1).then(E=>E||!1)}registerHandler(m){return this.handlers.add(m),(0,L.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=I;let n=class extends I{constructor(m){super();this.productService=m}create(m){let{authority:t,path:b,query:E,fragment:y}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&b&&b.indexOf("/")!==0&&(b=`/${b}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:b,query:E,fragment:y})}};n=he([ee(0,M.IProductService)],n),e.NativeURLService=n}),define(J[208],Z([0,1,14,9,5,2,3,7]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(b){return null}}class m{constructor(b,E,y,d,g){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=b,I.isWindows){const h=d.isBuilt?[]:[`"${d.appRoot}"`];h.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,h)}const P=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(h,u)=>({event:h,url:u})),({event:h,url:u})=>(h.preventDefault(),u));this.disposables.add(P(h=>{const u=f(h);!u||this.urlService.open(u,{originalUrl:h})})),y.getWindows().filter(h=>h.isReady).length>0?this.flush():k.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||b.push(E);b.length!==0&&(this.uris=b,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[209],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(J[210],Z([0,1,14,2,10,7]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class I extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,m){try{const t=M.URI.parse(f.url),b=I.validWebviewFilePaths.get(t.path);if(typeof b=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${b}`,y=k.FileAccess.asFileUri(E,V);return m(decodeURIComponent(y.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=I,I.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(m){return!!m.workspaceUri}e.isWorkspaceToOpen=L;function k(m){return!!m.folderUri}e.isFolderToOpen=k;function M(m){return!!m.fileUri}e.isFileToOpen=M;function I(m){const t=n(m),b=m.getValue("window.menuBarVisibility");return b==="default"||t==="native"&&b==="compact"||v.isMacintosh&&v.isNative?"classic":b}e.getMenuBarVisibility=I;function n(m){if(v.isWeb)return"custom";const t=m.getValue("window");if(t){if(v.isMacintosh&&t.nativeTabs===!0||v.isMacintosh&&t.nativeFullScreen===!1)return"native";const y=t.titleBarStyle;if(y==="native"||y==="custom")return y}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=f}),define(J[35],Z([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(m){m[m.INITIAL=1]="INITIAL",m[m.LOAD=2]="LOAD",m[m.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(m){m[m.CLOSE=1]="CLOSE",m[m.QUIT=2]="QUIT",m[m.RELOAD=3]="RELOAD",m[m.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const I=function(m=1){return{width:1024,height:768,mode:m}};e.defaultWindowState=I;var n;(function(m){m[m.Maximized=0]="Maximized",m[m.Normal=1]="Normal",m[m.Minimized=2]="Minimized",m[m.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(m){m[m.UNRESPONSIVE=1]="UNRESPONSIVE",m[m.CRASHED=2]="CRASHED",m[m.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,5,2,210,35]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,t){let b;if(typeof m.windowId=="number"){const{windowId:E}=m,y=this.windowsMainService.getWindowById(E);if(!y?.win)throw new Error(`Invalid windowId: ${E}`);b=y.win.webContents}else{const{webContentsId:E}=m;if(b=v.webContents.fromId(E),!b)throw new Error(`Invalid webContentsId: ${E}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(t)}async findInFrame(m,t,b,E){const y=this.getFrameByName(m,t),d=y;if(typeof d.findInFrame=="function"){d.findInFrame(b,{findNext:E.findNext,forward:E.forward});const g=(P,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(m,t,b){const y=this.getFrameByName(m,t);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,t){const b=this.windowsMainService.getWindowById(m.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${m}`);const E=b.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===t);if(!E)throw new Error(`Unknown frame: ${t}`);return E}};n=he([ee(0,I.IWindowsMainService)],n),e.WebviewMainService=n}),define(J[212],Z([0,1,9,5,2]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:m}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(J[213],Z([0,1,37,15,7,4]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var I;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const y=E;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function f(E){const y=E;return!!(y&&typeof y=="object"&&k.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class m{constructor(y,d,g,P){this._id=y,this._configuration=g,this._ignorePathCasing=P,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=m;class t{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function b(E){return new t({uri:E,index:0,name:(0,L.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=b}),define(J[27],Z([0,1,29,40,76,31,10,8,3,15,7,151,4,73,213]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(U){return(typeof U=="string"?(0,n.extname)(U):(0,m.extname)(U))===g}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function S(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function h(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=h;function u(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=u;function o(U){const $=U;return typeof $?.id=="string"&&t.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=l;function i(U){const $=U;return typeof $?.id=="string"&&t.URI.isUri($.configPath)}e.isWorkspaceIdentifier=i;function s(U){const $=U;if($?.uri)return{id:$.id,uri:t.URI.revive($.uri)};const W=U;if(W?.configPath)return{id:W.id,configPath:t.URI.revive(W.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,$){return m.extUriBiasedIgnorePathCase.isEqualOrParent(U,$.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(U){return c(U)||p(U)}e.isStoredWorkspaceFolder=a;function c(U){const $=U;return typeof $?.path=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=c;function p(U){const $=U;return typeof $?.uri=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=p;function w(U,$,W,N,B=!f.isWindows,F){if(U.scheme!==N.scheme)return{name:W,uri:U.toString(!0)};let z=$?void 0:F.relativePath(N,U);if(z!==void 0)z.length===0?z=".":f.isWindows&&U.scheme===I.Schemas.file&&!B&&(z=z.replace(/\//g,"\\"));else if(U.scheme===I.Schemas.file)z=U.fsPath,f.isWindows&&(z=(0,M.normalizeDriveLetter)(z),B&&(z=(0,v.toSlashes)(z)));else{if(!F.isEqualAuthority(U.authority,N.authority))return{name:W,uri:U.toString(!0)};z=U.path}return{name:W,path:z}}e.getStoredWorkspaceFolder=w;function D(U,$,W){let N=[],B=new Set;const F=W.dirname($);for(let z of U){let T;if(c(z))z.path&&(T=W.resolvePath(F,z.path));else if(p(z))try{T=t.URI.parse(z.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(A){console.warn(A)}if(T){let A=W.getComparisonKey(T);if(!B.has(A)){B.add(A);const O=z.name||W.basenameOrAuthority(T);N.push(new d.WorkspaceFolder({uri:T,name:O,index:N.length},z))}}}return N}e.toWorkspaceFolders=D;function R(U,$,W,N,B){let F=_($,U);const z=B.dirname($),T=B.dirname(N),A=[],O=C(F.folders);for(const X of F.folders){const ie=c(X)?B.resolvePath(z,X.path):t.URI.parse(X.uri);let se;W?se=!1:se=!c(X)||(0,n.isAbsolute)(X.path),A.push(w(ie,se,X.name,T,O,B))}const j={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},Y=k.setProperty(U,["folders"],A,j);let q=k.applyEdits(U,Y);return F.remoteAuthority===(0,y.getRemoteAuthority)(N)&&(q=k.applyEdits(q,k.removeProperty(q,["remoteAuthority"],j))),q}e.rewriteWorkspaceFileForNewLocation=R;function _(U,$){let W=L.parse($);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(N=>a(N));else throw new Error(`${U} looks like an invalid workspace file.`);return W}function C(U){return f.isWindows?U.some($=>c($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function G(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function x(U){return typeof U.folderUri=="string"}function ne(U){return typeof U.fileUri=="string"}function K(U,$){const W={workspaces:[],files:[]};if(U){const N=function(F,z){for(let T=0;T<F.length;T++)try{z(F[T],T)}catch(A){$.warn(`Error restoring recent entry ${JSON.stringify(F[T])}: ${A.toString()}. Skip entry.`)}},B=U;if(Array.isArray(B.entries))N(B.entries,F=>{const z=F.label,T=F.remoteAuthority;G(F)?W.workspaces.push({label:z,remoteAuthority:T,workspace:{id:F.workspace.id,configPath:t.URI.parse(F.workspace.configPath)}}):x(F)?W.workspaces.push({label:z,remoteAuthority:T,folderUri:t.URI.parse(F.folderUri)}):ne(F)&&W.files.push({label:z,remoteAuthority:T,fileUri:t.URI.parse(F.fileUri)})});else{const F=U;Array.isArray(F.workspaces3)&&N(F.workspaces3,(z,T)=>{const A=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[T]||void 0;typeof z=="object"&&typeof z.id=="string"&&typeof z.configURIPath=="string"?W.workspaces.push({label:A,workspace:{id:z.id,configPath:t.URI.parse(z.configURIPath)}}):typeof z=="string"&&W.workspaces.push({label:A,folderUri:t.URI.parse(z)})}),Array.isArray(F.files2)&&N(F.files2,(z,T)=>{const A=Array.isArray(F.fileLabels)&&F.fileLabels[T]||void 0;typeof z=="string"&&W.files.push({label:A,fileUri:t.URI.parse(z)})})}}return W}e.restoreRecentlyOpened=K;function Q(U){const $={entries:[]};for(const W of U.workspaces)h(W)?$.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):$.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of U.files)$.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return $}e.toStoreData=Q}),define(J[51],Z([0,1,4,27]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function k(M){const I=M;return I&&(0,L.isWorkspaceIdentifier)(I.workspace)}e.isWorkspaceBackupInfo=k}),define(J[52],Z([0,1,14,9,78,31,2,65,8,3,13,18,133,4,39,27]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let P=class gt{constructor(h){this.stateMainService=h,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,u){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},u)}pickFolder(h,u){return this.doPick({...h,pickFolders:!0,title:(0,E.localize)(1,null)},u)}pickFile(h,u){return this.doPick({...h,pickFiles:!0,title:(0,E.localize)(2,null)},u)}pickWorkspace(h,u){const o=(0,E.localize)(3,null),l=(0,M.mnemonicButtonLabel)((0,E.localize)(4,null)),i=g.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:o,filters:i,buttonLabel:l},u)}async doPick(h,u){const o={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};o.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(o.properties=void 0,h.pickFiles&&h.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&o.properties.push("treatPackageAsDirectory");const l=u||v.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(o,(0,t.withNullAsUndefined)(l));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(h){if(h){let u=this.windowDialogQueues.get(h.id);return u||(u=new L.Queue,this.windowDialogQueues.set(h.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(h,u){return this.getWindowDialogQueue(u).queue(async()=>u?v.dialog.showMessageBox(u,h):v.dialog.showMessageBox(h))}async showSaveDialog(h,u){const o=this.acquireFileDialogLock(h,u);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await v.dialog.showSaveDialog(u,h):l=await v.dialog.showSaveDialog(h),l.filePath=this.normalizePath(l.filePath),l})}finally{(0,I.dispose)(o)}}normalizePath(h){return h&&m.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(u=>this.normalizePath(u))}async showOpenDialog(h,u){h.defaultPath&&(await b.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const o=this.acquireFileDialogLock(h,u);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await v.dialog.showOpenDialog(u,h):l=await v.dialog.showOpenDialog(h),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{(0,I.dispose)(o)}}acquireFileDialogLock(h,u){if(!u)return I.Disposable.None;let o=this.windowFileDialogLocks.get(u.id);o||(o=new Set,this.windowFileDialogLocks.set(u.id,o));const l=(0,k.hash)(h);if(!o.has(l))return o.add(l),(0,I.toDisposable)(()=>{o?.delete(l),o?.size===0&&this.windowFileDialogLocks.delete(u.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=he([ee(0,d.IStateMainService)],P),e.DialogMainService=P}),define(J[214],Z([0,1,5,2,27]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,m=new Set;return n.forEach(t=>{const b=this.storageMainService.globalStorage.get(t.key);typeof b=="string"?f.set(t.key,b):m.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(m.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,m){const t=(0,k.reviveIdentifier)(m.workspace),b=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(b.items.entries());case"updateItems":{const E=m;if(E.insert)for(const[y,d]of E.insert)b.set(y,d);E.delete&&E.delete.forEach(y=>b.delete(y));break}case"close":{if(t)return b.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${m}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,5,2,8,28,18,84,123,6,95,32,27]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends L.Disposable{constructor(S){super();this.logService=S,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const S=await this.doCreate();this.storage.dispose(),this.storage=S,this._register(S.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(S);const h=S.getBoolean(t.IS_NEW_KEY);h===void 0?S.set(t.IS_NEW_KEY,!0):h&&S.set(t.IS_NEW_KEY,!1)}catch(S){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${S}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===m.LogLevel.Trace?S=>this.logService.trace(S):void 0,logError:S=>this.logService.error(S)}}doInit(S){return S.init()}get items(){return this.storage.items}get(S,h){return this.storage.get(S,h)}set(S,h){return this.storage.set(S,h)}delete(S){return this.storage.delete(S)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(S,h,u){super(h);this.options=S,this.environmentService=u}async doCreate(){let S;return this.options.useInMemoryStorage?S=f.SQLiteStorageDatabase.IN_MEMORY_PATH:S=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLogginOptions()}))}async doInit(S){await super.doInit(S),this.updateTelemetryState(S)}updateTelemetryState(S){S.get(b.instanceStorageKey,void 0)===void 0&&S.set(b.instanceStorageKey,(0,M.generateUuid)()),S.get(b.firstSessionDateStorageKey,void 0)===void 0&&S.set(b.firstSessionDateStorageKey,new Date().toUTCString());const o=S.get(b.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();S.set(b.lastSessionDateStorageKey,typeof o=="undefined"?null:o),S.set(b.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends y{constructor(S,h,u,o){super(u);this.workspace=S,this.options=h,this.environmentService=o}async doCreate(){const{storageFilePath:S,wasCreated:h}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLogginOptions()}),{hint:h?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const S=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),h=(0,k.join)(S,g.WORKSPACE_STORAGE_NAME);return await I.Promises.exists(S)?{storageFilePath:h,wasCreated:!1}:(await I.Promises.mkdir(S,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(S),{storageFilePath:h,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(S){let h;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?h={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(h={workspace:this.workspace.configPath.toString()}),h)try{const u=(0,k.join)(S,g.WORKSPACE_META_NAME);await I.Promises.exists(u)||await I.Promises.writeFile(u,JSON.stringify(h,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(J[98],Z([0,1,43,2,47,4,22,6,215]),function(V,e,v,L,k,M,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let m=class extends L.Disposable{constructor(b,E,y){super();this.logService=b,this.environmentService=E,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)b.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new f.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let E=this.mapWorkspaceToStorage.get(b.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),E=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),E}};m=he([ee(0,n.ILogService),ee(1,k.IEnvironmentService),ee(2,I.ILifecycleMainService)],m),e.StorageMainService=m}),define(J[99],Z([0,1,15,7,27]),function(V,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,m,t){for(const E of f){const y=E.openedWorkspace;if((0,k.isWorkspaceIdentifier)(y)){const d=t(y);if(d){if(d.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.uri)))return E}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.configPath))return E}}const b=f.filter(E=>(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.openedWorkspace.uri));if(b.length)return b.sort((E,y)=>-(E.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function I(f,m){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,m))return t}e.findWindowOnWorkspaceOrFolder=I;function n(f,m){const t=b=>m.some(E=>v.extUriBiasedIgnorePathCase.isEqual(L.URI.file(E),L.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(E=>t(E)))return b}e.findWindowOnExtensionDevelopmentPath=n}),define(J[216],Z([0,1,14,2,3,15,7,21,22,6,39,35,27]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends L.Disposable{constructor(u,o,l,i,s){super();this.windowsMainService=u,this.stateMainService=o,this.lifecycleMainService=l,this.logService=i,this.configurationService=s,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(u.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const l=P(u);this.stateMainService.setItem(mt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{const i=(0,E.isWorkspaceIdentifier)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,s=(0,E.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&l.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(i||s)&&(l.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(u){return{workspace:(0,E.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const o=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(u){const o=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=u.workspace;if((0,E.isWorkspaceIdentifier)(c)){const w=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(w.length)return w[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(c)){const w=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(w.length)return w[0]}else if(u.backupPath){const w=this.state.openedWindows.filter(D=>D.backupPath===u.backupPath).map(D=>D.uiState);if(w.length)return w[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!o&&p)return p.uiState}let l;const i=v.screen.getAllDisplays();if(i.length===1)l=i[0];else{if(k.isMacintosh){const c=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(c)}!l&&o&&(l=v.screen.getDisplayMatching(o.getBounds())),l||(l=v.screen.getPrimaryDisplay()||i[0])}let s=(0,b.defaultWindowState)();s.x=Math.round(l.bounds.x+l.bounds.width/2-s.width/2),s.y=Math.round(l.bounds.y+l.bounds.height/2-s.height/2);const r=this.configurationService.getValue("window");let a=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")s.mode=0,a=!1;else if(r.newWindowDimensions==="fullscreen")s.mode=3,a=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const c=o.serializeWindowState();c.mode===3?s.mode=3:s=c,a=s.mode!==3&&r.newWindowDimensions==="offset"}}return a&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const o=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;o.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};y.windowsStateStorageKey="windowsState",y=he([ee(0,b.IWindowsMainService),ee(1,t.IStateMainService),ee(2,f.ILifecycleMainService),ee(3,m.ILogService),ee(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(h){const u={openedWindows:[]},o=h||{openedWindows:[]};return o.lastActiveWindow&&(u.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(u.openedWindows=o.openedWindows.map(l=>g(l))),u}e.restoreWindowsState=d;function g(h){const u={uiState:h.uiState};return h.backupPath&&(u.backupPath=h.backupPath),h.remoteAuthority&&(u.remoteAuthority=h.remoteAuthority),h.folder&&(u.folderUri=I.URI.parse(h.folder)),h.workspaceIdentifier&&(u.workspace={id:h.workspaceIdentifier.id,configPath:I.URI.parse(h.workspaceIdentifier.configURIPath)}),u}function P(h){return{lastActiveWindow:h.lastActiveWindow&&S(h.lastActiveWindow),lastPluginDevelopmentHostWindow:h.lastPluginDevelopmentHostWindow&&S(h.lastPluginDevelopmentHostWindow),openedWindows:h.openedWindows.map(u=>S(u))}}e.getWindowsStateStoreData=P;function S(h){return{workspaceIdentifier:h.workspace&&{id:h.workspace.id,configURIPath:h.workspace.configPath.toString()},folder:h.folderUri&&h.folderUri.toString(),backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.uiState}}}),define(J[100],Z([0,1,58,30,10,3,15]),function(V,e,v,L,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(m){function t(){let b=m.scheme===k.Schemas.file?(0,I.originalFSPath)(m):m.toString();return M.isLinux||(b=b.toLowerCase()),(0,v.createHash)("md5").update(b).digest("hex")}return{id:t(),configPath:m}}e.getWorkspaceIdentifier=n;function f(m,t){function b(){if(m.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(m.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(m.fsPath)}catch(d){return}let y;return M.isLinux?y=t.ino:M.isMacintosh?y=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?y=Math.floor(t.birthtimeMs):y=t.birthtime.getTime()),(0,v.createHash)("md5").update(m.fsPath).update(y?String(y):"").digest("hex")}const E=b();if(typeof E=="string")return{id:E,uri:m}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[56],Z([0,1,58,59,26,17,16,5,2,8,3,28,34,82,217]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(w){this.socket=w,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const D=R=>w(M.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(w){const D=R=>{w({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(w){return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(w){if(!this.socket.destroyed)try{this.socket.write(w.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((w,D)=>{if(this.socket.bufferSize===0){w();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),w()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var P;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var S;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(S||(S={}));class h extends f.Disposable{constructor(w,D,R,_){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=w,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=_,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,I.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,I.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new y.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._totalOutgoingDataBytes+=w.byteLength,this._zlibDeflate?(this._zlibDeflate.write(w.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(w,!1)}_write(w,D){let R=2;w.byteLength<126?R+=0:w.byteLength<2**16?R+=2:R+=8;const _=M.VSBuffer.alloc(R);if(D?_.writeUInt8(194,0):_.writeUInt8(130,0),w.byteLength<126)_.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){_.writeUInt8(126,1);let C=1;_.writeUInt8(w.byteLength>>>8&255,++C),_.writeUInt8(w.byteLength>>>0&255,++C)}else{_.writeUInt8(127,1);let C=1;_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(w.byteLength>>>24&255,++C),_.writeUInt8(w.byteLength>>>16&255,++C),_.writeUInt8(w.byteLength>>>8&255,++C),_.writeUInt8(w.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=_.byteLength+w.byteLength,this.socket.write(M.VSBuffer.concat([_,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._totalIncomingWireBytes+=w.byteLength,this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),_=(D.readUInt8(0)&128)>>>7,C=D.readUInt8(1),G=(C&128)>>>7,x=C&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=_,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),_=(R&128)>>>7;let C=R&127,G=1;C===126?C=D.readUInt8(++G)*2**8+D.readUInt8(++G):C===127&&(C=D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G));let x=0;_&&(x=D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G)),this._state.state=3,this._state.readLen=C,this._state.mask=x}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);u(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=h;function u(p,w){if(w===0)return;let D=p.byteLength>>>2;for(let ne=0;ne<D;ne++){const K=p.readUInt32BE(ne*4);p.writeUInt32BE(K^w,ne*4)}let R=D*4,_=p.byteLength-R;const C=w>>>24&255,G=w>>>16&255,x=w>>>8&255;_>=1&&p.writeUInt8(p.readUInt8(R)^C,R),_>=2&&p.writeUInt8(p.readUInt8(R+1)^G,R+1),_>=3&&p.writeUInt8(p.readUInt8(R+2)^x,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function l(){const p=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):w=(0,m.join)((0,k.tmpdir)(),`vscode-ipc-${p}.sock`),s(w),w}e.createRandomIPCHandle=l;function i(p,w,D){const R=(0,v.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${w}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${w}.sock`):_=(0,m.join)(p,`${D}-${w}.sock`),s(_),_}e.createStaticIPCHandle=i;function s(p){const w=o[t.platform];typeof w=="number"&&p.length>=w&&console.warn(`WARNING: IPC handle "${p}" is longer than ${w} chars, try a shorter --user-data-dir`)}class r extends E.IPCServer{constructor(w){super(r.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const D=n.Event.fromNodeEventEmitter(w,"connection");return n.Event.map(D,R=>({protocol:new y.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(p){return new Promise((w,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(p,()=>{R.removeListener("error",D),w(new r(R))})})}e.serve=a;function c(p,w){return new Promise((D,R)=>{const _=(0,L.createConnection)(p,()=>{_.removeListener("error",R),D(y.Client.fromSocket(new g(_),w))});_.once("error",R)})}e.connect=c}),define(J[218],Z([0,1,56]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,m){throw new Error("No event found")}call(f,m,t){switch(m){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${m}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,m){return this.channel.call("dispatchKeybinding",[f,m])}click(f,m,t,b){return this.channel.call("click",[f,m,t,b])}doubleClick(f,m){return this.channel.call("doubleClick",[f,m])}setValue(f,m,t){return this.channel.call("setValue",[f,m,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,m){return this.channel.call("isActiveElement",[f,m])}getElements(f,m,t){return this.channel.call("getElements",[f,m,t])}getElementXY(f,m,t,b){return this.channel.call("getElementXY",[f,m,t,b])}typeInEditor(f,m,t){return this.channel.call("typeInEditor",[f,m,t])}getTerminalBuffer(f,m){return this.channel.call("getTerminalBuffer",[f,m])}writeInTerminal(f,m,t){return this.channel.call("writeInTerminal",[f,m,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,m){throw new Error(`Event not found: ${m}`)}call(f,m,t){switch(m){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${m}`)}}e.WindowDriverRegistryChannel=M;async function I(n){const f=await(0,v.connect)(n,"driverClient"),m=f.getChannel("driver"),t=new k(m);return{client:f,driver:t}}e.connect=I}),define(J[219],Z([0,1,9,5,106,57,2,3,77,34,56,155,218,176,22,35]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(u){return u<21}let S=class{constructor(o,l,i,s){this.windowServer=o,this.options=l,this.windowsMainService=i,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const l=this.windowsMainService.getWindowById(o);if(!l?.win)throw new Error("Invalid window");return(await l.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const l=this.windowsMainService.getWindowById(o);if(!l)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(l)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,l){await this.whenUnfrozen(o);const i=k.KeybindingParser.parseUserBinding(l);for(let s of i)await this._dispatchKeybinding(o,s)}async _dispatchKeybinding(o,l){if(l instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const s=i.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,l.keyCode),c=new y.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),p=[];l.ctrlKey&&p.push("ctrl"),l.metaKey&&p.push("meta"),l.shiftKey&&p.push("shift"),l.altKey&&p.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:c,modifiers:p}),P(l.keyCode)||s.sendInputEvent({type:"char",keyCode:c,modifiers:p}),s.sendInputEvent({type:"keyUp",keyCode:c,modifiers:p}),await(0,v.timeout)(100)}async click(o,l,i,s){await(await this.getWindowDriver(o)).click(l,i,s)}async doubleClick(o,l){await(await this.getWindowDriver(o)).doubleClick(l)}async setValue(o,l,i){await(await this.getWindowDriver(o)).setValue(l,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,l){return await(await this.getWindowDriver(o)).isActiveElement(l)}async getElements(o,l,i){return await(await this.getWindowDriver(o)).getElements(l,i)}async getElementXY(o,l,i,s){return await(await this.getWindowDriver(o)).getElementXY(l,i,s)}async typeInEditor(o,l,i){await(await this.getWindowDriver(o)).typeInEditor(l,i)}async getTerminalBuffer(o,l){return await(await this.getWindowDriver(o)).getTerminalBuffer(l)}async writeInTerminal(o,l,i){await(await this.getWindowDriver(o)).writeInTerminal(l,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const l=`window:${o}`,i=new m.StaticRouter(r=>r===l),s=this.windowServer.getChannel("windowDriver",i);return new b.WindowDriverChannelClient(s)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};S=he([ee(2,g.IWindowsMainService),ee(3,d.ILifecycleMainService)],S),e.Driver=S;async function h(u,o,l,i){const s=l.driverVerbose,r=i.createInstance(S,u,{verbose:s}),a=new E.WindowDriverRegistryChannel(r);u.registerChannel("windowDriverRegistry",a);const c=await(0,t.serve)(o),p=new E.DriverChannel(r);return c.registerChannel("driver",p),(0,I.combinedDisposable)(c,u)}e.serve=h}),define(J[24],Z([0,1,46,8,56,47,160,4]),function(V,e,v,L,k,M,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends I.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return typeof this.codeCachePath=="string"}}he([v.memoize],f.prototype,"cachedLanguagesPath",null),he([v.memoize],f.prototype,"backupHome",null),he([v.memoize],f.prototype,"backupWorkspacesPath",null),he([v.memoize],f.prototype,"mainIPCHandle",null),he([v.memoize],f.prototype,"mainLockfile",null),he([v.memoize],f.prototype,"sandbox",null),he([v.memoize],f.prototype,"driverVerbose",null),he([v.memoize],f.prototype,"disableUpdates",null),he([v.memoize],f.prototype,"disableKeytar",null),he([v.memoize],f.prototype,"codeCachePath",null),he([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[220],Z([0,1,58,30,29,10,8,3,15,7,18,51,21,24,19,6,27]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(u,o,l){this.configurationService=o,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,s)=>(0,k.isEqual)(i,s,!n.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let o=[];try{Array.isArray(u.rootURIWorkspaces)&&(o=u.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:m.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let l=[];try{Array.isArray(u.folderURIWorkspaces)&&(l=u.folderURIWorkspaces.map(i=>m.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,o){this.workspaces.some(i=>u.workspace.id===i.workspace.id)||(this.workspaces.push(u),this.saveSync());const l=this.getBackupPath(u.workspace.id);return o&&this.moveBackupFolderSync(l,o),l}moveBackupFolderSync(u,o){if(L.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),L.existsSync(o))try{L.renameSync(o,u)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(u){const o=u.id,l=this.workspaces.findIndex(i=>i.workspace.id===o);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(o=>this.backupUriComparer.isEqual(u,o))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const o=this.folders.findIndex(l=>this.backupUriComparer.isEqual(u,l));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(u,o){const l=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:o}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(u){const o=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,u));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(u){return(0,I.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const o=new Set,l=[];for(let i of u){const s=i.workspace;if(!(0,P.isWorkspaceIdentifier)(s))return[];if(!o.has(s.id)){o.add(s.id);const r=this.getBackupPath(s.id);await this.doHasBackups(r)?s.configPath.scheme!==M.Schemas.file||await t.Promises.exists(s.configPath.fsPath)?l.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const o=[],l=new Set;for(let i of u){const s=this.backupUriComparer.getComparisonKey(i);if(!l.has(s)){l.add(s);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const o=[],l=new Set;for(let i of u){const s=i.backupFolder;if(typeof s!="string")return[];if(!l.has(s)){l.add(s);const r=this.getBackupPath(s);await this.doHasBackups(r)?o.push(i):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(u){try{await t.Promises.exists(u)&&await t.Promises.rm(u,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{await t.Promises.rename(u,l)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{L.renameSync(u,l)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const u=[];for(const o of this.workspaces)await this.hasBackups(o)&&u.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&u.push(o);return u}hasBackups(u){let o;return m.URI.isUri(u)?o=this.getBackupPath(this.getFolderHash(u)):(0,b.isWorkspaceBackupInfo)(u)?o=this.getBackupPath(u.workspace.id):o=u.backupFolder,this.doHasBackups(o)}async doHasBackups(u){try{const o=await t.Promises.readdir(u);for(const l of o)try{if((await t.Promises.readdir((0,I.join)(u,l))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let o;return u.scheme===M.Schemas.file?o=n.isLinux?u.fsPath:u.fsPath.toLowerCase():o=u.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};S=he([ee(0,y.IEnvironmentMainService),ee(1,E.IConfigurationService),ee(2,g.ILogService)],S),e.BackupMainService=S}),define(J[221],Z([0,1,59,56]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,I,n){const f=t=>n(t,void 0),m=v.createConnection({host:k,port:M},()=>{m.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const b=t.toString("base64");let E=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];m.write(E.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",y),n(void 0,new L.NodeSocket(m)))};m.on("data",y)});m.once("error",f)}}}),define(J[222],Z([0,1,59,9,2,115,21,6,20,191,94,221,74]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(S,h,u,o,l){return new d(S,h,u,o,l).waitForReady()}class d extends k.Disposable{constructor(h,u,o,l,i){super();this.defaultTunnelHost=u,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=h,this._server=v.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let h=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(h=0,this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(h){h.pause();const u=await(0,m.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),o=u.getSocket().socket,l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&h.write(l.buffer),h.on("end",()=>{this._socketsDispose.delete(h.localAddress),o.end()}),h.on("close",()=>o.end()),h.on("error",()=>{this._socketsDispose.delete(h.localAddress),o.destroy()}),o.on("end",()=>h.end()),o.on("close",()=>h.end()),o.on("error",()=>{h.destroy()}),h.pipe(o),o.pipe(h),this._socketsDispose.set(h.localAddress,()=>{h.end(),o.end()})}}let g=class extends t.AbstractTunnelService{constructor(h,u,o,l,i){super(u);this.socketFactory=h,this.signService=o,this.productService=l,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(h,u,o,l,i,s,r){const a=this.getTunnelFromMap(u,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,o,l,i,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${o} on local port ${l}.`);const c={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:h,signService:this.signService,logService:this.logService,ipcLogger:null},p=y(c,this.defaultTunnelHost,u,o,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,o,p),p}}};g=he([ee(1,n.ILogService),ee(2,E.ISignService),ee(3,f.IProductService),ee(4,I.IConfigurationService)],g),e.BaseTunnelService=g;let P=class extends g{constructor(h,u,o,l){super(b.nodeSocketFactory,h,u,o,l)}};P=he([ee(0,n.ILogService),ee(1,E.ISignService),ee(2,f.IProductService),ee(3,I.IConfigurationService)],P),e.TunnelService=P}),define(J[223],Z([0,1,193,17,16,2,13,21,47,89,6,192,217]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends M.Disposable{constructor(g,P,S){super();this.environmentService=P,this.logService=S,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,P){this.logService.trace("RequestService#request",g.url);const{proxyUrl:S,strictSSL:h}=this,u={...process.env,...await(0,m.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=g.agent?g.agent:await(0,b.getProxyAgent)(g.url||"",u,{proxyUrl:S,strictSSL:h});return g.agent=o,g.strictSSL=h,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,P)}async getNodeRequest(g){return((0,v.parse)(g.url).protocol==="https:"?await new Promise((h,u)=>{V(["https"],h,u)}):await new Promise((h,u)=>{V(["http"],h,u)})).request}_request(g,P){return new Promise(async(S,h)=>{let u;const o=(0,v.parse)(g.url),l=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,I.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),u=l(i,s=>{const r=(0,I.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...g,url:s.headers.location,followRedirects:r-1},P).then(S,h);else{let a=s;s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,E.createGunzip)())),S({res:s,stream:(0,L.streamToBufferReadableStream)(a)})}}),u.on("error",h),g.timeout&&u.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&u.write(g.data),u.end(),P.onCancellationRequested(()=>{u.abort(),h((0,k.canceled)())})})}async resolveProxy(g){}};y=he([ee(0,n.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,t.ILogService)],y),e.RequestService=y}),define(J[224],Z([0,1,14,223]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(I){return v.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(J[225],Z([0,1,14,9,5,2,10,13,83,24,22,6,48,55,60]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(S,h,u,o,l,i,s){super();this.machineId=S,this.userEnv=h,this.environmentMainService=u,this.lifecycleMainService=o,this.logService=l,this.themeMainService=i,this.protocolMainService=s,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",async(S,h)=>this.onWindowConnection(S,h))}async onWindowConnection(S,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const u=await this.connect();if(S.sender.isDestroyed())return u.close();S.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[u])}onWillShutdown(){const S=this.window;!S||(!S.isDestroyed()&&!S.webContents.isDestroyed()&&S.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(S.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{S.close()}catch(h){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(S=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),S()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(S=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),S()}))})()),this._whenIpcReady}createWindow(){const S=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":void 0,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),S.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:E.default}),this.window.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=S=>{this.logService.trace("SharedProcess#close prevented"),S.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(S,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(S,h,u)=>this._onDidError.fire({type:3,details:{reason:u,exitCode:h}})))}async connect(){await this.whenIpcReady;const S=(0,n.assertIsDefined)(this.window);return(0,f.connect)(S)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=he([ee(2,m.IEnvironmentMainService),ee(3,t.ILifecycleMainService),ee(4,b.ILogService),ee(5,d.IThemeMainService),ee(6,y.IProtocolMainService)],g),e.SharedProcess=g}),define(J[226],Z([0,1,9,17,8,13,7,24,19,6]),function(V,e,v,L,k,M,I,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(y,d,g){this.storagePath=y,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const g=this.storage[y];return(0,M.isUndefinedOrNull)(g)?d:g}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:g,data:P}of y)this.storage[g]!==P&&((0,M.isUndefinedOrNull)(P)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=P,d=!0));d&&this.save()}removeItem(y){(0,M.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let b=class yt{constructor(y,d,g){this.fileStorage=new t(I.URI.file((0,k.join)(y.userDataPath,yt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=he([ee(0,n.IEnvironmentMainService),ee(1,m.ILogService),ee(2,f.IFileService)],b),e.StateMainService=b}),define(J[75],Z([0,1,9,25,5,21,24,22,6,20,50,42]),function(V,e,v,L,k,M,I,n,f,m,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,g,P){return`${P.updateUrl}/api/update/${d}/${g}/${P.commit}`}e.createUpdateURL=E;let y=class{constructor(g,P,S,h,u,o){this.lifecycleMainService=g,this.configurationService=P,this.environmentMainService=S,this.requestService=h,this.logService=u,this.productService=o,this._state=b.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(g);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([ee(0,n.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,I.IEnvironmentMainService),ee(3,t.IRequestService),ee(4,f.ILogService),ee(5,m.IProductService)],y),e.AbstractUpdateService=y}),define(J[227],Z([0,1,14,46,5,2,21,24,22,6,20,50,32,42,75]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(S,h,u,o,l,i,s){super(S,h,o,l,i,s);this.telemetryService=u,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(S,h)=>h)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(S,h,u)=>({url:h,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(S,h,u,o)=>({releaseNotes:h,version:u,productVersion:u,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(y.State.Idle(1,u))}buildUpdateFeedUrl(S){let h;this.productService.darwinUniversalAssetId?h=this.productService.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,d.createUpdateURL)(h,S,this.productService);try{v.autoUpdater.setFeedURL({url:u})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return u}doCheckForUpdates(S){this.setState(y.State.CheckingForUpdates(S)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(y.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],g.prototype,"onRawError",null),he([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],g.prototype,"onRawUpdateAvailable",null),he([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([ee(0,f.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,E.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,b.IRequestService),ee(5,m.ILogService),ee(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(J[228],Z([0,1,41,30,9,5,8,24,22,6,32,42]),function(V,e,v,L,k,M,I,n,f,m,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(g,P,S){if(this.lifecycleMainService=g,this.logService=S,this._state=b.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,h=>this.logService.error(h))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=he([ee(0,f.ILifecycleMainService),ee(1,n.IEnvironmentMainService),ee(2,m.ILogService)],E);let y=class extends E{constructor(g,P,S,h,u,o){super(S,h,u);this.snap=g,this.snapRevision=P,this.telemetryService=o;const l=(0,L.watch)(I.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(l,"change",(c,p)=>p),s=M.Event.filter(i,c=>c==="current"),a=M.Event.debounce(s,(c,p)=>p,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{a.dispose(),l.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+I.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((S,h)=>(0,L.realpath)(`${I.dirname(this.snap)}/current`,(u,o)=>u?h(u):S(o))),P=I.basename(g);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([ee(2,f.ILifecycleMainService),ee(3,n.IEnvironmentMainService),ee(4,m.ILogService),ee(5,t.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[45],Z([0,1,14,30,5,40,31,2,10,8,3,15,13,18,153,51,52,24,4,6,20,99,27,100]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,h.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(c,p,w,D,R){super();this.environmentMainService=c,this.logService=p,this.backupMainService=w,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,p=>(0,L.readFileSync)(p,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,p=>y.Promises.readFile(p,"utf8"))}doResolveLocalWorkspace(c,p){if(!!this.isWorkspacePath(c)&&c.scheme===f.Schemas.file)try{const w=p(c.fsPath);return w instanceof Promise?w.then(D=>this.doResolveWorkspace(c,D),D=>{}):this.doResolveWorkspace(c,w)}catch{return}}isWorkspacePath(c){return(0,i.isUntitledWorkspace)(c,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,p){try{const w=this.doParseStoredWorkspace(c,p),D=(0,s.getWorkspaceIdentifier)(c);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(w.folders,D.configPath,b.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(c,p){const w=(0,M.parse)(p);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(c,p){const{workspace:w,storedWorkspace:D}=this.newUntitledWorkspace(c,p),R=w.configPath.fsPath;return await y.Promises.mkdir((0,m.dirname)(R),{recursive:!0}),await y.Promises.writeFile(R,JSON.stringify(D,null,"	")),w}createUntitledWorkspaceSync(c,p){const{workspace:w,storedWorkspace:D}=this.newUntitledWorkspace(c,p),R=w.configPath.fsPath;return(0,L.mkdirSync)((0,m.dirname)(R),{recursive:!0}),(0,y.writeFileSync)(R,JSON.stringify(D,null,"	")),w}newUntitledWorkspace(c=[],p){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,b.joinPath)(this.untitledWorkspacesHome,w),R=(0,b.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),_=[];for(const C of c)_.push((0,i.getStoredWorkspaceFolder)(C.uri,!0,C.name,D,!t.isWindows,b.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(R),storedWorkspace:{folders:_,remoteAuthority:p}}}async getWorkspaceIdentifier(c){return(0,s.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,i.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const p=(0,b.originalFSPath)(c.configPath);try{(0,y.rimrafSync)((0,m.dirname)(p));const w=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,L.existsSync)(w)&&(0,y.writeFileSync)((0,m.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${p} (${w}).`)}}getUntitledWorkspacesSync(){const c=[];try{const p=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,b.joinPath)(this.untitledWorkspacesHome,w,i.UNTITLED_WORKSPACE_NAME));for(const w of p){const D=(0,s.getWorkspaceIdentifier)(w),R=this.resolveLocalWorkspaceSync(w);R?c.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(p){p.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${p}).`)}return c}async enterWorkspace(c,p,w){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,p,w))return;const R=this.doEnterWorkspace(c,(0,s.getWorkspaceIdentifier)(w));if(!!R)return this._onDidEnterWorkspace.fire({window:c,workspace:R.workspace}),R}async isValidTargetWorkspacePath(c,p,w){if(!w)return!0;if((0,i.isWorkspaceIdentifier)(c.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,w))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(p,w)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,b.basename)(w)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,E.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,p){if(!c.config)return;c.focus();let w;return c.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:p,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,i.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=p,c.config.backupPath=w,{workspace:p,backupPath:w}}};r=he([ee(0,S.IEnvironmentMainService),ee(1,u.ILogService),ee(2,g.IBackupMainService),ee(3,P.IDialogMainService),ee(4,o.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[101],Z([0,1,14,36,25,3,13,7,18,21,54,4,6,97,35,27,45]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let S=class{constructor(u,o,l,i,s){this.logService=u,this.windowsMainService=o,this.urlService=l,this.workspacesManagementMainService=i,this.configurationService=s}async start(u,o){this.logService.trace("Received data from other instance: ",u,o),M.isMacintosh&&v.app.focus({steal:!0});const l=this.parseOpenUrl(u);if(l.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:s,url:r}of l)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(u,o)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,L.coalesce)(u._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(l){return null}})):[]}async startOpenWindow(u,o){const l=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const s=u.wait&&u.waitMarkerFilePath?n.URI.file(u.waitMarkerFilePath):void 0,r=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:l,cli:u,userEnv:o,waitMarkerFileURI:s,remoteAuthority:r});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let a=!1;if(u["new-window"]||u["unity-launch"])a=!0;else if(u["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!M.isMacintosh}if(a)i=this.windowsMainService.open({context:l,cli:u,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s,remoteAuthority:r});else{const c=this.windowsMainService.getLastActiveWindow();c?(c.focus(),i=[c]):i=this.windowsMainService.open({context:l,cli:u,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:l,cli:u,userEnv:o,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:u.goto,remoteAuthority:r});if(s&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return v.BrowserWindow.getAllWindows().forEach(o=>{const l=this.windowsMainService.getWindowById(o.id);l?u.push(this.codeWindowToInfo(l)):u.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(s=>{const r=i.remoteAuthority;if(r){const a=`vscode:getDiagnosticInfoResponse${i.id}`,c={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:a,args:c}),v.ipcMain.once(a,(p,w)=>{w||s({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),s(w)}),setTimeout(()=>{s({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else s(void 0)})))).filter(i=>!!i)}getFolderURIs(u){const o=[],l=u.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(l))o.push(l.uri);else if((0,g.isWorkspaceIdentifier)(l)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);i&&i.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(u){const o=this.getFolderURIs(u),l=(0,I.assertIsDefined)(u.win);return this.browserWindowToInfo(l,o,u.remoteAuthority)}browserWindowToInfo(u,o=[],l){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:o,remoteAuthority:l}}};S=he([ee(0,E.ILogService),ee(1,d.IWindowsMainService),ee(2,y.IURLService),ee(3,P.IWorkspacesManagementMainService),ee(4,m.IConfigurationService)],S),e.LaunchMainService=S}),define(J[53],Z([0,1,41,14,26,114,46,5,31,2,10,8,3,7,80,66,18,145,52,24,4,22,6,20,32,60,35,27,45]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i,s,r,a,c,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let D=class at extends m.Disposable{constructor(_,C,G,x,ne,K,Q,U,$,W){super();this.sharedProcess=_,this.windowsMainService=C,this.dialogMainService=G,this.lifecycleMainService=x,this.environmentMainService=ne,this.telemetryService=K,this.logService=Q,this.productService=U,this.themeMainService=$,this.workspacesManagementMainService=W,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(N,B,F)=>F),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(_){return this.windowsMainService.getWindowCount()}async getActiveWindowId(_){const C=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(_,C,G){return Array.isArray(C)?this.doOpenWindow(_,C,G):this.doOpenEmptyWindow(_,C)}async doOpenWindow(_,C,G=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:_,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0})}async doOpenEmptyWindow(_,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:_},C)}async toggleFullScreen(_){const C=this.windowById(_);C&&C.toggleFullScreen()}async handleTitleDoubleClick(_){const C=this.windowById(_);C&&C.handleTitleDoubleClick()}async isMaximized(_){const C=this.windowById(_);return C?.win?C.win.isMaximized():!1}async maximizeWindow(_){const C=this.windowById(_);C?.win&&C.win.maximize()}async unmaximizeWindow(_){const C=this.windowById(_);C?.win&&C.win.unmaximize()}async minimizeWindow(_){const C=this.windowById(_);C?.win&&C.win.minimize()}async focusWindow(_,C){C&&typeof C.windowId=="number"&&(_=C.windowId);const G=this.windowById(_);G&&G.focus({force:C?.force??!1})}async setMinimumSize(_,C,G){const x=this.windowById(_);if(x?.win){const[ne,K]=x.win.getSize(),[Q,U]=x.win.getMinimumSize(),[$,W]=[C??Q,G??U],[N,B]=[Math.max(ne,$),Math.max(K,W)];(Q!==$||U!==W)&&x.win.setMinimumSize($,W),(ne!==N||K!==B)&&x.win.setSize(N,B)}}async saveWindowSplash(_,C){this.themeMainService.saveWindowSplash(_,C)}async installShellCommand(_){const{source:C,target:G}=await this.getShellCommandLink();try{const{symbolicLink:x}=await P.SymlinkSupport.stat(C);if(x&&!x.dangling){const ne=await(0,d.realpath)(C);if(G===ne)return}await P.Promises.unlink(C)}catch(x){if(x.code!=="ENOENT")throw x}try{await P.Promises.symlink(G,C)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:ne}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${C}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(K)}catch(K){throw new Error((0,S.localize)(3,null,C))}}}async uninstallShellCommand(_){const{source:C}=await this.getShellCommandLink();try{await P.Promises.unlink(C)}catch(G){switch(G.code){case"EACCES":const{response:x}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const ne=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(ne)}catch(ne){throw new Error((0,S.localize)(7,null,C))}break;case"ENOENT":break;default:throw G}}}async getShellCommandLink(){const _=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await P.Promises.exists(_))throw new Error((0,S.localize)(8,null,_));return{source:C,target:_}}async showMessageBox(_,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(_))}async showSaveDialog(_,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(_))}async showOpenDialog(_,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(_))}toBrowserWindow(_){const C=this.windowById(_);if(C?.win)return C.win}async pickFileFolderAndOpen(_,C){const G=await this.dialogMainService.pickFileFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(G.map(async x=>await P.SymlinkSupport.existsDirectory(x)?{folderUri:y.URI.file(x)}:{fileUri:y.URI.file(x)})),C,_))}async pickFolderAndOpen(_,C){const G=await this.dialogMainService.pickFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(G.map(x=>({folderUri:y.URI.file(x)})),C,_))}async pickFileAndOpen(_,C){const G=await this.dialogMainService.pickFile(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(G.map(x=>({fileUri:y.URI.file(x)})),C,_))}async pickWorkspaceAndOpen(_,C){const G=await this.dialogMainService.pickWorkspace(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(G.map(x=>({workspaceUri:y.URI.file(x)})),C,_))}doOpenPicked(_,C,G){this.windowsMainService.open({context:3,contextWindowId:G,cli:this.environmentMainService.args,urisToOpen:_,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(_,C,G){const x=_?_.length:0;this.telemetryService.publicLog(C,{...G,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(_,C){L.shell.showItemInFolder(C)}async setRepresentedFilename(_,C){const G=this.windowById(_);G&&G.setRepresentedFilename(C)}async setDocumentEdited(_,C){const G=this.windowById(_);G&&G.setDocumentEdited(C)}async openExternal(_,C){return E.isLinuxSnap?this.safeSnapOpenExternal(C):L.shell.openExternal(C),!0}safeSnapOpenExternal(_){const C=process.env.GDK_PIXBUF_MODULE_FILE,G=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(_),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=G}moveItemToTrash(_,C){return L.shell.trashItem(C)}async isAdmin(){let _;return E.isWindows?_=(await new Promise((C,G)=>{V(["native-is-elevated"],C,G)}))():_=process.getuid()===0,_}async writeElevated(_,C,G,x){const ne=await new Promise((K,Q)=>{V(["sudo-prompt"],K,Q)});return new Promise((K,Q)=>{const U=[`"${this.cliPath}"`];x?.unlock&&U.push("--file-chmod"),U.push("--file-write",`"${C.fsPath}"`,`"${G.fsPath}"`);const $={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(U.join(" "),$,(W,N,B)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),W?Q(W):K(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(_,C,G){process.kill(C,G)}async readClipboardText(_,C){return L.clipboard.readText(C)}async writeClipboardText(_,C,G){return L.clipboard.writeText(C,G)}async readClipboardFindText(_){return L.clipboard.readFindText()}async writeClipboardFindText(_,C){return L.clipboard.writeFindText(C)}async writeClipboardBuffer(_,C,G,x){return L.clipboard.writeBuffer(C,Buffer.from(G),x)}async readClipboardBuffer(_,C){return L.clipboard.readBuffer(C)}async hasClipboard(_,C,G){return L.clipboard.has(C,G)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(_,C){const G=this.windowById(_);G&&G.updateTouchBar(C)}async notifyReady(_){const C=this.windowById(_);C&&C.setReady()}async relaunch(_,C){return this.lifecycleMainService.relaunch(C)}async reload(_,C){const G=this.windowById(_);if(G){if((0,p.isWorkspaceIdentifier)(G.openedWorkspace)){const x=G.openedWorkspace.configPath;if(x.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(G,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(_){this.closeWindowById(_,_)}async closeWindowById(_,C){const G=this.windowById(C);if(G?.win)return G.win.close()}async quit(_){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(_,C){await this.lifecycleMainService.kill(C)}async resolveProxy(_,C){const x=this.windowById(_)?.win?.webContents?.session;if(x)return x.resolveProxy(C)}async openDevTools(_,C){const G=this.windowById(_);G?.win&&G.win.webContents.openDevTools(C)}async toggleDevTools(_){const C=this.windowById(_);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(_,C){const G=this.windowById(_);G?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&G.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(_,C,G,x){if(!E.isWindows)return;const ne=await new Promise((K,Q)=>{V(["vscode-windows-registry"],K,Q)});try{return ne.GetStringRegKey(C,G,x)}catch{return}}async getPassword(_,C,G){const x=await this.withKeytar(),ne=await x.getPassword(C,G);if(ne)try{let{content:K,hasNextChunk:Q}=JSON.parse(ne);if(!K||!Q)return ne;let U=1;for(;Q;){const $=await x.getPassword(C,`${G}-${U}`),W=JSON.parse($);K+=W.content,Q=W.hasNextChunk,U++}return K}catch{return ne}return ne}async setPassword(_,C,G,x){const ne=await this.withKeytar(),K=3,Q=async(U,$,W)=>{let N=0,B;for(;N<K;)try{await ne.setPassword(U,$,W);return}catch(F){B=F,this.logService.warn("Error attempting to set a password: ",F),N++,await new Promise(z=>setTimeout(z,200))}throw B};if(E.isWindows&&x.length>at.MAX_PASSWORD_LENGTH){let U=0,$=0,W=!0;for(;W;){const N=x.substring(U,U+at.PASSWORD_CHUNK_SIZE);U+=at.PASSWORD_CHUNK_SIZE,W=x.length-U>0;const B={content:N,hasNextChunk:W};await Q(C,$?`${G}-${$}`:G,JSON.stringify(B)),$++}}else await Q(C,G,x);this._onDidChangePassword.fire({service:C,account:G})}async deletePassword(_,C,G){const ne=await(await this.withKeytar()).deletePassword(C,G);return ne&&this._onDidChangePassword.fire({service:C,account:G}),ne}async findPassword(_,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(_,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((_,C)=>{V(["keytar"],_,C)})}windowById(_){if(typeof _=="number")return this.windowsMainService.getWindowById(_)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,he([I.memoize],D.prototype,"cliPath",null),D=he([ee(1,c.IWindowsMainService),ee(2,h.IDialogMainService),ee(3,l.ILifecycleMainService),ee(4,u.IEnvironmentMainService),ee(5,r.ITelemetryService),ee(6,i.ILogService),ee(7,s.IProductService),ee(8,a.IThemeMainService),ee(9,w.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(J[229],Z([0,1,14,25,5,78,2,28,87,6,53,20,35]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends I.Disposable{constructor(P,S,h,u,o){super();this.logService=P,this.windowsMainService=S,this.nativeHostMainService=h,this.encryptionMainService=u,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=k.Event.fromNodeEventEmitter(v.app,"login",(S,h,u,o,l)=>({event:S,webContents:h,req:u,authInfo:o,callback:l}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:S,req:h,callback:u}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&h.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(o?.username,o?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(P);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const S=String((0,M.hash)({scheme:P.scheme,host:P.host,port:P.port}));let h,u;try{const s=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(s){const r=JSON.parse(await this.encryptionMainService.decrypt(s));h=r.username,u=r.password}}catch(s){this.logService.error(s)}if(this.state!==y.StoredCredentialsUsed&&typeof h=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:h,password:u};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const l={authInfo:P,username:this.sessionCredentials?.username??h,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,l),this.state=y.LoginDialogShown;const i=await new Promise(s=>{const r=async(a,c,p)=>{if(c===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),p){const w={username:p.username,password:p.password};try{if(p.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(D){this.logService.error(D)}s({username:w.username,password:w.password})}else s(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};d=he([ee(0,m.ILogService),ee(1,E.IWindowsMainService),ee(2,t.INativeHostMainService),ee(3,f.IEncryptionMainService),ee(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(J[230],Z([0,1,14,26,31,2,10,3,81,143,70,52,24,4,101,6,53,48,20,55,61]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let l=class St{constructor(s,r,a,c,p,w,D,R,_){this.userEnv=s,this.environmentMainService=r,this.launchMainService=a,this.logService=c,this.diagnosticsService=p,this.dialogMainService=w,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=_,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[r,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),c=await this.diagnosticsService.getSystemInfo(r,a);this.safeSend(s,"vscode:issueSystemInfoResponse",c)}),v.ipcMain.on("vscode:listProcesses",async s=>{const r=[];try{const a=await this.launchMainService.getMainProcessId();r.push({name:(0,m.localize)(0,null),rootProcess:await(0,f.listProcesses)(a)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(p=>{(0,t.isRemoteDiagnosticError)(p)?r.push({name:p.hostName,rootProcess:p}):p.processes&&r.push({name:p.hostName,rootProcess:p.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",r)}),v.ipcMain.on("vscode:issueReporterClipboard",async s=>{const r={title:this.productService.nameLong,message:(0,m.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const r=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",r)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,m.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(s,r)=>{const{id:a,from:c,args:p}=r;let w;switch(c){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}w&&w.webContents.send("vscode:runAction",{id:a,from:c,args:p})}),v.ipcMain.on("vscode:openExternal",(s,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),v.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async s=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",r.windows)})}safeSend(s,r,...a){s.sender.isDestroyed()||s.sender.send(r,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1}),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:S.default}),this.issueReporterWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0}),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:S.default}),this.processExplorerWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(s,r,a){const c=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":void 0,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop});return c.setMenuBarVisibility(!1),c}async getSystemStatus(){const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,r)}getWindowPosition(s,r,a){let c;const p=v.screen.getAllDisplays();if(p.length===1)c=p[0];else{if(n.isMacintosh){const R=v.screen.getCursorScreenPoint();c=v.screen.getDisplayNearestPoint(R)}!c&&s&&(c=v.screen.getDisplayMatching(s.getBounds())),c||(c=v.screen.getPrimaryDisplay()||p[0])}const w={width:r,height:a},D=c.bounds;return w.x=D.x+D.width/2-w.width/2,w.y=D.y+D.height/2-w.height/2,D.width>0&&D.height>0&&(w.x<D.x&&(w.x=D.x),w.y<D.y&&(w.y=D.y),w.x>D.x+D.width&&(w.x=D.x),w.y>D.y+D.height&&(w.y=D.y),w.width>D.width&&(w.width=D.width),w.height>D.height&&(w.height=D.height)),w}async getPerformanceInfo(){try{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,r)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([ee(1,E.IEnvironmentMainService),ee(2,d.ILaunchMainService),ee(3,g.ILogService),ee(4,t.IDiagnosticsService),ee(5,b.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,u.IProtocolMainService),ee(8,h.IProductService)],l),e.IssueMainService=l}),define(J[231],Z([0,1,25,21,24,22,6,53,20,50,32,42,75]),function(V,e,v,L,k,M,I,n,f,m,t,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends E.AbstractUpdateService{constructor(g,P,S,h,u,o,l,i){super(g,P,h,u,o,i);this.telemetryService=S,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return(0,E.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const S=g?P.message||P:void 0;this.setState(b.State.Idle(1,S))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};y=he([ee(0,M.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,t.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,m.IRequestService),ee(5,I.ILogService),ee(6,n.INativeHostMainService),ee(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(J[232],Z([0,1,41,30,26,9,25,46,8,7,112,18,21,24,19,22,6,53,20,50,32,42,75]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(p,w=1e3){for(;!p();)await(0,M.timeout)(w)}let r;function a(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let c=class extends i.AbstractUpdateService{constructor(w,D,R,_,C,G,x,ne,K){super(w,D,_,C,G,K);this.telemetryService=R,this.fileService=x,this.nativeHostMainService=ne}get cachePath(){const w=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),a()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(l.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},I.CancellationToken.None).then(u.asJson).then(D=>{const R=a();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(l.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(l.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(l.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(_=>b.Promises.exists(_).then(C=>{if(C)return Promise.resolve(_);const G=D.url,x=D.hash,ne=`${_}.tmp`;return this.requestService.request({url:G},I.CancellationToken.None).then(K=>this.fileService.writeFile(m.URI.file(ne),K.stream)).then(x?()=>(0,t.checksum)(ne,D.hash):()=>{}).then(()=>b.Promises.rename(ne,_)).then(()=>_)})).then(_=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:_},C&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(D)):this.setState(l.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const R=w?D.message||D:void 0;this.setState(l.State.Idle(a(),R))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(l.State.Idle(a()))}async getUpdatePackagePath(w){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const D=w?G=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(G):()=>!0,R=await this.cachePath,C=(await b.Promises.readdir(R)).filter(D).map(async G=>{try{await b.Promises.unlink(f.join(R,G))}catch(x){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(l.State.Updating(w));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(a()))});const _=`${this.productService.win32MutexName}-ready`,C=await new Promise((G,x)=>{V(["windows-mutex"],G,x)});s(()=>C.isActive(_)).then(()=>this.setState(l.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};he([n.memoize],c.prototype,"cachePath",null),c=he([ee(0,g.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,o.ITelemetryService),ee(3,y.IEnvironmentMainService),ee(4,u.IRequestService),ee(5,P.ILogService),ee(6,d.IFileService),ee(7,S.INativeHostMainService),ee(8,h.IProductService)],c),e.Win32UpdateService=c}),define(J[233],Z([0,1,14,9,25,5,31,2,10,8,72,3,7,149,51,21,52,24,54,199,19,22,6,20,55,98,32,203,60,61,35,27,45]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i,s,r,a,c,p,w,D,R,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.LOADING=1]="LOADING",ne[ne.NAVIGATING=2]="NAVIGATING",ne[ne.READY=3]="READY"})(G||(G={}));let x=class extends n.Disposable{constructor(K,Q,U,$,W,N,B,F,z,T,A,O,j,Y){super();this.logService=Q,this.environmentMainService=U,this.fileService=$,this.configurationService=N,this.themeMainService=B,this.workspacesManagementMainService=F,this.backupMainService=z,this.telemetryService=T,this.dialogMainService=A,this.lifecycleMainService=O,this.productService=j,this.protocolMainService=Y,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[q,X]=this.restoreWindowState(K.state);this.windowState=q,this.logService.trace("window#ctor: using window state",q);const ie=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),ae={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ie,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":void 0,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};b.isLinux?ae.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(ae.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(ae.fullscreenable=!1),b.isMacintosh&&(ae.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(ae.acceptFirstMouse=!1));const de=b.isMacintosh&&se?.nativeTabs===!0;de&&(ae.tabbingIdentifier=this.productService.nameShort);const re=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(re&&(ae.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,b.isMacintosh||(ae.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(ae),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),b.isMacintosh&&re&&this._win.setSheetOffset(22),b.isMacintosh&&X&&(!de||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ce=>typeof ce=="number")){const ce=this.windowState;this._win.setBounds({width:ce.width,height:ce.height,x:ce.x,y:ce.y})}ie&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,u.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:q=>W.globalStorage.get(q),store:(q,X)=>W.globalStorage.set(q,X)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){b.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){b.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){b.isMacintosh&&K?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function Q(){U.dispose(),$.dispose(),K()}const U=this.onDidClose(()=>Q()),$=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(W,N,B)=>this.onWindowError(3,{reason:B,exitCode:N})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Q=W=>{for(let N=W;N;N=N.parent)if(N.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},U=W=>W.resourceType==="xhr"||Q(W.frame);this._win.webContents.session.webRequest.onBeforeRequest((W,N)=>{const B=E.URI.parse(W.url);return B.path.endsWith(".svg")&&!(K.has(B.scheme)||B.path.includes(f.Schemas.vscodeRemoteResource))?N({cancel:!U(W)}):N({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((W,N)=>{const B=W.responseHeaders,F=B["content-type"]||B["Content-Type"];if(F&&Array.isArray(F)){const z=E.URI.parse(W.url);if(z.path.endsWith(".svg")&&K.has(z.scheme))return B["Content-Type"]=["image/svg+xml"],N({cancel:!1,responseHeaders:B});if(!z.path.includes(f.Schemas.vscodeRemoteResource)&&F.some(T=>T.toLowerCase().includes("image/svg")))return N({cancel:!U(W)})}return N({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const $=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:$},async(W,N)=>{const B=await this.marketplaceHeadersPromise;N({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,B)})})}async onWindowError(K,Q){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:Q?.reason,code:Q?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,y.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,y.localize)(2,null))],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(K===2){let U;Q?U=(0,y.localize)(6,null,Q.reason,Q.exitCode??"<unknown>"):U=(0,y.localize)(5,null);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,y.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,y.localize)(8,null))],message:U,detail:(0,y.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;$.response===0?this.reload():$.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Q?.endsWith("/")&&(Q=Q.substr(0,Q.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=U;const $=Q||"",W=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${W}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:W,pacScript:""})}}addTabbedWindow(K){b.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,Q),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:Q.isReload?3:U?2:1})}updateConfiguration(K,Q){const U=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(U){const $=(0,h.isLaunchedFromCli)(U)&&!(0,h.isLaunchedFromCli)(K.userEnv),W=this.isExtensionDevelopmentHost;($||W)&&(K.userEnv={...U,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(K["disable-extensions"]=Q.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),K.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspaceBeforeReload(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&K&&(Q.verbose=K.verbose,Q.debugId=K.debugId,Q["inspect-extensions"]=K["inspect-extensions"],Q["inspect-brk-extensions"]=K["inspect-brk-extensions"],Q["extensions-dir"]=K["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,_.isWorkspaceIdentifier)(K.workspace)){const Q=K.workspace.configPath;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,_.isSingleFolderWorkspaceIdentifier)(K.workspace)){const Q=K.workspace.uri;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let U;try{U=v.screen.getDisplayMatching(this.getBounds())}catch(N){}const $=(0,R.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let Q;if(!b.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?K.mode=0:K.mode=1,Q===1||Q===0){let U;Q===1?U=this.getBounds():U=this._win.getNormalBounds(),K.x=U.x,K.y=U.y,K.width=U.width,K.height=U.height}return K}restoreWindowState(K){(0,t.mark)("code/willRestoreCodeWindowState");let Q=!1;if(K)try{const U=v.screen.getAllDisplays();Q=U.length>1,K=this.validateWindowState(K,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),Q]}validateWindowState(K,Q){if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const W=this.getWorkingArea(Q[0]);if(W){let N=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!W||(K.x<W.x&&(K.x=W.x),K.y<W.y&&(K.y=W.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",W),N(),K.width>W.width&&(K.width=W.width),K.height>W.height&&(K.height=W.height),K.x>W.x+W.width-128&&(K.x=W.x+W.width-K.width),K.y>W.y+W.height-128&&(K.y=W.y+W.height-K.height),N()}return K}if(K.display&&K.mode===3){const W=Q.find(N=>N.id===K.display);if(W&&typeof W.bounds?.x=="number"&&typeof W.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,R.defaultWindowState)(3);return N.x=W.bounds.x,N.y=W.bounds.y,N}}let U,$;try{U=v.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),$=this.getWorkingArea(U)}catch(W){}if(U&&$&&K.x+K.width>$.x&&K.y+K.height>$.y&&K.x<$.x+$.width&&K.y<$.y+$.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",$),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,Q]=this._win.getPosition(),[U,$]=this._win.getSize();return{x:K,y:Q,width:U,height:$}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,Q=!0){b.isMacintosh||(K==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,y.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const Q=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,Q,...U){this.isReady?this.send(K,...U):this.ready().then(()=>{Q.isCancellationRequested||this.send(K,...U)})}send(K,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${K} for window that is destroyed`);return}this._win.webContents.send(K,...Q)}}updateTouchBar(K){!b.isMacintosh||this.touchBarGroups.forEach((Q,U)=>{const $=K[U];Q.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(!!b.isMacintosh){for(let K=0;K<10;K++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const Q=this.createTouchBarGroupSegments(K),U=new v.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:U.segments[$].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(K=[]){return K.map(U=>{let $;U.icon&&!p.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===f.Schemas.file&&($=v.nativeImage.createFromPath(E.URI.revive(U.icon.dark).fsPath),$.isEmpty()&&($=void 0));let W;return typeof U.title=="string"?W=U.title:W=U.title.value,{id:U.id,label:$?void 0:W,icon:$}})}dispose(){super.dispose(),this._win=null}};x=he([ee(1,i.ILogService),ee(2,S.IEnvironmentMainService),ee(3,o.IFileService),ee(4,a.IStorageMainService),ee(5,g.IConfigurationService),ee(6,w.IThemeMainService),ee(7,C.IWorkspacesManagementMainService),ee(8,d.IBackupMainService),ee(9,c.ITelemetryService),ee(10,P.IDialogMainService),ee(11,l.ILifecycleMainService),ee(12,s.IProductService),ee(13,r.IProtocolMainService)],x),e.CodeWindow=x}),define(J[62],Z([0,1,14,36,9,5,31,2,10,3,15,7,18,152,4,22,6,39,27,45]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class $e extends n.Disposable{constructor(p,w,D,R){super();this.stateMainService=p,this.logService=w,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(p=>this.addRecentlyOpened([{workspace:p.workspace}])))}handleWindowsJumpList(){!m.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(p){const w=[],D=[];for(let R of p)if((0,h.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&s(w,R.workspace)===-1&&w.push(R);else if((0,h.isRecentFolder)(R))r(w,R.folderUri)===-1&&w.push(R);else{const _=a(D,R.fileUri)>=0,C=R.fileUri.scheme===f.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,t.basename)(R.fileUri))>=0;!_&&!C&&(D.push(R),m.isWindows&&R.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(w,D),w.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(w.length=$e.MAX_TOTAL_RECENT_ENTRIES),D.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(D.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:w,files:D}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(p){const w=C=>{const G=i(C);for(const x of p)if(t.extUriBiasedIgnorePathCase.isEqual(x,G))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(w),_=D.files.filter(w);(R.length!==D.workspaces.length||_.length!==D.files.length)&&(this.saveRecentlyOpened({files:_,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const p=this.getRecentlyOpened(),w=[];let D=0;for(let _=0;_<p.workspaces.length&&D<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;_++){const C=i(p.workspaces[_]);if(C.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(C);await E.Promises.exists(G)&&(w.push(G),D++)}}const R=[];for(let _=0;_<p.files.length&&D<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;_++){const C=i(p.files[_]);if(C.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(C);if($e.COMMON_FILES_FILTER.includes((0,t.basename)(C))||w.includes(G))continue;await E.Promises.exists(G)&&(R.push(G),D++)}}R.reverse().forEach(_=>v.app.addRecentDocument(_)),w.reverse().forEach(_=>v.app.addRecentDocument(_))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(p){const w=[],D=[],R=p?.config?.workspace;(0,h.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?w.push({workspace:R}):(0,h.isSingleFolderWorkspaceIdentifier)(R)&&w.push({folderUri:R.uri});const _=p?.config?.filesToOpenOrCreate;if(_)for(let C of _){const G=C.fileUri;G&&a(D,G)===-1&&D.push({fileUri:G})}return this.addEntriesFromStorage(w,D),{workspaces:w,files:D}}addEntriesFromStorage(p,w){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let _=(0,h.isRecentFolder)(R)?r(p,R.folderUri):s(p,R.workspace);_>=0?p[_].label=p[_].label||R.label:p.push(R)}for(let R of D.files){let _=a(w,R.fileUri);_>=0?w[_].label=w[_].label||R.label:w.push(R)}}getRecentlyOpenedFromStorage(){const p=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,h.restoreRecentlyOpened)(p,this.logService)}saveRecentlyOpened(p){const w=(0,h.toStoreData)(p);this.stateMainService.setItem($e.recentlyOpenedStorageKey,w)}updateWindowsJumpList(){if(!m.isWindows)return;const p=[];if(p.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let w=[];for(let _ of v.app.getJumpListSettings().removedItems){const C=_.args;if(C){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);G&&w.push(b.URI.parse(G[2]))}}this.removeRecentlyOpened(w);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(_=>{const C=(0,h.isRecentWorkspace)(_)?_.workspace:_.folderUri,{title:G,description:x}=this.getWindowsJumpListLabel(C,_.label);let ne;return b.URI.isUri(C)?ne=`--folder-uri "${C.toString()}"`:(D=!0,ne=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:x.substr(0,255),program:process.execPath,args:ne,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&p.push({type:"custom",name:D?(0,y.localize)(2,null):(0,y.localize)(3,null),items:R})}p.push({type:"recent"});try{v.app.setJumpList(p)}catch(w){this.logService.warn("updateWindowsJumpList#setJumpList",w)}}getWindowsJumpListLabel(p,w){if(w)return{title:(0,I.splitName)(w).name,description:w};if(b.URI.isUri(p))return{title:(0,t.basename)(p),description:l(p)};if(this.workspacesManagementMainService.isUntitledWorkspace(p))return{title:(0,y.localize)(4,null),description:""};let D=(0,t.basename)(p.configPath);return D.endsWith(h.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-h.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,D),description:l(p.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([ee(0,S.IStateMainService),ee(1,P.ILogService),ee(2,u.IWorkspacesManagementMainService),ee(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function l(c){return c.scheme==="file"?(0,I.normalizeDriveLetter)(c.fsPath):c.toString()}function i(c){return(0,h.isRecentFolder)(c)?c.folderUri:(0,h.isRecentFile)(c)?c.fileUri:c.workspace.configPath}function s(c,p){return c.findIndex(w=>(0,h.isRecentWorkspace)(w)&&w.workspace.id===p.id)}function r(c,p){return c.findIndex(w=>(0,h.isRecentFolder)(w)&&t.extUriBiasedIgnorePathCase.isEqual(w.folderUri,p))}function a(c,p){return c.findIndex(w=>t.extUriBiasedIgnorePathCase.isEqual(w.fileUri,p))}}),define(J[234],Z([0,1,14,9,25,31,3,7,144,21,24,22,6,182,53,20,39,32,42,61,35,62]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let s=class wt{constructor(c,p,w,D,R,_,C,G,x,ne,K){this.updateService=c,this.configurationService=p,this.windowsMainService=w,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=_,this.stateMainService=C,this.lifecycleMainService=G,this.logService=x,this.nativeHostMainService=ne,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(I.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const c=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);c&&(c.menus&&(this.menubarMenus=c.menus),c.keybindings&&(this.keybindings=c.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,C,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,C,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const c=this.productService.twitterUrl;c&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(c,"openTwitterUrl"));const p=this.productService.requestFeatureUrl;p&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(p,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(I.language){const _=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${_}lang=${I.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(c=>this.onDidChangeWindowsCount(c)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let c=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof c!="boolean"?!0:c}get currentEnableNativeTabs(){if(!I.isMacintosh)return!1;let c=this.configurationService.getValue("window.nativeTabs");return typeof c!="boolean"?!1:c}updateMenu(c,p){this.menubarMenus=c.menus,this.keybindings=c.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,c),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(c){!I.isMacintosh||(c.oldCount===0&&c.newCount>0||c.oldCount>0&&c.newCount===0)&&(this.closedLastWindow=c.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!I.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const c=v.Menu.getApplicationMenu();if(c&&this.oldMenus.push(c),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(I.isMacintosh?new v.Menu:null);return}const p=new v.Menu;let w;if(I.isMacintosh){const R=new v.Menu;w=new v.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),p.append(w)}if(I.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new v.Menu;R.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),p.append(_)}if(this.shouldDrawMenu("Edit")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),p.append(_)}if(this.shouldDrawMenu("Selection")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),p.append(_)}if(this.shouldDrawMenu("View")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),p.append(_)}if(this.shouldDrawMenu("Go")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),p.append(_)}if(this.shouldDrawMenu("Run")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),p.append(_)}if(this.shouldDrawMenu("Terminal")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),p.append(_)}let D;if(this.shouldDrawMenu("Window")){const R=new v.Menu;D=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&p.append(D),this.shouldDrawMenu("Help")){const R=new v.Menu,_=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),p.append(_)}p.items&&p.items.length>0?v.Menu.setApplicationMenu(p):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(c){const p=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const Q=new v.Menu;this.setMenuById(Q,"Preferences"),D=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Q})}const R=new v.Menu,_=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),C=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),ne=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[p];K.push(...w),D&&K.push(r(),D),K.push(r(),_,r(),C,G,x,r(),ne),K.forEach(Q=>c.append(Q))}shouldDrawMenu(c){if(!I.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(c){case"File":case"Help":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[c];case"Window":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[c]}}setMenu(c,p){p.forEach(w=>{if((0,y.isMenubarMenuItemSeparator)(w))c.append(r());else if((0,y.isMenubarMenuItemSubmenu)(w)){const D=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(w.label),submenu:D});this.setMenu(D,w.submenu.items),c.append(R)}else(0,y.isMenubarMenuItemRecentAction)(w)?c.append(this.createOpenRecentMenuItem(w)):(0,y.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(c),I.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?c.append(new v.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):c.append(this.createMenuItem(w.label,w.id,!1,w.checked)):c.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):c.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(c,p){this.menubarMenus&&this.menubarMenus[p]&&this.setMenu(c,this.menubarMenus[p].items)}insertCheckForUpdatesItems(c){const p=this.getUpdateMenuItems();p.length&&(p.forEach(w=>c.append(w)),c.append(r()))}createOpenRecentMenuItem(c){const p=n.URI.revive(c.uri),w=c.id,D=w==="openRecentFile"?{fileUri:p}:w==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new v.MenuItem(this.likeAction(w,{label:c.label,click:(R,_,C)=>{const G=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:c.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([p])}},!1))}isOptionClick(c){return!!(c&&(!I.isMacintosh&&(c.ctrlKey||c.shiftKey)||I.isMacintosh&&(c.metaKey||c.altKey)))}createRoleMenuItem(c,p,w){const D={label:this.mnemonicLabel(c),role:w,enabled:!0};return new v.MenuItem(this.withKeybinding(p,D))}setMacWindowMenu(c){const p=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(r()),_.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,w,r(),R,..._,r(),D].forEach(C=>c.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(c,p,w,D){const R=this.mnemonicLabel(c),_=typeof p=="function"?p:(K,Q,U)=>{const $=K?K.userSettingsLabel:null;let W=p;Array.isArray(p)&&(W=this.isOptionClick(U)?p[1]:p[0]),$&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:$}):this.runActionInRenderer({type:"commandId",commandId:W})},C=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,G=typeof D=="boolean"?D:!1,x={label:R,click:_,enabled:C};G&&(x.type="checkbox",x.checked=G);let ne;return typeof p=="string"?ne=p:Array.isArray(p)&&(ne=p[0]),I.isMacintosh&&(ne==="editor.action.clipboardCutAction"?x.role="cut":ne==="editor.action.clipboardCopyAction"?x.role="copy":ne==="editor.action.clipboardPasteAction"&&(x.role="paste"),ne==="undo"?x.click=this.makeContextAwareClickHandler(_,{inDevTools:K=>K.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?x.click=this.makeContextAwareClickHandler(_,{inDevTools:K=>K.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(_,{inDevTools:K=>K.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(ne,x))}makeContextAwareClickHandler(c,p){return(w,D,R)=>{const _=v.BrowserWindow.getFocusedWindow();if(!_)return p.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return p.inDevTools(_.webContents.devToolsWebContents);c(w,D||_,R)}}runActionInRenderer(c){let p=v.BrowserWindow.getFocusedWindow();if(!p){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(p=D.win)}const w=p?this.windowsMainService.getWindowById(p.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",c),I.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(c.type==="commandId"&&c.commandId==="workbench.action.toggleDevTools"||c.type!=="commandId"&&c.userSettingsLabel==="alt+cmd+i"))return;if(c.type==="commandId"){const D={id:c.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:c.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",c)}withKeybinding(c,p){const w=typeof c=="string"?this.keybindings[c]:void 0;if(w?.label){if(w.isNative!==!1)p.accelerator=w.label,p.userSettingsLabel=w.userSettingsLabel;else if(typeof p.label=="string"){const D=p.label.indexOf("[");D>=0?p.label=`${p.label.substr(0,D)} [${w.label}]`:p.label=`${p.label} [${w.label}]`}}else p.accelerator=void 0;return p}likeAction(c,p,w=!p.accelerator){w&&(p=this.withKeybinding(c,p));const D=p.click;return p.click=(R,_,C)=>{this.reportMenuActionTelemetry(c),D&&D(R,_,C)},p}openUrl(c,p){this.nativeHostMainService.openExternal(void 0,c),this.reportMenuActionTelemetry(p)}reportMenuActionTelemetry(c){this.telemetryService.publicLog2("workbenchActionExecuted",{id:c,from:i})}mnemonicLabel(c){return(0,M.mnemonicMenuLabel)(c,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=he([ee(0,h.IUpdateService),ee(1,m.IConfigurationService),ee(2,o.IWindowsMainService),ee(3,t.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,l.IWorkspacesHistoryMainService),ee(6,P.IStateMainService),ee(7,b.ILifecycleMainService),ee(8,E.ILogService),ee(9,d.INativeHostMainService),ee(10,g.IProductService)],s),e.Menubar=s;function r(){return new v.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,4,22,6,234]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let I=class{constructor(f,m,t){this.instantiationService=f,this.lifecycleMainService=m,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,m){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(m,f)}};I=he([ee(0,v.IInstantiationService),ee(1,L.ILifecycleMainService),ee(2,k.ILogService)],I),e.MenubarMainService=I}),define(J[236],Z([0,1,14,30,26,36,25,5,29,43,31,2,10,8,72,3,33,15,13,7,150,51,21,52,24,19,4,22,6,48,20,55,73,39,61,233,99,216,27,100,62,45]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i,s,r,a,c,p,w,D,R,_,C,G,x,ne,K,Q,U,$,W,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function B(T){return(0,U.isWorkspaceIdentifier)(T?.workspace)}function F(T){return(0,U.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let z=class Je extends b.Disposable{constructor(A,O,j,Y,q,X,ie,se,ae,de,re,ce,Ee,ve,be){super();this.machineId=A,this.initialUserEnv=O,this.logService=j,this.stateMainService=Y,this.environmentMainService=q,this.lifecycleMainService=X,this.backupMainService=ie,this.configurationService=se,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=de,this.instantiationService=re,this.dialogMainService=ce,this.fileService=Ee,this.productService=ve,this.protocolMainService=be,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new b.DisposableStore;if(O.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const j of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(u.URI.file(j)));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(u.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,O){let j=this.environmentMainService.args;const Y=O?.remoteAuthority||void 0,q=!0,X=O?.forceReuseWindow,ie=!X;return this.open({...A,cli:j,forceEmpty:q,forceNewWindow:ie,forceReuseWindow:X,remoteAuthority:Y})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],j=[],Y=[],q=[],X=[];let ie,se=0;const ae=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const ve of ae)F(ve)?A.addMode?O.push(ve):j.push(ve):B(ve)?Y.push(ve):ve.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ve.remoteAuthority}),ie.filesToOpenOrCreate.push(ve)):ve.backupPath?X.push({backupFolder:(0,y.basename)(ve.backupPath),remoteAuthority:ve.remoteAuthority}):se++;A.diffMode&&ie?.filesToOpenOrCreate.length===2&&(ie.filesToDiff=ie.filesToOpenOrCreate,ie.filesToOpenOrCreate=[]),ie&&A.waitMarkerFileURI&&(ie.filesToWait={paths:[...ie.filesToDiff,...ie.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(q.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...q),X.push(...this.backupMainService.getEmptyWindowBackupPaths())):X.length=0;const{windows:de,filesOpenedInWindow:re}=this.doOpen(A,Y,j,X,se,ie,O);if(this.logService.trace(`windowsManager#open used window count ${de.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${j.length}, emptyToRestore: ${X.length}, emptyToOpen: ${se})`),de.length>1)if(re)re.focus();else{const ve=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let be=!0,Te=!0;if(ve){const ye=de.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),be=!1,Te=!1)}if(be)for(let ye=de.length-1;ye>=0;ye--){const pe=de[ye];if(!(pe.openedWorkspace&&q.some(Ie=>pe.openedWorkspace&&Ie.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&X.some(Ie=>pe.backupPath&&Ie.backupFolder===(0,y.basename)(pe.backupPath)))){pe.focus(),Te=!1;break}}Te&&de[de.length-1].focus()}const ce=ie&&ie.filesToDiff.length>0;if(!de.some(ve=>ve.isExtensionDevelopmentHost)&&!ce&&!A.noRecentEntry){const ve=[];for(const be of ae)B(be)&&!be.transient?ve.push({label:be.label,workspace:be.workspace,remoteAuthority:be.remoteAuthority}):F(be)?ve.push({label:be.label,folderUri:be.workspace.uri,remoteAuthority:be.remoteAuthority}):be.fileUri&&ve.push({label:be.label,fileUri:be.fileUri,remoteAuthority:be.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ve)}const Ee=A.waitMarkerFileURI;return A.context===0&&Ee&&de.length===1&&de[0]&&(async()=>{await de[0].whenClosedOrLoaded;try{await this.fileService.del(Ee)}catch(ve){}})(),de}doOpen(A,O,j,Y,q,X,ie){const se=[];let ae;function de(ye,pe){se.push(ye),pe&&(ae=ye,X=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&ie.length>0){const ye=ie[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(ye);pe&&de(this.doAddFoldersToExistingWindow(pe,ie.map(Ie=>Ie.workspace.uri)))}const Ee=j.length+O.length+Y.length;if(X&&Ee===0){const ye=X.filesToOpenOrCreate[0]||X.filesToDiff[0],pe=this.getWindows().filter(Le=>X&&Le.remoteAuthority===X.remoteAuthority);let Ie;ye?.fileUri&&!ce&&((A.context===4||A.context===0||A.context===1)&&(Ie=(0,K.findWindowOnFile)(pe,ye.fileUri,Le=>Le.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(pe))),Ie?(0,U.isWorkspaceIdentifier)(Ie.openedWorkspace)?O.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,U.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?j.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):de(this.doOpenFilesInExistingWindow(A,Ie,X),!0):de(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:X,forceNewWindow:!0,remoteAuthority:X.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const ve=(0,M.distinct)(O,ye=>ye.workspace.id);if(ve.length>0){const ye=(0,M.coalesce)(ve.map(pe=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(ye.length>0){const pe=ye[0],Ie=X?.remoteAuthority===pe.remoteAuthority?X:void 0;de(this.doOpenFilesInExistingWindow(A,pe,Ie),!!Ie),re=!0}ve.forEach(pe=>{if(ye.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===pe.workspace.id))return;const Ie=pe.remoteAuthority,Le=X?.remoteAuthority===Ie?X:void 0;de(this.doOpenFolderOrWorkspace(A,pe,re,Le),!!Le),re=!0})}const be=(0,M.distinct)(j,ye=>S.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(be.length>0){const ye=(0,M.coalesce)(be.map(pe=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(ye.length>0){const pe=ye[0],Ie=X?.remoteAuthority===pe.remoteAuthority?X:void 0;de(this.doOpenFilesInExistingWindow(A,pe,Ie),!!Ie),re=!0}be.forEach(pe=>{if(ye.some(Fe=>(0,U.isSingleFolderWorkspaceIdentifier)(Fe.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Fe.openedWorkspace.uri,pe.workspace.uri)))return;const Ie=pe.remoteAuthority,Le=X?.remoteAuthority===Ie?X:void 0;de(this.doOpenFolderOrWorkspace(A,pe,re,Le),!!Le),re=!0})}const Te=(0,M.distinct)(Y,ye=>ye.backupFolder);if(Te.length>0&&Te.forEach(ye=>{const pe=ye.remoteAuthority,Ie=X?.remoteAuthority===pe?X:void 0;de(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ie,remoteAuthority:pe,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:ye}),!!Ie),re=!0}),se.length===0||X){X&&!q&&q++;const ye=X?X.remoteAuthority:A.remoteAuthority;for(let pe=0;pe<q;pe++)de(this.doOpenEmpty(A,re,ye,X),!!X),re=!0}return{windows:(0,M.distinct)(se),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(A,O,j){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const Y={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToWait:j?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",I.CancellationToken.None,Y),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const j={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",I.CancellationToken.None,j),A}doOpenEmpty(A,O,j,Y,q){return!O&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:j,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:q})}doOpenFolderOrWorkspace(A,O,j,Y,q){return!j&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:q})}getPathsToOpen(A){let O,j=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),j=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),j=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),Y=!0),!A.addMode&&j){const q=O.filter(X=>F(X));if(q.length>1){const X=q[0].remoteAuthority;if(q.every(ie=>ie.remoteAuthority===X)){const ie=this.workspacesManagementMainService.createUntitledWorkspaceSync(q.map(se=>({uri:se.workspace.uri})));O.push({workspace:ie,remoteAuthority:X}),O=O.filter(se=>!F(se))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(q=>B(q)||F(q)||q.backupPath)),O}doExtractPathsFromAPI(A){const O=[],j={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,M.coalesce)(A.urisToOpen||[])){const q=this.resolveOpenable(Y,j);if(q)q.label=Y.label,O.push(q);else{const X=this.resourceFromOpenable(Y),ie={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:X.scheme===E.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:X.scheme===E.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(X.fsPath,this.environmentMainService)):(0,o.localize)(4,null,X.toString()),noLink:!0};this.dialogMainService.showMessageBox(ie,(0,h.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],j={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const ie of Y){const se=this.cliArgToUri(ie);if(se){const ae=this.resolveOpenable({folderUri:se},j);ae&&O.push(ae)}}const q=A["file-uri"];if(q)for(const ie of q){const se=this.cliArgToUri(ie);if(se){const ae=this.resolveOpenable((0,U.hasWorkspaceFileExtension)(ie)?{workspaceUri:se}:{fileUri:se},j);ae&&O.push(ae)}}const X=A._;for(const ie of X){const se=j.remoteAuthority?this.doResolvePathRemote(ie,j):this.doResolveFilePath(ie,j);se&&O.push(se)}return O}cliArgToUri(A){try{const O=u.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const j=[];for(const Y of O)if(Y.workspace){const q=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});B(q)&&j.push(q)}else if(Y.folderUri){const q=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});F(q)&&j.push(q)}else A!=="folders"&&Y.backupPath&&j.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return j}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){let j=this.resourceFromOpenable(A);return j.scheme===E.Schemas.file?((0,x.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(j.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let j=this.resourceFromOpenable(A);const Y=(0,C.getRemoteAuthority)(j)||O.remoteAuthority;if(j=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(j)),(0,x.isFileToOpen)(A)){if(O.gotoLineMode){const{path:q,line:X,column:ie}=(0,f.parseLineAndColumnAware)(j.path);return{fileUri:j.with({path:q}),selection:X?{startLineNumber:X,startColumn:ie||1}:void 0,remoteAuthority:Y}}return{fileUri:j,remoteAuthority:Y}}else if((0,x.isWorkspaceToOpen)(A))return{workspace:(0,$.getWorkspaceIdentifier)(j),remoteAuthority:Y};return{workspace:(0,$.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:Y}}resourceFromOpenable(A){return(0,x.isWorkspaceToOpen)(A)?A.workspaceUri:(0,x.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let j,Y;O.gotoLineMode&&({path:A,line:j,column:Y}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,y.normalize)(A),(0,P.cwd)());try{const q=(0,L.statSync)(A);if(q.isFile()){if(!O.forceOpenWorkspaceAsFile){const X=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(A));if(X)return X.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:X.id,configPath:X.configPath},remoteAuthority:X.remoteAuthority,exists:!0,transient:X.transient}}return{fileUri:u.URI.file(A),selection:j?{startLineNumber:j,startColumn:Y||1}:void 0,exists:!0}}else if(q.isDirectory())return{workspace:(0,$.getSingleFolderWorkspaceIdentifier)(u.URI.file(A),q),exists:!0}}catch(q){const X=u.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([X]),O.ignoreFileNotFound)return{fileUri:X,exists:!1}}}doResolvePathRemote(A,O){const j=A.charCodeAt(0),Y=O.remoteAuthority;let q,X;O.gotoLineMode&&({path:A,line:q,column:X}=(0,f.parseLineAndColumnAware)(A)),j!==47&&((0,f.isWindowsDriveLetter)(j)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const ie=u.URI.from({scheme:E.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,U.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:ie,selection:q?{startLineNumber:q,startColumn:X||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,$.getWorkspaceIdentifier)(ie),remoteAuthority:Y};if(O.gotoLineMode||y.posix.basename(A).indexOf(".")!==-1)return{fileUri:ie,selection:q?{startLineNumber:q,startColumn:X||1}:void 0,remoteAuthority:Y}}return{workspace:(0,$.getSingleFolderWorkspaceIdentifier)(ie),remoteAuthority:Y}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),j=O?.openFoldersInNewWindow||"default",Y=O?.openFilesInNewWindow||"off";let q=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(j==="on"||j==="off")&&(q=j==="on");let X=!1;return A.forceNewWindow||A.forceReuseWindow?X=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(X=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(X=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(X=Y==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:X}}openExtensionDevelopmentHostWindow(A,O){const j=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(j)return this.lifecycleMainService.reload(j,O.cli),j.focus(),[j];let Y=O.cli["folder-uri"]||[],q=O.cli["file-uri"]||[],X=O.cli._;if(!X.length&&!Y.length&&!q.length&&!O.cli.extensionTestsPath){const de=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=de&&(de.workspace||de.folderUri);re&&(u.URI.isUri(re)?re.scheme===E.Schemas.file?X=[re.fsPath]:Y=[re.toString()]:re.configPath.scheme===E.Schemas.file?X=[(0,S.originalFSPath)(re.configPath)]:q=[re.configPath.toString()])}let ie=O.remoteAuthority;for(const de of A)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=u.URI.parse(de),ce=(0,C.getRemoteAuthority)(re);ce&&(ie?ce!==ie&&this.logService.error("more than one extension development path authority"):ie=ce)}X=X.filter(de=>{const re=u.URI.file(de);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,C.getRemoteAuthority)(re)===ie}),Y=Y.filter(de=>{const re=this.cliArgToUri(de);return re&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,C.getRemoteAuthority)(re)===ie:!1}),q=q.filter(de=>{const re=this.cliArgToUri(de);return re&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,C.getRemoteAuthority)(re)===ie:!1}),O.cli._=X,O.cli["folder-uri"]=Y,O.cli["file-uri"]=q;const se=!X.length&&!Y.length&&!q.length,ae={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:se,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:ie};return this.open(ae)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),j={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const q=Y.config;!j.extensionDevelopmentPath&&q&&!!q.extensionDevelopmentPath&&(j.extensionDevelopmentPath=q.extensionDevelopmentPath,j.verbose=q.verbose,j["inspect-brk-extensions"]=q["inspect-brk-extensions"],j.debugId=q.debugId,j["inspect-extensions"]=q["inspect-extensions"],j["extensions-dir"]=q["extensions-dir"])}else{const q=this.windowsStateHandler.getNewWindowState(j);(0,d.mark)("code/willCreateCodeWindow");const X=Y=this.instantiationService.createInstance(ne.CodeWindow,{state:q,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(X)}Je.WINDOWS.push(X),this._onDidOpenWindow.fire(X),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(X.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(X)),(0,m.once)(X.onDidClose)(()=>this.onWindowClosed(X)),(0,m.once)(X.onDidDestroy)(()=>this._onDidDestroyWindow.fire(X));const ie=(0,h.assertIsDefined)(X.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.lifecycleMainService.reload(X)),this.lifecycleMainService.registerWindow(X)}return j.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(q=>{q||this.doOpenInBrowserWindow(Y,j,A)}):this.doOpenInBrowserWindow(Y,j,A),Y}doOpenInBrowserWindow(A,O,j){if(!O.extensionDevelopmentPath)if((0,U.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,U.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const Y=j.emptyWindowBackupInfo&&j.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=v.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===A))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map(j=>j.lastFocusTime));return A.find(j=>j.lastFocusTime===O)}sendToFocused(A,...O){const j=this.getFocusedWindow()||this.getLastActiveWindow();j&&j.sendWhenReady(A,I.CancellationToken.None,...O)}sendToAll(A,O,j){for(const Y of this.getWindows())j&&j.indexOf(Y.id)>=0||Y.sendWhenReady(A,I.CancellationToken.None,O)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter(j=>j.id===A);return(0,M.firstOrDefault)(O)}getWindowByWebContents(A){const O=v.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};z.WINDOWS=[],z=he([ee(2,w.ILogService),ee(3,G.IStateMainService),ee(4,r.IEnvironmentMainService),ee(5,p.ILifecycleMainService),ee(6,l.IBackupMainService),ee(7,i.IConfigurationService),ee(8,W.IWorkspacesHistoryMainService),ee(9,N.IWorkspacesManagementMainService),ee(10,c.IInstantiationService),ee(11,s.IDialogMainService),ee(12,a.IFileService),ee(13,R.IProductService),ee(14,_.IProtocolMainService)],z),e.WindowsMainService=z}),define(J[237],Z([0,1,51,35,62,45]),function(V,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(f,m,t,b){this.workspacesManagementMainService=f,this.windowsMainService=m,this.workspacesHistoryMainService=t,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,m){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(f,m,t){return this.workspacesManagementMainService.createUntitledWorkspace(m,t)}deleteUntitledWorkspace(f,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(f,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}async removeRecentlyOpened(f,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=he([ee(0,M.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,v.IBackupMainService)],I),e.WorkspacesMainService=I}),define(J[238],Z([0,1,14,30,26,17,16,29,43,40,31,2,10,8,3,15,13,7,28,66,119,34,122,83,229,131,51,220,21,178,157,70,52,219,87,24,54,89,169,185,88,172,19,69,4,71,230,196,101,22,6,180,235,53,20,73,225,74,39,214,98,197,32,200,201,96,42,205,227,231,228,232,97,206,207,208,209,211,35,236,212,27,62,237,45]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i,s,r,a,c,p,w,D,R,_,C,G,x,ne,K,Q,U,$,W,N,B,F,z,T,A,O,j,Y,q,X,ie,se,ae,de,re,ce,Ee,ve,be,Te,ye,pe,Ie,Le,Fe,Ue,Ne,Ge,je,nt,Ce,rt,lt,ct,Ve,ut,Ye,H,te,oe,le,fe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pe=class extends b.Disposable{constructor(ue,ge,we,me,ke,De,Me,Ae,Re,Be){super();this.mainProcessNodeIpcServer=ue,this.userEnv=ge,this.mainInstantiationService=we,this.logService=me,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ae,this.fileService=Re,this.productService=Be,this.configureSession(),this.registerListeners()}configureSession(){const ue=me=>me?.startsWith(`${E.Schemas.vscodeWebview}://`),ge=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((me,ke,De,Me)=>ue(Me.requestingUrl)?De(ge.has(ke)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((me,ke,De,Me)=>ue(Me.requestingUrl)?ge.has(ke):!1);const we=v.session.defaultSession;typeof we.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&we.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(we=>this.onUnexpectedError(we)),process.on("uncaughtException",we=>(0,I.onUnexpectedError)(we)),process.on("unhandledRejection",we=>(0,I.onUnexpectedError)(we)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,o.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(we,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),v.app.on("activate",(we,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(we,me)=>{me.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),me.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let ue=[],ge;v.app.on("open-file",(we,me)=>{this.logService.trace("app#open-file: ",me),we.preventDefault(),ue.push(this.getWindowOpenableFromPathSync(me)),ge!==void 0&&(clearTimeout(ge),ge=void 0),ge=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ue,gotoLineMode:!1,preferNewWindow:!0}),ue=[],ge=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",we=>{const me=this.windowsMainService?.getWindowByWebContents(we.sender);let ke,De;return me?.config?(ke=me.config,De={...process.env,...me.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),(0,Q.resolveShellEnv)(this.logService,ke,De)}),v.ipcMain.handle("vscode:writeNlsFile",(we,me,ke)=>{const De=this.validateNlsPath([me]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,M.VSBuffer.fromString(ke))}),v.ipcMain.handle("vscode:readNlsFile",async(we,...me)=>{const ke=this.validateNlsPath(me);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",we=>we.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",we=>we.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",we=>we.sender.reload())}validateNlsPath(ue){let ge;for(const we of ue)typeof we=="string"&&(typeof ge!="string"?ge=we:ge=(0,y.join)(ge,we));if(!(typeof ge!="string"||!(0,y.isAbsolute)(ge)||!(0,n.isEqualOrParent)(ge,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return S.URI.file(ge)}onUnexpectedError(ue){if(ue){const ge={message:`[uncaught exception in main]: ${ue.message}`,stack:ue.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ge))}this.logService.error(`[uncaught exception in main]: ${ue}`),ue.stack&&this.logService.error(ue.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ue=this.productService.win32AppUserModelId;d.isWindows&&ue&&v.app.setAppUserModelId(ue);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const ge=new i.Server;this.logService.trace("Resolving machine identifier...");const we=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${we}`);const{sharedProcess:me,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(we),Me=await this.initServices(we,me,ke);if(this.environmentMainService.driverHandle){const Re=await(0,G.serve)(ge,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Re=>this.initChannels(Re,ge,De));const Ae=Me.invokeFunction(Re=>this.openFirstWindow(Re,ge));Me.invokeFunction(Re=>this.afterWindowOpen(Re,me)),this.environmentMainService.args.trace&&Me.invokeFunction(Re=>this.stopTracingEventually(Re,Ae))}async resolveMachineId(){let ue=this.stateMainService.getItem(ye.machineIdKey);return(!ue||d.isMacintosh&&ue==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ue=await(0,u.getMachineId)(),this.stateMainService.setItem(ye.machineIdKey,ue)),ue}setupSharedProcess(ue){const ge=this._register(this.mainInstantiationService.createInstance(re.SharedProcess,ue,this.userEnv)),we=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ge.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(ke,"main")})(),me=(async()=>(await ge.whenReady(),we))();return{sharedProcess:ge,sharedProcessReady:me,sharedProcessClient:we}}async initServices(ue,ge,we){const me=new T.ServiceCollection;switch(process.platform){case"win32":me.set(Fe.IUpdateService,new F.SyncDescriptor(nt.Win32UpdateService));break;case"linux":d.isLinuxSnap?me.set(Fe.IUpdateService,new F.SyncDescriptor(je.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(Fe.IUpdateService,new F.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":me.set(Fe.IUpdateService,new F.SyncDescriptor(Ne.DarwinUpdateService));break}me.set(Ye.IWindowsMainService,new F.SyncDescriptor(H.WindowsMainService,[ue,this.userEnv])),me.set(C.IDialogMainService,new F.SyncDescriptor(C.DialogMainService)),me.set(j.ILaunchMainService,new F.SyncDescriptor(j.LaunchMainService)),me.set(_.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(we.then(De=>De.getChannel("diagnostics"))))),me.set(A.IIssueMainService,new F.SyncDescriptor(A.IssueMainService,[this.userEnv])),me.set(x.IEncryptionMainService,new F.SyncDescriptor(x.EncryptionMainService,[ue])),me.set(O.IKeyboardLayoutMainService,new F.SyncDescriptor(O.KeyboardLayoutMainService)),me.set(se.INativeHostMainService,new F.SyncDescriptor(se.NativeHostMainService,[ge])),me.set(Ve.IWebviewManagerService,new F.SyncDescriptor(ut.WebviewMainService)),me.set(oe.IWorkspacesService,new F.SyncDescriptor(fe.WorkspacesMainService)),me.set(Se.IWorkspacesManagementMainService,new F.SyncDescriptor(Se.WorkspacesManagementMainService)),me.set(le.IWorkspacesHistoryMainService,new F.SyncDescriptor(le.WorkspacesHistoryMainService)),me.set(ie.IMenubarMainService,new F.SyncDescriptor(ie.MenubarMainService)),me.set(U.IExtensionUrlTrustService,new F.SyncDescriptor($.ExtensionUrlTrustService)),me.set(be.IStorageMainService,new F.SyncDescriptor(be.StorageMainService)),d.isWindows?me.set(W.IExternalTerminalMainService,new F.SyncDescriptor(N.WindowsExternalTerminalService)):d.isMacintosh?me.set(W.IExternalTerminalMainService,new F.SyncDescriptor(N.MacExternalTerminalService)):d.isLinux&&me.set(W.IExternalTerminalMainService,new F.SyncDescriptor(N.LinuxExternalTerminalService));const ke=new p.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(c.IBackupMainService,ke),me.set(Ce.IURLService,new F.SyncDescriptor(lt.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const De=(0,l.getDelayedChannel)(we.then(Ke=>Ke.getChannel("telemetryAppender"))),Me=new pe.TelemetryAppenderClient(De),Ae=(0,Te.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,ue,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Be={appender:Me,commonProperties:Ae,piiPaths:Re,sendErrorTelemetry:!0};me.set(ye.ITelemetryService,new F.SyncDescriptor(Ie.TelemetryService,[Be]))}else me.set(ye.ITelemetryService,Le.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(me)}initChannels(ue,ge,we){const me=l.ProxyChannel.fromService(ue.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me),ge.registerChannel(D.UserConfigurationFileServiceId,l.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const ke=new Ue.UpdateChannel(ue.get(Fe.IUpdateService));ge.registerChannel("update",ke);const De=l.ProxyChannel.fromService(ue.get(A.IIssueMainService));ge.registerChannel("issue",De);const Me=l.ProxyChannel.fromService(ue.get(x.IEncryptionMainService));ge.registerChannel("encryption",Me);const Ae=l.ProxyChannel.fromService(ue.get(ce.ISignService));ge.registerChannel("sign",Ae);const Re=l.ProxyChannel.fromService(ue.get(O.IKeyboardLayoutMainService));ge.registerChannel("keyboardLayout",Re),this.nativeHostMainService=ue.get(se.INativeHostMainService);const Be=l.ProxyChannel.fromService(this.nativeHostMainService);ge.registerChannel("nativeHost",Be),we.then(ze=>ze.registerChannel("nativeHost",Be));const Ke=l.ProxyChannel.fromService(ue.get(oe.IWorkspacesService));ge.registerChannel("workspaces",Ke);const Ze=l.ProxyChannel.fromService(ue.get(ie.IMenubarMainService));ge.registerChannel("menubar",Ze);const xe=l.ProxyChannel.fromService(ue.get(Ce.IURLService));ge.registerChannel("url",xe);const ht=l.ProxyChannel.fromService(ue.get(U.IExtensionUrlTrustService));ge.registerChannel("extensionUrlTrust",ht);const _e=l.ProxyChannel.fromService(ue.get(Ve.IWebviewManagerService));ge.registerChannel("webview",_e);const et=this._register(new ve.StorageDatabaseChannel(this.logService,ue.get(be.IStorageMainService)));ge.registerChannel("storage",et),we.then(ze=>ze.registerChannel("storage",et));const tt=l.ProxyChannel.fromService(ue.get(W.IExternalTerminalMainService));ge.registerChannel("externalTerminal",tt);const Xe=new X.LogLevelChannel(ue.get(q.ILogService));ge.registerChannel("logLevel",Xe),we.then(ze=>ze.registerChannel("logLevel",Xe));const it=new X.LoggerChannel(ue.get(q.ILoggerService));ge.registerChannel("logger",it),we.then(ze=>ze.registerChannel("logger",it));const st=new R.ElectronExtensionHostDebugBroadcastChannel(ue.get(Ye.IWindowsMainService));ge.registerChannel("extensionhostdebugservice",st)}openFirstWindow(ue,ge){const we=this.windowsMainService=ue.get(Ye.IWindowsMainService),me=ue.get(Ce.IURLService),ke=ue.get(se.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:S.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(De.push(Qe),!1):!0}),Ae=this,Re=this.environmentMainService,Be=this.productService;me.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===Be.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:S.URI.parse(Oe.query).path,query:""})),Ae.shouldBlockURI(Oe))return!0;const vt=Ae.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=we.open({context:5,cli:{...Re.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&we.getWindowCount()===0){const[ft]=we.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(Oe)});return await ft.ready(),me.open(Oe,Qe)}return!1}});const Ke=this._register(new te.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ze=new l.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),xe=new rt.URLHandlerRouter(Ze),ht=ge.getChannel("urlHandler",xe);me.registerHandler(new rt.URLHandlerChannelClient(ht)),this._register(new ct.ElectronURLListener(Me,me,we,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,et=global.macOpenFiles,tt=(0,K.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,it=!!_e["folder-uri"],st=!!_e["file-uri"],ze=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?S.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return De.length>0?we.open({context:tt,cli:_e,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!it&&!st?we.open({context:tt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ze,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):et.length&&!Xe&&!it&&!st?we.open({context:1,cli:_e,urisToOpen:et.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:ze,waitMarkerFileURI:dt,initialStartup:!0}):we.open({context:tt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:ze,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(ue){return!!(ue.authority===E.Schemas.file&&d.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,t.getPathLabel)(ue.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ue){if(!!ue.path){if(ue.authority===E.Schemas.file)return{fileUri:S.URI.file(ue.fsPath)};if(ue.authority===E.Schemas.vscodeRemote){const ge=ue.path.indexOf(y.posix.sep,1);if(ge!==-1){const we=ue.path.substring(1,ge),me=ue.path.substring(ge),ke=S.URI.from({scheme:E.Schemas.vscodeRemote,authority:we,path:me,query:ue.query,fragment:ue.fragment});return(0,oe.hasWorkspaceFileExtension)(me)?{workspaceUri:ke}:/:[\d]+$/.test(me)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(ue){try{if((0,L.statSync)(ue).isDirectory())return{folderUri:S.URI.file(ue)};if((0,oe.hasWorkspaceFileExtension)(ue))return{workspaceUri:S.URI.file(ue)}}catch(ge){}return{fileUri:S.URI.file(ue)}}async afterWindowOpen(ue,ge){this.lifecycleMainService.phase=3;let we=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>we=!0);const me=ue.get(ye.ITelemetryService);this._register(ge.onDidError(({type:Me,details:Ae})=>{let Re;switch(Me){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Re)),me.publicLog2("sharedprocesserror",{type:Me,reason:Ae?.reason,code:Ae?.exitCode,visible:ge.isVisible(),shuttingdown:we})}));const ke=this.productService.win32MutexName;if(d.isWindows&&ke)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Ae=new Me(ke);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(E.Schemas.vscodeRemoteResource,(Me,Ae)=>{Ae({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=ue.get(Fe.IUpdateService);(De instanceof nt.Win32UpdateService||De instanceof Ge.LinuxUpdateService||De instanceof Ne.DarwinUpdateService)&&De.initialize(),(0,Q.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,m.stripComments)(Ae))["enable-crash-reporter"]===void 0){const Be=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof Be=="boolean"?Be:!0,Ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],xe=Ae.substring(0,Ae.length-2).concat(`,
`,Ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(xe))}}catch(Me){this.logService.error(Me)}}stopTracingEventually(ue,ge){this.logService.info("Tracing: waiting for windows to get ready...");const we=ue.get(C.IDialogMainService);let me=!1;const ke=async Me=>{if(me)return;me=!0;const Ae=await v.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):we.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,a.localize)(4,null),detail:(0,a.localize)(5,null,Ae),buttons:[(0,t.mnemonicButtonLabel)((0,a.localize)(6,null))],defaultId:0,noLink:!0},(0,P.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(ge.map(Me=>Me.ready())).then(()=>{clearTimeout(De),ke(!1)})}};Pe=he([ee(2,z.IInstantiationService),ee(3,q.ILogService),ee(4,ne.IEnvironmentMainService),ee(5,Y.ILifecycleMainService),ee(6,w.IConfigurationService),ee(7,Ee.IStateMainService),ee(8,B.IFileService),ee(9,ae.IProductService)],Pe),e.CodeApplication=Pe}),define(J[242],Z([0,1,14,30,36,9,67,16,29,43,31,10,8,72,3,33,23,18,34,56,238,11,21,189,198,24,54,161,19,183,184,69,174,71,22,91,6,181,92,48,20,55,186,94,222,50,224,74,195,39,226,96,60,204]),function(V,e,v,L,k,M,I,n,f,m,t,b,E,y,d,g,P,S,h,u,o,l,i,s,r,a,c,p,w,D,R,_,C,G,x,ne,K,Q,U,$,W,N,B,F,z,T,A,O,j,Y,q,X,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class se{main(){try{this.startup()}catch(re){console.error(re.message),v.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(pe=>console.error(pe));const[re,ce,Ee,ve,be,Te,ye]=this.createServices();try{try{await this.initServices(Ee,ve,be)}catch(pe){throw this.handleStartupDataDirError(Ee,ye.nameLong,pe),pe}await re.invokeFunction(async pe=>{const Ie=pe.get(K.ILogService),Le=pe.get(x.ILifecycleMainService),Fe=pe.get(w.IFileService),Ue=await this.claimInstance(Ie,Ee,Le,re,ye,!0);return S.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Ne=>{Ie.warn(`Error writing main lockfile: ${Ne.stack}`)}),Te.logger=new U.SpdLogLogger("main",(0,E.join)(Ee.logsPath,"main.log"),!0,Te.getLevel()),(0,m.once)(Le.onWillShutdown)(()=>{Fe.dispose(),ve.dispose();try{(0,L.unlinkSync)(Ee.mainLockfile)}catch{}}),re.createInstance(o.CodeApplication,Ue,ce).startup()})}catch(pe){re.invokeFunction(this.quit,pe)}}createServices(){const re=new G.ServiceCollection,ce={_serviceBrand:void 0,...$.default};re.set(W.IProductService,ce);const Ee=new a.EnvironmentMainService(this.resolveArgs(),ce),ve=this.patchEnvironment(Ee);re.set(a.IEnvironmentMainService,Ee);const be=new ne.BufferLogService,Te=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(Ee)),be]);process.once("exit",()=>Te.dispose()),re.set(K.ILogService,Te);const ye=new D.FileService(Te);re.set(w.IFileService,ye);const pe=new R.DiskFileSystemProvider(Te);ye.registerProvider(b.Schemas.file,pe),re.set(K.ILoggerService,new Q.LoggerService(Te,ye));const Ie=new s.ConfigurationService(Ee.settingsResource,ye);re.set(i.IConfigurationService,Ie),re.set(x.ILifecycleMainService,new _.SyncDescriptor(x.LifecycleMainService));const Le=new q.StateMainService(Ee,Te,ye);return re.set(Y.IStateMainService,Le),re.set(T.IRequestService,new _.SyncDescriptor(A.RequestMainService)),re.set(ie.IThemeMainService,new _.SyncDescriptor(ie.ThemeMainService)),re.set(O.ISignService,new _.SyncDescriptor(j.SignService)),re.set(F.ITunnelService,new _.SyncDescriptor(z.TunnelService)),re.set(N.IProtocolMainService,new _.SyncDescriptor(B.ProtocolMainService)),[new C.InstantiationService(re,!0),ve,Ee,Ie,Le,be,ce]}patchEnvironment(re){const ce={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const ve=process.env[Ee];typeof ve=="string"&&(ce[Ee]=ve)}),Object.assign(process.env,ce),ce}initServices(re,ce,Ee){return M.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(ve=>ve?S.Promises.mkdir(ve,{recursive:!0}):void 0)),ce.initialize(),Ee.init()])}async claimInstance(re,ce,Ee,ve,be,Te){let ye;try{(0,y.mark)("code/willStartMainServer"),ye=await(0,u.serve)(ce.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.once)(Ee.onWillShutdown)(()=>ye.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,be.nameLong,pe),pe;let Ie;try{Ie=await(0,u.connect)(ce.mainIPCHandle,"main")}catch(Ue){if(!Te||d.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,be.nameShort),(0,l.localize)(1,null),be.nameLong),Ue;try{(0,L.unlinkSync)(ce.mainIPCHandle)}catch(Ne){throw re.warn("Could not delete obsolete instance handle",Ne),Ne}return this.claimInstance(re,ce,Ee,ve,be,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Ue),Ie.dispose(),new Error(Ue)}let Le;!ce.args.wait&&!ce.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,be.nameShort),(0,l.localize)(3,null),be.nameLong)},1e4));const Fe=h.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return ve.invokeFunction(async()=>{const Ue=new r.DiagnosticsService(X.NullTelemetryService,be),Ne=await Fe.getMainProcessInfo(),Ge=await Fe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),je=await Ue.getDiagnostics(Ne,Ge);throw console.log(je),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Fe,re),re.trace("Sending env to running instance..."),await Fe.start(ce.args,process.env),Ie.dispose(),Le&&clearTimeout(Le),new n.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(re,ce,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const ve=(0,k.coalesce)([re.userDataPath,re.extensionsPath,u.XDG_RUNTIME_DIR]).map(be=>(0,t.getPathLabel)(be,re));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,I.toErrorMessage)(Ee),ve.join(`
`)),ce)}}showStartupWarningDialog(re,ce,Ee){v.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,l.localize)(6,null))],message:re,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,ce){if(d.isWindows){const Ee=await re.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((ve,be)=>{V(["windows-foreground-love"],ve,be)})).allowSetForegroundWindow(Ee)}catch(ve){ce.error(ve)}}}quit(re,ce){const Ee=re.get(K.ILogService),ve=re.get(x.ILifecycleMainService);let be=0;ce&&(ce.isExpected?ce.message&&Ee.trace(ce.message):(be=1,ce.stack?Ee.error(ce.stack):Ee.error(`Startup error: ${ce.toString()}`))),ve.kill(be)}resolveArgs(){const re=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const ce=(0,p.createWaitMarkerFile)(re.verbose);ce&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",ce),re.waitMarkerFilePath=ce)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const ce=this.doValidatePaths(re._,re.goto);re._=ce}return re}doValidatePaths(re,ce){const Ee=(0,g.cwd)(),ve=re.map(ye=>{let pe=String(ye),Ie;ce&&(Ie=(0,f.parseLineAndColumnAware)(pe),pe=Ie.path),pe&&(pe=this.preparePath(Ee,pe));const Le=(0,f.sanitizeFilePath)(pe,Ee),Fe=(0,E.basename)(Le);return Fe&&!(0,f.isValidBasename)(Fe)?null:ce&&Ie?(Ie.path=Le,this.toPath(Ie)):Le}),be=d.isWindows||d.isMacintosh,Te=(0,k.distinct)(ve,ye=>ye&&be?ye.toLowerCase():ye||"");return(0,k.coalesce)(Te)}preparePath(re,ce){return d.isWindows&&(ce=(0,P.rtrim)(ce,'"')),ce=(0,P.trim)((0,P.trim)(ce," "),"	"),d.isWindows&&(ce=(0,E.resolve)(re,ce),ce=(0,P.rtrim)(ce,".")),ce}toPath(re){const ce=[re.path];return typeof re.line=="number"&&ce.push(String(re.line)),typeof re.column=="number"&&ce.push(String(re.column)),ce.join(":")}}new se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/49af1cbe00271ac2ea36cfc5f7352fe31a7b0094/core/vs/code/electron-main/main.js.map
