/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/errors","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function(q){for(var t=[],T=0,R=q.length;T<R;T++)t[T]=Z[q[T]];return t};define(Z[57],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(R,S){if(!R)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=T}),define(Z[44],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(k){return(C,c,d)=>{let m=null,v=null;if(typeof d.value=="function"?(m="value",v=d.value):typeof d.get=="function"&&(m="get",v=d.get),!v)throw new Error("not supported");d[m]=k(v,c)}}t.createDecorator=T;function R(k,C,c){let d=null,m=null;if(typeof c.value=="function"?(d="value",m=c.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",m=c.get),!m)throw new Error("not supported");const v=`$memoize$${C}`;c[d]=function(...p){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[v]}}t.memoize=R;function S(k,C,c){return T((d,m)=>{const v=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...L){this[p]||(this[p]=c?c():void 0),clearTimeout(this[v]),C&&(this[p]=C(this[p],...L),L=[this[p]]),this[v]=setTimeout(()=>{d.apply(this,L),this[p]=c?c():void 0},k)}})}t.debounce=S;function F(k,C,c){return T((d,m)=>{const v=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,L=`$throttle$lastRun$${m}`,a=`$throttle$pending$${m}`;return function(...l){if(this[p]||(this[p]=c?c():void 0),(this[L]===null||this[L]===void 0)&&(this[L]=-Number.MAX_VALUE),C&&(this[p]=C(this[p],...l)),this[a])return;const I=this[L]+k;I<=Date.now()?(this[L]=Date.now(),d.apply(this,[this[p]]),this[p]=c?c():void 0):(this[a]=!0,this[v]=setTimeout(()=>{this[a]=!1,this[L]=Date.now(),d.apply(this,[this[p]]),this[p]=c?c():void 0},I-Date.now()))}})}t.throttle=F}),define(Z[24],te([0,1,8]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function R(E,O=0){return E[E.length-(1+O)]}t.tail=R;function S(E){if(E.length===0)throw new Error("Invalid tail call");return[E.slice(0,E.length-1),E[E.length-1]]}t.tail2=S;function F(E,O,D=(z,j)=>z===j){if(E===O)return!0;if(!E||!O||E.length!==O.length)return!1;for(let z=0,j=E.length;z<j;z++)if(!D(E[z],O[z]))return!1;return!0}t.equals=F;function k(E,O,D){let z=0,j=E.length-1;for(;z<=j;){const $=(z+j)/2|0,H=D(E[$],O);if(H<0)z=$+1;else if(H>0)j=$-1;else return $}return-(z+1)}t.binarySearch=k;function C(E,O){let D=0,z=E.length;if(z===0)return 0;for(;D<z;){const j=Math.floor((D+z)/2);O(E[j])?z=j:D=j+1}return D}t.findFirstInSorted=C;function c(E,O,D){if(E=E|0,E>=O.length)throw new TypeError("invalid index");let z=O[Math.floor(O.length*Math.random())],j=[],$=[],H=[];for(let ee of O){const ne=D(ee,z);ne<0?j.push(ee):ne>0?$.push(ee):H.push(ee)}return E<j.length?c(E,j,D):E<j.length+H.length?H[0]:c(E-(j.length+H.length),$,D)}t.quickSelect=c;function d(E,O){const D=[];let z;for(const j of E.slice(0).sort(O))!z||O(z[0],j)!==0?(z=[j],D.push(z)):z.push(j);return D}t.groupBy=d;function m(E,O,D){const z=[];function j(ee,ne,re){if(ne===0&&re.length===0)return;const ce=z[z.length-1];ce&&ce.start+ce.deleteCount===ee?(ce.deleteCount+=ne,ce.toInsert.push(...re)):z.push({start:ee,deleteCount:ne,toInsert:re})}let $=0,H=0;for(;;){if($===E.length){j($,0,O.slice(H));break}if(H===O.length){j($,E.length-$,[]);break}const ee=E[$],ne=O[H],re=D(ee,ne);re===0?($+=1,H+=1):re<0?(j($,1,[]),$+=1):re>0&&(j($,0,[ne]),H+=1)}return z}t.sortedDiff=m;function v(E,O,D){const z=m(E,O,D),j=[],$=[];for(const H of z)j.push(...E.slice(H.start,H.start+H.deleteCount)),$.push(...H.toInsert);return{removed:j,added:$}}t.delta=v;function p(E,O,D){if(D===0)return[];const z=E.slice(0,D).sort(O);return a(E,O,z,D,E.length),z}t.top=p;function L(E,O,D,z,j){return D===0?Promise.resolve([]):new Promise(($,H)=>{(async()=>{const ee=E.length,ne=E.slice(0,D).sort(O);for(let re=D,ce=Math.min(D+z,ee);re<ee;re=ce,ce=Math.min(ce+z,ee)){if(re>D&&await new Promise(me=>setTimeout(me)),j&&j.isCancellationRequested)throw(0,T.canceled)();a(E,O,ne,re,ce)}return ne})().then($,H)})}t.topAsync=L;function a(E,O,D,z,j){for(const $=D.length;z<j;z++){const H=E[z];if(O(H,D[$-1])<0){D.pop();const ee=C(D,ne=>O(H,ne)<0);D.splice(ee,0,H)}}}function l(E){return E.filter(O=>!!O)}t.coalesce=l;function I(E){let O=0;for(let D=0;D<E.length;D++)E[D]&&(E[O]=E[D],O+=1);E.length=O}t.coalesceInPlace=I;function y(E,O,D){E.splice(D,0,E.splice(O,1)[0])}t.move=y;function b(E){return!Array.isArray(E)||E.length===0}t.isFalsyOrEmpty=b;function f(E){return Array.isArray(E)&&E.length>0}t.isNonEmptyArray=f;function r(E,O){if(!O)return E.filter((z,j)=>E.indexOf(z)===j);const D=Object.create(null);return E.filter(z=>{const j=O(z);return D[j]?!1:(D[j]=!0,!0)})}t.distinct=r;function s(E){const O=new Set;return E.filter(D=>O.has(D)?!1:(O.add(D),!0))}t.distinctES6=s;function e(E){const O=Object.create(null);return D=>{const z=E(D);return O[z]?!1:(O[z]=!0,!0)}}t.uniqueFilter=e;function i(E,O){for(let D=E.length-1;D>=0;D--){const z=E[D];if(O(z))return D}return-1}t.lastIndex=i;function n(E,O){return E.length>0?E[0]:O}t.firstOrDefault=n;function o(E,O,D=(z,j)=>z===j){let z=0;for(let j=0,$=Math.min(E.length,O.length);j<$&&D(E[j],O[j]);j++)z++;return z}t.commonPrefixLength=o;function u(E){return[].concat(...E)}t.flatten=u;function h(E,O){let D=typeof O=="number"?E:0;typeof O=="number"?D=E:(D=0,O=E);const z=[];if(D<=O)for(let j=D;j<O;j++)z.push(j);else for(let j=D;j>O;j--)z.push(j);return z}t.range=h;function g(E,O,D){return E.reduce((z,j)=>(z[O(j)]=D?D(j):j,z),Object.create(null))}t.index=g;function N(E,O){return E.push(O),()=>P(E,O)}t.insert=N;function P(E,O){const D=E.indexOf(O);if(D>-1)return E.splice(D,1),O}t.remove=P;function A(E,O,D){const z=E.slice(0,O),j=E.slice(O);return z.concat(D,j)}t.arrayInsert=A;function x(E,O){let D;if(typeof O=="number"){let z=O;D=()=>{const j=Math.sin(z++)*179426549;return j-Math.floor(j)}}else D=Math.random;for(let z=E.length-1;z>0;z-=1){const j=Math.floor(D()*(z+1)),$=E[z];E[z]=E[j],E[j]=$}}t.shuffle=x;function _(E,O){const D=E.indexOf(O);D>-1&&(E.splice(D,1),E.unshift(O))}t.pushToStart=_;function J(E,O){const D=E.indexOf(O);D>-1&&(E.splice(D,1),E.push(O))}t.pushToEnd=J;function ie(E,O){return Array.isArray(E)?E.map(O):O(E)}t.mapArrayOrNot=ie;function se(E){return Array.isArray(E)?E:[E]}t.asArray=se;function Y(E){return E[Math.floor(Math.random()*E.length)]}t.getRandomElement=Y;function X(E,O){for(const D of E){const z=O(D);if(z!==void 0)return z}}t.mapFind=X;function Q(E,O,D){const z=W(E,O),j=E.length,$=D.length;E.length=j+$;for(let H=j-1;H>=z;H--)E[H+$]=E[H];for(let H=0;H<$;H++)E[H+z]=D[H]}t.insertInto=Q;function B(E,O,D,z){const j=W(E,O),$=E.splice(j,D);return Q(E,j,z),$}t.splice=B;function W(E,O){return O<0?Math.max(O+E.length,0):Math.min(O,E.length)}function U(E,O){let D=Number.MAX_SAFE_INTEGER,z=0;return E.forEach((j,$)=>{const H=O(j);H<D&&(D=H,z=$)}),z}t.minIndex=U;function w(E,O){let D=Number.MIN_SAFE_INTEGER,z=0;return E.forEach((j,$)=>{const H=O(j);H>D&&(D=H,z=$)}),z}t.maxIndex=w;class M{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let D=this.firstIdx;for(;D<this.items.length&&O(this.items[D]);)D++;const z=D===this.firstIdx?null:this.items.slice(this.firstIdx,D);return this.firstIdx=D,z}takeFromEndWhile(O){let D=this.lastIdx;for(;D>=0&&O(this.items[D]);)D--;const z=D===this.lastIdx?null:this.items.slice(D+1,this.lastIdx+1);return this.lastIdx=D,z}}t.ArrayQueue=M}),define(Z[58],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var R;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(R=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var F;(function(e){e.DEFAULT={allowTrailingComma:!0}})(F=t.ParseOptions||(t.ParseOptions={}));function k(e,i=!1){let n=0,o=e.length,u="",h=0,g=16,N=0;function P(Y){let X=0,Q=0;for(;X<Y;){const B=e.charCodeAt(n);if(B>=48&&B<=57)Q=Q*16+B-48;else if(B>=65&&B<=70)Q=Q*16+B-65+10;else if(B>=97&&B<=102)Q=Q*16+B-97+10;else break;n++,X++}return X<Y&&(Q=-1),Q}function A(Y){n=Y,u="",h=0,g=16,N=0}function x(){const Y=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return N=3,e.substring(Y,n);let X=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;X=n}else N=3;return e.substring(Y,X)}function _(){let Y="",X=n;for(;;){if(n>=o){Y+=e.substring(X,n),N=2;break}const Q=e.charCodeAt(n);if(Q===34){Y+=e.substring(X,n),n++;break}if(Q===92){if(Y+=e.substring(X,n),n++,n>=o){N=2;break}switch(e.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const W=P(4);W>=0?Y+=String.fromCharCode(W):N=4;break;default:N=5}X=n;continue}if(Q>=0&&Q<=31)if(c(Q)){Y+=e.substring(X,n),N=2;break}else N=6;n++}return Y}function J(){if(u="",N=0,h=n,n>=o)return h=o,g=17;let Y=e.charCodeAt(n);if(C(Y)){do n++,u+=String.fromCharCode(Y),Y=e.charCodeAt(n);while(C(Y));return g=15}if(c(Y))return n++,u+=String.fromCharCode(Y),Y===13&&e.charCodeAt(n)===10&&(n++,u+=`
`),g=14;switch(Y){case 123:return n++,g=1;case 125:return n++,g=2;case 91:return n++,g=3;case 93:return n++,g=4;case 58:return n++,g=6;case 44:return n++,g=5;case 34:return n++,u=_(),g=10;case 47:const X=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<o&&!c(e.charCodeAt(n));)n++;return u=e.substring(X,n),g=12}if(e.charCodeAt(n+1)===42){n+=2;const Q=o-1;let B=!1;for(;n<Q;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,N=1),u=e.substring(X,n),g=13}return u+=String.fromCharCode(Y),n++,g=16;case 45:if(u+=String.fromCharCode(Y),n++,n===o||!d(e.charCodeAt(n)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=x(),g=11;default:for(;n<o&&ie(Y);)n++,Y=e.charCodeAt(n);if(h!==n){switch(u=e.substring(h,n),u){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return u+=String.fromCharCode(Y),n++,g=16}}function ie(Y){if(C(Y)||c(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let Y;do Y=J();while(Y>=12&&Y<=15);return Y}return{setPosition:A,getPosition:()=>n,scan:i?se:J,getToken:()=>g,getTokenValue:()=>u,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>N}}t.createScanner=k;function C(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var m;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(m||(m={}));function v(e,i){const n=[],o=new Object;let u;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function N(P,A,x,_){h.value=P,h.offset=A,h.length=x,h.type=_,h.colonOffset=void 0,u=h}try{f(e,{onObjectBegin:(P,A)=>{if(i<=P)throw o;u=void 0,g=i>P,n.push("")},onObjectProperty:(P,A,x)=>{if(i<A||(N(P,A,x,"property"),n[n.length-1]=P,i<=A+x))throw o},onObjectEnd:(P,A)=>{if(i<=P)throw o;u=void 0,n.pop()},onArrayBegin:(P,A)=>{if(i<=P)throw o;u=void 0,n.push(0)},onArrayEnd:(P,A)=>{if(i<=P)throw o;u=void 0,n.pop()},onLiteralValue:(P,A,x)=>{if(i<A||(N(P,A,x,s(P)),i<=A+x))throw o},onSeparator:(P,A,x)=>{if(i<=A)throw o;if(P===":"&&u&&u.type==="property")u.colonOffset=A,g=!1,u=void 0;else if(P===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(g=!0,n[n.length-1]=""),u=void 0}}})}catch(P){if(P!==o)throw P}return{path:n,previousNode:u,isAtPropertyKey:g,matches:P=>{let A=0;for(let x=0;A<P.length&&x<n.length;x++)if(P[A]===n[x]||P[A]==="*")A++;else if(P[A]!=="**")return!1;return A===P.length}}}t.getLocation=v;function p(e,i=[],n=F.DEFAULT){let o=null,u=[];const h=[];function g(P){Array.isArray(u)?u.push(P):o!==null&&(u[o]=P)}return f(e,{onObjectBegin:()=>{const P={};g(P),h.push(u),u=P,o=null},onObjectProperty:P=>{o=P},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{const P=[];g(P),h.push(u),u=P,o=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:g,onError:(P,A,x)=>{i.push({error:P,offset:A,length:x})}},n),u[0]}t.parse=p;function L(e,i=[],n=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(P){o.type==="property"&&(o.length=P-o.offset,o=o.parent)}function h(P){return o.children.push(P),P}f(e,{onObjectBegin:P=>{o=h({type:"object",offset:P,length:-1,parent:o,children:[]})},onObjectProperty:(P,A,x)=>{o=h({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:P,offset:A,length:x,parent:o})},onObjectEnd:(P,A)=>{o.length=P+A-o.offset,o=o.parent,u(P+A)},onArrayBegin:(P,A)=>{o=h({type:"array",offset:P,length:-1,parent:o,children:[]})},onArrayEnd:(P,A)=>{o.length=P+A-o.offset,o=o.parent,u(P+A)},onLiteralValue:(P,A,x)=>{h({type:s(P),offset:A,length:x,parent:o,value:P}),u(A+x)},onSeparator:(P,A,x)=>{o.type==="property"&&(P===":"?o.colonOffset=A:P===","&&u(A))},onError:(P,A,x)=>{i.push({error:P,offset:A,length:x})}},n);const N=o.children[0];return N&&delete N.parent,N}t.parseTree=L;function a(e,i){if(!e)return;let n=e;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===o){n=h.children[1],u=!0;break}if(!u)return}else{const u=o;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}t.findNodeAtLocation=a;function l(e){if(!e.parent||!e.parent.children)return[];const i=l(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=l;function I(e){switch(e.type){case"array":return e.children.map(I);case"object":const i=Object.create(null);for(let n of e.children){const o=n.children[1];o&&(i[n.children[0].value]=I(o))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=I;function y(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=y;function b(e,i,n=!1){if(y(e,i,n)){const o=e.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=i;u++){const h=b(o[u],i,n);if(h)return h}return e}}t.findNodeAtOffset=b;function f(e,i,n=F.DEFAULT){const o=k(e,!1);function u(D){return D?()=>D(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(D){return D?z=>D(z,o.getTokenOffset(),o.getTokenLength()):()=>!0}const g=u(i.onObjectBegin),N=h(i.onObjectProperty),P=u(i.onObjectEnd),A=u(i.onArrayBegin),x=u(i.onArrayEnd),_=h(i.onLiteralValue),J=h(i.onSeparator),ie=u(i.onComment),se=h(i.onError),Y=n&&n.disallowComments,X=n&&n.allowTrailingComma;function Q(){for(;;){const D=o.scan();switch(o.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:Y||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(D){case 12:case 13:Y?B(10):ie();break;case 16:B(1);break;case 15:case 14:break;default:return D}}}function B(D,z=[],j=[]){if(se(D),z.length+j.length>0){let $=o.getToken();for(;$!==17;){if(z.indexOf($)!==-1){Q();break}else if(j.indexOf($)!==-1)break;$=Q()}}}function W(D){const z=o.getTokenValue();return D?_(z):N(z),Q(),!0}function U(){switch(o.getToken()){case 11:let D=0;try{D=JSON.parse(o.getTokenValue()),typeof D!="number"&&(B(2),D=0)}catch(z){B(2)}_(D);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return Q(),!0}function w(){return o.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),o.getToken()===6?(J(":"),Q(),O()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function M(){g(),Q();let D=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(D||B(4,[],[]),J(","),Q(),o.getToken()===2&&X)break}else D&&B(6,[],[]);w()||B(4,[],[2,5]),D=!0}return P(),o.getToken()!==2?B(7,[2],[]):Q(),!0}function E(){A(),Q();let D=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(D||B(4,[],[]),J(","),Q(),o.getToken()===4&&X)break}else D&&B(6,[],[]);O()||B(4,[],[4,5]),D=!0}return x(),o.getToken()!==4?B(8,[4],[]):Q(),!0}function O(){switch(o.getToken()){case 3:return E();case 1:return M();case 10:return W(!0);default:return U()}}return Q(),o.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):O()?(o.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}t.visit=f;function r(e,i){let n=k(e),o=[],u,h=0,g;do switch(g=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:h!==g&&o.push(e.substring(h,g)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),h=n.getPosition();break}while(u!==17);return o.join("")}t.stripComments=r;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function q(S){const F=[];typeof S=="number"&&F.push("code/timeOrigin",S);function k(c){F.push(c,Date.now())}function C(){const c=[];for(let d=0;d<F.length;d+=2)c.push({name:F[d],startTime:F[d+1]});return c}return{mark:k,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))F.push({name:k.name,startTime:Math.round(S+k.startTime)});return F}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function T(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=T(R))}(),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var R in T)(typeof exports=="object"?exports:q)[R]=T[R]}}(typeof self!="undefined"?self:this,function(){return function(q){var t={};function T(R){if(t[R])return t[R].exports;var S=t[R]={i:R,l:!1,exports:{}};return q[R].call(S.exports,S,S.exports,T),S.l=!0,S.exports}return T.m=q,T.c=t,T.d=function(R,S,F){T.o(R,S)||Object.defineProperty(R,S,{enumerable:!0,get:F})},T.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},T.t=function(R,S){if(1&S&&(R=T(R)),8&S||4&S&&typeof R=="object"&&R&&R.__esModule)return R;var F=Object.create(null);if(T.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:R}),2&S&&typeof R!="string")for(var k in R)T.d(F,k,function(C){return R[C]}.bind(null,k));return F},T.n=function(R){var S=R&&R.__esModule?function(){return R.default}:function(){return R};return T.d(S,"a",S),S},T.o=function(R,S){return Object.prototype.hasOwnProperty.call(R,S)},T.p="",T(T.s=0)}([function(q,t,T){(function(R){var S;t=q.exports=j,S=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var F=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],c=t.src=[],d=0,m=d++;c[m]="0|[1-9]\\d*";var v=d++;c[v]="[0-9]+";var p=d++;c[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var L=d++;c[L]="("+c[m]+")\\.("+c[m]+")\\.("+c[m]+")";var a=d++;c[a]="("+c[v]+")\\.("+c[v]+")\\.("+c[v]+")";var l=d++;c[l]="(?:"+c[m]+"|"+c[p]+")";var I=d++;c[I]="(?:"+c[v]+"|"+c[p]+")";var y=d++;c[y]="(?:-("+c[l]+"(?:\\."+c[l]+")*))";var b=d++;c[b]="(?:-?("+c[I]+"(?:\\."+c[I]+")*))";var f=d++;c[f]="[0-9A-Za-z-]+";var r=d++;c[r]="(?:\\+("+c[f]+"(?:\\."+c[f]+")*))";var s=d++,e="v?"+c[L]+c[y]+"?"+c[r]+"?";c[s]="^"+e+"$";var i="[v=\\s]*"+c[a]+c[b]+"?"+c[r]+"?",n=d++;c[n]="^"+i+"$";var o=d++;c[o]="((?:<|>)?=?)";var u=d++;c[u]=c[v]+"|x|X|\\*";var h=d++;c[h]=c[m]+"|x|X|\\*";var g=d++;c[g]="[v=\\s]*("+c[h]+")(?:\\.("+c[h]+")(?:\\.("+c[h]+")(?:"+c[y]+")?"+c[r]+"?)?)?";var N=d++;c[N]="[v=\\s]*("+c[u]+")(?:\\.("+c[u]+")(?:\\.("+c[u]+")(?:"+c[b]+")?"+c[r]+"?)?)?";var P=d++;c[P]="^"+c[o]+"\\s*"+c[g]+"$";var A=d++;c[A]="^"+c[o]+"\\s*"+c[N]+"$";var x=d++;c[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=d++;c[_]="(?:~>?)";var J=d++;c[J]="(\\s*)"+c[_]+"\\s+",C[J]=new RegExp(c[J],"g");var ie=d++;c[ie]="^"+c[_]+c[g]+"$";var se=d++;c[se]="^"+c[_]+c[N]+"$";var Y=d++;c[Y]="(?:\\^)";var X=d++;c[X]="(\\s*)"+c[Y]+"\\s+",C[X]=new RegExp(c[X],"g");var Q=d++;c[Q]="^"+c[Y]+c[g]+"$";var B=d++;c[B]="^"+c[Y]+c[N]+"$";var W=d++;c[W]="^"+c[o]+"\\s*("+i+")$|^$";var U=d++;c[U]="^"+c[o]+"\\s*("+e+")$|^$";var w=d++;c[w]="(\\s*)"+c[o]+"\\s*("+i+"|"+c[g]+")",C[w]=new RegExp(c[w],"g");var M=d++;c[M]="^\\s*("+c[g]+")\\s+-\\s+("+c[g]+")\\s*$";var E=d++;c[E]="^\\s*("+c[N]+")\\s+-\\s+("+c[N]+")\\s*$";var O=d++;c[O]="(<|>)?=?\\s*\\*";for(var D=0;D<35;D++)S(D,c[D]),C[D]||(C[D]=new RegExp(c[D]));function z(V,G){if(V instanceof j)return V;if(typeof V!="string"||V.length>F||!(G?C[n]:C[s]).test(V))return null;try{return new j(V,G)}catch(K){return null}}function j(V,G){if(V instanceof j){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof j))return new j(V,G);S("SemVer",V,G),this.loose=G;var K=V.trim().match(G?C[n]:C[s]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ae=+oe;if(ae>=0&&ae<k)return ae}return oe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=z,t.valid=function(V,G){var K=z(V,G);return K?K.version:null},t.clean=function(V,G){var K=z(V.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(V){return S("SemVer.compare",this.version,this.loose,V),V instanceof j||(V=new j(V,this.loose)),this.compareMain(V)||this.comparePre(V)},j.prototype.compareMain=function(V){return V instanceof j||(V=new j(V,this.loose)),H(this.major,V.major)||H(this.minor,V.minor)||H(this.patch,V.patch)},j.prototype.comparePre=function(V){if(V instanceof j||(V=new j(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],oe=V.prerelease[G];if(S("prerelease compare",G,K,oe),K===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(K===void 0)return-1;if(K!==oe)return H(K,oe)}while(++G)},j.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,K,oe){typeof K=="string"&&(oe=K,K=void 0);try{return new j(V,K).inc(G,oe).version}catch(ae){return null}},t.diff=function(V,G){if(ce(V,G))return null;var K=z(V),oe=z(G);if(K.prerelease.length||oe.prerelease.length){for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==oe[ae])return"pre"+ae;return"prerelease"}for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==oe[ae])return ae},t.compareIdentifiers=H;var $=/^[0-9]+$/;function H(V,G){var K=$.test(V),oe=$.test(G);return K&&oe&&(V=+V,G=+G),K&&!oe?-1:oe&&!K?1:V<G?-1:V>G?1:0}function ee(V,G,K){return new j(V,K).compare(new j(G,K))}function ne(V,G,K){return ee(V,G,K)>0}function re(V,G,K){return ee(V,G,K)<0}function ce(V,G,K){return ee(V,G,K)===0}function me(V,G,K){return ee(V,G,K)!==0}function be(V,G,K){return ee(V,G,K)>=0}function ke(V,G,K){return ee(V,G,K)<=0}function Te(V,G,K,oe){var ae;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ae=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ae=V!==K;break;case"":case"=":case"==":ae=ce(V,K,oe);break;case"!=":ae=me(V,K,oe);break;case">":ae=ne(V,K,oe);break;case">=":ae=be(V,K,oe);break;case"<":ae=re(V,K,oe);break;case"<=":ae=ke(V,K,oe);break;default:throw new TypeError("Invalid operator: "+G)}return ae}function we(V,G){if(V instanceof we){if(V.loose===G)return V;V=V.value}if(!(this instanceof we))return new we(V,G);S("comparator",V,G),this.loose=G,this.parse(V),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(V,G){return H(G,V)},t.major=function(V,G){return new j(V,G).major},t.minor=function(V,G){return new j(V,G).minor},t.patch=function(V,G){return new j(V,G).patch},t.compare=ee,t.compareLoose=function(V,G){return ee(V,G,!0)},t.rcompare=function(V,G,K){return ee(G,V,K)},t.sort=function(V,G){return V.sort(function(K,oe){return t.compare(K,oe,G)})},t.rsort=function(V,G){return V.sort(function(K,oe){return t.rcompare(K,oe,G)})},t.gt=ne,t.lt=re,t.eq=ce,t.neq=me,t.gte=be,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function ve(V,G){if(V instanceof ve)return V.loose===G?V:new ve(V.raw,G);if(V instanceof we)return new ve(V.value,G);if(!(this instanceof ve))return new ve(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Re(V){return!V||V.toLowerCase()==="x"||V==="*"}function je(V,G,K,oe,ae,Se,de,Le,ye,De,Ae,Ee,Ie){return((G=Re(K)?"":Re(oe)?">="+K+".0.0":Re(ae)?">="+K+"."+oe+".0":">="+G)+" "+(Le=Re(ye)?"":Re(De)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+De+1)+".0":Ee?"<="+ye+"."+De+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(V,G){for(var K=0;K<V.length;K++)if(!V[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<V.length;K++)if(S(V[K].semver),V[K].semver!==Fe&&V[K].semver.prerelease.length>0){var oe=V[K].semver;if(oe.major===G.major&&oe.minor===G.minor&&oe.patch===G.patch)return!0}return!1}return!0}function xe(V,G,K){try{G=new ve(G,K)}catch(oe){return!1}return G.test(V)}function ze(V,G,K,oe){var ae,Se,de,Le,ye;switch(V=new j(V,oe),G=new ve(G,oe),K){case">":ae=ne,Se=ke,de=re,Le=">",ye=">=";break;case"<":ae=re,Se=be,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(V,G,oe))return!1;for(var De=0;De<G.set.length;++De){var Ae=G.set[De],Ee=null,Ie=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,Ie=Ie||Ce,ae(Ce.semver,Ee.semver,oe)?Ee=Ce:de(Ce.semver,Ie.semver,oe)&&(Ie=Ce)}),Ee.operator===Le||Ee.operator===ye||(!Ie.operator||Ie.operator===Le)&&Se(V,Ie.semver)||Ie.operator===ye&&de(V,Ie.semver))return!1}return!0}we.prototype.parse=function(V){var G=this.loose?C[W]:C[U],K=V.match(G);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new j(K[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(V){return S("Comparator.test",V,this.loose),this.semver===Fe||(typeof V=="string"&&(V=new j(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},we.prototype.intersects=function(V,G){if(!(V instanceof we))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,G),xe(this.value,K,G);if(V.operator==="")return K=new ve(this.value,G),xe(V.semver,K,G);var oe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Se=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=Te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return oe||ae||Se&&de||Le||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),S("range",V,G);var K=G?C[E]:C[M];V=V.replace(K,je),S("hyphen replace",V),V=V.replace(C[w],"$1$2$3"),S("comparator trim",V,C[w]),V=(V=(V=V.replace(C[J],"$1~")).replace(C[X],"$1^")).split(/\s+/).join(" ");var oe=G?C[W]:C[U],ae=V.split(" ").map(function(Se){return function(de,Le){return S("comp",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){S("caret",Ee,Ie);var Ce=Ie?C[B]:C[Q];return Ee.replace(Ce,function(Oe,le,he,ge,pe){var Pe;return S("caret",Ee,Oe,le,he,ge,pe),Re(le)?Pe="":Re(he)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":pe?(S("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=le==="0"?he==="0"?">="+le+"."+he+"."+ge+pe+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+pe+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+pe+" <"+(+le+1)+".0.0"):(S("no pr"),Pe=le==="0"?he==="0"?">="+le+"."+he+"."+ge+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+" <"+(+le+1)+".0.0"),S("caret return",Pe),Pe})}(Ae,De)}).join(" ")}(de,Le),S("caret",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){var Ce=Ie?C[se]:C[ie];return Ee.replace(Ce,function(Oe,le,he,ge,pe){var Pe;return S("tilde",Ee,Oe,le,he,ge,pe),Re(le)?Pe="":Re(he)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":pe?(S("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+le+"."+he+"."+ge+pe+" <"+le+"."+(+he+1)+".0"):Pe=">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0",S("tilde return",Pe),Pe})}(Ae,De)}).join(" ")}(de,Le),S("tildes",de),de=function(ye,De){return S("replaceXRanges",ye,De),ye.split(/\s+/).map(function(Ae){return function(Ee,Ie){Ee=Ee.trim();var Ce=Ie?C[A]:C[P];return Ee.replace(Ce,function(Oe,le,he,ge,pe,Pe){S("xRange",Ee,Oe,le,he,ge,pe,Pe);var Ve=Re(he),Me=Ve||Re(ge),Ue=Me||Re(pe);return le==="="&&Ue&&(le=""),Ve?Oe=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(Me&&(ge=0),Ue&&(pe=0),le===">"?(le=">=",Me?(he=+he+1,ge=0,pe=0):Ue&&(ge=+ge+1,pe=0)):le==="<="&&(le="<",Me?he=+he+1:ge=+ge+1),Oe=le+he+"."+ge+"."+pe):Me?Oe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Oe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),S("xRange return",Oe),Oe})}(Ae,De)}).join(" ")}(de,Le),S("xrange",de),de=function(ye,De){return S("replaceStars",ye,De),ye.trim().replace(C[O],"")}(de,Le),S("stars",de),de}(Se,G)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Se){return!!Se.match(oe)})),ae=ae.map(function(Se){return new we(Se,G)})},ve.prototype.intersects=function(V,G){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(oe){return V.set.some(function(ae){return ae.every(function(Se){return oe.intersects(Se,G)})})})})},t.toComparators=function(V,G){return new ve(V,G).set.map(function(K){return K.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new j(V,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],V))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(V,G,K){var oe=null,ae=null;try{var Se=new ve(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(oe&&ae.compare(de)!==-1||(ae=new j(oe=de,K)))}),oe},t.minSatisfying=function(V,G,K){var oe=null,ae=null;try{var Se=new ve(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(oe&&ae.compare(de)!==1||(ae=new j(oe=de,K)))}),oe},t.validRange=function(V,G){try{return new ve(V,G).range||"*"}catch(K){return null}},t.ltr=function(V,G,K){return ze(V,G,"<",K)},t.gtr=function(V,G,K){return ze(V,G,">",K)},t.outside=ze,t.prerelease=function(V,G){var K=z(V,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,G,K){return V=new ve(V,K),G=new ve(G,K),V.intersects(G)},t.coerce=function(V){if(V instanceof j)return V;if(typeof V!="string")return null;var G=V.match(C[x]);return G==null?null:z((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,T(1))},function(q,t){var T,R,S=q.exports={};function F(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function C(I){if(T===setTimeout)return setTimeout(I,0);if((T===F||!T)&&setTimeout)return T=setTimeout,setTimeout(I,0);try{return T(I,0)}catch(y){try{return T.call(null,I,0)}catch(b){return T.call(this,I,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:F}catch(I){T=F}try{R=typeof clearTimeout=="function"?clearTimeout:k}catch(I){R=k}})();var c,d=[],m=!1,v=-1;function p(){m&&c&&(m=!1,c.length?d=c.concat(d):v=-1,d.length&&L())}function L(){if(!m){var I=C(p);m=!0;for(var y=d.length;y;){for(c=d,d=[];++v<y;)c&&c[v].run();v=-1,y=d.length}c=null,m=!1,function(b){if(R===clearTimeout)return clearTimeout(b);if((R===k||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(b);try{R(b)}catch(f){try{return R.call(null,b)}catch(r){return R.call(this,b)}}}(I)}}function a(I,y){this.fun=I,this.array=y}function l(){}S.nextTick=function(I){var y=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)y[b-1]=arguments[b];d.push(new a(I,y)),d.length!==1||m||C(L)},a.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=l,S.addListener=l,S.once=l,S.off=l,S.removeListener=l,S.removeAllListeners=l,S.emit=l,S.prependListener=l,S.prependOnceListener=l,S.listeners=function(I){return[]},S.binding=function(I){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(I){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Z[37],te([0,1,8,2]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(f){const r=f;return r?[r.on,r.pause,r.resume,r.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function F(f){const r=f;return r?S(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=F;function k(f,r){return new C(f,r)}t.newWriteableStream=k;class C{constructor(r,s){this.reducer=r,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(s=>s(r))}emitError(r){this.listeners.error.length===0?(0,T.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(s=>s(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,s){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(r,s){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(f,r){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return r(s)}t.consumeReadable=c;function d(f,r,s){const e=[];let i;for(;(i=f.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=d;function m(f,r){return new Promise((s,e)=>{const i=[];v(f,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):s(void 0)},onEnd:()=>{s(r?r(i):void 0)}})})}t.consumeStream=m;function v(f,r){f.on("error",s=>r.onError(s)),f.on("end",()=>r.onEnd()),f.on("data",s=>r.onData(s))}t.listenStream=v;function p(f,r){return new Promise((s,e)=>{const i=new R.DisposableStore,n=[],o=g=>{if(n.push(g),n.length>r)return i.dispose(),f.pause(),s({stream:f,buffer:n,ended:!1})},u=g=>e(g),h=()=>s({stream:f,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),i.add((0,R.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),i.add((0,R.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}t.peekStream=p;function L(f,r){const s=k(r);return s.end(f),s}t.toStream=L;function a(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=a;function l(f){let r=!1;return{read:()=>r?null:(r=!0,f)}}t.toReadable=l;function I(f,r,s){const e=k(s);return v(f,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=I;function y(f,r,s){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?s([f,i]):f)}}}t.prefixedReadable=y;function b(f,r,s){let e=!1;const i=k(s);return v(r,{onData:n=>e?i.write(n):(e=!0,i.write(s([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=b}),define(Z[16],te([0,1,37,18]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const S=typeof Buffer!="undefined",F=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let C,c;class d{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return S?new d(Buffer.allocUnsafe(g)):new d(new Uint8Array(g))}static wrap(g){return S&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new d(g)}static fromString(g,N){return!(N?.dontUseNodeBuffer||!1)&&S?new d(Buffer.from(g)):F?(C||(C=new TextEncoder),new d(C.encode(g))):new d(R.encodeUTF8(g))}static concat(g,N){if(typeof N=="undefined"){N=0;for(let x=0,_=g.length;x<_;x++)N+=g[x].byteLength}const P=d.alloc(N);let A=0;for(let x=0,_=g.length;x<_;x++){const J=g[x];P.set(J,A),A+=J.byteLength}return P}toString(){return S?this.buffer.toString():k?(c||(c=new TextDecoder),c.decode(this.buffer)):R.decodeUTF8(this.buffer)}slice(g,N){return new d(this.buffer.subarray(g,N))}set(g,N){g instanceof d?this.buffer.set(g.buffer,N):this.buffer.set(g,N)}readUInt32BE(g){return p(this.buffer,g)}writeUInt32BE(g,N){L(this.buffer,g,N)}readUInt32LE(g){return a(this.buffer,g)}writeUInt32LE(g,N){l(this.buffer,g,N)}readUInt8(g){return I(this.buffer,g)}writeUInt8(g,N){y(this.buffer,g,N)}}t.VSBuffer=d;function m(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0}t.readUInt16LE=m;function v(h,g,N){h[N+0]=g&255,g=g>>>8,h[N+1]=g&255}t.writeUInt16LE=v;function p(h,g){return h[g]*2**24+h[g+1]*2**16+h[g+2]*2**8+h[g+3]}t.readUInt32BE=p;function L(h,g,N){h[N+3]=g,g=g>>>8,h[N+2]=g,g=g>>>8,h[N+1]=g,g=g>>>8,h[N]=g}t.writeUInt32BE=L;function a(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0|h[g+2]<<16>>>0|h[g+3]<<24>>>0}t.readUInt32LE=a;function l(h,g,N){h[N+0]=g&255,g=g>>>8,h[N+1]=g&255,g=g>>>8,h[N+2]=g&255,g=g>>>8,h[N+3]=g&255}t.writeUInt32LE=l;function I(h,g){return h[g]}t.readUInt8=I;function y(h,g,N){h[N]=g}t.writeUInt8=y;function b(h){return T.consumeReadable(h,g=>d.concat(g))}t.readableToBuffer=b;function f(h){return T.toReadable(h)}t.bufferToReadable=f;function r(h){return T.consumeStream(h,g=>d.concat(g))}t.streamToBuffer=r;async function s(h){return h.ended?d.concat(h.buffer):d.concat([...h.buffer,await r(h.stream)])}t.bufferedStreamToBuffer=s;function e(h){return T.toStream(h,g=>d.concat(g))}t.bufferToStream=e;function i(h){return T.transform(h,{data:g=>typeof g=="string"?d.fromString(g):d.wrap(g)},g=>d.concat(g))}t.streamToBufferReadableStream=i;function n(h){return T.newWriteableStream(g=>d.concat(g),h)}t.newWriteableBufferStream=n;function o(h,g){return T.prefixedReadable(h,g,N=>d.concat(N))}t.prefixedBufferReadable=o;function u(h,g){return T.prefixedStream(h,g,N=>d.concat(N))}t.prefixedBufferStream=u}),define(Z[19],te([0,1,13]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function R(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const I=Array.isArray(l)?[]:{};return Object.keys(l).forEach(y=>{l[y]&&typeof l[y]=="object"?I[y]=R(l[y]):I[y]=l[y]}),I}t.deepClone=R;function S(l){if(!l||typeof l!="object")return l;const I=[l];for(;I.length>0;){const y=I.shift();Object.freeze(y);for(const b in y)if(F.call(y,b)){const f=y[b];typeof f=="object"&&!Object.isFrozen(f)&&I.push(f)}}return l}t.deepFreeze=S;const F=Object.prototype.hasOwnProperty;function k(l,I){return C(l,I,new Set)}t.cloneAndChange=k;function C(l,I,y){if((0,T.isUndefinedOrNull)(l))return l;const b=I(l);if(typeof b!="undefined")return b;if((0,T.isArray)(l)){const f=[];for(const r of l)f.push(C(r,I,y));return f}if((0,T.isObject)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const f={};for(let r in l)F.call(l,r)&&(f[r]=C(l[r],I,y));return y.delete(l),f}return l}function c(l,I,y=!0){return(0,T.isObject)(l)?((0,T.isObject)(I)&&Object.keys(I).forEach(b=>{b in l?y&&((0,T.isObject)(l[b])&&(0,T.isObject)(I[b])?c(l[b],I[b],y):l[b]=I[b]):l[b]=I[b]}),l):I}t.mixin=c;function d(l,I){if(l===I)return!0;if(l==null||I===null||I===void 0||typeof l!=typeof I||typeof l!="object"||Array.isArray(l)!==Array.isArray(I))return!1;let y,b;if(Array.isArray(l)){if(l.length!==I.length)return!1;for(y=0;y<l.length;y++)if(!d(l[y],I[y]))return!1}else{const f=[];for(b in l)f.push(b);f.sort();const r=[];for(b in I)r.push(b);if(r.sort(),!d(f,r))return!1;for(y=0;y<f.length;y++)if(!d(l[f[y]],I[f[y]]))return!1}return!0}t.equals=d;function m(l){const I=new Set;return JSON.stringify(l,(y,b)=>{if((0,T.isObject)(b)||Array.isArray(b)){if(I.has(b))return"[Circular]";I.add(b)}return b})}t.safeStringify=m;function v(l,I,y){const b=I(l);return typeof b=="undefined"?y:b}t.getOrDefault=v;function p(l,I){const y=Object.create(null);return!l||!I||Object.keys(I).forEach(f=>{const r=l[f],s=I[f];d(r,s)||(y[f]=s)}),y}t.distinct=p;function L(l,I){const y=I.toLowerCase(),b=Object.keys(l).find(f=>f.toLowerCase()===y);return b?l[b]:l[I]}t.getCaseInsensitive=L;function a(l,I){const y=Object.create(null);for(const b of Object.keys(l))I(b,l[b])&&(y[b]=l[b]);return y}t.filter=a}),define(Z[59],te([0,1,7]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function R(d){const m=d;return m&&typeof m.type=="string"&&typeof m.severity=="string"}t.isRemoteConsoleLog=R;function S(d){const m=[];let v;try{const p=JSON.parse(d.arguments),L=p[p.length-1];L&&L.__$stack&&(p.pop(),v=L.__$stack),m.push(...p)}catch(p){m.push("Unable to log remote console arguments",d.arguments)}return{args:m,stack:v}}t.parse=S;function F(d){if(typeof d!="string")return F(S(d).stack);const m=d;if(m){const v=k(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(p&&p.length===4)return{uri:T.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}t.getFirstFrame=F;function k(d){if(!d)return d;const m=d.indexOf(`
`);return m===-1?d:d.substring(0,m)}function C(d,m){const{args:v,stack:p}=S(d),L=typeof v[0]=="string"&&v.length===1;let a=k(p);a&&(a=`(${a.trim()})`);let l=[];if(typeof v[0]=="string"?a&&L?l=[`%c[${m}] %c${v[0]} %c${a}`,c("blue"),c(""),c("grey")]:l=[`%c[${m}] %c${v[0]}`,c("blue"),c(""),...v.slice(1)]:l=[`%c[${m}]%`,c("blue"),...v],a&&!L&&l.push(a),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,l)}t.log=C;function c(d){return`color: ${d}`}}),define(Z[60],te([0,1,16,18,7]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function F(m){return JSON.stringify(m,c)}t.stringify=F;function k(m){let v=JSON.parse(m);return v=d(v),v}t.parse=k;var C;(function(m){m[m.Uri=1]="Uri",m[m.Regexp=2]="Regexp",m[m.ScmResource=3]="ScmResource",m[m.ScmResourceGroup=4]="ScmResourceGroup",m[m.ScmProvider=5]="ScmProvider",m[m.CommentController=6]="CommentController",m[m.CommentThread=7]="CommentThread",m[m.CommentThreadReply=8]="CommentThreadReply",m[m.CommentNode=9]="CommentNode",m[m.CommentThreadNode=10]="CommentThreadNode",m[m.TimelineActionContext=11]="TimelineActionContext",m[m.NotebookCellActionContext=12]="NotebookCellActionContext",m[m.TestItemContext=13]="TestItemContext"})(C=t.MarshalledId||(t.MarshalledId={}));function c(m,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,R.regExpFlags)(v)}:v}function d(m,v=0){if(!m||v>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return S.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof T.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let p=0;p<m.length;++p)m[p]=d(m[p],v+1);else for(const p in m)Object.hasOwnProperty.call(m,p)&&(m[p]=d(m[p],v+1))}return m}t.revive=d}),define(Z[61],te([0,1,3,31,45,4,18]),function(q,t,T,R,S,F,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function C(){return Object.create(null)}t.getEmptyExpression=C;const c="**",d="/",m="[/\\\\]",v="[^/\\\\]",p=/\//g;function L(w){switch(w){case 0:return"";case 1:return`${v}*?`;default:return`(?:${m}|${v}+${m}|${m}${v}+)*?`}}function a(w,M){if(!w)return[];const E=[];let O=!1,D=!1,z="";for(const j of w){switch(j){case M:if(!O&&!D){E.push(z),z="";continue}break;case"{":O=!0;break;case"}":O=!1;break;case"[":D=!0;break;case"]":D=!1;break}z+=j}return z&&E.push(z),E}t.splitGlobAware=a;function l(w){if(!w)return"";let M="";const E=a(w,d);if(E.every(O=>O===c))M=".*";else{let O=!1;E.forEach((D,z)=>{if(D===c){O||(M+=L(2),O=!0);return}let j=!1,$="",H=!1,ee="";for(const ne of D){if(ne!=="}"&&j){$+=ne;continue}if(H&&(ne!=="]"||!ee)){let re;ne==="-"?re=ne:(ne==="^"||ne==="!")&&!ee?re="^":ne===d?re="":re=k.escapeRegExpCharacters(ne),ee+=re;continue}switch(ne){case"{":j=!0;continue;case"[":H=!0;continue;case"}":M+=`(?:${a($,",").map(me=>l(me)).join("|")})`,j=!1,$="";break;case"]":M+="["+ee+"]",H=!1,ee="";break;case"?":M+=v;continue;case"*":M+=L(1);continue;default:M+=k.escapeRegExpCharacters(ne)}}z<E.length-1&&(E[z+1]!==c||z+2<E.length)&&(M+=m),O=!1})}return M}const I=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(w,M){if(!w)return n;let E;typeof w!="string"?E=w.pattern:E=w,E=E.trim();const O=`${E}_${!!M.trimForExclusions}`;let D=e.get(O);if(D)return u(D,w);let z;if(I.test(E)){const j=E.substr(4);D=function($,H){return typeof $=="string"&&$.endsWith(j)?E:null}}else(z=y.exec(h(E,M)))?D=g(z[1],E):(M.trimForExclusions?f:b).test(E)?D=N(E,M):(z=r.exec(h(E,M)))?D=P(z[1].substr(1),E,!0):(z=s.exec(h(E,M)))?D=P(z[1],E,!1):D=A(E);return e.set(O,D),u(D,w)}function u(w,M){return typeof M=="string"?w:function(E,O){return R.isEqualOrParent(E,M.base)?w(F.relative(M.base,E),O):null}}function h(w,M){return M.trimForExclusions&&w.endsWith("/**")?w.substr(0,w.length-2):w}function g(w,M){const E=`/${w}`,O=`\\${w}`,D=function(j,$){return typeof j!="string"?null:$?$===w?M:null:j===w||j.endsWith(E)||j.endsWith(O)?M:null},z=[w];return D.basenames=z,D.patterns=[M],D.allBasenames=z,D}function N(w,M){const E=U(w.slice(1,-1).split(",").map($=>o($,M)).filter($=>$!==n),w),O=E.length;if(!O)return n;if(O===1)return E[0];const D=function($,H){for(let ee=0,ne=E.length;ee<ne;ee++)if(E[ee]($,H))return w;return null},z=E.find($=>!!$.allBasenames);z&&(D.allBasenames=z.allBasenames);const j=E.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return j.length&&(D.allPaths=j),D}function P(w,M,E){const O=F.sep===F.posix.sep,D=O?w:w.replace(p,F.sep),z=F.sep+D,j=F.posix.sep+w,$=E?function(H,ee){return typeof H=="string"&&(H===D||H.endsWith(z)||!O&&(H===w||H.endsWith(j)))?M:null}:function(H,ee){return typeof H=="string"&&(H===D||!O&&H===w)?M:null};return $.allPaths=[(E?"*/":"./")+w],$}function A(w){try{const M=new RegExp(`^${l(w)}$`);return function(E){return M.lastIndex=0,typeof E=="string"&&M.test(E)?w:null}}catch(M){return n}}function x(w,M,E){return!w||typeof M!="string"?!1:_(w)(M,void 0,E)}t.match=x;function _(w,M={}){if(!w)return i;if(typeof w=="string"||Y(w)){const E=o(w,M);if(E===n)return i;const O=function(D,z){return!!E(D,z)};return E.allBasenames&&(O.allBasenames=E.allBasenames),E.allPaths&&(O.allPaths=E.allPaths),O}return B(w,M)}t.parse=_;function J(w){if(!w)return;let M;return E=>(M||(M=(w()||Promise.resolve([])).then(O=>O?se(O):{})),M.then(O=>!!O[E]))}t.hasSiblingPromiseFn=J;function ie(w){if(!w)return;let M;return E=>{if(!M){const O=w();M=O?se(O):{}}return!!M[E]}}t.hasSiblingFn=ie;function se(w){const M={};for(const E of w)M[E]=!0;return M}function Y(w){const M=w;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=Y;function X(w){return w.allBasenames||[]}t.getBasenameTerms=X;function Q(w){return w.allPaths||[]}t.getPathTerms=Q;function B(w,M){const E=U(Object.getOwnPropertyNames(w).map($=>W($,w[$],M)).filter($=>$!==n)),O=E.length;if(!O)return n;if(!E.some($=>!!$.requiresSiblings)){if(O===1)return E[0];const $=function(ne,re){for(let ce=0,me=E.length;ce<me;ce++){const be=E[ce](ne,re);if(be)return be}return null},H=E.find(ne=>!!ne.allBasenames);H&&($.allBasenames=H.allBasenames);const ee=E.reduce((ne,re)=>re.allPaths?ne.concat(re.allPaths):ne,[]);return ee.length&&($.allPaths=ee),$}const D=function($,H,ee){let ne;for(let re=0,ce=E.length;re<ce;re++){const me=E[re];me.requiresSiblings&&ee&&(H||(H=F.basename($)),ne||(ne=H.substr(0,H.length-F.extname($).length)));const be=me($,H,ne,ee);if(be)return be}return null},z=E.find($=>!!$.allBasenames);z&&(D.allBasenames=z.allBasenames);const j=E.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return j.length&&(D.allPaths=j),D}function W(w,M,E){if(M===!1)return n;const O=o(w,E);if(O===n)return n;if(typeof M=="boolean")return O;if(M){const D=M.when;if(typeof D=="string"){const z=(j,$,H,ee)=>{if(!ee||!O(j,$))return null;const ne=D.replace("$(basename)",H),re=ee(ne);return(0,T.isThenable)(re)?re.then(ce=>ce?w:null):re?w:null};return z.requiresSiblings=!0,z}}return O}function U(w,M){const E=w.filter($=>!!$.basenames);if(E.length<2)return w;const O=E.reduce(($,H)=>{const ee=H.basenames;return ee?$.concat(ee):$},[]);let D;if(M){D=[];for(let $=0,H=O.length;$<H;$++)D.push(M)}else D=E.reduce(($,H)=>{const ee=H.patterns;return ee?$.concat(ee):$},[]);const z=function($,H){if(typeof $!="string")return null;if(!H){let ne;for(ne=$.length;ne>0;ne--){const re=$.charCodeAt(ne-1);if(re===47||re===92)break}H=$.substr(ne)}const ee=O.indexOf(H);return ee!==-1?D[ee]:null};z.basenames=O,z.patterns=D,z.allBasenames=O;const j=w.filter($=>!$.basenames);return j.push(z),j}}),define(Z[62],te([0,1,31,9,4,10,20,18,7]),function(q,t,T,R,S,F,k,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(o,u,h){if(typeof o=="string"&&(o=c.URI.file(o)),h){const N=h.getWorkspaceFolder(o);if(N){const P=h.getWorkspace().folders.length>1;let A;if((0,k.isEqual)(N.uri,o)?A="":A=(0,k.relativePath)(N.uri,o),P){const x=N.name?N.name:(0,k.basename)(N.uri);A=A?x+" \u2022 "+A:x}return A}}if(o.scheme!==R.Schemas.file&&o.scheme!==R.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(o.fsPath))return(0,S.normalize)(v(o.fsPath));let g=(0,S.normalize)(o.fsPath);return!F.isWindows&&u?.userHome&&(g=L(g,u.userHome.fsPath)),g}t.getPathLabel=d;function m(o){if(!o)return;typeof o=="string"&&(o=c.URI.file(o));const u=(0,k.basename)(o)||(o.scheme===R.Schemas.file?o.fsPath:o.path);return F.isWindows&&(0,T.isRootOrDriveLetter)(u)?v(u):u}t.getBaseLabel=m;function v(o){return(0,T.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=v;let p=Object.create(null);function L(o,u){if(F.isWindows||!o||!u)return o;let h=p.original===u?p.normalized:void 0;return h||(h=`${(0,C.rtrim)(u,S.posix.sep)}${S.posix.sep}`,p={original:u,normalized:h}),(F.isLinux?o.startsWith(h):(0,C.startsWithIgnoreCase)(o,h))&&(o=`~/${o.substr(h.length)}`),o}t.tildify=L;function a(o,u){return o.replace(/^~($|\/|\\)/,`${u}$1`)}t.untildify=a;const l="\u2026",I="\\\\",y="~";function b(o,u=S.sep){const h=new Array(o.length);let g=!1;for(let N=0;N<o.length;N++){let P=o[N];if(P===""){h[N]=`.${u}`;continue}if(!P){h[N]=P;continue}g=!0;let A="";P.indexOf(I)===0?(A=P.substr(0,P.indexOf(I)+I.length),P=P.substr(P.indexOf(I)+I.length)):P.indexOf(u)===0?(A=P.substr(0,P.indexOf(u)+u.length),P=P.substr(P.indexOf(u)+u.length)):P.indexOf(y)===0&&(A=P.substr(0,P.indexOf(y)+y.length),P=P.substr(P.indexOf(y)+y.length));const x=P.split(u);for(let _=1;g&&_<=x.length;_++)for(let J=x.length-_;g&&J>=0;J--){g=!1;let ie=x.slice(J,J+_).join(u);for(let se=0;!g&&se<o.length;se++)if(se!==N&&o[se]&&o[se].indexOf(ie)>-1){const Y=J+_===x.length,X=J>0&&o[se].indexOf(u)>-1?u+ie:ie,Q=o[se].endsWith(X);g=!Y||Q}if(!g){let se="";(x[0].endsWith(":")||A!=="")&&(J===1&&(J=0,_++,ie=x[0]+u+ie),J>0&&(se=x[0]+u),se=A+se),J>0&&(se=se+l+u),se=se+ie,J+_<x.length&&(se=se+u+l),h[N]=se}}g&&(h[N]=P)}return h}t.shorten=b;var f;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function r(o,u=Object.create(null)){const h=[];let g=!1,N="";for(const P of o)if(P==="$"||g&&P==="{")N&&h.push({value:N,type:f.TEXT}),N="",g=!0;else if(P==="}"&&g){const A=u[N];if(typeof A=="string")A.length&&h.push({value:A,type:f.VARIABLE});else if(A){const x=h[h.length-1];(!x||x.type!==f.SEPARATOR)&&h.push({value:A.label,type:f.SEPARATOR})}N="",g=!1}else N+=P;return N&&!g&&h.push({value:N,type:f.TEXT}),h.filter((P,A)=>{if(P.type===f.SEPARATOR){const x=h[A-1],_=h[A+1];return[x,_].every(J=>J&&(J.type===f.VARIABLE||J.type===f.TEXT)&&J.value.length>0)}return!0}).map(P=>P.value).join("")}t.template=r;function s(o,u){return F.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(o,u){return F.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,""):F.isWindows?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(o){const u=o.indexOf("/")!==-1?S.posix:S.win32,h=u.basename(o),g=u.dirname(o);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}t.splitName=n}),define(Z[46],te([0,1,126]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class R{constructor(F="utf8"){this.stringDecoder=new T.StringDecoder(F),this.remaining=null}write(F){const k=[],C=this.remaining?this.remaining+this.stringDecoder.write(F):this.stringDecoder.write(F);if(C.length<1)return k;let c=0,d,m=c;for(;m<C.length;)if(d=C.charCodeAt(m),d===13||d===10){if(k.push(C.substring(c,m)),m++,m<C.length){const v=d;d=C.charCodeAt(m),(v===13&&d===10||v===10&&d===13)&&m++}c=m}else m++;return this.remaining=c<C.length?C.substr(c):null,k}end(){return this.remaining}}t.LineDecoder=R}),define(Z[63],te([0,1,38,4,18,11]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function k(m){const v=(0,R.dirname)(m);if(m===v)return m;const p=((0,R.basename)(m)||m).toLowerCase();try{const a=(0,F.readdirSync)(v).filter(l=>l.toLowerCase()===p);if(a.length===1){const l=k(v);if(l)return(0,R.join)(l,a[0])}else if(a.length>1){const l=a.indexOf(p);if(l>=0){const I=k(v);if(I)return(0,R.join)(I,a[l])}}}catch(L){}return null}t.realcaseSync=k;async function C(m){try{return await F.Promises.realpath(m)}catch(v){const p=d(m);return await F.Promises.access(p,T.constants.R_OK),p}}t.realpath=C;function c(m){try{return T.realpathSync(m)}catch(v){const p=d(m);return T.accessSync(p,T.constants.R_OK),p}}t.realpathSync=c;function d(m){return(0,S.rtrim)((0,R.normalize)(m),R.sep)}}),define(Z[64],te([0,1,32,4,11]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const F=/^\d+$/,k=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var c;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class v{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:r=!1}={}){return r?d===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function L({useAlternateBitness:r=!1,findPreview:s=!1}={}){const e=p({useAlternateBitness:r});if(!e)return null;const i=R.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let n=-1,o=null;for(const g of await S.Promises.readdir(i)){let N=-1;if(s){const A=g.indexOf("-");if(A<0)continue;const x=g.substring(0,A);if(!F.test(x)||g.substring(A+1)!=="preview")continue;N=parseInt(x,10)}else{if(!F.test(g))continue;N=parseInt(g,10)}if(N<=n)continue;const P=R.join(i,g,"pwsh.exe");!await S.SymlinkSupport.existsFile(P)||(o=P,n=N)}if(!o)return null;const u=e.includes("x86")?" (x86)":"",h=s?" Preview":"";return new v(o,`PowerShell${h}${u}`,!0)}async function a({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await S.Promises.readdir(s))if(e.test(n)){const o=R.join(s,n,"pwsh.exe");return new v(o,i)}return null}function l(){const r=R.join(T.homedir(),".dotnet","tools","pwsh.exe");return new v(r,".NET Core PowerShell Global Tool")}function I(){const r=R.join(process.env.windir,d===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(r,"Windows PowerShell",!0)}async function*y(){let r=await L();r&&(yield r),r=await L({useAlternateBitness:!0}),r&&(yield r),r=await a(),r&&(yield r),r=l(),r&&(yield r),r=await L({findPreview:!0}),r&&(yield r),r=await a({findPreview:!0}),r&&(yield r),r=await L({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=I(),r&&(yield r)}async function*b(){for await(const r of y())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=b;async function f(){for await(const r of b())return r;return null}t.getFirstAvailablePowerShellInstallation=f}),define(Z[65],te([0,1,38,31,2,127,4,10,11]),function(q,t,T,R,S,F,k,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function d(p,L,a){return v({path:p,isDirectory:!1},L,a)}t.watchFile=d;function m(p,L,a){return v({path:p,isDirectory:!0},L,a)}t.watchFolder=m,t.CHANGE_BUFFER_DELAY=100;function v(p,L,a){if(C.isMacintosh&&(0,R.isEqualOrParent)(p.path,"/Volumes/"))return a(`Refusing to watch ${p.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const l=(0,k.basename)(p.path),I=new Map;let y=!1,b=[(0,S.toDisposable)(()=>{I.forEach(f=>(0,S.dispose)(f)),I.clear()})];try{const f=(0,T.watch)(p.path);b.push((0,S.toDisposable)(()=>{f.removeAllListeners(),f.close()}));const r=new Set;p.isDirectory&&c.Promises.readdir(p.path).then(s=>s.forEach(e=>r.add(e))),f.on("error",(s,e)=>{y||a(`Failed to watch ${p.path} for changes using fs.watch() (${s}, ${e})`)}),f.on("change",(s,e)=>{if(y)return;let i="";if(e&&(i=e.toString(),C.isMacintosh&&(i=(0,F.normalizeNFC)(i))),!i||s!=="change"&&s!=="rename")return;const n=p.isDirectory?(0,k.join)(p.path,i):p.path;if(p.isDirectory)if(s==="rename"){const o=I.get(n);o&&(0,S.dispose)(o);const u=setTimeout(async()=>{I.delete(n);const h=await c.Promises.exists(n);if(y)return;let g;h?r.has(i)?g="changed":(g="added",r.add(i)):(r.delete(i),g="deleted"),L(g,n)},t.CHANGE_BUFFER_DELAY);I.set(n,(0,S.toDisposable)(()=>clearTimeout(u)))}else{let o;r.has(i)?o="changed":(o="added",r.add(i)),L(o,n)}else if(s==="rename"||i!==l){const o=setTimeout(async()=>{const u=await c.Promises.exists(n);y||(u?(L("changed",n),b=[v(p,L,a)]):L("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(b),b=[(0,S.toDisposable)(()=>clearTimeout(o))]}else L("changed",n)})}catch(f){c.Promises.exists(p.path).then(r=>{r&&!y&&a(`Failed to watch ${p.path} for changes using fs.watch() (${f.toString()})`)})}return(0,S.toDisposable)(()=>{y=!0,b=(0,S.dispose)(b)})}});var ue=this&&this.__decorate||function(q,t,T,R){var S=arguments.length,F=S<3?t:R===null?R=Object.getOwnPropertyDescriptor(t,T):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(q,t,T,R);else for(var C=q.length-1;C>=0;C--)(k=q[C])&&(F=(S<3?k(F):S>3?k(t,T,F):k(t,T))||F);return S>3&&F&&Object.defineProperty(t,T,F),F};define(Z[39],te([0,1,24,3,16,26,44,8,14,2,60,18,13]),function(q,t,T,R,S,F,k,C,c,d,m,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var L;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(L=t.RequestType||(t.RequestType={}));function a(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function I(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(y||(y={}));class b{constructor(w){this.buffer=w,this.pos=0}read(w){const M=this.buffer.slice(this.pos,this.pos+w);return this.pos+=M.byteLength,M}}class f{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(w){this.buffers.push(w)}}var r;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(r||(r={}));function s(U){const w=S.VSBuffer.alloc(4);return w.writeUInt32BE(U,0),w}function e(U){return U.read(4).readUInt32BE(0)}function i(U){const w=S.VSBuffer.alloc(1);return w.writeUInt8(U,0),w}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},o=typeof Buffer!="undefined";function u(U,w){if(typeof w=="undefined")U.write(n.Undefined);else if(typeof w=="string"){const M=S.VSBuffer.fromString(w);U.write(n.String),U.write(s(M.byteLength)),U.write(M)}else if(o&&Buffer.isBuffer(w)){const M=S.VSBuffer.wrap(w);U.write(n.Buffer),U.write(s(M.byteLength)),U.write(M)}else if(w instanceof S.VSBuffer)U.write(n.VSBuffer),U.write(s(w.byteLength)),U.write(w);else if(Array.isArray(w)){U.write(n.Array),U.write(s(w.length));for(const M of w)u(U,M)}else{const M=S.VSBuffer.fromString(JSON.stringify(w));U.write(n.Object),U.write(s(M.byteLength)),U.write(M)}}function h(U){switch(U.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return U.read(e(U)).toString();case r.Buffer:return U.read(e(U)).buffer;case r.VSBuffer:return U.read(e(U));case r.Array:{const M=e(U),E=[];for(let O=0;O<M;O++)E.push(h(U));return E}case r.Object:return JSON.parse(U.read(e(U)).toString())}}class g{constructor(w,M,E=null,O=1e3){this.protocol=w,this.ctx=M,this.logger=E,this.timeoutDelay=O,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(D=>this.onRawMessage(D)),this.sendResponse({type:200})}registerChannel(w,M){this.channels.set(w,M),setTimeout(()=>this.flushPendingRequests(w),0)}sendResponse(w){switch(w.type){case 200:{const M=this.send([w.type]);this.logger&&this.logger.logOutgoing(M,0,1,I(w.type));return}case 201:case 202:case 204:case 203:{const M=this.send([w.type,w.id],w.data);this.logger&&this.logger.logOutgoing(M,w.id,1,I(w.type),w.data);return}}}send(w,M=void 0){const E=new f;return u(E,w),u(E,M),this.sendBuffer(E.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch(M){return 0}}onRawMessage(w){const M=new b(w),E=h(M),O=h(M),D=E[0];switch(D){case 100:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${a(D)}: ${E[2]}.${E[3]}`,O),this.onPromise({type:D,id:E[1],channelName:E[2],name:E[3],arg:O});case 102:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${a(D)}: ${E[2]}.${E[3]}`,O),this.onEventListen({type:D,id:E[1],channelName:E[2],name:E[3],arg:O});case 101:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${a(D)}`),this.disposeActiveRequest({type:D,id:E[1]});case 103:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${a(D)}`),this.disposeActiveRequest({type:D,id:E[1]})}}onPromise(w){const M=this.channels.get(w.channelName);if(!M){this.collectPendingRequest(w);return}const E=new F.CancellationTokenSource;let O;try{O=M.call(this.ctx,w.name,w.arg,E.token)}catch(j){O=Promise.reject(j)}const D=w.id;O.then(j=>{this.sendResponse({id:D,data:j,type:201}),this.activeRequests.delete(w.id)},j=>{j instanceof Error?this.sendResponse({id:D,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:D,data:j,type:203}),this.activeRequests.delete(w.id)});const z=(0,d.toDisposable)(()=>E.cancel());this.activeRequests.set(w.id,z)}onEventListen(w){const M=this.channels.get(w.channelName);if(!M){this.collectPendingRequest(w);return}const E=w.id,D=M.listen(this.ctx,w.name,w.arg)(z=>this.sendResponse({id:E,data:z,type:204}));this.activeRequests.set(w.id,D)}disposeActiveRequest(w){const M=this.activeRequests.get(w.id);M&&(M.dispose(),this.activeRequests.delete(w.id))}collectPendingRequest(w){let M=this.pendingRequests.get(w.channelName);M||(M=[],this.pendingRequests.set(w.channelName,M));const E=setTimeout(()=>{console.error(`Unknown channel: ${w.channelName}`),w.type===100&&this.sendResponse({id:w.id,data:{name:"Unknown channel",message:`Channel name '${w.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:w,timeoutTimer:E})}flushPendingRequests(w){const M=this.pendingRequests.get(w);if(M){for(const E of M)switch(clearTimeout(E.timeoutTimer),E.request.type){case 100:this.onPromise(E.request);break;case 102:this.onEventListen(E.request);break}this.pendingRequests.delete(w)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(w=>w.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var N;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(N=t.RequestInitiator||(t.RequestInitiator={}));class P{constructor(w,M=null){this.protocol=w,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(E=>this.onBuffer(E)),this.logger=M}getChannel(w){const M=this;return{call(E,O,D){return M.isDisposed?Promise.reject(C.canceled()):M.requestPromise(w,E,O,D)},listen(E,O){return M.isDisposed?Promise.reject(C.canceled()):M.requestEvent(w,E,O)}}}requestPromise(w,M,E,O=F.CancellationToken.None){const D=this.lastRequestId++,j={id:D,type:100,channelName:w,name:M,arg:E};if(O.isCancellationRequested)return Promise.reject(C.canceled());let $;return new Promise((ee,ne)=>{if(O.isCancellationRequested)return ne(C.canceled());const re=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(D),ee(Te.data);break;case 202:this.handlers.delete(D);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(D),ne(Te.data);break}};this.handlers.set(D,ke),this.sendRequest(j)};let ce=null;this.state===y.Idle?re():(ce=(0,R.createCancelablePromise)(ke=>this.whenInitialized()),ce.then(()=>{ce=null,re()}));const me=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:D,type:101}),ne(C.canceled())},be=O.onCancellationRequested(me);$=(0,d.combinedDisposable)((0,d.toDisposable)(me),be),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(w,M,E){const O=this.lastRequestId++,z={id:O,type:102,channelName:w,name:M,arg:E};let j=null;const $=new c.Emitter({onFirstListenerAdd:()=>{j=(0,R.createCancelablePromise)(ee=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add($),this.sendRequest(z)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete($),this.sendRequest({id:O,type:103}))}}),H=ee=>$.fire(ee.data);return this.handlers.set(O,H),$.event}sendRequest(w){switch(w.type){case 100:case 102:{const M=this.send([w.type,w.id,w.channelName,w.name],w.arg);this.logger&&this.logger.logOutgoing(M,w.id,0,`${a(w.type)}: ${w.channelName}.${w.name}`,w.arg);return}case 101:case 103:{const M=this.send([w.type,w.id]);this.logger&&this.logger.logOutgoing(M,w.id,0,a(w.type));return}}}send(w,M=void 0){const E=new f;return u(E,w),u(E,M),this.sendBuffer(E.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch(M){return 0}}onBuffer(w){const M=new b(w),E=h(M),O=h(M),D=E[0];switch(D){case 200:return this.logger&&this.logger.logIncoming(w.byteLength,0,0,I(D)),this.onResponse({type:E[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],0,I(D),O),this.onResponse({type:E[0],id:E[1],data:O})}}onResponse(w){if(w.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(w.id);M&&M(w)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(w=>w.dispose()),this.activeRequests.clear()}}ue([k.memoize],P.prototype,"onDidInitializePromise",null),t.ChannelClient=P;class A{constructor(w){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,w(({protocol:M,onDidClientDisconnect:E})=>{c.Event.once(M.onMessage)(D=>{const z=new b(D),j=h(z),$=new g(M,j),H=new P(M);this.channels.forEach((ne,re)=>$.registerChannel(re,ne));const ee={channelServer:$,channelClient:H,ctx:j};this._connections.add(ee),this._onDidAddConnection.fire(ee),E(()=>{$.dispose(),H.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const w=[];return this._connections.forEach(M=>w.push(M)),w}getChannel(w,M){const E=this;return{call(O,D,z){let j;if((0,p.isFunction)(M)){let H=(0,T.getRandomElement)(E.connections.filter(M));j=H?Promise.resolve(H):c.Event.toPromise(c.Event.filter(E.onDidAddConnection,M))}else j=M.routeCall(E,O,D);const $=j.then(H=>H.channelClient.getChannel(w));return _($).call(O,D,z)},listen(O,D){if((0,p.isFunction)(M))return E.getMulticastEvent(w,M,O,D);const z=M.routeEvent(E,O,D).then(j=>j.channelClient.getChannel(w));return _(z).listen(O,D)}}}getMulticastEvent(w,M,E,O){const D=this;let z=new d.DisposableStore;const j=new c.Emitter({onFirstListenerAdd:()=>{z=new d.DisposableStore;const $=new c.EventMultiplexer,H=new Map,ee=re=>{const me=re.channelClient.getChannel(w).listen(E,O),be=$.add(me);H.set(re,be)},ne=re=>{const ce=H.get(re);!ce||(ce.dispose(),H.delete(re))};D.connections.filter(M).forEach(ee),c.Event.filter(D.onDidAddConnection,M)(ee,void 0,z),D.onDidRemoveConnection(ne,void 0,z),$.event(j.fire,j,z),z.add($)},onLastListenerRemove:()=>{z.dispose()}});return j.event}registerChannel(w,M){this.channels.set(w,M),this._connections.forEach(E=>{E.channelServer.registerChannel(w,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=A;class x{constructor(w,M,E=null){const O=new f;u(O,M),w.send(O.buffer),this.channelClient=new P(w,E),this.channelServer=new g(w,M,E)}getChannel(w){return this.channelClient.getChannel(w)}registerChannel(w,M){this.channelServer.registerChannel(w,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=x;function _(U){return{call(w,M,E){return U.then(O=>O.call(w,M,E))},listen(w,M){const E=new c.Relay;return U.then(O=>E.input=O.listen(w,M)),E.event}}}t.getDelayedChannel=_;function J(U){let w=!1;return{call(M,E,O){return w?U.call(M,E,O):(0,R.timeout)(0).then(()=>w=!0).then(()=>U.call(M,E,O))},listen(M,E){if(w)return U.listen(M,E);const O=new c.Relay;return(0,R.timeout)(0).then(()=>w=!0).then(()=>O.input=U.listen(M,E)),O.event}}}t.getNextTickChannel=J;class ie{constructor(w){this.fn=w}routeCall(w){return this.route(w)}routeEvent(w){return this.route(w)}async route(w){for(const M of w.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await c.Event.toPromise(w.onDidAddConnection),await this.route(w)}}t.StaticRouter=ie;var se;(function(U){function w(O,D){const z=O,j=D&&D.disableMarshalling,$=new Map;for(const H in z)E(H)&&$.set(H,c.Event.buffer(z[H],!0));return new class{listen(H,ee){const ne=$.get(ee);if(ne)return ne;throw new Error(`Event not found: ${ee}`)}call(H,ee,ne){const re=z[ee];if(typeof re=="function"){if(!j&&Array.isArray(ne))for(let ce=0;ce<ne.length;ce++)ne[ce]=(0,m.revive)(ne[ce]);return re.apply(z,ne)}throw new Error(`Method not found: ${ee}`)}}}U.fromService=w;function M(O,D){const z=D&&D.disableMarshalling;return new Proxy({},{get(j,$){if(typeof $=="string")return D?.properties?.has($)?D.properties.get($):E($)?O.listen($):async function(...H){let ee;D&&!(0,p.isUndefinedOrNull)(D.context)?ee=[D.context,...H]:ee=H;const ne=await O.call($,ee);return z?ne:(0,m.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}U.toService=M;function E(O){return O[0]==="o"&&O[1]==="n"&&v.isUpperAsciiLetter(O.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let w=U.toString();if(w!=="[object Object]")return w}return U}function Q(U){return Array.isArray(U)?U.map(X):X(U)}function B(U,w,M,E,O,D,z){z=Q(z);const j=Y[O],$=j[E%j.length];let H=[`%c[${U}]%c[${String(w).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(E).padStart(5," ")} - ${D}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(D)?(H=H.concat(z),H.push(")")):H.push(z),console.log.apply(console,H)}t.logWithColors=B;class W{constructor(w,M){this._outgoingPrefix=w,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(w,M,E,O,D){this._totalOutgoing+=w,B(this._outgoingPrefix,this._totalOutgoing,w,M,E,O,D)}logIncoming(w,M,E,O,D){this._totalIncoming+=w,B(this._incomingPrefix,this._totalIncoming,w,M,E,O,D)}}t.IPCLogger=W}),define(Z[66],te([0,1,3,14,2,13]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var k;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=t.StorageHint||(t.StorageHint={}));var C;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(C||(C={}));class c extends S.Disposable{constructor(v,p=Object.create(null)){super();this.database=v,this.options=p,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((p,L)=>this.accept(L,p)),v.deleted?.forEach(p=>this.accept(p,void 0))}accept(v,p){if(this.state===C.Closed)return;let L=!1;(0,F.isUndefinedOrNull)(p)?L=this.cache.delete(v):this.cache.get(v)!==p&&(this.cache.set(v,p),L=!0),L&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,p){const L=this.cache.get(v);return(0,F.isUndefinedOrNull)(L)?p:L}getBoolean(v,p){const L=this.get(v);return(0,F.isUndefinedOrNull)(L)?p:L==="true"}getNumber(v,p){const L=this.get(v);return(0,F.isUndefinedOrNull)(L)?p:parseInt(L,10)}async set(v,p){if(this.state===C.Closed)return;if((0,F.isUndefinedOrNull)(p))return this.delete(v);const L=String(p);if(this.cache.get(v)!==L)return this.cache.set(v,L),this.pendingInserts.set(v,L),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===C.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=c,c.DEFAULT_FLUSH_DELAY=100;class d{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((p,L)=>this.items.set(L,p)),v.delete&&v.delete.forEach(p=>this.items.delete(p))}async close(){}}t.InMemoryStorageDatabase=d}),define(Z[67],te([5,6]),function(q,t){return q.create("vs/base/common/date",t)}),define(Z[68],te([0,1,67]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const R=60,S=R*60,F=S*24,k=F*7,C=F*30,c=F*365;function d(v,p){typeof v!="number"&&(v=v.getTime());const L=Math.round((new Date().getTime()-v)/1e3);if(L<-30)return(0,T.localize)(0,null,d(new Date().getTime()+L*1e3,!1));if(L<30)return(0,T.localize)(1,null);let a;return L<R?(a=L,p?a===1?(0,T.localize)(2,null,a):(0,T.localize)(3,null,a):a===1?(0,T.localize)(4,null,a):(0,T.localize)(5,null,a)):L<S?(a=Math.floor(L/R),p?a===1?(0,T.localize)(6,null,a):(0,T.localize)(7,null,a):a===1?(0,T.localize)(8,null,a):(0,T.localize)(9,null,a)):L<F?(a=Math.floor(L/S),p?a===1?(0,T.localize)(10,null,a):(0,T.localize)(11,null,a):a===1?(0,T.localize)(12,null,a):(0,T.localize)(13,null,a)):L<k?(a=Math.floor(L/F),p?a===1?(0,T.localize)(14,null,a):(0,T.localize)(15,null,a):a===1?(0,T.localize)(16,null,a):(0,T.localize)(17,null,a)):L<C?(a=Math.floor(L/k),p?a===1?(0,T.localize)(18,null,a):(0,T.localize)(19,null,a):a===1?(0,T.localize)(20,null,a):(0,T.localize)(21,null,a)):L<c?(a=Math.floor(L/C),p?a===1?(0,T.localize)(22,null,a):(0,T.localize)(23,null,a):a===1?(0,T.localize)(24,null,a):(0,T.localize)(25,null,a)):(a=Math.floor(L/c),p?a===1?(0,T.localize)(26,null,a):(0,T.localize)(27,null,a):a===1?(0,T.localize)(28,null,a):(0,T.localize)(29,null,a))}t.fromNow=d;function m(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=m}),define(Z[69],te([5,6]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(Z[28],te([0,1,24,13,69]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function F(d,m){return m&&(d.stack||d.stacktrace)?S.localize(0,null,C(d),k(d.stack)||k(d.stacktrace)):C(d)}function k(d){return Array.isArray(d)?d.join(`
`):d}function C(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?S.localize(1,null,d.message):d.message||S.localize(2,null)}function c(d=null,m=!1){if(!d)return S.localize(3,null);if(Array.isArray(d)){const v=T.coalesce(d),p=c(v[0],m);return v.length>1?S.localize(4,null,p,v.length):p}if(R.isString(d))return d;if(d.detail){const v=d.detail;if(v.error)return F(v.error,m);if(v.exception)return F(v.exception,m)}return d.stack?F(d,m):d.message?d.message:S.localize(5,null)}t.toErrorMessage=c}),define(Z[70],te([5,6]),function(q,t){return q.create("vs/base/node/processes",t)}),define(Z[47],te([0,1,33,31,9,19,4,10,34,13,46,11,70]),function(q,t,T,R,S,F,k,C,c,d,m,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function L(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(r,s){if(C.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=T.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,u)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?L(e.status):1})}else if(C.isLinux||C.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{T.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,o,u)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function l(r=c.env){return r.comspec||"cmd.exe"}t.getWindowsShell=l;class I{constructor(s,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=n;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(c.env).forEach(u=>{o[u]=c.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(k.sep);return e!==-1&&(s=s.substring(e+1)),I.WellKnowCommands[s]?s:"other"}start(s){return C.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(c.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(e=>{let i,n;const o=new Promise((u,h)=>{i=u,n=h});if(e){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=T.exec(u,this.options,(h,g,N)=>{this.childProcess=null;const P=h;P&&P.killed?n({killed:this.terminateRequested,stdout:g.toString(),stderr:N.toString()}):this.handleExec(i,s,h,g,N)})}else{let u=null;const h=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,i,s,n);const N={terminated:this.terminateRequested};d.isNumber(g)&&(N.cmdCode=g),i(N)};if(this.shell&&C.isWindows){const g=F.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let N=!1,P=!1;const A=[];let x=this.ensureQuotes(this.cmd);A.push(x.value),N=x.quoted,this.args&&this.args.forEach(J=>{x=this.ensureQuotes(J),A.push(x.value),P=P&&x.quoted});const _=["/s","/c"];N?P?_.push('"'+A.join(" ")+'"'):A.length>1?_.push('"'+A[0]+'" '+A.slice(1).join(" ")):_.push('"'+A[0]+'"'):_.push(A.join(" ")),u=T.spawn(l(),_,g)}else this.cmd&&(u=T.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(d.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",g=>{this.childProcess=null,n({terminated:this.terminateRequested,error:g})}),u.pid&&(this.childProcess.on("close",h),this.handleSpawn(u,i,s,n,!0)))}return o})}handleClose(s,e,i,n){}ensureQuotes(s){return I.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,a(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!C.isWindows)return s(!1);const e=T.spawn(l(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class y extends I{constructor(s,e,i,n){super(s,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,n,o){[n,o].forEach((u,h)=>{const g=new m.LineDecoder;g.write(u).forEach(A=>{e({line:A,source:h===0?0:1})});const P=g.end();P&&e({line:P,source:h===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,n,o){const u=new m.LineDecoder,h=new m.LineDecoder;s.stdout.on("data",g=>{u.write(g).forEach(P=>i({line:P,source:0}))}),s.stderr.on("data",g=>{h.write(g).forEach(P=>i({line:P,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=h}handleClose(s,e,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}t.LineProcess=y;function b(r){let s=[],e=!1;const i=function(n){if(e){s.push(n);return}(!r.send(n,u=>{if(u&&console.error(u),e=!1,s.length>0){const h=s.slice(0);s=[],h.forEach(g=>i(g))}})||C.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=b;var f;(function(r){async function s(e,i,n){if(k.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),k.dirname(e)!=="."||(n===void 0&&d.isString(c.env.PATH)&&(n=c.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(i,e);async function u(h){return await v.Promises.exists(h)?!(await v.Promises.stat(h)).isDirectory():!1}for(let h of n){let g;if(k.isAbsolute(h)?g=k.join(h,e):g=k.join(i,h,e),await u(g))return g;let N=g+".com";if(await u(N)||(N=g+".exe",await u(N)))return N}return k.join(i,e)}r.findExecutable=s})(f=t.win32||(t.win32={}))}),define(Z[71],te([0,1,32,10,64,47]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function k(L,a){return L===1?R.isWindows?v():F.getWindowsShell(a):d(L,a)}t.getSystemShell=k;function C(L,a){return L===1?R.isWindows?p(a):F.getWindowsShell(a):d(L,a)}t.getSystemShellSync=C;let c=null;function d(L,a){if(R.isLinux&&L===2||R.isMacintosh&&L===3)return"/bin/bash";if(!c){let l;if(R.isWindows)l="/bin/bash";else{if(l=a.SHELL,!l)try{l=(0,T.userInfo)().shell}catch(I){}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}c=l}return c}let m=null;async function v(){return m||(m=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(L){if(m)return m;const a=R.isWindows&&parseFloat((0,T.release)())>=10,l=L.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${L.windir}\\${l?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?I:F.getWindowsShell(L)}}),define(Z[48],te([0,1,33,3,16,26,59,8,14,2,19,10,47,39]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends L.ChannelServer{constructor(y){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(f){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",b=>S.VSBuffer.wrap(Buffer.from(b,"base64")))},y);process.once("disconnect",()=>this.dispose())}}t.Server=a;class l{constructor(y,b){this.modulePath=y,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new R.Delayer(f),this.child=null,this._client=null}getChannel(y){const b=this;return{call(f,r,s){return b.requestPromise(y,f,r,s)},listen(f,r){return b.requestEvent(y,f,r)}}}requestPromise(y,b,f,r=F.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(y),e=(0,R.createCancelablePromise)(o=>s.call(b,f,o)),i=r.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(y,b,f){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let r;const s=new c.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(y).listen(b,f)(s.fire,s),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),v.isMacintosh&&b.env&&delete b.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,y,b);const f=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,k.isRemoteConsoleLog)(u)){(0,k.log)(u,`IPC Library: ${this.options.serverName}`);return}f.fire(S.VSBuffer.wrap(Buffer.from(u,"base64")))});const s=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,e=u=>this.child&&this.child.connected&&s.send(u.buffer.toString("base64")),i=f.event,n={send:e,onMessage:i};this._client=new L.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,h)=>{process.removeListener("exit",o),this.activeRequests.forEach(g=>(0,d.dispose)(g)),this.activeRequests.clear(),u!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:h})})}return this._client}getCachedChannel(y){let b=this.channels.get(y);return b||(b=this.client.getChannel(y),this.channels.set(y,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=l}),define(Z[72],te([5,6]),function(q,t){return q.create("vs/base/node/zip",t)}),define(Z[73],te([5,6]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[74],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[75],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[76],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[77],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[78],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[79],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[80],te([5,6]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[81],te([5,6]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(Z[82],te([5,6]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(Z[83],te([5,6]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[84],te([5,6]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(Z[85],te([5,6]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[86],te([0,1,68,44,9,4,34,20,7]),function(q,t,T,R,S,F,k,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(a,l,I){this._args=a,this.paths=l,this.productService=I}get appRoot(){return(0,F.dirname)(S.FileAccess.asFileUri("",q).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,F.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,F.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,F.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(c.URI.file((0,F.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=k.env.VSCODE_PORTABLE;return a?c.URI.file((0,F.join)(a,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,F.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,F.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,F.resolve)(a):(0,F.normalize)((0,F.join)(S.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,F.resolve)(a):(0,F.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,F.resolve)(a);const l=k.env.VSCODE_EXTENSIONS;if(l)return l;const I=k.env.VSCODE_PORTABLE;return I?(0,F.join)(I,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(l=>/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,F.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?c.URI.parse(a):c.URI.file((0,F.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,F.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([R.memoize],d.prototype,"appRoot",null),ue([R.memoize],d.prototype,"userHome",null),ue([R.memoize],d.prototype,"userDataPath",null),ue([R.memoize],d.prototype,"appSettingsHome",null),ue([R.memoize],d.prototype,"tmpDir",null),ue([R.memoize],d.prototype,"userRoamingDataHome",null),ue([R.memoize],d.prototype,"settingsResource",null),ue([R.memoize],d.prototype,"userDataSyncHome",null),ue([R.memoize],d.prototype,"userDataSyncLogResource",null),ue([R.memoize],d.prototype,"sync",null),ue([R.memoize],d.prototype,"machineSettingsResource",null),ue([R.memoize],d.prototype,"globalStorageHome",null),ue([R.memoize],d.prototype,"workspaceStorageHome",null),ue([R.memoize],d.prototype,"keybindingsResource",null),ue([R.memoize],d.prototype,"keyboardLayoutResource",null),ue([R.memoize],d.prototype,"argvResource",null),ue([R.memoize],d.prototype,"snippetsHome",null),ue([R.memoize],d.prototype,"isExtensionDevelopment",null),ue([R.memoize],d.prototype,"untitledWorkspacesHome",null),ue([R.memoize],d.prototype,"installSourcePath",null),ue([R.memoize],d.prototype,"builtinExtensionsPath",null),ue([R.memoize],d.prototype,"extensionsPath",null),ue([R.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ue([R.memoize],d.prototype,"extensionDevelopmentKind",null),ue([R.memoize],d.prototype,"extensionTestsLocationURI",null),ue([R.memoize],d.prototype,"debugExtensionHost",null),ue([R.memoize],d.prototype,"serviceMachineIdResource",null),ue([R.memoize],d.prototype,"telemetryLogResource",null),ue([R.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function m(L,a){return p(L["inspect-extensions"],L["inspect-brk-extensions"],5870,a,L.debugId)}t.parseExtensionHostPort=m;function v(L,a){return p(L["inspect-search"],L["inspect-brk-search"],5876,a)}t.parseSearchPort=v;function p(L,a,l,I,y){const f=Number(a||L)||(I?null:l),r=f?Boolean(!!a):!1;return{port:f,break:r,debugId:y}}}),function(){"use strict";function q(t,T,R,S){function F(C){const c=k(C),d=[c];return t.isAbsolute(c)||d.unshift(S),t.resolve(...d)}function k(C){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,R);const m=C["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(v,"AppData","Roaming")}break;case"darwin":d=t.join(T.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,R)}return{getUserDataPath:F}}if(typeof define=="function")define(Z[87],te([0,88,32,9,20,34]),function(t,T,R,S,F,k){const C=F.dirname(S.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(F.joinPath(C,"package.json").fsPath);return q(T,R,c.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),R=require("os");module.exports=q(T,R,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[89],te([0,1,32,86,87]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class F extends R.AbstractNativeEnvironmentService{constructor(C,c){super(C,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,S.getUserDataPath)(C)},c)}}t.NativeEnvironmentService=F}),define(Z[90],te([0,1,19]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function S(F,k){const C=c=>{if(typeof c!="string")return;const d=R.exec(c);if(!d)return;const m=k[d[1]]??c;return typeof m=="string"?m:typeof m.message=="string"?m.message:c};return(0,T.cloneAndChange)(F,C)}t.localizeManifest=S}),define(Z[49],te([0,1,80]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function F(p){return p=p.trim(),p==="*"||R.test(p)}t.isValidVersionStr=F;function k(p){if(!F(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let L=p.match(R);return L?{hasCaret:L[1]==="^",hasGreaterEquals:L[1]===">=",majorBase:L[2]==="x"?0:parseInt(L[2],10),majorMustEqual:L[2]!=="x",minorBase:L[4]==="x"?0:parseInt(L[4],10),minorMustEqual:L[4]!=="x",patchBase:L[6]==="x"?0:parseInt(L[6],10),patchMustEqual:L[6]!=="x",preRelease:L[8]||null}:null}t.parseVersion=k;function C(p){if(!p)return null;let L=p.majorBase,a=p.majorMustEqual,l=p.minorBase,I=p.minorMustEqual,y=p.patchBase,b=p.patchMustEqual;p.hasCaret&&(L===0||(I=!1),b=!1);let f=0;if(p.preRelease){const r=S.exec(p.preRelease);if(r){const[,s,e,i]=r;f=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:L,majorMustEqual:a,minorBase:l,minorMustEqual:I,patchBase:y,patchMustEqual:b,isMinimum:p.hasGreaterEquals,notBefore:f}}t.normalizeVersion=C;function c(p,L,a){let l;typeof p=="string"?l=C(k(p)):l=p;let I;L instanceof Date?I=L.getTime():typeof L=="string"&&(I=new Date(L).getTime());let y;if(typeof a=="string"?y=C(k(a)):y=a,!l||!y)return!1;let b=l.majorBase,f=l.minorBase,r=l.patchBase,s=y.majorBase,e=y.minorBase,i=y.patchBase,n=y.notBefore,o=y.majorMustEqual,u=y.minorMustEqual,h=y.patchMustEqual;return y.isMinimum?b>s?!0:b<s?!1:f>e?!0:f<e||I&&I<n?!1:r>=i:(b===1&&s===0&&(!o||!u||!h)&&(s=1,e=0,i=0,o=!0,u=!1,h=!1),b<s?!1:b>s?!o:f<e?!1:f>e?!u:r<i?!1:r>i?!h:!(I&&I<n))}t.isValidVersion=c;function d(p,L,a,l){return a.isBuiltin||typeof a.main=="undefined"?!0:v(p,L,a.engines.vscode,l)}t.isValidExtensionVersion=d;function m(p,L,a){return p==="*"||v(L,a,p)}t.isEngineValid=m;function v(p,L,a,l=[]){let I=C(k(a));if(!I)return l.push(T.localize(0,null,a)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return l.push(T.localize(1,null,a)),!1}else if(!I.majorMustEqual)return l.push(T.localize(2,null,a)),!1;return c(p,L,I)?!0:(l.push(T.localize(3,null,p,a)),!1)}}),define(Z[91],te([0,1,2,9,39,48]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k extends T.Disposable{constructor(c,d,m,v){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=m,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new F.Client(R.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[92],te([0,1,2,9,39,48]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k extends T.Disposable{constructor(c,d,m,v,p={}){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=m,this.verboseLogging=v,this.watcherOptions=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new F.Client(R.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[93],te([0,1,33,61,9,46]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(c,d,m,v,p){this.watchedFolder=c,this.eventCallback=m,this.logCallback=v,this.verboseLogging=p,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(L=>(0,R.parse)(L)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,T.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,c);const d=new F.LineDecoder;this.handle.stdout.on("data",m=>{const v=[];for(const p of d.write(m)){const L=p.split("|");if(L.length===2){const a=Number(L[0]),l=L[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(I=>I(l))){this.verboseLogging&&this.log(l);continue}v.push({type:k.changeTypeMap[a],path:l})}else this.log(L[1])}}v.length>0&&this.eventCallback(v)}),this.handle.on("error",m=>this.onError(m)),this.handle.stderr.on("data",m=>this.onError(m)),this.handle.on("exit",(m,v)=>this.onExit(m,v))}onError(c){this.error("process error: "+c.toString())}onExit(c,d){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${d})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Z[94],te([0,1,4,18,93]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F{constructor(C,c,d,m){this.onDidFilesChange=c,this.onLogMessage=d,this.verboseLogging=m,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,R.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=F}),define(Z[50],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(S,F=[],k=!1){this.ctor=S,this.staticArguments=F,this.supportsDelayedInstantiation=k}}t.SyncDescriptor=T}),define(Z[95],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(F){this.incoming=new Map,this.outgoing=new Map,this.data=F}}t.Node=T;class R{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(let k of this._nodes.values())k.outgoing.size===0&&F.push(k);return F}insertEdge(F,k){const C=this.lookupOrInsertNode(F),c=this.lookupOrInsertNode(k);C.outgoing.set(this._hashFn(k),c),c.incoming.set(this._hashFn(F),C)}removeNode(F){const k=this._hashFn(F);this._nodes.delete(k);for(let C of this._nodes.values())C.outgoing.delete(k),C.incoming.delete(k)}lookupOrInsertNode(F){const k=this._hashFn(F);let C=this._nodes.get(k);return C||(C=new T(F),this._nodes.set(k,C)),C}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){let F=[];for(let[k,C]of this._nodes)F.push(`${k}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return F.join(`
`)}findCycleSlow(){for(let[F,k]of this._nodes){const C=new Set([F]),c=this._findCycle(k,C);if(c)return c}}_findCycle(F,k){for(let[C,c]of F.outgoing){if(k.has(C))return[...k,C].join(" -> ");k.add(C);const d=this._findCycle(c,k);if(d)return d;k.delete(C)}}}t.Graph=R}),define(Z[96],te([0,1,12]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Z[21],te([0,1,12]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[22],te([0,1,9,75,12]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function F(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=F;var k;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(k=t.SortBy||(t.SortBy={}));var C;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(C=t.SortOrder||(t.SortOrder={}));var c;(function(v){v.Install="install",v.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var d;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(d=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class m extends Error{constructor(p,L){super(p);this.code=L,this.name=L}}t.ExtensionManagementError=m,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),t.ExtensionsLabel=(0,R.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,R.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],te([0,1,18,12]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}t.getWorkspaceSupportTypeMessage=S;function F(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}t.isIExtensionIdentifier=F,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(k=t.ExtensionType||(t.ExtensionType={}));class C{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,p){if(typeof v=="undefined"||v===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof v=="string"||typeof p=="string"){let L=typeof v=="string"?v:v.value,a=typeof p=="string"?p:p.value;return T.equalsIgnoreCase(L,a)}return v._lower===p._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}t.ExtensionIdentifier=C;function c(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function d(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],te([0,1,18,40]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,T.compareIgnoreCase)(a.id,l.id)===0}t.areSameExtensions=S;class F{constructor(l,I){this.version=I,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof F?S(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=F;function k(a,l){return`${a}.${l}`}t.getExtensionId=k;function C(a){return a.toLocaleLowerCase()}t.adoptToGalleryExtensionId=C;function c(a,l){return C(k(a,l))}t.getGalleryExtensionId=c;function d(a,l){const I=[],y=b=>{for(const f of I)if(f.some(r=>S(l(r),l(b))))return f;return null};for(const b of a){const f=y(b);f?f.push(b):I.push([b])}return I}t.groupByExtension=d;function m(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=m;function v(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}t.getGalleryExtensionTelemetryData=v,t.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function p(a){const l=new Set;for(const I of a)I.malicious&&l.add(I.id.id);return l}t.getMaliciousExtensionsSet=p;function L(a,l){const I=[],y=l.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const b=y.shift();if(b&&I.every(f=>!S(f.identifier,{id:b}))){const f=a.filter(r=>S(r.identifier,{id:b}));f.length===1&&(I.push(f[0]),y.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}t.getExtensionDependencies=L});var fe=this&&this.__param||function(q,t){return function(T,R){t(T,R,q)}};define(Z[97],te([0,1,26,8,62,9,41,7,76,22,23,40]),function(q,t,T,R,S,F,k,C,c,d,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const p=b=>(0,c.localize)(0,null,b),L=(0,c.localize)(1,null,"ms-dotnettools.csharp");function a(b,f){return f?`${b.publisher}.${b.name}@${b.version}`:`${b.publisher}.${b.name}`}const l=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(b){const f=l.exec(b);return f&&f[1]?[(0,m.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,m.adoptToGalleryExtensionId)(b),void 0]}t.getIdAndVersion=I;let y=class{constructor(f,r){this.extensionManagementService=f,this.extensionGalleryService=r}get location(){}async listExtensions(f,r,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=v.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(h=>h.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){s.log("Possible Categories: "),i.forEach(o=>{s.log(o)});return}this.location&&s.log((0,c.localize)(2,null,this.location)),e=e.sort((o,u)=>o.identifier.id.localeCompare(u.identifier.id));let n;for(let o of e)n!==o.identifier.id&&(n=o.identifier.id,s.log(a(o.manifest,f)))}async installExtensions(f,r,s,e,i=console){const n=[],o=[];f.length&&i.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const u=await this.extensionManagementService.getInstalled(1),h=(P,A)=>{const x=u.find(_=>(0,m.areSameExtensions)(_.identifier,{id:P}));if(x){if(!A&&!e)return i.log((0,c.localize)(5,null,P,x.manifest.version,P)),!1;if(A&&x.manifest.version===A)return i.log((0,c.localize)(6,null,`${P}@${A}`)),!1}return!0},g=[],N=[];for(const P of f)if(P instanceof C.URI)g.push(P);else{const[A,x]=I(P);h(A,x)&&N.push({id:A,version:x,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const P of r){const[A,x]=I(P);h(A,x)&&N.push({id:A,version:x,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(g.length&&await Promise.all(g.map(async P=>{try{const A=await this.installVSIX(P,{isBuiltin:!1,isMachineScoped:s},e,i);A&&o.push(A)}catch(A){i.error(A.message||A.stack||A),n.push(P.toString())}})),N.length){const P=await this.getGalleryExtensions(N);await Promise.all(N.map(async A=>{const x=P.get(A.id.toLowerCase());if(x)try{const _=await this.installFromGallery(A,x,u,e,i);_&&o.push(_)}catch(_){i.error(_.message||_.stack||_),n.push(A.id)}else i.error(`${p(A.version?`${A.id}@${A.version}`:A.id)}
${L}`),n.push(A.id)}))}if(n.length)throw new Error((0,c.localize)(7,null,n.join(", ")))}async installVSIX(f,r,s,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(f,r),e.log((0,c.localize)(8,null,(0,S.getBaseLabel)(f))),i}catch(o){if((0,R.isPromiseCanceledError)(o))return e.log((0,c.localize)(9,null,(0,S.getBaseLabel)(f))),null;throw o}return null}async getGalleryExtensions(f){const r=f.filter(({version:i})=>i===void 0).map(({id:i})=>i),s=f.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,T.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(s.map(async({id:i,version:n})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:i},n);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:f,version:r,installOptions:s},e,i,n,o){const u=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(u&&!this.validateExtensionKind(u,o))return null;const h=i.find(g=>(0,m.areSameExtensions)(g.identifier,e.identifier));if(h){if(e.version===h.manifest.version)return o.log((0,c.localize)(10,null,r?`${f}@${r}`:f)),null;o.log((0,c.localize)(11,null,f,e.version))}try{return s.isBuiltin?o.log(r?(0,c.localize)(12,null,f,r):(0,c.localize)(13,null,f)):o.log(r?(0,c.localize)(14,null,f,r):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,s),o.log((0,c.localize)(16,null,f,e.version)),u}catch(g){if((0,R.isPromiseCanceledError)(g))return o.log((0,c.localize)(17,null,f)),null;throw g}}validateExtensionKind(f,r){return!0}async validateVSIX(f,r,s){const e={id:(0,m.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,m.areSameExtensions)(e,o.identifier)&&(0,k.gt)(o.manifest.version,f.version));return n&&!r?(s.log((0,c.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,r,s=console){const e=async n=>{if(n instanceof C.URI){const o=await this.extensionManagementService.getManifest(n);return a(o)}return n},i=[];for(const n of f){const o=await e(n),h=(await this.extensionManagementService.getInstalled()).filter(g=>(0,m.areSameExtensions)(g.identifier,{id:o}));if(!h.length)throw new Error(`${this.notInstalled(o)}
${L}`);if(h.some(g=>g.type===0)){s.log((0,c.localize)(19,null,o));return}if(!r&&h.some(g=>g.isBuiltin)){s.log((0,c.localize)(20,null,o));return}s.log((0,c.localize)(21,null,o));for(const g of h)await this.extensionManagementService.uninstall(g),i.push(g);this.location?s.log((0,c.localize)(22,null,o,this.location)):s.log((0,c.localize)(23,null,o))}}async locateExtension(f,r=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===F.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};y=ue([fe(0,d.IExtensionManagementService),fe(1,d.IExtensionGalleryService)],y),t.ExtensionManagementCLIService=y}),define(Z[98],te([0,1,2,4,11,40]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class k extends T.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,F.MANIFEST_CACHE_FOLDER,F.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(d.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=k}),define(Z[99],te([0,1,33,88,26,28,8,10,29,71,128]),function(q,t,T,R,S,F,k,C,c,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function v(a,l,I){return l["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(I)&&!l["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(I)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=new Promise(async y=>{const b=new S.CancellationTokenSource,f=setTimeout(()=>{a.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),b.dispose(!0),y({})},1e4);try{const r=await L(a,b.token);y(r)}catch(r){(0,k.isPromiseCanceledError)(r)||a.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),y({})}finally{clearTimeout(f),b.dispose()}})),p)}t.resolveShellEnv=v;let p;async function L(a,l){const I=new Promise(async(y,b)=>{const f=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",f);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",r);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",i);const n=await(0,d.getSystemShell)(C.OS,i);if(a.trace("getUnixShellEnvironment#shell",n),l.isCancellationRequested)return b(k.canceled);const o=R.basename(n);let u,h;/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),u);const g=(0,T.spawn)(n,[...h,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});l.onCancellationRequested(()=>(g.kill(),b(k.canceled))),g.on("error",A=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,F.toErrorMessage)(A)),y({})});const N=[];g.stdout.on("data",A=>N.push(A));const P=[];g.stderr.on("data",A=>P.push(A)),g.on("close",(A,x)=>{const _=Buffer.concat(N).toString("utf8");a.trace("getUnixShellEnvironment#raw",_);const J=Buffer.concat(P).toString("utf8");if(J.trim()&&a.trace("getUnixShellEnvironment#stderr",J),A||x)return b(new Error(`Failed to get environment (code ${A}, signal ${x})`));const ie=e.exec(_),se=ie?ie[1]:"{}";try{const Y=JSON.parse(se);f?Y.ELECTRON_RUN_AS_NODE=f:delete Y.ELECTRON_RUN_AS_NODE,r?Y.ELECTRON_NO_ATTACH_CONSOLE=r:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",Y),y(Y)}catch(Y){a.error("getUnixShellEnvironment#errorCaught",(0,F.toErrorMessage)(Y)),b(Y)}})});try{return await I}catch(y){return a.error("getUnixShellEnvironment#error",(0,F.toErrorMessage)(y)),{}}}}),define(Z[51],te([0,1,10,7,17]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function F(c){return c.map(d=>({type:d.type,resource:R.URI.file(d.path)}))}t.toFileChanges=F;function k(c){const d=new C;for(const m of c)d.processEvent(m);return d.normalize()}t.normalizeFileChanges=k;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const m=this.mapPathToChange.get(d.path);if(m){const v=m.type,p=d.type;v===1&&p===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(m),1)):v===2&&p===1?m.type=0:v===1&&p===0||(m.type=p)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],m=[];return this.normalized.filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,p)=>v.path.length-p.path.length).filter(v=>m.some(p=>(0,S.isParent)(v.path,p,!T.isLinux))?!1:(m.push(v.path),!0)).concat(d)}}}),define(Z[100],te([0,1,3,2,4,63,11,65,51]),function(q,t,T,R,S,F,k,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends R.Disposable{constructor(v,p,L,a){super();this.path=v,this.onDidFilesChange=p,this.onLogMessage=L,this.verboseLogging=a,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:p}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let L=this.path;if(p)try{L=await(0,F.realpath)(L)}catch(a){if(this.onError(a),p.dangling)return}v.isDirectory()?this._register((0,C.watchFolder)(L,(a,l)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(l))})},a=>this.onError(a))):this._register((0,C.watchFile)(L,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const L=(0,c.normalizeFileChanges)(p);if(this.verboseLogging)for(const a of L)this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);L.length>0&&this.onDidFilesChange(L)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Z[52],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...S){this._entries=new Map;for(let[F,k]of S)this.set(F,k)}set(S,F){const k=this._entries.get(S);return this._entries.set(S,F),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=T}),define(Z[101],te([0,1,3,8,50,95,12,52]),function(q,t,T,R,S,F,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class m{constructor(a=new C.ServiceCollection,l=!1,I){this._activeInstantiations=new Set,this._services=a,this._strict=l,this._parent=I,this._services.set(k.IInstantiationService,this)}createChild(a){return new m(a,this._strict,this)}invokeFunction(a,...l){let I=p.traceInvocation(a),y=!1;try{return a({get:(f,r)=>{if(y)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,I);if(!s&&r!==k.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...l)}finally{y=!0,I.stop()}}createInstance(a,...l){let I,y;return a instanceof S.SyncDescriptor?(I=p.traceCreation(a.ctor),y=this._createInstance(a.ctor,a.staticArguments.concat(l),I)):(I=p.traceCreation(a),y=this._createInstance(a,l,I)),I.stop(),y}_createInstance(a,l=[],I){let y=k._util.getServiceDependencies(a).sort((r,s)=>r.index-s.index),b=[];for(const r of y){let s=this._getOrCreateServiceInstance(r.id,I);if(!s&&this._strict&&!r.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${r.id}.`);b.push(s)}let f=y.length>0?y[0].index:l.length;if(l.length!==f){console.warn(`[createInstance] First service dependency of ${a.name} at position ${f+1} conflicts with ${l.length} static arguments`);let r=f-l.length;r>0?l=l.concat(new Array(r)):l=l.slice(0,f)}return new a(...[...l,...b])}_setServiceInstance(a,l){if(this._services.get(a)instanceof S.SyncDescriptor)this._services.set(a,l);else if(this._parent)this._parent._setServiceInstance(a,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let l=this._services.get(a);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):l}_getOrCreateServiceInstance(a,l){let I=this._getServiceInstanceOrDescriptor(a);return I instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,I,l.branch(a,!0)):(l.branch(a,!1),I)}_safeCreateAndCacheServiceInstance(a,l,I){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,l,I)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,l,I){const y=new F.Graph(r=>r.id.toString());let b=0;const f=[{id:a,desc:l,_trace:I}];for(;f.length;){const r=f.pop();if(y.lookupOrInsertNode(r),b++>1e3)throw new d(y);for(let s of k._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const i={id:s.id,desc:e,_trace:r._trace.branch(s.id,!0)};y.insertEdge(r,i),f.push(i)}}}for(;;){const r=y.roots();if(r.length===0){if(!y.isEmpty())throw new d(y);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}y.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,l,I=[],y,b){if(this._services.get(a)instanceof S.SyncDescriptor)return this._createServiceInstance(l,I,y,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,l,I,y,b);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(a,l=[],I,y){if(I){const b=new T.IdleValue(()=>this._createInstance(a,l,y));return new Proxy(Object.create(null),{get(f,r){if(r in f)return f[r];let s=b.value,e=s[r];return typeof e!="function"||(e=e.bind(s),f[r]=e),e},set(f,r,s){return b.value[r]=s,!0}})}else return this._createInstance(a,l,y)}}t.InstantiationService=m;var v;(function(L){L[L.Creation=0]="Creation",L[L.Invocation=1]="Invocation",L[L.Branch=2]="Branch"})(v||(v={}));class p{constructor(a,l){this.type=a,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return c?new p(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(a){return c?new p(0,a.name):p._None}branch(a,l){let I=new p(2,a.toString());return this._dep.push([a,l,I]),I}stop(){let a=Date.now()-this._start;p._totals+=a;let l=!1;function I(b,f){let r=[],s=new Array(b+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){l=!0,r.push(`${s}CREATES -> ${e}`);let o=I(b+1,n);o&&r.push(o)}else r.push(`${s}uses -> ${e}`);return r.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(a>2||l)&&console.log(y.join(`
`))}}p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(Z[53],te([0,1,12]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function R(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const F of S.translations)if(typeof F.id!="string"||typeof F.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=R}),define(Z[15],te([0,1,28,14,2,10,12]),function(q,t,T,R,S,F,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,k.createDecorator)("logService"),t.ILoggerService=(0,k.createDecorator)("loggerService");function C(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class d extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class m extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let o=e[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}i+=(n>0?" ":"")+o}return i}}t.AbstractMessageLogger=m;class v extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!F.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,e,...i):console.warn(`[main ${C()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class p extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=p;class L extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=L;class a extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class l extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=l;class I extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=I;class y{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=y;function b(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=b;function f(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=f;function r(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=r}),define(Z[102],te([0,1,3,8,2,10,20,41,7,29,11,21,22,23,17,15]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let y=class extends S.Disposable{constructor(f,r,s,e){super();this.fileService=r,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=c.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,r){await this.cleanUpPromise;const s=this.getName(f),e=(0,k.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){}async rename(f,r,s){try{await m.Promises.rename(f.fsPath,r.fsPath)}catch(e){if(F.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${r} with 'EPERM' error. Trying again...`),this.rename(f,r,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const r=[],s=[];for(const n of f.children){const o=this.parse(n.name);o&&s.push([o,n])}const e=(0,L.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((o,u)=>C.rcompare(o[0].version,u[0].version)),r.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new L.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,d.generateUuid)()}parse(f){const r=I.exec(f);return r&&r[1]&&r[2]?new L.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};y=ue([fe(0,v.INativeEnvironmentService),fe(1,a.IFileService),fe(2,p.IExtensionGalleryService),fe(3,l.ILogService)],y),t.ExtensionsDownloader=y}),define(Z[103],te([0,1,33,3,28,14,2,9,4,11,21,15]),function(q,t,T,R,S,F,k,C,c,d,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let p=class extends k.Disposable{constructor(a,l){super();this.environmentService=a,this.logService=l,this.processesLimiter=new R.Limiter(5)}async postUninstall(a){const l=this.parseScript(a,"uninstall");return l&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(l.script,"uninstall",l.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${I}`)))),d.Promises.rm(this.getExtensionStoragePath(a)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(a,l){const I=`vscode:${l}`;if(a.location.scheme===C.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[I]=="string"){const y=a.manifest.scripts[I].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${I} should be a node script`),null):{script:(0,c.join)(a.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(a,l,I,y,b){return new Promise((f,r)=>{const s=this.start(a,l,I,b);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):f(void 0)};s.on("error",n=>{i((0,S.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,o)=>{i(n?`post-${l} process exited with code ${n}`:void 0)}),y&&(e=setTimeout(()=>{e=null,s.kill(),r("timed out")},5e3))})}start(a,l,I,y){const b={silent:!0,execArgv:void 0},f=(0,T.fork)(a,[`--type=extension-post-${l}`,...I],b);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const r=F.Event.fromNodeEventEmitter(f.stdout,"data"),s=F.Event.fromNodeEventEmitter(f.stderr,"data");r(n=>this.logService.info(y.identifier.id,y.manifest.version,`post-${l}`,n)),s(n=>this.logService.error(y.identifier.id,y.manifest.version,`post-${l}`,n));const e=F.Event.any(F.Event.map(r,n=>({data:`%c${n}`,format:[""]})),F.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return F.Event.debounce(e,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(y.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(a){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};p=ue([fe(0,m.IEnvironmentService),fe(1,v.ILogService)],p),t.ExtensionsLifecycle=p}),define(Z[104],te([0,1,14,2,20,7,21,23,17,15]),function(q,t,T,R,S,F,k,C,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let m=class extends R.Disposable{constructor(p,L,a,l){super();this.extensionsManagementService=p,this.logService=l,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(b=>this.onInstallExtension(b))),this._register(p.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(p.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const I=F.URI.file(a.extensionsPath),y=new S.ExtUri(b=>!L.hasCapability(b,1024));this._register(L.watch(I)),this._register(T.Event.filter(L.onDidChangeFilesRaw,b=>b.changes.some(f=>this.doesChangeAffects(f,I,y)))(()=>this.onDidChange()))}doesChangeAffects(p,L,a){return a.isEqual(a.dirname(p.resource),L)?a.isEqual(p.resource,a.joinPath(L,".obsolete"))?!0:!(p.type!==1&&p.type!==2||a.basename(p.resource).startsWith(".")):!1}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const L of p)this.removeInstallingExtension(L.identifier),L.local&&this.addInstalledExtension(L.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(L=>!(0,C.areSameExtensions)(L,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(L=>!(0,C.areSameExtensions)(L,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(1),L=p.filter(l=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,C.areSameExtensions)(I,l.identifier))?!1:l.installedTimestamp&&l.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",l.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",l.identifier.id),!1)),a=this.installedExtensions.filter(l=>this.installingExtensions.some(I=>(0,C.areSameExtensions)(I,l))?!1:p.every(I=>!(0,C.areSameExtensions)(I.identifier,l))?(this.logService.info("Detected extension removed from another source",l.id),!0):!1);this.installedExtensions=p.map(l=>l.identifier),(L.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:L,removed:a})}}};m=ue([fe(1,c.IFileService),fe(2,k.INativeEnvironmentService),fe(3,d.ILogService)],m),t.ExtensionsWatcher=m}),define(Z[105],te([0,1,129,24,3,2,9,4,11,21,22,23,53,15]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let a=class extends F.Disposable{constructor(y,b,f){super();this.extensionManagementService=y,this.logService=f,this.cache=this._register(new l(b,f)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getLanguageIds(){const y=await this.cache.getLanguagePacks(),b=["en",...Object.keys(y)];return(0,R.distinct)(b)}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const b=await this.cache.getLanguagePacks();Object.keys(b).some(f=>b[f]&&b[f].extensions.some(r=>(0,v.areSameExtensions)(r.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,b]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(b);return!(0,R.equals)(Object.keys(y),Object.keys(f))}};a=ue([fe(0,m.IExtensionManagementService),fe(1,d.INativeEnvironmentService),fe(2,L.ILogService)],a),t.LocalizationsService=a;let l=class extends F.Disposable{constructor(y,b){super();this.logService=b,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(b=>{Object.keys(b).forEach(f=>delete b[f]),this.createLanguagePacksFromExtensions(b,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...b){for(const f of b)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,f);Object.keys(y).forEach(f=>this.updateHash(y[f]))}createLanguagePacksFromExtension(y,b){const f=b.identifier,r=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const s of r)if(b.location.scheme===k.Schemas.file&&(0,p.isValidLocalization)(s)){let e=y[s.languageId];e||(e={hash:"",extensions:[],translations:{}},y[s.languageId]=e);let i=e.extensions.filter(n=>(0,v.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=b.manifest.version:e.extensions.push({extensionIdentifier:f,version:b.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,C.join)(b.location.fsPath,n.path)}}updateHash(y){if(y){const b=(0,T.createHash)("md5");for(const f of y.extensions)b.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);y.hash=b.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let b=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(r){return{}}}).then(f=>(b=y(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),c.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>b,f=>this.logService.error(f))})}};l=ue([fe(0,d.INativeEnvironmentService),fe(1,L.ILogService)],l)}),define(Z[106],te([0,1,17,15]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(c,d,m,v){try{const p=await new Promise((L,a)=>{q(["spdlog"],L,a)});return p.setFlushOn(R.LogLevel.Trace),p.createAsyncRotatingLogger(c,d,m,v)}catch(p){console.error(p)}return null}function F(c,d,m,v){const p=q.__$__nodeRequire("spdlog");return p.setFlushOn(R.LogLevel.Trace),p.createRotatingLogger(c,d,m,v)}t.createRotatingLogger=F;function k(c,d,m){switch(d){case R.LogLevel.Trace:c.trace(m);break;case R.LogLevel.Debug:c.debug(m);break;case R.LogLevel.Info:c.info(m);break;case R.LogLevel.Warning:c.warn(m);break;case R.LogLevel.Error:c.error(m);break;case R.LogLevel.Critical:c.critical(m);break;default:throw new Error("Invalid log level")}}class C extends R.AbstractMessageLogger{constructor(d,m,v,p){super();this.name=d,this.filepath=m,this.rotating=v,this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(L=>{this._logger&&this._logger.setLevel(L)}))}_createSpdLogLogger(){const d=this.rotating?6:1,m=30/d*T.ByteSize.MB;return S(this.name,this.filepath,m,d).then(v=>{if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:p,message:L}of this.buffer)k(this._logger,p,L);this.buffer=[]}})}log(d,m){this._logger?k(this._logger,d,m):this.getLevel()<=d&&this.buffer.push({level:d,message:m})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=C}),define(Z[54],te([0,1,16,8,82,17,35]),function(q,t,T,R,S,F,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(v,p,L,a,l,I){let y;try{await c(v,p,L,a,l,I)}catch(b){y=b}finally{y&&l.errorTransformer&&(y=l.errorTransformer(y)),typeof y!="undefined"&&L.error(y),L.end()}}t.readFileIntoStream=C;async function c(v,p,L,a,l,I){d(I);const y=await v.open(p,{create:!1});try{d(I);let b=0,f=0,r=l&&typeof l.length=="number"?l.length:void 0,s=T.VSBuffer.alloc(Math.min(l.bufferSize,typeof r=="number"?r:l.bufferSize)),e=l&&typeof l.position=="number"?l.position:0,i=0;do f=await v.read(y,e,s.buffer,i,s.byteLength-i),e+=f,i+=f,b+=f,typeof r=="number"&&(r-=f),i===s.byteLength&&(await L.write(a(s)),s=T.VSBuffer.alloc(Math.min(l.bufferSize,typeof r=="number"?r:l.bufferSize)),i=0);while(f>0&&(typeof r!="number"||r>0)&&d(I)&&m(b,l));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),L.write(a(s.slice(0,n)))}}catch(b){throw(0,F.ensureFileSystemProviderError)(b)}finally{await v.close(y)}}function d(v){if(v.isCancellationRequested)throw(0,R.canceled)();return!0}function m(v,p){if(p?.limits){if(typeof p.limits.memory=="number"&&v>p.limits.memory)throw(0,F.createFileSystemProviderError)((0,S.localize)(0,null,k.default.nameShort),F.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&v>p.limits.size)throw(0,F.createFileSystemProviderError)((0,S.localize)(1,null),F.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[107],te([0,1,24,3,16,26,14,130,2,45,9,131,20,37,81,17,54,15]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l,I,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let b=class Ne extends c.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new l.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new l.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(r,s){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:s});const e=new c.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:r}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:s}),this.provider.delete(r),(0,c.dispose)(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){s.push(e)}}),!this.provider.has(r)&&await R.Promises.settled(s)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,s){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return C.Iterable.map(this.provider,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async withProvider(r){if(!(0,p.isAbsolutePath)(r))throw new l.FileOperationError((0,a.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const s=this.provider.get(r.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,a.localize)(1,null,r.toString()),e}return s}async withReadProvider(r){const s=await this.withProvider(r);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s)||(0,l.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const s=await this.withProvider(r);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.doResolveFile(r,s)}catch(e){throw(0,l.toFileSystemProviderErrorCode)(e)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,a.localize)(2,null,this.resourceForError(r)),1):(0,l.ensureFileSystemProviderError)(e)}}async doResolveFile(r,s){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,u=s?.resolveMetadata,h=await e.stat(r);let g;return this.toFileStat(e,r,h,void 0,!!u,(N,P)=>(g||(g=d.TernarySearchTree.forUris(()=>!i),g.set(r,!0),(0,T.isNonEmptyArray)(n)&&n.forEach(A=>g.set(A,!0))),Boolean(g.findSuperstr(N.resource)||g.get(N.resource))?!0:N.isDirectory&&o?P===1:!1))}async toFileStat(r,s,e,i,n,o){const{providerExtUri:u}=this.getExtUri(r),h={resource:s,name:u.basename(s),isFile:(e.type&l.FileType.File)!=0,isDirectory:(e.type&l.FileType.Directory)!=0,isSymbolicLink:(e.type&l.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&l.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,l.etag)({mtime:e.mtime,size:e.size})};if(h.isDirectory&&o(h,i)){try{const g=await r.readdir(s),N=await R.Promises.settled(g.map(async([P,A])=>{try{const x=u.joinPath(s,P),_=n?await r.stat(x):{type:A};return await this.toFileStat(r,x,_,g.length,n,o)}catch(x){return this.logService.trace(x),null}}));h.children=(0,T.coalesce)(N)}catch(g){this.logService.trace(g),h.children=[]}return h}return h}async resolveAll(r){return R.Promises.settled(r.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const s=await this.withProvider(r);try{return!!await s.stat(r)}catch(e){return!1}}async canCreateFile(r,s){try{await this.doValidateCreateFile(r,s)}catch(e){return e}return!0}async doValidateCreateFile(r,s){if(!s?.overwrite&&await this.exists(r))throw new l.FileOperationError((0,a.localize)(3,null,this.resourceForError(r)),3,s)}async createFile(r,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,s);return this._onDidRunOperation.fire(new l.FileOperationEvent(r,0,i)),i}async writeFile(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let u;if((0,l.hasReadWriteCapability)(i)&&!(s instanceof S.VSBuffer))if((0,L.isReadableStream)(s)){const h=await(0,L.peekStream)(s,3);h.ended?u=S.VSBuffer.concat(h.buffer):u=h}else u=(0,L.peekReadable)(s,h=>S.VSBuffer.concat(h),3);else u=s;!(0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasReadWriteCapability)(i)&&u instanceof S.VSBuffer?await this.doWriteUnbuffered(i,r,e,u):await this.doWriteBuffered(i,r,e,u instanceof S.VSBuffer?(0,S.bufferToReadable)(u):u)}catch(o){throw new l.FileOperationError((0,a.localize)(4,null,this.resourceForError(r),(0,l.ensureFileSystemProviderError)(o).toString()),(0,l.toFileOperationResult)(o),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,s,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error((0,a.localize)(5,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch(o){return}if((n.type&l.FileType.Directory)!=0)throw new l.FileOperationError((0,a.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==l.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,l.etag)({mtime:e.mtime,size:n.size}))throw new l.FileOperationError((0,a.localize)(7,null),3,e);return n}async readFile(r,s){const e=await this.withReadProvider(r);return s?.atomic?this.doReadFileAtomic(e,r,s):this.doReadFile(e,r,s)}async doReadFileAtomic(r,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(r,s,e);i(o)}catch(o){n(o)}})})}async doReadFile(r,s,e){const i=await this.doReadFileStream(r,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,S.streamToBuffer)(i.value)}}async readFileStream(r,s){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,s)}async doReadFileStream(r,s,e){const i=new F.CancellationTokenSource,n=this.validateReadFile(s,e).then(u=>u,u=>{throw i.cancel(),u});let o;try{return e&&typeof e.etag=="string"&&e.etag!==l.ETAG_DISABLED&&await n,!((0,l.hasOpenReadWriteCloseCapability)(r)||(0,l.hasFileReadStreamCapability)(r))||(0,l.hasReadWriteCapability)(r)&&e?.preferUnbuffered?o=this.readFileUnbuffered(r,s,e):(0,l.hasFileReadStreamCapability)(r)?o=this.readFileStreamed(r,s,i.token,e):o=this.readFileBuffered(r,s,i.token,e),{...await n,value:o}}catch(u){o&&await(0,L.consumeStream)(o);const h=(0,a.localize)(8,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(u).toString());throw u instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(h,u.stat,e):new l.FileOperationError(h,(0,l.toFileOperationResult)(u),e)}}readFileStreamed(r,s,e,i=Object.create(null)){const n=r.readFileStream(s,i,e);return(0,L.transform)(n,{data:o=>o instanceof S.VSBuffer?o:S.VSBuffer.wrap(o),error:o=>new l.FileOperationError((0,a.localize)(9,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(o).toString()),(0,l.toFileOperationResult)(o),i)},o=>S.VSBuffer.concat(o))}readFileBuffered(r,s,e,i=Object.create(null)){const n=(0,S.newWriteableBufferStream)();return(0,I.readFileIntoStream)(r,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new l.FileOperationError((0,a.localize)(10,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(o).toString()),(0,l.toFileOperationResult)(o),i)},e),n}readFileUnbuffered(r,s,e){const i=(0,L.newWriteableStream)(n=>S.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(s);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(S.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,s){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new l.FileOperationError((0,a.localize)(11,null,this.resourceForError(r)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==l.ETAG_DISABLED&&s.etag===e.etag)throw new l.NotModifiedSinceFileOperationError((0,a.localize)(12,null),e,s);return this.validateReadFileLimits(r,e.size,s),e}validateReadFileLimits(r,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new l.FileOperationError((0,a.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,s,e){return this.doCanMoveCopy(r,s,"move",e)}async canCopy(r,s,e){return this.doCanMoveCopy(r,s,"copy",e)}async doCanMoveCopy(r,s,e,i){if(r.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,r,o,s,e,i)}catch(n){return n}return!0}async move(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"move",!!e),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(r,o==="move"?2:3,u)),u}async copy(r,s,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"copy",!!e),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(r,o==="copy"?3:2,u)),u}async doMoveCopy(r,s,e,i,n,o){if(s.toString()===i.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(r,s,e,i,n,o);if(u&&!h&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&(0,l.hasFileFolderCopyCapability)(r))await r.copy(s,i,{overwrite:o});else{const g=await this.resolve(s);g.isDirectory?await this.doCopyFolder(r,g,e,i):await this.doCopyFile(r,s,e,i)}return n}else return r===e?(await r.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(r,s,e,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(r,s,e,i){if((0,l.hasOpenReadWriteCloseCapability)(r)&&(0,l.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(r,s,e,i);if((0,l.hasOpenReadWriteCloseCapability)(r)&&(0,l.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(r,s,e,i);if((0,l.hasReadWriteCapability)(r)&&(0,l.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(r,s,e,i);if((0,l.hasReadWriteCapability)(r)&&(0,l.hasReadWriteCapability)(e))return this.doPipeUnbuffered(r,s,e,i)}async doCopyFolder(r,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,o):this.doCopyFile(r,n.resource,e,o)}))}async doValidateMoveCopy(r,s,e,i,n,o){let u=!1;if(r===e){const{providerExtUri:g,isPathCaseSensitive:N}=this.getExtUri(r);if(N||(u=g.isEqual(s,i)),u&&n==="copy")throw new Error((0,a.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!u&&g.isEqualOrParent(i,s))throw new Error((0,a.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const h=await this.exists(i);if(h&&!u){if(!o)throw new l.FileOperationError((0,a.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(r===e){const{providerExtUri:g}=this.getExtUri(r);if(g.isEqualOrParent(s,i))throw new Error((0,a.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:h,isSameResourceWithDifferentPathCase:u}}getExtUri(r){const s=this.isPathCaseSensitive(r);return{providerExtUri:s?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(s,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(r,0,e)),e}async mkdirp(r,s){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(s,i.dirname(s));)try{if(((await r.stat(s)).type&l.FileType.Directory)==0)throw new Error((0,a.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,l.toFileSystemProviderErrorCode)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await r.mkdir(s)}catch(o){if((0,l.toFileSystemProviderErrorCode)(o)!==l.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(r,s){try{await this.doValidateDelete(r,s)}catch(e){return e}return!0}async doValidateDelete(r,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,a.localize)(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(u){}if(n)this.throwIfFileIsReadonly(r,n);else throw new l.FileOperationError((0,a.localize)(20,null,this.resourceForError(r)),1);if(!!!s?.recursive){const u=await this.resolve(r);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,a.localize)(21,null,this.resourceForError(r)))}return e}async del(r,s){const e=await this.doValidateDelete(r,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new l.FileOperationEvent(r,1))}onDidChangeFile(r,s){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new l.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,s={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,c.toDisposable)(()=>n())),this.doWatch(r,s).then(o=>{i?(0,c.dispose)(o):n=()=>(0,c.dispose)(o)},o=>this.logService.error(o))}return s.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add((0,c.toDisposable)(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,s){const e=await this.withProvider(r),i=this.toWatchKey(e,r,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,c.toDisposable)(()=>{n.count--,n.count===0&&((0,c.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,s,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,c.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,L.isReadableStream)(i)||(0,L.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(o){throw(0,l.ensureFileSystemProviderError)(o)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,s,e){let i=0,n;if((0,L.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,s,o,o.byteLength,i,0),i+=o.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(o,u)=>{(0,L.listenStream)(n,{onData:async h=>{n.pause();try{await this.doWriteBuffer(r,s,h,h.byteLength,i,0)}catch(g){return u(g)}i+=h.byteLength,setTimeout(()=>n.resume())},onError:h=>u(h),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(r,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,s,e,i,n,o){let u=0;for(;u<i;)u+=await r.write(s,n+u,e.buffer,o+u,i-u)}async doWriteUnbuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,s,e,i))}async doWriteUnbufferedQueued(r,s,e,i){let n;i instanceof S.VSBuffer?n=i:(0,L.isReadableStream)(i)?n=await(0,S.streamToBuffer)(i):(0,L.isReadableBufferedStream)(i)?n=await(0,S.bufferedStreamToBuffer)(i):n=(0,S.readableToBuffer)(i),await r.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,s,e,i))}async doPipeBufferedQueued(r,s,e,i){let n,o;try{n=await r.open(s,{create:!1}),o=await e.open(i,{create:!0,unlock:!1});const u=S.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,g=0,N=0;do N=await r.read(n,h,u.buffer,g,u.byteLength-g),await this.doWriteBuffer(e,o,u,N,h,g),h+=N,g+=N,g===u.byteLength&&(g=0);while(N>0)}catch(u){throw(0,l.ensureFileSystemProviderError)(u)}finally{await R.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,s,e,i))}async doPipeUnbufferedQueued(r,s,e,i){return e.writeFile(i,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,s,e,i))}async doPipeUnbufferedToBufferedQueued(r,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const o=await r.readFile(s);await this.doWriteBuffer(e,n,S.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,l.ensureFileSystemProviderError)(o)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,s,e,i){const n=await(0,S.streamToBuffer)(this.readFileBuffered(r,s,F.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,s){if(r.capabilities&2048)throw new l.FileOperationError((0,a.localize)(22,null,this.resourceForError(s)),6);return r}throwIfFileIsReadonly(r,s){if((s.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,a.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===m.Schemas.file?r.fsPath:r.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=ue([fe(0,y.ILogService)],b),t.FileService=b}),define(Z[108],te([0,1,24,3,16,14,31,2,4,10,20,37,11,83,17,54,100,91,92,51,94,15]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l,I,y,b,f,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends C.Disposable{constructor(n,o){super();this.logService=n,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=F.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new F.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new F.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:u}=await p.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,u),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await p.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(o.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,m.joinPath)(n,h.name))).type:g=this.toType(h),u.push([h.name,g])}catch(g){this.logService.trace(g)}})),u}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let u;return o?.dangling?u=a.FileType.Unknown:n.isFile()?u=a.FileType.File:n.isDirectory()?u=a.FileType.Directory:u=a.FileType.Unknown,o&&(u|=a.FileType.SymbolicLink),u}async readFile(n){try{const o=this.toFilePath(n);return await p.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(n,o,u){const h=(0,v.newWriteableStream)(g=>S.VSBuffer.concat(g.map(N=>S.VSBuffer.wrap(N))).buffer);return(0,l.readFileIntoStream)(this,n,h,g=>g.buffer,{...o,bufferSize:this.BUFFER_SIZE},u),h}async writeFile(n,o,u){let h;try{const g=this.toFilePath(n);if(!u.create||!u.overwrite){if(await p.Promises.exists(g)){if(!u.overwrite)throw(0,a.createFileSystemProviderError)((0,L.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,a.createFileSystemProviderError)((0,L.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(g){throw await this.toFileSystemProviderWriteError(n,g)}finally{typeof h=="number"&&await this.close(h)}}async open(n,o){try{const u=this.toFilePath(n);if((0,a.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:N}=await p.SymlinkSupport.stat(u);N.mode&128||await p.Promises.chmod(u,N.mode|128)}catch(N){this.logService.trace(N)}let h;if((0,a.isFileOpenForWriteOptions)(o)){if(d.isWindows)try{await p.Promises.truncate(u,0),h="r+"}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}h||(h="w")}else h="r";const g=await p.Promises.open(u,h);return this.mapHandleToPos.set(g,0),(0,a.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(g,n),g}catch(u){throw(0,a.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await p.Promises.fdatasync(n)}catch(o){this.canFlush=!1,this.logService.error(o)}return await p.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}}async read(n,o,u,h,g){const N=this.normalizePos(n,o);let P=null;try{const A=await p.Promises.read(n,u,h,g,N);return typeof A=="number"?P=A:P=A.bytesRead,P}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,N,P)}}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,u){const h=this.mapHandleToPos.get(n);typeof h=="number"&&(typeof o=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,h+u):this.mapHandleToPos.delete(n)))}async write(n,o,u,h,g){return(0,R.retry)(()=>this.doWrite(n,o,u,h,g),100,3)}async doWrite(n,o,u,h,g){const N=this.normalizePos(n,o);let P=null;try{const A=await p.Promises.write(n,u,h,g,N);return typeof A=="number"?P=A:P=A.bytesWritten,P}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),A)}finally{this.updatePos(n,N,P)}}async mkdir(n){try{await p.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const u=this.toFilePath(n);await this.doDelete(u,o)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,o){o.recursive?await p.Promises.rm(n,p.RimRafMode.MOVE):await p.Promises.unlink(n)}async rename(n,o,u){const h=this.toFilePath(n),g=this.toFilePath(o);if(h!==g)try{await this.validateTargetDeleted(n,o,"move",u.overwrite),await p.Promises.move(h,g)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,L.localize)(2,null,(0,c.basename)(h),(0,c.basename)((0,c.dirname)(g)),N.toString()))),this.toFileSystemProviderError(N)}}async copy(n,o,u){const h=this.toFilePath(n),g=this.toFilePath(o);if(h!==g)try{await this.validateTargetDeleted(n,o,"copy",u.overwrite),await p.Promises.copy(h,g,{preserveSymlinks:!0})}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,L.localize)(3,null,(0,c.basename)(h),(0,c.basename)((0,c.dirname)(g)),N.toString()))),this.toFileSystemProviderError(N)}}async validateTargetDeleted(n,o,u,h){const g=this.toFilePath(n),N=this.toFilePath(o);let P=!1;if(!!(this.capabilities&1024)||(P=(0,k.isEqual)(g,N,!0)),P&&u==="copy")throw(0,a.createFileSystemProviderError)((0,L.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!P&&await p.Promises.exists(N)){if(!h)throw(0,a.createFileSystemProviderError)((0,L.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(n,o){return o.recursive?this.watchRecursive(n,o.excludes):this.watchNonRecursive(n)}watchRecursive(n,o){const u={path:this.toFilePath(n),excludes:o},h=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,o;this.options?.watcher?.usePolling?(n=b.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?d.isWindows?n=r.FileWatcher:n=b.FileWatcher:n=y.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,f.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===s.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(n){const o=new I.FileWatcher(this.toFilePath(n),h=>this._onDidChangeFile.fire((0,f.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===s.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,C.combinedDisposable)(o,u)}toFilePath(n){return(0,c.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof a.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=a.FileSystemProviderErrorCode.NoPermissions;break;default:o=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let u=this.toFileSystemProviderError(o);if(n&&u.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await p.SymlinkSupport.stat(this.toFilePath(n));h.mode&128||(u=(0,a.createFileSystemProviderError)(o,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return u}dispose(){super.dispose(),(0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,C.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Z[42],te([0,1,12]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(Z[25],te([0,1,57,13]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(k,C){T.ok(R.isString(k)),T.ok(R.isObject(C)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,C)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}t.Registry=new S}),define(Z[109],te([0,1,14,25]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class F{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[S(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new F;R.Registry.add(t.Extensions.JSONContribution,k)}),define(Z[30],te([0,1,14,13,73,109,25]),function(q,t,T,R,S,F,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var C;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(C=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=k.Registry.as(F.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,f=!0){this.registerConfigurations([b],f)}registerConfigurations(b,f=!0){const r=[];b.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,f,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(b){const f=[],r=s=>{if(s.properties)for(const e in s.properties)f.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>r(e))};for(const s of b){r(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(b){const f=[],r=[];for(const s of b)for(const e in s)if(f.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const i={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(p(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=s[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(b){const f=[];for(const r of b)for(const s in r)if(f.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const f of b)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,f=!0,r,s=3){s=R.isUndefinedOrNull(b.scope)?s:b.scope;let e=[],i=b.properties;if(i)for(let o in i){if(f&&l(o)){delete i[o];continue}const u=i[o];if(this.updatePropertyDefaultValue(o,u),t.OVERRIDE_PROPERTY_PATTERN.test(o)?u.scope=void 0:(u.scope=R.isUndefinedOrNull(u.scope)?s:u.scope,u.restricted=R.isUndefinedOrNull(u.restricted)?!!r?.restrictedConfigurations?.includes(o):u.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),e.push(o)}let n=b.allOf;if(n)for(let o of n)e.push(...this.validateAndRegisterProperties(o,f,r,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const f=r=>{let s=r.properties;if(s)for(const i in s)this.updateSchema(i,s[i]);let e=r.allOf;e&&e.forEach(f)};f(b)}updateSchema(b,f){switch(t.allSettings.properties[b]=f,f.scope){case 1:t.applicationSettings.properties[b]=f;break;case 2:t.machineSettings.properties[b]=f;break;case 6:t.machineOverridableSettings.properties[b]=f;break;case 3:t.windowSettings.properties[b]=f;break;case 4:t.resourceSettings.properties[b]=f;break;case 5:t.resourceSettings.properties[b]=f,this.resourceLanguageSettingsSchema.properties[b]=f;break}}removeFromSchema(b,f){switch(delete t.allSettings.properties[b],f.scope){case 1:delete t.applicationSettings.properties[b];break;case 2:delete t.machineSettings.properties[b];break;case 6:delete t.machineOverridableSettings.properties[b];break;case 3:delete t.windowSettings.properties[b];break;case 4:case 5:delete t.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const f=`[${b}]`,r={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,r),t.allSettings.properties[f]=r,t.applicationSettings.properties[f]=r,t.machineSettings.properties[f]=r,t.machineOverridableSettings.properties[f]=r,t.windowSettings.properties[f]=r,t.resourceSettings.properties[f]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,f){let r=this.defaultValues[b];R.isUndefined(r)&&(r=f.default),R.isUndefined(r)&&(r=L(f.type)),f.default=r}}const v="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function p(y){return y.substring(1,y.length-1)}t.overrideIdentifierFromKey=p;function L(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=L;const a=new m;k.Registry.add(t.Extensions.Configuration,a);function l(y){return y.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(y)?S.localize(5,null,y):a.getConfigurationProperties()[y]!==void 0?S.localize(6,null,y):null:S.localize(4,null)}t.validateProperty=l;function I(){const y=[],b=a.getConfigurationProperties();for(const f of Object.keys(b))y.push([f,b[f].scope]);return y.push(["launch",4]),y.push(["task",4]),y}t.getScopes=I}),define(Z[27],te([0,1,19,13,7,30,12,25]),function(q,t,T,R,S,F,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,k.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}t.isConfigurationOverrides=c;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function m(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=m;function v(i,n){const o=n?i?n.keys.filter(x=>i.keys.indexOf(x)===-1):[...n.keys]:[],u=i?n?i.keys.filter(x=>n.keys.indexOf(x)===-1):[...i.keys]:[],h=[];if(n&&i){for(const x of i.keys)if(n.keys.indexOf(x)!==-1){const _=y(i.contents,x),J=y(n.contents,x);T.equals(_,J)||h.push(x)}}const g=[],N=x=>{const _={};for(const J of x)for(const ie of J.identifiers)_[s(ie)]=J;return _},P=n?N(n.overrides):{},A=i?N(i.overrides):{};if(Object.keys(P).length)for(const x of o){const _=P[x];_&&g.push([(0,F.overrideIdentifierFromKey)(x),_.keys])}if(Object.keys(A).length)for(const x of u){const _=A[x];_&&g.push([(0,F.overrideIdentifierFromKey)(x),_.keys])}if(Object.keys(P).length&&Object.keys(A).length)for(const x of h){const _=A[x],J=P[x];if(_&&J){const ie=v({contents:_.contents,keys:_.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});g.push([(0,F.overrideIdentifierFromKey)(x),[...ie.added,...ie.removed,...ie.updated]])}}return{added:o,removed:u,updated:h,overrides:g}}t.compare=v;function p(i,n){const o=[];for(const u of Object.keys(i))if(F.OVERRIDE_PROPERTY_PATTERN.test(u)){const h={};for(const g in i[u])h[g]=i[u][g];o.push({identifiers:[(0,F.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(h),contents:L(h,n)})}return o}t.toOverrides=p;function L(i,n){const o=Object.create(null);for(let u in i)a(o,u,i[u],n);return o}t.toValuesTree=L;function a(i,n,o,u){const h=n.split("."),g=h.pop();let N=i;for(let P=0;P<h.length;P++){let A=h[P],x=N[A];switch(typeof x){case"undefined":x=N[A]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${h.slice(0,P+1).join(".")} is ${JSON.stringify(x)}`);return}N=x}if(typeof N=="object"&&N!==null)try{N[g]=o}catch(P){u(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(N)}`)}else u(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(N)}`)}t.addToValueTree=a;function l(i,n){const o=n.split(".");I(i,o)}t.removeFromValueTree=l;function I(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const u=i[o];typeof u=="object"&&!Array.isArray(u)&&(I(u,n),Object.keys(u).length===0&&delete i[o])}}function y(i,n,o){function u(N,P){let A=N;for(const x of P){if(typeof A!="object"||A===null)return;A=A[x]}return A}const h=n.split("."),g=u(i,h);return typeof g=="undefined"?o:g}t.getConfigurationValue=y;function b(i,n,o){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in i?R.isObject(i[u])&&R.isObject(n[u])?b(i[u],n[u],o):o&&(i[u]=n[u]):i[u]=n[u])})}t.merge=b;function f(){const i=C.Registry.as(F.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function r(){const i=Object.create(null),n=C.Registry.as(F.Extensions.Configuration).getConfigurationProperties();for(let o in n){let u=n[o].default;a(i,o,u,h=>console.error(`Conflict in default settings: ${h}`))}return i}t.getDefaultValues=r;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,o){const u=i.inspect(n),h=i.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:u.defaultValue}t.getMigratedSettingValue=e}),define(Z[110],te([0,1,24,14,58,2,45,19,13,7,27,30,25]),function(q,t,T,R,S,F,k,C,c,d,m,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class L{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,m.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,m.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[o],h=i[o];h&&(typeof u=="object"&&typeof h=="object"?(u=C.deepClone(u),this.mergeContents(u,h)):u=h),n[o]=u}return new L(n,this.keys,this.overrides)}merge(...e){const i=C.deepClone(this.contents),n=C.deepClone(this.overrides),o=[...this.keys];for(const u of e){this.mergeContents(i,u.contents);for(const h of u.overrides){const[g]=n.filter(N=>T.equals(N.identifiers,h.identifiers));g?this.mergeContents(g.contents,h.contents):n.push(C.deepClone(h))}for(const h of u.keys)o.indexOf(h)===-1&&o.push(h)}return new L(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&c.isObject(e[n])&&c.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=C.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?C.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,m.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,m.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=L;class a extends L{constructor(){const e=(0,m.getDefaultValues)(),i=(0,m.getConfigurationKeys)(),n=[];for(const o of Object.keys(e))v.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,v.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,m.toValuesTree)(e[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(e,i,n)}}t.DefaultConfigurationModel=a;class l{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new L}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!c.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:o,overrides:u,restricted:h}=this.doParseRaw(e,i);this._configurationModel=new L(n,o,u),this._restrictedConfigurations=h||[]}doParseContent(e){let i={},n=null,o=[],u=[],h=[];function g(P){Array.isArray(o)?o.push(P):n!==null&&(o[n]=P)}let N={onObjectBegin:()=>{let P={};g(P),u.push(o),o=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let P=[];g(P),u.push(o),o=P,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:g,onError:(P,A,x)=>{h.push({error:P,offset:A,length:x})}};if(e)try{S.visit(e,N),i=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(e,i){const n=p.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,n,!0,i);e=o.raw;const u=(0,m.toValuesTree)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`)),h=Object.keys(e),g=(0,m.toOverrides)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`));return{contents:u,keys:h,overrides:g,restricted:o.restricted}}filter(e,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:e,restricted:[]};const u={},h=[];for(let g in e)if(v.OVERRIDE_PROPERTY_PATTERN.test(g)&&n){const N=this.filter(e[g],i,!1,o);u[g]=N.raw,h.push(...N.restricted)}else{const N=i[g],P=N?typeof N.scope!="undefined"?N.scope:3:void 0;N?.restricted&&h.push(g),(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&(o.skipRestricted&&N?.restricted||(u[g]=e[g]))}return{raw:u,restricted:h}}}t.ConfigurationModelParser=l;class I extends F.Disposable{constructor(e,i,n,o){super();this.userSettingsResource=e,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new L}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=I;class y{constructor(e,i,n=new L,o=new L,u=new k.ResourceMap,h=new L,g=new k.ResourceMap,N=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new L,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(e):o.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const o=this.getConsolidateConfigurationModel(i,n),u=this.getFolderConfigurationModelForResource(i.resource,n),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,g=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),x=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,_=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,J=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(e):h.getValue(e),ie=o.getValue(e),se=T.distinct(T.flatten(o.overrides.map(Y=>Y.identifiers))).filter(Y=>o.getOverrideValue(e,Y)!==void 0);return{defaultValue:g,userValue:N,userLocalValue:P,userRemoteValue:A,workspaceValue:x,workspaceFolderValue:_,memoryValue:J,value:ie,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:N!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:u?.freeze().getValue(e),override:i.overrideIdentifier?u?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:h.getValue(e),override:i.overrideIdentifier?h.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(o=>v.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=(0,v.overrideIdentifierFromKey)(o),h=this._defaultConfiguration.getKeysForOverrideIdentifier(u),g=e.getKeysForOverrideIdentifier(u),N=[...g.filter(P=>h.indexOf(P)===-1),...h.filter(P=>g.indexOf(P)===-1),...h.filter(P=>!C.equals(this._defaultConfiguration.override(u).getValue(P),e.override(u).getValue(P)))];return[u,N]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:u}=(0,m.compare)(this.localUserConfiguration,e),h=[...i,...n,...o];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:u}=(0,m.compare)(this.remoteUserConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:o,overrides:u}=(0,m.compare)(this.workspaceConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:u}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:o,updated:u,removed:h,overrides:g}=(0,m.compare)(n,i);let N=[...o,...u,...h];return(N.length||!n)&&this.updateFolderConfiguration(e,i),{keys:N,overrides:g}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:o,removed:u,overrides:h}=(0,m.compare)(i,void 0);return{keys:[...n,...o,...u],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const o=i.getFolder(e);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const u=this._memoryConfigurationByResource.get(e);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:o,keys:u}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:o,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(o=>i.add(o))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((h,g)=>(h.set(d.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new k.ResourceMap);return new y(i,n,new L,o,u,new L,new k.ResourceMap,!1)}static parseConfigurationModel(e){return new L(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=y;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const o of s)o.keys.forEach(u=>e.add(u)),o.overrides.forEach(([u,h])=>{const g=(0,k.getOrSet)(i,u,new Set);h.forEach(N=>g.add(N))});const n=[];return i.forEach((o,u)=>n.push([u,[...o.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=b;class f{constructor(e,i,n,o){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(g=>u.add(g)),e.overrides.forEach(([,g])=>g.forEach(N=>u.add(N))),this.affectedKeys=[...u.values()];const h=new L;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!C.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,m.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(e=e[o],!e)return!1;n=n[o]}return!0}}t.ConfigurationChangeEvent=f;class r extends f{constructor(e,i,n,o){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=r}),define(Z[111],te([0,1,3,14,2,20,27,110,30,25]),function(q,t,T,R,S,F,k,C,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class m extends S.Disposable{constructor(p,L){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,F.extUriBiasedIgnorePathCase,L)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,L){const a=typeof p=="string"?p:void 0,l=(0,k.isConfigurationOverrides)(p)?p:(0,k.isConfigurationOverrides)(L)?L:{};return this.configuration.getValue(a,l,void 0)}updateValue(p,L,a,l){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const L=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(a,L,1)}onDidDefaultConfigurationChange(p){const L=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,p);this.trigger(a,L,6)}trigger(p,L,a){const l=new C.ConfigurationChangeEvent(p,{data:L},this.configuration);l.source=a,l.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(l)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=m}),define(Z[55],te([0,1,16,84,30,12,25]),function(q,t,T,R,S,F,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,F.createDecorator)("requestService");function C(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=C;function c(a){return a.res.statusCode===204}async function d(a){if(!C(a))throw new Error("Server returned "+a.res.statusCode);return c(a)?null:(await(0,T.streamToBuffer)(a.stream)).toString()}t.asText=d;async function m(a){if(!C(a))throw new Error("Server returned "+a.res.statusCode);if(c(a))return null;const I=(await(0,T.streamToBuffer)(a.stream)).toString();try{return JSON.parse(I)}catch(y){throw y.message+=`:
`+I,y}}t.asJson=m;function v(a){L(a)}t.updateProxyConfigurationsScope=v;let p;function L(a){const l=k.Registry.as(S.Extensions.Configuration);p&&l.deregisterConfigurations([p]),p={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},l.registerConfiguration(p)}L(2)}),define(Z[112],te([0,1,113,13]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(k,C){return k.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:k.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function F(k,C,c={}){const d=(0,T.parse)(k),m=c.proxyUrl||S(d,C);if(!m)return null;const v=(0,T.parse)(m);if(!/^https?:$/.test(v.protocol||""))return null;const p={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((L,a)=>{q(["http-proxy-agent"],L,a)}))(p):new(await new Promise((L,a)=>{q(["https-proxy-agent"],L,a)}))(p)}t.getProxyAgent=F}),define(Z[114],te([0,1,16,29]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(F,k,C){let c=C&&C.get("storage.serviceMachineId",0)||null;if(c)return c;try{const m=(await k.readFile(F.serviceMachineIdResource)).value.toString();c=(0,R.isUUID)(m)?m:null}catch(d){c=null}if(!c){c=(0,R.generateUuid)();try{await k.writeFile(F.serviceMachineIdResource,T.VSBuffer.fromString(c))}catch(d){}}return C&&C.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=S}),define(Z[115],te([0,1,3,14,2,13,66,12]),function(q,t,T,R,S,F,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,C.createDecorator)("storageService");var d;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var m;(function(l){l[l.GLOBAL=0]="GLOBAL",l[l.WORKSPACE=1]="WORKSPACE"})(m=t.StorageScope||(t.StorageScope={}));var v;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(v=t.StorageTarget||(t.StorageTarget={}));class p extends S.Disposable{constructor(I={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,y){y===c?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:y,target:this.getKeyTargets(I)[y]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,y,b){return this.getStorage(y)?.get(I,b)}getBoolean(I,y,b){return this.getStorage(y)?.getBoolean(I,b)}getNumber(I,y,b){return this.getStorage(y)?.getNumber(I,b)}store(I,y,b,f){if((0,F.isUndefinedOrNull)(y)){this.remove(I,b);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,b,f),this.getStorage(b)?.set(I,y)})}remove(I,y){this.withPausedEmitters(()=>{this.updateKeyTarget(I,y,void 0),this.getStorage(y)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,y){const b=[],f=this.getKeyTargets(I);for(const r of Object.keys(f))f[r]===y&&b.push(r);return b}updateKeyTarget(I,y,b){const f=this.getKeyTargets(y);typeof b=="number"?f[I]!==b&&(f[I]=b,this.getStorage(y)?.set(c,JSON.stringify(f))):typeof f[I]=="number"&&(delete f[I],this.getStorage(y)?.set(c,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const y=this.get(c,I);if(y)try{return JSON.parse(y)}catch(b){}return Object.create(null)}isNew(I){return this.getBoolean(t.IS_NEW_KEY,I)===!0}async flush(I=d.NONE){this._onWillSaveState.fire({reason:I}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return a(I,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class L extends p{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}t.InMemoryStorageService=L;async function a(l,I,y,b){const f=u=>{try{return JSON.parse(u)}catch(h){return u}},r=new Map,s=new Map;l.forEach((u,h)=>{r.set(h,u),s.set(h,f(u))});const e=new Map,i=new Map;I.forEach((u,h)=>{e.set(h,u),i.set(h,f(u))}),console.group(`Storage: Global (path: ${y})`);let n=[];r.forEach((u,h)=>{n.push({key:h,value:u})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${b})`);let o=[];e.forEach((u,h)=>{o.push({key:h,value:u})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=a}),define(Z[116],te([0,1,10,34,7,29]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function k(d){if(T.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function C(d,m,v,p,L,a,l,I,y,b){const f=Object.create(null);f["common.machineId"]=l,f.sessionID=(0,F.generateUuid)()+Date.now(),f.commitHash=L,f.version=a,f["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=R.platform,f["common.nodeArch"]=p,f["common.product"]=b||"desktop";const r=c(I||[]);r&&(f["common.msftInternal"]=r);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const i=k(v);i&&(f["common.platformDetail"]=i);try{const n=await d.readFile(S.URI.file(y));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=C;function c(d){const m=R.env.USERDNSDOMAIN;if(!m)return!1;const v=m.toLowerCase();return d.some(p=>v===p)}t.verifyMicrosoftInternalDomain=c}),define(Z[36],te([0,1,12]),function(q,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Z[117],te([0,1,3,26,8,14,2,10,7,74,22,23,15,35,36]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let l=class extends k.Disposable{constructor(r,s,e){super();this.galleryService=r,this.telemetryService=s,this.logService=e,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new F.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new F.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new F.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new F.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(r,s={}){if(!this.galleryService.isEnabled())throw new Error(d.localize(0,null));try{r=await this.checkAndGetCompatibleVersion(r)}catch(i){throw this.logService.error((0,S.getErrorMessage)(i)),y(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(r),void 0,i),i}if(!await this.canInstall(r)){const i=new m.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",r.identifier.id,i.message),y(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(r),void 0,i),i}const e=await this.galleryService.getManifest(r,R.CancellationToken.None);if(e===null){const i=new m.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",r.identifier.id,i.message),y(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(r),void 0,i),i}return this.installExtension(e,r,s)}async uninstall(r,s={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,s)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(d.localize(1,null));const s=await this.findGalleryExtension(r);if(!s)throw new Error(d.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,s,e){if(!c.URI.isUri(s)){let h=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(h)return this.logService.info("Extensions is already requested to install",s.identifier.id),h.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],n=[],o=this.createInstallExtensionTask(r,s,e);c.URI.isUri(s)||this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(o.identifier,r.version).key(),o),this._onInstallExtension.fire({identifier:o.identifier,source:s}),this.logService.info("Installing extension:",o.identifier.id),i.push({task:o,manifest:r});let u=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,r,!!e.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:N,manifest:P}of g)if(u=u||!!P.extensionDependencies?.some(A=>(0,v.areSameExtensions)({id:A},o.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const A=this.createInstallExtensionTask(P,N,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(A.identifier,P.version).key(),A),this._onInstallExtension.fire({identifier:A.identifier,source:N}),this.logService.info("Installing extension:",A.identifier.id),i.push({task:A,manifest:P})}}catch(g){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),this.logService.error(g),g}const h=i.reduce((g,{task:N,manifest:P})=>(g.set(N.identifier.id.toLowerCase(),{task:N,manifest:P}),g),new Map);for(;h.size;){let g;const N=[...h.values()].filter(({manifest:P})=>!P.extensionDependencies?.some(A=>h.has(A.toLowerCase())));N.length?g=h.size===1?N:N.filter(({task:P})=>!(P===o&&!u)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:P})=>P.identifier.id)),g=[...h.values()]),await this.joinAllSettled(g.map(async({task:P})=>{const A=new Date().getTime();try{const x=await P.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(x,P.source,e,R.CancellationToken.None))),!c.URI.isUri(P.source)&&(y(this.telemetryService,P.operation===2?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(P.source),new Date().getTime()-A,void 0),C.isWeb&&P.operation===1))try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch(_){}n.push({local:x,identifier:P.identifier,operation:P.operation,source:P.source})}catch(x){throw c.URI.isUri(P.source)||y(this.telemetryService,P.operation===2?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(P.source),new Date().getTime()-A,x),this.logService.error("Error while installing the extension:",P.identifier.id),this.logService.error(x),x}finally{h.delete(P.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:g})=>(0,v.areSameExtensions)(g,o.identifier))[0].local}catch(h){if(i.forEach(({task:g})=>g.cancel()),n.length)try{const g=await Promise.allSettled(n.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<g.length;N++){const P=g[N],{identifier:A}=n[N];P.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",A.id):this.logService.warn("Rollback: Error while uninstalling extension",A.id,(0,S.getErrorMessage)(P.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,S.getErrorMessage)(g),n.map(({identifier:N})=>N.id))}throw this.logService.error("Failed to install extension:",o.identifier.id,(0,S.getErrorMessage)(h)),this._onDidInstallExtensions.fire(i.map(({task:g})=>({identifier:g.identifier,operation:1,source:g.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:t.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:g}of i)if(!c.URI.isUri(h.source)){const N=new v.ExtensionIdentifierWithVersion(h.identifier,g.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const s=[],e=[],i=await Promise.allSettled(r);for(const n of i)n.status==="fulfilled"?s.push(n.value):e.push(n.reason);if(e.length)throw I(e);return s}async getAllDepsAndPackExtensionsToInstall(r,s,e){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const n=[r,...i.map(h=>h.identifier)],o=[],u=async(h,g)=>{const N=g.extensionDependencies||[];if(g.extensionPack){const P=e?i.find(A=>(0,v.areSameExtensions)(A.identifier,h)):void 0;for(const A of g.extensionPack)P&&P.manifest.extensionPack&&P.manifest.extensionPack.some(x=>(0,v.areSameExtensions)({id:x},{id:A}))||N.every(x=>!(0,v.areSameExtensions)({id:x},{id:A}))&&N.push(A)}if(N.length){const P=[...n,...o.map(x=>x.gallery.identifier)],A=N.filter(x=>P.every(_=>!(0,v.areSameExtensions)(_,{id:x})));if(A.length){const x=await this.galleryService.query({names:A,pageSize:N.length},R.CancellationToken.None);for(const _ of x.firstPage){if(P.find(se=>(0,v.areSameExtensions)(se,_.identifier)))continue;const J=await this.checkAndGetCompatibleVersion(_);if(!await this.canInstall(J)){this.logService.info("Skipping the extension as it cannot be installed",J.identifier.id);continue}const ie=await this.galleryService.getManifest(J,R.CancellationToken.None);if(ie===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${J.identifier.id}`,t.INSTALL_ERROR_VALIDATING);o.push({gallery:J,manifest:ie}),await u(J.identifier,ie)}}}};return await u(r,s),i=await this.getInstalled(),o.filter(h=>!i.some(g=>(0,v.areSameExtensions)(g.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(r){if(await this.isMalicious(r))throw new m.ExtensionManagementError(d.localize(3,null,r.identifier.id),m.INSTALL_ERROR_MALICIOUS);const s=await this.galleryService.getCompatibleExtension(r);if(!s)throw new m.ExtensionManagementError(d.localize(4,null,r.identifier.id,L.default.version),m.INSTALL_ERROR_INCOMPATIBLE);return s}async isMalicious(r){const s=await this.getExtensionsReport();return(0,v.getMaliciousExtensionsSet)(s).has(r.identifier.id)}async unininstallExtension(r,s){const e=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),e.waitUntilTaskIsFinished();const i=(h,g)=>{const N=this.createUninstallExtensionTask(h,g);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),N},n=(h,g)=>{g?this.logService.error("Failed to uninstall extension:",h.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)(h),void 0,g),this._onDidUninstallExtension.fire({identifier:h.identifier,error:g?.code})},o=[],u=[];try{o.push(i(r,{}));const h=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(r,h);for(const N of g)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):o.push(i(N,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(o.map(g=>g.extension),h,r),await this.joinAllSettled(o.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(g.extension,s,R.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(N){}n(g.extension)}catch(N){const P=N instanceof m.ExtensionManagementError?N:new m.ExtensionManagementError((0,S.getErrorMessage)(N),t.ERROR_UNKNOWN);throw n(g.extension,P),P}finally{u.push(g)}}))}catch(h){const g=h instanceof m.ExtensionManagementError?h:new m.ExtensionManagementError((0,S.getErrorMessage)(h),t.ERROR_UNKNOWN);for(const N of o){try{N.cancel()}catch(P){}u.includes(N)||n(N.extension,g)}throw g}finally{for(const h of o)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(r,s,e){for(const i of r){const n=this.getDependents(i,s);if(n.length){const o=n.filter(u=>r.indexOf(u)===-1);if(o.length)throw new Error(this.getDependentsErrorMessage(i,o,e))}}}getDependentsErrorMessage(r,s,e){return e===r?s.length===1?d.localize(5,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?d.localize(6,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):d.localize(7,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?d.localize(8,null,e.manifest.displayName||e.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?d.localize(9,null,e.manifest.displayName||e.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):d.localize(10,null,e.manifest.displayName||e.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(r,s,e=[]){if(e.indexOf(r)!==-1)return[];e.push(r);const i=r.manifest.extensionPack?r.manifest.extensionPack:[];if(i.length){const n=s.filter(u=>!u.isBuiltin&&i.some(h=>(0,v.areSameExtensions)({id:h},u.identifier))),o=[];for(const u of n)o.push(...this.getAllPackExtensionsToUninstall(u,s,e));return[...n,...o]}return[]}getDependents(r,s){return s.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(i=>(0,v.areSameExtensions)({id:i},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const s=await this.findGalleryExtensionById(r.identifier.uuid);return s||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};l=ue([fe(0,m.IExtensionGalleryService),fe(1,a.ITelemetryService),fe(2,p.ILogService)],l),t.AbstractExtensionManagementService=l;function I(f){const r=Array.isArray(f)?f:[f];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((s,e)=>new Error(`${s.message}${s.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}t.joinErrors=I;function y(f,r,s,e,i){const n=i?i instanceof m.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;f.publicLogError(r,{...s,success:!i,duration:e,errorcode:n})}t.reportTelemetry=y;class b{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(r=>new Promise((s,e)=>{const i=r.onCancellationRequested(()=>{i.dispose(),e((0,S.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=b}),define(Z[118],te([0,1,26,8,19,10,7,21,22,23,49,17,12,15,42,55,114,115,36]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l,I,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var f;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(f||(f={}));function r(...B){return String(B.reduce((W,U)=>W|U,0))}var s;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class u{constructor(W=o){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,U=this.state.pageSize){return new u({...this.state,pageNumber:W,pageSize:U})}withFilter(W,...U){const w=[...this.state.criteria,...U.length?U.map(M=>({filterType:W,value:M})):[{filterType:W}]];return new u({...this.state,criteria:w})}withSortBy(W){return new u({...this.state,sortBy:W})}withSortOrder(W){return new u({...this.state,sortOrder:W})}withFlags(...W){return new u({...this.state,flags:W.reduce((U,w)=>U|w,0)})}withAssetTypes(...W){return new u({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:U,pageSize:w,sortBy:M,sortOrder:E,flags:O,assetTypes:D}=this.state;return{filters:[{criteria:W,pageNumber:U,pageSize:w,sortBy:M,sortOrder:E}],assetTypes:D,flags:O}}get searchText(){const W=this.state.criteria.filter(U=>U.filterType===s.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function h(B,W){const U=(B||[]).filter(w=>w.statisticName===W)[0];return U?U.value:0}function g(B){const W="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(w=>w.assetType.indexOf(W)===0).reduce((w,M)=>{const E=x(B,M.assetType);return E&&w.push([M.assetType.substring(W.length),E]),w},[])}function N(B){if(B.properties){const W=B.properties.filter(M=>M.key===e.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),w=W.filter(M=>U.test(M.value))[0];return w?{uri:w.value,fallbackUri:w.value}:null}return x(B,e.Repository)}function P(B){return{uri:`${B.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${B.fallbackAssetUri}/${e.VSIX}`}}function A(B){const W=x(B,e.Icon);if(W)return W;const U=c.DefaultIconPath;return{uri:U,fallbackUri:U}}function x(B,W){return B.files.filter(w=>w.assetType===W)[0]?{uri:`${B.assetUri}/${W}`,fallbackUri:`${B.fallbackAssetUri}/${W}`}:null}function _(B,W){const U=B.properties?B.properties.filter(M=>M.key===W):[],w=U.length>0&&U[0].value;return w?w.split(",").map(M=>(0,d.adoptToGalleryExtensionId)(M)):[]}function J(B){const W=B.properties?B.properties.filter(U=>U.key===i.Engine):[];return W.length>0&&W[0].value||""}function ie(B){const W=B.properties?B.properties.filter(w=>w.key===i.LocalizedLanguages):[],U=W.length>0&&W[0].value||"";return U?U.split(","):[]}function se(B){return B.indexOf("preview")!==-1}function Y(B,W,U,w,M){const E={manifest:x(W,e.Manifest),readme:x(W,e.Details),changelog:x(W,e.Changelog),license:x(W,e.License),repository:N(W),download:P(W),icon:A(W),coreTranslations:g(W)};return{identifier:{id:(0,d.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:W.version,date:W.lastUpdated,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:h(B.statistics,"install"),rating:h(B.statistics,"averagerating"),ratingCount:h(B.statistics,"ratingcount"),assetUri:k.URI.parse(W.assetUri),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),webExtension:!!B.tags?.includes(c.WEB_EXTENSION_TAG),assetTypes:W.files.map(({assetType:O})=>O),assets:E,properties:{dependencies:_(W,i.Dependency),extensionPack:_(W,i.ExtensionPack),engine:J(W),localizedLanguages:ie(W)},telemetryData:{index:(w.pageNumber-1)*w.pageSize+U,querySource:M},preview:se(B.flags)}}let X=class{constructor(W,U,w,M,E,O,D){this.requestService=W,this.logService=U,this.environmentService=w,this.telemetryService=M,this.fileService=E,this.productService=O;const z=O.extensionsGallery;this.extensionsGalleryUrl=z&&z.serviceUrl,this.extensionsControlUrl=z&&z.controlUrl,this.commonHeadersPromise=Q(O.version,this.environmentService,this.fileService,D)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,U){const w=[];let{total:M,firstPage:E,getPage:O}=await this.query({names:W,pageSize:W.length},U);w.push(...E);for(let D=1;w.length<M&&(E=await O(D,U),E.length);D++)w.push(...E);return w}async getCompatibleExtension(W,U){return this.getCompatibleExtensionByEngine(W,U)}async getCompatibleExtensionByEngine(W,U){const w=(0,c.isIExtensionIdentifier)(W)?null:W;if(w&&w.properties.engine&&(0,m.isEngineValid)(w.properties.engine,this.productService.version,this.productService.date))return w;const{id:M,uuid:E}=w?w.identifier:W;let O=new u().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");E?O=O.withFilter(s.ExtensionId,E):O=O.withFilter(s.ExtensionName,M);const{galleryExtensions:D}=await this.queryGallery(O,T.CancellationToken.None),[z]=D;if(!z||!z.versions.length)return null;if(U){const $=z.versions.filter(H=>H.version===U)[0];if($){const H=Y(z,$,0,O);if(H.properties.engine&&(0,m.isEngineValid)(H.properties.engine,this.productService.version,this.productService.date))return H}return null}const j=await this.getLastValidExtensionVersion(z,z.versions);return j?Y(z,j,0,O):null}async query(W,U){const w=T.CancellationToken.isCancellationToken(W)?{}:W,M=T.CancellationToken.isCancellationToken(W)?W:U;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let E=w.text||"";const O=(0,S.getOrDefault)(w,ee=>ee.pageSize,50);let D=new u().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,O).withFilter(s.Target,"Microsoft.VisualStudio.Code");E?(E=E.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,ne,re)=>(D=D.withFilter(s.Category,re||ne),"")),E=E.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,ne,re)=>(D=D.withFilter(s.Tag,re||ne),"")),E=E.replace(/\bfeatured(\s+|\b|$)/g,()=>(D=D.withFilter(s.Featured),"")),E=E.trim(),E&&(E=E.length<200?E:E.substring(0,200),D=D.withFilter(s.SearchText,E)),D=D.withSortBy(0)):w.ids?D=D.withFilter(s.ExtensionId,...w.ids):w.names?D=D.withFilter(s.ExtensionName,...w.names):D=D.withSortBy(4),typeof w.sortBy=="number"&&(D=D.withSortBy(w.sortBy)),typeof w.sortOrder=="number"&&(D=D.withSortOrder(w.sortOrder));const{galleryExtensions:z,total:j}=await this.queryGallery(D,M),$=z.map((ee,ne)=>Y(ee,ee.versions[0],ne,D,w.source)),H=async(ee,ne)=>{if(ne.isCancellationRequested)throw(0,R.canceled)();const re=D.withPage(ee+1),{galleryExtensions:ce}=await this.queryGallery(re,ne);return ce.map((me,be)=>Y(me,me.versions[0],be,re,w.source))};return{firstPage:$,total:j,pageSize:D.pageSize,getPage:H}}async queryGallery(W,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,f.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(f.Unpublished));const w=await this.commonHeadersPromise,M=JSON.stringify(W.raw),E={...w,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(M.length)},O=new Date().getTime();let D,z,j=0;try{if(D=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:M,headers:E},U),D.res.statusCode&&D.res.statusCode>=400&&D.res.statusCode<500)return{galleryExtensions:[],total:j};const $=await(0,l.asJson)(D);if($){const H=$.results[0],ee=H.extensions,ne=H.resultMetadata&&H.resultMetadata.filter(re=>re.metadataType==="ResultCount")[0];return j=ne&&ne.metadataItems.filter(re=>re.name==="TotalCount")[0].count||0,{galleryExtensions:ee,total:j}}return{galleryExtensions:[],total:j}}catch($){throw z=$,$}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(M.length),duration:new Date().getTime()-O,success:!!D&&(0,l.isSuccess)(D),responseBodySize:D?.res.headers["Content-Length"],statusCode:D?String(D.res.statusCode):void 0,errorCode:z?(0,R.isPromiseCanceledError)(z)?"canceled":(0,R.getErrorMessage)(z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(W,U,w,M){if(!this.isEnabled())return;const E=F.isWeb?this.api(`/itemName/${W}.${U}/version/${w}/statType/${M==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${U}/${w}/stats?statType=${M}`),O=F.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",z={...await this.commonHeadersPromise,Accept:O};try{await this.requestService.request({type:"POST",url:E,headers:z},T.CancellationToken.None)}catch(j){}}async download(W,U,w){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const M=(0,d.getGalleryExtensionTelemetryData)(W),E=new Date().getTime(),O=$=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...M,duration:$}),D=w===1?"install":w===2?"update":"",z=D?{uri:`${W.assets.download.uri}&${D}=true`,fallbackUri:`${W.assets.download.fallbackUri}?${D}=true`}:W.assets.download,j=await this.getAsset(z);await this.fileService.writeFile(U,j.stream),O(new Date().getTime()-E)}async getReadme(W,U){if(W.assets.readme){const w=await this.getAsset(W.assets.readme,{},U);return await(0,l.asText)(w)||""}return""}async getManifest(W,U){if(W.assets.manifest){const w=await this.getAsset(W.assets.manifest,{},U),M=await(0,l.asText)(w);return M?JSON.parse(M):null}return null}async getCoreTranslation(W,U){const w=W.assets.coreTranslations.filter(M=>M[0]===U.toUpperCase())[0];if(w){const M=await this.getAsset(w[1]),E=await(0,l.asText)(M);return E?JSON.parse(E):null}return null}async getChangelog(W,U){if(W.assets.changelog){const w=await this.getAsset(W.assets.changelog,{},U);return await(0,l.asText)(w)||""}return""}async getAllVersions(W,U){let w=new u().withFlags(f.IncludeVersions,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?w=w.withFilter(s.ExtensionId,W.identifier.uuid):w=w.withFilter(s.ExtensionName,W.identifier.id);const M=[],{galleryExtensions:E}=await this.queryGallery(w,T.CancellationToken.None);return E.length&&(U?await Promise.all(E[0].versions.map(async O=>{let D;try{D=await this.getEngine(O)}catch(z){}D&&(0,m.isEngineValid)(D,this.productService.version,this.productService.date)&&M.push({version:O.version,date:O.lastUpdated})})):M.push(...E[0].versions.map(O=>({version:O.version,date:O.lastUpdated})))),M}async getAsset(W,U={},w=T.CancellationToken.None){const M=await this.commonHeadersPromise,E={type:"GET"},O={...M,...U.headers||{}};U={...U,...E,headers:O};const D=W.uri,z=W.fallbackUri,j={...U,url:D};try{const $=await this.requestService.request(j,w);if($.res.statusCode===200)return $;const H=await(0,l.asText)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${H}`)}catch($){if((0,R.isPromiseCanceledError)($))throw $;const H=(0,R.getErrorMessage)($);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:D,message:H});const ee={...U,url:z};return this.requestService.request(ee,w)}}async getLastValidExtensionVersion(W,U){const w=this.getLastValidExtensionVersionFromProperties(W,U);return w||this.getLastValidExtensionVersionRecursively(W,U)}getLastValidExtensionVersionFromProperties(W,U){for(const w of U){const M=J(w);if(!M)return null;if((0,m.isEngineValid)(M,this.productService.version,this.productService.date))return w}return null}async getEngine(W){const U=J(W);if(U)return U;const w=x(W,e.Manifest);if(!w)throw new Error("Manifest was not found");const M={"Accept-Encoding":"gzip"},E=await this.getAsset(w,{headers:M}),O=await(0,l.asJson)(E);if(O)return O.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(W,U){if(!U.length)return null;const w=U[0],M=await this.getEngine(w);return(0,m.isEngineValid)(M,this.productService.version,this.productService.date)?{...w,properties:[...w.properties||[],{key:i.Engine,value:M}]}:this.getLastValidExtensionVersionRecursively(W,U.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(W),w=new Map;if(U)for(const M of U.malicious){const E=w.get(M)||{id:{id:M},malicious:!0,slow:!1};E.malicious=!0,w.set(M,E)}return[...w.values()]}};X=ue([fe(0,l.IRequestService),fe(1,L.ILogService),fe(2,C.IEnvironmentService),fe(3,b.ITelemetryService),fe(4,v.IFileService),fe(5,a.IProductService),fe(6,(0,p.optional)(y.IStorageService))],X),t.ExtensionGalleryService=X;async function Q(B,W,U,w){const M={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},E=await(0,I.getServiceMachineId)(W,U,w);return M["X-Market-User-Id"]=E,M}t.resolveMarketplaceHeaders=Q}),define(Z[119],te([0,1,2,19,18,85,27,30,12,35,25]),function(q,t,T,R,S,F,k,C,c,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let v=class{constructor(a,l){this._configurationService=l,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const y=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})}))}setExperimentProperty(a,l){this._experimentProperties[a]=l}setEnabled(a){this._enabled=a}_updateUserOptIn(){const a=this._configurationService?.getValue(p);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let l=a.sessionID,I=a["common.instanceId"],y=a["common.machineId"],b=a["common.firstSessionDate"],f=a["common.msftInternal"];return{sessionId:l,instanceId:I,machineId:y,firstSessionDate:b,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(a,l,I){return this.isOptedIn?this._commonProperties.then(y=>{l=(0,R.mixin)(l,y),l=(0,R.mixin)(l,this._experimentProperties),l=(0,R.cloneAndChange)(l,b=>{if(typeof b=="string")return this._cleanupInfo(b,I)}),this._appender.log(a,l)},y=>{console.error(y)}):Promise.resolve(void 0)}publicLog2(a,l,I){return this.publicLog(a,l,I)}publicLogError(a,l){return this.sendErrorTelemetry?this.publicLog(a,l,!0):Promise.resolve(void 0)}publicLogError2(a,l){return this.publicLogError(a,l)}_cleanupInfo(a,l){let I=a;if(l){const y=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(a);if(!e)break;y.push([e.index,s.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(I="";;){const s=f.exec(a);if(!s)break;!b.test(s[0])&&y.every(([e,i])=>s.index<e||s.index>=i)&&(I+=a.substring(r,s.index)+"<REDACTED: user-file-path>",r=f.lastIndex)}r<a.length&&(I+=a.substr(r))}for(let y of this._cleanupPatterns)I=I.replace(y,"");return I}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ue([fe(1,(0,c.optional)(k.IConfigurationService))],v),t.TelemetryService=v;const p="telemetry";m.Registry.as(C.Extensions.Configuration).registerConfiguration({id:p,order:110,type:"object",title:(0,F.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,F.localize)(2,null,d.default.nameLong,d.default.privacyStatementUrl):(0,F.localize)(1,null,d.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[56],te([0,1,3,19,13,27]),function(q,t,T,R,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,l){return Promise.resolve(void 0)}publicLog2(a,l){return this.publicLog(a,l)}publicLogError(a,l){return Promise.resolve(void 0)}publicLogError2(a,l){return this.publicLogError(a,l)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(l,I,y){}async publicLogError(l,I,y){}}t.NullEndpointTelemetryService=k;function C(...a){return{log:(l,I)=>a.forEach(y=>y.log(l,I)),flush:()=>T.Promises.settled(a.map(l=>l.flush()))}}t.combinedAppender=C,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,l){return l.onDidChangeConfiguration(I=>{I.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(I.source),configurationKeys:p(I.sourceConfig)})})}t.configurationTelemetry=c;function d(a){const l=Object.create(null),I=Object.create(null),y=Object.create(null);v(a,y);for(let b in y){b=b.length>150?b.substr(b.length-149):b;const f=y[b];typeof f=="number"?I[b]=f:typeof f=="boolean"?I[b]=f?1:0:typeof f=="string"?l[b]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(l[b]=f)}return{properties:l,measurements:I}}t.validateTelemetryData=d;function m(a){if(!a)return"none";let l="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{a.indexOf(`${y}+`)===0&&(l=y)}),l}t.cleanRemoteAuthority=m;function v(a,l,I=0,y){if(!!a)for(let b of Object.getOwnPropertyNames(a)){const f=a[b],r=y?y+b:b;Array.isArray(f)?l[r]=(0,R.safeStringify)(f):f instanceof Date?l[r]=f.toISOString():(0,S.isObject)(f)?I<2?v(f,l,I+1,r+"."):l[r]=(0,R.safeStringify)(f):l[r]=f}}function p(a){if(!a)return[];const l=[];return L(l,"",a),l}function L(a,l,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(y=>L(a,l?`${l}.${y}`:y,I[y])):a.push(l)}}),define(Z[120],te([0,1,8,19,56]),function(q,t,T,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function F(C){const c=await new Promise((m,v)=>{q(["applicationinsights"],m,v)});let d;return c.defaultClient?(d=new c.TelemetryClient(C),d.channel.setUseDiskRetryCaching(!0)):(c.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=c.defaultClient),C.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class k{constructor(c,d,m){this._eventPrefix=c,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof m=="function"?this._aiClient=m():this._aiClient=m,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=F(this._aiClient)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,T.onUnexpectedError)(d),console.error(d)})}}log(c,d){!this._aiClient||(d=(0,R.mixin)(d,this._defaultData),d=(0,S.validateTelemetryData)(d),this._withAIClient(m=>m.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=k}),define(Z[121],te([0,1,4,11]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(F,k){const C=Object.create(null),c=(m,v)=>{const p=JSON.parse(m);C[v]=p};if(k){const m=[],v=await R.Promises.readdir(k);for(const L of v)try{(await R.Promises.stat((0,T.join)(k,L))).isDirectory()&&m.push(L)}catch{}const p=[];for(const L of m)(await R.Promises.readdir((0,T.join)(k,L))).filter(l=>l==="telemetry.json").length===1&&p.push(L);for(const L of p){const a=(await R.Promises.readFile((0,T.join)(k,L,"telemetry.json"))).toString();c(a,L)}}let d=(await R.Promises.readFile((0,T.join)(F,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await R.Promises.readFile((0,T.join)(F,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(C,null,4)}t.buildTelemetryMessage=S}),define(Z[43],te([0,1,38,3,4,13,11,72,132,133]),function(q,t,T,R,S,F,k,C,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class m extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=m;function v(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function p(s){if(s instanceof m)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new m(e,s)}function L(s,e,i,n,o,u){const h=S.dirname(e),g=S.join(n,h);if(!g.startsWith(n))return Promise.reject(new Error(C.localize(0,null,e)));const N=S.join(n,e);let P;return u.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(k.Promises.mkdir(g,{recursive:!0})).then(()=>new Promise((A,x)=>{if(!u.isCancellationRequested)try{P=(0,T.createWriteStream)(N,{mode:i}),P.once("close",()=>A()),P.once("error",x),s.once("error",x),s.pipe(P)}catch(_){x(_)}}))}function a(s,e,i,n){let o=(0,R.createCancelablePromise)(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((h,g)=>{const N=new R.Sequencer,P=A=>{A.isCancellationRequested||(u++,s.readEntry())};s.once("error",g),s.once("close",()=>o.then(()=>{n.isCancellationRequested||s.entryCount===u?h():g(new m("Incomplete",new Error(C.localize(1,null,u,s.entryCount))))},g)),s.readEntry(),s.on("entry",A=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(A.fileName)){P(n);return}const x=A.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const ie=S.join(e,x);o=(0,R.createCancelablePromise)(se=>k.Promises.mkdir(ie,{recursive:!0}).then(()=>P(se)).then(void 0,g));return}const _=I(s,A),J=v(A);o=(0,R.createCancelablePromise)(ie=>N.queue(()=>_.then(se=>L(se,x,J,e,i,ie).then(()=>P(ie)))).then(null,g))})})}function l(s,e=!1){return new Promise((i,n)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(o,u)=>{o?n(p(o)):i((0,F.assertIsDefined)(u))})})}function I(s,e){return new Promise((i,n)=>{s.openReadStream(e,(o,u)=>{o?n(p(o)):i((0,F.assertIsDefined)(u))})})}function y(s,e){return new Promise((i,n)=>{const o=new d.ZipFile;e.forEach(h=>{h.contents?o.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&o.addFile(h.localPath,h.path)}),o.end();const u=(0,T.createWriteStream)(s);o.outputStream.pipe(u),o.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>i(s))})}t.zip=y;function b(s,e,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let u=l(s,!0);return i.overwrite&&(u=u.then(h=>k.Promises.rm(e).then(()=>h))),u.then(h=>a(h,e,{sourcePathRegex:o},n))}t.extract=b;function f(s,e){return l(s).then(i=>new Promise((n,o)=>{i.on("entry",u=>{u.fileName===e&&I(i,u).then(h=>n(h),h=>o(h))}),i.once("close",()=>o(new Error(C.localize(2,null,e))))}))}function r(s,e){return f(s,e).then(i=>new Promise((n,o)=>{const u=[];i.once("error",o),i.on("data",h=>u.push(h)),i.on("end",()=>n(Buffer.concat(u)))}))}t.buffer=r}),define(Z[122],te([0,1,43,78]),function(q,t,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(F){return(0,T.buffer)(F,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(C){throw new Error((0,R.localize)(0,null))}})}t.getManifest=S}),define(Z[123],te([0,1,24,3,8,2,9,4,10,20,41,7,29,11,43,79,21,22,23,90,17,15,42]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l,I,y,b,f,r,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",o="extracting",u="deleting",h="renaming";let g=class extends F.Disposable{constructor(P,A,x,_,J){super();this.beforeRemovingExtension=P,this.fileService=A,this.logService=x,this.environmentService=_,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=_.builtinExtensionsPath,this.extensionsPath=_.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(P){const A=[];(P===null||P===0)&&A.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(x).message,i)))),(P===null||P===1)&&A.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(x).message,n))));try{const x=await Promise.all(A);return(0,T.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(P){this.logService.trace("Started scanning user extensions");let[A,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(_=>!A[new b.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).key()]),P&&(x=(0,b.groupByExtension)(x,J=>J.identifier).map(J=>J.sort((ie,se)=>m.rcompare(ie.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(P,A,x){const _=P.key(),J=C.join(this.extensionsPath,`.${(0,p.generateUuid)()}`),ie=C.join(this.extensionsPath,_);try{await L.Promises.rm(ie)}catch(Y){try{await L.Promises.rm(ie)}catch(X){}throw new y.ExtensionManagementError((0,l.localize)(0,null,ie,P.id),u)}await this.extractAtLocation(P,A,J,x);let se=await this.scanExtension(v.URI.file(J),1);if(!se)throw new Error((0,l.localize)(1,null,J));await this.storeMetadata(se,{installedTimestamp:Date.now()});try{await this.rename(P,J,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Y){try{await L.Promises.rm(J)}catch(X){}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",P.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(Y)}. Deleted from extracted location`,J),Y}try{se=await this.scanExtension(v.URI.file(ie),1)}catch(Y){}if(se)return se;throw new Error((0,l.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(P,A){return this.setMetadata(P,A),await this.storeMetadata(P,{...A,installedTimestamp:P.installedTimestamp}),P}async storeMetadata(P,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const x=C.join(P.location.fsPath,"package.json"),_=await L.Promises.readFile(x,"utf8"),{manifest:J}=await this.parseManifest(_);return J.__metadata=A,await L.Promises.writeFile(x,JSON.stringify(J,null,"	")),P}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...P){const A=P.map(x=>new b.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{A.forEach(_=>x[_.key()]=!0)})}async setInstalled(P){await this.withUninstalledExtensions(_=>delete _[P.key()]);const x=(await this.scanExtensions(1)).find(_=>new b.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(P))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(P){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let x={};if(A)try{x=JSON.parse(A)}catch(_){}return P&&(P(x),Object.keys(x).length?await L.Promises.writeFile(this.uninstalledPath,JSON.stringify(x)):await L.Promises.rm(this.uninstalledPath)),x})}async removeExtension(P,A){this.logService.trace(`Deleting ${A} extension from disk`,P.identifier.id,P.location.fsPath),await L.Promises.rm(P.location.fsPath),this.logService.info("Deleted from disk",P.identifier.id,P.location.fsPath)}async removeUninstalledExtension(P){await this.removeExtension(P,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new b.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()])}async extractAtLocation(P,A,x,_){this.logService.trace(`Started extracting the extension from ${A} to ${x}`);try{await L.Promises.rm(x)}catch(J){throw new y.ExtensionManagementError(this.joinErrors(J).message,u)}try{await(0,a.extract)(A,x,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${x}:`,P.id)}catch(J){try{await L.Promises.rm(x)}catch(ie){}throw new y.ExtensionManagementError(J.message,J instanceof a.ExtractError&&J.type?J.type:o)}}async rename(P,A,x,_){try{await L.Promises.rename(A,x)}catch(J){if(c.isWindows&&J&&J.code==="EPERM"&&Date.now()<_)return this.logService.info(`Failed renaming ${A} to ${x} with 'EPERM' error. Trying again...`,P.id),this.rename(P,A,x,_);throw new y.ExtensionManagementError(J.message||(0,l.localize)(3,null,A,x),J.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const P=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return P;const A=this.scanDevSystemExtensions(),[x,_]=await Promise.all([P,A]);return[...x,..._]}async scanExtensionsInDir(P,A){const x=new R.Limiter(10),_=await this.fileService.resolve(v.URI.file(P));return _.children?(await Promise.all(_.children.filter(ie=>ie.isDirectory).map(ie=>x.queue(async()=>A===1&&(0,d.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,A))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(P,A){try{const x=await this.fileService.resolve(P);if(x.children){const{manifest:_,metadata:J}=await this.readManifest(P.fsPath),ie=x.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,se=x.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource,Y={id:(0,b.getGalleryExtensionId)(_.publisher,_.name)},X={type:A,identifier:Y,manifest:_,location:P,readmeUrl:ie,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return J&&(this.setMetadata(X,J),X.installedTimestamp=J.installedTimestamp),X}}catch(x){A!==0&&this.logService.trace(x)}return null}async scanDefaultSystemExtensions(){const P=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",P.length),P}async scanDevSystemExtensions(){const P=this.getDevSystemExtensionsList();if(P.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(x=>P.some(_=>(0,b.areSameExtensions)(x.identifier,{id:_})))}else return[]}setMetadata(P,A){P.publisherDisplayName=A.publisherDisplayName||null,P.publisherId=A.publisherId||null,P.identifier.uuid=A.id,P.isMachineScoped=!!A.isMachineScoped,P.isBuiltin=P.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const P=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),x=new Set;for(const ie of A)P[new b.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||x.add(ie.identifier.id.toLowerCase());const _=(0,b.groupByExtension)(A,ie=>ie.identifier);await R.Promises.settled(_.map(async ie=>{const se=ie.sort((Y,X)=>m.rcompare(Y.manifest.version,X.manifest.version))[0];x.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const J=A.filter(ie=>P[new b.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await R.Promises.settled(J.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const P=await this.scanAllUserExtensions(),A=[],x=(0,b.groupByExtension)(P,_=>_.identifier);A.push(...(0,T.flatten)(x.map(_=>_.sort((J,ie)=>m.rcompare(J.manifest.version,ie.manifest.version)).slice(1)))),await R.Promises.settled(A.map(_=>this.removeExtension(_,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(P=>P.name)}joinErrors(P){const A=Array.isArray(P)?P:[P];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((x,_)=>new Error(`${x.message}${x.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(k.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(P){const A=[L.Promises.readFile(C.join(P,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),L.Promises.readFile(C.join(P,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:x,metadata:_},J]=await Promise.all(A);return{manifest:(0,f.localizeManifest)(x,J),metadata:_}}parseManifest(P){return new Promise((A,x)=>{try{const _=JSON.parse(P),J=_.__metadata||null;A({manifest:_,metadata:J})}catch(_){x(new Error((0,l.localize)(4,null)))}})}};g=ue([fe(1,r.IFileService),fe(2,s.ILogService),fe(3,I.INativeEnvironmentService),fe(4,e.IProductService)],g),t.ExtensionsScanner=g}),define(Z[124],te([0,1,28,9,4,10,20,41,7,29,11,43,77,96,21,117,22,23,102,103,122,98,123,104,49,17,12,15,35,36]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l,I,y,b,f,r,s,e,i,n,o,u,h,g,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const P="unsetUninstalled",A="downloading";let x=class extends l.AbstractExtensionManagementService{constructor(X,Q,B,W,U,w,M){super(X,Q,B);this.environmentService=W,this.downloadService=U;const E=this._register(w.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(w.createInstance(e.ExtensionsScanner,D=>E.postUninstall(D))),this.manifestCache=this._register(new s.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(w.createInstance(b.ExtensionsDownloader));const O=this._register(new i.ExtensionsWatcher(this,M,W,B));this._register(O.onDidChangeExtensionsByAnotherSource(({added:D,removed:z})=>{D.length&&this._onDidInstallExtensions.fire(D.map(j=>({identifier:j.identifier,operation:0,local:j}))),z.forEach(j=>this._onDidUninstallExtension.fire({identifier:j}))}))}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const Q=await this.collectFiles(X),B=await(0,v.zip)((0,k.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,Q);return c.URI.file(B)}async unzip(X){return this.logService.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const Q=await this.downloadVsix(X),B=S.resolve(Q.fsPath);return(0,r.getManifest)(B)}getInstalled(X=null){return this.extensionsScanner.scanExtensions(X)}async canInstall(X){return!0}async install(X,Q={}){this.logService.trace("ExtensionManagementService#install",X.toString());const B=await this.downloadVsix(X),W=await(0,r.getManifest)(S.resolve(B.fsPath));if(W.engines&&W.engines.vscode&&!(0,n.isEngineValid)(W.engines.vscode,g.default.version,g.default.date))throw new Error(p.localize(0,null,(0,y.getGalleryExtensionId)(W.publisher,W.name),g.default.version));return this.installExtension(W,B,Q)}async updateMetadata(X,Q){return this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},...Q}),this.manifestCache.invalidate(),X}async updateExtensionScope(X,Q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},isMachineScoped:Q}),this.manifestCache.invalidate(),X}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(X){if(X.scheme===R.Schemas.file)return X;if(!this.downloadService)throw new Error("Download service is not available");const Q=(0,k.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(X,Q),Q}createInstallExtensionTask(X,Q,B){return c.URI.isUri(Q)?new ie(X,Q,B,this.galleryService,this.extensionsScanner,this.logService):new J(Q,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(X,Q){return new se(X,Q,this.extensionsScanner)}async collectFiles(X){const Q=async W=>{let U=await m.Promises.readdir(W);U=U.map(E=>S.join(W,E));const w=await Promise.all(U.map(E=>m.Promises.stat(E)));let M=Promise.resolve([]);return w.forEach((E,O)=>{const D=U[O];E.isFile()&&(M=M.then(z=>[...z,D])),E.isDirectory()&&(M=M.then(z=>Q(D).then(j=>[...z,...j])))}),M};return(await Q(X.location.fsPath)).map(W=>({path:`extension/${S.relative(X.location.fsPath,W)}`,localPath:W}))}};x=ue([fe(0,I.IExtensionGalleryService),fe(1,N.ITelemetryService),fe(2,h.ILogService),fe(3,a.INativeEnvironmentService),fe(4,(0,u.optional)(L.IDownloadService)),fe(5,u.IInstantiationService),fe(6,o.IFileService)],x),t.ExtensionManagementService=x;class _ extends l.AbstractExtensionTask{constructor(X,Q,B,W){super();this.identifier=X,this.source=Q,this.extensionsScanner=B,this.logService=W,this._operation=1}get operation(){return this._operation}async installExtension(X,Q){try{const B=await this.unsetUninstalledAndGetLocal(X.identifierWithVersion);if(B)return X.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,X.metadata):B}catch(B){throw F.isMacintosh?new I.ExtensionManagementError(p.localize(1,null),P):new I.ExtensionManagementError(p.localize(2,null),P)}return this.extract(X,Q)}async unsetUninstalledAndGetLocal(X){if(!await this.isUninstalled(X))return null;this.logService.trace("Removing the extension from uninstalled list:",X.id);const B=await this.extensionsScanner.setInstalled(X);return this.logService.info("Removed the extension from uninstalled list:",X.id),B}async isUninstalled(X){return!!(await this.extensionsScanner.getUninstalledExtensions())[X.key()]}async extract({zipPath:X,identifierWithVersion:Q,metadata:B},W){let U=await this.extensionsScanner.extractUserExtension(Q,X,W);return this.logService.info("Extracting completed.",Q.id),B&&(U=await this.extensionsScanner.saveMetadataForLocalExtension(U,B)),U}}class J extends _{constructor(X,Q,B,W,U){super(X.identifier,X,W,U);this.gallery=X,this.options=Q,this.extensionsDownloader=B}async doRun(X){const B=(await this.extensionsScanner.scanExtensions(null)).find(w=>(0,y.areSameExtensions)(w.identifier,this.gallery.identifier));B&&(this._operation=2);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin;const U=await this.installExtension(W,X);B&&C.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B);try{await this.extensionsDownloader.delete(c.URI.file(W.zipPath))}catch(w){}return U}async downloadInstallableExtension(X,Q){const B={id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",X.identifier.id),W=(await this.extensionsDownloader.downloadExtension(X,Q)).fsPath,this.logService.info("Downloaded extension:",X.identifier.id,W)}catch(U){throw new I.ExtensionManagementError((0,l.joinErrors)(U).message,A)}try{const U=await(0,r.getManifest)(W);return{zipPath:W,identifierWithVersion:new y.ExtensionIdentifierWithVersion(X.identifier,U.version),metadata:B}}catch(U){throw new I.ExtensionManagementError((0,l.joinErrors)(U).message,l.INSTALL_ERROR_VALIDATING)}}}class ie extends _{constructor(X,Q,B,W,U,w){super({id:(0,y.getGalleryExtensionId)(X.publisher,X.name)},Q,U,w);this.manifest=X,this.location=Q,this.options=B,this.galleryService=W}async doRun(X){const Q=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(w=>(0,y.areSameExtensions)(this.identifier,w.identifier)),U=await this.getMetadata(this.identifier.id,X);if(W)if(U.isMachineScoped=this.options.isMachineScoped||W.isMachineScoped,U.isBuiltin=this.options.isBuiltin||W.isBuiltin,this._operation=2,Q.equals(new y.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch(w){throw new Error(p.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const w=await this.unsetUninstalledAndGetLocal(Q);if(w)try{await this.extensionsScanner.removeExtension(w,"existing")}catch(M){throw new Error(p.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),identifierWithVersion:Q,metadata:U},X)}async getMetadata(X,Q){try{const B=(await this.galleryService.query({names:[X],pageSize:1},Q)).firstPage[0];if(B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId}}catch(B){}return{}}}class se extends l.AbstractExtensionTask{constructor(X,Q,B){super();this.extension=X,this.options=Q,this.extensionsScanner=B}async doRun(X){const Q=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Q.push(...B.filter(U=>W.equals(new y.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version))))}else Q.push(...B.filter(W=>(0,y.areSameExtensions)(W.identifier,this.extension.identifier)));if(!Q.length)throw new Error(p.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Q),this.options.remove)for(const W of Q)try{X.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(U){throw new Error(p.localize(6,null,(0,T.toErrorMessage)(U)))}}}}),define(Z[125],te([0,1,113,16,8,2,13,27,21,99,15,112,134]),function(q,t,T,R,S,F,k,C,c,d,m,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let L=class extends F.Disposable{constructor(l,I,y){super();this.environmentService=I,this.logService=y,this.configure(l.getValue()),this._register(l.onDidChangeConfiguration(()=>this.configure(l.getValue()),this))}configure(l){this.proxyUrl=l.http&&l.http.proxy,this.strictSSL=!!(l.http&&l.http.proxyStrictSSL),this.authorization=l.http&&l.http.proxyAuthorization}async request(l,I){this.logService.trace("RequestService#request",l.url);const{proxyUrl:y,strictSSL:b}=this,f={...process.env,...await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},r=l.agent?l.agent:await(0,v.getProxyAgent)(l.url||"",f,{proxyUrl:y,strictSSL:b});return l.agent=r,l.strictSSL=b,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this._request(l,I)}async getNodeRequest(l){return((0,T.parse)(l.url).protocol==="https:"?await new Promise((b,f)=>{q(["https"],b,f)}):await new Promise((b,f)=>{q(["http"],b,f)})).request}_request(l,I){return new Promise(async(y,b)=>{let f;const r=(0,T.parse)(l.url),s=l.getRawRequest?l.getRawRequest(l):await this.getNodeRequest(l),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,k.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(e.auth=l.user+":"+l.password),f=s(e,i=>{const n=(0,k.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...l,url:i.headers.location,followRedirects:n-1},I).then(y,b);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,p.createGunzip)())),y({res:i,stream:(0,R.streamToBufferReadableStream)(o)})}}),f.on("error",b),l.timeout&&f.setTimeout(l.timeout),l.data&&typeof l.data=="string"&&f.write(l.data),f.end(),I.onCancellationRequested(()=>{f.abort(),b((0,S.canceled)())})})}async resolveProxy(l){}};L=ue([fe(0,C.IConfigurationService),fe(1,c.INativeEnvironmentService),fe(2,m.ILogService)],L),t.RequestService=L}),define(Z[135],te([0,1,38,136,32,3,16,28,8,2,9,4,34,7,11,27,111,21,89,118,22,97,124,17,107,108,50,101,52,53,105,15,106,35,42,55,125,116,36,119,56,120,121]),function(q,t,T,R,S,F,k,C,c,d,m,v,p,L,a,l,I,y,b,f,r,s,e,i,n,o,u,h,g,N,P,A,x,_,J,ie,se,Y,X,Q,B,W,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class w extends d.Disposable{constructor(O){super();this.argv=O,(0,R.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[O,D]=await this.initServices();return O.invokeFunction(async z=>{const j=z.get(A.ILogService),$=z.get(i.IFileService),H=z.get(y.INativeEnvironmentService),ee=z.get(r.IExtensionManagementCLIService);return j.info("CLI main",this.argv),this.registerErrorHandler(j),await this.doRun(H,ee,$),(0,F.raceTimeout)((0,B.combinedAppender)(...D).flush(),1e3)})}async initServices(){const O=new g.ServiceCollection,D={_serviceBrand:void 0,..._.default};O.set(J.IProductService,D);const z=new b.NativeEnvironmentService(this.argv,D);O.set(y.INativeEnvironmentService,z),await Promise.all([z.appSettingsHome.fsPath,z.extensionsPath].map(me=>me?a.Promises.mkdir(me,{recursive:!0}):void 0));const j=(0,A.getLogLevel)(z),$=[];$.push(new x.SpdLogLogger("cli",(0,v.join)(z.logsPath,"cli.log"),!0,j)),j===A.LogLevel.Trace&&$.push(new A.ConsoleLogger(j));const H=this._register(new A.MultiplexLogService($));O.set(A.ILogService,H);const ee=this._register(new n.FileService(H));O.set(i.IFileService,ee);const ne=this._register(new o.DiskFileSystemProvider(H));ee.registerProvider(m.Schemas.file,ne);const re=this._register(new I.ConfigurationService(z.settingsResource,ee));O.set(l.IConfigurationService,re),await re.initialize(),O.set(ie.IRequestService,new u.SyncDescriptor(se.RequestService)),O.set(r.IExtensionManagementService,new u.SyncDescriptor(e.ExtensionManagementService)),O.set(r.IExtensionGalleryService,new u.SyncDescriptor(f.ExtensionGalleryService)),O.set(r.IExtensionManagementCLIService,new u.SyncDescriptor(s.ExtensionManagementCLIService)),O.set(N.ILocalizationsService,new u.SyncDescriptor(P.LocalizationsService));const ce=[];if(z.isBuilt&&!z.isExtensionDevelopment&&!z.disableTelemetry&&D.enableTelemetry){D.aiConfig&&D.aiConfig.asimovKey&&ce.push(new W.AppInsightsAppender("monacoworkbench",null,D.aiConfig.asimovKey));const{appRoot:me,extensionsPath:be,installSourcePath:ke}=z,Te={appender:(0,B.combinedAppender)(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await a.Promises.readFile((0,v.join)(z.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[X.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&H.error(Fe)}return(0,Y.resolveCommonProperties)(ee,(0,S.release)(),(0,S.hostname)(),process.arch,D.commit,D.version,we,D.msftInternalDomains,ke)})(),piiPaths:[me,be]};O.set(X.ITelemetryService,new u.SyncDescriptor(Q.TelemetryService,[Te]))}else O.set(X.ITelemetryService,B.NullTelemetryService);return[new h.InstantiationService(O),ce]}registerErrorHandler(O){(0,c.setUnexpectedErrorHandler)(D=>{const z=(0,C.toErrorMessage)(D,!0);!z||O.error(`[uncaught exception in CLI]: ${z}`)}),process.on("uncaughtException",D=>(0,c.onUnexpectedError)(D)),process.on("unhandledRejection",D=>(0,c.onUnexpectedError)(D))}async doRun(O,D,z){if(this.argv["install-source"])return this.setInstallSource(O,z,this.argv["install-source"]);if(this.argv["list-extensions"])return D.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return D.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return D.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return D.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(O.appRoot,O.extensionsPath))}asExtensionIdOrVSIX(O){return O.map(D=>/\.vsix$/i.test(D)?L.URI.file((0,v.isAbsolute)(D)?D:(0,v.join)((0,p.cwd)(),D)):D)}async setInstallSource(O,D,z){await D.writeFile(L.URI.file(O.installSourcePath),k.VSBuffer.fromString(z.slice(0,30)))}}async function M(E){const O=new w(E);try{await O.run()}finally{O.dispose()}}t.main=M})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/49af1cbe00271ac2ea36cfc5f7352fe31a7b0094/core/vs/code/node/cliProcessMain.js.map
