/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ee){for(var e=[],h=0,R=ee.length;h<R;h++)e[h]=be[ee[h]];return e};define(be[41],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(R,S){if(!R)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=h}),define(be[51],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function R(n){const C=[];for(let l in n)h.call(n,l)&&C.push(n[l]);return C}e.values=R;function S(n,C){for(let l in n)if(h.call(n,l)&&C({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=S;function E(n,C){const l=Object.create(null);for(const f of n){const u=C(f);let g=l[u];g||(g=l[u]=[]),g.push(f)}return l}e.groupBy=E;function A(n){const C=Object.create(null);return n&&n.forEach((l,f)=>{C[f]=l}),C}e.fromMap=A;function _(n,C){const l=[],f=[];for(let u of n)C.has(u)||l.push(u);for(let u of C)n.has(u)||f.push(u);return{removed:l,added:f}}e.diffSets=_;function y(n,C){const l=[],f=[];for(let[u,g]of n)C.has(u)||l.push(g);for(let[u,g]of C)n.has(u)||f.push(g);return{removed:l,added:f}}e.diffMaps=y;class I{constructor(){this.map=new Map}add(C,l){let f=this.map.get(C);f||(f=new Set,this.map.set(C,f)),f.add(l)}delete(C,l){const f=this.map.get(C);!f||(f.delete(l),f.size===0&&this.map.delete(C))}forEach(C,l){const f=this.map.get(C);!f||f.forEach(l)}}e.SetMap=I}),define(be[52],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(A){return(_,y,I)=>{let n=null,C=null;if(typeof I.value=="function"?(n="value",C=I.value):typeof I.get=="function"&&(n="get",C=I.get),!C)throw new Error("not supported");I[n]=A(C,y)}}e.createDecorator=h;function R(A,_,y){let I=null,n=null;if(typeof y.value=="function"?(I="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(I="get",n=y.get),!n)throw new Error("not supported");const C=`$memoize$${_}`;y[I]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[C]}}e.memoize=R;function S(A,_,y){return h((I,n)=>{const C=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...f){this[l]||(this[l]=y?y():void 0),clearTimeout(this[C]),_&&(this[l]=_(this[l],...f),f=[this[l]]),this[C]=setTimeout(()=>{I.apply(this,f),this[l]=y?y():void 0},A)}})}e.debounce=S;function E(A,_,y){return h((I,n)=>{const C=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...g){if(this[l]||(this[l]=y?y():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),_&&(this[l]=_(this[l],...g)),this[u])return;const b=this[f]+A;b<=Date.now()?(this[f]=Date.now(),I.apply(this,[this[l]]),this[l]=y?y():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[f]=Date.now(),I.apply(this,[this[l]]),this[l]=y?y():void 0},b-Date.now()))}})}e.throttle=E}),define(be[12],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=h,e.errorHandler=new h;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function S(v){y(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=S;function E(v){y(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=E;function A(v){if(v instanceof Error){let{name:t,message:r}=v;const a=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:a}}return v}e.transformErrorForSerialization=A;const _="Canceled";function y(v){return v instanceof Error&&v.name===_&&v.message===_}e.isPromiseCanceledError=y;class I extends Error{constructor(){super(_);this.name=this.message}}e.CancellationError=I;function n(){const v=new Error(_);return v.name=v.message,v}e.canceled=n;function C(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=C;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function f(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class T extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=T;function o(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=o;function m(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=m}),define(be[17],Ee([0,1,12]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R($,ne=0){return $[$.length-(1+ne)]}e.tail=R;function S($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=S;function E($,ne,he=(ye,Ne)=>ye===Ne){if($===ne)return!0;if(!$||!ne||$.length!==ne.length)return!1;for(let ye=0,Ne=$.length;ye<Ne;ye++)if(!he($[ye],ne[ye]))return!1;return!0}e.equals=E;function A($,ne,he){let ye=0,Ne=$.length-1;for(;ye<=Ne;){const Me=(ye+Ne)/2|0,$e=he($[Me],ne);if($e<0)ye=Me+1;else if($e>0)Ne=Me-1;else return Me}return-(ye+1)}e.binarySearch=A;function _($,ne){let he=0,ye=$.length;if(ye===0)return 0;for(;he<ye;){const Ne=Math.floor((he+ye)/2);ne($[Ne])?ye=Ne:he=Ne+1}return he}e.findFirstInSorted=_;function y($,ne,he){if($=$|0,$>=ne.length)throw new TypeError("invalid index");let ye=ne[Math.floor(ne.length*Math.random())],Ne=[],Me=[],$e=[];for(let Xe of ne){const qe=he(Xe,ye);qe<0?Ne.push(Xe):qe>0?Me.push(Xe):$e.push(Xe)}return $<Ne.length?y($,Ne,he):$<Ne.length+$e.length?$e[0]:y($-(Ne.length+$e.length),Me,he)}e.quickSelect=y;function I($,ne){const he=[];let ye;for(const Ne of $.slice(0).sort(ne))!ye||ne(ye[0],Ne)!==0?(ye=[Ne],he.push(ye)):ye.push(Ne);return he}e.groupBy=I;function n($,ne,he){const ye=[];function Ne(Xe,qe,je){if(qe===0&&je.length===0)return;const U=ye[ye.length-1];U&&U.start+U.deleteCount===Xe?(U.deleteCount+=qe,U.toInsert.push(...je)):ye.push({start:Xe,deleteCount:qe,toInsert:je})}let Me=0,$e=0;for(;;){if(Me===$.length){Ne(Me,0,ne.slice($e));break}if($e===ne.length){Ne(Me,$.length-Me,[]);break}const Xe=$[Me],qe=ne[$e],je=he(Xe,qe);je===0?(Me+=1,$e+=1):je<0?(Ne(Me,1,[]),Me+=1):je>0&&(Ne(Me,0,[qe]),$e+=1)}return ye}e.sortedDiff=n;function C($,ne,he){const ye=n($,ne,he),Ne=[],Me=[];for(const $e of ye)Ne.push(...$.slice($e.start,$e.start+$e.deleteCount)),Me.push(...$e.toInsert);return{removed:Ne,added:Me}}e.delta=C;function l($,ne,he){if(he===0)return[];const ye=$.slice(0,he).sort(ne);return u($,ne,ye,he,$.length),ye}e.top=l;function f($,ne,he,ye,Ne){return he===0?Promise.resolve([]):new Promise((Me,$e)=>{(async()=>{const Xe=$.length,qe=$.slice(0,he).sort(ne);for(let je=he,U=Math.min(he+ye,Xe);je<Xe;je=U,U=Math.min(U+ye,Xe)){if(je>he&&await new Promise(K=>setTimeout(K)),Ne&&Ne.isCancellationRequested)throw(0,h.canceled)();u($,ne,qe,je,U)}return qe})().then(Me,$e)})}e.topAsync=f;function u($,ne,he,ye,Ne){for(const Me=he.length;ye<Ne;ye++){const $e=$[ye];if(ne($e,he[Me-1])<0){he.pop();const Xe=_(he,qe=>ne($e,qe)<0);he.splice(Xe,0,$e)}}}function g($){return $.filter(ne=>!!ne)}e.coalesce=g;function b($){let ne=0;for(let he=0;he<$.length;he++)$[he]&&($[ne]=$[he],ne+=1);$.length=ne}e.coalesceInPlace=b;function w($,ne,he){$.splice(he,0,$.splice(ne,1)[0])}e.move=w;function T($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=T;function o($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=o;function m($,ne){if(!ne)return $.filter((ye,Ne)=>$.indexOf(ye)===Ne);const he=Object.create(null);return $.filter(ye=>{const Ne=ne(ye);return he[Ne]?!1:(he[Ne]=!0,!0)})}e.distinct=m;function v($){const ne=new Set;return $.filter(he=>ne.has(he)?!1:(ne.add(he),!0))}e.distinctES6=v;function t($){const ne=Object.create(null);return he=>{const ye=$(he);return ne[ye]?!1:(ne[ye]=!0,!0)}}e.uniqueFilter=t;function r($,ne){for(let he=$.length-1;he>=0;he--){const ye=$[he];if(ne(ye))return he}return-1}e.lastIndex=r;function a($,ne){return $.length>0?$[0]:ne}e.firstOrDefault=a;function i($,ne,he=(ye,Ne)=>ye===Ne){let ye=0;for(let Ne=0,Me=Math.min($.length,ne.length);Ne<Me&&he($[Ne],ne[Ne]);Ne++)ye++;return ye}e.commonPrefixLength=i;function c($){return[].concat(...$)}e.flatten=c;function p($,ne){let he=typeof ne=="number"?$:0;typeof ne=="number"?he=$:(he=0,ne=$);const ye=[];if(he<=ne)for(let Ne=he;Ne<ne;Ne++)ye.push(Ne);else for(let Ne=he;Ne>ne;Ne--)ye.push(Ne);return ye}e.range=p;function d($,ne,he){return $.reduce((ye,Ne)=>(ye[ne(Ne)]=he?he(Ne):Ne,ye),Object.create(null))}e.index=d;function D($,ne){return $.push(ne),()=>k($,ne)}e.insert=D;function k($,ne){const he=$.indexOf(ne);if(he>-1)return $.splice(he,1),ne}e.remove=k;function s($,ne,he){const ye=$.slice(0,ne),Ne=$.slice(ne);return ye.concat(he,Ne)}e.arrayInsert=s;function P($,ne){let he;if(typeof ne=="number"){let ye=ne;he=()=>{const Ne=Math.sin(ye++)*179426549;return Ne-Math.floor(Ne)}}else he=Math.random;for(let ye=$.length-1;ye>0;ye-=1){const Ne=Math.floor(he()*(ye+1)),Me=$[ye];$[ye]=$[Ne],$[Ne]=Me}}e.shuffle=P;function F($,ne){const he=$.indexOf(ne);he>-1&&($.splice(he,1),$.unshift(ne))}e.pushToStart=F;function x($,ne){const he=$.indexOf(ne);he>-1&&($.splice(he,1),$.push(ne))}e.pushToEnd=x;function j($,ne){return Array.isArray($)?$.map(ne):ne($)}e.mapArrayOrNot=j;function ae($){return Array.isArray($)?$:[$]}e.asArray=ae;function oe($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=oe;function V($,ne){for(const he of $){const ye=ne(he);if(ye!==void 0)return ye}}e.mapFind=V;function W($,ne,he){const ye=Q($,ne),Ne=$.length,Me=he.length;$.length=Ne+Me;for(let $e=Ne-1;$e>=ye;$e--)$[$e+Me]=$[$e];for(let $e=0;$e<Me;$e++)$[$e+ye]=he[$e]}e.insertInto=W;function L($,ne,he,ye){const Ne=Q($,ne),Me=$.splice(Ne,he);return W($,Ne,ye),Me}e.splice=L;function Q($,ne){return ne<0?Math.max(ne+$.length,0):Math.min(ne,$.length)}function O($,ne){let he=Number.MAX_SAFE_INTEGER,ye=0;return $.forEach((Ne,Me)=>{const $e=ne(Ne);$e<he&&(he=$e,ye=Me)}),ye}e.minIndex=O;function G($,ne){let he=Number.MIN_SAFE_INTEGER,ye=0;return $.forEach((Ne,Me)=>{const $e=ne(Ne);$e>he&&(he=$e,ye=Me)}),ye}e.maxIndex=G;class de{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let he=this.firstIdx;for(;he<this.items.length&&ne(this.items[he]);)he++;const ye=he===this.firstIdx?null:this.items.slice(this.firstIdx,he);return this.firstIdx=he,ye}takeFromEndWhile(ne){let he=this.lastIdx;for(;he>=0&&ne(this.items[he]);)he--;const ye=he===this.lastIdx?null:this.items.slice(he+1,this.lastIdx+1);return this.lastIdx=he,ye}}e.ArrayQueue=de}),define(be[53],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(R){const S=this;let E=!1,A;return function(){return E||(E=!0,A=R.apply(S,arguments)),A}}e.once=h}),define(be[54],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(be[55],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(R){function S(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=S;const E=Object.freeze([]);function A(){return E}R.empty=A;function*_(v){yield v}R.single=_;function y(v){return v||E}R.from=y;function I(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=I;function n(v){return v[Symbol.iterator]().next().value}R.first=n;function C(v,t){for(const r of v)if(t(r))return!0;return!1}R.some=C;function l(v,t){for(const r of v)if(t(r))return r}R.find=l;function*f(v,t){for(const r of v)t(r)&&(yield r)}R.filter=f;function*u(v,t){let r=0;for(const a of v)yield t(a,r++)}R.map=u;function*g(...v){for(const t of v)for(const r of t)yield r}R.concat=g;function*b(v){for(const t of v)for(const r of t)yield r}R.concatNested=b;function w(v,t,r){let a=r;for(const i of v)a=t(a,i);return a}R.reduce=w;function*T(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}R.slice=T;function o(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const a=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=a.next();if(c.done)return[r,R.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return a}}]}R.consume=o;function m(v,t,r=(a,i)=>a===i){const a=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=a.next(),p=i.next();if(c.done!==p.done)return!1;if(c.done)return!0;if(!r(c.value,p.value))return!1}}R.equals=m})(h=e.Iterable||(e.Iterable={}))}),define(be[111],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let a=0,i=t.length,c="",p=0,d=16,D=0;function k(oe){let V=0,W=0;for(;V<oe;){const L=t.charCodeAt(a);if(L>=48&&L<=57)W=W*16+L-48;else if(L>=65&&L<=70)W=W*16+L-65+10;else if(L>=97&&L<=102)W=W*16+L-97+10;else break;a++,V++}return V<oe&&(W=-1),W}function s(oe){a=oe,c="",p=0,d=16,D=0}function P(){const oe=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&I(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&I(t.charCodeAt(a)))for(a++;a<t.length&&I(t.charCodeAt(a));)a++;else return D=3,t.substring(oe,a);let V=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&I(t.charCodeAt(a))){for(a++;a<t.length&&I(t.charCodeAt(a));)a++;V=a}else D=3;return t.substring(oe,V)}function F(){let oe="",V=a;for(;;){if(a>=i){oe+=t.substring(V,a),D=2;break}const W=t.charCodeAt(a);if(W===34){oe+=t.substring(V,a),a++;break}if(W===92){if(oe+=t.substring(V,a),a++,a>=i){D=2;break}switch(t.charCodeAt(a++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:const Q=k(4);Q>=0?oe+=String.fromCharCode(Q):D=4;break;default:D=5}V=a;continue}if(W>=0&&W<=31)if(y(W)){oe+=t.substring(V,a),D=2;break}else D=6;a++}return oe}function x(){if(c="",D=0,p=a,a>=i)return p=i,d=17;let oe=t.charCodeAt(a);if(_(oe)){do a++,c+=String.fromCharCode(oe),oe=t.charCodeAt(a);while(_(oe));return d=15}if(y(oe))return a++,c+=String.fromCharCode(oe),oe===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),d=14;switch(oe){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,c=F(),d=10;case 47:const V=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!y(t.charCodeAt(a));)a++;return c=t.substring(V,a),d=12}if(t.charCodeAt(a+1)===42){a+=2;const W=i-1;let L=!1;for(;a<W;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,L=!0;break}a++}return L||(a++,D=1),c=t.substring(V,a),d=13}return c+=String.fromCharCode(oe),a++,d=16;case 45:if(c+=String.fromCharCode(oe),a++,a===i||!I(t.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),d=11;default:for(;a<i&&j(oe);)a++,oe=t.charCodeAt(a);if(p!==a){switch(c=t.substring(p,a),c){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return c+=String.fromCharCode(oe),a++,d=16}}function j(oe){if(_(oe)||y(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let oe;do oe=x();while(oe>=12&&oe<=15);return oe}return{setPosition:s,getPosition:()=>a,scan:r?ae:x,getToken:()=>d,getTokenValue:()=>c,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>D}}e.createScanner=A;function _(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function C(t,r){const a=[],i=new Object;let c;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function D(k,s,P,F){p.value=k,p.offset=s,p.length=P,p.type=F,p.colonOffset=void 0,c=p}try{o(t,{onObjectBegin:(k,s)=>{if(r<=k)throw i;c=void 0,d=r>k,a.push("")},onObjectProperty:(k,s,P)=>{if(r<s||(D(k,s,P,"property"),a[a.length-1]=k,r<=s+P))throw i},onObjectEnd:(k,s)=>{if(r<=k)throw i;c=void 0,a.pop()},onArrayBegin:(k,s)=>{if(r<=k)throw i;c=void 0,a.push(0)},onArrayEnd:(k,s)=>{if(r<=k)throw i;c=void 0,a.pop()},onLiteralValue:(k,s,P)=>{if(r<s||(D(k,s,P,v(k)),r<=s+P))throw i},onSeparator:(k,s,P)=>{if(r<=s)throw i;if(k===":"&&c&&c.type==="property")c.colonOffset=s,d=!1,c=void 0;else if(k===","){const F=a[a.length-1];typeof F=="number"?a[a.length-1]=F+1:(d=!0,a[a.length-1]=""),c=void 0}}})}catch(k){if(k!==i)throw k}return{path:a,previousNode:c,isAtPropertyKey:d,matches:k=>{let s=0;for(let P=0;s<k.length&&P<a.length;P++)if(k[s]===a[P]||k[s]==="*")s++;else if(k[s]!=="**")return!1;return s===k.length}}}e.getLocation=C;function l(t,r=[],a=E.DEFAULT){let i=null,c=[];const p=[];function d(k){Array.isArray(c)?c.push(k):i!==null&&(c[i]=k)}return o(t,{onObjectBegin:()=>{const k={};d(k),p.push(c),c=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const k=[];d(k),p.push(c),c=k,i=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:d,onError:(k,s,P)=>{r.push({error:k,offset:s,length:P})}},a),c[0]}e.parse=l;function f(t,r=[],a=E.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function p(k){return i.children.push(k),k}o(t,{onObjectBegin:k=>{i=p({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,s,P)=>{i=p({type:"property",offset:s,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:s,length:P,parent:i})},onObjectEnd:(k,s)=>{i.length=k+s-i.offset,i=i.parent,c(k+s)},onArrayBegin:(k,s)=>{i=p({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,s)=>{i.length=k+s-i.offset,i=i.parent,c(k+s)},onLiteralValue:(k,s,P)=>{p({type:v(k),offset:s,length:P,parent:i,value:k}),c(s+P)},onSeparator:(k,s,P)=>{i.type==="property"&&(k===":"?i.colonOffset=s:k===","&&c(s))},onError:(k,s,P)=>{r.push({error:k,offset:s,length:P})}},a);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=f;function u(t,r){if(!t)return;let a=t;for(let i of r)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===i){a=p.children[1],c=!0;break}if(!c)return}else{const c=i;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=u;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}e.getNodePath=g;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let a of t.children){const i=a.children[1];i&&(r[a.children[0].value]=b(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}e.contains=w;function T(t,r,a=!1){if(w(t,r,a)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const p=T(i[c],r,a);if(p)return p}return t}}e.findNodeAtOffset=T;function o(t,r,a=E.DEFAULT){const i=A(t,!1);function c(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function p(he){return he?ye=>he(ye,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=c(r.onObjectBegin),D=p(r.onObjectProperty),k=c(r.onObjectEnd),s=c(r.onArrayBegin),P=c(r.onArrayEnd),F=p(r.onLiteralValue),x=p(r.onSeparator),j=c(r.onComment),ae=p(r.onError),oe=a&&a.disallowComments,V=a&&a.allowTrailingComma;function W(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:oe||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(he){case 12:case 13:oe?L(10):j();break;case 16:L(1);break;case 15:case 14:break;default:return he}}}function L(he,ye=[],Ne=[]){if(ae(he),ye.length+Ne.length>0){let Me=i.getToken();for(;Me!==17;){if(ye.indexOf(Me)!==-1){W();break}else if(Ne.indexOf(Me)!==-1)break;Me=W()}}}function Q(he){const ye=i.getTokenValue();return he?F(ye):D(ye),W(),!0}function O(){switch(i.getToken()){case 11:let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(L(2),he=0)}catch(ye){L(2)}F(he);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return W(),!0}function G(){return i.getToken()!==10?(L(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(x(":"),W(),ne()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function de(){d(),W();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||L(4,[],[]),x(","),W(),i.getToken()===2&&V)break}else he&&L(6,[],[]);G()||L(4,[],[2,5]),he=!0}return k(),i.getToken()!==2?L(7,[2],[]):W(),!0}function $(){s(),W();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||L(4,[],[]),x(","),W(),i.getToken()===4&&V)break}else he&&L(6,[],[]);ne()||L(4,[],[4,5]),he=!0}return P(),i.getToken()!==4?L(8,[4],[]):W(),!0}function ne(){switch(i.getToken()){case 3:return $();case 1:return de();case 10:return Q(!0);default:return O()}}return W(),i.getToken()===17?a.allowEmptyContent?!0:(L(4,[],[]),!1):ne()?(i.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=o;function m(t,r){let a=A(t),i=[],c,p=0,d;do switch(d=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:p!==d&&i.push(t.substring(p,d)),r!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,r)),p=a.getPosition();break}while(c!==17);return i.join("")}e.stripComments=m;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(be[112],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new h(()=>S(this.getValue()))}}e.Lazy=h}),define(be[6],Ee([0,1,53,55]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let E=null;function A(a){E=a}if(e.setDisposableTracker=A,S){const a="__is_disposable_tracked__";A(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[a]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==T.None)try{i[a]=!0}catch{}}markAsDisposed(i){if(i&&i!==T.None)try{i[a]=!0}catch{}}markAsSingleton(i){}})}function _(a){return E?.trackDisposable(a),a}function y(a){E?.markAsDisposed(a)}function I(a,i){E?.setParent(a,i)}function n(a,i){if(!!E)for(const c of a)E.setParent(c,i)}function C(a){return E?.markAsSingleton(a),a}e.markAsSingleton=C;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function f(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=f;function u(a){if(R.Iterable.is(a)){let i=[];for(const c of a)if(c)try{c.dispose()}catch(p){i.push(p)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=u;function g(...a){const i=b(()=>u(a));return n(a,i),i}e.combinedDisposable=g;function b(a){const i=_({dispose:(0,h.once)(()=>{y(i),a()})});return i}e.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return I(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class T{constructor(){this._store=new w,_(this),I(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=T,T.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&I(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&I(i,null),i}}e.MutableDisposable=o;class m{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=m;class v{constructor(){this.references=new Map}acquire(i,...c){let p=this.references.get(i);p||(p={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,p));const{object:d}=p,D=(0,h.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(i,p.object),this.references.delete(i))});return p.counter++,{object:d,dispose:D}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const p=this.referenceCollection.acquire(i,...c);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(d){throw p.dispose(),d}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(be[80],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(E){this.element=E,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class R{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let E=this._first;for(;E!==h.Undefined;){const A=E.next;E.prev=h.Undefined,E.next=h.Undefined,E=A}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,A){const _=new h(E);if(this._first===h.Undefined)this._first=_,this._last=_;else if(A){const I=this._last;this._last=_,_.prev=I,I.next=_}else{const I=this._first;this._first=_,_.next=I,I.prev=_}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(_))}}shift(){if(this._first!==h.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==h.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==h.Undefined&&E.next!==h.Undefined){const A=E.prev;A.next=E.next,E.next.prev=A}else E.prev===h.Undefined&&E.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):E.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):E.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==h.Undefined;)yield E.element,E=E.next}}e.LinkedList=R}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(De,Se){for(var Pe=0;Pe<Se.length;Pe++){var se=Se[Pe];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(De,se.key,se)}}function e(De,Se,Pe){return Se&&ee(De.prototype,Se),Pe&&ee(De,Pe),De}function h(De,Se){if(!!De){if(typeof De=="string")return R(De,Se);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(De,Se)}}function R(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Pe=0,se=new Array(Se);Pe<Se;Pe++)se[Pe]=De[Pe];return se}function S(De,Se){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=h(De))||Se&&De&&typeof De.length=="number"){Pe&&(De=Pe);var se=0;return function(){return se>=De.length?{done:!0}:{done:!1,value:De[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function E(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var A=E(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(se){De.exports.defaults=se}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),_=/[&<>"']/,y=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(Se){return C[Se]};function f(De,Se){if(Se){if(_.test(De))return De.replace(y,l)}else if(I.test(De))return De.replace(n,l);return De}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(De){return De.replace(u,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var b=/(^|[^\[])\^/g;function w(De,Se){De=De.source||De,Se=Se||"";var Pe={replace:function(le,fe){return fe=fe.source||fe,fe=fe.replace(b,"$1"),De=De.replace(le,fe),Pe},getRegex:function(){return new RegExp(De,Se)}};return Pe}var T=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(De,Se,Pe){if(De){var se;try{se=decodeURIComponent(g(Pe)).replace(T,"").toLowerCase()}catch(le){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!o.test(Pe)&&(Pe=i(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(le){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,Se){v[" "+De]||(t.test(De)?v[" "+De]=De+"/":v[" "+De]=D(De,"/",!0)),De=v[" "+De];var Pe=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:De.replace(r,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:De.replace(a,"$1")+Se:De+Se}var c={exec:function(){}};function p(De){for(var Se=1,Pe,se;Se<arguments.length;Se++){Pe=arguments[Se];for(se in Pe)Object.prototype.hasOwnProperty.call(Pe,se)&&(De[se]=Pe[se])}return De}function d(De,Se){var Pe=De.replace(/\|/g,function(fe,pe,B){for(var me=!1,we=pe;--we>=0&&B[we]==="\\";)me=!me;return me?"|":" |"}),se=Pe.split(/ \|/),le=0;if(se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function D(De,Se,Pe){var se=De.length;if(se===0)return"";for(var le=0;le<se;){var fe=De.charAt(se-le-1);if(fe===Se&&!Pe)le++;else if(fe!==Se&&Pe)le++;else break}return De.substr(0,se-le)}function k(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Pe=De.length,se=0,le=0;le<Pe;le++)if(De[le]==="\\")le++;else if(De[le]===Se[0])se++;else if(De[le]===Se[1]&&(se--,se<0))return le;return-1}function s(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(De,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=De),Se>>=1,De+=De;return Pe+De}var F={escape:f,unescape:g,edit:w,cleanUrl:m,resolveUrl:i,noopTest:c,merge:p,splitCells:d,rtrim:D,findClosingBracket:k,checkSanitizeDeprecation:s,repeatString:P},x=A.defaults,j=F.rtrim,ae=F.splitCells,oe=F.escape,V=F.findClosingBracket;function W(De,Se,Pe){var se=Se.href,le=Se.title?oe(Se.title):null,fe=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:se,title:le,text:fe}:{type:"image",raw:Pe,href:se,title:le,text:oe(fe)}}function L(De,Se){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var se=Pe[1];return Se.split(`
`).map(function(le){var fe=le.match(/^\s+/);if(fe===null)return le;var pe=fe[0];return pe.length>=se.length?le.slice(se.length):le}).join(`
`)}var Q=function(){function De(Pe){this.options=Pe||x}var Se=De.prototype;return Se.space=function(se){var le=this.rules.block.newline.exec(se);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Se.code=function(se){var le=this.rules.block.code.exec(se);if(le){var fe=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:j(fe,`
`)}}},Se.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var fe=le[0],pe=L(fe,le[3]||"");return{type:"code",raw:fe,lang:le[2]?le[2].trim():le[2],text:pe}}},Se.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var fe=le[2].trim();if(/#$/.test(fe)){var pe=j(fe,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(fe=pe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:fe}}},Se.nptable=function(se){var le=this.rules.block.nptable.exec(se);if(le){var fe={type:"table",header:ae(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(fe.header.length===fe.align.length){var pe=fe.align.length,B;for(B=0;B<pe;B++)/^ *-+: *$/.test(fe.align[B])?fe.align[B]="right":/^ *:-+: *$/.test(fe.align[B])?fe.align[B]="center":/^ *:-+ *$/.test(fe.align[B])?fe.align[B]="left":fe.align[B]=null;for(pe=fe.cells.length,B=0;B<pe;B++)fe.cells[B]=ae(fe.cells[B],fe.header.length);return fe}}},Se.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},Se.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var fe=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:fe}}},Se.list=function(se){var le=this.rules.block.list.exec(se);if(le){var fe=le[0],pe=le[2],B=pe.length>1,me={type:"list",raw:fe,ordered:B,start:B?+pe.slice(0,-1):"",loose:!1,items:[]},we=le[0].match(this.rules.block.item),Ie=!1,Oe,He,Ze,Ke,Qe,ut,mt,bt,ot=we.length;Ze=this.rules.block.listItemStart.exec(we[0]);for(var at=0;at<ot;at++){if(Oe=we[at],fe=Oe,at!==ot-1){if(Ke=this.rules.block.listItemStart.exec(we[at+1]),this.options.pedantic?Ke[1].length>Ze[1].length:Ke[1].length>Ze[0].length||Ke[1].length>3){we.splice(at,2,we[at]+`
`+we[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==pe[pe.length-1]:B===(Ke[2].length===1))&&(Qe=we.slice(at+1).join(`
`),me.raw=me.raw.substring(0,me.raw.length-Qe.length),at=ot-1);Ze=Ke}He=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(He-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),ut=Ie||/\n\n(?!\s*$)/.test(Oe),at!==ot-1&&(Ie=Oe.charAt(Oe.length-1)===`
`,ut||(ut=Ie)),ut&&(me.loose=!0),this.options.gfm&&(mt=/^\[[ xX]\] /.test(Oe),bt=void 0,mt&&(bt=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),me.items.push({type:"list_item",raw:fe,task:mt,checked:bt,loose:ut,text:Oe})}return me}},Se.html=function(se){var le=this.rules.block.html.exec(se);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):oe(le[0]):le[0]}},Se.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var fe=le[1].toLowerCase().replace(/\s+/g," ");return{tag:fe,raw:le[0],href:le[2],title:le[3]}}},Se.table=function(se){var le=this.rules.block.table.exec(se);if(le){var fe={type:"table",header:ae(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=le[0];var pe=fe.align.length,B;for(B=0;B<pe;B++)/^ *-+: *$/.test(fe.align[B])?fe.align[B]="right":/^ *:-+: *$/.test(fe.align[B])?fe.align[B]="center":/^ *:-+ *$/.test(fe.align[B])?fe.align[B]="left":fe.align[B]=null;for(pe=fe.cells.length,B=0;B<pe;B++)fe.cells[B]=ae(fe.cells[B].replace(/^ *\| *| *\| *$/g,""),fe.header.length);return fe}}},Se.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},Se.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},Se.text=function(se){var le=this.rules.block.text.exec(se);if(le)return{type:"text",raw:le[0],text:le[0]}},Se.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:oe(le[1])}},Se.tag=function(se,le,fe){var pe=this.rules.inline.tag.exec(se);if(pe)return!le&&/^<a /i.test(pe[0])?le=!0:le&&/^<\/a>/i.test(pe[0])&&(le=!1),!fe&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?fe=!0:fe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(fe=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:le,inRawBlock:fe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):oe(pe[0]):pe[0]}},Se.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var fe=le[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var pe=j(fe.slice(0,-1),"\\");if((fe.length-pe.length)%2==0)return}else{var B=V(le[2],"()");if(B>-1){var me=le[0].indexOf("!")===0?5:4,we=me+le[1].length+B;le[2]=le[2].substring(0,B),le[0]=le[0].substring(0,we).trim(),le[3]=""}}var Ie=le[2],Oe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Oe=He[3])}else Oe=le[3]?le[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(fe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),W(le,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},le[0])}},Se.reflink=function(se,le){var fe;if((fe=this.rules.inline.reflink.exec(se))||(fe=this.rules.inline.nolink.exec(se))){var pe=(fe[2]||fe[1]).replace(/\s+/g," ");if(pe=le[pe.toLowerCase()],!pe||!pe.href){var B=fe[0].charAt(0);return{type:"text",raw:B,text:B}}return W(fe,pe,fe[0])}},Se.emStrong=function(se,le,fe){fe===void 0&&(fe="");var pe=this.rules.inline.emStrong.lDelim.exec(se);if(!!pe&&!(pe[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=pe[1]||pe[2]||"";if(!B||B&&(fe===""||this.rules.inline.punctuation.exec(fe))){var me=pe[0].length-1,we,Ie,Oe=me,He=0,Ze=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,le=le.slice(-1*se.length+me);(pe=Ze.exec(le))!=null;)if(we=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!we){if(Ie=we.length,pe[3]||pe[4]){Oe+=Ie;continue}else if((pe[5]||pe[6])&&me%3&&!((me+Ie)%3)){He+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Oe+He-Ie<=0&&!le.slice(Ze.lastIndex).match(Ze)&&(Ie=Math.min(Ie,Ie+Oe+He)),Math.min(me,Ie)%2)return{type:"em",raw:se.slice(0,me+pe.index+Ie+1),text:se.slice(1,me+pe.index+Ie)};if(Math.min(me,Ie)%2==0)return{type:"strong",raw:se.slice(0,me+pe.index+Ie+1),text:se.slice(2,me+pe.index+Ie-1)}}}}}},Se.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var fe=le[2].replace(/\n/g," "),pe=/[^ ]/.test(fe),B=/^ /.test(fe)&&/ $/.test(fe);return pe&&B&&(fe=fe.substring(1,fe.length-1)),fe=oe(fe,!0),{type:"codespan",raw:le[0],text:fe}}},Se.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},Se.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2]}},Se.autolink=function(se,le){var fe=this.rules.inline.autolink.exec(se);if(fe){var pe,B;return fe[2]==="@"?(pe=oe(this.options.mangle?le(fe[1]):fe[1]),B="mailto:"+pe):(pe=oe(fe[1]),B=pe),{type:"link",raw:fe[0],text:pe,href:B,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.url=function(se,le){var fe;if(fe=this.rules.inline.url.exec(se)){var pe,B;if(fe[2]==="@")pe=oe(this.options.mangle?le(fe[0]):fe[0]),B="mailto:"+pe;else{var me;do me=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(me!==fe[0]);pe=oe(fe[0]),fe[1]==="www."?B="http://"+pe:B=pe}return{type:"link",raw:fe[0],text:pe,href:B,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.inlineText=function(se,le,fe){var pe=this.rules.inline.text.exec(se);if(pe){var B;return le?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):oe(pe[0]):pe[0]:B=oe(this.options.smartypants?fe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:B}}},De}(),O=F.noopTest,G=F.edit,de=F.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=G($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=G($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=G(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=G($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=G($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=G($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=G($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=de({},$),$.gfm=de({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=G($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=G($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=de({},$.normal,{html:G(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:G($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=G(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=G($._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=G(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=G(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=G(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=G(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=G(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=G(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=G(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=G(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=de({},ne),ne.pedantic=de({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:G(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:G(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=de({},ne.normal,{escape:G(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=G(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=de({},ne.gfm,{br:G(ne.br).replace("{2,}","*").getRegex(),text:G(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:$,inline:ne},ye=A.defaults,Ne=he.block,Me=he.inline,$e=F.repeatString;function Xe(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(De){var Se="",Pe,se,le=De.length;for(Pe=0;Pe<le;Pe++)se=De.charCodeAt(Pe),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var je=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Ne.normal,inline:Me.normal};this.options.pedantic?(se.block=Ne.pedantic,se.inline=Me.pedantic):this.options.gfm&&(se.block=Ne.gfm,this.options.breaks?se.inline=Me.breaks:se.inline=Me.gfm),this.tokenizer.rules=se}De.lex=function(se,le){var fe=new De(le);return fe.lex(se)},De.lexInline=function(se,le){var fe=new De(le);return fe.inlineTokens(se)};var Se=De.prototype;return Se.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(se,le,fe){le===void 0&&(le=[]),fe===void 0&&(fe=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var pe,B,me,we;se;){if(pe=this.tokenizer.space(se)){se=se.substring(pe.raw.length),pe.type&&le.push(pe);continue}if(pe=this.tokenizer.code(se)){se=se.substring(pe.raw.length),we=le[le.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):le.push(pe);continue}if(pe=this.tokenizer.fences(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.heading(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.nptable(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.hr(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.blockquote(se)){se=se.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],fe),le.push(pe);continue}if(pe=this.tokenizer.list(se)){for(se=se.substring(pe.raw.length),me=pe.items.length,B=0;B<me;B++)pe.items[B].tokens=this.blockTokens(pe.items[B].text,[],!1);le.push(pe);continue}if(pe=this.tokenizer.html(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(fe&&(pe=this.tokenizer.def(se))){se=se.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.lheading(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(fe&&(pe=this.tokenizer.paragraph(se))){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.text(se)){se=se.substring(pe.raw.length),we=le[le.length-1],we&&we.type==="text"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):le.push(pe);continue}if(se){var Ie="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return le},Se.inline=function(se){var le,fe,pe,B,me,we,Ie=se.length;for(le=0;le<Ie;le++)switch(we=se[le],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},B=we.header.length,fe=0;fe<B;fe++)we.tokens.header[fe]=[],this.inlineTokens(we.header[fe],we.tokens.header[fe]);for(B=we.cells.length,fe=0;fe<B;fe++)for(me=we.cells[fe],we.tokens.cells[fe]=[],pe=0;pe<me.length;pe++)we.tokens.cells[fe][pe]=[],this.inlineTokens(me[pe],we.tokens.cells[fe][pe]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(B=we.items.length,fe=0;fe<B;fe++)this.inline(we.items[fe].tokens);break}}return se},Se.inlineTokens=function(se,le,fe,pe){le===void 0&&(le=[]),fe===void 0&&(fe=!1),pe===void 0&&(pe=!1);var B,me,we=se,Ie,Oe,He;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)Ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Ie.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(Oe||(He=""),Oe=!1,B=this.tokenizer.escape(se)){se=se.substring(B.raw.length),le.push(B);continue}if(B=this.tokenizer.tag(se,fe,pe)){se=se.substring(B.raw.length),fe=B.inLink,pe=B.inRawBlock;var Ke=le[le.length-1];Ke&&B.type==="text"&&Ke.type==="text"?(Ke.raw+=B.raw,Ke.text+=B.text):le.push(B);continue}if(B=this.tokenizer.link(se)){se=se.substring(B.raw.length),B.type==="link"&&(B.tokens=this.inlineTokens(B.text,[],!0,pe)),le.push(B);continue}if(B=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(B.raw.length);var Qe=le[le.length-1];B.type==="link"?(B.tokens=this.inlineTokens(B.text,[],!0,pe),le.push(B)):Qe&&B.type==="text"&&Qe.type==="text"?(Qe.raw+=B.raw,Qe.text+=B.text):le.push(B);continue}if(B=this.tokenizer.emStrong(se,we,He)){se=se.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],fe,pe),le.push(B);continue}if(B=this.tokenizer.codespan(se)){se=se.substring(B.raw.length),le.push(B);continue}if(B=this.tokenizer.br(se)){se=se.substring(B.raw.length),le.push(B);continue}if(B=this.tokenizer.del(se)){se=se.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],fe,pe),le.push(B);continue}if(B=this.tokenizer.autolink(se,qe)){se=se.substring(B.raw.length),le.push(B);continue}if(!fe&&(B=this.tokenizer.url(se,qe))){se=se.substring(B.raw.length),le.push(B);continue}if(B=this.tokenizer.inlineText(se,pe,Xe)){se=se.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(He=B.raw.slice(-1)),Oe=!0,me=le[le.length-1],me&&me.type==="text"?(me.raw+=B.raw,me.text+=B.text):le.push(B);continue}if(se){var ut="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ut);break}else throw new Error(ut)}}return le},e(De,null,[{key:"rules",get:function(){return{block:Ne,inline:Me}}}]),De}(),U=A.defaults,K=F.cleanUrl,X=F.escape,re=function(){function De(Pe){this.options=Pe||U}var Se=De.prototype;return Se.code=function(se,le,fe){var pe=(le||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,pe);B!=null&&B!==se&&(fe=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+X(pe,!0)+'">'+(fe?se:X(se,!0))+`</code></pre>
`:"<pre><code>"+(fe?se:X(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,le,fe,pe){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+pe.slug(fe)+'">'+se+"</h"+le+`>
`:"<h"+le+">"+se+"</h"+le+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,le,fe){var pe=le?"ol":"ul",B=le&&fe!==1?' start="'+fe+'"':"";return"<"+pe+B+`>
`+se+"</"+pe+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,le){var fe=le.header?"th":"td",pe=le.align?"<"+fe+' align="'+le.align+'">':"<"+fe+">";return pe+se+"</"+fe+`>
`},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,le,fe){if(se=K(this.options.sanitize,this.options.baseUrl,se),se===null)return fe;var pe='<a href="'+X(se)+'"';return le&&(pe+=' title="'+le+'"'),pe+=">"+fe+"</a>",pe},Se.image=function(se,le,fe){if(se=K(this.options.sanitize,this.options.baseUrl,se),se===null)return fe;var pe='<img src="'+se+'" alt="'+fe+'"';return le&&(pe+=' title="'+le+'"'),pe+=this.options.xhtml?"/>":">",pe},Se.text=function(se){return se},De}(),q=function(){function De(){}var Se=De.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,le,fe){return""+fe},Se.image=function(se,le,fe){return""+fe},Se.br=function(){return""},De}(),ie=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,le){var fe=se,pe=0;if(this.seen.hasOwnProperty(fe)){pe=this.seen[se];do pe++,fe=se+"-"+pe;while(this.seen.hasOwnProperty(fe))}return le||(this.seen[se]=pe,this.seen[fe]=0),fe},Se.slug=function(se,le){le===void 0&&(le={});var fe=this.serialize(se);return this.getNextSafeSlug(fe,le.dryrun)},De}(),ge=A.defaults,Re=F.unescape,We=function(){function De(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ie}De.parse=function(se,le){var fe=new De(le);return fe.parse(se)},De.parseInline=function(se,le){var fe=new De(le);return fe.parseInline(se)};var Se=De.prototype;return Se.parse=function(se,le){le===void 0&&(le=!0);var fe="",pe,B,me,we,Ie,Oe,He,Ze,Ke,Qe,ut,mt,bt,ot,at,_e,ke,Y,H=se.length;for(pe=0;pe<H;pe++)switch(Qe=se[pe],Qe.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,Re(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(Ze="",He="",we=Qe.header.length,B=0;B<we;B++)He+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[B]),{header:!0,align:Qe.align[B]});for(Ze+=this.renderer.tablerow(He),Ke="",we=Qe.cells.length,B=0;B<we;B++){for(Oe=Qe.tokens.cells[B],He="",Ie=Oe.length,me=0;me<Ie;me++)He+=this.renderer.tablecell(this.parseInline(Oe[me]),{header:!1,align:Qe.align[me]});Ke+=this.renderer.tablerow(He)}fe+=this.renderer.table(Ze,Ke);continue}case"blockquote":{Ke=this.parse(Qe.tokens),fe+=this.renderer.blockquote(Ke);continue}case"list":{for(ut=Qe.ordered,mt=Qe.start,bt=Qe.loose,we=Qe.items.length,Ke="",B=0;B<we;B++)at=Qe.items[B],_e=at.checked,ke=at.task,ot="",at.task&&(Y=this.renderer.checkbox(_e),bt?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=Y+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=Y+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:Y}):ot+=Y),ot+=this.parse(at.tokens,bt),Ke+=this.renderer.listitem(ot,ke,_e);fe+=this.renderer.list(Ke,ut,mt);continue}case"html":{fe+=this.renderer.html(Qe.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(Ke=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;pe+1<H&&se[pe+1].type==="text";)Qe=se[++pe],Ke+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);fe+=le?this.renderer.paragraph(Ke):Ke;continue}default:{var Fe='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return fe},Se.parseInline=function(se,le){le=le||this.renderer;var fe="",pe,B,me=se.length;for(pe=0;pe<me;pe++)switch(B=se[pe],B.type){case"escape":{fe+=le.text(B.text);break}case"html":{fe+=le.html(B.text);break}case"link":{fe+=le.link(B.href,B.title,this.parseInline(B.tokens,le));break}case"image":{fe+=le.image(B.href,B.title,B.text);break}case"strong":{fe+=le.strong(this.parseInline(B.tokens,le));break}case"em":{fe+=le.em(this.parseInline(B.tokens,le));break}case"codespan":{fe+=le.codespan(B.text);break}case"br":{fe+=le.br();break}case"del":{fe+=le.del(this.parseInline(B.tokens,le));break}case"text":{fe+=le.text(B.text);break}default:{var we='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return fe},De}(),ve=F.merge,Je=F.checkSanitizeDeprecation,z=F.escape,Z=A.getDefaults,ce=A.changeDefaults,Ue=A.defaults;function xe(De,Se,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=ve({},xe.defaults,Se||{}),Je(Se),Pe){var se=Se.highlight,le;try{le=je.lex(De,Se)}catch(me){return Pe(me)}var fe=function(we){var Ie;if(!we)try{Ie=We.parse(le,Se)}catch(Oe){we=Oe}return Se.highlight=se,we?Pe(we):Pe(null,Ie)};if(!se||se.length<3||(delete Se.highlight,!le.length))return fe();var pe=0;xe.walkTokens(le,function(me){me.type==="code"&&(pe++,setTimeout(function(){se(me.text,me.lang,function(we,Ie){if(we)return fe(we);Ie!=null&&Ie!==me.text&&(me.text=Ie,me.escaped=!0),pe--,pe===0&&fe()})},0))}),pe===0&&fe();return}try{var B=je.lex(De,Se);return Se.walkTokens&&xe.walkTokens(B,Se.walkTokens),We.parse(B,Se)}catch(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+z(me.message+"",!0)+"</pre>";throw me}}xe.options=xe.setOptions=function(De){return ve(xe.defaults,De),ce(xe.defaults),xe},xe.getDefaults=Z,xe.defaults=Ue,xe.use=function(De){var Se=ve({},De);if(De.renderer&&function(){var se=xe.defaults.renderer||new re,le=function(B){var me=se[B];se[B]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.renderer[B].apply(se,Ie);return He===!1&&(He=me.apply(se,Ie)),He}};for(var fe in De.renderer)le(fe);Se.renderer=se}(),De.tokenizer&&function(){var se=xe.defaults.tokenizer||new Q,le=function(B){var me=se[B];se[B]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.tokenizer[B].apply(se,Ie);return He===!1&&(He=me.apply(se,Ie)),He}};for(var fe in De.tokenizer)le(fe);Se.tokenizer=se}(),De.walkTokens){var Pe=xe.defaults.walkTokens;Se.walkTokens=function(se){De.walkTokens(se),Pe&&Pe(se)}}xe.setOptions(Se)},xe.walkTokens=function(De,Se){for(var Pe=S(De),se;!(se=Pe()).done;){var le=se.value;switch(Se(le),le.type){case"table":{for(var fe=S(le.tokens.header),pe;!(pe=fe()).done;){var B=pe.value;xe.walkTokens(B,Se)}for(var me=S(le.tokens.cells),we;!(we=me()).done;)for(var Ie=we.value,Oe=S(Ie),He;!(He=Oe()).done;){var Ze=He.value;xe.walkTokens(Ze,Se)}break}case"list":{xe.walkTokens(le.items,Se);break}default:le.tokens&&xe.walkTokens(le.tokens,Se)}}},xe.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=ve({},xe.defaults,Se||{}),Je(Se);try{var Pe=je.lexInline(De,Se);return Se.walkTokens&&xe.walkTokens(Pe,Se.walkTokens),We.parseInline(Pe,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+z(se.message+"",!0)+"</pre>";throw se}},xe.Parser=We,xe.parser=We.parse,xe.Renderer=re,xe.TextRenderer=q,xe.Lexer=je,xe.lexer=je.lex,xe.Tokenizer=Q,xe.Slugger=ie,xe.parse=xe;var et=xe;return et}),define(be[81],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(A,_,y){return Math.min(Math.max(A,_),y)}e.clamp=h;function R(A,_){return(_+A%_)%_}e.rot=R;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class E{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function ee(S){const E=[];typeof S=="number"&&E.push("code/timeOrigin",S);function A(y){E.push(y,Date.now())}function _(){const y=[];for(let I=0;I<E.length;I+=2)y.push({name:E[I],startTime:E[I+1]});return y}return{mark:A,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const A of performance.getEntriesByType("mark"))E.push({name:A.name,startTime:Math.round(S+A.startTime)});return E}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function h(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=h(R))}(),define(be[22],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const h="en";let R=!1,S=!1,E=!1,A=!1,_=!1,y=!1,I=!1,n,C=h,l,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const g=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=g&&u?.sandboxed,typeof navigator=="object"&&!g)f=navigator.userAgent,R=f.indexOf("Windows")>=0,S=f.indexOf("Macintosh")>=0,I=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=f.indexOf("Linux")>=0,y=!0,n=navigator.language,C=n;else if(typeof u=="object"){R=u.platform==="win32",S=u.platform==="darwin",E=u.platform==="linux",A=E&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=h,C=h;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const i=JSON.parse(a),c=i.availableLanguages["*"];n=i.locale,C=c||h,l=i._translationsConfigFile}catch(i){}_=!0}else console.error("Unable to resolve platform.");var b;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let T=0;S?T=1:R?T=3:E&&(T=2),e.isWindows=R,e.isMacintosh=S,e.isLinux=E,e.isLinuxSnap=A,e.isNative=_,e.isWeb=y,e.isIOS=I,e.platform=T,e.userAgent=f,e.language=C;var o;(function(a){function i(){return e.language}a.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=c;function p(){return e.language==="en"}a.isDefault=p})(o=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let D=0,k=c.length;D<k;D++){const s=c[D];if(s.id===d.data.vscodeSetImmediateId){c.splice(D,1),s.callback();return}}});let p=0;return d=>{const D=++p;c.push({id:D,callback:d}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var m;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||I?2:R?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,v=new Uint16Array(a.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(be[42],Ee([0,1,22]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof h.globals.vscode!="undefined"&&typeof h.globals.vscode.process!="undefined"){const S=h.globals.vscode.process;R={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(E){return(0,h.setImmediate)(E)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:R={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},nextTick(S){return(0,h.setImmediate)(S)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[14],Ee([0,1,42]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,S=97,E=90,A=122,_=46,y=47,I=92,n=58,C=63;class l extends Error{constructor(m,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const a=m.indexOf(".")!==-1?"property":"argument";let i=`The "${m}" ${a} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(o,m){if(typeof o!="string")throw new l(m,"string",o)}function u(o){return o===y||o===I}function g(o){return o===y}function b(o){return o>=R&&o<=E||o>=S&&o<=A}function w(o,m,v,t){let r="",a=0,i=-1,c=0,p=0;for(let d=0;d<=o.length;++d){if(d<o.length)p=o.charCodeAt(d);else{if(t(p))break;p=y}if(t(p)){if(!(i===d-1||c===1))if(c===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==_||r.charCodeAt(r.length-2)!==_){if(r.length>2){const D=r.lastIndexOf(v);D===-1?(r="",a=0):(r=r.slice(0,D),a=r.length-1-r.lastIndexOf(v)),i=d,c=0;continue}else if(r.length!==0){r="",a=0,i=d,c=0;continue}}m&&(r+=r.length>0?`${v}..`:"..",a=2)}else r.length>0?r+=`${v}${o.slice(i+1,d)}`:r=o.slice(i+1,d),a=d-i-1;i=d,c=0}else p===_&&c!==-1?++c:c=-1}return r}function T(o,m){if(m===null||typeof m!="object")throw new l("pathObject","Object",m);const v=m.dir||m.root,t=m.base||`${m.name||""}${m.ext||""}`;return v?v===m.root?`${v}${t}`:`${v}${o}${t}`:t}e.win32={resolve(...o){let m="",v="",t=!1;for(let r=o.length-1;r>=-1;r--){let a;if(r>=0){if(a=o[r],f(a,"path"),a.length===0)continue}else m.length===0?a=h.cwd():(a=h.env[`=${m}`]||h.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==m.toLowerCase()&&a.charCodeAt(2)===I)&&(a=`${m}\\`));const i=a.length;let c=0,p="",d=!1;const D=a.charCodeAt(0);if(i===1)u(D)&&(c=1,d=!0);else if(u(D))if(d=!0,u(a.charCodeAt(1))){let k=2,s=k;for(;k<i&&!u(a.charCodeAt(k));)k++;if(k<i&&k!==s){const P=a.slice(s,k);for(s=k;k<i&&u(a.charCodeAt(k));)k++;if(k<i&&k!==s){for(s=k;k<i&&!u(a.charCodeAt(k));)k++;(k===i||k!==s)&&(p=`\\\\${P}\\${a.slice(s,k)}`,c=k)}}}else c=1;else b(D)&&a.charCodeAt(1)===n&&(p=a.slice(0,2),c=2,i>2&&u(a.charCodeAt(2))&&(d=!0,c=3));if(p.length>0)if(m.length>0){if(p.toLowerCase()!==m.toLowerCase())continue}else m=p;if(t){if(m.length>0)break}else if(v=`${a.slice(c)}\\${v}`,t=d,d&&m.length>0)break}return v=w(v,!t,"\\",u),t?`${m}\\${v}`:`${m}${v}`||"."},normalize(o){f(o,"path");const m=o.length;if(m===0)return".";let v=0,t,r=!1;const a=o.charCodeAt(0);if(m===1)return g(a)?"\\":o;if(u(a))if(r=!0,u(o.charCodeAt(1))){let c=2,p=c;for(;c<m&&!u(o.charCodeAt(c));)c++;if(c<m&&c!==p){const d=o.slice(p,c);for(p=c;c<m&&u(o.charCodeAt(c));)c++;if(c<m&&c!==p){for(p=c;c<m&&!u(o.charCodeAt(c));)c++;if(c===m)return`\\\\${d}\\${o.slice(p)}\\`;c!==p&&(t=`\\\\${d}\\${o.slice(p,c)}`,v=c)}}}else v=1;else b(a)&&o.charCodeAt(1)===n&&(t=o.slice(0,2),v=2,m>2&&u(o.charCodeAt(2))&&(r=!0,v=3));let i=v<m?w(o.slice(v),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(o.charCodeAt(m-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(o){f(o,"path");const m=o.length;if(m===0)return!1;const v=o.charCodeAt(0);return u(v)||m>2&&b(v)&&o.charCodeAt(1)===n&&u(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let m,v;for(let a=0;a<o.length;++a){const i=o[a];f(i,"path"),i.length>0&&(m===void 0?m=v=i:m+=`\\${i}`)}if(m===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++r;const a=v.length;a>1&&u(v.charCodeAt(1))&&(++r,a>2&&(u(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<m.length&&u(m.charCodeAt(r));)r++;r>=2&&(m=`\\${m.slice(r)}`)}return e.win32.normalize(m)},relative(o,m){if(f(o,"from"),f(m,"to"),o===m)return"";const v=e.win32.resolve(o),t=e.win32.resolve(m);if(v===t||(o=v.toLowerCase(),m=t.toLowerCase(),o===m))return"";let r=0;for(;r<o.length&&o.charCodeAt(r)===I;)r++;let a=o.length;for(;a-1>r&&o.charCodeAt(a-1)===I;)a--;const i=a-r;let c=0;for(;c<m.length&&m.charCodeAt(c)===I;)c++;let p=m.length;for(;p-1>c&&m.charCodeAt(p-1)===I;)p--;const d=p-c,D=i<d?i:d;let k=-1,s=0;for(;s<D;s++){const F=o.charCodeAt(r+s);if(F!==m.charCodeAt(c+s))break;F===I&&(k=s)}if(s!==D){if(k===-1)return t}else{if(d>D){if(m.charCodeAt(c+s)===I)return t.slice(c+s+1);if(s===2)return t.slice(c+s)}i>D&&(o.charCodeAt(r+s)===I?k=s:s===2&&(k=3)),k===-1&&(k=0)}let P="";for(s=r+k+1;s<=a;++s)(s===a||o.charCodeAt(s)===I)&&(P+=P.length===0?"..":"\\..");return c+=k,P.length>0?`${P}${t.slice(c,p)}`:(t.charCodeAt(c)===I&&++c,t.slice(c,p))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const m=e.win32.resolve(o);if(m.length<=2)return o;if(m.charCodeAt(0)===I){if(m.charCodeAt(1)===I){const v=m.charCodeAt(2);if(v!==C&&v!==_)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(b(m.charCodeAt(0))&&m.charCodeAt(1)===n&&m.charCodeAt(2)===I)return`\\\\?\\${m}`;return o},dirname(o){f(o,"path");const m=o.length;if(m===0)return".";let v=-1,t=0;const r=o.charCodeAt(0);if(m===1)return u(r)?o:".";if(u(r)){if(v=t=1,u(o.charCodeAt(1))){let c=2,p=c;for(;c<m&&!u(o.charCodeAt(c));)c++;if(c<m&&c!==p){for(p=c;c<m&&u(o.charCodeAt(c));)c++;if(c<m&&c!==p){for(p=c;c<m&&!u(o.charCodeAt(c));)c++;if(c===m)return o;c!==p&&(v=t=c+1)}}}}else b(r)&&o.charCodeAt(1)===n&&(v=m>2&&u(o.charCodeAt(2))?3:2,t=v);let a=-1,i=!0;for(let c=m-1;c>=t;--c)if(u(o.charCodeAt(c))){if(!i){a=c;break}}else i=!1;if(a===-1){if(v===-1)return".";a=v}return o.slice(0,a)},basename(o,m){m!==void 0&&f(m,"ext"),f(o,"path");let v=0,t=-1,r=!0,a;if(o.length>=2&&b(o.charCodeAt(0))&&o.charCodeAt(1)===n&&(v=2),m!==void 0&&m.length>0&&m.length<=o.length){if(m===o)return"";let i=m.length-1,c=-1;for(a=o.length-1;a>=v;--a){const p=o.charCodeAt(a);if(u(p)){if(!r){v=a+1;break}}else c===-1&&(r=!1,c=a+1),i>=0&&(p===m.charCodeAt(i)?--i==-1&&(t=a):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=o.length),o.slice(v,t)}for(a=o.length-1;a>=v;--a)if(u(o.charCodeAt(a))){if(!r){v=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":o.slice(v,t)},extname(o){f(o,"path");let m=0,v=-1,t=0,r=-1,a=!0,i=0;o.length>=2&&o.charCodeAt(1)===n&&b(o.charCodeAt(0))&&(m=t=2);for(let c=o.length-1;c>=m;--c){const p=o.charCodeAt(c);if(u(p)){if(!a){t=c+1;break}continue}r===-1&&(a=!1,r=c+1),p===_?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":o.slice(v,r)},format:T.bind(null,"\\"),parse(o){f(o,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return m;const v=o.length;let t=0,r=o.charCodeAt(0);if(v===1)return u(r)?(m.root=m.dir=o,m):(m.base=m.name=o,m);if(u(r)){if(t=1,u(o.charCodeAt(1))){let k=2,s=k;for(;k<v&&!u(o.charCodeAt(k));)k++;if(k<v&&k!==s){for(s=k;k<v&&u(o.charCodeAt(k));)k++;if(k<v&&k!==s){for(s=k;k<v&&!u(o.charCodeAt(k));)k++;k===v?t=k:k!==s&&(t=k+1)}}}}else if(b(r)&&o.charCodeAt(1)===n){if(v<=2)return m.root=m.dir=o,m;if(t=2,u(o.charCodeAt(2))){if(v===3)return m.root=m.dir=o,m;t=3}}t>0&&(m.root=o.slice(0,t));let a=-1,i=t,c=-1,p=!0,d=o.length-1,D=0;for(;d>=t;--d){if(r=o.charCodeAt(d),u(r)){if(!p){i=d+1;break}continue}c===-1&&(p=!1,c=d+1),r===_?a===-1?a=d:D!==1&&(D=1):a!==-1&&(D=-1)}return c!==-1&&(a===-1||D===0||D===1&&a===c-1&&a===i+1?m.base=m.name=o.slice(i,c):(m.name=o.slice(i,a),m.base=o.slice(i,c),m.ext=o.slice(a,c))),i>0&&i!==t?m.dir=o.slice(0,i-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let m="",v=!1;for(let t=o.length-1;t>=-1&&!v;t--){const r=t>=0?o[t]:h.cwd();f(r,"path"),r.length!==0&&(m=`${r}/${m}`,v=r.charCodeAt(0)===y)}return m=w(m,!v,"/",g),v?`/${m}`:m.length>0?m:"."},normalize(o){if(f(o,"path"),o.length===0)return".";const m=o.charCodeAt(0)===y,v=o.charCodeAt(o.length-1)===y;return o=w(o,!m,"/",g),o.length===0?m?"/":v?"./":".":(v&&(o+="/"),m?`/${o}`:o)},isAbsolute(o){return f(o,"path"),o.length>0&&o.charCodeAt(0)===y},join(...o){if(o.length===0)return".";let m;for(let v=0;v<o.length;++v){const t=o[v];f(t,"path"),t.length>0&&(m===void 0?m=t:m+=`/${t}`)}return m===void 0?".":e.posix.normalize(m)},relative(o,m){if(f(o,"from"),f(m,"to"),o===m||(o=e.posix.resolve(o),m=e.posix.resolve(m),o===m))return"";const v=1,t=o.length,r=t-v,a=1,i=m.length-a,c=r<i?r:i;let p=-1,d=0;for(;d<c;d++){const k=o.charCodeAt(v+d);if(k!==m.charCodeAt(a+d))break;k===y&&(p=d)}if(d===c)if(i>c){if(m.charCodeAt(a+d)===y)return m.slice(a+d+1);if(d===0)return m.slice(a+d)}else r>c&&(o.charCodeAt(v+d)===y?p=d:d===0&&(p=0));let D="";for(d=v+p+1;d<=t;++d)(d===t||o.charCodeAt(d)===y)&&(D+=D.length===0?"..":"/..");return`${D}${m.slice(a+p)}`},toNamespacedPath(o){return o},dirname(o){if(f(o,"path"),o.length===0)return".";const m=o.charCodeAt(0)===y;let v=-1,t=!0;for(let r=o.length-1;r>=1;--r)if(o.charCodeAt(r)===y){if(!t){v=r;break}}else t=!1;return v===-1?m?"/":".":m&&v===1?"//":o.slice(0,v)},basename(o,m){m!==void 0&&f(m,"ext"),f(o,"path");let v=0,t=-1,r=!0,a;if(m!==void 0&&m.length>0&&m.length<=o.length){if(m===o)return"";let i=m.length-1,c=-1;for(a=o.length-1;a>=0;--a){const p=o.charCodeAt(a);if(p===y){if(!r){v=a+1;break}}else c===-1&&(r=!1,c=a+1),i>=0&&(p===m.charCodeAt(i)?--i==-1&&(t=a):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=o.length),o.slice(v,t)}for(a=o.length-1;a>=0;--a)if(o.charCodeAt(a)===y){if(!r){v=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":o.slice(v,t)},extname(o){f(o,"path");let m=-1,v=0,t=-1,r=!0,a=0;for(let i=o.length-1;i>=0;--i){const c=o.charCodeAt(i);if(c===y){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),c===_?m===-1?m=i:a!==1&&(a=1):m!==-1&&(a=-1)}return m===-1||t===-1||a===0||a===1&&m===t-1&&m===v+1?"":o.slice(m,t)},format:T.bind(null,"/"),parse(o){f(o,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return m;const v=o.charCodeAt(0)===y;let t;v?(m.root="/",t=1):t=0;let r=-1,a=0,i=-1,c=!0,p=o.length-1,d=0;for(;p>=t;--p){const D=o.charCodeAt(p);if(D===y){if(!c){a=p+1;break}continue}i===-1&&(c=!1,i=p+1),D===_?r===-1?r=p:d!==1&&(d=1):r!==-1&&(d=-1)}if(i!==-1){const D=a===0&&v?1:a;r===-1||d===0||d===1&&r===i-1&&r===a+1?m.base=m.name=o.slice(D,i):(m.name=o.slice(D,r),m.base=o.slice(D,i),m.ext=o.slice(r,i))}return a>0?m.dir=o.slice(0,a-1):v&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],Ee([0,1,22]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=h.globals.performance&&typeof h.globals.performance.now=="function";class S{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new S(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=S}),define(be[3],Ee([0,1,12,53,6,80,56]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var _;(function(o){o.None=()=>S.Disposable.None;function m(oe){return(V,W=null,L)=>{let Q=!1,O;return O=oe(G=>{if(!Q)return O?O.dispose():Q=!0,V.call(W,G)},null,L),Q&&O.dispose(),O}}o.once=m;function v(oe,V){return p((W,L=null,Q)=>oe(O=>W.call(L,V(O)),null,Q))}o.map=v;function t(oe,V){return p((W,L=null,Q)=>oe(O=>{V(O),W.call(L,O)},null,Q))}o.forEach=t;function r(oe,V){return p((W,L=null,Q)=>oe(O=>V(O)&&W.call(L,O),null,Q))}o.filter=r;function a(oe){return oe}o.signal=a;function i(...oe){return(V,W=null,L)=>(0,S.combinedDisposable)(...oe.map(Q=>Q(O=>V.call(W,O),null,L)))}o.any=i;function c(oe,V,W){let L=W;return v(oe,Q=>(L=V(L,Q),L))}o.reduce=c;function p(oe){let V;const W=new l({onFirstListenerAdd(){V=oe(W.fire,W)},onLastListenerRemove(){V.dispose()}});return W.event}function d(oe,V,W=100,L=!1,Q){let O,G,de,$=0;const ne=new l({leakWarningThreshold:Q,onFirstListenerAdd(){O=oe(he=>{$++,G=V(G,he),L&&!de&&(ne.fire(G),G=void 0),clearTimeout(de),de=setTimeout(()=>{const ye=G;G=void 0,de=void 0,(!L||$>1)&&ne.fire(ye),$=0},W)})},onLastListenerRemove(){O.dispose()}});return ne.event}o.debounce=d;function D(oe,V=(W,L)=>W===L){let W=!0,L;return r(oe,Q=>{const O=W||!V(Q,L);return W=!1,L=Q,O})}o.latch=D;function k(oe,V){return[o.filter(oe,V),o.filter(oe,W=>!V(W))]}o.split=k;function s(oe,V=!1,W=[]){let L=W.slice(),Q=oe(de=>{L?L.push(de):G.fire(de)});const O=()=>{L&&L.forEach(de=>G.fire(de)),L=null},G=new l({onFirstListenerAdd(){Q||(Q=oe(de=>G.fire(de)))},onFirstListenerDidAdd(){L&&(V?setTimeout(O):O())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return G.event}o.buffer=s;class P{constructor(V){this.event=V}map(V){return new P(v(this.event,V))}forEach(V){return new P(t(this.event,V))}filter(V){return new P(r(this.event,V))}reduce(V,W){return new P(c(this.event,V,W))}latch(){return new P(D(this.event))}debounce(V,W=100,L=!1,Q){return new P(d(this.event,V,W,L,Q))}on(V,W,L){return this.event(V,W,L)}once(V,W,L){return m(this.event)(V,W,L)}}function F(oe){return new P(oe)}o.chain=F;function x(oe,V,W=L=>L){const L=(...de)=>G.fire(W(...de)),Q=()=>oe.on(V,L),O=()=>oe.removeListener(V,L),G=new l({onFirstListenerAdd:Q,onLastListenerRemove:O});return G.event}o.fromNodeEventEmitter=x;function j(oe,V,W=L=>L){const L=(...de)=>G.fire(W(...de)),Q=()=>oe.addEventListener(V,L),O=()=>oe.removeEventListener(V,L),G=new l({onFirstListenerAdd:Q,onLastListenerRemove:O});return G.event}o.fromDOMEventEmitter=j;function ae(oe){return new Promise(V=>m(oe)(V))}o.toPromise=ae})(_=e.Event||(e.Event={}));class y{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${y._idPool++}`}start(m){this._stopWatch=new A.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let I=-1;function n(o){const m=I;return I=o,{dispose(){I=m}}}e.setGlobalLeakWarningThreshold=n;class C{constructor(m,v=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let v=I;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||m<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let a,i=0;for(const[c,p]of this._stacks)(!a||i<p)&&(a=c,i=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${i}):`),console.warn(a)}return()=>{const a=this._stacks.get(t)||0;this._stacks.set(t,a-1)}}}class l{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=I>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(m,v,t)=>{this._listeners||(this._listeners=new E.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(v?[m,v]:m);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,S.toDisposable)(()=>{i&&i(),this._disposed||(a(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof S.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,h.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class f extends l{async fireAsync(m,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,m]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,a]=this._asyncDeliveryQueue.shift(),i=[],c={...a,waitUntil:p=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(p=t(p,typeof r=="function"?r:r[0])),i.push(p)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(p){(0,h.onUnexpectedError)(p);continue}Object.freeze(i),await Promise.allSettled(i).then(p=>{for(const d of p)d.status==="rejected"&&(0,h.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=f;class u extends l{constructor(m){super(m);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=u;class g extends u{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const v={event:m,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,S.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(v=>this.emitter.fire(v))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class w{constructor(){this.buffers=[]}wrapEvent(m){return(v,t,r)=>m(a=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,a)):v.call(t,a)},void 0,r)}bufferEvents(m){const v=[];this.buffers.push(v);const t=m();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=w;class T{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=S.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=T}),define(be[20],Ee([0,1,3]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(_,y){const I=setTimeout(_.bind(y),0);return{dispose(){clearTimeout(I)}}});var S;(function(_){function y(I){return I===_.None||I===_.Cancelled||I instanceof E?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}_.isCancellationToken=y,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(S=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=S.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=A}),define(be[35],Ee([0,1,3]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(C){const l=this._icons.get(C.id);l?C.description?l.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new R;e.iconRegistry=S;function E(n,C){return new _(n,C)}e.registerCodicon=E;function A(n){return n?n.replace(/\$\((.*?)\)/g,(C,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class _{constructor(C,l,f){this.id=C,this.definition=l,this.description=f,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=_;function y(n,C){const l=["codicon","codicon-"+n];return C&&l.push("codicon-modifier-"+C),l}e.getClassNamesArray=y;var I;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(g){if(g instanceof _)return["codicon","codicon-"+g.id];const b=C.exec(g.id);if(!b)return l(_.error);let[,w,T]=b;const o=["codicon","codicon-"+w];return T&&o.push("codicon-modifier-"+T.substr(1)),o}n.asClassNameArray=l;function f(g){return l(g).join(" ")}n.asClassName=f;function u(g){return"."+l(g).join(".")}n.asCSSSelector=u})(I=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(_=e.Codicon||(e.Codicon={}))}),define(be[113],Ee([0,1,12,6]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(o){const m=o;return m?[m.on,m.pause,m.resume,m.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=S;function E(o){const m=o;return m?S(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=E;function A(o,m){return new _(o,m)}e.newWriteableStream=A;class _{constructor(m,v){this.reducer=m,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(v=>v(m))}emitError(m){this.listeners.error.length===0?(0,h.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(v=>v(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,v){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(m,v){if(this.state.destroyed)return;let t;switch(m){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(o,m){const v=[];let t;for(;(t=o.read())!==null;)v.push(t);return m(v)}e.consumeReadable=y;function I(o,m,v){const t=[];let r;for(;(r=o.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?m(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const a=r;return r=void 0,a}return o.read()}}}e.peekReadable=I;function n(o,m){return new Promise((v,t)=>{const r=[];C(o,{onData:a=>{m&&r.push(a)},onError:a=>{m?t(a):v(void 0)},onEnd:()=>{v(m?m(r):void 0)}})})}e.consumeStream=n;function C(o,m){o.on("error",v=>m.onError(v)),o.on("end",()=>m.onEnd()),o.on("data",v=>m.onData(v))}e.listenStream=C;function l(o,m){return new Promise((v,t)=>{const r=new R.DisposableStore,a=[],i=d=>{if(a.push(d),a.length>m)return r.dispose(),o.pause(),v({stream:o,buffer:a,ended:!1})},c=d=>t(d),p=()=>v({stream:o,buffer:a,ended:!0});r.add((0,R.toDisposable)(()=>o.removeListener("error",c))),o.on("error",c),r.add((0,R.toDisposable)(()=>o.removeListener("end",p))),o.on("end",p),r.add((0,R.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=l;function f(o,m){const v=A(m);return v.end(o),v}e.toStream=f;function u(){const o=A(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=u;function g(o){let m=!1;return{read:()=>m?null:(m=!0,o)}}e.toReadable=g;function b(o,m,v){const t=A(v);return C(o,{onData:r=>t.write(m.data(r)),onError:r=>t.error(m.error?m.error(r):r),onEnd:()=>t.end()}),t}e.transform=b;function w(o,m,v){let t=!1;return{read:()=>{const r=m.read();return t?r:(t=!0,r!==null?v([o,r]):o)}}}e.prefixedReadable=w;function T(o,m,v){let t=!1;const r=A(v);return C(m,{onData:a=>t?r.write(a):(t=!0,r.write(v([o,a]))),onError:a=>r.error(a),onEnd:()=>{t||(t=!0,r.write(o)),r.end()}}),r}e.prefixedStream=T}),define(be[8],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function h(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=h;const R=/{(\d+)}/g;function S(B,...me){return me.length===0?B:B.replace(R,function(we,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=me.length?we:me[Oe]})}e.format=S;const E=/{([^}]+)}/g;function A(B,me){return B.replace(E,(we,Ie)=>me[Ie]??we)}e.format2=A;function _(B){return B.replace(/[<>&]/g,function(me){switch(me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return me}})}e.escape=_;function y(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function I(B,me){let we=0;const Ie=me.charCodeAt(0);for(let Oe=B.length-1;Oe>=0;Oe--)B.charCodeAt(Oe)===Ie&&we++;return we}e.count=I;function n(B,me,we="\u2026"){return B.length<=me?B:`${B.substr(0,me)}${we}`}e.truncate=n;function C(B,me=" "){const we=l(B,me);return f(we,me)}e.trim=C;function l(B,me){if(!B||!me)return B;const we=me.length;if(we===0||B.length===0)return B;let Ie=0;for(;B.indexOf(me,Ie)===Ie;)Ie=Ie+we;return B.substring(Ie)}e.ltrim=l;function f(B,me){if(!B||!me)return B;const we=me.length,Ie=B.length;if(we===0||Ie===0)return B;let Oe=Ie,He=-1;for(;He=B.lastIndexOf(me,Oe-1),!(He===-1||He+we!==Oe);){if(He===0)return"";Oe=He}return B.substring(0,Oe)}e.rtrim=f;function u(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(B){return B.replace(/\*/g,"")}e.stripWildcards=g;function b(B,me,we={}){if(!B)throw new Error("Cannot create regex from empty string");me||(B=y(B)),we.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let Ie="";return we.global&&(Ie+="g"),we.matchCase||(Ie+="i"),we.multiline&&(Ie+="m"),we.unicode&&(Ie+="u"),new RegExp(B,Ie)}e.createRegExp=b;function w(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function T(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=T;function o(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=o;function m(B){return B.split(/\r\n|\r|\n/)}e.splitLines=m;function v(B){for(let me=0,we=B.length;me<we;me++){const Ie=B.charCodeAt(me);if(Ie!==32&&Ie!==9)return me}return-1}e.firstNonWhitespaceIndex=v;function t(B,me=0,we=B.length){for(let Ie=me;Ie<we;Ie++){const Oe=B.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return B.substring(me,Ie)}return B.substring(me,we)}e.getLeadingWhitespace=t;function r(B,me=B.length-1){for(let we=me;we>=0;we--){const Ie=B.charCodeAt(we);if(Ie!==32&&Ie!==9)return we}return-1}e.lastNonWhitespaceIndex=r;function a(B,me){return B<me?-1:B>me?1:0}e.compare=a;function i(B,me,we=0,Ie=B.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Qe=B.charCodeAt(we),ut=me.charCodeAt(Oe);if(Qe<ut)return-1;if(Qe>ut)return 1}const Ze=Ie-we,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstring=i;function c(B,me){return p(B,me,0,B.length,0,me.length)}e.compareIgnoreCase=c;function p(B,me,we=0,Ie=B.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Qe=B.charCodeAt(we),ut=me.charCodeAt(Oe);if(Qe===ut)continue;const mt=Qe-ut;if(!(mt===32&&D(ut))&&!(mt===-32&&D(Qe)))return d(Qe)&&d(ut)?mt:i(B.toLowerCase(),me.toLowerCase(),we,Ie,Oe,He)}const Ze=Ie-we,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstringIgnoreCase=p;function d(B){return B>=97&&B<=122}e.isLowerAsciiLetter=d;function D(B){return B>=65&&B<=90}e.isUpperAsciiLetter=D;function k(B){return d(B)||D(B)}function s(B,me){return B.length===me.length&&P(B,me)}e.equalsIgnoreCase=s;function P(B,me,we=B.length){for(let Ie=0;Ie<we;Ie++){const Oe=B.charCodeAt(Ie),He=me.charCodeAt(Ie);if(Oe!==He){if(k(Oe)&&k(He)){const Ze=Math.abs(Oe-He);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function F(B,me){const we=me.length;return me.length>B.length?!1:P(B,me,we)}e.startsWithIgnoreCase=F;function x(B,me){let we,Ie=Math.min(B.length,me.length);for(we=0;we<Ie;we++)if(B.charCodeAt(we)!==me.charCodeAt(we))return we;return Ie}e.commonPrefixLength=x;function j(B,me){let we,Ie=Math.min(B.length,me.length);const Oe=B.length-1,He=me.length-1;for(we=0;we<Ie;we++)if(B.charCodeAt(Oe-we)!==me.charCodeAt(He-we))return we;return Ie}e.commonSuffixLength=j;function ae(B){return 55296<=B&&B<=56319}e.isHighSurrogate=ae;function oe(B){return 56320<=B&&B<=57343}e.isLowSurrogate=oe;function V(B,me){return(B-55296<<10)+(me-56320)+65536}e.computeCodePoint=V;function W(B,me,we){const Ie=B.charCodeAt(we);if(ae(Ie)&&we+1<me){const Oe=B.charCodeAt(we+1);if(oe(Oe))return V(Ie,Oe)}return Ie}e.getNextCodePoint=W;function L(B,me){const we=B.charCodeAt(me-1);if(oe(we)&&me>1){const Ie=B.charCodeAt(me-2);if(ae(Ie))return V(Ie,we)}return we}function Q(B,me){const we=De.getInstance(),Ie=me,Oe=B.length,He=W(B,Oe,me);me+=He>=65536?2:1;let Ze=we.getGraphemeBreakType(He);for(;me<Oe;){const Ke=W(B,Oe,me),Qe=we.getGraphemeBreakType(Ke);if(xe(Ze,Qe))break;me+=Ke>=65536?2:1,Ze=Qe}return me-Ie}e.nextCharLength=Q;function O(B,me){const we=De.getInstance(),Ie=me,Oe=L(B,me);me-=Oe>=65536?2:1;let He=we.getGraphemeBreakType(Oe);for(;me>0;){const Ze=L(B,me),Ke=we.getGraphemeBreakType(Ze);if(xe(Ke,He))break;me-=Ze>=65536?2:1,He=Ke}return Ie-me}e.prevCharLength=O;function G(B,me){const we=De.getInstance(),Ie=B.length,Oe=me,He=W(B,Ie,me),Ze=we.getGraphemeBreakType(He);me+=He>=65536?2:1;let Ke=Ze;for(;me<Ie;){const ut=W(B,Ie,me),mt=we.getGraphemeBreakType(ut);if(xe(Ke,mt))break;me+=ut>=65536?2:1,Ke=mt}const Qe=me;for(me=Oe,Ke=Ze;me>0;){const ut=L(B,me),mt=we.getGraphemeBreakType(ut);if(xe(mt,Ke))break;me-=ut>=65536?2:1,Ke=mt}return[me,Qe]}function de(B,me){return me>0&&oe(B.charCodeAt(me))?G(B,me-1):G(B,me)}e.getCharContainingOffset=de;function $(B){const me=B.length;let we=0,Ie=0;for(;Ie<me;){const Ze=W(B,me,Ie);Ie+=Ze>=65536?2:1,Ze<128?we+=1:Ze<2048?we+=2:Ze<65536?we+=3:we+=4}const Oe=new Uint8Array(we);Ie=0;let He=0;for(;Ie<me;){const Ze=W(B,me,Ie);Ie+=Ze>=65536?2:1,Ze<128?Oe[He++]=Ze:Ze<2048?(Oe[He++]=192|(Ze&1984)>>>6,Oe[He++]=128|(Ze&63)>>>0):Ze<65536?(Oe[He++]=224|(Ze&61440)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0):(Oe[He++]=240|(Ze&1835008)>>>18,Oe[He++]=128|(Ze&258048)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0)}return Oe}e.encodeUTF8=$;function ne(B){const me=B.byteLength,we=[];let Ie=0;for(;Ie<me;){const Oe=B[Ie];let He;if(Oe>=240&&Ie+3<me?He=(B[Ie++]&7)<<18>>>0|(B[Ie++]&63)<<12>>>0|(B[Ie++]&63)<<6>>>0|(B[Ie++]&63)<<0>>>0:Oe>=224&&Ie+2<me?He=(B[Ie++]&15)<<12>>>0|(B[Ie++]&63)<<6>>>0|(B[Ie++]&63)<<0>>>0:Oe>=192&&Ie+1<me?He=(B[Ie++]&31)<<6>>>0|(B[Ie++]&63)<<0>>>0:He=B[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const Ze=He-65536,Ke=55296+((Ze&1047552)>>>10),Qe=56320+((Ze&1023)>>>0);we.push(String.fromCharCode(Ke)),we.push(String.fromCharCode(Qe))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=ne;const he=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(B){return he.test(B)}e.containsRTL=ye;const Ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Me(B){return Ne.test(B)}e.containsEmoji=Me;const $e=/^[\t\n\r\x20-\x7E]*$/;function Xe(B){return $e.test(B)}e.isBasicASCII=Xe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function qe(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=qe;function je(B){for(let me=0,we=B.length;me<we;me++)if(U(B.charCodeAt(me)))return!0;return!1}e.containsFullWidthCharacter=je;function U(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=U;function K(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=K;function X(B,me){if(B.length<me)return B;const we=/\b/g;let Ie=0;for(;we.test(B)&&!(B.length-we.lastIndex<me);)Ie=we.lastIndex,we.lastIndex+=1;return B.substring(Ie).replace(/^\s/,"")}e.lcut=X;const re=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ge(B){return B&&(B=B.replace(re,""),B=B.replace(q,""),B=B.replace(ie,"")),B}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function We(B){return Re(B)?B.substr(1):B}e.stripUTF8BOM=We;function ve(B,me){if(!B||!me||B.length<me.length)return!1;const we=me.length,Ie=B.toLowerCase();let Oe=0,He=-1;for(;Oe<we;){const Ze=Ie.indexOf(me[Oe],He+1);if(Ze<0)return!1;He=Ze,Oe++}return!0}e.fuzzyContains=ve;function Je(B,me=!1){return B?(me&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Je;function z(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=z;function Z(B,me=1){if(me===0)return"";let we=-1;do we=B.indexOf(`
`,we+1),me--;while(me>0&&we>=0);return we===-1?B:(B[we-1]==="\r"&&we--,B.substr(0,we))}e.getNLines=Z;function ce(B){const me=90-65+1;return B=B%(2*me),B<me?String.fromCharCode(97+B):String.fromCharCode(65+B-me)}e.singleLetterHash=ce;function Ue(B){return De.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=Ue;function xe(B,me){return B===0?me!==5&&me!==7:B===2&&me===3?!1:B===4||B===2||B===3||me===4||me===2||me===3?!0:!(B===8&&(me===8||me===9||me===11||me===12)||(B===11||B===9)&&(me===9||me===10)||(B===12||B===10)&&me===10||me===5||me===13||me===7||B===1||B===13&&me===14||B===6&&me===6)}e.breakBetweenGraphemeBreakType=xe;var et;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class De{constructor(){this._data=Se()}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}getGraphemeBreakType(me){if(me<32)return me===10?3:me===13?2:4;if(me<127)return 0;const we=this._data,Ie=we.length/3;let Oe=1;for(;Oe<=Ie;)if(me<we[3*Oe])Oe=2*Oe;else if(me>we[3*Oe+1])Oe=2*Oe+1;else return we[3*Oe+2];return 0}}De._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(B,me){if(B===0)return 0;const we=se(B,me);if(we!==void 0)return we;const Ie=L(me,B);return B-=le(Ie),B}e.getLeftDeleteOffset=Pe;function se(B,me){let we=L(me,B);for(B-=le(we);fe(we)||we===65039||we===8419;){if(B===0)return;we=L(me,B),B-=le(we)}if(!!K(we)){if(B>=0){const Ie=L(me,B);Ie===8205&&(B-=le(Ie))}return B}}function le(B){return B>=65536?2:1}function fe(B){return 127995<=B&&B<=127999}var pe;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(pe||(pe={}))}),define(be[24],Ee([0,1,113,8]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let _,y;class I{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return S?new I(Buffer.allocUnsafe(d)):new I(new Uint8Array(d))}static wrap(d){return S&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new I(d)}static fromString(d,D){return!(D?.dontUseNodeBuffer||!1)&&S?new I(Buffer.from(d)):E?(_||(_=new TextEncoder),new I(_.encode(d))):new I(R.encodeUTF8(d))}static concat(d,D){if(typeof D=="undefined"){D=0;for(let P=0,F=d.length;P<F;P++)D+=d[P].byteLength}const k=I.alloc(D);let s=0;for(let P=0,F=d.length;P<F;P++){const x=d[P];k.set(x,s),s+=x.byteLength}return k}toString(){return S?this.buffer.toString():A?(y||(y=new TextDecoder),y.decode(this.buffer)):R.decodeUTF8(this.buffer)}slice(d,D){return new I(this.buffer.subarray(d,D))}set(d,D){d instanceof I?this.buffer.set(d.buffer,D):this.buffer.set(d,D)}readUInt32BE(d){return l(this.buffer,d)}writeUInt32BE(d,D){f(this.buffer,d,D)}readUInt32LE(d){return u(this.buffer,d)}writeUInt32LE(d,D){g(this.buffer,d,D)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,D){w(this.buffer,d,D)}}e.VSBuffer=I;function n(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0}e.readUInt16LE=n;function C(p,d,D){p[D+0]=d&255,d=d>>>8,p[D+1]=d&255}e.writeUInt16LE=C;function l(p,d){return p[d]*2**24+p[d+1]*2**16+p[d+2]*2**8+p[d+3]}e.readUInt32BE=l;function f(p,d,D){p[D+3]=d,d=d>>>8,p[D+2]=d,d=d>>>8,p[D+1]=d,d=d>>>8,p[D]=d}e.writeUInt32BE=f;function u(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0|p[d+2]<<16>>>0|p[d+3]<<24>>>0}e.readUInt32LE=u;function g(p,d,D){p[D+0]=d&255,d=d>>>8,p[D+1]=d&255,d=d>>>8,p[D+2]=d&255,d=d>>>8,p[D+3]=d&255}e.writeUInt32LE=g;function b(p,d){return p[d]}e.readUInt8=b;function w(p,d,D){p[D]=d}e.writeUInt8=w;function T(p){return h.consumeReadable(p,d=>I.concat(d))}e.readableToBuffer=T;function o(p){return h.toReadable(p)}e.bufferToReadable=o;function m(p){return h.consumeStream(p,d=>I.concat(d))}e.streamToBuffer=m;async function v(p){return p.ended?I.concat(p.buffer):I.concat([...p.buffer,await m(p.stream)])}e.bufferedStreamToBuffer=v;function t(p){return h.toStream(p,d=>I.concat(d))}e.bufferToStream=t;function r(p){return h.transform(p,{data:d=>typeof d=="string"?I.fromString(d):I.wrap(d)},d=>I.concat(d))}e.streamToBufferReadableStream=r;function a(p){return h.newWriteableStream(d=>I.concat(d),p)}e.newWriteableBufferStream=a;function i(p,d){return h.prefixedReadable(p,d,D=>I.concat(D))}e.prefixedBufferReadable=i;function c(p,d){return h.prefixedStream(p,d,D=>I.concat(D))}e.prefixedBufferStream=c}),define(be[43],Ee([0,1,8]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return S(w,0)}e.hash=R;function S(w,T){switch(typeof w){case"object":return w===null?E(349,T):Array.isArray(w)?y(w,T):I(w,T);case"string":return _(w,T);case"boolean":return A(w,T);case"number":return E(w,T);case"undefined":return E(937,T);default:return E(617,T)}}e.doHash=S;function E(w,T){return(T<<5)-T+w|0}function A(w,T){return E(w?433:863,T)}function _(w,T){T=E(149417,T);for(let o=0,m=w.length;o<m;o++)T=E(w.charCodeAt(o),T);return T}e.stringHash=_;function y(w,T){return T=E(104579,T),w.reduce((o,m)=>S(m,o),T)}function I(w,T){return T=E(181387,T),Object.keys(w).sort().reduce((o,m)=>(o=_(m,o),S(w[m],o)),T)}class n{constructor(){this._value=0}get value(){return this._value}hash(T){return this._value=S(T,this._value),this._value}}e.Hasher=n;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function l(w,T,o=32){const m=o-T,v=~((1<<m)-1);return(w<<T|(v&w)>>>m)>>>0}function f(w,T=0,o=w.byteLength,m=0){for(let v=0;v<o;v++)w[T+v]=m}function u(w,T,o="0"){for(;w.length<T;)w=o+w;return w}function g(w,T=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(o=>o.toString(16).padStart(2,"0")).join(""):u((w>>>0).toString(16),T/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(T){const o=T.length;if(o===0)return;const m=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,a;for(t!==0?(r=t,a=-1,t=0):(r=T.charCodeAt(0),a=0);;){let i=r;if(h.isHighSurrogate(r))if(a+1<o){const c=T.charCodeAt(a+1);h.isLowSurrogate(c)?(a++,i=h.computeCodePoint(r,c)):i=65533}else{t=r;break}else h.isLowSurrogate(r)&&(i=65533);if(v=this._push(m,v,i),a++,a<o)r=T.charCodeAt(a);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(T,o,m){return m<128?T[o++]=m:m<2048?(T[o++]=192|(m&1984)>>>6,T[o++]=128|(m&63)>>>0):m<65536?(T[o++]=224|(m&61440)>>>12,T[o++]=128|(m&4032)>>>6,T[o++]=128|(m&63)>>>0):(T[o++]=240|(m&1835008)>>>18,T[o++]=128|(m&258048)>>>12,T[o++]=128|(m&4032)>>>6,T[o++]=128|(m&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,T[0]=T[64+0],T[1]=T[64+1],T[2]=T[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const T=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(T/4294967296),!1),this._buffDV.setUint32(60,T%4294967296,!1),this._step()}_step(){const T=b._bigBlock32,o=this._buffDV;for(let d=0;d<64;d+=4)T.setUint32(d,o.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)T.setUint32(d,l(T.getUint32(d-12,!1)^T.getUint32(d-32,!1)^T.getUint32(d-56,!1)^T.getUint32(d-64,!1),1),!1);let m=this._h0,v=this._h1,t=this._h2,r=this._h3,a=this._h4,i,c,p;for(let d=0;d<80;d++)d<20?(i=v&t|~v&r,c=1518500249):d<40?(i=v^t^r,c=1859775393):d<60?(i=v&t|v&r|t&r,c=2400959708):(i=v^t^r,c=3395469782),p=l(m,5)+i+a+c+T.getUint32(d*4,!1)&4294967295,a=r,r=t,t=l(v,30),v=m,m=p;this._h0=this._h0+m&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[36],Ee([0,1,8]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(R||(R={})),function(S){const E="error",A="warning",_="warn",y="info",I="ignore";function n(l){return l?h.equalsIgnoreCase(E,l)?S.Error:h.equalsIgnoreCase(A,l)||h.equalsIgnoreCase(_,l)?S.Warning:h.equalsIgnoreCase(y,l)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function C(l){switch(l){case S.Error:return E;case S.Warning:return A;case S.Info:return y;default:return I}}S.toString=C}(R||(R={})),e.default=R}),define(be[10],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(d){return Array.isArray(d)}e.isArray=h;function R(d){return typeof d=="string"}e.isString=R;function S(d){return Array.isArray(d)&&d.every(D=>R(D))}e.isStringArray=S;function E(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=E;function A(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=A;function _(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=_;function y(d){return d===!0||d===!1}e.isBoolean=y;function I(d){return typeof d=="undefined"}e.isUndefined=I;function n(d){return!C(d)}e.isDefined=n;function C(d){return I(d)||d===null}e.isUndefinedOrNull=C;function l(d,D){if(!d)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=l;function f(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=f;function u(...d){const D=[];for(let k=0;k<d.length;k++){const s=d[k];if(C(s))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);D.push(s)}return D}e.assertAllDefined=u;const g=Object.prototype.hasOwnProperty;function b(d){if(!E(d))return!1;for(let D in d)if(g.call(d,D))return!1;return!0}e.isEmptyObject=b;function w(d){return typeof d=="function"}e.isFunction=w;function T(...d){return d.length>0&&d.every(w)}e.areFunctions=T;function o(d,D){const k=Math.min(d.length,D.length);for(let s=0;s<k;s++)m(d[s],D[s])}e.validateConstraints=o;function m(d,D){if(R(D)){if(typeof d!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(w(D)){try{if(d instanceof D)return}catch{}if(!C(d)&&d.constructor===D||D.length===1&&D.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function v(d){let D=[],k=Object.getPrototypeOf(d);for(;Object.prototype!==k;)D=D.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return D}e.getAllPropertyNames=v;function t(d){const D=[];for(const k of v(d))typeof d[k]=="function"&&D.push(k);return D}e.getAllMethodNames=t;function r(d,D){const k=P=>function(){const F=Array.prototype.slice.call(arguments,0);return D(P,F)};let s={};for(const P of d)s[P]=k(P);return s}e.createProxyObject=r;function a(d){return d===null?void 0:d}e.withNullAsUndefined=a;function i(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=i;function c(d){return class{constructor(){return new Proxy({},{get(D,k){if(D[k])return D[k];throw new Error(`Not Implemented: ${d}->${String(k)}`)}})}}}e.NotImplementedProxy=c;function p(d,D="Unreachable"){throw new Error(D)}e.assertNever=p}),define(be[44],Ee([0,1,14,22,8,10]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(a){return a===47||a===92}e.isPathSeparator=A;function _(a){return a.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=_;function y(a){return a.indexOf("/")===-1&&(a=_(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=y;function I(a,i=h.posix.sep){if(!a)return"";const c=a.length,p=a.charCodeAt(0);if(A(p)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let D=3;const k=D;for(;D<c&&!A(a.charCodeAt(D));D++);if(k!==D&&!A(a.charCodeAt(D+1))){for(D+=1;D<c;D++)if(A(a.charCodeAt(D)))return a.slice(0,D+1).replace(/[\\/]/g,i)}}return i}else if(w(p)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+i:a.slice(0,2);let d=a.indexOf("://");if(d!==-1){for(d+=3;d<c;d++)if(A(a.charCodeAt(d)))return a.slice(0,d+1)}return""}e.getRoot=I;function n(a){if(!R.isWindows||!a||a.length<5)return!1;let i=a.charCodeAt(0);if(i!==92||(i=a.charCodeAt(1),i!==92))return!1;let c=2;const p=c;for(;c<a.length&&(i=a.charCodeAt(c),i!==92);c++);return!(p===c||(i=a.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(a,i=R.isWindows){const c=i?C:l;return!(!a||a.length===0||/^\s+$/.test(a)||(c.lastIndex=0,c.test(a))||i&&f.test(a)||a==="."||a===".."||i&&a[a.length-1]==="."||i&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=u;function g(a,i,c){const p=a===i;return!c||p?p:!a||!i?!1:(0,S.equalsIgnoreCase)(a,i)}e.isEqual=g;function b(a,i,c,p=h.sep){if(a===i)return!0;if(!a||!i||i.length>a.length)return!1;if(c){if(!(0,S.startsWithIgnoreCase)(a,i))return!1;if(i.length===a.length)return!0;let D=i.length;return i.charAt(i.length-1)===p&&D--,a.charAt(D)===p}return i.charAt(i.length-1)!==p&&(i+=p),a.indexOf(i)===0}e.isEqualOrParent=b;function w(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=w;function T(a,i){return R.isWindows&&a.endsWith(":")&&(a+=h.sep),(0,h.isAbsolute)(a)||(a=(0,h.join)(i,a)),a=(0,h.normalize)(a),R.isWindows?(a=(0,S.rtrim)(a,h.sep),a.endsWith(":")&&(a+=h.sep)):(a=(0,S.rtrim)(a,h.sep),a||(a=h.sep)),a}e.sanitizeFilePath=T;function o(a){const i=(0,h.normalize)(a);return R.isWindows?a.length>3?!1:m(i)&&(a.length===2||i.charCodeAt(2)===92):i===h.posix.sep}e.isRootOrDriveLetter=o;function m(a){return R.isWindows?w(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function v(a){return m(a)?a[0]:void 0}e.getDriveLetter=v;function t(a,i,c){return i.length>a.length?-1:a===i?0:(c&&(a=a.toLowerCase(),i=i.toLowerCase()),a.indexOf(i))}e.indexOfPath=t;function r(a){const i=a.split(":");let c,p,d;if(i.forEach(D=>{const k=Number(D);(0,E.isNumber)(k)?p===void 0?p=k:d===void 0&&(d=k):c=c?[c,D].join(":"):D}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:p!==void 0?p:void 0,column:d!==void 0?d:p!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(be[23],Ee([0,1,10]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(w=>{g[w]&&typeof g[w]=="object"?b[w]=R(g[w]):b[w]=g[w]}),b}e.deepClone=R;function S(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const T in w)if(E.call(w,T)){const o=w[T];typeof o=="object"&&!Object.isFrozen(o)&&b.push(o)}}return g}e.deepFreeze=S;const E=Object.prototype.hasOwnProperty;function A(g,b){return _(g,b,new Set)}e.cloneAndChange=A;function _(g,b,w){if((0,h.isUndefinedOrNull)(g))return g;const T=b(g);if(typeof T!="undefined")return T;if((0,h.isArray)(g)){const o=[];for(const m of g)o.push(_(m,b,w));return o}if((0,h.isObject)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const o={};for(let m in g)E.call(g,m)&&(o[m]=_(g[m],b,w));return w.delete(g),o}return g}function y(g,b,w=!0){return(0,h.isObject)(g)?((0,h.isObject)(b)&&Object.keys(b).forEach(T=>{T in g?w&&((0,h.isObject)(g[T])&&(0,h.isObject)(b[T])?y(g[T],b[T],w):g[T]=b[T]):g[T]=b[T]}),g):b}e.mixin=y;function I(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let w,T;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(w=0;w<g.length;w++)if(!I(g[w],b[w]))return!1}else{const o=[];for(T in g)o.push(T);o.sort();const m=[];for(T in b)m.push(T);if(m.sort(),!I(o,m))return!1;for(w=0;w<o.length;w++)if(!I(g[o[w]],b[o[w]]))return!1}return!0}e.equals=I;function n(g){const b=new Set;return JSON.stringify(g,(w,T)=>{if((0,h.isObject)(T)||Array.isArray(T)){if(b.has(T))return"[Circular]";b.add(T)}return T})}e.safeStringify=n;function C(g,b,w){const T=b(g);return typeof T=="undefined"?w:T}e.getOrDefault=C;function l(g,b){const w=Object.create(null);return!g||!b||Object.keys(b).forEach(o=>{const m=g[o],v=b[o];I(m,v)||(w[o]=v)}),w}e.distinct=l;function f(g,b){const w=b.toLowerCase(),T=Object.keys(g).find(o=>o.toLowerCase()===w);return T?g[T]:g[b]}e.getCaseInsensitive=f;function u(g,b){const w=Object.create(null);for(const T of Object.keys(g))b(T,g[T])&&(w[T]=g[T]);return w}e.filter=u}),define(be[82],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var h;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h=e.Constants||(e.Constants={}));function R(E){return E<0?0:E>255?255:E|0}e.toUint8=R;function S(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=S}),define(be[2],Ee([0,1,14,22]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,E=/^\//,A=/^\/\//;function _(a,i){if(!a.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!S.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!E.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,i){return!a&&!i?"file":a}function I(a,i){switch(a){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const n="",C="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,c,p,d,D,k=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,k),this.authority=c||n,this.path=I(this.scheme,p||n),this.query=d||n,this.fragment=D||n,_(this,k))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return o(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:p,path:d,query:D,fragment:k}=i;return c===void 0?c=this.scheme:c===null&&(c=n),p===void 0?p=this.authority:p===null&&(p=n),d===void 0?d=this.path:d===null&&(d=n),D===void 0?D=this.query:D===null&&(D=n),k===void 0?k=this.fragment:k===null&&(k=n),c===this.scheme&&p===this.authority&&d===this.path&&D===this.query&&k===this.fragment?this:new g(c,p,d,D,k)}static parse(i,c=!1){const p=l.exec(i);return p?new g(p[2]||n,r(p[4]||n),r(p[5]||n),r(p[7]||n),r(p[9]||n),c):new g(n,n,n,n,n)}static file(i){let c=n;if(R.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const p=i.indexOf(C,2);p===-1?(c=i.substring(2),i=C):(c=i.substring(2,p),i=i.substring(p)||C)}return new g("file",c,i,n,n)}static from(i){const c=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return _(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.isWindows&&i.scheme==="file"?p=f.file(h.win32.join(o(i,!0),...c)).path:p=h.posix.join(i.path,...c),i.with({path:p})}toString(i=!1){return m(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const c=new g(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=f;const u=R.isWindows?1:void 0;class g extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(i=!1){return i?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(a,i){let c,p=-1;for(let d=0;d<a.length;d++){const D=a.charCodeAt(d);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47)p!==-1&&(c+=encodeURIComponent(a.substring(p,d)),p=-1),c!==void 0&&(c+=a.charAt(d));else{c===void 0&&(c=a.substr(0,d));const k=b[D];k!==void 0?(p!==-1&&(c+=encodeURIComponent(a.substring(p,d)),p=-1),c+=k):p===-1&&(p=d)}}return p!==-1&&(c+=encodeURIComponent(a.substring(p))),c!==void 0?c:a}function T(a){let i;for(let c=0;c<a.length;c++){const p=a.charCodeAt(c);p===35||p===63?(i===void 0&&(i=a.substr(0,c)),i+=b[p]):i!==void 0&&(i+=a[c])}return i!==void 0?i:a}function o(a,i){let c;return a.authority&&a.path.length>1&&a.scheme==="file"?c=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?i?c=a.path.substr(1):c=a.path[1].toLowerCase()+a.path.substr(2):c=a.path,R.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=o;function m(a,i){const c=i?T:w;let p="",{scheme:d,authority:D,path:k,query:s,fragment:P}=a;if(d&&(p+=d,p+=":"),(D||d==="file")&&(p+=C,p+=C),D){let F=D.indexOf("@");if(F!==-1){const x=D.substr(0,F);D=D.substr(F+1),F=x.indexOf(":"),F===-1?p+=c(x,!1):(p+=c(x.substr(0,F),!1),p+=":",p+=c(x.substr(F+1),!1)),p+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?p+=c(D,!1):(p+=c(D.substr(0,F),!1),p+=D.substr(F))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const F=k.charCodeAt(1);F>=65&&F<=90&&(k=`/${String.fromCharCode(F+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const F=k.charCodeAt(0);F>=65&&F<=90&&(k=`${String.fromCharCode(F+32)}:${k.substr(2)}`)}p+=c(k,!0)}return s&&(p+="?",p+=c(s,!1)),P&&(p+="#",p+=i?P:w(P,!1)),p}function v(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+v(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(a){return a.match(t)?a.replace(t,i=>v(i)):a}});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[21],Ee([0,1,8,2]),function(ee,e,h,R){"use strict";var S,E,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(t,r,a){let i=t.get(r);return i===void 0&&(i=a,t.set(r,i)),i}e.getOrSet=_;function y(t){const r=[];return t.forEach((a,i)=>{r.push(`${i} => ${a}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function I(t){const r=[];return t.forEach(a=>{r.push(a)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=I;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return a-i}value(){return this._value[this._pos]}}e.StringIterator=n;class C{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,h.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,h.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class l{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,h.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,h.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,h.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,h.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,h.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,h.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(r){this._iter=r}static forUris(r=()=>!1){return new b(new u(r))}static forPaths(){return new b(new l)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new C)}clear(){this._root=void 0}set(r,a){const i=this._iter.reset(r);let c;for(this._root||(this._root=new g,this._root.segment=i.value()),c=this._root;;){const d=i.cmp(c.segment);if(d>0)c.left||(c.left=new g,c.left.segment=i.value()),c=c.left;else if(d<0)c.right||(c.right=new g,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new g,c.mid.segment=i.value()),c=c.mid;else break}const p=c.value;return c.value=a,c.key=r,p}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let i=this._root;for(;i;){const c=a.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(a.hasNext())a.next(),i=i.mid;else break}return i}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const i=this._iter.reset(r),c=[];let p=this._root;for(;p;){const d=i.cmp(p.segment);if(d>0)c.push([1,p]),p=p.left;else if(d<0)c.push([-1,p]),p=p.right;else if(i.hasNext())i.next(),c.push([0,p]),p=p.mid;else{for(a?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;c.length>0&&p.isEmpty();){let[D,k]=c.pop();switch(D){case 1:k.left=void 0;break;case 0:k.mid=void 0;break;case-1:k.right=void 0;break}p=k}break}}}findSubstr(r){const a=this._iter.reset(r);let i=this._root,c;for(;i;){const p=a.cmp(i.segment);if(p>0)i=i.left;else if(p<0)i=i.right;else if(a.hasNext())a.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(r){const a=this._iter.reset(r);let i=this._root;for(;i;){const c=a.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(a.hasNext())a.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[a,i]of this)r(i,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const a=[r];for(;a.length>0;){const i=a.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&a.push(i.left),i.mid&&a.push(i.mid),i.right&&a.push(i.right))}}}e.TernarySearchTree=b;class w{constructor(r,a){this[S]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=a??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[i,c]of this.map)r(c,R.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield R.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[R.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[R.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var T;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class o{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const i=this._map.get(r);if(!!i)return a!==0&&this.touch(i,a),i.value}set(r,a,i=0){let c=this._map.get(r);if(c)c.value=a,i!==0&&this.touch(c,i);else{switch(c={key:r,value:a,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const i=this._state;let c=this._head;for(;c;){if(a?r.bind(a)(c.value,c.key,this):r(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,a=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.key,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return c}values(){const r=this,a=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.value,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return c}entries(){const r=this,a=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:[i.key,i.value],done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return c}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,i=this.size;for(;a&&i>r;)this._map.delete(a.key),a=a.next,i--;this._head=a,this._size=i,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,i=r.previous;if(!a||!i)throw new Error("Invalid list");a.previous=i,i.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const i=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const i=r.next,c=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,i)=>{r.push([i,a])}),r}fromJSON(r){this.clear();for(const[a,i]of r)this.set(a,i)}}e.LinkedMap=o;class m extends o{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class v{constructor(r){A.set(this,void 0),it(this,A,r,"f")}get size(){return Be(this,A,"f").size}forEach(r,a){Be(this,A,"f").forEach(r,a)}get(r){return Be(this,A,"f").get(r)}has(r){return Be(this,A,"f").has(r)}entries(){return Be(this,A,"f").entries()}keys(){return Be(this,A,"f").keys()}values(){return Be(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Be(this,A,"f").entries()}}e.ReadonlyMapView=v}),define(be[114],Ee([0,1,21,8]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(ie,ge){for(let Re=0,We=q.length;Re<We;Re++){const ve=q[Re](ie,ge);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(q,ie,ge){if(!ge||ge.length<ie.length)return null;let Re;return q?Re=R.startsWithIgnoreCase(ge,ie):Re=ge.indexOf(ie)===0,Re?ie.length>0?[{start:0,end:ie.length}]:[]:null}function A(q,ie){const ge=ie.toLowerCase().indexOf(q.toLowerCase());return ge===-1?null:[{start:ge,end:ge+q.length}]}e.matchesContiguousSubString=A;function _(q,ie){return y(q.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=_;function y(q,ie,ge,Re){if(ge===q.length)return[];if(Re===ie.length)return null;if(q[ge]===ie[Re]){let We=null;return(We=y(q,ie,ge+1,Re+1))?w({start:Re,end:Re+1},We):null}return y(q,ie,ge,Re+1)}function I(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function C(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>f.add(q.charCodeAt(0)));function u(q){return l(q)||f.has(q)}function g(q,ie){return q===ie||u(q)&&u(ie)}function b(q){return I(q)||n(q)||C(q)}function w(q,ie){return ie.length===0?ie=[q]:q.end===ie[0].start?ie[0].start=q.start:ie.unshift(q),ie}function T(q,ie){for(let ge=ie;ge<q.length;ge++){const Re=q.charCodeAt(ge);if(n(Re)||C(Re)||ge>0&&!b(q.charCodeAt(ge-1)))return ge}return q.length}function o(q,ie,ge,Re){if(ge===q.length)return[];if(Re===ie.length)return null;if(q[ge]!==ie[Re].toLowerCase())return null;{let We=null,ve=Re+1;for(We=o(q,ie,ge+1,Re+1);!We&&(ve=T(ie,ve))<ie.length;)We=o(q,ie,ge+1,ve),ve++;return We===null?null:w({start:Re,end:Re+1},We)}}function m(q){let ie=0,ge=0,Re=0,We=0,ve=0;for(let Ue=0;Ue<q.length;Ue++)ve=q.charCodeAt(Ue),n(ve)&&ie++,I(ve)&&ge++,b(ve)&&Re++,C(ve)&&We++;const Je=ie/q.length,z=ge/q.length,Z=Re/q.length,ce=We/q.length;return{upperPercent:Je,lowerPercent:z,alphaPercent:Z,numericPercent:ce}}function v(q){const{upperPercent:ie,lowerPercent:ge}=q;return ge===0&&ie>.6}function t(q){const{upperPercent:ie,lowerPercent:ge,alphaPercent:Re,numericPercent:We}=q;return ge>.2&&ie<.8&&Re>.6&&We<.2}function r(q){let ie=0,ge=0,Re=0,We=0;for(let ve=0;ve<q.length;ve++)Re=q.charCodeAt(ve),n(Re)&&ie++,I(Re)&&ge++,l(Re)&&We++;return(ie===0||ge===0)&&We===0?q.length<=30:ie<=5}function a(q,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!r(q)||ie.length>60)return null;const ge=m(ie);if(!t(ge)){if(!v(ge))return null;ie=ie.toLowerCase()}let Re=null,We=0;for(q=q.toLowerCase();We<ie.length&&(Re=o(q,ie,0,We))===null;)We=T(ie,We+1);return Re}e.matchesCamelCase=a;function i(q,ie,ge=!1){if(!ie||ie.length===0)return null;let Re=null,We=0;for(q=q.toLowerCase(),ie=ie.toLowerCase();We<ie.length&&(Re=c(q,ie,0,We,ge))===null;)We=p(ie,We+1);return Re}e.matchesWords=i;function c(q,ie,ge,Re,We){if(ge===q.length)return[];if(Re===ie.length)return null;if(g(q.charCodeAt(ge),ie.charCodeAt(Re))){let ve=null,Je=Re+1;if(ve=c(q,ie,ge+1,Re+1,We),!We)for(;!ve&&(Je=p(ie,Je))<ie.length;)ve=c(q,ie,ge+1,Je,We),Je++;return ve===null?null:w({start:Re,end:Re+1},ve)}else return null}function p(q,ie){for(let ge=ie;ge<q.length;ge++)if(u(q.charCodeAt(ge))||ge>0&&u(q.charCodeAt(ge-1)))return ge;return q.length}const d=S(e.matchesPrefix,a,A),D=S(e.matchesPrefix,a,_),k=new h.LRUCache(1e4);function s(q,ie,ge=!1){if(typeof q!="string"||typeof ie!="string")return null;let Re=k.get(q);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(q),"i"),k.set(q,Re));const We=Re.exec(ie);return We?[{start:We.index,end:We.index+We[0].length}]:ge?D(q,ie):d(q,ie)}e.matchesFuzzy=s;function P(q,ie){const ge=Xe(q,q.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return ge?x(ge):null}e.matchesFuzzy2=P;function F(q,ie,ge,Re,We,ve){const Je=Math.min(13,q.length);for(;ge<Je;ge++){const z=Xe(q,ie,ge,Re,We,ve,!1);if(z)return z}return[0,ve]}e.anyScore=F;function x(q){if(typeof q=="undefined")return[];const ie=[],ge=q[1];for(let Re=q.length-1;Re>1;Re--){const We=q[Re]+ge,ve=ie[ie.length-1];ve&&ve.end===We?ve.end=We+1:ie.push({start:We,end:We+1})}return ie}e.createMatches=x;const j=128;function ae(){const q=[],ie=[];for(let ge=0;ge<=j;ge++)ie[ge]=0;for(let ge=0;ge<=j;ge++)q.push(ie.slice(0));return q}function oe(q){const ie=[];for(let ge=0;ge<=q;ge++)ie[ge]=0;return ie}const V=oe(2*j),W=oe(2*j),L=ae(),Q=ae(),O=ae(),G=!1;function de(q,ie,ge,Re,We){function ve(z,Z,ce=" "){for(;z.length<Z;)z=ce+z;return z}let Je=` |   |${Re.split("").map(z=>ve(z,3)).join("|")}
`;for(let z=0;z<=ge;z++)z===0?Je+=" |":Je+=`${ie[z-1]}|`,Je+=q[z].slice(0,We+1).map(Z=>ve(Z.toString(),3)).join("|")+`
`;return Je}function $(q,ie,ge,Re){q=q.substr(ie),ge=ge.substr(Re),console.log(de(Q,q,q.length,ge,ge.length)),console.log(de(O,q,q.length,ge,ge.length)),console.log(de(L,q,q.length,ge,ge.length))}function ne(q,ie){if(ie<0||ie>=q.length)return!1;const ge=q.codePointAt(ie);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ge)}}function he(q,ie){if(ie<0||ie>=q.length)return!1;switch(q.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ye(q,ie,ge){return ie[q]!==ge[q]}function Ne(q,ie,ge,Re,We,ve,Je=!1){for(;ie<ge&&We<ve;)q[ie]===Re[We]&&(Je&&(V[ie]=We),ie+=1),We+=1;return ie===ge}e.isPatternInWord=Ne;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var $e;(function(q){q.Default=[-100,0];function ie(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}q.isDefault=ie})($e=e.FuzzyScore||(e.FuzzyScore={}));function Xe(q,ie,ge,Re,We,ve,Je){const z=q.length>j?j:q.length,Z=Re.length>j?j:Re.length;if(ge>=z||ve>=Z||z-ge>Z-ve||!Ne(ie,ge,z,We,ve,Z,!0))return;qe(z,Z,ge,ve,ie,We);let ce=1,Ue=1,xe=ge,et=ve;const De=[!1];for(ce=1,xe=ge;xe<z;ce++,xe++){const fe=V[xe],pe=W[xe],B=xe+1<z?W[xe+1]:Z;for(Ue=fe-ve+1,et=fe;et<B;Ue++,et++){let me=Number.MIN_SAFE_INTEGER,we=!1;et<=pe&&(me=je(q,ie,xe,ge,Re,We,et,Z,ve,L[ce-1][Ue-1]===0,De));let Ie=0;me!==Number.MAX_SAFE_INTEGER&&(we=!0,Ie=me+Q[ce-1][Ue-1]);const Oe=et>fe,He=Oe?Q[ce][Ue-1]+(L[ce][Ue-1]>0?-5:0):0,Ze=et>fe+1&&L[ce][Ue-1]>0,Ke=Ze?Q[ce][Ue-2]+(L[ce][Ue-2]>0?-5:0):0;if(Ze&&(!Oe||Ke>=He)&&(!we||Ke>=Ie))Q[ce][Ue]=Ke,O[ce][Ue]=3,L[ce][Ue]=0;else if(Oe&&(!we||He>=Ie))Q[ce][Ue]=He,O[ce][Ue]=2,L[ce][Ue]=0;else if(we)Q[ce][Ue]=Ie,O[ce][Ue]=1,L[ce][Ue]=L[ce-1][Ue-1]+1;else throw new Error("not possible")}}if(G&&$(q,ge,Re,ve),!De[0]&&!Je)return;ce--,Ue--;const Se=[Q[ce][Ue],ve];let Pe=0,se=0;for(;ce>=1;){let fe=Ue;do{const pe=O[ce][fe];if(pe===3)fe=fe-2;else if(pe===2)fe=fe-1;else break}while(fe>=1);Pe>1&&ie[ge+ce-1]===We[ve+Ue-1]&&!ye(fe+ve-1,Re,We)&&Pe+1>L[ce][fe]&&(fe=Ue),fe===Ue?Pe++:Pe=1,se||(se=fe),ce--,Ue=fe-1,Se.push(Ue)}Z===z&&(Se[0]+=2);const le=se-z;return Se[0]-=le,Se}e.fuzzyScore=Xe;function qe(q,ie,ge,Re,We,ve){let Je=q-1,z=ie-1;for(;Je>=ge&&z>=Re;)We[Je]===ve[z]&&(W[Je]=z,Je--),z--}function je(q,ie,ge,Re,We,ve,Je,z,Z,ce,Ue){if(ie[ge]!==ve[Je])return Number.MIN_SAFE_INTEGER;let xe=1,et=!1;return Je===ge-Re?xe=q[ge]===We[Je]?7:5:ye(Je,We,ve)&&(Je===0||!ye(Je-1,We,ve))?(xe=q[ge]===We[Je]?7:5,et=!0):ne(ve,Je)&&(Je===0||!ne(ve,Je-1))?xe=5:(ne(ve,Je-1)||he(ve,Je-1))&&(xe=5,et=!0),xe>1&&ge===Re&&(Ue[0]=!0),et||(et=ye(Je,We,ve)||ne(ve,Je-1)||he(ve,Je-1)),ge===Re?Je>Z&&(xe-=et?3:5):ce?xe+=et?2:0:xe+=et?0:1,Je+1===z&&(xe-=et?3:5),xe}function U(q,ie,ge,Re,We,ve,Je){return X(q,ie,ge,Re,We,ve,!0,Je)}e.fuzzyScoreGracefulAggressive=U;function K(q,ie,ge,Re,We,ve,Je){return X(q,ie,ge,Re,We,ve,!1,Je)}e.fuzzyScoreGraceful=K;function X(q,ie,ge,Re,We,ve,Je,z){let Z=Xe(q,ie,ge,Re,We,ve,z);if(Z&&!Je)return Z;if(q.length>=3){const ce=Math.min(7,q.length-1);for(let Ue=ge+1;Ue<ce;Ue++){const xe=re(q,Ue);if(xe){const et=Xe(xe,xe.toLowerCase(),ge,Re,We,ve,z);et&&(et[0]-=3,(!Z||et[0]>Z[0])&&(Z=et))}}}return Z}function re(q,ie){if(ie+1>=q.length)return;const ge=q[ie],Re=q[ie+1];if(ge!==Re)return q.slice(0,ie)+Re+ge+q.slice(ie+2)}}),define(be[115],Ee([0,1,35,114,8]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${E.source}`,"g");function _(g){return g.replace(A,(b,w)=>w?b:`\\${b}`)}e.escapeIcons=_;const y=new RegExp(`\\\\${E.source}`,"g");function I(g){return g.replace(y,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=I;const n=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function C(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(n,(b,w,T,o)=>T?b:w||o||"")}e.stripIcons=C;function l(g){const b=g.indexOf(e.iconStartMarker);return b===-1?{text:g}:f(g,b)}e.parseLabelWithIcons=l;function f(g,b){const w=[];let T="";function o(p){if(p){T+=p;for(const d of p)w.push(t)}}let m=-1,v="",t=0,r,a,i=b;const c=g.length;for(o(g.substr(0,b));i<c;)r=g[i],a=g[i+1],r===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(m=i,o(v),v=e.iconStartMarker,i++):r===")"&&m!==-1?(t+=i-m+1,m=-1,v=""):m!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(o(v),m=-1,v=""):o(r),i++;return o(v),{text:T,iconOffsets:w}}function u(g,b,w=!1){const{text:T,iconOffsets:o}=b;if(!o||o.length===0)return(0,R.matchesFuzzy)(g,T,w);const m=(0,S.ltrim)(T," "),v=T.length-m.length,t=(0,R.matchesFuzzy)(g,m,w);if(t)for(const r of t){const a=o[r.start+v]+v;r.start+=a,r.end+=a}return t}e.matchesFuzzyIconAware=u}),define(be[83],Ee([0,1,12,115]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(f="",u=!1){if(this.value=f,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(f,u=0){return this.value+=I(this.supportThemeIcons?(0,R.escapeIcons)(f):f).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,u){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=E;function A(l){return _(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function _(l){return l instanceof E?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=_;function y(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=y;function I(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function C(l){const f=[],u=l.split("|").map(b=>b.trim());l=u[0];const g=u[1];if(g){const b=/height=(\d+)/.exec(g),w=/width=(\d+)/.exec(g),T=b?b[1]:"",o=w?w[1]:"",m=isFinite(parseInt(o)),v=isFinite(parseInt(T));m&&f.push(`width="${o}"`),v&&f.push(`height="${T}"`)}return{href:l,dimensions:f}}e.parseHrefAndDimensions=C}),define(be[57],Ee([0,1,24,8,2]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function E(n){return JSON.stringify(n,y)}e.stringify=E;function A(n){let C=JSON.parse(n);return C=I(C),C}e.parse=A;var _;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(_=e.MarshalledId||(e.MarshalledId={}));function y(n,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function I(n,C=0){if(!n||C>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof h.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=I(n[l],C+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=I(n[l],C+1))}return n}e.revive=I}),define(be[11],Ee([0,1,22,2]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(_){_.inMemory="inmemory",_.vscode="vscode",_.internal="private",_.walkThrough="walkThrough",_.walkThroughSnippet="walkThroughSnippet",_.http="http",_.https="https",_.file="file",_.mailto="mailto",_.untitled="untitled",_.data="data",_.command="command",_.vscodeRemote="vscode-remote",_.vscodeRemoteResource="vscode-remote-resource",_.userData="vscode-userdata",_.vscodeCustomEditor="vscode-custom-editor",_.vscodeNotebook="vscode-notebook",_.vscodeNotebookCell="vscode-notebook-cell",_.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",_.vscodeNotebookCellOutput="vscode-notebook-cell-output",_.vscodeInteractive="vscode-interactive",_.vscodeInteractiveInput="vscode-interactive-input",_.vscodeSettings="vscode-settings",_.vscodeWorkspaceTrust="vscode-workspace-trust",_.vscodeTerminal="vscode-terminal",_.webviewPanel="webview-panel",_.vscodeWebview="vscode-webview",_.extension="extension",_.vscodeFileResource="vscode-file",_.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,I,n){this._hosts[y]=I,this._ports[y]=n}setConnectionToken(y,I){this._connectionTokens[y]=I}rewrite(y){if(this._delegate)return this._delegate(y);const I=y.authority;let n=this._hosts[I];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const C=this._ports[I],l=this._connectionTokens[I];let f=`path=${encodeURIComponent(y.path)}`;return typeof l=="string"&&(f+=`&tkn=${encodeURIComponent(l)}`),R.URI.from({scheme:h.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${C}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new E;class A{asBrowserUri(y,I){const n=this.toUri(y,I);return n.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===S.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${S.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:S.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,I){const n=this.toUri(y,I);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,I){return R.URI.isUri(y)?y:R.URI.parse(I.toUrl(y))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(be[25],Ee([0,1,44,11,14,22,8,2]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,_.uriToFsPath)(f,!0)}e.originalFSPath=y;class I{constructor(u){this._ignorePathCasing=u}compare(u,g,b=!1){return u===g?0:(0,A.compare)(this.getComparisonKey(u,b),this.getComparisonKey(g,b))}isEqual(u,g,b=!1){return u===g?!0:!u||!g?!1:this.getComparisonKey(u,b)===this.getComparisonKey(g,b)}getComparisonKey(u,g=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,g,b=!1){if(u.scheme===g.scheme){if(u.scheme===R.Schemas.file)return h.isEqualOrParent(y(u),y(g),this._ignorePathCasing(u))&&u.query===g.query&&(b||u.fragment===g.fragment);if((0,e.isEqualAuthority)(u.authority,g.authority))return h.isEqualOrParent(u.path,g.path,this._ignorePathCasing(u),"/")&&u.query===g.query&&(b||u.fragment===g.fragment)}return!1}joinPath(u,...g){return _.URI.joinPath(u,...g)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return S.posix.basename(u.path)}extname(u){const g=S.posix.extname(u.path),b=g.indexOf("?");return b!==-1?g.substr(0,b):g}dirname(u){if(u.path.length===0)return u;let g;return u.scheme===R.Schemas.file?g=_.URI.file(S.dirname(y(u))).path:(g=S.posix.dirname(u.path),u.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),g="/")),u.with({path:g})}normalizePath(u){if(!u.path.length)return u;let g;return u.scheme===R.Schemas.file?g=_.URI.file(S.normalize(y(u))).path:g=S.posix.normalize(u.path),u.with({path:g})}relativePath(u,g){if(u.scheme!==g.scheme||!(0,e.isEqualAuthority)(u.authority,g.authority))return;if(u.scheme===R.Schemas.file){const T=S.relative(y(u),y(g));return E.isWindows?h.toSlashes(T):T}let b=u.path||"/",w=g.path||"/";if(this._ignorePathCasing(u)){let T=0;for(const o=Math.min(b.length,w.length);T<o&&!(b.charCodeAt(T)!==w.charCodeAt(T)&&b.charAt(T).toLowerCase()!==w.charAt(T).toLowerCase());T++);b=w.substr(0,T)+b.substr(T)}return S.posix.relative(b,w)}resolvePath(u,g){if(u.scheme===R.Schemas.file){const b=_.URI.file(S.resolve(y(u),g));return u.with({authority:b.authority,path:b.path})}return g=h.toPosixPath(g),u.with({path:S.posix.resolve(u.path,g)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,g){return u===g||(0,A.equalsIgnoreCase)(u,g)}hasTrailingPathSeparator(u,g=S.sep){if(u.scheme===R.Schemas.file){const b=y(u);return b.length>h.getRoot(b).length&&b[b.length-1]===g}else{const b=u.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,g=S.sep){return(0,e.hasTrailingPathSeparator)(u,g)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,g=S.sep){let b=!1;if(u.scheme===R.Schemas.file){const w=y(u);b=w!==void 0&&w.length===h.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=u.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(u,g)?u.with({path:u.path+"/"}):u}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(f=>f.scheme===R.Schemas.file?!E.isLinux:!0),e.extUriIgnorePathCase=new I(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,u){const g=[];for(let b=0;b<f.length;b++){const w=u(f[b]);f.some((T,o)=>o===b?!1:(0,e.isEqualOrParent)(w,u(T)))||g.push(f[b])}return g}e.distinctParents=n;var C;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function u(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[m,v]=o.split(":");m&&v&&b.set(m,v)});const T=g.path.substring(0,g.path.indexOf(";"));return T&&b.set(f.META_DATA_MIME,T),b}f.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function l(f,u,g){if(u){let b=f.path;return b&&b[0]!==S.posix.sep&&(b=S.posix.sep+b),f.with({scheme:g,authority:u,path:b})}return f.with({scheme:g})}e.toLocalResource=l}),define(be[15],Ee([0,1,20,12,3,6,25]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(W){return!!W&&typeof W.then=="function"}e.isThenable=_;function y(W){const L=new h.CancellationTokenSource,Q=W(L.token),O=new Promise((G,de)=>{const $=L.token.onCancellationRequested(()=>{$.dispose(),L.dispose(),de((0,R.canceled)())});Promise.resolve(Q).then(ne=>{$.dispose(),L.dispose(),G(ne)},ne=>{$.dispose(),L.dispose(),de(ne)})});return new class{cancel(){L.cancel()}then(G,de){return O.then(G,de)}catch(G){return this.then(void 0,G)}finally(G){return O.finally(G)}}}e.createCancelablePromise=y;function I(W,L,Q){return Promise.race([W,new Promise(O=>L.onCancellationRequested(()=>O(Q)))])}e.raceCancellation=I;async function n(W){let L=-1;const Q=W.map((G,de)=>G.then($=>(L=de,$))),O=await Promise.race(Q);return W.forEach((G,de)=>{de!==L&&G.cancel()}),O}e.raceCancellablePromises=n;function C(W,L,Q){let O;const G=setTimeout(()=>{O?.(void 0),Q?.()},L);return Promise.race([W.finally(()=>clearTimeout(G)),new Promise(de=>O=de)])}e.raceTimeout=C;function l(W){return new Promise((L,Q)=>{const O=W();_(O)?O.then(L,Q):L(O)})}e.asPromise=l;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const Q=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(Q,Q).then(O)})}return new Promise((Q,O)=>{this.queuedPromise.then(Q,O)})}return this.activePromise=L(),new Promise((Q,O)=>{this.activePromise.then(G=>{this.activePromise=null,Q(G)},G=>{this.activePromise=null,O(G)})})}}e.Throttler=f;class u{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=u;class g{constructor(){this.promiseMap=new Map}queue(L,Q){const G=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(L)===G&&this.promiseMap.delete(L)});return this.promiseMap.set(L,G),G}}e.SequencerByKey=g;class b{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,Q=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,G)=>{this.doResolve=O,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(L){this.delayer=new b(L),this.throttler=new f}trigger(L,Q){return this.delayer.trigger(()=>this.throttler.queue(L),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class T{constructor(){this._isOpen=!1,this._promise=new Promise((L,Q)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=T;class o extends T{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function m(W,L){return L?new Promise((Q,O)=>{const G=setTimeout(()=>{de.dispose(),Q()},W),de=L.onCancellationRequested(()=>{clearTimeout(G),de.dispose(),O((0,R.canceled)())})}):y(Q=>m(W,Q))}e.timeout=m;function v(W,L=0){const Q=setTimeout(W,L);return(0,E.toDisposable)(()=>clearTimeout(Q))}e.disposableTimeout=v;function t(W){const L=[];let Q=0;const O=W.length;function G(){return Q<O?W[Q++]():null}function de($){$!=null&&L.push($);const ne=G();return ne?ne.then(de):Promise.resolve(L)}return Promise.resolve(null).then(de)}e.sequence=t;function r(W,L=O=>!!O,Q=null){let O=0;const G=W.length,de=()=>{if(O>=G)return Promise.resolve(Q);const $=W[O++];return Promise.resolve($()).then(he=>L(he)?Promise.resolve(he):de())};return de()}e.first=r;function a(W,L=O=>!!O,Q=null){if(W.length===0)return Promise.resolve(Q);let O=W.length;const G=()=>{O=-1;for(const de of W)de.cancel?.()};return new Promise((de,$)=>{for(const ne of W)ne.then(he=>{--O>=0&&L(he)?(G(),de(he)):O===0&&de(Q)}).catch(he=>{--O>=0&&(G(),$(he))})})}e.firstParallel=a;class i{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((Q,O)=>{this.outstandingPromises.push({factory:L,c:Q,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const Q=L.factory();Q.then(L.c,L.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class p{constructor(){this.queues=new Map}queueFor(L,Q=A.extUri){const O=Q.getComparisonKey(L);let G=this.queues.get(O);return G||(G=new c,S.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(O)}),this.queues.set(O,G)),G}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=p;class d{constructor(L,Q){this._token=-1,typeof L=="function"&&typeof Q=="number"&&this.setIfNotSet(L,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},Q)}setIfNotSet(L,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},Q))}}e.TimeoutTimer=d;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,Q){this.cancel(),this._token=setInterval(()=>{L()},Q)}}e.IntervalTimer=D;class k{constructor(L,Q){this.timeoutToken=-1,this.runner=L,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=k;class s extends k{constructor(L,Q){super(L,Q);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=s;class P extends E.Disposable{constructor(L,Q,O,G){super();this.maxWorkChunkSize=L,this.maxPendingWork=Q,this.throttleDelay=O,this.handler=G,this.pendingWork=[],this.throttler=this._register(new E.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new k(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=P,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const Q=setTimeout(()=>L(W));let O=!1;return{dispose(){O||(O=!0,clearTimeout(Q))}}}}else e.runWhenIdle=(W,L)=>{const Q=requestIdleCallback(W,typeof L=="number"?{timeout:L}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(Q))}}}}();class F{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=F;async function x(W,L,Q){let O;for(let G=0;G<Q;G++)try{return await W()}catch(de){O=de,await m(L)}throw O}e.retry=x;class j{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,Q,O){return this._pending={taskId:L,cancel:()=>O?.(),promise:Q},Q.then(()=>this.donePending(L),()=>this.donePending(L)),Q}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let Q,O;const G=new Promise((de,$)=>{Q=de,O=$});this._next={run:L,promise:G,promiseResolve:Q,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=j;class ae{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;class oe{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,Q)=>{this.completeCallback=L,this.errorCallback=Q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(Q=>{this.completeCallback(L),this.resolved=!0,Q()})}error(L){return new Promise(Q=>{this.errorCallback(L),this.rejected=!0,Q()})}cancel(){new Promise(L=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=oe;var V;(function(W){async function L(Q){let O;const G=await Promise.all(Q.map(de=>de.then($=>$,$=>{O||(O=$)})));if(typeof O!="undefined")throw O;return G}W.settled=L})(V=e.Promises||(e.Promises={}))}),define(be[116],Ee([0,1,15,14]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new h.IdleValue(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),E=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function _(k,s,P=!1){const F=k||"",x=s||"",j=S.value.collator.compare(F,x);return S.value.collatorIsNumeric&&j===0&&F!==x?F<x?-1:1:j}e.compareFileNames=_;function y(k,s){const P=E.value.collator;return k=k||"",s=s||"",v(P,k,s)}e.compareFileNamesDefault=y;function I(k,s){const P=E.value.collator;return k=k||"",s=s||"",i(k,s)||v(P,k,s)}e.compareFileNamesUpper=I;function n(k,s){const P=E.value.collator;return k=k||"",s=s||"",a(k,s)||v(P,k,s)}e.compareFileNamesLower=n;function C(k,s){return k=k||"",s=s||"",k===s?0:k<s?-1:1}e.compareFileNamesUnicode=C;function l(k,s,P=!1){P||(k=k&&k.toLowerCase(),s=s&&s.toLowerCase());const[F,x]=o(k),[j,ae]=o(s);return F!==j?F<j?-1:1:x===ae?0:x<ae?-1:1}e.noIntlCompareFileNames=l;function f(k,s){const[P,F]=o(k),[x,j]=o(s);let ae=S.value.collator.compare(F,j);if(ae===0){if(S.value.collatorIsNumeric&&F!==j)return F<j?-1:1;if(ae=S.value.collator.compare(P,x),S.value.collatorIsNumeric&&ae===0&&P!==x)return P<x?-1:1}return ae}e.compareFileExtensions=f;function u(k,s){k=k||"",s=s||"";const P=m(k),F=m(s),x=E.value.collator,j=A.value.collator;return v(j,P,F)||v(x,k,s)}e.compareFileExtensionsDefault=u;function g(k,s){k=k||"",s=s||"";const P=m(k),F=m(s),x=E.value.collator,j=A.value.collator;return v(j,P,F)||i(k,s)||v(x,k,s)}e.compareFileExtensionsUpper=g;function b(k,s){k=k||"",s=s||"";const P=m(k),F=m(s),x=E.value.collator,j=A.value.collator;return v(j,P,F)||a(k,s)||v(x,k,s)}e.compareFileExtensionsLower=b;function w(k,s){k=k||"",s=s||"";const P=m(k).toLowerCase(),F=m(s).toLowerCase();return P!==F?P<F?-1:1:k!==s?k<s?-1:1:0}e.compareFileExtensionsUnicode=w;const T=/^(.*?)(\.([^.]*))?$/;function o(k,s=!1){const P=k?T.exec(k):[];let F=[P&&P[1]||"",P&&P[3]||""];return s&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function m(k){const s=k?T.exec(k):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function v(k,s,P){let F=k.compare(s,P);return F!==0?F:s.length!==P.length?s.length<P.length?-1:1:0}function t(k){const s=k.charAt(0);return s.toLocaleUpperCase()!==s}function r(k){const s=k.charAt(0);return s.toLocaleLowerCase()!==s}function a(k,s){return t(k)&&r(s)?-1:r(k)&&t(s)?1:0}function i(k,s){return r(k)&&t(s)?-1:t(k)&&r(s)?1:0}function c(k,s,P=!1){return P||(k=k&&k.toLowerCase(),s=s&&s.toLowerCase()),k===s?0:k<s?-1:1}function p(k,s,P=!1){const F=k.split(R.sep),x=s.split(R.sep),j=F.length-1,ae=x.length-1;let oe,V;for(let W=0;;W++){if(oe=j===W,V=ae===W,oe&&V)return _(F[W],x[W],P);if(oe)return-1;if(V)return 1;const L=c(F[W],x[W],P);if(L!==0)return L}}e.comparePaths=p;function d(k,s,P){const F=k.toLowerCase(),x=s.toLowerCase(),j=D(k,s,P);if(j)return j;const ae=F.endsWith(P),oe=x.endsWith(P);if(ae!==oe)return ae?-1:1;const V=_(F,x);return V!==0?V:F.localeCompare(x)}e.compareAnything=d;function D(k,s,P){const F=k.toLowerCase(),x=s.toLowerCase(),j=F.startsWith(P),ae=x.startsWith(P);if(j!==ae)return j?-1:1;if(j&&ae){if(F.length<x.length)return-1;if(F.length>x.length)return 1}return 0}e.compareByPrefix=D}),define(be[27],Ee([0,1,15,44,21,14,8]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_;const y="**",I="/",n="[/\\\\]",C="[^/\\\\]",l=/\//g;function f(G){switch(G){case 0:return"";case 1:return`${C}*?`;default:return`(?:${n}|${C}+${n}|${n}${C}+)*?`}}function u(G,de){if(!G)return[];const $=[];let ne=!1,he=!1,ye="";for(const Ne of G){switch(Ne){case de:if(!ne&&!he){$.push(ye),ye="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":he=!0;break;case"]":he=!1;break}ye+=Ne}return ye&&$.push(ye),$}e.splitGlobAware=u;function g(G){if(!G)return"";let de="";const $=u(G,I);if($.every(ne=>ne===y))de=".*";else{let ne=!1;$.forEach((he,ye)=>{if(he===y){ne||(de+=f(2),ne=!0);return}let Ne=!1,Me="",$e=!1,Xe="";for(const qe of he){if(qe!=="}"&&Ne){Me+=qe;continue}if($e&&(qe!=="]"||!Xe)){let je;qe==="-"?je=qe:(qe==="^"||qe==="!")&&!Xe?je="^":qe===I?je="":je=A.escapeRegExpCharacters(qe),Xe+=je;continue}switch(qe){case"{":Ne=!0;continue;case"[":$e=!0;continue;case"}":de+=`(?:${u(Me,",").map(K=>g(K)).join("|")})`,Ne=!1,Me="";break;case"]":de+="["+Xe+"]",$e=!1,Xe="";break;case"?":de+=C;continue;case"*":de+=f(1);continue;default:de+=A.escapeRegExpCharacters(qe)}}ye<$.length-1&&($[ye+1]!==y||ye+2<$.length)&&(de+=n),ne=!1})}return de}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,T=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},a=function(){return null};function i(G,de){if(!G)return a;let $;typeof G!="string"?$=G.pattern:$=G,$=$.trim();const ne=`${$}_${!!de.trimForExclusions}`;let he=t.get(ne);if(he)return c(he,G);let ye;if(b.test($)){const Ne=$.substr(4);he=function(Me,$e){return typeof Me=="string"&&Me.endsWith(Ne)?$:null}}else(ye=w.exec(p($,de)))?he=d(ye[1],$):(de.trimForExclusions?o:T).test($)?he=D($,de):(ye=m.exec(p($,de)))?he=k(ye[1].substr(1),$,!0):(ye=v.exec(p($,de)))?he=k(ye[1],$,!1):he=s($);return t.set(ne,he),c(he,G)}function c(G,de){return typeof de=="string"?G:function($,ne){return R.isEqualOrParent($,de.base)?G(E.relative(de.base,$),ne):null}}function p(G,de){return de.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function d(G,de){const $=`/${G}`,ne=`\\${G}`,he=function(Ne,Me){return typeof Ne!="string"?null:Me?Me===G?de:null:Ne===G||Ne.endsWith($)||Ne.endsWith(ne)?de:null},ye=[G];return he.basenames=ye,he.patterns=[de],he.allBasenames=ye,he}function D(G,de){const $=O(G.slice(1,-1).split(",").map(Me=>i(Me,de)).filter(Me=>Me!==a),G),ne=$.length;if(!ne)return a;if(ne===1)return $[0];const he=function(Me,$e){for(let Xe=0,qe=$.length;Xe<qe;Xe++)if($[Xe](Me,$e))return G;return null},ye=$.find(Me=>!!Me.allBasenames);ye&&(he.allBasenames=ye.allBasenames);const Ne=$.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Ne.length&&(he.allPaths=Ne),he}function k(G,de,$){const ne=E.sep===E.posix.sep,he=ne?G:G.replace(l,E.sep),ye=E.sep+he,Ne=E.posix.sep+G,Me=$?function($e,Xe){return typeof $e=="string"&&($e===he||$e.endsWith(ye)||!ne&&($e===G||$e.endsWith(Ne)))?de:null}:function($e,Xe){return typeof $e=="string"&&($e===he||!ne&&$e===G)?de:null};return Me.allPaths=[($?"*/":"./")+G],Me}function s(G){try{const de=new RegExp(`^${g(G)}$`);return function($){return de.lastIndex=0,typeof $=="string"&&de.test($)?G:null}}catch(de){return a}}function P(G,de,$){return!G||typeof de!="string"?!1:F(G)(de,void 0,$)}e.match=P;function F(G,de={}){if(!G)return r;if(typeof G=="string"||oe(G)){const $=i(G,de);if($===a)return r;const ne=function(he,ye){return!!$(he,ye)};return $.allBasenames&&(ne.allBasenames=$.allBasenames),$.allPaths&&(ne.allPaths=$.allPaths),ne}return L(G,de)}e.parse=F;function x(G){if(!G)return;let de;return $=>(de||(de=(G()||Promise.resolve([])).then(ne=>ne?ae(ne):{})),de.then(ne=>!!ne[$]))}e.hasSiblingPromiseFn=x;function j(G){if(!G)return;let de;return $=>{if(!de){const ne=G();de=ne?ae(ne):{}}return!!de[$]}}e.hasSiblingFn=j;function ae(G){const de={};for(const $ of G)de[$]=!0;return de}function oe(G){const de=G;return de&&typeof de.base=="string"&&typeof de.pattern=="string"}e.isRelativePattern=oe;function V(G){return G.allBasenames||[]}e.getBasenameTerms=V;function W(G){return G.allPaths||[]}e.getPathTerms=W;function L(G,de){const $=O(Object.getOwnPropertyNames(G).map(Me=>Q(Me,G[Me],de)).filter(Me=>Me!==a)),ne=$.length;if(!ne)return a;if(!$.some(Me=>!!Me.requiresSiblings)){if(ne===1)return $[0];const Me=function(qe,je){for(let U=0,K=$.length;U<K;U++){const X=$[U](qe,je);if(X)return X}return null},$e=$.find(qe=>!!qe.allBasenames);$e&&(Me.allBasenames=$e.allBasenames);const Xe=$.reduce((qe,je)=>je.allPaths?qe.concat(je.allPaths):qe,[]);return Xe.length&&(Me.allPaths=Xe),Me}const he=function(Me,$e,Xe){let qe;for(let je=0,U=$.length;je<U;je++){const K=$[je];K.requiresSiblings&&Xe&&($e||($e=E.basename(Me)),qe||(qe=$e.substr(0,$e.length-E.extname(Me).length)));const X=K(Me,$e,qe,Xe);if(X)return X}return null},ye=$.find(Me=>!!Me.allBasenames);ye&&(he.allBasenames=ye.allBasenames);const Ne=$.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Ne.length&&(he.allPaths=Ne),he}function Q(G,de,$){if(de===!1)return a;const ne=i(G,$);if(ne===a)return a;if(typeof de=="boolean")return ne;if(de){const he=de.when;if(typeof he=="string"){const ye=(Ne,Me,$e,Xe)=>{if(!Xe||!ne(Ne,Me))return null;const qe=he.replace("$(basename)",$e),je=Xe(qe);return(0,h.isThenable)(je)?je.then(U=>U?G:null):je?G:null};return ye.requiresSiblings=!0,ye}}return ne}function O(G,de){const $=G.filter(Me=>!!Me.basenames);if($.length<2)return G;const ne=$.reduce((Me,$e)=>{const Xe=$e.basenames;return Xe?Me.concat(Xe):Me},[]);let he;if(de){he=[];for(let Me=0,$e=ne.length;Me<$e;Me++)he.push(de)}else he=$.reduce((Me,$e)=>{const Xe=$e.patterns;return Xe?Me.concat(Xe):Me},[]);const ye=function(Me,$e){if(typeof Me!="string")return null;if(!$e){let qe;for(qe=Me.length;qe>0;qe--){const je=Me.charCodeAt(qe-1);if(je===47||je===92)break}$e=Me.substr(qe)}const Xe=ne.indexOf($e);return Xe!==-1?he[Xe]:null};ye.basenames=ne,ye.patterns=he,ye.allBasenames=ne;const Ne=G.filter(Me=>!Me.basenames);return Ne.push(ye),Ne}}),define(be[84],Ee([0,1,44,11,14,22,25,8,2]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(i,c,p){if(typeof i=="string"&&(i=y.URI.file(i)),p){const D=p.getWorkspaceFolder(i);if(D){const k=p.getWorkspace().folders.length>1;let s;if((0,A.isEqual)(D.uri,i)?s="":s=(0,A.relativePath)(D.uri,i),k){const P=D.name?D.name:(0,A.basename)(D.uri);s=s?P+" \u2022 "+s:P}return s}}if(i.scheme!==R.Schemas.file&&i.scheme!==R.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(i.fsPath))return(0,S.normalize)(C(i.fsPath));let d=(0,S.normalize)(i.fsPath);return!E.isWindows&&c?.userHome&&(d=f(d,c.userHome.fsPath)),d}e.getPathLabel=I;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,A.basename)(i)||(i.scheme===R.Schemas.file?i.fsPath:i.path);return E.isWindows&&(0,h.isRootOrDriveLetter)(c)?C(c):c}e.getBaseLabel=n;function C(i){return(0,h.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let l=Object.create(null);function f(i,c){if(E.isWindows||!i||!c)return i;let p=l.original===c?l.normalized:void 0;return p||(p=`${(0,_.rtrim)(c,S.posix.sep)}${S.posix.sep}`,l={original:c,normalized:p}),(E.isLinux?i.startsWith(p):(0,_.startsWithIgnoreCase)(i,p))&&(i=`~/${i.substr(p.length)}`),i}e.tildify=f;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const g="\u2026",b="\\\\",w="~";function T(i,c=S.sep){const p=new Array(i.length);let d=!1;for(let D=0;D<i.length;D++){let k=i[D];if(k===""){p[D]=`.${c}`;continue}if(!k){p[D]=k;continue}d=!0;let s="";k.indexOf(b)===0?(s=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(c)===0?(s=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(w)===0&&(s=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length));const P=k.split(c);for(let F=1;d&&F<=P.length;F++)for(let x=P.length-F;d&&x>=0;x--){d=!1;let j=P.slice(x,x+F).join(c);for(let ae=0;!d&&ae<i.length;ae++)if(ae!==D&&i[ae]&&i[ae].indexOf(j)>-1){const oe=x+F===P.length,V=x>0&&i[ae].indexOf(c)>-1?c+j:j,W=i[ae].endsWith(V);d=!oe||W}if(!d){let ae="";(P[0].endsWith(":")||s!=="")&&(x===1&&(x=0,F++,j=P[0]+c+j),x>0&&(ae=P[0]+c),ae=s+ae),x>0&&(ae=ae+g+c),ae=ae+j,x+F<P.length&&(ae=ae+c+g),p[D]=ae}}d&&(p[D]=k)}return p}e.shorten=T;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function m(i,c=Object.create(null)){const p=[];let d=!1,D="";for(const k of i)if(k==="$"||d&&k==="{")D&&p.push({value:D,type:o.TEXT}),D="",d=!0;else if(k==="}"&&d){const s=c[D];if(typeof s=="string")s.length&&p.push({value:s,type:o.VARIABLE});else if(s){const P=p[p.length-1];(!P||P.type!==o.SEPARATOR)&&p.push({value:s.label,type:o.SEPARATOR})}D="",d=!1}else D+=k;return D&&!d&&p.push({value:D,type:o.TEXT}),p.filter((k,s)=>{if(k.type===o.SEPARATOR){const P=p[s-1],F=p[s+1];return[P,F].every(x=>x&&(x.type===o.VARIABLE||x.type===o.TEXT)&&x.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=m;function v(i,c){return E.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):i.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return E.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):E.isWindows?i.replace(/&&|&/g,p=>p==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function a(i){const c=i.indexOf("/")!==-1?S.posix:S.win32,p=c.basename(i),d=c.dirname(i);return p.length?{name:p,parentPath:d}:{name:d,parentPath:""}}e.splitName=a}),define(be[85],Ee([0,1,27,11,14,25,8]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var _;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(_=e.Mimes||(e.Mimes={}));let y=[],I=[],n=[];function C(r,a=!1){const i=l(r);y.push(i),i.userConfigured?n.push(i):I.push(i),a&&!i.userConfigured&&y.forEach(c=>{c.mime===i.mime||c.userConfigured||(i.extension&&c.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&c.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&c.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&c.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=C;function l(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(S.posix.sep)>=0:!1}}function f(r){r?(y=y.filter(a=>!a.userConfigured),n=[]):(y=[],I=[],n=[])}e.clearTextMimes=f;function u(r,a){let i;if(r)switch(r.scheme){case R.Schemas.file:i=r.fsPath;break;case R.Schemas.data:i=E.DataUri.parseMetaData(r).get(E.DataUri.META_DATA_LABEL);break;default:i=r.path}if(!i)return[_.unknown];i=i.toLowerCase();const c=(0,S.basename)(i),p=g(i,c,n);if(p)return[p,_.text];const d=g(i,c,I);if(d)return[d,_.text];if(a){const D=b(a);if(D)return[D,_.text]}return[_.unknown]}e.guessMimeTypes=u;function g(r,a,i){let c=null,p=null,d=null;for(let D=i.length-1;D>=0;D--){const k=i[D];if(a===k.filenameLowercase){c=k;break}if(k.filepattern&&(!p||k.filepattern.length>p.filepattern.length)){const s=k.filepatternOnPath?r:a;(0,h.match)(k.filepatternLowercase,s)&&(p=k)}k.extension&&(!d||k.extension.length>d.extension.length)&&a.endsWith(k.extensionLowercase)&&(d=k)}return c?c.mime:p?p.mime:d?d.mime:null}function b(r){if((0,A.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let a=y.length-1;a>=0;a--){const i=y[a];if(!i.firstline)continue;const c=r.match(i.firstline);if(c&&c.length>0)return i.mime}return null}function w(r){return r?typeof r=="string"?r===_.binary||r===_.text||r===_.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(r){const a=(0,S.extname)(r);return T[a.toLowerCase()]}e.getMediaMime=o;function m(r){for(const a in T)if(T[a]===r)return a}e.getExtensionForMimeType=m;const v=/^(.+)\/(.+?)(;.+)?$/;function t(r,a){const i=v.exec(r);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:a?void 0:r}e.normalizeMimeType=t}),define(be[117],Ee([0,1,2]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class S{constructor(C){this._uriTransformer=C}transformIncoming(C){const l=this._uriTransformer.transformIncoming(C);return l===C?C:R(h.URI.from(l))}transformOutgoing(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:R(h.URI.from(l))}transformOutgoingURI(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:h.URI.from(l)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function E(n,C,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof h.URI)return C.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const u=E(n[f],C,l+1);u!==null&&(n[f]=u)}}return null}function A(n,C){const l=E(n,C,0);return l===null?n:l}e.transformOutgoingURIs=A;function _(n,C,l,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?h.URI.revive(C.transformIncoming(n)):C.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const g=_(n[u],C,l,f+1);g!==null&&(n[u]=g)}}return null}function y(n,C){const l=_(n,C,!1,0);return l===null?n:l}e.transformIncomingURIs=y;function I(n,C){const l=_(n,C,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=I}),define(be[37],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return h.test(y)}e.isUUID=R;const S=new Uint8Array(16),E=[];for(let y=0;y<256;y++)E.push(y.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(y){for(let I=0;I<y.length;I++)y[I]=Math.floor(Math.random()*256);return y};function _(){A(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let y=0,I="";return I+=E[S[y++]],I+=E[S[y++]],I+=E[S[y++]],I+=E[S[y++]],I+="-",I+=E[S[y++]],I+=E[S[y++]],I+="-",I+=E[S[y++]],I+=E[S[y++]],I+="-",I+=E[S[y++]],I+=E[S[y++]],I+="-",I+=E[S[y++]],I+=E[S[y++]],I+=E[S[y++]],I+=E[S[y++]],I+=E[S[y++]],I+=E[S[y++]],I}e.generateUuid=_}),define(be[86],Ee([0,1,82]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(_){let y=(0,h.toUint8)(_);this._defaultValue=y,this._asciiMap=R._createAsciiMap(y),this._map=new Map}static _createAsciiMap(_){let y=new Uint8Array(256);for(let I=0;I<256;I++)y[I]=_;return y}set(_,y){let I=(0,h.toUint8)(y);_>=0&&_<256?this._asciiMap[_]=I:this._map.set(_,I)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}}e.CharacterClassifier=R;var S;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(S||(S={}));class E{constructor(){this._actual=new R(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}}e.CharacterSet=E}),define(be[118],Ee([0,1,86]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends h.CharacterClassifier{constructor(_){super(0);for(let y=0,I=_.length;y<I;y++)this.set(_.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function E(A){let _={};return y=>(_.hasOwnProperty(y)||(_[y]=A(y)),_[y])}e.getMapForWordSeparators=E(A=>new S(A))}),define(be[38],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(S,E){this.lineNumber=S,this.column=E}with(S=this.lineNumber,E=this.column){return S===this.lineNumber&&E===this.column?this:new h(S,E)}delta(S=0,E=0){return this.with(this.lineNumber+S,this.column+E)}equals(S){return h.equals(this,S)}static equals(S,E){return!S&&!E?!0:!!S&&!!E&&S.lineNumber===E.lineNumber&&S.column===E.column}isBefore(S){return h.isBefore(this,S)}static isBefore(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<E.column}isBeforeOrEqual(S){return h.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<=E.column}static compare(S,E){let A=S.lineNumber|0,_=E.lineNumber|0;if(A===_){let y=S.column|0,I=E.column|0;return y-I}return A-_}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new h(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=h}),define(be[31],Ee([0,1,38]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(E,A,_,y){E>_||E===_&&A>y?(this.startLineNumber=_,this.startColumn=y,this.endLineNumber=E,this.endColumn=A):(this.startLineNumber=E,this.startColumn=A,this.endLineNumber=_,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return R.containsPosition(this,E)}static containsPosition(E,A){return!(A.lineNumber<E.startLineNumber||A.lineNumber>E.endLineNumber||A.lineNumber===E.startLineNumber&&A.column<E.startColumn||A.lineNumber===E.endLineNumber&&A.column>E.endColumn)}containsRange(E){return R.containsRange(this,E)}static containsRange(E,A){return!(A.startLineNumber<E.startLineNumber||A.endLineNumber<E.startLineNumber||A.startLineNumber>E.endLineNumber||A.endLineNumber>E.endLineNumber||A.startLineNumber===E.startLineNumber&&A.startColumn<E.startColumn||A.endLineNumber===E.endLineNumber&&A.endColumn>E.endColumn)}strictContainsRange(E){return R.strictContainsRange(this,E)}static strictContainsRange(E,A){return!(A.startLineNumber<E.startLineNumber||A.endLineNumber<E.startLineNumber||A.startLineNumber>E.endLineNumber||A.endLineNumber>E.endLineNumber||A.startLineNumber===E.startLineNumber&&A.startColumn<=E.startColumn||A.endLineNumber===E.endLineNumber&&A.endColumn>=E.endColumn)}plusRange(E){return R.plusRange(this,E)}static plusRange(E,A){let _,y,I,n;return A.startLineNumber<E.startLineNumber?(_=A.startLineNumber,y=A.startColumn):A.startLineNumber===E.startLineNumber?(_=A.startLineNumber,y=Math.min(A.startColumn,E.startColumn)):(_=E.startLineNumber,y=E.startColumn),A.endLineNumber>E.endLineNumber?(I=A.endLineNumber,n=A.endColumn):A.endLineNumber===E.endLineNumber?(I=A.endLineNumber,n=Math.max(A.endColumn,E.endColumn)):(I=E.endLineNumber,n=E.endColumn),new R(_,y,I,n)}intersectRanges(E){return R.intersectRanges(this,E)}static intersectRanges(E,A){let _=E.startLineNumber,y=E.startColumn,I=E.endLineNumber,n=E.endColumn,C=A.startLineNumber,l=A.startColumn,f=A.endLineNumber,u=A.endColumn;return _<C?(_=C,y=l):_===C&&(y=Math.max(y,l)),I>f?(I=f,n=u):I===f&&(n=Math.min(n,u)),_>I||_===I&&y>n?null:new R(_,y,I,n)}equalsRange(E){return R.equalsRange(this,E)}static equalsRange(E,A){return!!E&&!!A&&E.startLineNumber===A.startLineNumber&&E.startColumn===A.startColumn&&E.endLineNumber===A.endLineNumber&&E.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(E){return new h.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(E){return new h.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,A){return new R(this.startLineNumber,this.startColumn,E,A)}setStartPosition(E,A){return new R(E,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(E){return new R(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,A=E){return new R(E.lineNumber,E.column,A.lineNumber,A.column)}static lift(E){return E?new R(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,A){return!(E.endLineNumber<A.startLineNumber||E.endLineNumber===A.startLineNumber&&E.endColumn<A.startColumn||A.endLineNumber<E.startLineNumber||A.endLineNumber===E.startLineNumber&&A.endColumn<E.startColumn)}static areIntersecting(E,A){return!(E.endLineNumber<A.startLineNumber||E.endLineNumber===A.startLineNumber&&E.endColumn<=A.startColumn||A.endLineNumber<E.startLineNumber||A.endLineNumber===E.startLineNumber&&A.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,A){if(E&&A){const I=E.startLineNumber|0,n=A.startLineNumber|0;if(I===n){const C=E.startColumn|0,l=A.startColumn|0;if(C===l){const f=E.endLineNumber|0,u=A.endLineNumber|0;if(f===u){const g=E.endColumn|0,b=A.endColumn|0;return g-b}return f-u}return C-l}return I-n}return(E?1:0)-(A?1:0)}static compareRangesUsingEnds(E,A){return E.endLineNumber===A.endLineNumber?E.endColumn===A.endColumn?E.startLineNumber===A.startLineNumber?E.startColumn-A.startColumn:E.startLineNumber-A.startLineNumber:E.endColumn-A.endColumn:E.endLineNumber-A.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=R}),define(be[119],Ee([0,1,38,31]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class E extends R.Range{constructor(_,y,I,n){super(_,y,I,n);this.selectionStartLineNumber=_,this.selectionStartColumn=y,this.positionLineNumber=I,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return E.selectionsEqual(this,_)}static selectionsEqual(_,y){return _.selectionStartLineNumber===y.selectionStartLineNumber&&_.selectionStartColumn===y.selectionStartColumn&&_.positionLineNumber===y.positionLineNumber&&_.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,y){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,_,y):new E(_,y,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(_,y){return this.getDirection()===0?new E(_,y,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,_,y)}static fromPositions(_,y=_){return new E(_.lineNumber,_.column,y.lineNumber,y.column)}static liftSelection(_){return new E(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,y){if(_&&!y||!_&&y)return!1;if(!_&&!y)return!0;if(_.length!==y.length)return!1;for(let I=0,n=_.length;I<n;I++)if(!this.selectionsEqual(_[I],y[I]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,y,I,n,C){return C===0?new E(_,y,I,n):new E(I,n,_,y)}}e.Selection=E}),define(be[87],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var h;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(h=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace)}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class y{constructor(g,b){this._findMatchBrand=void 0,this.range=g,this.matches=b}}e.FindMatch=y;var I;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class l{constructor(g,b,w,T,o,m){this.identifier=g,this.range=b,this.text=w,this.forceMoveMarkers=T,this.isAutoWhitespaceEdit=o,this._isTracked=m}}e.ValidAnnotatedEditOperation=l;class f{constructor(g,b,w){this.reverseEdits=g,this.changes=b,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=f}),define(be[120],Ee([0,1,8,118,38,31,87]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const _=999;class y{constructor(o,m,v,t){this.searchString=o,this.isRegex=m,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=I(this.searchString):o=this.searchString.indexOf(`
`)>=0;let m=null;try{m=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(t){return null}if(!m)return null;let v=!this.isRegex&&!o;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(m,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=y;function I(T){if(!T||T.length===0)return!1;for(let o=0,m=T.length;o<m;o++)if(T.charCodeAt(o)===92){if(o++,o>=m)break;const t=T.charCodeAt(o);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=I;class n{constructor(o,m,v){this.regex=o,this.wordSeparators=m,this.simpleSearch=v}}e.SearchData=n;function C(T,o,m){if(!m)return new A.FindMatch(T,null);let v=[];for(let t=0,r=o.length;t<r;t++)v[t]=o[t];return new A.FindMatch(T,v)}e.createFindMatch=C;class l{constructor(o){let m=[],v=0;for(let t=0,r=o.length;t<r;t++)o.charCodeAt(t)===10&&(m[v++]=t);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(o){const m=this._lineFeedsOffsets;let v=0,t=m.length-1;if(t===-1||o<=m[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);m[r]>=o?t=r-1:m[r+1]>=o?(v=r,t=r):v=r+1}return v+1}}class f{static findMatches(o,m,v,t,r){const a=m.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,v,new w(a.wordSeparators,a.regex),t,r):this._doFindMatchesLineByLine(o,v,a,t,r):[]}static _getMultilineMatchRange(o,m,v,t,r,a){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(r),i=m+r+c):i=m+r;let p;if(t){let s=t.findLineFeedCountBeforeOffset(r+a.length)-c;p=i+a.length+s}else p=i+a.length;const d=o.getPositionAt(i),D=o.getPositionAt(p);return new E.Range(d.lineNumber,d.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(o,m,v,t,r){const a=o.getOffsetAt(m.getStartPosition()),i=o.getValueInRange(m,1),c=o.getEOL()===`\r
`?new l(i):null,p=[];let d=0,D;for(v.reset(0);D=v.next(i);)if(p[d++]=C(this._getMultilineMatchRange(o,a,i,c,D.index,D[0]),D,t),d>=r)return p;return p}static _doFindMatchesLineByLine(o,m,v,t,r){const a=[];let i=0;if(m.startLineNumber===m.endLineNumber){const p=o.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return i=this._findMatchesInLine(v,p,m.startLineNumber,m.startColumn-1,i,a,t,r),a}const c=o.getLineContent(m.startLineNumber).substring(m.startColumn-1);i=this._findMatchesInLine(v,c,m.startLineNumber,m.startColumn-1,i,a,t,r);for(let p=m.startLineNumber+1;p<m.endLineNumber&&i<r;p++)i=this._findMatchesInLine(v,o.getLineContent(p),p,0,i,a,t,r);if(i<r){const p=o.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);i=this._findMatchesInLine(v,p,m.endLineNumber,0,i,a,t,r)}return a}static _findMatchesInLine(o,m,v,t,r,a,i,c){const p=o.wordSeparators;if(!i&&o.simpleSearch){const k=o.simpleSearch,s=k.length,P=m.length;let F=-s;for(;(F=m.indexOf(k,F+s))!==-1;)if((!p||b(p,m,P,F,s))&&(a[r++]=new A.FindMatch(new E.Range(v,F+1+t,v,F+1+s+t),null),r>=c))return r;return r}const d=new w(o.wordSeparators,o.regex);let D;d.reset(0);do if(D=d.next(m),D&&(a[r++]=C(new E.Range(v,D.index+1+t,v,D.index+1+D[0].length+t),D,i),r>=c))return r;while(D);return r}static findNextMatch(o,m,v,t){const r=m.parseSearchRequest();if(!r)return null;const a=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(o,v,a,t):this._doFindNextMatchLineByLine(o,v,a,t)}static _doFindNextMatchMultiline(o,m,v,t){const r=new S.Position(m.lineNumber,1),a=o.getOffsetAt(r),i=o.getLineCount(),c=o.getValueInRange(new E.Range(r.lineNumber,r.column,i,o.getLineMaxColumn(i)),1),p=o.getEOL()===`\r
`?new l(c):null;v.reset(m.column-1);let d=v.next(c);return d?C(this._getMultilineMatchRange(o,a,c,p,d.index,d[0]),d,t):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(o,new S.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(o,m,v,t){const r=o.getLineCount(),a=m.lineNumber,i=o.getLineContent(a),c=this._findFirstMatchInLine(v,i,a,m.column,t);if(c)return c;for(let p=1;p<=r;p++){const d=(a+p-1)%r,D=o.getLineContent(d+1),k=this._findFirstMatchInLine(v,D,d+1,1,t);if(k)return k}return null}static _findFirstMatchInLine(o,m,v,t,r){o.reset(t-1);const a=o.next(m);return a?C(new E.Range(v,a.index+1,v,a.index+1+a[0].length),a,r):null}static findPreviousMatch(o,m,v,t){const r=m.parseSearchRequest();if(!r)return null;const a=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(o,v,a,t):this._doFindPreviousMatchLineByLine(o,v,a,t)}static _doFindPreviousMatchMultiline(o,m,v,t){const r=this._doFindMatchesMultiline(o,new E.Range(1,1,m.lineNumber,m.column),v,t,10*_);if(r.length>0)return r[r.length-1];const a=o.getLineCount();return m.lineNumber!==a||m.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new S.Position(a,o.getLineMaxColumn(a)),v,t):null}static _doFindPreviousMatchLineByLine(o,m,v,t){const r=o.getLineCount(),a=m.lineNumber,i=o.getLineContent(a).substring(0,m.column-1),c=this._findLastMatchInLine(v,i,a,t);if(c)return c;for(let p=1;p<=r;p++){const d=(r+a-p-1)%r,D=o.getLineContent(d+1),k=this._findLastMatchInLine(v,D,d+1,t);if(k)return k}return null}static _findLastMatchInLine(o,m,v,t){let r=null,a;for(o.reset(0);a=o.next(m);)r=C(new E.Range(v,a.index+1,v,a.index+1+a[0].length),a,t);return r}}e.TextModelSearch=f;function u(T,o,m,v,t){if(v===0)return!0;const r=o.charCodeAt(v-1);if(T.get(r)!==0||r===13||r===10)return!0;if(t>0){const a=o.charCodeAt(v);if(T.get(a)!==0)return!0}return!1}function g(T,o,m,v,t){if(v+t===m)return!0;const r=o.charCodeAt(v+t);if(T.get(r)!==0||r===13||r===10)return!0;if(t>0){const a=o.charCodeAt(v+t-1);if(T.get(a)!==0)return!0}return!1}function b(T,o,m,v,t){return u(T,o,m,v,t)&&g(T,o,m,v,t)}e.isValidMatch=b;class w{constructor(o,m){this._wordSeparators=o,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const m=o.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(v=this._searchRegex.exec(o),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){h.getNextCodePoint(o,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,o,m,t,r))return v}while(v);return null}}e.Searcher=w}),define(be[88],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(_=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)_.indexOf(I)>=0||(y+="\\"+I);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=h();function R(_){let y=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)y=_;else{let I="g";_.ignoreCase&&(I+="i"),_.multiline&&(I+="m"),_.unicode&&(I+="u"),y=new RegExp(_.source,I)}return y.lastIndex=0,y}e.ensureValidWordDefinition=R;const S={maxLen:1e3,windowSize:15,timeBudget:150};function E(_,y,I,n,C=S){if(I.length>C.maxLen){let b=_-C.maxLen/2;return b<0?b=0:n+=b,I=I.substring(b,_+C.maxLen/2),E(_,y,I,n,C)}const l=Date.now(),f=_-1-n;let u=-1,g=null;for(let b=1;!(Date.now()-l>=C.timeBudget);b++){const w=f-C.windowSize*b;y.lastIndex=Math.max(0,w);const T=A(y,I,f,u);if(!T&&g||(g=T,w<=0))break;u=w}if(g){let b={word:g[0],startColumn:n+1+g.index,endColumn:n+1+g.index+g[0].length};return y.lastIndex=0,b}return null}e.getWordAtText=E;function A(_,y,I,n){let C;for(;C=_.exec(y);){const l=C.index||0;if(l<=I&&_.lastIndex>=I)return C;if(n>0&&l>n)return null}return null}}),define(be[121],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class R{constructor(_){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=_.open,this.close=_.close,this._standardTokenMask=0,Array.isArray(_.notIn))for(let y=0,I=_.notIn.length;y<I;y++)switch(_.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(_){return(this._standardTokenMask&_)==0}}e.StandardAutoClosingPairConditional=R;class S{constructor(_){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of _)E(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),E(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),E(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),E(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&E(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function E(A,_,y){A.has(_)?A.get(_).push(y):A.set(_,[y])}}),define(be[58],Ee([0,1,27,14]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(E,A,_,y){if(Array.isArray(E)){let I=0;for(const n of E){const C=S(n,A,_,y);if(C===10)return C;C>I&&(I=C)}return I}else{if(typeof E=="string")return y?E==="*"?5:E===_?10:0:0;if(E){const{language:I,pattern:n,scheme:C,hasAccessToAllModels:l}=E;if(!y&&!l)return 0;let f=0;if(C)if(C===A.scheme)f=10;else if(C==="*")f=5;else return 0;if(I)if(I===_)f=10;else if(I==="*")f=Math.max(f,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,R.normalize)(n.base)},u===A.fsPath||(0,h.match)(u,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=S}),define(be[122],Ee([0,1,86]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class S{constructor(u,g,b){const w=new Uint8Array(u*g);for(let T=0,o=u*g;T<o;T++)w[T]=b;this._data=w,this.rows=u,this.cols=g}get(u,g){return this._data[u*this.cols+g]}set(u,g,b){this._data[u*this.cols+g]=b}}e.Uint8Matrix=S;class E{constructor(u){let g=0,b=0;for(let T=0,o=u.length;T<o;T++){let[m,v,t]=u[T];v>g&&(g=v),m>b&&(b=m),t>b&&(b=t)}g++,b++;let w=new S(b,g,0);for(let T=0,o=u.length;T<o;T++){let[m,v,t]=u[T];w.set(m,v,t)}this._states=w,this._maxCharCode=g}nextState(u,g){return g<0||g>=this._maxCharCode?0:this._states.get(u,g)}}e.StateMachine=E;let A=null;function _(){return A===null&&(A=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let I=null;function n(){if(I===null){I=new h.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<f.length;g++)I.set(f.charCodeAt(g),1);const u=".,;";for(let g=0;g<u.length;g++)I.set(u.charCodeAt(g),2)}return I}class C{static _createLink(u,g,b,w,T){let o=T-1;do{const m=g.charCodeAt(o);if(u.get(m)!==2)break;o--}while(o>w);if(w>0){const m=g.charCodeAt(w-1),v=g.charCodeAt(o);(m===40&&v===41||m===91&&v===93||m===123&&v===125)&&o--}return{range:{startLineNumber:b,startColumn:w+1,endLineNumber:b,endColumn:o+2},url:g.substring(w,o+1)}}static computeLinks(u,g=_()){const b=n();let w=[];for(let T=1,o=u.getLineCount();T<=o;T++){const m=u.getLineContent(T),v=m.length;let t=0,r=0,a=0,i=1,c=!1,p=!1,d=!1,D=!1;for(;t<v;){let k=!1;const s=m.charCodeAt(t);if(i===13){let P;switch(s){case 40:c=!0,P=0;break;case 41:P=c?0:1;break;case 91:d=!0,p=!0,P=0;break;case 93:d=!1,P=p?0:1;break;case 123:D=!0,P=0;break;case 125:P=D?0:1;break;case 39:P=a===34||a===96?0:1;break;case 34:P=a===39||a===96?0:1;break;case 96:P=a===39||a===34?0:1;break;case 42:P=a===42?1:0;break;case 124:P=a===124?1:0;break;case 32:P=d?0:1;break;default:P=b.get(s)}P===1&&(w.push(C._createLink(b,m,T,r,t)),k=!0)}else if(i===12){let P;s===91?(p=!0,P=0):P=b.get(s),P===1?k=!0:i=13}else i=g.nextState(i,s),i===0&&(k=!0);k&&(i=1,c=!1,p=!1,D=!1,r=t+1,a=s),t++}i===13&&w.push(C._createLink(b,m,T,r,v))}return w}}e.LinkComputer=C;function l(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:C.computeLinks(f)}e.computeLinks=l}),define(be[123],Ee([0,1,3,6]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,_){return this._map.set(A,_),this.fire([A]),(0,R.toDisposable)(()=>{this._map.get(A)===_&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,_){let y=null,I=!1;return this._promises.set(A,_.then(n=>{this._promises.delete(A),!(I||!n)&&(y=this.register(A,n))})),(0,R.toDisposable)(()=>{I=!0,y&&y.dispose()})}getPromise(A){const _=this.get(A);if(_)return Promise.resolve(_);const y=this._promises.get(A);return y?y.then(I=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(be[89],Ee([0,1,24,22]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(S||(S={}));function E(C){for(let l=0,f=C.length;l<f;l+=4){const u=C[l+0],g=C[l+1],b=C[l+2],w=C[l+3];C[l+0]=w,C[l+1]=b,C[l+2]=g,C[l+3]=u}}function A(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return R.isLittleEndian()||E(l),h.VSBuffer.wrap(l)}function _(C){const l=C.buffer;if(R.isLittleEndian()||E(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const f=new Uint8Array(l.byteLength);return f.set(l),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(C){const l=new Uint32Array(I(C));let f=0;if(l[f++]=C.id,C.type==="full")l[f++]=1,l[f++]=C.data.length,l.set(C.data,f),f+=C.data.length;else{l[f++]=2,l[f++]=C.deltas.length;for(const u of C.deltas)l[f++]=u.start,l[f++]=u.deleteCount,u.data?(l[f++]=u.data.length,l.set(u.data,f),f+=u.data.length):l[f++]=0}return A(l)}e.encodeSemanticTokensDto=y;function I(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const f of C.deltas)f.data&&(l+=f.data.length)}return l}function n(C){const l=_(C);let f=0;const u=l[f++];if(l[f++]===1){const T=l[f++],o=l.subarray(f,f+T);return f+=T,{id:u,type:"full",data:o}}const b=l[f++];let w=[];for(let T=0;T<b;T++){const o=l[f++],m=l[f++],v=l[f++];let t;v>0&&(t=l.subarray(f,f+v),f+=v),w[T]={start:o,deleteCount:m,data:t}}return{id:u,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(be[90],Ee([0,1,82]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,_){this._prefixSumIndexOfResultBrand=void 0,this.index=A,this.remainder=_}}e.PrefixSumIndexOfResult=R;class S{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,_){A=(0,h.toUint32)(A);const y=this.values,I=this.prefixSum,n=_.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,A),0),this.values.set(y.subarray(A),A+n),this.values.set(_,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,_){return A=(0,h.toUint32)(A),_=(0,h.toUint32)(_),this.values[A]===_?!1:(this.values[A]=_,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,_){A=(0,h.toUint32)(A),_=(0,h.toUint32)(_);const y=this.values,I=this.prefixSum;if(A>=y.length)return!1;let n=y.length-A;return _>=n&&(_=n),_===0?!1:(this.values=new Uint32Array(y.length-_),this.values.set(y.subarray(0,A),0),this.values.set(y.subarray(A+_),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=(0,h.toUint32)(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let _=this.prefixSumValidIndex[0]+1;_===0&&(this.prefixSum[0]=this.values[0],_++),A>=this.values.length&&(A=this.values.length-1);for(let y=_;y<=A;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let _=0,y=this.values.length-1,I=0,n=0,C=0;for(;_<=y;)if(I=_+(y-_)/2|0,n=this.prefixSum[I],C=n-this.values[I],A<C)y=I-1;else if(A>=n)_=I+1;else break;return new R(I,A-C)}}e.PrefixSumComputer=S}),define(be[124],Ee([0,1,8,38,90]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(_,y,I,n){this._uri=_,this._lines=y,this._eol=I,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const y=_.changes;for(const I of y)this._acceptDeleteRange(I.range),this._acceptInsertText(new R.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,y=this._lines.length,I=new Uint32Array(y);for(let n=0;n<y;n++)I[n]=this._lines[n].length+_;this._lineStarts=new S.PrefixSumComputer(I)}}_setLineText(_,y){this._lines[_]=y,this._lineStarts&&this._lineStarts.changeValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,y){if(y.length===0)return;let I=(0,h.splitLines)(y);if(I.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+I[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}I[I.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+I[0]);let n=new Uint32Array(I.length-1);for(let C=1;C<I.length;C++)this._lines.splice(_.lineNumber+C-1,0,I[C]),n[C-1]=I[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,n)}}e.MirrorTextModel=E}),define(be[125],Ee([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(be[59],Ee([0,1,17,10,125]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(I,n){return n&&(I.stack||I.stacktrace)?S.localize(0,null,_(I),A(I.stack)||A(I.stacktrace)):_(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function _(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?S.localize(1,null,I.message):I.message||S.localize(2,null)}function y(I=null,n=!1){if(!I)return S.localize(3,null);if(Array.isArray(I)){const C=h.coalesce(I),l=y(C[0],n);return C.length>1?S.localize(4,null,l,C.length):l}if(R.isString(I))return I;if(I.detail){const C=I.detail;if(C.error)return E(C.error,n);if(C.exception)return E(C.exception,n)}return I.stack?E(I,n):I.message?I.message:S.localize(5,null)}e.toErrorMessage=y}),define(be[126],Ee([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(be[127],Ee([0,1,126,22,88]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=A;class _{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,ce){this._values[Z]=ce}}e.ValidatedEditorOptions=_;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class I{constructor(Z,ce,Ue,xe){this.id=Z,this.name=ce,this.defaultValue=Ue,this.schema=xe}compute(Z,ce,Ue){return Ue}}class n{constructor(Z,ce=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=ce}validate(Z){return this.defaultValue}}class C{constructor(Z,ce,Ue,xe){this.id=Z,this.name=ce,this.defaultValue=Ue,this.schema=xe}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,ce,Ue){return Ue}}function l(z,Z){return typeof z=="undefined"?Z:z==="false"?!1:Boolean(z)}e.boolean=l;class f extends C{constructor(Z,ce,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Ue),super(Z,ce,Ue,xe)}validate(Z){return l(Z,this.defaultValue)}}class u extends C{constructor(Z,ce,Ue,xe,et,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Ue,De.minimum=xe,De.maximum=et),super(Z,ce,Ue,De),this.minimum=xe,this.maximum=et}static clampedInt(Z,ce,Ue,xe){if(typeof Z=="undefined")return ce;let et=parseInt(Z,10);return isNaN(et)?ce:(et=Math.max(Ue,et),et=Math.min(xe,et),et|0)}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class g extends C{constructor(Z,ce,Ue,xe,et){typeof et!="undefined"&&(et.type="number",et.default=Ue),super(Z,ce,Ue,et),this.validationFn=xe}static clamp(Z,ce,Ue){return Z<ce?ce:Z>Ue?Ue:Z}static float(Z,ce){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return ce;const Ue=parseFloat(Z);return isNaN(Ue)?ce:Ue}validate(Z){return this.validationFn(g.float(Z,this.defaultValue))}}class b extends C{static string(Z,ce){return typeof Z!="string"?ce:Z}constructor(Z,ce,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Ue),super(Z,ce,Ue,xe)}validate(Z){return b.string(Z,this.defaultValue)}}function w(z,Z,ce){return typeof z!="string"||ce.indexOf(z)===-1?Z:z}e.stringSet=w;class T extends C{constructor(Z,ce,Ue,xe,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=xe,et.default=Ue),super(Z,ce,Ue,et),this._allowedValues=xe}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class o extends I{constructor(Z,ce,Ue,xe,et,De,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=et,Se.default=xe),super(Z,ce,Ue,Se),this._allowedValues=et,this._convert=De}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function m(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ce,Ue){return Ue===0?Z.accessibilitySupport:Ue}}class t extends I{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{insertSpace:l(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(z){switch(z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function p(z){switch(z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class d extends n{constructor(){super(126,[64,31])}compute(Z,ce,Ue){const xe=["monaco-editor"];return ce.get(31)&&xe.push(ce.get(31)),Z.extraEditorClassName&&xe.push(Z.extraEditorClassName),ce.get(64)==="default"?xe.push("mouse-default"):ce.get(64)==="copy"&&xe.push("mouse-copy"),ce.get(99)&&xe.push("showUnused"),ce.get(124)&&xe.push("showDeprecated"),xe.join(" ")}}class D extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Z,ce,Ue){return Ue&&Z.emptySelectionClipboard}}class k extends I{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:h.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:h.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{cursorMoveOnType:l(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":w(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ce.loop,this.defaultValue.loop)}}}class s extends I{constructor(){super(42,"fontLigatures",s.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?s.OFF:Z==="true"?s.ON:Z:Boolean(Z)?s.ON:s.OFF}}e.EditorFontLigatures=s,s.OFF='"liga" off, "calt" off',s.ON='"liga" on, "calt" on';class P extends n{constructor(){super(41)}compute(Z,ce,Ue){return Z.fontInfo}}class F extends C{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(Z){let ce=g.float(Z,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(ce,6,100)}compute(Z,ce,Ue){return Z.fontInfo.fontSize}}class x extends I{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class j extends I{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...ce},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...ce},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ue,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ue,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ue,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ue,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ue,description:h.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{multiple:w(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??w(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??w(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??w(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??w(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??w(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends I{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(51,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:h.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),delay:u.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:l(ce.sticky,this.defaultValue.sticky)}}}var oe;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(oe=e.RenderMinimap||(e.RenderMinimap={}));class V extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(Z,ce,Ue){return V.computeLayout(ce,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const ce=Z.height/Z.lineHeight,Ue=Z.scrollBeyondLastLine?ce-1:0,xe=(Z.viewLineCount+Ue)/(Z.pixelRatio*Z.height),et=Math.floor(Z.viewLineCount/xe);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Ue,desiredRatio:xe,minimapLineCount:et}}static _computeMinimapLayout(Z,ce){const Ue=Z.outerWidth,xe=Z.outerHeight,et=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const De=ce.stableMinimapLayoutInput,Se=De&&Z.outerHeight===De.outerHeight&&Z.lineHeight===De.lineHeight&&Z.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&Z.pixelRatio===De.pixelRatio&&Z.scrollBeyondLastLine===De.scrollBeyondLastLine&&Z.minimap.enabled===De.minimap.enabled&&Z.minimap.side===De.minimap.side&&Z.minimap.size===De.minimap.size&&Z.minimap.showSlider===De.minimap.showSlider&&Z.minimap.renderCharacters===De.minimap.renderCharacters&&Z.minimap.maxColumn===De.minimap.maxColumn&&Z.minimap.scale===De.minimap.scale&&Z.verticalScrollbarWidth===De.verticalScrollbarWidth&&Z.isViewportWrapping===De.isViewportWrapping,Pe=Z.lineHeight,se=Z.typicalHalfwidthCharacterWidth,le=Z.scrollBeyondLastLine,fe=Z.minimap.renderCharacters;let pe=et>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const B=Z.minimap.maxColumn,me=Z.minimap.size,we=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Oe=Z.viewLineCount,He=Z.remainingWidth,Ze=Z.isViewportWrapping,Ke=fe?2:3;let Qe=Math.floor(et*xe);const ut=Qe/et;let mt=!1,bt=!1,ot=Ke*pe,at=pe/et,_e=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:ct,desiredRatio:yt,minimapLineCount:kt}=V.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:le,height:xe,lineHeight:Pe,pixelRatio:et});if(Oe/kt>1)mt=!0,bt=!0,pe=1,ot=1,at=pe/et;else{let ft=!1,dt=pe+1;if(me==="fit"){const vt=Math.ceil((Oe+ct)*ot);Ze&&Se&&He<=ce.stableFitRemainingWidth?(ft=!0,dt=ce.stableFitMaxMinimapScale):ft=vt>Qe}if(me==="fill"||ft){mt=!0;const vt=pe;ot=Math.min(Pe*et,Math.max(1,Math.floor(1/yt))),Ze&&Se&&He<=ce.stableFitRemainingWidth&&(dt=ce.stableFitMaxMinimapScale),pe=Math.min(dt,Math.max(1,Math.floor(ot/Ke))),pe>vt&&(_e=Math.min(2,pe/vt)),at=pe/et/_e,Qe=Math.ceil(Math.max(Ge,Oe+ct)*ot),Ze?(ce.stableMinimapLayoutInput=Z,ce.stableFitRemainingWidth=He,ce.stableFitMaxMinimapScale=pe):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const ke=Math.floor(B*at),Y=Math.min(ke,Math.max(0,Math.floor((He-Ie-2)*at/(se+at)))+e.MINIMAP_GUTTER_WIDTH);let H=Math.floor(et*Y);const Fe=H/et;H=Math.floor(H*_e);const Te=fe?1:2,tt=we==="left"?0:Ue-Y-Ie;return{renderMinimap:Te,minimapLeft:tt,minimapWidth:Y,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:pe,minimapLineHeight:ot,minimapCanvasInnerWidth:H,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:ut}}static computeLayout(Z,ce){const Ue=ce.outerWidth|0,xe=ce.outerHeight|0,et=ce.lineHeight|0,De=ce.lineNumbersDigitCount|0,Se=ce.typicalHalfwidthCharacterWidth,Pe=ce.maxDigitWidth,se=ce.pixelRatio,le=ce.viewLineCount,fe=Z.get(121),pe=fe==="inherit"?Z.get(120):fe,B=pe==="inherit"?Z.get(116):pe,me=Z.get(119),we=Z.get(2),Ie=ce.isDominatedByLongLines,Oe=Z.get(47),He=Z.get(58).renderType!==0,Ze=Z.get(59),Ke=Z.get(93),Qe=Z.get(63),ut=Z.get(91),mt=ut.verticalScrollbarSize,bt=ut.verticalHasArrows,ot=ut.arrowSize,at=ut.horizontalScrollbarSize,_e=Z.get(56),ke=Z.get(35);let Y;if(typeof _e=="string"&&/^\d+(\.\d+)?ch$/.test(_e)){const It=parseFloat(_e.substr(0,_e.length-2));Y=u.clampedInt(It*Se,0,0,1e3)}else Y=u.clampedInt(_e,0,0,1e3);ke&&(Y+=16);let H=0;if(He){const It=Math.max(De,Ze);H=Math.round(It*Pe)}let Fe=0;Oe&&(Fe=et);let Te=0,tt=Te+Fe,Ge=tt+H,ct=Ge+Y;const yt=Ue-Fe-H-Y;let kt=!1,Dt=!1,ft=-1;we!==2&&(pe==="inherit"&&Ie?(kt=!0,Dt=!0):B==="on"||B==="bounded"?Dt=!0:B==="wordWrapColumn"&&(ft=me));const dt=V._computeMinimapLayout({outerWidth:Ue,outerHeight:xe,lineHeight:et,typicalHalfwidthCharacterWidth:Se,pixelRatio:se,scrollBeyondLastLine:Ke,minimap:Qe,verticalScrollbarWidth:mt,viewLineCount:le,remainingWidth:yt,isViewportWrapping:Dt},ce.memory||new y);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Te+=dt.minimapWidth,tt+=dt.minimapWidth,Ge+=dt.minimapWidth,ct+=dt.minimapWidth);const vt=yt-dt.minimapWidth,Et=Math.max(1,Math.floor((vt-mt-2)/Se)),Tt=bt?ot:0;return Dt&&(ft=Math.max(1,Et),B==="bounded"&&(ft=Math.min(ft,me))),{width:Ue,height:xe,glyphMarginLeft:Te,glyphMarginWidth:Fe,lineNumbersLeft:tt,lineNumbersWidth:H,decorationsLeft:Ge,decorationsWidth:Y,contentLeft:ct,contentWidth:vt,minimap:dt,viewportColumn:Et,isWordWrapMinified:kt,isViewportWrapping:Dt,wrappingColumn:ft,verticalScrollbarWidth:mt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:mt,height:xe-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends I{constructor(){const Z={enabled:!0};super(55,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:h.localize(42,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:l(Z.enabled,this.defaultValue.enabled)}}}class L extends I{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:h.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:h.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:h.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class Q extends g{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>g.clamp(Z,0,150),{markdownDescription:h.localize(46,null)})}compute(Z,ce,Ue){return Z.fontInfo.lineHeight}}class O extends I{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:h.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(48,null),h.localize(49,null),h.localize(50,null)],default:Z.size,description:h.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:h.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:h.localize(53,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:h.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:h.localize(56,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),size:w(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ce.side,this.defaultValue.side,["right","left"]),showSlider:w(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ce.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(ce.scale,1,1,3),maxColumn:u.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends I{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{top:u.clampedInt(ce.top,0,0,1e3),bottom:u.clampedInt(ce.bottom,0,0,1e3)}}}class $ extends I{constructor(){const Z={enabled:!0,cycle:!1};super(74,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:h.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:h.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),cycle:l(ce.cycle,this.defaultValue.cycle)}}}class ne extends n{constructor(){super(127)}compute(Z,ce,Ue){return Z.pixelRatio}}class he extends I{constructor(){const Z={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:h.localize(61,null)},comments:{type:"boolean",default:Z.comments,description:h.localize(62,null)},other:{type:"boolean",default:Z.other,description:h.localize(63,null)}}}],default:Z,description:h.localize(64,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const ce=Z,Ue={other:l(ce.other,this.defaultValue.other),comments:l(ce.comments,this.defaultValue.comments),strings:l(ce.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var ye;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends I{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:"on",description:h.localize(69,null)})}validate(Z){let ce=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(ce=4,Ue=Z):Z==="interval"?ce=3:Z==="relative"?ce=2:Z==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ue}}}function Me(z){const Z=z.get(86);return Z==="editable"?z.get(79):Z!=="on"}e.filterValidationDecorations=Me;class $e extends I{constructor(){const Z=[],ce={type:"number",description:h.localize(70,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:h.localize(71,null),format:"color-hex"}}}]},default:Z,description:h.localize(72,null)})}validate(Z){if(Array.isArray(Z)){let ce=[];for(let Ue of Z)if(typeof Ue=="number")ce.push({column:u.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const xe=Ue;ce.push({column:u.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ce.sort((Ue,xe)=>Ue.column-xe.column),ce}return this.defaultValue}}function Xe(z,Z){if(typeof z!="string")return Z;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends I{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(73,null),h.localize(74,null),h.localize(75,null)],default:"auto",description:h.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)],default:"auto",description:h.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:h.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:h.localize(83,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z,Ue=u.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=u.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Xe(ce.vertical,this.defaultValue.vertical),horizontal:Xe(ce.horizontal,this.defaultValue.horizontal),useShadows:l(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:u.clampedInt(ce.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:u.clampedInt(ce.verticalSliderSize,xe,0,1e3),scrollByPage:l(ce.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends I{constructor(){const Z={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:h.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(85,null),h.localize(86,null),h.localize(87,null)],default:Z.mode,description:h.localize(88,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),mode:w(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class U extends I{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(89,null),h.localize(90,null)],default:Z.insertMode,description:h.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:h.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:h.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:h.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:h.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:h.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:h.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:h.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(99,null),h.localize(100,null),h.localize(101,null)],default:Z.previewMode,description:h.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:h.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{insertMode:w(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ce.showIcons,this.defaultValue.showIcons),showStatusBar:l(ce.showStatusBar,this.defaultValue.showStatusBar),preview:l(ce.preview,this.defaultValue.preview),previewMode:w(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ce.showMethods,this.defaultValue.showMethods),showFunctions:l(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ce.showFields,this.defaultValue.showFields),showVariables:l(ce.showVariables,this.defaultValue.showVariables),showClasses:l(ce.showClasses,this.defaultValue.showClasses),showStructs:l(ce.showStructs,this.defaultValue.showStructs),showInterfaces:l(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ce.showModules,this.defaultValue.showModules),showProperties:l(ce.showProperties,this.defaultValue.showProperties),showEvents:l(ce.showEvents,this.defaultValue.showEvents),showOperators:l(ce.showOperators,this.defaultValue.showOperators),showUnits:l(ce.showUnits,this.defaultValue.showUnits),showValues:l(ce.showValues,this.defaultValue.showValues),showConstants:l(ce.showConstants,this.defaultValue.showConstants),showEnums:l(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ce.showKeywords,this.defaultValue.showKeywords),showWords:l(ce.showWords,this.defaultValue.showWords),showColors:l(ce.showColors,this.defaultValue.showColors),showFiles:l(ce.showFiles,this.defaultValue.showFiles),showReferences:l(ce.showReferences,this.defaultValue.showReferences),showFolders:l(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ce.showSnippets,this.defaultValue.showSnippets),showUsers:l(ce.showUsers,this.defaultValue.showUsers),showIssues:l(ce.showIssues,this.defaultValue.showIssues)}}}class K extends I{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(135,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends n{constructor(){super(128,[79])}compute(Z,ce,Ue){return ce.get(79)?!0:Z.tabFocusMode}}var re;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function q(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ie extends n{constructor(){super(130,[129])}compute(Z,ce,Ue){const xe=ce.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?We:ge,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(z){return e.editorOptionsRegistry[z.id]=z,z}var Je;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.foldingImportsByDefault=38]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=40]="fontFamily",z[z.fontInfo=41]="fontInfo",z[z.fontLigatures=42]="fontLigatures",z[z.fontSize=43]="fontSize",z[z.fontWeight=44]="fontWeight",z[z.formatOnPaste=45]="formatOnPaste",z[z.formatOnType=46]="formatOnType",z[z.glyphMargin=47]="glyphMargin",z[z.gotoLocation=48]="gotoLocation",z[z.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",z[z.hover=51]="hover",z[z.inDiffEditor=52]="inDiffEditor",z[z.inlineSuggest=53]="inlineSuggest",z[z.letterSpacing=54]="letterSpacing",z[z.lightbulb=55]="lightbulb",z[z.lineDecorationsWidth=56]="lineDecorationsWidth",z[z.lineHeight=57]="lineHeight",z[z.lineNumbers=58]="lineNumbers",z[z.lineNumbersMinChars=59]="lineNumbersMinChars",z[z.linkedEditing=60]="linkedEditing",z[z.links=61]="links",z[z.matchBrackets=62]="matchBrackets",z[z.minimap=63]="minimap",z[z.mouseStyle=64]="mouseStyle",z[z.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=66]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",z[z.multiCursorModifier=68]="multiCursorModifier",z[z.multiCursorPaste=69]="multiCursorPaste",z[z.occurrencesHighlight=70]="occurrencesHighlight",z[z.overviewRulerBorder=71]="overviewRulerBorder",z[z.overviewRulerLanes=72]="overviewRulerLanes",z[z.padding=73]="padding",z[z.parameterHints=74]="parameterHints",z[z.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",z[z.quickSuggestions=77]="quickSuggestions",z[z.quickSuggestionsDelay=78]="quickSuggestionsDelay",z[z.readOnly=79]="readOnly",z[z.renameOnType=80]="renameOnType",z[z.renderControlCharacters=81]="renderControlCharacters",z[z.renderIndentGuides=82]="renderIndentGuides",z[z.renderFinalNewline=83]="renderFinalNewline",z[z.renderLineHighlight=84]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=86]="renderValidationDecorations",z[z.renderWhitespace=87]="renderWhitespace",z[z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",z[z.roundedSelection=89]="roundedSelection",z[z.rulers=90]="rulers",z[z.scrollbar=91]="scrollbar",z[z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=93]="scrollBeyondLastLine",z[z.scrollPredominantAxis=94]="scrollPredominantAxis",z[z.selectionClipboard=95]="selectionClipboard",z[z.selectionHighlight=96]="selectionHighlight",z[z.selectOnLineNumbers=97]="selectOnLineNumbers",z[z.showFoldingControls=98]="showFoldingControls",z[z.showUnused=99]="showUnused",z[z.snippetSuggestions=100]="snippetSuggestions",z[z.smartSelect=101]="smartSelect",z[z.smoothScrolling=102]="smoothScrolling",z[z.stickyTabStops=103]="stickyTabStops",z[z.stopRenderingLineAfter=104]="stopRenderingLineAfter",z[z.suggest=105]="suggest",z[z.suggestFontSize=106]="suggestFontSize",z[z.suggestLineHeight=107]="suggestLineHeight",z[z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",z[z.suggestSelection=109]="suggestSelection",z[z.tabCompletion=110]="tabCompletion",z[z.tabIndex=111]="tabIndex",z[z.unusualLineTerminators=112]="unusualLineTerminators",z[z.useShadowDOM=113]="useShadowDOM",z[z.useTabStops=114]="useTabStops",z[z.wordSeparators=115]="wordSeparators",z[z.wordWrap=116]="wordWrap",z[z.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=119]="wordWrapColumn",z[z.wordWrapOverride1=120]="wordWrapOverride1",z[z.wordWrapOverride2=121]="wordWrapOverride2",z[z.wrappingIndent=122]="wrappingIndent",z[z.wrappingStrategy=123]="wrappingStrategy",z[z.showDeprecated=124]="showDeprecated",z[z.inlayHints=125]="inlayHints",z[z.editorClassName=126]="editorClassName",z[z.pixelRatio=127]="pixelRatio",z[z.tabFocusMode=128]="tabFocusMode",z[z.layoutInfo=129]="layoutInfo",z[z.wrappingInfo=130]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(136,null)})),acceptSuggestionOnEnter:ve(new T(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(137,null),""],markdownDescription:h.localize(138,null)})),accessibilitySupport:ve(new v),accessibilityPageSize:ve(new u(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(139,null)})),ariaLabel:ve(new b(4,"ariaLabel",h.localize(140,null))),autoClosingBrackets:ve(new T(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(141,null),h.localize(142,null),""],description:h.localize(143,null)})),autoClosingDelete:ve(new T(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(144,null),""],description:h.localize(145,null)})),autoClosingOvertype:ve(new T(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(146,null),""],description:h.localize(147,null)})),autoClosingQuotes:ve(new T(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(148,null),h.localize(149,null),""],description:h.localize(150,null)})),autoIndent:ve(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[h.localize(151,null),h.localize(152,null),h.localize(153,null),h.localize(154,null),h.localize(155,null)],description:h.localize(156,null)})),automaticLayout:ve(new f(10,"automaticLayout",!1)),autoSurround:ve(new T(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(157,null),h.localize(158,null),h.localize(159,null),""],description:h.localize(160,null)})),stickyTabStops:ve(new f(103,"stickyTabStops",!1,{description:h.localize(161,null)})),codeLens:ve(new f(12,"codeLens",!0,{description:h.localize(162,null)})),codeLensFontFamily:ve(new b(13,"codeLensFontFamily","",{description:h.localize(163,null)})),codeLensFontSize:ve(new u(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(164,null)})),colorDecorators:ve(new f(15,"colorDecorators",!0,{description:h.localize(165,null)})),columnSelection:ve(new f(16,"columnSelection",!1,{description:h.localize(166,null)})),comments:ve(new t),contextmenu:ve(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new f(19,"copyWithSyntaxHighlighting",!0,{description:h.localize(167,null)})),cursorBlinking:ve(new o(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:h.localize(168,null)})),cursorSmoothCaretAnimation:ve(new f(21,"cursorSmoothCaretAnimation",!1,{description:h.localize(169,null)})),cursorStyle:ve(new o(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:h.localize(170,null)})),cursorSurroundingLines:ve(new u(23,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(171,null)})),cursorSurroundingLinesStyle:ve(new T(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(172,null),h.localize(173,null)],description:h.localize(174,null)})),cursorWidth:ve(new u(25,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(175,null)})),disableLayerHinting:ve(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new f(28,"domReadOnly",!1)),dragAndDrop:ve(new f(29,"dragAndDrop",!0,{description:h.localize(176,null)})),emptySelectionClipboard:ve(new D),extraEditorClassName:ve(new b(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new g(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:h.localize(177,null)})),find:ve(new k),fixedOverflowWidgets:ve(new f(34,"fixedOverflowWidgets",!1)),folding:ve(new f(35,"folding",!0,{description:h.localize(178,null)})),foldingStrategy:ve(new T(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(179,null),h.localize(180,null)],description:h.localize(181,null)})),foldingHighlight:ve(new f(37,"foldingHighlight",!0,{description:h.localize(182,null)})),foldingImportsByDefault:ve(new f(38,"foldingImportsByDefault",!1,{description:h.localize(183,null)})),unfoldOnClickAfterEndOfLine:ve(new f(39,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(184,null)})),fontFamily:ve(new b(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(185,null)})),fontInfo:ve(new P),fontLigatures2:ve(new s),fontSize:ve(new F),fontWeight:ve(new x),formatOnPaste:ve(new f(45,"formatOnPaste",!1,{description:h.localize(186,null)})),formatOnType:ve(new f(46,"formatOnType",!1,{description:h.localize(187,null)})),glyphMargin:ve(new f(47,"glyphMargin",!0,{description:h.localize(188,null)})),gotoLocation:ve(new j),hideCursorInOverviewRuler:ve(new f(49,"hideCursorInOverviewRuler",!1,{description:h.localize(189,null)})),highlightActiveIndentGuide:ve(new f(50,"highlightActiveIndentGuide",!0,{description:h.localize(190,null)})),hover:ve(new ae),inDiffEditor:ve(new f(52,"inDiffEditor",!1)),letterSpacing:ve(new g(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>g.clamp(z,-5,20),{description:h.localize(191,null)})),lightbulb:ve(new W),lineDecorationsWidth:ve(new C(56,"lineDecorationsWidth",10)),lineHeight:ve(new Q),lineNumbers:ve(new Ne),lineNumbersMinChars:ve(new u(59,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new f(60,"linkedEditing",!1,{description:h.localize(192,null)})),links:ve(new f(61,"links",!0,{description:h.localize(193,null)})),matchBrackets:ve(new T(62,"matchBrackets","always",["always","near","never"],{description:h.localize(194,null)})),minimap:ve(new O),mouseStyle:ve(new T(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new g(65,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:h.localize(195,null)})),mouseWheelZoom:ve(new f(66,"mouseWheelZoom",!1,{markdownDescription:h.localize(196,null)})),multiCursorMergeOverlapping:ve(new f(67,"multiCursorMergeOverlapping",!0,{description:h.localize(197,null)})),multiCursorModifier:ve(new o(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[h.localize(198,null),h.localize(199,null)],markdownDescription:h.localize(200,null)})),multiCursorPaste:ve(new T(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(201,null),h.localize(202,null)],markdownDescription:h.localize(203,null)})),occurrencesHighlight:ve(new f(70,"occurrencesHighlight",!0,{description:h.localize(204,null)})),overviewRulerBorder:ve(new f(71,"overviewRulerBorder",!0,{description:h.localize(205,null)})),overviewRulerLanes:ve(new u(72,"overviewRulerLanes",3,0,3)),padding:ve(new de),parameterHints:ve(new $),peekWidgetDefaultFocus:ve(new T(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(206,null),h.localize(207,null)],description:h.localize(208,null)})),definitionLinkOpensInPeek:ve(new f(76,"definitionLinkOpensInPeek",!1,{description:h.localize(209,null)})),quickSuggestions:ve(new he),quickSuggestionsDelay:ve(new u(78,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(210,null)})),readOnly:ve(new f(79,"readOnly",!1)),renameOnType:ve(new f(80,"renameOnType",!1,{description:h.localize(211,null),markdownDeprecationMessage:h.localize(212,null)})),renderControlCharacters:ve(new f(81,"renderControlCharacters",!1,{description:h.localize(213,null)})),renderIndentGuides:ve(new f(82,"renderIndentGuides",!0,{description:h.localize(214,null)})),renderFinalNewline:ve(new f(83,"renderFinalNewline",!0,{description:h.localize(215,null)})),renderLineHighlight:ve(new T(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(216,null)],description:h.localize(217,null)})),renderLineHighlightOnlyWhenFocus:ve(new f(85,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(218,null)})),renderValidationDecorations:ve(new T(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new T(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(219,null),h.localize(220,null),h.localize(221,null),""],description:h.localize(222,null)})),revealHorizontalRightPadding:ve(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new f(89,"roundedSelection",!0,{description:h.localize(223,null)})),rulers:ve(new $e),scrollbar:ve(new qe),scrollBeyondLastColumn:ve(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(224,null)})),scrollBeyondLastLine:ve(new f(93,"scrollBeyondLastLine",!0,{description:h.localize(225,null)})),scrollPredominantAxis:ve(new f(94,"scrollPredominantAxis",!0,{description:h.localize(226,null)})),selectionClipboard:ve(new f(95,"selectionClipboard",!0,{description:h.localize(227,null),included:R.isLinux})),selectionHighlight:ve(new f(96,"selectionHighlight",!0,{description:h.localize(228,null)})),selectOnLineNumbers:ve(new f(97,"selectOnLineNumbers",!0)),showFoldingControls:ve(new T(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(229,null),h.localize(230,null)],description:h.localize(231,null)})),showUnused:ve(new f(99,"showUnused",!0,{description:h.localize(232,null)})),showDeprecated:ve(new f(124,"showDeprecated",!0,{description:h.localize(233,null)})),inlayHints:ve(new L),snippetSuggestions:ve(new T(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(234,null),h.localize(235,null),h.localize(236,null),h.localize(237,null)],description:h.localize(238,null)})),smartSelect:ve(new K),smoothScrolling:ve(new f(102,"smoothScrolling",!1,{description:h.localize(239,null)})),stopRenderingLineAfter:ve(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new U),inlineSuggest:ve(new je),suggestFontSize:ve(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(240,null)})),suggestLineHeight:ve(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(241,null)})),suggestOnTriggerCharacters:ve(new f(108,"suggestOnTriggerCharacters",!0,{description:h.localize(242,null)})),suggestSelection:ve(new T(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(243,null),h.localize(244,null),h.localize(245,null)],description:h.localize(246,null)})),tabCompletion:ve(new T(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(247,null),h.localize(248,null),h.localize(249,null)],description:h.localize(250,null)})),tabIndex:ve(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new T(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(251,null),h.localize(252,null),h.localize(253,null)],description:h.localize(254,null)})),useShadowDOM:ve(new f(113,"useShadowDOM",!0)),useTabStops:ve(new f(114,"useTabStops",!0,{description:h.localize(255,null)})),wordSeparators:ve(new b(115,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:h.localize(256,null)})),wordWrap:ve(new T(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(257,null),h.localize(258,null),h.localize(259,null),h.localize(260,null)],description:h.localize(261,null)})),wordWrapBreakAfterCharacters:ve(new b(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new b(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(262,null)})),wordWrapOverride1:ve(new T(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new T(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[h.localize(263,null),h.localize(264,null),h.localize(265,null),h.localize(266,null)],description:h.localize(267,null)})),wrappingStrategy:ve(new T(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(268,null),h.localize(269,null)],description:h.localize(270,null)})),editorClassName:ve(new d),pixelRatio:ve(new ne),tabFocusMode:ve(new X),layoutInfo:ve(new V),wrappingInfo:ve(new ie)}}),define(be[128],Ee([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[129],Ee([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[130],Ee([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(be[131],Ee([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(be[132],Ee([18,19]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(be[133],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[134],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[135],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(be[136],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[137],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[138],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[139],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[140],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(be[141],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(be[142],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[143],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[144],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[145],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[146],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var R;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var S;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[147],Ee([0,1,129]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function E(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=E;function A(l){if(!E(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=l.match(R);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function _(l){if(!l)return null;let f=l.majorBase,u=l.majorMustEqual,g=l.minorBase,b=l.minorMustEqual,w=l.patchBase,T=l.patchMustEqual;l.hasCaret&&(f===0||(b=!1),T=!1);let o=0;if(l.preRelease){const m=S.exec(l.preRelease);if(m){const[,v,t,r]=m;o=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:f,majorMustEqual:u,minorBase:g,minorMustEqual:b,patchBase:w,patchMustEqual:T,isMinimum:l.hasGreaterEquals,notBefore:o}}e.normalizeVersion=_;function y(l,f,u){let g;typeof l=="string"?g=_(A(l)):g=l;let b;f instanceof Date?b=f.getTime():typeof f=="string"&&(b=new Date(f).getTime());let w;if(typeof u=="string"?w=_(A(u)):w=u,!g||!w)return!1;let T=g.majorBase,o=g.minorBase,m=g.patchBase,v=w.majorBase,t=w.minorBase,r=w.patchBase,a=w.notBefore,i=w.majorMustEqual,c=w.minorMustEqual,p=w.patchMustEqual;return w.isMinimum?T>v?!0:T<v?!1:o>t?!0:o<t||b&&b<a?!1:m>=r:(T===1&&v===0&&(!i||!c||!p)&&(v=1,t=0,r=0,i=!0,c=!1,p=!1),T<v?!1:T>v?!i:o<t?!1:o>t?!c:m<r?!1:m>r?!p:!(b&&b<a))}e.isValidVersion=y;function I(l,f,u,g){return u.isBuiltin||typeof u.main=="undefined"?!0:C(l,f,u.engines.vscode,g)}e.isValidExtensionVersion=I;function n(l,f,u){return l==="*"||C(f,u,l)}e.isEngineValid=n;function C(l,f,u,g=[]){let b=_(A(u));if(!b)return g.push(h.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(h.localize(1,null,u)),!1}else if(!b.majorMustEqual)return g.push(h.localize(2,null,u)),!1;return y(l,f,b)?!0:(g.push(h.localize(3,null,l,u)),!1)}}),define(be[91],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(S,E=[],A=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=h}),define(be[60],Ee([0,1,91]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function S(A,_,y){_ instanceof h.SyncDescriptor||(_=new h.SyncDescriptor(_,[],y)),R.push([A,_])}e.registerSingleton=S;function E(){return R}e.getSingletonServiceDescriptors=E}),define(be[148],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=h;class R{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let A of this._nodes.values())A.outgoing.size===0&&E.push(A);return E}insertEdge(E,A){const _=this.lookupOrInsertNode(E),y=this.lookupOrInsertNode(A);_.outgoing.set(this._hashFn(A),y),y.incoming.set(this._hashFn(E),_)}removeNode(E){const A=this._hashFn(E);this._nodes.delete(A);for(let _ of this._nodes.values())_.outgoing.delete(A),_.incoming.delete(A)}lookupOrInsertNode(E){const A=this._hashFn(E);let _=this._nodes.get(A);return _||(_=new h(E),this._nodes.set(A,_)),_}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[A,_]of this._nodes)E.push(`${A}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,A]of this._nodes){const _=new Set([E]),y=this._findCycle(A,_);if(y)return y}}_findCycle(E,A){for(let[_,y]of E.outgoing){if(A.has(_))return[...A,_].join(" -> ");A.add(_);const I=this._findCycle(y,A);if(I)return I;A.delete(_)}}}e.Graph=R}),define(be[4],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function y(I){return I[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=y})(h=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function R(_,y,I,n){y[h.DI_TARGET]===y?y[h.DI_DEPENDENCIES].push({id:_,index:I,optional:n}):(y[h.DI_DEPENDENCIES]=[{id:_,index:I,optional:n}],y[h.DI_TARGET]=y)}function S(_){if(h.serviceIds.has(_))return h.serviceIds.get(_);const y=function(I,n,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,I,C,!1)};return y.toString=()=>_,h.serviceIds.set(_,y),y}e.createDecorator=S;function E(_){return _}e.refineServiceDecorator=E;function A(_){return function(y,I,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(_,y,n,!0)}}e.optional=A}),define(be[149],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function R(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[150],Ee([0,1,3,43,6,21,81,58,149]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(I):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(f,u){let g={selector:f,provider:u,_score:-1,_time:this._clock++};return this._entries.push(g),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(g){let b=this._entries.indexOf(g);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const u=[];for(let g of this._entries)g._score>0&&u.push(g.provider);return u}ordered(f){const u=[];return this._orderedForEach(f,g=>u.push(g.provider)),u}orderedGroups(f){const u=[];let g,b;return this._orderedForEach(f,w=>{g&&b===w._score?g.push(w.provider):(b=w._score,g=[w.provider],u.push(g))}),u}_orderedForEach(f,u){if(!!f){this._updateScores(f);for(const g of this._entries)g._score>0&&u(g)}}_updateScores(f){let u={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let g of this._entries)if(g._score=(0,_.score)(g.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),I(g.selector)&&g._score>0){for(let b of this._entries)b._score=0;g._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(f,u){return f._score<u._score?1:f._score>u._score?-1:f._time<u._time?1:f._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class C{constructor(f,u,g=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=u,this.max=g,this._cache=new E.LRUCache(50,.7)}_key(f){return f.id+(0,R.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const u=this._key(f),g=this._cache.get(u);return this._clamp(g?.value)}update(f,u){const g=this._key(f);let b=this._cache.get(g);return b||(b=new A.MovingAverage,this._cache.set(g,b)),b.update(u),this.get(f)}}e.LanguageFeatureRequestDelays=C}),define(be[61],Ee([0,1,2,31,150,123,35]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var _;(function(s){s[s.Null=0]="Null",s[s.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));class y{constructor(P,F){this.language=P,this.id=F}}e.LanguageIdentifier=y;var I;(function(s){s[s.NotSet=-1]="NotSet",s[s.None=0]="None",s[s.Italic=1]="Italic",s[s.Bold=2]="Bold",s[s.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var n;(function(s){s[s.None=0]="None",s[s.DefaultForeground=1]="DefaultForeground",s[s.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var C;(function(s){s[s.Other=0]="Other",s[s.Comment=1]="Comment",s[s.String=2]="String",s[s.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(s){s[s.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",s[s.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",s[s.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",s[s.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",s[s.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",s[s.ITALIC_MASK=2048]="ITALIC_MASK",s[s.BOLD_MASK=4096]="BOLD_MASK",s[s.UNDERLINE_MASK=8192]="UNDERLINE_MASK",s[s.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",s[s.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",s[s.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",s[s.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",s[s.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",s[s.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",s[s.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",s[s.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",s[s.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",s[s.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let F=this.getForeground(P),x="mtk"+F,j=this.getFontStyle(P);return j&1&&(x+=" mtki"),j&2&&(x+=" mtkb"),j&4&&(x+=" mtku"),x}static getInlineStyleFromMetadata(P,F){const x=this.getForeground(P),j=this.getFontStyle(P);let ae=`color: ${F[x]};`;return j&1&&(ae+="font-style: italic;"),j&2&&(ae+="font-weight: bold;"),j&4&&(ae+="text-decoration: underline;"),ae}}e.TokenMetadata=f;var u;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let s=Object.create(null);return s[0]="symbol-method",s[1]="symbol-function",s[2]="symbol-constructor",s[3]="symbol-field",s[4]="symbol-variable",s[5]="symbol-class",s[6]="symbol-struct",s[7]="symbol-interface",s[8]="symbol-module",s[9]="symbol-property",s[10]="symbol-event",s[11]="symbol-operator",s[12]="symbol-unit",s[13]="symbol-value",s[14]="symbol-constant",s[15]="symbol-enum",s[16]="symbol-enum-member",s[17]="symbol-keyword",s[27]="symbol-snippet",s[18]="symbol-text",s[19]="symbol-color",s[20]="symbol-file",s[21]="symbol-reference",s[22]="symbol-customcolor",s[23]="symbol-folder",s[24]="symbol-type-parameter",s[25]="account",s[26]="issues",function(P){const F=s[P];let x=F&&A.iconRegistry.get(F);return x||(console.info("No codicon found for CompletionItemKind "+P),x=A.Codicon.symbolProperty),x.classNames}}(),e.completionKindFromString=function(){let s=Object.create(null);return s.method=0,s.function=1,s.constructor=2,s.field=3,s.variable=4,s.class=5,s.struct=6,s.interface=7,s.module=8,s.property=9,s.event=10,s.operator=11,s.unit=12,s.value=13,s.constant=14,s.enum=15,s["enum-member"]=16,s.enumMember=16,s.keyword=17,s.snippet=27,s.text=18,s.color=19,s.file=20,s.reference=21,s.customcolor=22,s.folder=23,s["type-parameter"]=24,s.typeParameter=24,s.account=25,s.issue=26,function(P,F){let x=s[P];return typeof x=="undefined"&&!F&&(x=9),x}}();var g;(function(s){s[s.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(s){s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var T;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(T=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(s){return s&&h.URI.isUri(s.uri)&&R.Range.isIRange(s.range)&&(R.Range.isIRange(s.originSelectionRange)||R.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=t;var r;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var a;(function(s){s[s.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var i;(function(s){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function x(oe){return P.get(oe)}s.fromString=x;function j(oe){return F.get(oe)}s.toString=j;function ae(oe,V){const W=F.get(oe);let L=W&&A.iconRegistry.get("symbol-"+W);return L||(console.info("No codicon found for SymbolKind "+oe),L=A.Codicon.symbolProperty),`${V?"inline":"block"} ${L.classNames}`}s.toCssClassName=ae})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(P){this.value=P}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var p;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var D;(function(s){s[s.Other=0]="Other",s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var k;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(k=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,22,8,4]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=h.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",h.isMacintosh),A.set("isLinux",h.isLinux),A.set("isWindows",h.isWindows),A.set("isWeb",h.isWeb),A.set("isMacNative",h.isMacintosh&&!h.isWeb),A.set("isEdge",E.indexOf("Edg/")>=0),A.set("isFirefox",E.indexOf("Firefox")>=0),A.set("isChrome",E.indexOf("Chrome")>=0),A.set("isSafari",E.indexOf("Safari")>=0);const _=Object.prototype.hasOwnProperty;var y;(function(k){k[k.False=0]="False",k[k.True=1]="True",k[k.Defined=2]="Defined",k[k.Not=3]="Not",k[k.Equals=4]="Equals",k[k.NotEquals=5]="NotEquals",k[k.And=6]="And",k[k.Regex=7]="Regex",k[k.NotRegex=8]="NotRegex",k[k.Or=9]="Or",k[k.In=10]="In",k[k.NotIn=11]="NotIn",k[k.Greater=12]="Greater",k[k.GreaterEquals=13]="GreaterEquals",k[k.Smaller=14]="Smaller",k[k.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return l.INSTANCE}static has(s){return f.create(s)}static equals(s,P){return u.create(s,P)}static notEquals(s,P){return w.create(s,P)}static regex(s,P){return r.create(s,P)}static in(s,P){return g.create(s,P)}static not(s){return T.create(s)}static and(...s){return i.create(s)}static or(...s){return c.create(s)}static greater(s,P){return o.create(s,P)}static less(s,P){return v.create(s,P)}static deserialize(s,P=!1){if(!!s)return this._deserializeOrExpression(s,P)}static _deserializeOrExpression(s,P){let F=s.split("||");return c.create(F.map(x=>this._deserializeAndExpression(x,P)))}static _deserializeAndExpression(s,P){let F=s.split("&&");return i.create(F.map(x=>this._deserializeOne(x,P)))}static _deserializeOne(s,P){if(s=s.trim(),s.indexOf("!=")>=0){let F=s.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],P))}if(s.indexOf("==")>=0){let F=s.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],P))}if(s.indexOf("=~")>=0){let F=s.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],P))}if(s.indexOf(" in ")>=0){let F=s.split(" in ");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(s)){const F=s.split(">=");return m.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(s)){const F=s.split(">");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(s)){const F=s.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(s)){const F=s.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(s)?T.create(s.substr(1).trim()):f.create(s)}static _deserializeValue(s,P){if(s=s.trim(),s==="true")return!0;if(s==="false")return!1;let F=/^'([^']*)'$/.exec(s);return F?F[1].trim():s}static _deserializeRegexValue(s,P){if((0,R.isFalsyOrWhitespace)(s)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=s.indexOf("/"),x=s.lastIndexOf("/");if(F===x||F<0){if(P)throw new Error(`bad regexp-value '${s}', missing /-enclosure`);return console.warn(`bad regexp-value '${s}', missing /-enclosure`),null}let j=s.slice(F+1,x),ae=s[x+1]==="i"?"i":"";try{return new RegExp(j,ae)}catch(oe){if(P)throw new Error(`bad regexp-value '${s}', parse error: ${oe}`);return console.warn(`bad regexp-value '${s}', parse error: ${oe}`),null}}}e.ContextKeyExpr=I;function n(k,s){return k.cmp(s)}class C{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class l{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class f{constructor(s){this.key=s,this.type=2}static create(s){const P=A.get(s);return typeof P=="boolean"?P?l.INSTANCE:C.INSTANCE:new f(s)}cmp(s){return s.type!==this.type?this.type-s.type:d(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return T.create(this.key)}}e.ContextKeyDefinedExpr=f;class u{constructor(s,P){this.key=s,this.value=P,this.type=4}static create(s,P){if(typeof P=="boolean")return P?f.create(s):T.create(s);const F=A.get(s);return typeof F=="boolean"?P===(F?"true":"false")?l.INSTANCE:C.INSTANCE:new u(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class g{constructor(s,P){this.key=s,this.valueKey=P,this.type=10}static create(s,P){return new g(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}evaluate(s){const P=s.getValue(this.valueKey),F=s.getValue(this.key);return Array.isArray(P)?P.indexOf(F)>=0:typeof F=="string"&&typeof P=="object"&&P!==null?_.call(P,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=g;class b{constructor(s){this._actual=s,this.type=11}static create(s){return new b(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new b(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class w{constructor(s,P){this.key=s,this.value=P,this.type=5}static create(s,P){if(typeof P=="boolean")return P?T.create(s):f.create(s);const F=A.get(s);return typeof F=="boolean"?P===(F?"true":"false")?C.INSTANCE:l.INSTANCE:new w(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class T{constructor(s){this.key=s,this.type=3}static create(s){const P=A.get(s);return typeof P=="boolean"?P?C.INSTANCE:l.INSTANCE:new T(s)}cmp(s){return s.type!==this.type?this.type-s.type:d(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=T;class o{constructor(s,P){this.key=s,this.value=P,this.type=12}static create(s,P){return new o(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=o;class m{constructor(s,P){this.key=s,this.value=P,this.type=13}static create(s,P){return new m(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=m;class v{constructor(s,P){this.key=s,this.value=P,this.type=14}static create(s,P){return new v(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(s,P){this.key=s,this.value=P,this.type=15}static create(s,P){return new t(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(s,P){this.key=s,this.regexp=P,this.type=7}static create(s,P){return new r(s,P)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const P=this.regexp?this.regexp.source:"",F=s.regexp?s.regexp.source:"";return P<F?-1:P>F?1:0}equals(s){if(s.type===this.type){const P=this.regexp?this.regexp.source:"",F=s.regexp?s.regexp.source:"";return this.key===s.key&&P===F}return!1}evaluate(s){let P=s.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=r;class a{constructor(s){this._actual=s,this.type=8}static create(s){return new a(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new a(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class i{constructor(s){this.expr=s,this.type=6}static create(s){return i._normalizeArr(s)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const x=n(this.expr[P],s.expr[P]);if(x!==0)return x}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(s.expr[P]))return!1;return!0}return!1}evaluate(s){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(s))return!1;return!0}static _normalizeArr(s){const P=[];let F=!1;for(const x of s)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return C.INSTANCE;if(x.type===6){P.push(...x.expr);continue}P.push(x)}if(P.length===0&&F)return l.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(n);P.length>1;){const x=P[P.length-1];if(x.type!==9)break;P.pop();const j=P.pop(),ae=c.create(x.expr.map(oe=>i.create([oe,j])));ae&&(P.push(ae),P.sort(n))}return P.length===1?P[0]:new i(P)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(let P of this.expr)s.push(...P.keys());return s}map(s){return new i(this.expr.map(P=>P.map(s)))}negate(){let s=[];for(let P of this.expr)s.push(P.negate());return c.create(s)}}e.ContextKeyAndExpr=i;class c{constructor(s){this.expr=s,this.type=9}static create(s){const P=c._normalizeArr(s);if(P.length!==0)return P.length===1?P[0]:new c(P)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const x=n(this.expr[P],s.expr[P]);if(x!==0)return x}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(s.expr[P]))return!1;return!0}return!1}evaluate(s){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(s))return!0;return!1}static _normalizeArr(s){let P=[],F=!1;if(s){for(let x=0,j=s.length;x<j;x++){const ae=s[x];if(!!ae){if(ae.type===0){F=!0;continue}if(ae.type===1)return[l.INSTANCE];if(ae.type===9){P=P.concat(ae.expr);continue}P.push(ae)}}if(P.length===0&&F)return[C.INSTANCE];P.sort(n)}return P}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(let P of this.expr)s.push(...P.keys());return s}map(s){return new c(this.expr.map(P=>P.map(s)))}negate(){let s=[];for(let F of this.expr)s.push(F.negate());const P=F=>F.type===9?F.expr:[F];for(;s.length>1;){const F=s.shift(),x=s.shift(),j=[];for(const ae of P(F))for(const oe of P(x))j.push(I.and(ae,oe));s.unshift(I.or(...j))}return s[0]}}e.ContextKeyOrExpr=c;class p extends f{constructor(s,P,F){super(s);this._defaultValue=P,typeof F=="object"?p._info.push({...F,key:s}):F!==!0&&p._info.push({key:s,description:F,type:P!=null?typeof P:void 0})}static all(){return p._info.values()}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return I.not(this.key)}isEqualTo(s){return I.equals(this.key,s)}notEqualsTo(s){return I.notEquals(this.key,s)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(k,s){return k<s?-1:k>s?1:0}function D(k,s,P,F){return k<P?-1:k>P?1:s<F?-1:s>F?1:0}}),define(be[151],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,8,4]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=S;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class _{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,l){if(typeof C=="undefined"||C===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof C=="string"||typeof l=="string"){let f=typeof C=="string"?C:C.value,u=typeof l=="string"?l:l.value;return h.equalsIgnoreCase(f,u)}return C._lower===l._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=_;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function I(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[152],Ee([0,1,8,26]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(u,g){return u.uuid&&g.uuid?u.uuid===g.uuid:u.id===g.id?!0:(0,h.compareIgnoreCase)(u.id,g.id)===0}e.areSameExtensions=S;class E{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof E?S(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=E;function A(u,g){return`${u}.${g}`}e.getExtensionId=A;function _(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=_;function y(u,g){return _(A(u,g))}e.getGalleryExtensionId=y;function I(u,g){const b=[],w=T=>{for(const o of b)if(o.some(m=>S(g(m),g(T))))return o;return null};for(const T of u){const o=w(T);o?o.push(T):b.push([T])}return b}e.groupByExtension=I;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(u){const g=new Set;for(const b of u)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=l;function f(u,g){const b=[],w=g.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const T=w.shift();if(T&&b.every(o=>!S(o.identifier,{id:T}))){const o=u.filter(m=>S(m.identifier,{id:T}));o.length===1&&(b.push(o[0]),w.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=f}),define(be[62],Ee([0,1,21,14,8,10,2,130,4]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I(V){return V.create===!0}e.isFileOpenForWriteOptions=I;var n;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var C;(function(V){V[V.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var l;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=f;function u(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=u;function g(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=b;var w;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class T extends Error{constructor(W,L){super(W);this.code=L}}e.FileSystemProviderError=T;function o(V,W){const L=new T(V.toString(),W);return v(L,W),L}e.createFileSystemProviderError=o;function m(V){return V||o((0,_.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=m;function v(V,W){return V.name=W?`${W} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=v;function t(V){if(!V)return w.Unknown;if(V instanceof T)return V.code;const W=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!W)return w.Unknown;switch(W[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(V){if(V instanceof D)return V.fileOperationResult;switch(t(V)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var a;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class i{constructor(W,L,Q){this.resource=W,this.operation=L,this.target=Q}isOperation(W){return this.operation===W}}e.FileOperationEvent=i;var c;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class p{constructor(W,L){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const Q of W)switch(Q.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>L)),this.added.set(Q.resource,Q);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>L)),this.updated.set(Q.resource,Q);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>L)),this.deleted.set(Q.resource,Q);break}}contains(W,...L){return this.doContains(W,{includeChildren:!1},...L)}affects(W,...L){return this.doContains(W,{includeChildren:!0},...L)}doContains(W,L,...Q){if(!W)return!1;const O=Q.length>0;return!!((!O||Q.includes(1))&&(this.added?.get(W)||L.includeChildren&&this.added?.findSuperstr(W))||(!O||Q.includes(0))&&(this.updated?.get(W)||L.includeChildren&&this.updated?.findSuperstr(W))||(!O||Q.includes(2))&&(this.deleted?.findSubstr(W)||L.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function d(V,W,L){return!V||!W||V===W||W.length>V.length?!1:(W.charAt(W.length-1)!==R.sep&&(W+=R.sep),L?(0,S.startsWithIgnoreCase)(V,W):V.indexOf(W)===0)}e.isParent=d;class D extends Error{constructor(W,L,Q){super(W);this.fileOperationResult=L,this.options=Q}}e.FileOperationError=D;class k extends D{constructor(W,L,Q){super(W,2,Q);this.stat=L}}e.NotModifiedSinceFileOperationError=k;var s;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(s=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=F;async function x(V,W){if(!W.canHandleResource(A.URI.from({scheme:V.scheme})))return new Promise(L=>{const Q=W.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===V.scheme&&O.added&&(Q.dispose(),L())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(W){return(0,E.isNumber)(W)||(W=0),W<j.KB?(0,_.localize)(1,null,W.toFixed(0)):W<j.MB?(0,_.localize)(2,null,(W/j.KB).toFixed(2)):W<j.GB?(0,_.localize)(3,null,(W/j.MB).toFixed(2)):W<j.TB?(0,_.localize)(4,null,(W/j.GB).toFixed(2)):(0,_.localize)(5,null,(W/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var ae;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function oe(V){return{maxFileSize:V===0?300*j.MB:16*j.GB,maxHeapSize:V===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=oe}),define(be[63],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...S){this._entries=new Map;for(let[E,A]of S)this.set(E,A)}set(S,E){const A=this._entries.get(S);return this._entries.set(S,E),A}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=h}),define(be[153],Ee([0,1,15,12,91,148,4,63]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class I extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new _.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=g,this._parent=b,this._services.set(A.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...g){let b=l.traceInvocation(u),w=!1;try{return u({get:(o,m)=>{if(w)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(o,b);if(!v&&m!==A.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return v}},...g)}finally{w=!0,b.stop()}}createInstance(u,...g){let b,w;return u instanceof S.SyncDescriptor?(b=l.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(g),b)):(b=l.traceCreation(u),w=this._createInstance(u,g,b)),b.stop(),w}_createInstance(u,g=[],b){let w=A._util.getServiceDependencies(u).sort((m,v)=>m.index-v.index),T=[];for(const m of w){let v=this._getOrCreateServiceInstance(m.id,b);if(!v&&this._strict&&!m.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${m.id}.`);T.push(v)}let o=w.length>0?w[0].index:g.length;if(g.length!==o){console.warn(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${g.length} static arguments`);let m=o-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,o)}return new u(...[...g,...T])}_setServiceInstance(u,g){if(this._services.get(u)instanceof S.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,g.branch(u,!0)):(g.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,g,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,b){const w=new E.Graph(m=>m.id.toString());let T=0;const o=[{id:u,desc:g,_trace:b}];for(;o.length;){const m=o.pop();if(w.lookupOrInsertNode(m),T++>1e3)throw new I(w);for(let v of A._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:v.id,desc:t,_trace:m._trace.branch(v.id,!0)};w.insertEdge(m,r),o.push(r)}}}for(;;){const m=w.roots();if(m.length===0){if(!w.isEmpty())throw new I(w);break}for(const{data:v}of m){if(this._getServiceInstanceOrDescriptor(v.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,b=[],w,T){if(this._services.get(u)instanceof S.SyncDescriptor)return this._createServiceInstance(g,b,w,T);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,b,w,T);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g=[],b,w){if(b){const T=new h.IdleValue(()=>this._createInstance(u,g,w));return new Proxy(Object.create(null),{get(o,m){if(m in o)return o[m];let v=T.value,t=v[m];return typeof t!="function"||(t=t.bind(v),o[m]=t),t},set(o,m,v){return T.value[m]=v,!0}})}else return this._createInstance(u,g,w)}}e.InstantiationService=n;var C;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(C||(C={}));class l{constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new l(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(u){return y?new l(0,u.name):l._None}branch(u,g){let b=new l(2,u.toString());return this._dep.push([u,g,b]),b}stop(){let u=Date.now()-this._start;l._totals+=u;let g=!1;function b(T,o){let m=[],v=new Array(T+1).join("	");for(const[t,r,a]of o._dep)if(r&&a){g=!0,m.push(`${v}CREATES -> ${t}`);let i=b(T+1,a);i&&m.push(i)}else m.push(`${v}uses -> ${t}`);return m.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(u>2||g)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(be[16],Ee([0,1,59,3,6,22,4]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function _(){return new Date().toISOString()}var y;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class I extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class n extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(y.Error,this.format(a))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let a=0;a<t.length;a++){let i=t[a];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}r+=(a>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class C extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!E.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...r):console.log(`[main ${_()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...r):console.log(`[main ${_()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...r):console.log(`[main ${_()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,t,...r):console.warn(`[main ${_()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,t,...r):console.error(`[main ${_()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,t,...r):console.error(`[main ${_()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class l extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class f extends I{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,h.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class u extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const a of this.logServices)a.trace(t,...r)}debug(t,...r){for(const a of this.logServices)a.debug(t,...r)}info(t,...r){for(const a of this.logServices)a.info(t,...r)}warn(t,...r){for(const a of this.logServices)a.warn(t,...r)}error(t,...r){for(const a of this.logServices)a.error(t,...r)}critical(t,...r){for(const a of this.logServices)a.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class g extends S.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class b extends S.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(a))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),a),r?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function T(v){if(v.verbose)return y.Trace;if(typeof v.logLevel=="string"){const t=o(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=T;function o(v){switch(v){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=o;function m(v){switch(v){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=m}),define(be[92],Ee([0,1,36,131,4]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var A;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function I(u,g){return g-u}y.compare=I;const n=Object.create(null);n[y.Error]=(0,R.localize)(0,null),n[y.Warning]=(0,R.localize)(1,null),n[y.Info]=(0,R.localize)(2,null);function C(u){return n[u]||""}y.toString=C;function l(u){switch(u){case h.default.Error:return y.Error;case h.default.Warning:return y.Warning;case h.default.Info:return y.Info;case h.default.Ignore:return y.Hint}}y.fromSeverity=l;function f(u){switch(u){case y.Error:return h.default.Error;case y.Warning:return h.default.Warning;case y.Info:return h.default.Info;case y.Hint:return h.default.Ignore}}y.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var _;(function(y){const I="";function n(l){return C(l,!0)}y.makeKey=n;function C(l,f){let u=[I];return l.source?u.push(l.source.replace("\xA6","\\\xA6")):u.push(I),l.code?typeof l.code=="string"?u.push(l.code.replace("\xA6","\\\xA6")):u.push(l.code.value.replace("\xA6","\\\xA6")):u.push(I),l.severity!==void 0&&l.severity!==null?u.push(A.toString(l.severity)):u.push(I),l.message&&f?u.push(l.message.replace("\xA6","\\\xA6")):u.push(I),l.startLineNumber!==void 0&&l.startLineNumber!==null?u.push(l.startLineNumber.toString()):u.push(I),l.startColumn!==void 0&&l.startColumn!==null?u.push(l.startColumn.toString()):u.push(I),l.endLineNumber!==void 0&&l.endLineNumber!==null?u.push(l.endLineNumber.toString()):u.push(I),l.endColumn!==void 0&&l.endColumn!==null?u.push(l.endColumn.toString()):u.push(I),u.push(I),u.join("\xA6")}y.makeKeyOptionalMessage=C})(_=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(be[154],Ee([0,1,3,36,4]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,S.createDecorator)("notificationService");var E;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class _{constructor(){this.progress=new y,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=_;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(be[155],Ee([0,1,6,8,2,4]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,E.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function A(_,y){return S.URI.isUri(_)?(0,R.equalsIgnoreCase)(_.scheme,y):(0,R.startsWithIgnoreCase)(_,y+":")}e.matchesScheme=A});var ze=this&&this.__decorate||function(ee,e,h,R){var S=arguments.length,E=S<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,h):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(ee,e,h,R);else for(var _=ee.length-1;_>=0;_--)(A=ee[_])&&(E=(S<3?A(E):S>3?A(e,h,E):A(e,h))||E);return S>3&&E&&Object.defineProperty(e,h,E),E},Ve=this&&this.__param||function(ee,e){return function(h,R){e(h,R,ee)}};define(be[156],Ee([0,1,15,20,6,4]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var A;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class _{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=_,_.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(C,l){super();this.deferred=new h.DeferredPromise,l.withProgress(C,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=ze([Ve(1,e.IProgressService)],y),e.UnmanagedProgress=y;class I extends S.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(C){this.stop();const l=++this.currentOperationId,f=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:f.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,41,10]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(A,_){h.ok(R.isString(A)),h.ok(R.isObject(_)),h.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,_)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new S}),define(be[93],Ee([0,1,3,28]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class E{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,I){this.schemasById[S(y)]=I,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new E;R.Registry.add(e.Extensions.JSONContribution,A)}),define(be[64],Ee([0,1,3,10,128,93,28]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=A.Registry.as(E.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new h.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new h.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(T,o=!0){this.registerConfigurations([T],o)}registerConfigurations(T,o=!0){const m=[];T.forEach(v=>{m.push(...this.validateAndRegisterProperties(v,o,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(T){const o=[],m=v=>{if(v.properties)for(const t in v.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>m(t))};for(const v of T){m(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(T){const o=[],m=[];for(const v of T)for(const t in v)if(o.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:S.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};m.push(l(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(T){const o=[];for(const m of T)for(const v in m)if(o.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...T){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(T){for(const o of T)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(T,o=!0,m,v=3){v=R.isUndefinedOrNull(T.scope)?v:T.scope;let t=[],r=T.properties;if(r)for(let i in r){if(o&&g(i)){delete r[i];continue}const c=r[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=R.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=R.isUndefinedOrNull(c.restricted)?!!m?.restrictedConfigurations?.includes(i):c.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let a=T.allOf;if(a)for(let i of a)t.push(...this.validateAndRegisterProperties(i,o,m,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(T){const o=m=>{let v=m.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=m.allOf;t&&t.forEach(o)};o(T)}updateSchema(T,o){switch(e.allSettings.properties[T]=o,o.scope){case 1:e.applicationSettings.properties[T]=o;break;case 2:e.machineSettings.properties[T]=o;break;case 6:e.machineOverridableSettings.properties[T]=o;break;case 3:e.windowSettings.properties[T]=o;break;case 4:e.resourceSettings.properties[T]=o;break;case 5:e.resourceSettings.properties[T]=o,this.resourceLanguageSettingsSchema.properties[T]=o;break}}removeFromSchema(T,o){switch(delete e.allSettings.properties[T],o.scope){case 1:delete e.applicationSettings.properties[T];break;case 2:delete e.machineSettings.properties[T];break;case 6:delete e.machineOverridableSettings.properties[T];break;case 3:delete e.windowSettings.properties[T];break;case 4:case 5:delete e.resourceSettings.properties[T];break}}updateOverridePropertyPatternKey(){for(const T of this.overrideIdentifiers.values()){const o=`[${T}]`,m={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,m),e.allSettings.properties[o]=m,e.applicationSettings.properties[o]=m,e.machineSettings.properties[o]=m,e.machineOverridableSettings.properties[o]=m,e.windowSettings.properties[o]=m,e.resourceSettings.properties[o]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(T,o){let m=this.defaultValues[T];R.isUndefined(m)&&(m=o.default),R.isUndefined(m)&&(m=f(o.type)),o.default=m}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function f(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const u=new n;A.Registry.add(e.Extensions.Configuration,u);function g(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?S.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?S.localize(6,null,w):null:S.localize(4,null)}e.validateProperty=g;function b(){const w=[],T=u.getConfigurationProperties();for(const o of Object.keys(T))w.push([o,T[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(be[94],Ee([0,1,23,10,2,64,4,28]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=y;var I;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function C(r,a){const i=a?r?a.keys.filter(P=>r.keys.indexOf(P)===-1):[...a.keys]:[],c=r?a?r.keys.filter(P=>a.keys.indexOf(P)===-1):[...r.keys]:[],p=[];if(a&&r){for(const P of r.keys)if(a.keys.indexOf(P)!==-1){const F=w(r.contents,P),x=w(a.contents,P);h.equals(F,x)||p.push(P)}}const d=[],D=P=>{const F={};for(const x of P)for(const j of x.identifiers)F[v(j)]=x;return F},k=a?D(a.overrides):{},s=r?D(r.overrides):{};if(Object.keys(k).length)for(const P of i){const F=k[P];F&&d.push([(0,E.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(s).length)for(const P of c){const F=s[P];F&&d.push([(0,E.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(k).length&&Object.keys(s).length)for(const P of p){const F=s[P],x=k[P];if(F&&x){const j=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});d.push([(0,E.overrideIdentifierFromKey)(P),[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:c,updated:p,overrides:d}}e.compare=C;function l(r,a){const i=[];for(const c of Object.keys(r))if(E.OVERRIDE_PROPERTY_PATTERN.test(c)){const p={};for(const d in r[c])p[d]=r[c][d];i.push({identifiers:[(0,E.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(p),contents:f(p,a)})}return i}e.toOverrides=l;function f(r,a){const i=Object.create(null);for(let c in r)u(i,c,r[c],a);return i}e.toValuesTree=f;function u(r,a,i,c){const p=a.split("."),d=p.pop();let D=r;for(let k=0;k<p.length;k++){let s=p[k],P=D[s];switch(typeof P){case"undefined":P=D[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${a} as ${p.slice(0,k+1).join(".")} is ${JSON.stringify(P)}`);return}D=P}if(typeof D=="object"&&D!==null)try{D[d]=i}catch(k){c(`Ignoring ${a} as ${p.join(".")} is ${JSON.stringify(D)}`)}else c(`Ignoring ${a} as ${p.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=u;function g(r,a){const i=a.split(".");b(r,i)}e.removeFromValueTree=g;function b(r,a){const i=a.shift();if(a.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const c=r[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,a),Object.keys(c).length===0&&delete r[i])}}function w(r,a,i){function c(D,k){let s=D;for(const P of k){if(typeof s!="object"||s===null)return;s=s[P]}return s}const p=a.split("."),d=c(r,p);return typeof d=="undefined"?i:d}e.getConfigurationValue=w;function T(r,a,i){Object.keys(a).forEach(c=>{c!=="__proto__"&&(c in r?R.isObject(r[c])&&R.isObject(a[c])?T(r[c],a[c],i):i&&(r[c]=a[c]):r[c]=a[c])})}e.merge=T;function o(){const r=_.Registry.as(E.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=o;function m(){const r=Object.create(null),a=_.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(let i in a){let c=a[i].default;u(r,i,c,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=m;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,a,i){const c=r.inspect(a),p=r.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:c.defaultValue}e.getMigratedSettingValue=t}),define(be[157],Ee([0,1,17,3,111,6,21,23,10,2,94,64,28]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],a=[]){this._contents=t,this._keys=r,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const a=this.getContentsForOverrideIdentifer(r);return a?t?(0,n.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let a={};for(const i of h.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[i],p=r[i];p&&(typeof c=="object"&&typeof p=="object"?(c=_.deepClone(c),this.mergeContents(c,p)):c=p),a[i]=c}return new f(a,this.keys,this.overrides)}merge(...t){const r=_.deepClone(this.contents),a=_.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const p of c.overrides){const[d]=a.filter(D=>h.equals(D.identifiers,p.identifiers));d?this.mergeContents(d.contents,p.contents):a.push(_.deepClone(p))}for(const p of c.keys)i.indexOf(p)===-1&&i.push(p)}return new f(r,i,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const a of Object.keys(r)){if(a in t&&y.isObject(t[a])&&y.isObject(r[a])){this.mergeContents(t[a],r[a]);continue}t[a]=_.deepClone(r[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let a=0;a<r;a++)t.indexOf(this.keys[a])===0&&(r=a);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class u extends f{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),a=[];for(const i of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(i)&&a.push({identifiers:[(0,C.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,a)}}e.DefaultConfigurationModel=u;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const a=this.doParseContent(t);this.parseRaw(a,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:a,keys:i,overrides:c,restricted:p}=this.doParseRaw(t,r);this._configurationModel=new f(a,i,c),this._restrictedConfigurations=p||[]}doParseContent(t){let r={},a=null,i=[],c=[],p=[];function d(k){Array.isArray(i)?i.push(k):a!==null&&(i[a]=k)}let D={onObjectBegin:()=>{let k={};d(k),c.push(i),i=k,a=null},onObjectProperty:k=>{a=k},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let k=[];d(k),c.push(i),i=k,a=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:d,onError:(k,s,P)=>{p.push({error:k,offset:s,length:P})}};if(t)try{S.visit(t,D),r=i[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return r}doParseRaw(t,r){const a=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,a,!0,r);t=i.raw;const c=(0,n.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),p=Object.keys(t),d=(0,n.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:p,overrides:d,restricted:i.restricted}}filter(t,r,a,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},p=[];for(let d in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(d)&&a){const D=this.filter(t[d],r,!1,i);c[d]=D.raw,p.push(...D.restricted)}else{const D=r[d],k=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&p.push(d),(k===void 0||i.scopes===void 0||i.scopes.includes(k))&&(i.skipRestricted&&D?.restricted||(c[d]=t[d]))}return{raw:c,restricted:p}}}e.ConfigurationModelParser=g;class b extends E.Disposable{constructor(t,r,a,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(t,r,a=new f,i=new f,c=new A.ResourceMap,p=new f,d=new A.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=p,this._memoryConfigurationByResource=d,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,a){return this.getConsolidateConfigurationModel(r,a).getValue(t)}updateValue(t,r,a={}){let i;a.resource?(i=this._memoryConfigurationByResource.get(a.resource),i||(i=new f,this._memoryConfigurationByResource.set(a.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,a){const i=this.getConsolidateConfigurationModel(r,a),c=this.getFolderConfigurationModelForResource(r.resource,a),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),k=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),s=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=a?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,x=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(t):p.getValue(t),j=i.getValue(t),ae=h.distinct(h.flatten(i.overrides.map(oe=>oe.identifiers))).filter(oe=>i.getOverrideValue(t,oe)!==void 0);return{defaultValue:d,userValue:D,userLocalValue:k,userRemoteValue:s,workspaceValue:P,workspaceFolderValue:F,memoryValue:x,value:j,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:s!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:p.getValue(t),override:r.overrideIdentifier?p.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const a=r.filter(i=>C.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,C.overrideIdentifierFromKey)(i),p=this._defaultConfiguration.getKeysForOverrideIdentifier(c),d=t.getKeysForOverrideIdentifier(c),D=[...d.filter(k=>p.indexOf(k)===-1),...p.filter(k=>d.indexOf(k)===-1),...p.filter(k=>!_.equals(this._defaultConfiguration.override(c).getValue(k),t.override(c).getValue(k)))];return[c,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:a,removed:i,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),p=[...r,...a,...i];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:a,removed:i,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let p=[...r,...a,...i];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:a,removed:i,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let p=[...r,...a,...i];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const a=this.folderConfigurations.get(t),{added:i,updated:c,removed:p,overrides:d}=(0,n.compare)(a,r);let D=[...i,...c,...p];return(D.length||!a)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:i,removed:c,overrides:p}=(0,n.compare)(r,void 0);return{keys:[...a,...i,...c],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let a=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},r){let a=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(a=this.getFolderConsolidatedConfiguration(i.uri)||a);const c=this._memoryConfigurationByResource.get(t);c&&(a=a.merge(c))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const a=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=a.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=a}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const a=r.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:a,overrides:i,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:a,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((p,d)=>(p.set(I.URI.revive(d[0]),this.parseConfigurationModel(d[1])),p),new A.ResourceMap);return new w(r,a,new f,i,c,new f,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function T(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,p])=>{const d=(0,A.getOrSet)(r,c,new Set);p.forEach(D=>d.add(D))});const a=[];return r.forEach((i,c)=>a.push([c,[...i.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=T;class o{constructor(t,r,a,i){this.change=t,this.previous=r,this.currentConfiguraiton=a,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(d=>c.add(d)),t.overrides.forEach(([,d])=>d.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const p=new f;this.affectedKeys.forEach(d=>p.setValue(d,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!_.equals(a,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let a=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof a=="object"&&(i=Object.keys(a)[0]);){if(t=t[i],!t)return!1;a=a[i]}return!0}}e.ConfigurationChangeEvent=o;class m extends o{constructor(t,r,a,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=a,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=m}),define(be[95],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var R;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(A,_=R.Unknown,y){super(A);this._message=A,this._code=_,this._detail=y,this.isHandled=_===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(A){return A instanceof S&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof S&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof S&&A.isHandled}}e.RemoteAuthorityResolverError=S}),define(be[96],Ee([0,1,11]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(I){return I.scheme===h.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=R;function S(I){if(!I)return;const n=I.indexOf("+");return n<0?I:I.substr(0,n)}e.getRemoteName=S;function E(I){return I.scheme!==h.Schemas.file&&I.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=E;function A(I){if(I.folders.length)return I.folders.every(n=>E(n.uri))?I.folders[0].uri:void 0;if(I.configuration&&E(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=A;function _(I){return A(I)?.scheme}e.getVirtualWorkspaceScheme=_;function y(I){return A(I)!==void 0}e.isVirtualWorkspace=y}),define(be[158],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,E,A=5){let _;return _=E(y=>{const I=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(I);return}const C=setTimeout(()=>this.flushBuffer(S),A);n={data:[I],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(S),_.dispose()}},this._terminalBufferMap.set(S,n)}),_}stopBuffering(S){const E=this._terminalBufferMap.get(S);E&&E.dispose()}flushBuffer(S){const E=this._terminalBufferMap.get(S);E&&(this._terminalBufferMap.delete(S),this._callback(S,E.data.join("")))}}e.TerminalDataBufferer=h}),define(be[159],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(be[65],Ee([0,1,35,3,6,4,28,159]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(b){function w(T){return T&&typeof T=="object"&&typeof T.id=="string"}b.isThemeColor=w})(y=e.ThemeColor||(e.ThemeColor={}));function I(b){return{id:b}}e.themeColorFromId=I;var n;(function(b){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}b.isThemeIcon=w;const T=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function o(r){const a=T.exec(r);if(!a)return;let[,i]=a;return{id:i}}b.fromString=o;function m(r,a){let i=r.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),a&&(i=`${i}~${a}`),{id:i}}b.modify=m;function v(r,a){return r.id===a.id&&r.color?.id===a.color?.id}b.isEqual=v;function t(r,a){return{id:r.id,color:a?I(a):void 0}}b.asThemeIcon=t,b.asClassNameArray=h.CSSIcon.asClassNameArray,b.asClassName=h.CSSIcon.asClassName,b.asCSSSelector=h.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function C(b){switch(b){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,S.toDisposable)(()=>{const T=this.themingParticipants.indexOf(w);this.themingParticipants.splice(T,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new l;A.Registry.add(e.Extensions.ThemingContribution,f);function u(b){return f.onColorThemeChange(b)}e.registerThemingParticipant=u;class g extends S.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(T=>this.onThemeChange(T)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,T){let o=this.theme.getColor(w);return o&&T&&(o=T(o,this.theme)),o?o.toString():null}}e.Themable=g}),define(be[160],Ee([0,1,15,35,3,132,93,28,65]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${R.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,T,o,m){const v=this.iconsById[w];if(v){if(o&&!v.description){v.description=o,this.iconSchema.properties[w].markdownDescription=`${o} $(${w})`;const a=this.iconReferenceSchema.enum.indexOf(w);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return v}let t={id:w,description:o,defaults:T,deprecationMessage:m};this.iconsById[w]=t;let r={$ref:"#/definitions/icons"};return m&&(r.deprecationMessage=m),o&&(r.markdownDescription=`${o}: $(${w})`),this.iconSchema.properties[w]=r,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const T=this.iconReferenceSchema.enum.indexOf(w);T!==-1&&(this.iconReferenceSchema.enum.splice(T,1),this.iconReferenceSchema.enumDescriptions.splice(T,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,T){const o=this.iconFontsById[w];if(o)return o;let m={id:w,definition:T};return this.iconFontsById[w]=m,this._onDidChange.fire(),m}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),T=v=>{for(;y.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of m.filter(t=>!!t.description).sort(w))o.push(`|<i class="${T(v)}"></i>|${v.id}|${y.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const v of m.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(w))o.push(`|<i class="${T(v)}"></i>|${v.id}|`);return o.join(`
`)}}const n=new I;_.Registry.add(e.Extensions.IconContribution,n);function C(b,w,T,o){return n.registerIcon(b,w,T,o)}e.registerIcon=C;function l(){return n}e.getIconRegistry=l;function f(){for(const b of R.iconRegistry.all)n.registerIcon(b.id,b.definition,b.description);R.iconRegistry.onDidRegister(b=>n.registerIcon(b.id,b.definition,b.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let u=_.Registry.as(A.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const g=new h.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=C("widget-close",R.Codicon.close,(0,E.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",R.Codicon.arrowUp,(0,E.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",R.Codicon.arrowDown,(0,E.localize)(4,null)),e.syncing=y.ThemeIcon.modify(R.Codicon.sync,"spin")}),define(be[46],Ee([0,1,21,25,2,4]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function _(l){const f=l;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=_;function y(l){const f=l;return!!(f&&typeof f=="object"&&S.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class I{constructor(f,u,g,b){this._id=f,this._configuration=g,this._ignorePathCasing=b,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class n{constructor(f,u){this.raw=u,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,R.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function C(l){return new n({uri:l,index:0,name:(0,R.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=C}),define(be[66],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const E=this._idPool++;return this._data.set(E,S),this.logDebugInfo(),E}get(S,E){return this._data.has(S)?this._data.get(S)[E]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(be[67],Ee([0,1,2,3,4]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(_){this._tabs=_.map(y=>({name:y.name,group:y.group,resource:h.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(be[47],Ee([0,1,11,4]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,_){_===null?this._providerInfo.delete(A):this._providerInfo.set(A,_)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(be[161],Ee([0,1,15]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,_,y){this._deferredPromises=new Map,this._id=A,this._shared=_,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of I.values())n.complete()}catch(n){for(const C of I.values())C.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,_){let y=this._value[A];return typeof y=="undefined"&&(y=_),y}update(A,_){this._value[A]=_;let y=this._deferredPromises.get(A);if(y!==void 0)return y.p;const I=new h.DeferredPromise;return this._deferredPromises.set(A,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class S extends R{constructor(A,_){super(A.identifier.value,!0,_);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=S}),define(be[162],Ee([0,1,3,2,16]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let E=class{constructor(_,y){this._logService=_,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(_,y,I){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(_)).acceptModelChanged(y,I)}$acceptDirtyStateChanged(_,y){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(_)).acceptDirty(y)}$acceptModelSaved(_){const y=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(_));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(_,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",_.path,y);const I=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(_));I.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};E=ze([Ve(0,S.ILogService)],E),e.ExtHostNotebookDocuments=E}),define(be[13],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class R{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[163],Ee([0,1,26,3]),function(ee,e,h,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(_,y){S.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(_.identifier),it(this,S,y,"f"),Be(this,S,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(_){return Be(this,S,"f").get(this._id,_)}store(_,y){return Be(this,S,"f").store(this._id,_,y)}delete(_){return Be(this,S,"f").delete(this._id,_)}}e.ExtensionSecrets=E,S=new WeakMap}),define(be[97],Ee([0,1,4,3]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(be[68],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(T){T[T.Upsert=0]="Upsert",T[T.RemoveChild=1]="RemoveChild",T[T.Invalidated=2]="Invalidated",T[T.SetProp=3]="SetProp",T[T.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,S=(T,o)=>{const m={controllerId:o};return R.set(T,m),m};e.createPrivateApiFor=S;const E=T=>R.get(T);e.getPrivateApiFor=E;const A=(T,o,m,v)=>{let t=m;return{enumerable:!0,configurable:!1,get(){return t},set(r){v(t,r)||(t=r,T.listener?.({op:3,key:o,value:r}))}}},_=(T,o)=>T===o,y={range:(T,o)=>T===o?!0:!T||!o?!1:T.isEqual(o),label:_,description:_,busy:_,error:_,canResolveChildren:_},I=Object.keys(y),n=(T,o)=>({range:A(T,"range",void 0,y.range),label:A(T,"label",o,y.label),description:A(T,"description",void 0,y.description),canResolveChildren:A(T,"canResolveChildren",!1,y.canResolveChildren),busy:A(T,"busy",!1,y.busy),error:A(T,"error",void 0,y.error)}),C=(T,o)=>{const m=new Map;for(const v of I)y[v](T[v],o[v])||m.set(v,o[v]);return m};e.diffTestItems=C;class l extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=l;class f extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class u extends Error{constructor(o,m,v){super(`TestItem with ID "${o}" is from controller "${m}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=u;const g=T=>{const o=(0,e.getPrivateApiFor)(T);let m=new Map;return{get size(){return m.size},forEach(v,t){for(const r of m.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(m.keys()),a={op:4,ops:[]};for(const i of v){if(!(i instanceof b))throw new f(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==o.controllerId)throw new u(i.id,c,o.controllerId);if(t.has(i.id))throw new l(i.id);t.set(i.id,i),r.delete(i.id),a.ops.push({op:0,item:i})}for(const i of r.keys())a.ops.push({op:1,id:i});o.listener?.(a),m=t},add(v){if(!(v instanceof b))throw new f(v.id);m.set(v.id,v),o.listener?.({op:0,item:v})},delete(v){m.delete(v)&&o.listener?.({op:1,id:v})},get(v){return m.get(v)},toJSON(){return Array.from(m.values())},[Symbol.iterator](){return m.values()}}};class b{constructor(o,m,v,t){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof w?void 0:r.parent}},children:{value:g(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=b;class w extends b{constructor(o,m){super(o,o,m,void 0)}}e.TestItemRootImpl=w}),define(be[69],Ee([0,1,4,3,13]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(_){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}_.fromApiTunnel=y;function I(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}_.fromServiceTunnel=I})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let A=class{constructor(y){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,I){return{dispose:()=>{}}}async $providePortAttributes(y,I,n,C,l){return[]}async $forwardPort(y,I){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([Ve(0,S.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[7],Ee([0,1,17,12,83,21,85,10,2,37,62,95]),function(ee,e,h,R,S,E,A,_,y,I,n,C){"use strict";var l,f,u,g,b,w,T,o,m,v,t,r,a,i,c,p,d,D,k,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let F=b=class{constructor(M){l.set(this,void 0),it(this,l,M,"f")}static from(...M){let te=M;return new b(function(){if(te){for(const Ce of te)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();te=void 0}})}dispose(){typeof Be(this,l,"f")=="function"&&(Be(this,l,"f").call(this),it(this,l,void 0,"f"))}};l=new WeakMap,F=b=ze([P],F),e.Disposable=F;let x=w=class{constructor(M,te){if(M<0)throw(0,R.illegalArgument)("line must be non-negative");if(te<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Ce=1;Ce<M.length;Ce++){const Ye=M[Ce];Ye.isBefore(te)&&(te=Ye)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Ce=1;Ce<M.length;Ce++){const Ye=M[Ce];Ye.isAfter(te)&&(te=Ye)}return te}static isPosition(M){if(!M)return!1;if(M instanceof w)return!0;let{line:te,character:Ce}=M;return typeof te=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,R.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=0:typeof M=="number"?Ce=M:(Ce=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),Ce===0&&te===0?this:new w(this.line+Ce,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,R.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=this.line:typeof M=="number"?Ce=M:(Ce=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),Ce===this.line&&te===this.character?this:new w(Ce,te)}toJSON(){return{line:this.line,character:this.character}}};x=w=ze([P],x),e.Position=x;let j=T=class{constructor(M,te,Ce,Ye){let nt,rt;if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Ye=="number"?(nt=new x(M,te),rt=new x(Ce,Ye)):M instanceof x&&te instanceof x&&(nt=M,rt=te),!nt||!rt)throw new Error("Invalid arguments");nt.isBefore(rt)?(this._start=nt,this._end=rt):(this._start=rt,this._end=nt)}static isRange(M){return M instanceof T?!0:M?x.isPosition(M.start)&&x.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof T?this.contains(M._start)&&this.contains(M._end):M instanceof x?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=x.Max(M.start,this._start),Ce=x.Min(M.end,this._end);if(!te.isAfter(Ce))return new T(te,Ce)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=x.Min(M.start,this._start),Ce=x.Max(M.end,this.end);return new T(te,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,R.illegalArgument)();let Ce;return M?x.isPosition(M)?Ce=M:(Ce=M.start||this.start,te=M.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&te.isEqual(this.end)?this:new T(Ce,te)}toJSON(){return[this.start,this.end]}};j=T=ze([P],j),e.Range=j;let ae=o=class extends j{constructor(M,te,Ce,Ye){let nt,rt;if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Ye=="number"?(nt=new x(M,te),rt=new x(Ce,Ye)):M instanceof x&&te instanceof x&&(nt=M,rt=te),!nt||!rt)throw new Error("Invalid arguments");super(nt,rt);this._anchor=nt,this._active=rt}static isSelection(M){return M instanceof o?!0:M?j.isRange(M)&&x.isPosition(M.anchor)&&x.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ae=o=ze([P],ae),e.Selection=ae;class oe{constructor(M,te,Ce){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,R.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,R.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=Ce}}e.ResolvedAuthority=oe;class V extends Error{constructor(M,te=C.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(M);this._message=M,this._code=te,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(M,te){return new V(M,C.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new V(M,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var W;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var L;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=m=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof m?!0:M?j.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new m(M,te)}static insert(M,te){return m.replace(new j(M,M),te)}static delete(M){return m.replace(M,"")}static setEndOfLine(M){const te=new m(new j(new x(0,0),new x(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!j.isRange(M))throw(0,R.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,R.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,R.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=m=ze([P],Q),e.TextEdit=Q;var O;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,Ce,Ye){this._edits.push({_type:1,from:M,to:te,options:Ce,metadata:Ye})}createFile(M,te,Ce){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:Ce})}deleteFile(M,te,Ce){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:Ce})}replaceNotebookMetadata(M,te,Ce){this._edits.push({_type:3,metadata:Ce,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,Ce,Ye,nt){let rt,lt,St=[],At;if(Bt.isNotebookRange(te)&&Ft.isNotebookCellDataArray(Ce)&&!Ft.isNotebookCellDataArray(Ye)?(rt=te.start,lt=te.end,St=Ce,At=Ye):typeof te=="number"&&typeof Ce=="number"&&Ft.isNotebookCellDataArray(Ye)&&(rt=te,lt=Ce,St=Ye,At=nt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||St.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:lt-rt,cells:St,metadata:At})}replaceNotebookCellMetadata(M,te,Ce,Ye){this._edits.push({_type:3,metadata:Ye,uri:M,edit:{editType:8,index:te,metadata:Ce}})}replace(M,te,Ce,Ye){this._edits.push({_type:2,uri:M,edit:new Q(te,Ce),metadata:Ye})}insert(M,te,Ce,Ye){this.replace(M,new j(te,te),Ce,Ye)}delete(M,te,Ce){this.replace(M,te,"",Ce)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const Ce of te)Ce&&this._edits.push({_type:2,uri:M,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ye=this._edits[Ce];Ye._type===2&&Ye.uri.toString()===M.toString()&&(this._edits[Ce]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===M.toString()&&te.push(Ce.edit);return te}entries(){const M=new E.ResourceMap;for(let te of this._edits)if(te._type===2){let Ce=M.get(te.uri);Ce||(Ce=[te.uri,[]],M.set(te.uri,Ce)),Ce[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=ze([P],G),e.WorkspaceEdit=G;let de=v=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=v._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const Ce=new v;Ce._tabstop=this._tabstop,M(Ce),this._tabstop=Ce._tabstop,M=Ce.value}else M=v._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const Ce=M.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const Ce=new v;Ce._tabstop=this._tabstop,te(Ce),this._tabstop=Ce._tabstop,te=Ce.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};de=v=ze([P],de),e.SnippetString=de;var $;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var ne;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(ne=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=t=class{constructor(M,te){if(this.uri=M,te)if(te instanceof j)this.range=te;else if(te instanceof x)this.range=new j(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?j.isRange(M.range)&&y.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};he=t=ze([P],he),e.Location=he;let ye=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&j.isRange(M.location.range)&&y.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};ye=ze([P],ye),e.DiagnosticRelatedInformation=ye;let Ne=class{constructor(M,te,Ce=ne.Error){if(!j.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=Ce}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,h.equals)(M.tags,te.tags)&&(0,h.equals)(M.relatedInformation,te.relatedInformation,ye.isEqual)}};Ne=ze([P],Ne),e.Diagnostic=Ne;let Me=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=te}};Me=ze([P],Me),e.Hover=Me;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Xe=class{constructor(M,te=$e.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Xe=ze([P],Xe),e.DocumentHighlight=Xe;var qe;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let U=r=class{constructor(M,te,Ce,Ye,nt){this.name=M,this.kind=te,this.containerName=nt,typeof Ce=="string"&&(this.containerName=Ce),Ye instanceof he?this.location=Ye:Ce instanceof j&&(this.location=new he(Ye,Ce)),r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};U=r=ze([P],U),e.SymbolInformation=U;let K=a=class{constructor(M,te,Ce,Ye,nt){this.name=M,this.detail=te,this.kind=Ce,this.range=Ye,this.selectionRange=nt,this.children=[],a.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(a.validate)}};K=a=ze([P],K),e.DocumentSymbol=K;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(M,te){this.title=M,this.kind=te}};re=ze([P],re),e.CodeAction=re;let q=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([P],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ie=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ie=ze([P],ie),e.SelectionRange=ie;class ge{constructor(M,te,Ce,Ye,nt,rt){this.kind=M,this.name=te,this.detail=Ce,this.uri=Ye,this.range=nt,this.selectionRange=rt}}e.CallHierarchyItem=ge;class Re{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=Re;class We{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=We;var ve;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};Je=ze([P],Je),e.CodeLens=Je;let z=c=class{constructor(M,te=!1){f.set(this,void 0),it(this,f,new S.MarkdownString(M,{supportThemeIcons:te}),"f")}static isMarkdownString(M){return M instanceof c?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Be(this,f,"f").value}set value(M){Be(this,f,"f").value=M}get isTrusted(){return Be(this,f,"f").isTrusted}set isTrusted(M){Be(this,f,"f").isTrusted=M}get supportThemeIcons(){return Be(this,f,"f").supportThemeIcons}set supportThemeIcons(M){Be(this,f,"f").supportThemeIcons=M}appendText(M){return Be(this,f,"f").appendText(M),this}appendMarkdown(M){return Be(this,f,"f").appendMarkdown(M),this}appendCodeblock(M,te){return Be(this,f,"f").appendCodeblock(te??"",M),this}};f=new WeakMap,z=c=ze([P],z),e.MarkdownString=z;let Z=class{constructor(M,te){this.label=M,this.documentation=te}};Z=ze([P],Z),e.ParameterInformation=Z;let ce=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};ce=ze([P],ce),e.SignatureInformation=ce;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=ze([P],Ue),e.SignatureHelp=Ue;var xe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let De=class{constructor(M,te,Ce){this.text=M,this.position=te,this.kind=Ce}};De=ze([P],De),e.InlayHint=De;var Se;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Pe=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(N){N[N.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let le=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};le=ze([P],le),e.CompletionItem=le;let fe=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};fe=ze([P],fe),e.CompletionList=fe;let pe=class{constructor(M,te,Ce){this.text=M,this.range=te,this.command=Ce}};pe=ze([P],pe),e.InlineSuggestion=pe;let B=class{constructor(M){this.items=M}};B=ze([P],B),e.InlineSuggestions=B;var me;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(me=e.ViewColumn||(e.ViewColumn={}));var we;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(we=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Oe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var He;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(He=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ke;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Ke=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(M,te){if(te&&!y.URI.isUri(te))throw(0,R.illegalArgument)("target");if(!j.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.target=te}};ut=ze([P],ut),e.DocumentLink=ut;let mt=class{constructor(M,te,Ce,Ye){this.red=M,this.green=te,this.blue=Ce,this.alpha=Ye}};mt=ze([P],mt),e.Color=mt;let bt=class{constructor(M,te){if(te&&!(te instanceof mt))throw(0,R.illegalArgument)("color");if(!j.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.color=te}};bt=ze([P],bt),e.ColorInformation=bt;let ot=class{constructor(M){if(!M||typeof M!="string")throw(0,R.illegalArgument)("label");this.label=M}};ot=ze([P],ot),e.ColorPresentation=ot;var at;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var _e;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(_e=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ke{constructor(M,te,Ce){if(this.startIndex=M,this.length=te,this.tooltip=Ce,typeof M!="number"||M<0)throw(0,R.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,R.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=ke;class Y{constructor(M){this.options=M,typeof M!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=Y;var H;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(H=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=p=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw(0,R.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Te.Clean=new p("clean","Clean"),Te.Build=new p("build","Build"),Te.Rebuild=new p("rebuild","Rebuild"),Te.Test=new p("test","Test"),Te=p=ze([P],Te),e.TaskGroup=Te;function tt(N){let M="";for(let te=0;te<N.length;te++)M+=N[te].replace(/,/g,",,")+",";return M}let Ge=class{constructor(M,te,Ce){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ce):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return tt(M)}};Ge=ze([P],Ge),e.ProcessExecution=Ge;let ct=class{constructor(M,te,Ce){if(this._args=[],Array.isArray(te)){if(!M)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M,this._args=te,this._options=Ce}else{if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return tt(M)}};ct=ze([P],ct),e.ShellExecution=ct;var yt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Dt;let ft=d=class{constructor(M,te,Ce,Ye,nt,rt){this.__deprecated=!1,this._definition=this.definition=M;let lt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ce,this.execution=Ye,lt=nt,this.__deprecated=!0):te===kt.Global||te===kt.Workspace?(this.target=te,this._name=this.name=Ce,this._source=this.source=Ye,this.execution=nt,lt=rt):(this.target=te,this._name=this.name=Ce,this._source=this.source=Ye,this.execution=nt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof ct?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(d.EmptyType===te||d.ProcessType===te||d.ShellType===te||d.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=d=ze([P],ft),e.Task=ft;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(M,te=Et.None){this.collapsibleState=te,y.URI.isUri(M)?this.resourceUri=M:this.label=M}};vt=ze([P],vt),e.TreeItem=vt;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(M,te){this.id=M,this.color=te}};Tt=ze([P],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor(M){this.id=M}};It=ze([P],It),e.ThemeColor=It;var bn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(M,te){if(typeof M!="string"&&(!M||!y.URI.isUri(M)&&!y.URI.isUri(M.uri)))throw(0,R.illegalArgument)("base");if(typeof te!="string")throw(0,R.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=y.URI.file(M),this.base=M):y.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};Vt=ze([P],Vt),e.RelativePattern=Vt;let _t=class{constructor(M,te,Ce,Ye){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};_t=ze([P],_t),e.Breakpoint=_t;let Yt=class extends _t{constructor(M,te,Ce,Ye,nt){super(te,Ce,Ye,nt);if(M===null)throw(0,R.illegalArgument)("location");this.location=M}};Yt=ze([P],Yt),e.SourceBreakpoint=Yt;let Jt=class extends _t{constructor(M,te,Ce,Ye,nt){super(te,Ce,Ye,nt);this.functionName=M}};Jt=ze([P],Jt),e.FunctionBreakpoint=Jt;let gt=class extends _t{constructor(M,te,Ce,Ye,nt,rt,lt){super(Ye,nt,rt,lt);if(!te)throw(0,R.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=Ce}};gt=ze([P],gt),e.DataBreakpoint=gt;let qt=class{constructor(M,te,Ce){this.command=M,this.args=te||[],this.options=Ce}};qt=ze([P],qt),e.DebugAdapterExecutable=qt;let Wt=class{constructor(M,te){this.port=M,this.host=te}};Wt=ze([P],Wt),e.DebugAdapterServer=Wt;let Xt=class{constructor(M){this.path=M}};Xt=ze([P],Xt),e.DebugAdapterNamedPipeServer=Xt;let Zt=class{constructor(M){this.implementation=M}};Zt=ze([P],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor(M,te){this.range=M,this.expression=te}};Pt=ze([P],Pt),e.EvaluatableExpression=Pt;var dn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(M,te){this.range=M,this.text=te}};en=ze([P],en),e.InlineValueText=en;let xt=class{constructor(M,te,Ce=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=Ce}};xt=ze([P],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor(M,te){this.range=M,this.expression=te}};ht=ze([P],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};tn=ze([P],tn),e.InlineValueContext=tn;var Mt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Nt=D=class extends Error{constructor(M,te=n.FileSystemProviderErrorCode.Unknown,Ce){super(y.URI.isUri(M)?M.toString(!0):M);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(M){return new D(M,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(M){return new D(M,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(M){return new D(M,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(M){return new D(M,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Nt=D=ze([P],Nt),e.FileSystemError=Nt;let jt=class{constructor(M,te,Ce){this.start=M,this.end=te,this.kind=Ce}};jt=ze([P],jt),e.FoldingRange=jt;var En;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=fn;function nn(N){return typeof N=="undefined"||(0,_.isStringArray)(N)}class rn{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,Ce=M.tokenTypes.length;te<Ce;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,Ce=M.tokenModifiers.length;te<Ce;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,Ce,Ye,nt){if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(M,te,Ce,Ye,nt);if(j.isRange(M)&&typeof te=="string"&&nn(Ce))return this._push(M,te,Ce);throw(0,R.illegalArgument)()}_push(M,te,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ye=M.start.line,nt=M.start.character,rt=M.end.character-M.start.character,lt=this._tokenTypeStrToInt.get(te);let St=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);St|=1<<Rt>>>0}this._pushEncoded(Ye,nt,rt,lt,St)}_pushEncoded(M,te,Ce,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Rt=0;for(let Lt=0;Lt<St;Lt++){let Ot=this._data[5*Lt],un=this._data[5*Lt+1];Ot===0?(Ot=At,un+=Rt):Ot+=At,this._data[5*Lt]=Ot,this._data[5*Lt+1]=un,At=Ot,Rt=un}}let rt=M,lt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const Ce=M.length/5|0;for(let lt=0;lt<Ce;lt++)te[lt]=lt;te.sort((lt,St)=>{const At=M[5*lt],Rt=M[5*St];if(At===Rt){const Lt=M[5*lt+1],Ot=M[5*St+1];return Lt-Ot}return At-Rt});const Ye=new Uint32Array(M.length);let nt=0,rt=0;for(let lt=0;lt<Ce;lt++){const St=5*te[lt],At=M[St+0],Rt=M[St+1],Lt=M[St+2],Ot=M[St+3],un=M[St+4],Un=At-nt,jn=Un===0?Rt-rt:Rt,cn=5*lt;Ye[cn+0]=Un,Ye[cn+1]=jn,Ye[cn+2]=Lt,Ye[cn+3]=Ot,Ye[cn+4]=un,nt=At,rt=Rt}return Ye}build(M){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),M):new Ht(rn._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=rn;class Ht{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=Ht;class sn{constructor(M,te,Ce){this.start=M,this.deleteCount=te,this.data=Ce}}e.SemanticTokensEdit=sn;class yn{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=yn;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=ze([P],Gt),e.QuickInputButtons=Gt;var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(M,te,Ce){this.badge=M,this.tooltip=te,this.color=Ce}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor(M){this.kind=M}};on=ze([P],on),e.ColorTheme=on;var an;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,te){if(M<0)throw(0,R.illegalArgument)("start must be positive");if(te<0)throw(0,R.illegalArgument)("end must be positive");M<=te?(this._start=M,this._end=te):(this._start=te,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let te=this._start,Ce=this._end;return M.start!==void 0&&(te=M.start),M.end!==void 0&&(Ce=M.end),te===this._start&&Ce===this._end?this:new Bt(te,Ce)}}e.NotebookRange=Bt;class Ft{constructor(M,te,Ce,Ye,nt,rt,lt){this.kind=M,this.value=te,this.languageId=Ce,this.mime=Ye,this.outputs=nt??[],this.metadata=rt,this.executionSummary=lt,Ft.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(te=>Ft.isNotebookCellData(te))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Ft;class Kt{constructor(M){this.cells=M}}e.NotebookData=Kt;class Le{constructor(M,te){this.data=M,this.mime=te;const Ce=(0,A.normalizeMimeType)(te,!0);if(!Ce)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(M){return M instanceof Le?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const te={name:M.name,message:M.message,stack:M.stack};return Le.json(te,"application/vnd.code.notebook.error")}static stdout(M){return Le.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Le.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,te="application/octet-stream"){return new Le(M,te)}static text(M,te=A.Mimes.text){const Ce=Be(Le,u,"f",g).encode(String(M));return new Le(Ce,te)}static json(M,te="application/json"){const Ce=JSON.stringify(M,void 0,"	");return Le.text(Ce,te)}}e.NotebookCellOutputItem=Le,u=Le,g={value:new TextEncoder};class $t{constructor(M,te,Ce){this.items=$t.ensureUniqueMimeTypes(M,!0),typeof te=="string"?(this.id=te,this.metadata=Ce):(this.id=(0,I.generateUuid)(),this.metadata=te??Ce)}static isNotebookCellOutput(M){return M instanceof $t?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,_.isArray)(M.items)}static ensureUniqueMimeTypes(M,te=!1){const Ce=new Set,Ye=new Set;for(let nt=0;nt<M.length;nt++){const rt=M[nt],lt=(0,A.normalizeMimeType)(rt.mime);if(!Ce.has(lt)){Ce.add(lt);continue}Ye.add(nt),te&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ye.size===0?M:M.filter((nt,rt)=>!Ye.has(rt))}}e.NotebookCellOutput=$t;var mn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(M,te){this.text=M,this.alignment=te}}e.NotebookCellStatusBarItem=gn;var pn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(M,te=[]){this.uri=M,this.provides=(0,h.asArray)(te)}}e.NotebookRendererScript=Pn;let ln=class{constructor(M,te){this.label=M,this.timestamp=te}};ln=ze([P],ln),e.TimelineItem=ln;var An;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=Rn;class Fn{constructor(M,te){this._port=M,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Ln;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var Mn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let J=class{constructor(M,te,Ce){this.include=M,this.exclude=te,this.profile=Ce}};J=ze([P],J),e.TestRunRequest=J;let ue=k=class{constructor(M){this.message=M}static diff(M,te,Ce){const Ye=new k(M);return Ye.expectedOutput=te,Ye.actualOutput=Ce,Ye}};ue=k=ze([P],ue),e.TestMessage=ue;let Ae=class{constructor(M,te){this.covered=M,this.total=te}};Ae=ze([P],Ae),e.CoveredCount=Ae;let st=s=class{constructor(M,te,Ce,Ye){this.uri=M,this.statementCoverage=te,this.branchCoverage=Ce,this.functionCoverage=Ye}static fromDetails(M,te){const Ce=new Ae(0,0),Ye=new Ae(0,0),nt=new Ae(0,0);for(const lt of te)if("branches"in lt){Ce.total+=1,Ce.covered+=lt.executionCount>0?1:0;for(const St of lt.branches)Ye.total+=1,Ye.covered+=St.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const rt=new s(M,Ce,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return rt.detailedCoverage=te,rt}};st=s=ze([P],st),e.FileCoverage=st;let wt=class{constructor(M,te,Ce=[]){this.executionCount=M,this.location=te,this.branches=Ce}};wt=ze([P],wt),e.StatementCoverage=wt;let Ct=class{constructor(M,te){this.executionCount=M,this.location=te}};Ct=ze([P],Ct),e.BranchCoverage=Ct;let On=class{constructor(M,te){this.executionCount=M,this.location=te}};On=ze([P],On),e.FunctionCoverage=On;var Hn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(M,te,Ce,Ye,nt,rt){this.kind=M,this.name=te,this.detail=Ce,this.uri=Ye,this.range=nt,this.selectionRange=rt}}e.TypeHierarchyItem=qn}),define(be[98],Ee([0,1,41,11,8,124,88,7,17]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function n(u,g){g?I.set(u,g):I.delete(u)}e.setWordDefinitionFor=n;function C(u){return I.get(u)}e.getWordDefinitionFor=C;class l extends E.MirrorTextModel{constructor(g,b,w,T,o,m,v,t){super(b,w,T,o);this._proxy=g,this._languageId=m,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,y.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===R.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(b){return b?g._getTextInRange(b):g.getText()},get eol(){return g._eol===`
`?_.EndOfLine.LF:_.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(b){return g._lineAt(b)},offsetAt(b){return g._offsetAt(b)},positionAt(b){return g._positionAt(b)},validateRange(b){return g._validateRange(b)},validatePosition(b){return g._validatePosition(b)},getWordRangeAtPosition(b,w){return g._getWordRangeAtPosition(b,w)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,h.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,h.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const b=this._validateRange(g);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const w=this._eol,T=b.start.line,o=b.end.line,m=[];m.push(this._lines[T].substring(b.start.character));for(let v=T+1;v<o;v++)m.push(this._lines[v]);return m.push(this._lines[o].substring(0,b.end.character)),m.join(w)}_lineAt(g){let b;if(g instanceof _.Position?b=g.line:typeof g=="number"&&(b=g),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new f(b,this._lines[b],b===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(g),w=this._lines[b.index].length;return new _.Position(b.index,Math.min(b.remainder,w))}_validateRange(g){if(!(g instanceof _.Range))throw new Error("Invalid argument");const b=this._validatePosition(g.start),w=this._validatePosition(g.end);return b===g.start&&w===g.end?g:new _.Range(b.line,b.character,w.line,w.character)}_validatePosition(g){if(!(g instanceof _.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:b,character:w}=g,T=!1;if(b<0)b=0,w=0,T=!0;else if(b>=this._lines.length)b=this._lines.length-1,w=this._lines[b].length,T=!0;else{const o=this._lines[b].length;w<0?(w=0,T=!0):w>o&&(w=o,T=!0)}return T?new _.Position(b,w):g}_getWordRangeAtPosition(g,b){const w=this._validatePosition(g);if(!b)b=C(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const T=(0,A.getWordAtText)(w.character+1,(0,A.ensureValidWordDefinition)(b),this._lines[w.line],0);if(T)return new _.Range(w.line,T.startColumn-1,w.line,T.endColumn-1)}}e.ExtHostDocumentData=l;class f{constructor(g,b,w){this._line=g,this._text=b,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new _.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new _.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[164],Ee([0,1,7,3,90,6,58,21,2,37]),function(ee,e,h,R,S,E,A,_,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,f,u,g){this._notebook=u,this._selector=g,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(w=>{const T=this._cellUris.get(w.document.uri);T!==void 0&&(this._cellLengths.changeValue(T,this._cells[T].document.getText().length+1),this._cellLines.changeValue(T,this._cells[T].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>b(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new _.ResourceMap;const l=[],f=[];for(const u of this._notebook.getCells())u.kind===h.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),l.push(u.document.getText().length+1),f.push(u.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(l){if(!l){let T="";for(const o of this._cells)T+=o.document.getText()+`
`;return T=T.slice(0,-1),T}if(l.isEmpty)return"";const f=this.locationAt(l.start),u=this.locationAt(l.end),g=this._cellUris.get(f.uri),b=this._cellUris.get(u.uri);if(g===void 0||b===void 0)return"";if(g===b)return this._cells[g].document.getText(new h.Range(f.range.start,u.range.end));const w=[this._cells[g].document.getText(new h.Range(f.range.start,new h.Position(this._cells[g].document.lineCount,0)))];for(let T=g+1;T<b;T++)w.push(this._cells[T].document.getText());return w.push(this._cells[b].document.getText(new h.Range(new h.Position(0,0),u.range.end))),w.join(`
`)}offsetAt(l){const f=this._cellLines.getIndexOf(l.line),u=this._cellLengths.getPrefixSum(f.index-1),g=this._cells[f.index].document.offsetAt(l.with(f.remainder));return u+g}positionAt(l){if(typeof l=="number"){const u=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(g)}const f=this._cellUris.get(l.uri);if(f!==void 0){const u=this._cellLines.getPrefixSum(f-1);return new h.Position(u+l.range.start.line,l.range.start.character)}return new h.Position(0,0)}locationAt(l){h.Range.isRange(l)||(l=new h.Range(l,l));const f=this._cellLines.getIndexOf(l.start.line);let u=f;l.isEmpty||(u=this._cellLines.getIndexOf(l.end.line));const g=new h.Position(f.remainder,l.start.character),b=new h.Position(u.remainder,l.end.character),w=new h.Range(g,b),T=this._cells[f.index];return new h.Location(T.document.uri,T.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const f=this.validatePosition(l.start),u=this.validatePosition(l.end);return l.with(f,u)}validatePosition(l){const f=this._cellLines.getIndexOf(l.line),u=new h.Position(f.remainder,l.character),g=this._cells[f.index].document.validatePosition(u),b=this._cellLines.getPrefixSum(f.index-1);return new h.Position(b+g.line,g.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[165],Ee([0,1,7,13,3]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(_){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(_){let y=_==="light"?h.ColorThemeKind.Light:_==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=ze([Ve(0,R.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(be[70],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class R{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(be[166],Ee([0,1,24]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let I=this.buffers.indexOf(y);return I<0&&(I=this.buffers.length,this.buffers.push(y)),I}}function S(_,y){if(y.serializeBuffersForPostMessage){const I=new R,n=(f,u)=>{if(u instanceof ArrayBuffer){const g=I.add(u);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(u)){const g=E(u);if(g){const b=I.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:g,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},C=JSON.stringify(_,n),l=I.buffers.map(f=>{const u=new Uint8Array(f);return h.VSBuffer.wrap(u)});return{message:C,buffers:l}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeWebviewMessage=S;function E(_){switch(_.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(_,y){const I=y.map(l=>{const f=new ArrayBuffer(l.byteLength);return new Uint8Array(f).set(l.buffer),f}),n=y.length?(l,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const u=f,{index:g}=u,b=I[g];if(u.view)switch(u.view.type){case 1:return new Int8Array(b,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return f}:void 0;return{message:JSON.parse(_,n),arrayBuffers:I}}e.deserializeWebviewMessage=A}),define(be[167],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(R){function S(A){const _={items:new Map};return A.types.forEach((y,I)=>{_.items.set(y,{asString:async()=>A.items[I].asString})}),_}R.toITreeDataTransfer=S;async function E(A){const _={types:[],items:[]},y=Array.from(A.items.entries());for(const I of y)_.types.push(I[0]),_.items.push({asString:await I[1].asString()});return _}R.toTreeDataTransferDTO=E})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[71],Ee([0,1,11,2]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(E,A){return E.scheme===h.Schemas.http||E.scheme===h.Schemas.https?E:(A&&A.authority&&A.isRemote&&E.scheme===h.Schemas.file&&(E=R.URI.from({scheme:h.Schemas.vscodeRemote,authority:A.authority,path:E.path})),R.URI.from({scheme:h.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=S}),define(be[168],Ee([0,1,3,6,71]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(_,y,I){this._proxy=_,this._editors=y,this._initData=I,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const C of this._insets.values())n.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(_=>_.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(_,y,I,n,C){let l;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===_){l=o;break}if(!l)throw new Error("not a visible editor");const f=this,u=this._handlePool++,g=new h.Emitter,b=new h.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,S.asWebviewUri)(o,f._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(o){this._options=o,f._proxy.$setOptions(u,o)}get options(){return this._options}set html(o){this._html=o,f._proxy.$setHtml(u,o)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(o){return f._proxy.$postMessage(u,o)}},T=new class{constructor(){this.editor=_,this.line=y,this.height=I,this.webview=w,this.onDidDispose=b.event}dispose(){f._insets.has(u)&&(f._insets.delete(u),f._proxy.$disposeEditorInset(u),b.fire(),b.dispose(),g.dispose())}};return this._proxy.$createEditorInset(u,l.id,l.value.document.uri,y+1,I,n||{},C.identifier,C.extensionLocation),this._insets.set(u,{editor:_,inset:T,onDidReceiveMessage:g}),T}$onDidDispose(_){const y=this._insets.get(_);y&&y.inset.dispose()}$onDidReceiveMessage(_,y){const I=this._insets.get(_);I&&I.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=E}),define(be[169],Ee([0,1,140,10,2,6,4,45,28,17,11]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new _.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new _.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new _.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new _.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new _.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorContext=new _.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new _.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new _.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new _.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.EditorGroupEditorsCountContext=new _.RawContextKey("groupEditorsCount",0,(0,h.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new _.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(12,null)),e.ActiveEditorGroupIndexContext=new _.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(13,null)),e.ActiveEditorGroupLastContext=new _.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(14,null)),e.MultipleEditorGroupsContext=new _.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new _.RawContextKey("editorIsOpen",!1,(0,h.localize)(16,null)),e.InEditorZenModeContext=new _.RawContextKey("inZenMode",!1,(0,h.localize)(17,null)),e.IsCenteredLayoutContext=new _.RawContextKey("isCenteredLayout",!1,(0,h.localize)(18,null)),e.SplitEditorsVertically=new _.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(19,null)),e.EditorAreaVisibleContext=new _.RawContextKey("editorAreaVisible",!0,(0,h.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function C(s){return typeof s?.getViewState=="function"}e.isTextEditorPane=C;function l(s){if(o(s))return!1;const P=s;return S.URI.isUri(P?.resource)}e.isResourceEditorInput=l;function f(s){if(o(s))return!1;const P=s;return P?.original!==void 0&&P.modified!==void 0}e.isResourceDiffEditorInput=f;function u(s){if(o(s))return!1;const P=s;return P?P?.resource===void 0||P.resource.scheme===n.Schemas.untitled||P.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var g;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var b;(function(s){s[s.EXPLICIT=1]="EXPLICIT",s[s.AUTO=2]="AUTO",s[s.FOCUS_CHANGE=3]="FOCUS_CHANGE",s[s.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var w;(function(s){s[s.None=0]="None",s[s.Readonly=2]="Readonly",s[s.Untitled=4]="Untitled",s[s.Singleton=8]="Singleton",s[s.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class T extends E.Disposable{}e.AbstractEditorInput=T;function o(s){return s instanceof T}e.isEditorInput=o;function m(s){const P=s;return S.URI.isUri(P?.preferredResource)}function v(s){const P=s;return o(P?.primary)&&o(P?.secondary)}e.isSideBySideEditorInput=v;function t(s){return o(s?.editor)}e.isEditorInputWithOptions=t;function r(s){const P=s;return t(s)&&P?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function a(s){const P=s;return typeof P?.groupId=="number"&&o(P.editor)}e.isEditorIdentifier=a;var i;(function(s){s[s.PRIMARY=1]="PRIMARY",s[s.SECONDARY=2]="SECONDARY",s[s.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(P,F){if(!P)return;const x=v(P)?P.primary:f(P)?P.modified:void 0,j=v(P)?P.secondary:f(P)?P.original:void 0;if(F?.supportSideBySide&&x&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:F.filterByScheme})};P=F.supportSideBySide===i.PRIMARY?x:j}if(f(P))return;const ae=m(P)?P.preferredResource:P.resource;return!ae||!F||!F.filterByScheme?ae:this.filterUri(ae,F.filterByScheme)}getCanonicalUri(P,F){if(!P)return;const x=v(P)?P.primary:f(P)?P.modified:void 0,j=v(P)?P.secondary:f(P)?P.original:void 0;if(F?.supportSideBySide&&x&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:F.filterByScheme})};P=F.supportSideBySide===i.PRIMARY?x:j}if(f(P))return;const ae=P.resource;return!ae||!F||!F.filterByScheme?ae:this.filterUri(ae,F.filterByScheme)}filterUri(P,F){if(Array.isArray(F)){if(F.some(x=>P.scheme===x))return P}else if(F===P.scheme)return P}}e.EditorResourceAccessor=new c;var p;(function(s){s[s.LEFT=0]="LEFT",s[s.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class d{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(P){const F=this.instantiationService=P.get(A.IInstantiationService);for(const[x,j]of this.editorSerializerConstructors)this.createEditorSerializer(x,j,F);this.editorSerializerConstructors.clear()}createEditorSerializer(P,F,x){const j=x.createInstance(F);this.editorSerializerInstances.set(P,j)}registerFileEditorFactory(P){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=P}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(P,F){if(this.editorSerializerConstructors.has(P)||this.editorSerializerInstances.has(P))throw new Error(`A editor serializer with type ID '${P}' was already registered.`);return this.instantiationService?this.createEditorSerializer(P,F,this.instantiationService):this.editorSerializerConstructors.set(P,F),(0,E.toDisposable)(()=>{this.editorSerializerConstructors.delete(P),this.editorSerializerInstances.delete(P)})}getEditorSerializer(P){return this.editorSerializerInstances.get(typeof P=="string"?P:P.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new d);async function D(s,P){if(!s||!s.length)return[];const F=await Promise.all(s.map(async x=>{const j=S.URI.revive(x.fileUri);if(!j||(await P.activateProvider(j.scheme),!P.canHandleResource(j)))return;const ae=typeof x.exists=="boolean"?x.exists:await P.exists(j);if(!ae&&x.openOnlyIfExists)return;const oe=ae&&!(0,R.isUndefined)(x.selection)?{selection:x.selection,pinned:!0,override:x.editorOverrideId}:{pinned:!0,override:x.editorOverrideId};let V;return ae?V={resource:j,options:oe,forceFile:!0}:V={resource:j,options:oe,forceUntitled:!0},V}));return(0,I.coalesce)(F)}e.pathsToEditors=D;var k;(function(s){s[s.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",s[s.SEQUENTIAL=1]="SEQUENTIAL"})(k=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[170],Ee([0,1,3,45,141,4,6,21,28,17,51,23,35,160]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",l.Codicon.window,(0,S.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var g;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function w(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=w;class T extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(p,d,D){const k=this.get(p.id);if(k)return k;const s=p;return s.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,_.getOrSet)(this.viewContainers,d,[]).push(s),D?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:d}),s}deregisterViewContainer(p){for(const d of this.viewContainers.keys()){const D=this.viewContainers.get(d),k=D?.indexOf(p);if(k!==-1){D?.splice(k,1),D.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:p,viewContainerLocation:d});return}}}get(p){return this.all.filter(d=>d.id===p)[0]}getViewContainers(p){return[...this.viewContainers.get(p)||[]]}getViewContainerLocation(p){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(D=>D?.id===p.id).length>0)[0]}getDefaultViewContainer(p){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===p)}}y.Registry.add(u.ViewContainersRegistry,new T);var o;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function m(c,p){const d=c.group??o.More,D=p.group??o.More;return d!==D?d.localeCompare(D):(c.order??5)-(p.order??5)}class v extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(p,d){this.registerViews2([{views:p,viewContainer:d}])}registerViews2(p){p.forEach(({views:d,viewContainer:D})=>this.addViews(d,D)),this._onViewsRegistered.fire(p)}deregisterViews(p,d){const D=this.removeViews(p,d);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:d})}moveViews(p,d){for(const D of this._views.keys())if(D!==d){const k=this.removeViews(p,D);k.length&&(this.addViews(k,d),this._onDidChangeContainer.fire({views:k,from:D,to:d}))}}getViews(p){return this._views.get(p)||[]}getView(p){for(const d of this._viewContainers){const D=(this._views.get(d)||[]).filter(k=>k.id===p)[0];if(D)return D}return null}getViewContainer(p){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(k=>k.id===p)[0])return d;return null}registerViewWelcomeContent(p,d){return this._viewWelcomeContents.add(p,d),this._onDidChangeViewWelcomeContent.fire(p),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(p,d),this._onDidChangeViewWelcomeContent.fire(p)})}registerViewWelcomeContent2(p,d){const D=new Map;for(const[k,s]of d)this._viewWelcomeContents.add(p,s),D.set(k,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(p,s),this._onDidChangeViewWelcomeContent.fire(p)}));return this._onDidChangeViewWelcomeContent.fire(p),D}getViewWelcomeContent(p){const d=[];return this._viewWelcomeContents.forEach(p,D=>d.push(D)),d.sort(m)}addViews(p,d){let D=this._views.get(d);D||(D=[],this._views.set(d,D),this._viewContainers.push(d));for(const k of p){if(this.getView(k.id)!==null)throw new Error((0,S.localize)(1,null,k.id));D.push(k)}}removeViews(p,d){const D=this._views.get(d);if(!D)return[];const k=[],s=[];for(const P of D)p.includes(P)?k.push(P):s.push(P);return k.length&&(s.length?this._views.set(d,s):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),k}}y.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,E.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,E.createDecorator)("viewDescriptorService");var r;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(p,d){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,p),this._hasResolve=!!d,this.resolve=async D=>{if(d&&!this.resolved){const k=await d(D);k&&(this.tooltip=this.tooltip??k.tooltip,this.command=this.command??k.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[171],Ee([0,1,3,15,142]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(_){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=_}onEvent(_){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=_}onRequest(_){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=_}sendResponse(_){_.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${_.command}`)):this.internalSend("response",_)}sendRequest(_,y,I,n){const C={command:_};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const f=this.pendingRequests.get(C.seq);if(f){this.pendingRequests.delete(C.seq);const u={type:"response",seq:0,request_seq:C.seq,success:!1,command:_,message:(0,S.localize)(0,null,n,_)};f(u)}},n)}return I&&this.pendingRequests.set(C.seq,I),C.seq}acceptMessage(_){this.messageCallback?this.messageCallback(_):(this.queue.push(_),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(_,y){return _.type!=="event"||y.type!=="event"}async processQueue(){let _;for(;this.queue.length;){if((!_||this.needsTaskBoundaryBetween(this.queue[0],_))&&await(0,R.timeout)(0),_=this.queue.shift(),!_)return;switch(_.type){case"event":this.eventCallback&&this.eventCallback(_);break;case"request":this.requestCallback&&this.requestCallback(_);break;case"response":const y=_,I=this.pendingRequests.get(y.request_seq);I&&(this.pendingRequests.delete(y.request_seq),I(y));break}}}internalSend(_,y){y.type=_,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const _=new Map;this.pendingRequests.forEach((y,I)=>_.set(I,y)),await(0,R.timeout)(500),_.forEach((y,I)=>{y({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(be[172],Ee([0,1,8,2,14,23,11]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const _=/{([^}]+)}/g;function y(r,a,i){return r.replace(_,function(c,p){return a&&p.length>0&&p[0]!=="_"?c:i&&i.hasOwnProperty(p)?i[p]:c})}e.formatPII=y;function I(r){const a={};for(const i of Object.keys(r))i.startsWith("!")||(a[i]=r[i]);return a}e.filterExceptionsFromTelemetry=I;function n(r){return r.configuration.request==="attach"&&!C(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function C(r){let a=r.configuration.type;if(!!a)return a==="vslsShare"&&(a=r.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(a,"extensionhost")||(0,h.equalsIgnoreCase)(a,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function f(r,a,i){let c,p=0,d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=d.exec(r);){let k=D.index+1,s=k+D[0].length;if(k<=a&&s>=i){c=D[0],p=k;break}}if(c){let k=/\w+/g,s=null;for(;(s=k.exec(c))&&!(s.index+1+p+s[0].length>=i););s&&(c=c.substring(0,k.lastIndex))}return c?{start:p,end:p+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(u))}e.isUri=g;function b(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return R.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const a=R.URI.revive(r.path);if(a)return a.scheme===A.Schemas.file?a.fsPath:a.toString()}return r.path}function T(r,a){const i=a?b:w,c=(0,E.deepClone)(r);return m(c,(p,d)=>{p&&d&&(d.path=i(d))}),c}e.convertToDAPaths=T;function o(r,a){const i=a?b:w,c=(0,E.deepClone)(r);return m(c,(p,d)=>{!p&&d&&(d.path=i(d))}),c}e.convertToVSCPaths=o;function m(r,a){switch(r.type){case"event":const i=r;switch(i.event){case"output":a(!1,i.body.source);break;case"loadedSource":a(!1,i.body.source);break;case"breakpoint":a(!1,i.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":a(!0,c.arguments.source);break;case"breakpointLocations":a(!0,c.arguments.source);break;case"source":a(!0,c.arguments.source);break;case"gotoTargets":a(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(d=>a(!1,d));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(d=>a(!1,d.source));break;case"loadedSources":p.body.sources.forEach(d=>a(!1,d));break;case"scopes":p.body.scopes.forEach(d=>a(!1,d.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(d=>a(!1,d.source));break;case"setBreakpoints":p.body.breakpoints.forEach(d=>a(!1,d.source));break;default:break}break}}function v(r){return r.filter(a=>!a.presentation?.hidden).sort((a,i)=>a.presentation?i.presentation?a.presentation.group?i.presentation.group?a.presentation.group!==i.presentation.group?a.presentation.group.localeCompare(i.presentation.group):t(a.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(a.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=v;function t(r,a){return typeof r!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:r-a}}),define(be[72],Ee([0,1,27,85,11,14,22,45]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(s){s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var b;(function(s){s.scheme=S.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function F(V,W){return V.with({scheme:s.scheme,fragment:`ch${W.toString().padStart(7,"0")}${V.scheme!==S.Schemas.file?V.scheme:""}`})}s.generate=F;function x(V){if(V.scheme!==s.scheme)return;const W=P.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||S.Schemas.file,fragment:null})}:void 0}s.parse=x;function j(V){if(V.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const W=P.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||S.Schemas.file,fragment:null})}:void 0}s.parseCellMetadataUri=j;function ae(V,W,L){return V.with({scheme:L,fragment:`ch${W.toString().padStart(7,"0")}${V.scheme!==S.Schemas.file?V.scheme:""}`})}s.generateCellUri=ae;function oe(V,W){if(V.scheme!==W)return;const L=P.exec(V.fragment);return L?{handle:Number(L[1]),notebook:V.with({scheme:V.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}:void 0}s.parseCellUri=oe})(b=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function T(s){return w.get(s)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=T;function o(s){return w.get(s)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function m(s){return w.get(s)?.mergeable??!1}e.mimeTypeIsMergeable=m;function v(s,P){return A.isWindows&&(s=s.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),h.match(s,P)}function t(s,P,F){let x=0;for(let j=0;j<P.length;j++){if(v(P[j],s))return x;x++}for(let j=0;j<F.length;j++){if(v(F[j],s))return x;x++}return x}function r(s,P,F){return s.sort((x,j)=>t(x,P,F)-t(j,P,F))}e.sortMimeTypes=r;function a(s,P,F,x=(j,ae)=>j===ae){const j=[];function ae(W,L,Q){if(L===0&&Q.length===0)return;const O=j[j.length-1];O&&O.start+O.deleteCount===W?(O.deleteCount+=L,O.toInsert.push(...Q)):j.push({start:W,deleteCount:L,toInsert:Q})}let oe=0,V=0;for(;;){if(oe===s.length){ae(oe,0,P.slice(V));break}if(V===P.length){ae(oe,s.length-oe,[]);break}const W=s[oe],L=P[V];if(x(W,L)){oe+=1,V+=1;continue}F(L)?(ae(oe,1,[]),oe+=1):(ae(oe,0,[L]),V+=1)}return j}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(s){s.default="default",s.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(s){const P=s;return!!((typeof P.include=="string"||h.isRelativePattern(P.include))&&(typeof P.exclude=="string"||h.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=c;function p(s,P,F){if(Array.isArray(s.viewType)&&s.viewType.indexOf(P)>=0||s.viewType===P)return!0;if(s.filenamePattern){let x=c(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,j=c(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(h.match(x,(0,E.basename)(F.fsPath).toLowerCase()))return!(j&&h.match(j,(0,E.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class d{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)P[F]=this.textModel.cells[F].getHashValue();return P}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var D;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class k{static create(P){return`${k._prefix}${P}`}static parse(P){if(P.startsWith(k._prefix))return P.substr(k._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=k,k._prefix="notebook/"}),define(be[173],Ee([0,1,144,4,45]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[174],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=h;function R(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=R}),define(be[99],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var h;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));const R=C=>({testId:C.item.extId,controllerId:C.controllerId});e.identifyTest=R;var S;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=A;var _;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var y;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(l){}update(l){}remove(l,f){}complete(){}}e.IncrementalChangeCollector=I;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const f=this.createChangeCollector();for(const u of l)switch(u[0]){case 0:{const g=u[1];if(g.parent){if(this.items.has(g.parent)){const b=this.items.get(g.parent);b.children.add(g.item.extId);const w=this.createItem(g,b);this.items.set(g.item.extId,w),f.add(w)}}else{const b=this.createItem(g);this.roots.add(b),this.items.set(g.item.extId,b),f.add(b)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=u[1],b=this.items.get(g.extId);if(!b)break;g.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,g),f.update(b);break}case 2:{const g=this.items.get(u[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const b=[[u[1]]];for(;b.length;)for(const w of b.pop()){const T=this.items.get(w);T&&(b.push(T.children),this.items.delete(w),f.remove(T,T!==g),T.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break}f.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=n}),define(be[73],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(E){E.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(E){E[E.IsSame=0]="IsSame",E[E.Disconnected=1]="Disconnected",E[E.IsChild=2]="IsChild",E[E.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class S{constructor(A,_=A.length){if(this.path=A,this.viewEnd=_,A.length===0||_<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,_,y=A.parent){if(A.id===_)return new S([_]);let I=[A.id];for(let n=y;n&&n.id!==_;n=n.parent)I.push(n.id);return I.push(_),new S(I.reverse())}static fromString(A){return new S(A.split("\0"))}static join(A,_){return new S([...A.path,_])}static joinToString(A,_){return A.toString()+"\0"+_}static compare(A,_){return A===_?0:_.startsWith(A+"\0")?2:A.startsWith(_+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new S(this.path,A)}compare(A){if(typeof A=="string")return S.compare(this.toString(),A);for(let _=0;_<A.viewEnd&&_<this.viewEnd;_++)if(A.path[_]!==this.path[_])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=S}),define(be[175],Ee([0,1,14,42,10,23,22,84,145]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(C,l,f){this._contributedVariables=new Map,this._context=C,this._labelService=l,f&&(this._envVariablesPromise=f.then(u=>this.prepareEnv(u)))}prepareEnv(C){if(A.isWindows){const l=Object.create(null);return Object.keys(C).forEach(f=>{l[f.toLowerCase()]=C[f]}),l}return C}resolveWithEnvironment(C,l,f){return this.recursiveResolve(this.prepareEnv(C),l?l.uri:void 0,f)}async resolveAsync(C,l){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,l)}async resolveAnyBase(C,l,f,u){const g=E.deepClone(l);return A.isWindows&&g.windows?Object.keys(g.windows).forEach(b=>g[b]=g.windows[b]):A.isMacintosh&&g.osx?Object.keys(g.osx).forEach(b=>g[b]=g.osx[b]):A.isLinux&&g.linux&&Object.keys(g.linux).forEach(b=>g[b]=g.linux[b]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g,f,u)}async resolveAnyAsync(C,l,f){return this.resolveAnyBase(C,l,f)}async resolveAnyMap(C,l,f){const u=new Map;return{newConfig:await this.resolveAnyBase(C,l,f,u),resolvedVariables:u}}resolveWithInteractionReplace(C,l,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,l,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,l){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,l)}recursiveResolve(C,l,f,u,g){if(S.isString(f))return this.resolveString(C,l,f,u,g);if(S.isArray(f))return f.map(b=>this.recursiveResolve(C,l,b,u,g));if(S.isObject(f)){let b=Object.create(null);return Object.keys(f).forEach(w=>{const T=this.resolveString(C,l,w,u,g);b[T]=this.recursiveResolve(C,l,f[w],u,g)}),b}return f}resolveString(C,l,f,u,g){return f.replace(I.VARIABLE_REGEXP,(w,T)=>{if(T.includes(I.VARIABLE_LHS))return w;let o=this.evaluateSingleVariable(C,w,T,l,u);return g&&g.set(T,o),o!==w&&S.isString(o)&&o.match(I.VARIABLE_REGEXP)&&(o=this.resolveString(C,l,o,u,g)),o})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,l,f,u,g){let b;const w=f.split(":");w.length>1&&(f=w[0],b=w[1]);const T=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,y.localize)(0,null,l))},o=()=>{const v=T();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,l,h.basename(v)))},m=()=>{if(b){const v=this._context.getFolderUri(b);if(v)return v;throw new Error((0,y.localize)(2,null,l,b))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,l)):new Error((0,y.localize)(4,null,l))};switch(f){case"env":if(b){if(C){const v=C[A.isWindows?b.toLowerCase():b];if(S.isString(v))return v}return""}throw new Error((0,y.localize)(5,null,l));case"config":if(b){const v=this._context.getConfigurationValue(u,b);if(S.isUndefinedOrNull(v))throw new Error((0,y.localize)(6,null,l,b));if(S.isObject(v))throw new Error((0,y.localize)(7,null,l,b));return v}throw new Error((0,y.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,g,"command");case"input":return this.resolveFromMap(l,b,g,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,_.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return u||b?(0,_.normalizeDriveLetter)(this.fsPath(m())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(m()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,y.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,l));case"file":return T();case"fileWorkspaceFolder":return o();case"relativeFile":return u||b?h.relative(this.fsPath(m()),T()):T();case"relativeFileDirname":const r=h.dirname(T());if(u||b){const p=h.relative(this.fsPath(m()),r);return p.length===0?".":p}return r;case"fileDirname":return h.dirname(T());case"fileExtname":return h.extname(T());case"fileBasename":return h.basename(T());case"fileBasenameNoExtension":const a=h.basename(T());return a.slice(0,a.length-h.extname(a).length);case"fileDirnameBasename":return h.basename(h.dirname(T()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return h.sep;default:try{const p=b?`${f}:${b}`:f;return this.resolveFromMap(l,p,g,void 0)}catch(p){return l}}}}resolveFromMap(C,l,f,u){if(l&&f){const g=u===void 0?f[l]:f[u+":"+l];if(typeof g=="string")return g;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[100],Ee([0,1,4,169]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var S;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var E;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(E=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var _;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function I(g){const b=g;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=I;var n;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=8]="EDITOR_PIN",g[g.EDITOR_STICKY=9]="EDITOR_STICKY",g[g.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function f(g){const b=g;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=f;function u(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(be[176],Ee([0,1,4,100]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(E){const A=E;return typeof E=="number"||(0,R.isEditorGroup)(A)}e.isPreferredGroup=S}),define(be[9],Ee([0,1,17,83,233,57,23,10,2,31,61,146,92,68,72,73,176,7]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var T;(function(_e){function ke(H){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:tt,positionColumn:Ge}=H,ct=new w.Position(Fe-1,Te-1),yt=new w.Position(tt-1,Ge-1);return new w.Selection(ct,yt)}_e.to=ke;function Y(H){const{anchor:Fe,active:Te}=H;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}_e.from=Y})(T=e.Selection||(e.Selection={}));var o;(function(_e){function ke(H){if(!H)return;const{start:Fe,end:Te}=H;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}_e.from=ke;function Y(H){if(!H)return;const{startLineNumber:Fe,startColumn:Te,endLineNumber:tt,endColumn:Ge}=H;return new w.Range(Fe-1,Te-1,tt-1,Ge-1)}_e.to=Y})(o=e.Range||(e.Range={}));var m;(function(_e){function ke(Y){switch(Y){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}_e.to=ke})(m=e.TokenType||(e.TokenType={}));var v;(function(_e){function ke(H){return new w.Position(H.lineNumber-1,H.column-1)}_e.to=ke;function Y(H){return{lineNumber:H.line+1,column:H.character+1}}_e.from=Y})(v=e.Position||(e.Position={}));var t;(function(_e){function ke(H){switch(H){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}_e.from=ke;function Y(H){switch(H){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}_e.to=Y})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ke(H){let Fe;return H.code&&((0,_.isString)(H.code)||(0,_.isNumber)(H.code)?Fe=String(H.code):Fe={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Fe,severity:i.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(a.from),tags:Array.isArray(H.tags)?(0,h.coalesce)(H.tags.map(t.from)):void 0}}_e.from=ke;function Y(H){const Fe=new w.Diagnostic(o.to(H),H.message,i.to(H.severity));return Fe.source=H.source,Fe.code=(0,_.isString)(H.code)?H.code:H.code?.value,Fe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(a.to),Fe.tags=H.tags&&(0,h.coalesce)(H.tags.map(t.to)),Fe}_e.to=Y})(r=e.Diagnostic||(e.Diagnostic={}));var a;(function(_e){function ke(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}_e.from=ke;function Y(H){return new w.DiagnosticRelatedInformation(new w.Location(H.resource,o.to(H)),H.message)}_e.to=Y})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ke(H){switch(H){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ke;function Y(H){switch(H){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}_e.to=Y})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(_e){function ke(H){return typeof H=="number"&&H>=w.ViewColumn.One?H-1:H===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}_e.from=ke;function Y(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=Y})(c=e.ViewColumn||(e.ViewColumn={}));function p(_e){return typeof _e.range!="undefined"}function d(_e){return _e.length===0?!0:!!p(_e[0])}e.isDecorationOptionsArr=d;var D;(function(_e){function ke(Ge){return Ge.map(_e.from)}_e.fromMany=ke;function Y(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function H(Ge){let ct;if(Y(Ge)){const{language:ft,value:dt}=Ge;ct={value:"```"+ft+`
`+dt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const kt=ft=>{try{let dt=y.URI.parse(ft,!0);dt=dt.with({query:Fe(dt.query,yt)}),yt[ft]=dt}catch(dt){}return""},Dt=new S.Renderer;return Dt.link=kt,Dt.image=ft=>kt(R.parseHrefAndDimensions(ft).href),S(ct.value,{renderer:Dt}),ct}_e.from=H;function Fe(Ge,ct){if(!Ge)return Ge;let yt;try{yt=(0,E.parse)(Ge)}catch(Dt){}if(!yt)return Ge;let kt=!1;return yt=(0,A.cloneAndChange)(yt,Dt=>{if(y.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=Dt,kt=!0,ft}else return}),kt?JSON.stringify(yt):Ge}function Te(Ge){const ct=new w.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct}_e.to=Te;function tt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:_e.from(Ge)}_e.fromStrict=tt})(D=e.MarkdownString||(e.MarkdownString={}));function k(_e){return d(_e)?_e.map(ke=>({range:o.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?D.fromMany(ke.hoverMessage):ke.hoverMessage?D.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):_e.map(ke=>({range:o.from(ke)}))}e.fromRangeOrRangeWithMessage=k;function s(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?y.URI.file(_e):_e}e.pathOrURIToURI=s;var P;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?s(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}_e.from=ke})(P=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?s(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?P.from(Y.before):void 0,after:Y.after?P.from(Y.after):void 0}}_e.from=ke})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(_e){function ke(Y){if(typeof Y=="undefined")return Y;switch(Y){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ke})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(_e){function ke(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?x.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?F.from(Y.light):void 0,dark:Y.dark?F.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?s(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?P.from(Y.before):void 0,after:Y.after?P.from(Y.after):void 0}}_e.from=ke})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ae;(function(_e){function ke(H){return{text:H.newText,eol:H.newEol&&ce.from(H.newEol),range:o.from(H.range)}}_e.from=ke;function Y(H){const Fe=new w.TextEdit(o.to(H.range),H.text);return Fe.newEol=typeof H.eol=="undefined"?void 0:ce.to(H.eol),Fe}_e.to=Y})(ae=e.TextEdit||(e.TextEdit={}));var oe;(function(_e){function ke(H,Fe,Te){const tt={edits:[]};if(H instanceof w.WorkspaceEdit)for(let Ge of H._allEntries())if(Ge._type===1)tt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ct=Fe?.getDocument(Ge.uri);tt.edits.push({_type:2,resource:Ge.uri,edit:ae.from(Ge.edit),modelVersionId:ct?.version,metadata:Ge.metadata})}else Ge._type===3?tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Te?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Te?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(B.from)}});return tt}_e.from=ke;function Y(H){const Fe=new w.WorkspaceEdit;for(const Te of H.edits)Te.edit?Fe.replace(y.URI.revive(Te.resource),o.to(Te.edit.range),Te.edit.text):Fe.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Fe}_e.to=Y})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(_e){const ke=Object.create(null);ke[w.SymbolKind.File]=0,ke[w.SymbolKind.Module]=1,ke[w.SymbolKind.Namespace]=2,ke[w.SymbolKind.Package]=3,ke[w.SymbolKind.Class]=4,ke[w.SymbolKind.Method]=5,ke[w.SymbolKind.Property]=6,ke[w.SymbolKind.Field]=7,ke[w.SymbolKind.Constructor]=8,ke[w.SymbolKind.Enum]=9,ke[w.SymbolKind.Interface]=10,ke[w.SymbolKind.Function]=11,ke[w.SymbolKind.Variable]=12,ke[w.SymbolKind.Constant]=13,ke[w.SymbolKind.String]=14,ke[w.SymbolKind.Number]=15,ke[w.SymbolKind.Boolean]=16,ke[w.SymbolKind.Array]=17,ke[w.SymbolKind.Object]=18,ke[w.SymbolKind.Key]=19,ke[w.SymbolKind.Null]=20,ke[w.SymbolKind.EnumMember]=21,ke[w.SymbolKind.Struct]=22,ke[w.SymbolKind.Event]=23,ke[w.SymbolKind.Operator]=24,ke[w.SymbolKind.TypeParameter]=25;function Y(Fe){return typeof ke[Fe]=="number"?ke[Fe]:6}_e.from=Y;function H(Fe){for(const Te in ke)if(ke[Te]===Fe)return Number(Te);return w.SymbolKind.Property}_e.to=H})(V=e.SymbolKind||(e.SymbolKind={}));var W;(function(_e){function ke(H){switch(H){case w.SymbolTag.Deprecated:return 1}}_e.from=ke;function Y(H){switch(H){case 1:return w.SymbolTag.Deprecated}}_e.to=Y})(W=e.SymbolTag||(e.SymbolTag={}));var L;(function(_e){function ke(H){return{name:H.name,kind:V.from(H.kind),tags:H.tags&&H.tags.map(W.from),containerName:H.containerName,location:$.from(H.location)}}_e.from=ke;function Y(H){const Fe=new w.SymbolInformation(H.name,V.to(H.kind),H.containerName,$.to(H.location));return Fe.tags=H.tags&&H.tags.map(W.to),Fe}_e.to=Y})(L=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(_e){function ke(H){const Fe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:V.from(H.kind),tags:H.tags?.map(W.from)??[]};return H.children&&(Fe.children=H.children.map(ke)),Fe}_e.from=ke;function Y(H){const Fe=new w.DocumentSymbol(H.name,H.detail,V.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,h.isNonEmptyArray)(H.tags)&&(Fe.tags=H.tags.map(W.to)),H.children&&(Fe.children=H.children.map(Y)),Fe}_e.to=Y})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var O;(function(_e){function ke(H){const Fe=new w.CallHierarchyItem(V.to(H.kind),H.name,H.detail||"",y.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}_e.to=ke;function Y(H,Fe,Te){if(Fe=Fe??H._sessionId,Te=Te??H._itemId,Fe===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Te,name:H.name,detail:H.detail,kind:V.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(W.from)}}_e.from=Y})(O=e.CallHierarchyItem||(e.CallHierarchyItem={}));var G;(function(_e){function ke(Y){return new w.CallHierarchyIncomingCall(O.to(Y.from),Y.fromRanges.map(H=>o.to(H)))}_e.to=ke})(G=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(_e){function ke(Y){return new w.CallHierarchyOutgoingCall(O.to(Y.to),Y.fromRanges.map(H=>o.to(H)))}_e.to=ke})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(_e){function ke(H){return{range:H.range&&o.from(H.range),uri:H.uri}}_e.from=ke;function Y(H){return new w.Location(y.URI.revive(H.uri),o.to(H.range))}_e.to=Y})($=e.location||(e.location={}));var ne;(function(_e){function ke(H){const Fe=H,Te=H;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:o.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}_e.from=ke;function Y(H){return{targetUri:y.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}_e.to=Y})(ne=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(_e){function ke(H){return{range:o.from(H.range),contents:D.fromMany(H.contents)}}_e.from=ke;function Y(H){return new w.Hover(H.contents.map(D.to),o.to(H.range))}_e.to=Y})(he=e.Hover||(e.Hover={}));var ye;(function(_e){function ke(H){return{range:o.from(H.range),expression:H.expression}}_e.from=ke;function Y(H){return new w.EvaluatableExpression(o.to(H.range),H.expression)}_e.to=Y})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(_e){function ke(H){if(H instanceof w.InlineValueText)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof w.InlineValueVariableLookup)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ke;function Y(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}_e.to=Y})(Ne=e.InlineValue||(e.InlineValue={}));var Me;(function(_e){function ke(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}_e.from=ke;function Y(H){return new w.InlineValueContext(H.frameId,o.to(H.stoppedLocation))}_e.to=Y})(Me=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(_e){function ke(H){return{range:o.from(H.range),kind:H.kind}}_e.from=ke;function Y(H){return new w.DocumentHighlight(o.to(H.range),H.kind)}_e.to=Y})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(_e){function ke(Y){switch(Y){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}_e.to=ke})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(_e){function ke(Y){return{triggerKind:Xe.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}_e.to=ke})(qe=e.CompletionContext||(e.CompletionContext={}));var je;(function(_e){function ke(H){switch(H){case w.CompletionItemTag.Deprecated:return 1}}_e.from=ke;function Y(H){switch(H){case 1:return w.CompletionItemTag.Deprecated}}_e.to=Y})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(_e){const ke=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function Y(Te){return ke.get(Te)??9}_e.from=Y;const H=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Fe(Te){return H.get(Te)??w.CompletionItemKind.Property}_e.to=Fe})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(_e){function ke(Y,H){const Fe=new w.CompletionItem(Y.label);return Fe.insertText=Y.insertText,Fe.kind=U.to(Y.kind),Fe.tags=Y.tags?.map(je.to),Fe.detail=Y.detail,Fe.documentation=R.isMarkdownString(Y.documentation)?D.to(Y.documentation):Y.documentation,Fe.sortText=Y.sortText,Fe.filterText=Y.filterText,Fe.preselect=Y.preselect,Fe.commitCharacters=Y.commitCharacters,I.Range.isIRange(Y.range)?Fe.range=o.to(Y.range):typeof Y.range=="object"&&(Fe.range={inserting:o.to(Y.range.insert),replacing:o.to(Y.range.replace)}),Fe.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?Fe.insertText=new w.SnippetString(Y.insertText):(Fe.insertText=Y.insertText,Fe.textEdit=Fe.range instanceof w.Range?new w.TextEdit(Fe.range,Fe.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Y.additionalTextEdits.map(Te=>ae.to(Te))),Fe.command=H&&Y.command?H.fromInternal(Y.command):void 0,Fe}_e.to=ke})(K=e.CompletionItem||(e.CompletionItem={}));var X;(function(_e){function ke(H){return{label:H.label,documentation:H.documentation?D.fromStrict(H.documentation):void 0}}_e.from=ke;function Y(H){return{label:H.label,documentation:R.isMarkdownString(H.documentation)?D.to(H.documentation):H.documentation}}_e.to=Y})(X=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(_e){function ke(H){return{label:H.label,documentation:H.documentation?D.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(X.from):[],activeParameter:H.activeParameter}}_e.from=ke;function Y(H){return{label:H.label,documentation:R.isMarkdownString(H.documentation)?D.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(X.to):[],activeParameter:H.activeParameter}}_e.to=Y})(re=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function ke(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(re.from):[]}}_e.from=ke;function Y(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(re.to):[]}}_e.to=Y})(q=e.SignatureHelp||(e.SignatureHelp={}));var ie;(function(_e){function ke(H){return{text:H.text,position:v.from(H.position),kind:ge.from(H.kind??w.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}_e.from=ke;function Y(H){const Fe=new w.InlayHint(H.text,v.to(H.position),ge.to(H.kind));return Fe.whitespaceAfter=H.whitespaceAfter,Fe.whitespaceBefore=H.whitespaceBefore,Fe}_e.to=Y})(ie=e.InlayHint||(e.InlayHint={}));var ge;(function(_e){function ke(H){return H}_e.from=ke;function Y(H){return H}_e.to=Y})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(_e){function ke(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}_e.from=ke;function Y(H){let Fe;if(H.url)try{Fe=typeof H.url=="string"?y.URI.parse(H.url,!0):y.URI.revive(H.url)}catch(Te){}return new w.DocumentLink(o.to(H.range),Fe)}_e.to=Y})(Re=e.DocumentLink||(e.DocumentLink={}));var We;(function(_e){function ke(H){const Fe=new w.ColorPresentation(H.label);return H.textEdit&&(Fe.textEdit=ae.to(H.textEdit)),H.additionalTextEdits&&(Fe.additionalTextEdits=H.additionalTextEdits.map(Te=>ae.to(Te))),Fe}_e.to=ke;function Y(H){return{label:H.label,textEdit:H.textEdit?ae.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Fe=>ae.from(Fe)):void 0}}_e.from=Y})(We=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function ke(H){return new w.Color(H[0],H[1],H[2],H[3])}_e.to=ke;function Y(H){return[H.red,H.green,H.blue,H.alpha]}_e.from=Y})(ve=e.Color||(e.Color={}));var Je;(function(_e){function ke(H){return{range:o.from(H.range)}}_e.from=ke;function Y(H){return new w.SelectionRange(o.to(H.range))}_e.to=Y})(Je=e.SelectionRange||(e.SelectionRange={}));var z;(function(_e){function ke(Y){switch(Y){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}_e.to=ke})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(_e){function ke(H){switch(H){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ke;function Y(H){switch(H){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}_e.to=Y})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(_e){function ke(H){if(H===w.EndOfLine.CRLF)return 1;if(H===w.EndOfLine.LF)return 0}_e.from=ke;function Y(H){if(H===1)return w.EndOfLine.CRLF;if(H===0)return w.EndOfLine.LF}_e.to=Y})(ce=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(_e){function ke(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ke})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(_e){function ke(Y){const H={start:Y.start+1,end:Y.end+1};return Y.kind&&(H.kind=et.from(Y.kind)),H}_e.from=ke})(xe=e.FoldingRange||(e.FoldingRange={}));var et;(function(_e){function ke(Y){if(Y)switch(Y){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}_e.from=ke})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var De;(function(_e){function ke(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?o.from(Y.selection):void 0,override:typeof Y.override=="boolean"?C.EditorResolution.DISABLED:void 0}}_e.from=ke})(De=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(_e){function ke(H){return H instanceof w.RelativePattern||typeof H=="string"?H:Y(H)?new w.RelativePattern(H.base,H.pattern):H}_e.from=ke;function Y(H){const Fe=H;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Se=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(_e){function ke(Y){if(Y){if(Array.isArray(Y))return Y.map(ke);if(typeof Y=="string")return Y;{const H=Y;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:Se.from(H.pattern),exclusive:H.exclusive}}}else return}_e.from=ke})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(_e){function ke(H){return{start:H.start,end:H.end}}_e.from=ke;function Y(H){return new w.NotebookRange(H.start,H.end)}_e.to=Y})(se=e.NotebookRange||(e.NotebookRange={}));var le;(function(_e){function ke(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}_e.to=ke;function Y(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}_e.from=Y})(le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var fe;(function(_e){function ke(H){switch(H){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}_e.from=ke;function Y(H){switch(H){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}_e.to=Y})(fe=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(_e){function ke(H){const Fe={metadata:H.metadata??Object.create(null),cells:[]};for(let Te of H.cells)w.NotebookCellData.validate(Te),Fe.cells.push(B.from(Te));return Fe}_e.from=ke;function Y(H){const Fe=new w.NotebookData(H.cells.map(B.to));return(0,_.isEmptyObject)(H.metadata)||(Fe.metadata=H.metadata),Fe}_e.to=Y})(pe=e.NotebookData||(e.NotebookData={}));var B;(function(_e){function ke(H){return{cellKind:fe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:le.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(we.from):[]}}_e.from=ke;function Y(H){return new w.NotebookCellData(fe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(we.to):void 0,H.metadata,H.internalMetadata?le.to(H.internalMetadata):void 0)}_e.to=Y})(B=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(_e){function ke(H){return{mime:H.mime,valueBytes:Array.from(H.data)}}_e.from=ke;function Y(H){return new w.NotebookCellOutputItem(new Uint8Array(H.valueBytes),H.mime)}_e.to=Y})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var we;(function(_e){function ke(H){return{outputId:H.id,items:H.items.map(me.from),metadata:H.metadata}}_e.from=ke;function Y(H){const Fe=H.items.map(me.to);return new w.NotebookCellOutput(Fe,H.outputId,H.metadata)}_e.to=Y})(we=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(_e){function ke(Te){if(Te!=null){if(Te instanceof w.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new w.RelativePattern(Te.base,Te.pattern);if(H(Te))return{include:Se.from(Te.include)||void 0,exclude:Se.from(Te.exclude)||void 0}}}_e.from=ke;function Y(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}_e.to=Y;function H(Te){const tt=Te,Ge=Se.from(tt.include);if(!(Ge&&Ge instanceof w.RelativePattern||typeof Ge=="string"))return!1;const ct=Se.from(tt.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function Fe(Te){const tt=Te;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(_e){function ke(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?P.from(Y.top):void 0}}_e.from=ke})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var He;(function(_e){function ke(Y,H,Fe){const Te=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Te,Fe),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}_e.from=ke})(He=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(_e){function ke(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}_e.from=ke})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ke;(function(_e){function ke(H){return{uri:H.uri,provides:H.provides}}_e.from=ke;function Y(H){return new w.NotebookRendererScript(y.URI.revive(H.uri),H.provides)}_e.to=Y})(Ke=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Qe;(function(_e){function ke(H){return{message:D.fromStrict(H.message)||"",severity:w.TestMessageSeverity.Error,expectedOutput:H.expectedOutput,actualOutput:H.actualOutput,location:H.location?$.from(H.location):void 0}}_e.from=ke;function Y(H){const Fe=new w.TestMessage(typeof H.message=="string"?H.message:D.to(H.message));return Fe.actualOutput=H.actualOutput,Fe.expectedOutput=H.expectedOutput,Fe}_e.to=Y})(Qe=e.TestMessage||(e.TestMessage={}));var ut;(function(_e){function ke(Te){return{extId:g.TestId.fromExtHostTestItem(Te,(0,f.getPrivateApiFor)(Te).controllerId).toString(),label:Te.label,uri:Te.uri,range:o.from(Te.range)||null,description:Te.description||null,error:Te.error&&D.fromStrict(Te.error)||null}}_e.from=ke;function Y(Te){return{id:g.TestId.fromString(Te.extId).localId,label:Te.label,uri:y.URI.revive(Te.uri),range:o.to(Te.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Te.description||void 0}}_e.toPlain=Y;function H(Te){const tt=g.TestId.fromString(Te.extId),Ge=new f.TestItemImpl(tt.controllerId,tt.localId,Te.label,y.URI.revive(Te.uri));return Ge.range=o.to(Te.range||void 0),Ge.description=Te.description||void 0,Ge}function Fe(Te){let tt;for(const Ge of Te.tests){const ct=H(Ge.item);(0,f.getPrivateApiFor)(ct).parent=tt,tt=ct}return tt}_e.toItemFromContext=Fe})(ut=e.TestItem||(e.TestItem={}));var mt;(function(_e){const ke=(H,Fe)=>{const Te={...ut.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Qe.to)})),children:H.children.map(tt=>Fe.get(tt)).filter(_.isDefined).map(tt=>ke(tt,Fe))};for(const tt of Te.children)tt.parent=Te;return Te};function Y(H){const Fe=[],Te=new Map;for(const tt of H.items)Te.set(tt.item.extId,tt),H.request.targets.some(Ge=>Ge.controllerId===tt.controllerId&&Ge.testIds.includes(tt.item.extId))&&Fe.push(tt);return{completedAt:H.completedAt,results:Fe.map(tt=>ke(tt,Te))}}_e.to=Y})(mt=e.TestResults||(e.TestResults={}));var bt;(function(_e){function ke(Te){return{covered:Te.covered,total:Te.covered}}function Y(Te){return"line"in Te?v.from(Te):o.from(Te)}function H(Te){return"branches"in Te?{count:Te.executionCount,location:Y(Te.location),type:1,branches:Te.branches.length?Te.branches.map(tt=>({count:tt.executionCount,location:tt.location&&Y(tt.location)})):void 0}:{type:0,count:Te.executionCount,location:Y(Te.location)}}_e.fromDetailed=H;function Fe(Te){return{uri:Te.uri,statement:ke(Te.statementCoverage),branch:Te.branchCoverage&&ke(Te.branchCoverage),function:Te.functionCoverage&&ke(Te.functionCoverage),details:Te.detailedCoverage?.map(H)}}_e.fromFile=Fe})(bt=e.TestCoverage||(e.TestCoverage={}));var ot;(function(_e){function ke(Y){switch(Y){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}_e.to=ke})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(_e){function ke(H){const Fe=new w.TypeHierarchyItem(V.to(H.kind),H.name,H.detail||"",y.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}_e.to=ke;function Y(H,Fe,Te){if(Fe=Fe??H._sessionId,Te=Te??H._itemId,Fe===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Te,kind:V.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(W.from)}}_e.from=Y})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[177],Ee([0,1,2,12,7,9,80]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class _{constructor(I,n,C,l={timeout:1500,errors:3}){this._logService=I,this._documents=n,this._mainThreadBulkEdits=C,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(n,C,l)=>{const u={dispose:this._callbacks.push([n,C,I])};return Array.isArray(l)&&l.push(u),u}}async $participateInSave(I,n){const C=h.URI.revive(I);let l=!1;const f=setTimeout(()=>l=!0,this._thresholds.timeout),u=[];try{for(let g of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(g,{document:b,reason:E.TextDocumentSaveReason.to(n)});u.push(w)}}finally{clearTimeout(f)}return u}_deliverEventAsyncAndBlameBadListeners([I,n,C],l){const f=this._badListeners.get(I);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,I,n,l).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const g=this._badListeners.get(I);this._badListeners.set(I,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,n,C,l){const f=[],u=Date.now(),{document:g,reason:b}=l,{version:w}=g,T=Object.freeze({document:g,reason:b,waitUntil(o){if(Object.isFrozen(f))throw(0,R.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(o))}});try{n.apply(C,[T])}catch(o){return Promise.reject(o)}return Object.freeze(f),new Promise((o,m)=>{const v=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),o(t)}).catch(t=>{clearTimeout(v),m(t)})}).then(o=>{const m={edits:[]};for(const v of o)if(Array.isArray(v)&&v.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:a}of v)m.edits.push({_type:2,resource:g.uri,edit:{range:a&&E.Range.from(a),text:t,eol:r&&E.EndOfLine.from(r)}});if(m.edits.length!==0)return w===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=_}),define(be[178],Ee([0,1,3,27,2,9,7]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(n,C,l,f,u){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,l&&(this._config+=1),f&&(this._config+=2),u&&(this._config+=4);const g=(0,R.parse)(C),b=n(w=>{if(!l)for(let T of w.created){const o=S.URI.revive(T);g(o.fsPath)&&this._onDidCreate.fire(o)}if(!f)for(let T of w.changed){const o=S.URI.revive(T);g(o.fsPath)&&this._onDidChange.fire(o)}if(!u)for(let T of w.deleted){const o=S.URI.revive(T);g(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,C,l){this._logService=C,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,C,l,f){return new _(this._onFileSystemEvent.event,n,C,l,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,C){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(l=>S.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:C.map(l=>S.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,C){return(l,f,u)=>{const g=function(w){l.call(f,w)};return g.extension=n,C.event(g,void 0,u)}}async $onWillRunFileOperation(n,C,l,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(u=>({oldUri:S.URI.revive(u.source),newUri:S.URI.revive(u.target)}))},l,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(u=>S.URI.revive(u.target))},l,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(u=>S.URI.revive(u.target))},l,f)}}async _fireWillEvent(n,C,l,f){const u=new Set,g=[];if(await n.fireAsync(C,f,async(w,T)=>{const o=Date.now(),m=await Promise.resolve(w);m instanceof A.WorkspaceEdit&&(g.push(m),u.add(T.extension.displayName??T.extension.identifier.value)),Date.now()-o>l&&this._logService.warn("SLOW file-participant",T.extension.identifier)}),f.isCancellationRequested||g.length===0)return;const b={edits:[]};for(let w of g){let{edits:T}=E.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(T)}return{edit:b,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=y}),define(be[179],Ee([0,1,11,23,2,9,7,72]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(l,f,u,g){this.start=l,this.deletedCount=f,this.deletedItems=u,this.items=g}static asApiEvents(l){return l.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(u=>u.apiCell)}))}}class I{constructor(l,f,u){this.notebook=l,this._extHostDocument=f,this._cellData=u,this.handle=u.handle,this.uri=S.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(E.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(l,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return l._mime},set mime(u){l._mime=u},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(E.NotebookCellOutput.to)}setOutputItems(l,f,u){const g=u.map(E.NotebookCellOutputItem.to),b=this._outputs.find(w=>w.id===l);b&&(f||(b.items.length=0),b.items.push(...g))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(E.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=I;class n{constructor(l,f,u,g,b,w){this._proxy=l,this._textDocumentsAndEditors=f,this._textDocuments=u,this._emitter=g,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===h.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(f){return f=l._validateIndex(f),l._cells[f].apiCell},getCells(f){return(f?l._getCells(f):l._cells).map(g=>g.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,f){this._versionId=l.versionId,this._isDirty=f;for(const u of l.rawEvents)u.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===_.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===_.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===_.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===_.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===_.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let f=l.start|0,u=l.end|0;return f<0&&(f=0),u>this._cells.length&&(u=this._cells.length),l.with({start:f,end:u})}_getCells(l){l=this._validateRange(l);const f=[];for(let u=l.start;u<l.end;u++)f.push(this._cells[u]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,f){if(this._disposed)return;const u=[],g=[],b=[];l.reverse().forEach(w=>{const o=w[2].map(t=>{const r=new I(this,this._textDocumentsAndEditors,t);return f||g.push(I.asModelAddData(this.apiNotebook,t)),r}),m=new y(w[0],w[1],[],o),v=this._cells.splice(w[0],w[1],...o);for(const t of v)b.push(t.uri),m.deletedItems.push(t.apiCell);u.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:b}),f||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(u)}))}_moveCell(l,f){const u=this._cells.splice(l,1);this._cells.splice(f,0,...u);const g=[new y(l,1,u.map(b=>b.apiCell),[]),new y(f,0,[],u)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(g)}))}_setCellOutputs(l,f){const u=this._cells[l];u.setOutputs(f),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(l,f,u,g){const b=this._cells[l];b.setOutputItems(f,u,g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(l,f){const u=this._cells[l];u.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(u.uri,f)}_changeCellMime(l,f){const u=this._cells[l];u.apiCell.mime=f}_changeCellMetadata(l,f){const u=this._cells[l],g=u.apiCell.metadata;u.setMetadata(f);const b=u.apiCell.metadata;(0,R.equals)(g,b)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(l,f){const u=this._cells[l],g=u.internalMetadata;if(u.setInternalMetadata(f),g.runState!==f.runState){const b=f.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(f=>f.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(f=>f.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[101],Ee([0,1,7,9,12]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class E{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:I})}replaceCells(y,I,n){this._throwIfFinalized(),!(y===I&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:I-y,cells:n.map(R.NotebookCellData.from)})}}class A{constructor(y,I,n,C,l,f){this.id=y,this._proxy=I,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=C,this._viewColumn=f}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(I){if(!Array.isArray(I)||!I.every(h.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");y._selections=I,y._trySetSelections(I)},get visibleRanges(){return y._visibleRanges},revealRange(I,n){y._proxy.$tryRevealRange(y.id,R.NotebookRange.from(I),n??h.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(I){const n=new E(this.document.version);return I(n),y._applyEdit(n.finalize())},setDecorations(I,n){return y.setDecorations(I,n)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(R.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const I=[];let n=-1;for(let C=0;C<y.cellEdits.length;C++){if(n<0){I.push(y.cellEdits[C]),n++;continue}const f=I[n],u=y.cellEdits[C];if(f.editType===1&&u.editType===1&&f.index===u.index){f.cells.push(...y.cellEdits[C].cells),f.count+=y.cellEdits[C].count;continue}I.push(y.cellEdits[C]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,I)}setDecorations(y,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return I.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(I),y.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(be[180],Ee([0,1,9,156,135,20,52]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,l,f){const u=this._handles++,{title:g,location:b,cancellable:w}=l,T={label:(0,S.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(u,{location:h.ProgressLocation.from(b),title:g,source:T,cancellable:w},C),this._withProgress(u,f,!!w)}_withProgress(C,l,f){let u;f&&(u=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,u));const g=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let b;try{b=l(new I(this._proxy,C),f&&u?u.token:E.CancellationToken.None)}catch(w){throw g(C),w}return b.then(w=>g(C),w=>g(C)),b}$acceptProgressCanceled(C){const l=this._mapHandleToCancellationSource.get(C);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=_;function y(n,C){return n.message=C.message,typeof C.increment=="number"&&(typeof n.increment=="number"?n.increment+=C.increment:n.increment=C.increment),n}class I extends R.Progress{constructor(C,l){super(f=>this.throttledReport(f));this._proxy=C,this._handle=l}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}ze([(0,A.throttle)(100,(n,C)=>y(n,C),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(be[102],Ee([0,1,41,12,54,9,7]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class _{constructor(l,f,u){const g=_._Keys.nextId();l.$registerTextEditorDecorationType(f.identifier,g,E.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=_,_._Keys=new S.IdGenerator("TextEditorDecorationType");class y{constructor(l,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,f){this._throwIfFinalized();let u=null;if(l instanceof A.Position)u=new A.Range(l,l);else if(l instanceof A.Range)u=l;else throw new Error("Unrecognized location");this._pushEdit(u,f,!1)}insert(l,f){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),f,!0)}delete(l){this._throwIfFinalized();let f=null;if(l instanceof A.Range)f=l;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(l,f,u){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:f,forceMoveMarkers:u})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=y;class I{constructor(l,f,u,g){this._proxy=l,this._id=f,this._accept(u),this._logService=g;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(w){b._setTabSize(w)},get insertSpaces(){return b._insertSpaces},set insertSpaces(w){b._setInsertSpaces(w)},get cursorStyle(){return b._cursorStyle},set cursorStyle(w){b._setCursorStyle(w)},get lineNumbers(){return b._lineNumbers},set lineNumbers(w){b._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const f=Math.floor(l);return f>0?f:null}if(typeof l=="string"){const f=parseInt(l,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(l){const f=this._validateTabSize(l);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const f=this._validateInsertSpaces(l);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(l)})))}assign(l){const f={};let u=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(u=!0,f.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,u=!0,f.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(u=!0,f.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,u=!0,f.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,u=!0,f.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,u=!0,f.lineNumbers=E.TextEditorLineNumbersStyle.from(l.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(l){l.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=I;class n{constructor(l,f,u,g,b,w,T,o){this.id=l,this._proxy=f,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new I(this._proxy,this.id,w,u),this._visibleRanges=T,this._viewColumn=o;const m=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return m._selections&&m._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,R.illegalArgument)("selection");m._selections=[v],m._trySetSelection()},get selections(){return m._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof A.Selection)))throw(0,R.illegalArgument)("selections");m._selections=v,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return m._options.value},set options(v){m._disposed||m._options.assign(v)},get viewColumn(){return m._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(g.getValue(),t);return v(r),m._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=m._selections.map(i=>E.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:c}=E.Position.from(t);a=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof A.Range)a=[E.Range.from(t)];else{a=[];for(const i of t)if(i instanceof A.Range)a.push(E.Range.from(i));else{const{lineNumber:c,column:p}=E.Position.from(i);a.push({startLineNumber:c,startColumn:p,endLineNumber:c,endColumn:p})}}return f.$tryInsertSnippet(l,v.value,a,r)},setDecorations(v,t){const r=t.length===0;r&&!m._hasDecorationsForKey.has(v.key)||(r?m._hasDecorationsForKey.delete(v.key):m._hasDecorationsForKey.add(v.key),m._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return f.$trySetDecorations(l,v.key,E.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const p=t[i];a[4*i]=p.start.line+1,a[4*i+1]=p.start.character+1,a[4*i+2]=p.end.line+1,a[4*i+3]=p.end.character+1}return f.$trySetDecorationsFast(l,v.key,a)}}))},revealRange(v,t){m._runOnProxy(()=>f.$tryRevealRange(l,E.Range.from(v),t||A.TextEditorRevealType.Default))},show(v){f.$tryShowEditor(l,E.ViewColumn.from(v))},hide(){f.$tryHideEditor(l)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,h.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,h.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,h.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,h.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const f=l.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const u=f.edits.map(b=>b.range);u.sort((b,w)=>b.end.line===w.end.line?b.end.character===w.end.character?b.start.line===w.start.line?b.start.character-w.start.character:b.start.line-w.start.line:b.end.character-w.end.character:b.end.line-w.end.line);for(let b=0,w=u.length-1;b<w;b++){const T=u[b].end;if(u[b+1].start.isBefore(T))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=f.edits.map(b=>({range:E.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,g,{setEndOfLine:typeof f.setEndOfLine=="number"?E.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(be[181],Ee([0,1,138,25,2,3,6,170,15,7,10,17,9,20,167]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(T,o){if((0,n.isString)(T))return{label:T};if(T&&typeof T=="object"&&typeof T.label=="string"){let m;return Array.isArray(T.highlights)&&(m=T.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),m=m.length?m:void 0),{label:T.label,highlights:m}}}class b{constructor(o,m,v){this._proxy=o,this.commands=m,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(a=>t(a)?this.convertArgument(a):a):r})}registerTreeDataProvider(o,m,v){const t=this.createTreeView(o,{treeDataProvider:m},v);return{dispose:()=>t.dispose()}}createTreeView(o,m,v){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=m.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,canDragAndDrop:t}),a=this.createExtHostTreeView(o,m,v);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(i){a.message=i},get title(){return a.title},set title(i){a.title=i},get description(){return a.description},set description(i){a.description=i},reveal:(i,c)=>a.reveal(i,c),dispose:async()=>{await r,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,m){const v=this.treeViews.get(o);return v?v.getChildren(m):Promise.reject(new Error((0,h.localize)(0,null,o)))}async $onDrop(o,m,v){const t=this.treeViews.get(o);if(!t)return Promise.reject(new Error((0,h.localize)(1,null,o)));const r=u.TreeDataTransferConverter.toITreeDataTransfer(m);if(r.items.has(_.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(_.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?r.items.set(_.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(_.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(o){const m=this.treeViews.get(o);if(!m)throw new Error((0,h.localize)(2,null,o));return m.hasResolve}$resolve(o,m,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,h.localize)(3,null,o));return t.resolveTreeItem(m,v)}$setExpanded(o,m,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,h.localize)(4,null,o));t.setExpanded(m,v)}$setSelection(o,m){const v=this.treeViews.get(o);if(!v)throw new Error((0,h.localize)(5,null,o));v.setSelection(m)}$setVisible(o,m){const v=this.treeViews.get(o);if(!v)throw new Error((0,h.localize)(6,null,o));v.setVisible(m)}createExtHostTreeView(o,m,v){const t=new w(o,m,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(o,t),t}convertArgument(o){const m=this.treeViews.get(o.$treeViewId);return m?m.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=b;class w extends A.Disposable{constructor(o,m,v,t,r,a){super();if(this.viewId=o,this.proxy=v,this.commands=t,this.logService=r,this.extension=a,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,a.contributes&&a.contributes.views)for(const p in a.contributes.views)for(const d of a.contributes.views[p])d.id===o&&(this._title=d.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let i,c;this._register(E.Event.debounce(this._onDidChangeData.event,(p,d)=>(p||(p={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(D=>c=D),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?p.elements.push(...d.element):p.elements.push(d.element)),d.message&&(p.message=!0),p),200,!0)(({message:p,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=c;return i=null,this.refresh(d).then(()=>D())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,n.isUndefinedOrNull)(o))}getChildren(o){const m=o?this.getExtensionElement(o):void 0;if(o&&!m)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(o);return(v?Promise.resolve(v):this.fetchChildrenNodes(m)).then(t=>t.map(r=>r.item))}getExtensionElement(o){return this.elements.get(o)}reveal(o,m){m=m||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(m.select)?!0:m.select,t=(0,n.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,n.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:a.map(c=>c.item)},{select:v,focus:t,expand:r})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,m){const v=this.getExtensionElement(o);v&&(m?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(o){(0,C.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,m){const v=this.getExtensionElement(m);if(!!v)return(0,y.asPromise)(()=>this.dndController?.onDrop(o,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,m){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(o);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,m)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(m=>m?this.resolveUnknownParentChain(m).then(v=>this.resolveTreeNode(m,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(o){const m=this.nodes.get(o);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,m){const v=this.nodes.get(o);return v?Promise.resolve(v):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>this.createHandle(o,t,m,!0)).then(t=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const a=this.nodes.get(r);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(o){if(o){let m;if(typeof o=="string"){const v=this.getExtensionElement(o);m=v?this.nodes.get(v):void 0}else m=o;return m&&m.children||null}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const m=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=o?this.nodes.get(o):void 0,t=await this.dataProvider.getChildren(o);if(m.token.isCancellationRequested)return[];const r=await Promise.all((0,C.coalesce)(t||[]).map(async a=>{const i=await this.dataProvider.getTreeItem(a);return i&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(a,i,v):null}));return m.token.isCancellationRequested?[]:(0,C.coalesce)(r)}finally{m.dispose()}}refresh(o){if(o.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(o);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const m=new Set,v=o.map(r=>this.nodes.get(r));for(const r of v)if(r&&!m.has(r.item.handle)){let a=r;for(;a&&a.parent&&v.findIndex(i=>a&&a.parent&&i&&i.item.handle===a.parent.item.handle)===-1;){const i=this.elements.get(a.parent.item.handle);a=i?this.nodes.get(i):void 0}a&&!a.parent&&m.add(r.item.handle)}const t=[];return m.forEach(r=>{const a=this.elements.get(r);if(a){const i=this.nodes.get(a);i&&(!i.parent||!m.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(o){const m={};return Promise.all(o.map(v=>this.refreshNode(v).then(t=>{t&&(m[v]=t.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(o){const m=this.getExtensionElement(o);if(m){const v=this.nodes.get(m);if(v)return this.clearChildren(m),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(t=>{if(t){const r=this.createTreeNode(m,t,v.parent);return this.updateNodeCache(m,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,m,v){const t=this.createTreeNode(o,m,v);if(m.id&&this.elements.has(t.item.handle))throw new Error((0,h.localize)(7,null,m.id));return this.addNodeToCache(o,t),this.addNodeToParentCache(t,v),t}getTooltip(o){return I.MarkdownString.isMarkdownString(o)?l.MarkdownString.from(o):o}getCommand(o,m){return m?this.commands.toInternal(m,o):void 0}createTreeNode(o,m,v){const t=new A.DisposableStore,r=this.createHandle(o,m,v),a=this.getLightIconPath(m);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:g(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(t,m.command),contextValue:m.contextValue,icon:a,iconDark:this.getDarkIconPath(m)||a,themeIcon:this.getThemeIcon(m),collapsibleState:(0,n.isUndefinedOrNull)(m.collapsibleState)?I.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(o){return o.iconPath instanceof I.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:m,label:v,resourceUri:t},r,a){if(m)return`${w.ID_HANDLE_PREFIX}/${m}`;const i=g(v,this.extension),c=r?r.item.handle:w.LABEL_HANDLE_PREFIX;let p=i?i.label:t?(0,R.basename)(t):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const d=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,D=this.getChildrenNodes(r)||[];let k,s=0;do{if(k=`${c}/${s}:${p}`,a||!this.elements.has(k)||d===k)break;s++}while(s<=D.length);return k}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof I.ThemeIcon))return typeof o.iconPath=="string"||S.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof I.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return S.URI.isUri(o)?o:S.URI.file(o)}addNodeToCache(o,m){this.elements.set(m.item.handle,o),this.nodes.set(o,m)}updateNodeCache(o,m,v,t){this.elements.delete(m.item.handle),this.nodes.delete(o),m.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(o,m);const r=this.getChildrenNodes(t)||[],a=r.filter(i=>i.item.handle===v.item.handle)[0];a&&r.splice(r.indexOf(a),1,m)}addNodeToParentCache(o,m){m?(m.children||(m.children=[]),m.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const m=this.nodes.get(o);if(m){if(m.children)for(const v of m.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}m.children=void 0}}else this.clearAll()}clear(o){const m=this.nodes.get(o);if(m){if(m.children)for(const v of m.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(o),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(be[182],Ee([0,1,15,3,6,10,68,9,99,73]),function(ee,e,h,R,S,E,A,_,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends S.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const f=this.diff[this.diff.length-1];if(f&&l[0]===1){if(f[0]===1&&f[1].extId===l[1].extId){(0,y.applyTestItemUpdate)(f[1],l[1]);return}if(f[0]===0&&f[1].item.extId===l[1].extId){(0,y.applyTestItemUpdate)(f[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,f){const u=this.tree.get(l);if(!!u){if((u.expandLevels===void 0||f>u.expandLevels)&&(u.expandLevels=f),u.expand===1){const g=this.resolveChildren(u);return g.isOpen()?this.expandChildren(u,f-1):g.wait().then(()=>this.expandChildren(u,f-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,f-1)):this.expandChildren(u,f-1)}}dispose(){for(const l of this.tree.values())(0,A.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,f){switch(f.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(l.fullId,f.id));break;case 0:this.upsertItem(f.item,l);break;case 4:for(const w of f.ops)this.onTestItemEvent(l,w);break;case 3:const{key:u,value:g}=f,b=l.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(l);break;case"range":this.pushDiff([1,{extId:b,item:{range:_.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:_.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:g??null}}]);break}break;default:(0,E.assertNever)(f)}}upsertItem(l,f){if(!(l instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const u=I.TestId.fromExtHostTestItem(l,this.root.id,f?.actual),g=(0,A.getPrivateApiFor)(l);g.parent&&g.parent!==f?.actual&&g.parent.children.delete(l.id);let b=this.tree.get(u.toString());if(!b){b={fullId:u,actual:l,parent:f?u.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},this.tree.set(b.fullId.toString(),b),this.setItemParent(l,f),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:_.TestItem.from(l)}]),this.connectItemAndChildren(l,b,f);return}if(b.actual===l){this.connectItem(l,b,f);return}const w=b.actual.children,T=b.actual,o=(0,A.diffTestItems)(T,l);(0,A.getPrivateApiFor)(T).listener=void 0,b.actual=l,b.expand=0;for(const[m,v]of o)this.onTestItemEvent(b,{op:3,key:m,value:v});this.connectItemAndChildren(l,b,f);for(const m of w)l.children.get(m.id)||this.removeItem(I.TestId.joinToString(u,m.id))}setItemParent(l,f){(0,A.getPrivateApiFor)(l).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(l,f,u){this.setItemParent(l,u);const g=(0,A.getPrivateApiFor)(l);g.parent=u?.actual,g.listener=b=>this.onTestItemEvent(f,b),this.updateExpandability(f)}connectItemAndChildren(l,f,u){this.connectItem(l,f,u);for(const g of l.children)this.upsertItem(g,f)}updateExpandability(l){let f;this._resolveHandler?l.resolveBarrier?f=l.resolveBarrier.isOpen()?3:2:f=l.actual.canResolveChildren?1:0:f=0,f!==l.expand&&(l.expand=f,this.pushDiff([1,{extId:l.fullId.toString(),expand:f}]),f===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,f){if(f<0)return;const u=[];for(const g of l.actual.children){const b=this.expand(I.TestId.joinToString(l.fullId,g.id),f);(0,h.isThenable)(b)&&u.push(b)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const b=new h.Barrier;return b.open(),b}l.expand=2,this.pushExpandStateUpdate(l);const f=l.resolveBarrier=new h.Barrier,u=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=b.stack||b.message||String(b))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(b){u(b)}return(0,h.isThenable)(g)?g.catch(u).then(()=>{f.open(),this.updateExpandability(l)}):(f.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const f=this.tree.get(l);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const u=[f];for(;u.length;){const g=u.pop();if(!!g){(0,A.getPrivateApiFor)(g.actual).listener=void 0,this.tree.delete(g.fullId.toString());for(const b of g.actual.children)u.push(this.tree.get(I.TestId.joinToString(g.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(be[183],Ee([0,1,4,151]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(R.IEnvironmentService)}),define(be[184],Ee([0,1,26,3,14]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=E;class A{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let C of n.activationEvents)C==="onUri"&&(C=`onUri:${h.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(n)}}keepOnly(n){const C=new Set;n.forEach(l=>C.add(h.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>C.has(h.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,C){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=A._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(l.map(f=>f.identifier)),C.length>0){const f=new Set;C.forEach(u=>f.add(h.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!f.has(h.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(l)}static _findLoopingExtensions(n){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,w){this.addNode(b),this.addNode(w),this._arcs.has(b)?this._arcs.get(b).push(w):this._arcs.set(b,[w])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,w){const T=C.getArcs(b);for(let o=0;o<T.length;o++)if(!w.has(T[o]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of n){const w=h.ExtensionIdentifier.toKey(b.identifier);if(l.set(w,b),b.extensionDependencies)for(let T of b.extensionDependencies){const o=h.ExtensionIdentifier.toKey(T);C.addArc(w,o)}}let f=new Set;C.getNodes().filter(b=>C.getArcs(b).length===0).forEach(b=>f.add(b));let u=C.getNodes().filter(b=>!f.has(b)),g;do{g=!1;for(let b=0;b<u.length;b++){const w=u[b];C.hasOnlyGoodArcs(w,f)&&(u.splice(b,1),b--,f.add(w),g=!0)}}while(g);return u.map(b=>l.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const C=this._activationMap.get(n);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const C=this._extensionsMap.get(h.ExtensionIdentifier.toKey(n));return C||void 0}}e.ExtensionDescriptionRegistry=A;var _;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(_||(_={}));function y(I,n){const C=I.isBuiltin?0:I.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(C!==l)return C-l;const f=S.posix.basename(I.extensionLocation.path),u=S.posix.basename(n.extensionLocation.path);return f<u?-1:f>u?1:0}}),define(be[185],Ee([0,1,24]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function E(_){const y=h.VSBuffer.alloc(1);switch(_){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=E;function A(_,y){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=A}),define(be[30],Ee([0,1,3,2,4,26,152]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class _{constructor(T){this.dependency=T}}e.MissingExtensionDependency=_;var y;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class I{constructor(T,o,m,v){this.codeLoadingTime=T,this.activateCallTime=o,this.activateResolvedTime=m,this.activationReason=v}}e.ActivationTimes=I;class n{constructor(T,o){this.description=T,this.value=o}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||f(w)}e.checkProposedApiEnabled=l;function f(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=f;function u(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=u;function g(w,T){return{identifier:new E.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!T,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=g;class b{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(T){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(T){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(T){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(T){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(T,o){return Promise.resolve()}_onWillActivateExtension(T){}_onDidActivateExtension(T,o,m,v,t){}_onDidActivateExtensionError(T,o){}_onExtensionRuntimeError(T,o){}_onExtensionHostExit(T){}}e.NullExtensionService=b}),define(be[186],Ee([0,1,26,30,16]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class A{constructor(u,g,b,w){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class _{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,g){return u===-1||g===-1?-1:g-u}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class y{constructor(u,g,b,w,T,o){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=b,this.module=w,this.exports=T,this.subscriptions=o}}e.ActivatedExtension=y;class I extends y{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class n extends y{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class C extends y{constructor(u){super(!0,u,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let l=class{constructor(u,g,b,w,T){this._logService=T,this._registry=u,this._resolvedExtensionsSet=new Set,g.forEach(o=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,b.forEach(o=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(o),o)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const g=h.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(g)}getActivatedExtension(u){const g=h.ExtensionIdentifier.toKey(u),b=this._activatedExtensions.get(g);if(!b)throw new Error("Extension `"+u.value+"` is not known or not activated");return b}activateByEvent(u,g){if(this._alreadyActivatedEvents[u])return E;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:g,extensionId:w.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,g){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:b.identifier,reason:g}])}_handleActivateRequest(u,g,b){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(u.id))){g[h.ExtensionIdentifier.toKey(u.id)]=u;return}const w=this._registry.getExtensionDescription(u.id);if(!w){const m=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,m,new R.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(u.id),new C(m));return}const T=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let o=!0;for(let m=0,v=T.length;m<v;m++){const t=T[m];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const p=w.displayName||w.identifier.value,d=this._registry.getExtensionDescription(t),D=d&&d.displayName||t,k=new Error(`Cannot activate the '${p}' extension because its dependency '${D}' failed to activate`);k.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,k,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(w.identifier),new C(k));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(t))){o=!1,g[h.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const a=this._registry.getExtensionDescription(t);if(a){o=!1,g[h.ExtensionIdentifier.toKey(t)]={id:a.identifier,reason:u.reason};continue}const i=w.displayName||w.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,c,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(w.identifier),new C(c));return}o?g[h.ExtensionIdentifier.toKey(w.identifier)]=u:b.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(T=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(T.id))),u.length===0))return Promise.resolve(void 0);const g=Object.create(null),b=[];for(let T=0,o=u.length;T<o;T++)this._handleActivateRequest(u[T],g,b);for(let T=0,o=b.length;T<o;T++){const m=h.ExtensionIdentifier.toKey(b[T].id);g[m]&&delete g[m]}const w=Object.keys(g).map(T=>g[T]);return b.length===0?Promise.all(w.map(T=>this._activateExtension(T.id,T.reason))).then(T=>{}):this._activateExtensions(w).then(T=>this._activateExtensions(b))}_activateExtension(u,g){const b=h.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const w=this._activatingExtensions.get(b);if(w)return w;const T=this._host.actualActivateExtension(u,g).then(void 0,o=>{const m=new Error;return o&&o.name&&(m.name=o.name),o&&o.message?m.message=`Activating extension '${u.value}' failed: ${o.message}.`:m.message=`Activating extension '${u.value}' failed: ${o}.`,o&&o.stack&&(m.stack=o.stack),this._host.onExtensionActivationError(u,m,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(o),new C(o)}).then(o=>{this._activatedExtensions.set(b,o),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,T),T}};l=ze([Ve(4,S.ILogService)],l),e.ExtensionsActivator=l}),define(be[187],Ee([0,1,12]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,A)=>{this._actualOk=E,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):(0,h.onUnexpectedError)(E))}then(E,A){return this._ensureActual().then(E,A)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=R}),define(be[103],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(y,I){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=I,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const R=[];function S(_){const y=new h(!0,_);return R[y.nid]=y,y}e.createMainContextProxyIdentifier=S;function E(_){const y=new h(!1,_);return R[y.nid]=y,y}e.createExtHostContextProxyIdentifier=E;function A(_){return R[_].sid}e.getStringIdentifierForProxy=A}),define(be[5],Ee([0,1,57,2,103]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var A;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(o){o.name="$ident";function m(t,r){return Object.defineProperty(t,o.name,{value:r,enumerable:!0}),t}o.mixin=m;function v(t){return t[o.name]}o.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(m){return m._id=f._n++,m}}e.IdObject=f,f._n=0;var u;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(o){if(o&&o.edits)for(const m of o.edits)typeof m.resource=="object"?m.resource=R.URI.revive(m.resource):(m.newUri=R.URI.revive(m.newUri),m.oldUri=R.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,h.revive)(m.metadata));return o}e.reviveWorkspaceEditDto=w;var T;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(T=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],Ee([0,1,5,3,4]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(_){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=_.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(_){this._onDidChangePassword.fire(_)}get(_,y){return this._proxy.$getPassword(_,y)}store(_,y,I){return this._proxy.$setPassword(_,y,I)}delete(_,y){return this._proxy.$deletePassword(_,y)}}e.ExtHostSecretState=E,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(be[75],Ee([0,1,4,16,5,13]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(y,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,I,n){const C=this.getUsageKey(y,I);this._reportedUsages.has(C)||(this._reportedUsages.add(C),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:y}))}getUsageKey(y,I){return`${y}-${I.identifier.value}`}};A=ze([Ve(0,E.IExtHostRpcService),Ve(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(_,y,I){}})}),define(be[188],Ee([0,1,3,5,7,26]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,I,n,C={}){const l=E.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(l)||[],u=[...n].sort().join(" ");let g=f.find(b=>b.scopes===u);if(g)return g.result;{const b=this._getSession(y,l,I,n,C);g={scopes:u,result:b},f.push(g),this._inFlightRequests.set(l,f);try{await b}finally{const w=f.findIndex(T=>T.scopes===u);w>-1&&(f.splice(w),this._inFlightRequests.set(l,f))}return b}}async _getSession(y,I,n,C,l={}){await this._proxy.$ensureProvider(n);const f=y.displayName||y.name;return this._proxy.$getSession(n,C,I,f,l)}async removeSession(y,I){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(I):this._proxy.$removeSession(y,I)}registerAuthenticationProvider(y,I,n,C){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:I,provider:n,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===y)||this._providers.push({id:y,label:I});const l=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(y,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,I,C?.supportsMultipleAccounts??!1),new S.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(y);const f=this._providers.findIndex(u=>u.id===y);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,I){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,I){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,I){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,I){return this._onDidChangeSessions.fire({provider:{id:y,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(be[189],Ee([0,1,5,13,9]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(_,y){this._extHostDocumentsAndEditors=y,this._proxy=_.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(_){const y=S.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};E=ze([Ve(0,R.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(be[190],Ee([0,1,5]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(E){const A=E.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(_){return A.$writeText(_)}})}}e.ExtHostClipboard=R}),define(be[48],Ee([0,1,10,7,9,23,5,17,16,57,31,38,2,6,4,13]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,a=>{const i=this._apiCommands.get(a);return i?.result===o.Void?i:void 0},r),this._argumentProcessors=[{processArgument(a){return(0,I.revive)(a)}},{processArgument(a){return(0,E.cloneAndChange)(a,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(C.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...a)=>{const i=t.args.map((p,d)=>{if(!p.validate(a[d]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${a[d]}`);return p.convert(a[d])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,a,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:a,thisArg:i,description:c}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,a){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,E.cloneAndChange)(r,function(c){if(c instanceof R.Position)return S.Position.from(c);if(c instanceof R.Range)return S.Range.from(c);if(c instanceof R.Location)return S.location.from(c);if(R.NotebookRange.isNotebookRange(c))return S.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,a);return(0,I.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:i,thisArg:c,description:p}=a;if(p)for(let d=0;d<p.args.length;d++)try{(0,h.validateConstraint)(r[d],p.args[d].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[d].name}' - ${p.args[d].description}`)}try{return await i.apply(c,r)}catch(d){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(d,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(a=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),a)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(a=>a[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,a]of this._commands){let{description:i}=a;i&&(t[r]=i)}return Promise.resolve(t)}};b=ze([Ve(0,g.IExtHostRpcService),Ve(1,y.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class w{constructor(t,r,a){this._commands=t,this._lookupApiCommand=r,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const i=this._lookupApiCommand(t.command);if(i)a.id=i.internalId,a.arguments=i.args.map((c,p)=>c.convert(t.arguments&&t.arguments[p]));else if((0,_.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),a.$ident=c,a.id=this.delegatingCommandId,a.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return a}fromInternal(t){const r=A.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class T{constructor(t,r,a,i){this.name=t,this.description=r,this.validate=a,this.convert=i}optional(){return new T(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new T(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=T,T.Uri=new T("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v),T.Position=new T("position","A position in a text document",v=>R.Position.isPosition(v),S.Position.from),T.Range=new T("range","A range in a text document",v=>R.Range.isRange(v),S.Range.from),T.Selection=new T("selection","A selection in a text document",v=>R.Selection.isSelection(v),S.Selection.from),T.Number=new T("number","",v=>typeof v=="number",v=>v),T.String=new T("string","",v=>typeof v=="string",v=>v),T.CallHierarchyItem=new T("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,S.CallHierarchyItem.from),T.TypeHierarchyItem=new T("item","A type hierarchy item",v=>v instanceof R.TypeHierarchyItem,S.TypeHierarchyItem.from);class o{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=o,o.Void=new o("no result",v=>v);class m{constructor(t,r,a,i,c){this.id=t,this.internalId=r,this.description=a,this.args=i,this.result=c}}e.ApiCommand=m}),define(be[191],Ee([0,1,9,7,61,48,17,89]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(h.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,A.isFalsyOrEmpty)(l))return;class u extends R.SymbolInformation{static to(b){const w=new u(b.name,h.SymbolKind.to(b.kind),b.containerName||"",new R.Location(f[0],h.Range.to(b.range)));return w.detail=b.detail,w.range=w.location.range,w.selectionRange=h.Range.to(b.selectionRange),w.children=b.children?b.children.map(u.to):[],w}}return l.map(u.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(h.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(h.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(h.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(h.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(h.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>R.Position.isPosition(f)),l=>l.map(h.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(f=>{let u;for(const g of f.reverse())u=new R.SelectionRange(h.Range.to(g),u);return u}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const f=[];if(Array.isArray(l))for(let u of l)f.push(...u[1].map(h.WorkspaceSymbol.to));return f})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(h.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(h.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(h.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return h.WorkspaceEdit.to(l)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(h.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,_.decodeSemanticTokensDto)(l);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,_.decodeSemanticTokensDto)(l);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,f,u)=>{if(!l)return new R.CompletionList([]);const g=l.suggestions.map(b=>h.CompletionItem.to(b,u));return new R.CompletionList(g,l.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return h.SignatureHelp.to(l)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,f,u)=>n(g=>new R.CodeLens(h.Range.to(g.range),g.command&&u.fromInternal(g.command)))(l))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?h.Selection.from(l):h.Range.from(l)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,f,u)=>n(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const b=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=h.WorkspaceEdit.to(g.edit)),g.command&&(b.command=u.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(l))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new R.ColorInformation(h.Range.to(f.range),h.Color.to(f.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,h.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:h.Range.from(l.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(h.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(h.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>h.NotebookExclusiveDocumentPattern.to(f))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(h.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[h.ViewColumn.from(l.viewColumn),h.TextEditorOpenOptions.from(l)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[h.ViewColumn.from(l.viewColumn),h.TextEditorOpenOptions.from(l)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[h.ViewColumn.from(l.viewColumn),h.TextEditorOpenOptions.from(l)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(h.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(h.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(h.TypeHierarchyItem.to)))];class I{static register(f){y.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=I;function n(l){return f=>{if(Array.isArray(f))return f.map(l)}}function C(l){if(!Array.isArray(l))return;const f=[];for(const u of l)S.isLocationLink(u)?f.push(h.DefinitionLink.to(u)):f.push(h.location.to(u));return f}}),define(be[192],Ee([0,1,15,52,3,6,2,61,26,9,7,5]),function(ee,e,h,R,S,E,A,_,y,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(f,u,g){const b=f.getProxy(C.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.commentThreadHandle);return p||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.thread.commentThreadHandle);return p?{thread:p,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.thread.commentThreadHandle);if(!p)return i;let d=i.commentUniqueId,D=p.getCommentByUniqueId(d);return D||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.thread.commentThreadHandle);if(!p)return i;let d=i.text,D=i.commentUniqueId,k=p.getCommentByUniqueId(D);return k?(k.body=d,k):i}return i}})}createCommentController(i,c,p){const d=w.handlePool++,D=new o(i,d,c,p);this._commentControllers.set(D.handle,D);const k=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return k.push(D),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),k),D.value}$createCommentThreadTemplate(i,c,p){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(c,p)}async $updateCommentThreadTemplate(i,c,p){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(c,p)}$deleteCommentThread(i,c){const p=this._commentControllers.get(i);p&&p.$deleteCommentThread(c)}$provideCommentingRanges(i,c,p){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const D=g.getDocument(A.URI.revive(c));return(0,h.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(D,p)).then(k=>k?k.map(s=>I.Range.from(s)):void 0)}$toggleReaction(i,c,p,d,D){const k=this._commentControllers.get(i);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const s=k.getCommentThread(c);if(s){const P=s.getCommentByUniqueId(d.uniqueIdInThread);if(k!==void 0&&P&&k.reactionHandler)return k.reactionHandler(P,t(D))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class T{constructor(i,c,p,d,D,k,s){this._commentControllerHandle=c,this._id=p,this._uri=d,this._range=D,this._comments=k,this.handle=T._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),b.$createCommentThread(c,this.handle,this._id,this._uri,I.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this._localDisposables.push({dispose:()=>{b.$deleteCommentThread(c,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(F){P.range=F},get comments(){return P.comments},set comments(F){P.comments=F},get collapsibleState(){return P.collapsibleState},set collapsibleState(F){P.collapsibleState=F},get canReply(){return P.canReply},set canReply(F){P.canReply=F},get contextValue(){return P.contextValue},set contextValue(F){P.contextValue=F},get label(){return P.label},set label(F){P.label=F},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const i=p=>Object.prototype.hasOwnProperty.call(this.modifications,p),c={};i("range")&&(c.range=I.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(p=>m(this,p,this._commentsMap))),i("collapsibleState")&&(c.collapseState=r(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},b.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let p=c[0],d=c[1];if(i===d)return p}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}T._handlePool=0,ze([(0,R.debounce)(100)],T.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,c,p,d){this._extension=i,this._handle=c,this._id=p,this._label=d,this._threads=new Map,b.$registerCommentController(this.handle,p,d);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(k){D.options=k},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(k){D.commentingRangeProvider=k},get reactionHandler(){return D.reactionHandler},set reactionHandler(k){D.reactionHandler=k},createCommentThread(k,s,P){return D.createCommentThread(k,s,P).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{b.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,b.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,b.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,p,d){if(typeof i=="string"){const D=new T(this.id,this.handle,i,c,p,d,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new T(this.id,this.handle,void 0,i,c,p,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(i,c){const p=new T(this.id,this.handle,void 0,A.URI.revive(i),I.Range.to(c),[],this._extension.identifier);return p.collapsibleState=_.CommentThreadCollapsibleState.Expanded,this._threads.set(p.handle,p),p}$updateCommentThreadTemplate(i,c){let p=this._threads.get(i);p&&(p.range=I.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function m(a,i,c){let p=c.get(i);p||(p=++a.commentHandle,c.set(i,p));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:p,body:I.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(D=>v(D)):void 0}}function v(a){return{label:a.label,iconPath:a.iconPath?I.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function t(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function r(a){if(a!==void 0)switch(a){case n.CommentThreadCollapsibleState.Expanded:return _.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return _.CommentThreadCollapsibleState.Collapsed}return _.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(be[104],Ee([0,1,2,5,7,4,13,16,17,8,14]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class wn{constructor(f,u){this._logService=u,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,u){const g=wn._handlePool++;this._provider.set(g,{provider:f,extensionId:u}),this._proxy.$registerDecorationProvider(g,u.value);const b=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(g,null);return}let T=(0,y.asArray)(w);if(T.length<=wn._maxEventSize){this._proxy.$onDidChange(g,T);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,T.length);const o=T.map(t=>({uri:t,rank:(0,I.count)(t.path,"/")})),m=(0,y.groupBy)(o,(t,r)=>t.rank-r.rank||(0,I.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of m){let r;for(let a of t){let i=(0,n.dirname)(a.uri.path);if(r!==i&&(r=i,v.push(a.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new S.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(f,u,g){if(!this._provider.has(f))return Object.create(null);const b=Object.create(null),{provider:w,extensionId:T}=this._provider.get(f);return await Promise.all(u.map(async o=>{try{const{uri:m,id:v}=o,t=await Promise.resolve(w.provideFileDecoration(h.URI.revive(m),g));if(!t)return;try{S.FileDecoration.validate(t),b[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${T.value}': ${r}`)}}catch(m){this._logService.error(m)}})),b}};C._handlePool=0,C._maxEventSize=250,C=ze([Ve(0,A.IExtHostRpcService),Ve(1,_.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,E.createDecorator)("IExtHostDecorations")}),define(be[193],Ee([0,1,133,92,2,5,7,9,3,16,21]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(u,g,b,w,T){this._name=u,this._owner=g,this._maxDiagnosticsPerFile=b,this._proxy=w,this._onDidChangeDiagnostics=T,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,g){if(!u){this.clear();return}this._checkDisposed();let b=[];if(S.URI.isUri(u)){if(!g){this.delete(u);return}this._data.set(u,g.slice()),b=[u]}else if(Array.isArray(u)){b=[];let T;u=[...u].sort(C._compareIndexedTuplesByUri);for(const o of u){const[m,v]=o;if((!T||m.toString()!==T.toString())&&(T&&this._data.get(T).length===0&&this._data.delete(T),T=m,b.push(m),this._data.set(m,[])),v){const t=this._data.get(m);t&&t.push(...v)}else{const t=this._data.get(m);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const w=[];for(let T of b){let o=[];const m=this._data.get(T);if(m)if(m.length>this._maxDiagnosticsPerFile){o=[];const v=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of m)if(r.severity===v[t]&&o.push(_.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;o.push({severity:R.MarkerSeverity.Info,message:(0,h.localize)(0,null,m.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=m.map(v=>_.Diagnostic.from(v));w.push([T,o])}this._proxy.$changeMany(this._owner,w)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,g){this._checkDisposed();for(let b of this._data.keys())u.apply(g,[b,this.get(b),this])}get(u){this._checkDisposed();const g=this._data.get(u);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,g){return u[0].toString()<g[0].toString()?-1:u[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=C;let l=class Qt{constructor(u,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=u.getProxy(E.MainContext.MainThreadDiagnostics)}static _mapper(u){const g=new n.ResourceMap;for(const b of u)g.set(b,b);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(u,g){const{_collections:b,_proxy:w,_onDidChangeDiagnostics:T,_logService:o}=this,m=new class{$changeMany(r,a){w.$changeMany(r,a),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,r,a.length===0?"CLEARING":a)}$clear(r){w.$clear(r),o.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,r)}dispose(){w.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=g;else if(!b.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Qt._idPool++;while(b.has(v))}return new class extends C{constructor(){super(g,v,Qt._maxDiagnosticsPerFile,m,T);b.set(v,this)}dispose(){super.dispose(),b.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const g=new Map,b=[];for(const w of this._collections.values())w.forEach((T,o)=>{let m=g.get(T.toString());typeof m=="undefined"&&(m=b.length,g.set(T.toString(),m),b.push([T,[]])),b[m][1]=b[m][1].concat(...o)});return b}}_getDiagnostics(u){let g=[];for(let b of this._collections.values())b.has(u)&&(g=g.concat(b.get(u)));return g}$acceptMarkersChange(u){if(!this._mirrorCollection){const g="_generated_mirror",b=new C(g,g,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,b),this._mirrorCollection=b}for(const[g,b]of u)this._mirrorCollection.set(S.URI.revive(g),b.map(_.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([Ve(1,I.ILogService)],l),e.ExtHostDiagnostics=l}),define(be[194],Ee([0,1,2,5]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(_=>_?_.map(y=>h.URI.revive(y)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(_=>_?h.URI.revive(_):void 0)}}e.ExtHostDialogs=S}),define(be[195],Ee([0,1,12,2,7,5,11,20,8]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(C,l,f){this._documentsAndEditors=l,this._logService=f,this._documentContentProviders=new Map,this._proxy=C.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const f=I._handlePool++;this._documentContentProviders.set(f,l),this._proxy.$registerTextContentProvider(f,C);let u;return typeof l.onDidChange=="function"&&(u=l.onDidChange(g=>{if(g.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(f,g).then(b=>{if(!b&&typeof b!="string")return;const w=this._documentsAndEditors.getDocument(g);if(!w)return;const T=(0,y.splitLines)(b);if(!w.equalLines(T))return this._proxy.$onVirtualDocumentChange(g,b)},h.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(C,l){const f=this._documentContentProviders.get(C);return f?Promise.resolve(f.provideTextDocumentContent(R.URI.revive(l),_.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(be[196],Ee([0,1,3,6,2,5,98,9,10,23,7]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(f,u){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const b of g)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const b of g)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const u=this._documentsAndEditors.getDocument(f);if(u)return u}getDocument(f){const u=this.getDocumentData(f);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return u.document}ensureDocumentData(f){const u=this._documentsAndEditors.getDocument(f);if(u)return Promise.resolve(u);let g=this._documentLoader.get(f.toString());return g||(g=this._proxy.$tryOpenDocument(f).then(b=>{this._documentLoader.delete(f.toString());const w=S.URI.revive(b);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(w))},b=>(this._documentLoader.delete(f.toString()),Promise.reject(b))),this._documentLoader.set(f.toString(),g)),g}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(u=>S.URI.revive(u))}$acceptModelModeChanged(f,u){const g=S.URI.revive(f),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(u),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(f){const u=S.URI.revive(f),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(f,u){const g=S.URI.revive(f),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");b._acceptIsDirty(u),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,u,g){const b=S.URI.revive(f),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");w._acceptIsDirty(g),w.onEvents(u);let T;u.isUndoing?T=n.TextDocumentChangeReason.Undo:u.isRedoing&&(T=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:w.document,contentChanges:u.changes.map(o=>({range:_.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:T}))}setWordDefinitionFor(f,u){(0,A.setWordDefinitionFor)(f,u)}}e.ExtHostDocuments=C}),define(be[49],Ee([0,1,41,3,6,2,4,5,98,13,102,9,16,21,11,55,112]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let T=class{constructor(m,v){this._extHostRpc=m,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const v=[],t=[],r=[];if(m.removedDocuments)for(const a of m.removedDocuments){const i=E.URI.revive(a),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(m.addedDocuments)for(const a of m.addedDocuments){const i=E.URI.revive(a.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new w(new y.ExtHostDocumentData(this._extHostRpc.getProxy(_.MainContext.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(m.removedEditors)for(const a of m.removedEditors){const i=this._editors.get(a);this._editors.delete(a),i&&r.push(i)}if(m.addedEditors)for(const a of m.addedEditors){const i=E.URI.revive(a.documentUri);h.ok(this._documents.has(i),`document '${i}' does not exist`),h.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const c=this._documents.get(i).value,p=new n.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(_.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>c.document),a.selections.map(C.Selection.to),a.options,a.visibleRanges.map(d=>C.Range.to(d)),typeof a.editorPosition=="number"?C.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,p)}m.newActiveEditor!==void 0&&(h.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),(0,S.dispose)(v),(0,S.dispose)(r),m.removedDocuments&&this._onDidRemoveDocuments.fire(v),m.addedDocuments&&this._onDidAddDocuments.fire(t),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){return this._documents.get(m)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return m?v:v?.value}allEditors(){return[...this._editors.values()]}};T=ze([Ve(0,I.IExtHostRpcService),Ve(1,l.ILogService)],T),e.ExtHostDocumentsAndEditors=T,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[197],Ee([0,1,2,5,6,7,9,122,8,24]),function(ee,e,h,R,S,E,A,_,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let g,b,w=14,T=14;for(const o of f){let m=g?(0,y.commonPrefixLength)(g,o):0;for(m===0?b=1:b=T;m<o.length;m++)m+1===o.length?(w=T,T=9):T+=1,u.push([b,o.toUpperCase().charCodeAt(m),T]),u.push([b,o.toLowerCase().charCodeAt(m),T]),b=T;g=o,T=w}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new _.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],g=_.LinkComputer.computeLinks({getLineContent(b){return f.lineAt(b-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const b of g){const w=A.DocumentLink.to(b);w.target&&u.push(w)}return u}}class C{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,u,g,b={},w){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const T=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(T,g),this._enableProposedApi.set(T,w??!1);let o=2;b.isCaseSensitive&&(o+=1024),b.isReadonly&&(o+=2048),typeof g.copy=="function"&&(o+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(o+=4),this._proxy.$registerFileSystemProvider(T,u,o).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${u}`),console.error(v)});const m=g.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:a,type:i}=r;if(a.scheme!==u)continue;let c;switch(i){case E.FileChangeType.Changed:c=0;break;case E.FileChangeType.Created:c=1;break;case E.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:a,type:c})}this._proxy.$onFileSystemChange(T,t)});return(0,S.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(T),this._enableProposedApi.delete(T),this._proxy.$unregisterProvider(T)})}static _asIStat(f,u){const{type:g,ctime:b,mtime:w,size:T,permissions:o}=f;return u?{type:g,ctime:b,mtime:w,size:T,permissions:o}:{type:g,ctime:b,mtime:w,size:T}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(h.URI.revive(u))).then(g=>C._asIStat(g,this._enableProposedApi.get(f)??!1))}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(h.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(h.URI.revive(u))).then(g=>I.VSBuffer.wrap(g))}$writeFile(f,u,g,b){return Promise.resolve(this._getFsProvider(f).writeFile(h.URI.revive(u),g.buffer,b))}$delete(f,u,g){return Promise.resolve(this._getFsProvider(f).delete(h.URI.revive(u),g))}$rename(f,u,g,b){return Promise.resolve(this._getFsProvider(f).rename(h.URI.revive(u),h.URI.revive(g),b))}$copy(f,u,g,b){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(h.URI.revive(u),h.URI.revive(g),b))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(h.URI.revive(u)))}$watch(f,u,g,b){const w=this._getFsProvider(f).watch(h.URI.revive(g),b);this._watches.set(u,w)}$unwatch(f,u){const g=this._watches.get(u);g&&(g.dispose(),this._watches.delete(u))}$open(f,u,g){const b=this._getFsProvider(f);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(h.URI.revive(u),g))}$close(f,u){const g=this._getFsProvider(f);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(u))}$read(f,u,g,b){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const T=I.VSBuffer.alloc(b);return Promise.resolve(w.read(u,g,T.buffer,0,b)).then(o=>T.slice(0,o))}$write(f,u,g,b){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(u,g,b.buffer,0,b.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return u}}e.ExtHostFileSystem=C}),define(be[76],Ee([0,1,5,62,7,24,4,13,47]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Ut{constructor(C,l){const f=C.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return f.$stat(u).catch(Ut._handleError)},readDirectory(u){return f.$readdir(u).catch(Ut._handleError)},createDirectory(u){return f.$mkdir(u).catch(Ut._handleError)},async readFile(u){return f.$readFile(u).then(g=>g.buffer).catch(Ut._handleError)},writeFile(u,g){return f.$writeFile(u,E.VSBuffer.wrap(g)).catch(Ut._handleError)},delete(u,g){return f.$delete(u,{recursive:!1,useTrash:!1,...g}).catch(Ut._handleError)},rename(u,g,b){return f.$rename(u,g,{overwrite:!1,...b}).catch(Ut._handleError)},copy(u,g,b){return f.$copy(u,g,{overwrite:!1,...b}).catch(Ut._handleError)},isWritableFileSystem(u){const g=l.getCapabilities(u);if(typeof g=="number")return!(g&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new S.FileSystemError(String(C));if(C.name==="ENOPRO")throw S.FileSystemError.Unavailable(C.message);switch(C.name){case R.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(C.message);case R.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(C.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(C.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(C.message);case R.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(C.message);case R.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(C.message);default:throw new S.FileSystemError(C.message,C.name)}}};I=ze([Ve(0,_.IExtHostRpcService),Ve(1,y.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(be[198],Ee([0,1,2,48]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(A,_,y,I){this._extHostNotebooks=_,this._textDocumentsAndEditors=y,this._commands=I;const n=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new R.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new R.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new R.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new R.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:h.URI.revive(C.notebookUri),inputUri:h.URI.revive(C.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:h.URI.revive(C.notebookUri),inputUri:h.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(A,_,y,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:_,lines:[""],modeId:y,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=S}),define(be[199],Ee([0,1,6,5]),function(ee,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const _=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(_,A),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(_)})}}e.ExtHostLabelService=S}),define(be[200],Ee([0,1,2,23,9,7,5,8,31,17,10,119,6,89,54,66,56,12,3]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentSymbols(U,K){const X=this._documents.getDocument(U),re=await this._provider.provideDocumentSymbols(X,K);if(!(0,I.isFalsyOrEmpty)(re))return re[0]instanceof E.DocumentSymbol?re.map(S.DocumentSymbol.from):o._asDocumentSymbolTree(re)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((re,q)=>{let ie=re.location.range.start.compareTo(q.location.range.start);return ie===0&&(ie=q.location.range.end.compareTo(re.location.range.end)),ie});const K=[],X=[];for(const re of U){const q={name:re.name||"!!MISSING: name!!",kind:S.SymbolKind.from(re.kind),tags:re.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:S.Range.from(re.location.range),selectionRange:S.Range.from(re.location.range),children:[]};for(;;){if(X.length===0){X.push(q),K.push(q);break}const ie=X[X.length-1];if(y.Range.containsRange(ie.range,q.range)&&!y.Range.equalsRange(ie.range,q.range)){ie.children&&ie.children.push(q),X.push(q);break}X.pop()}}return K}}class m{constructor(U,K,X){this._documents=U,this._commands=K,this._provider=X,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,K){const X=this._documents.getDocument(U),re=await this._provider.provideCodeLenses(X,K);if(!re||K.isCancellationRequested)return;const q=this._cache.add(re),ie=new l.DisposableStore;this._disposables.set(q,ie);const ge={cacheId:q,lenses:[]};for(let Re=0;Re<re.length;Re++)ge.lenses.push({cacheId:[q,Re],range:S.Range.from(re[Re].range),command:this._commands.toInternal(re[Re].command,ie)});return ge}async resolveCodeLens(U,K){const X=U.cacheId&&this._cache.get(...U.cacheId);if(!X)return;let re;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?re=X:re=await this._provider.resolveCodeLens(X,K),re||(re=X),K.isCancellationRequested)return;const q=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!q)return U.command=this._commands.toInternal(re.command??m._badCmd,q),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(je){return Array.isArray(je)?je.map(S.DefinitionLink.from):je?[S.DefinitionLink.from(je)]:[]}class t{constructor(U,K){this._documents=U,this._provider=K}async provideDefinition(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideDefinition(re,q,X);return v(ie)}}class r{constructor(U,K){this._documents=U,this._provider=K}async provideDeclaration(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideDeclaration(re,q,X);return v(ie)}}class a{constructor(U,K){this._documents=U,this._provider=K}async provideImplementation(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideImplementation(re,q,X);return v(ie)}}class i{constructor(U,K){this._documents=U,this._provider=K}async provideTypeDefinition(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideTypeDefinition(re,q,X);return v(ie)}}class c{constructor(U,K){this._documents=U,this._provider=K}async provideHover(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideHover(re,q,X);if(!(!ie||(0,I.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=re.getWordRangeAtPosition(q)),ie.range||(ie.range=new E.Range(q,q)),S.Hover.from(ie)}}class p{constructor(U,K){this._documents=U,this._provider=K}async provideEvaluatableExpression(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideEvaluatableExpression(re,q,X);if(ie)return S.EvaluatableExpression.from(ie)}}class d{constructor(U,K){this._documents=U,this._provider=K}async provideInlineValues(U,K,X,re){const q=this._documents.getDocument(U),ie=await this._provider.provideInlineValues(q,S.Range.to(K),S.InlineValueContext.to(X),re);if(Array.isArray(ie))return ie.map(ge=>S.InlineValue.from(ge))}}class D{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentHighlights(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideDocumentHighlights(re,q,X);if(Array.isArray(ie))return ie.map(S.DocumentHighlight.from)}}class k{constructor(U,K){this._documents=U,this._provider=K}async provideLinkedEditingRanges(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(re,q,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,I.coalesce)(ie.ranges.map(S.Range.from)),wordPattern:ie.wordPattern}}}class s{constructor(U,K){this._documents=U,this._provider=K}async provideReferences(U,K,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(K),ge=await this._provider.provideReferences(q,ie,X,re);if(Array.isArray(ge))return ge.map(S.location.from)}}class P{constructor(U,K,X,re,q,ie,ge){this._documents=U,this._commands=K,this._diagnostics=X,this._provider=re,this._logService=q,this._extension=ie,this._apiDeprecation=ge,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,K,X,re){const q=this._documents.getDocument(U),ie=C.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),ge=[];for(const Z of this._diagnostics.getDiagnostics(U))if(ie.intersection(Z.range)&&ge.push(Z)>P._maxCodeActionsPerFile)break;const Re={diagnostics:ge,only:X.only?new E.CodeActionKind(X.only):void 0,triggerKind:S.CodeActionTriggerKind.to(X.trigger)},We=await this._provider.provideCodeActions(q,ie,Re,re);if(!(0,I.isNonEmptyArray)(We)||re.isCancellationRequested)return;const ve=this._cache.add(We),Je=new l.DisposableStore;this._disposables.set(ve,Je);const z=[];for(let Z=0;Z<We.length;Z++){const ce=We[Z];!ce||(P._isCommand(ce)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),z.push({_isSynthetic:!0,title:ce.title,command:this._commands.toInternal(ce,Je)})):(Re.only&&(ce.kind?Re.only.contains(ce.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),z.push({cacheId:[ve,Z],title:ce.title,command:ce.command&&this._commands.toInternal(ce.command,Je),diagnostics:ce.diagnostics&&ce.diagnostics.map(S.Diagnostic.from),edit:ce.edit&&S.WorkspaceEdit.from(ce.edit),kind:ce.kind&&ce.kind.value,isPreferred:ce.isPreferred,disabled:ce.disabled?.reason})))}return{cacheId:ve,actions:z}}async resolveCodeAction(U,K){const[X,re]=U,q=this._cache.get(X,re);if(!q||P._isCommand(q)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(q,K)??q;return ie?.edit?S.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}P._maxCodeActionsPerFile=1e3;class F{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentFormattingEdits(U,K,X){const re=this._documents.getDocument(U),q=await this._provider.provideDocumentFormattingEdits(re,K,X);if(Array.isArray(q))return q.map(S.TextEdit.from)}}class x{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentRangeFormattingEdits(U,K,X,re){const q=this._documents.getDocument(U),ie=S.Range.to(K),ge=await this._provider.provideDocumentRangeFormattingEdits(q,ie,X,re);if(Array.isArray(ge))return ge.map(S.TextEdit.from)}}class j{constructor(U,K){this._documents=U,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,K,X,re,q){const ie=this._documents.getDocument(U),ge=S.Position.to(K),Re=await this._provider.provideOnTypeFormattingEdits(ie,ge,X,re,q);if(Array.isArray(Re))return Re.map(S.TextEdit.from)}}class ae{constructor(U,K){this._provider=U,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,K){const X=A.IdObject.mixin({symbols:[]}),re=await this._provider.provideWorkspaceSymbols(U,K);if((0,I.isNonEmptyArray)(re))for(const q of re){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ie=A.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(ie._id,q),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(U,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const X=this._symbolCache.get(U._id);if(X){const re=await this._provider.resolveWorkspaceSymbol(X,K);return re&&(0,R.mixin)(U,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(U){const K=this._resultCache.get(U);if(K){for(let[X,re]=K;X<=re;X++)this._symbolCache.delete(X);this._resultCache.delete(U)}}}class oe{constructor(U,K,X){this._documents=U,this._provider=K,this._logService=X}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,K,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(K);try{const ge=await this._provider.provideRenameEdits(q,ie,X,re);return ge?S.WorkspaceEdit.from(ge):void 0}catch(ge){const Re=oe._asMessage(ge);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(ge)}}async resolveRenameLocation(U,K,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(U),q=S.Position.to(K);try{const ie=await this._provider.prepareRename(re,q,X);let ge,Re;if(E.Range.isRange(ie)?(ge=ie,Re=re.getText(ie)):(0,n.isObject)(ie)&&(ge=ie.range,Re=ie.placeholder),!ge||!Re)return;if(ge.start.line>q.line||ge.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ge),text:Re}}catch(ie){const ge=oe._asMessage(ie);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class V{constructor(U,K){this.resultId=U,this.tokens=K}}class W{constructor(U,K){this._documents=U,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,K,X){const re=this._documents.getDocument(U),q=K!==0?this._previousResults.get(K):null;let ie=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(re,q.resultId,X):await this._provider.provideDocumentSemanticTokens(re,X);return q&&this._previousResults.delete(K),ie?(ie=W._fixProvidedSemanticTokens(ie),this._send(W._convertToEdits(q,ie),ie)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return W._isSemanticTokens(U)?W._isCorrectSemanticTokens(U)?U:new E.SemanticTokens(new Uint32Array(U.data),U.resultId):W._isSemanticTokensEdits(U)?W._isCorrectSemanticTokensEdits(U)?U:new E.SemanticTokensEdits(U.edits.map(K=>new E.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const K of U.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,K){if(!W._isSemanticTokens(K)||!U||!U.tokens)return K;const X=U.tokens,re=X.length,q=K.data,ie=q.length;let ge=0;const Re=Math.min(re,ie);for(;ge<Re&&X[ge]===q[ge];)ge++;if(ge===re&&ge===ie)return new E.SemanticTokensEdits([],K.resultId);let We=0;const ve=Re-ge;for(;We<ve&&X[re-We-1]===q[ie-We-1];)We++;return new E.SemanticTokensEdits([{start:ge,deleteCount:re-ge-We,data:q.subarray(ge,ie-We)}],K.resultId)}_send(U,K){if(W._isSemanticTokens(U)){const X=this._nextResultId++;return this._previousResults.set(X,new V(U.resultId,U.data)),(0,f.encodeSemanticTokensDto)({id:X,type:"full",data:U.data})}if(W._isSemanticTokensEdits(U)){const X=this._nextResultId++;return W._isSemanticTokens(K)?this._previousResults.set(X,new V(K.resultId,K.data)):this._previousResults.set(X,new V(U.resultId)),(0,f.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(U.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class L{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentRangeSemanticTokens(U,K,X){const re=this._documents.getDocument(U),q=await this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(K),X);return q?this._send(q):null}_send(U){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=L;class Q{constructor(U,K,X,re,q){this._documents=U,this._commands=K,this._provider=X,this._apiDeprecation=re,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,K,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(K),ge=q.getWordRangeAtPosition(ie)||new E.Range(ie,ie),Re=ge.with({end:ie}),We=new b.StopWatch(!0),ve=await this._provider.provideCompletionItems(q,ie,re,S.CompletionContext.to(X));if(!ve||re.isCancellationRequested)return;const Je=Array.isArray(ve)?new E.CompletionList(ve):ve,z=Q.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),Z=new l.DisposableStore;this._disposables.set(z,Z);const ce=[],Ue={x:z,b:ce,a:{replace:S.Range.from(ge),insert:S.Range.from(Re)},c:Je.isIncomplete||void 0,d:We.elapsed()};for(let xe=0;xe<Je.items.length;xe++){const et=Je.items[xe],De=this._convertCompletionItem(et,[z,xe],Re,ge);ce.push(De)}return Ue}async resolveCompletionItem(U,K){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...U);if(!X)return;const re=await this._provider.resolveCompletionItem(X,K);if(!!re)return this._convertCompletionItem(re,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,K,X,re){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const ie={x:K,a:U.label,b:U.kind!==void 0?S.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(S.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(U.command,q)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=U.textEdit.newText):typeof U.insertText=="string"?ie.h=U.insertText:U.insertText instanceof E.SnippetString&&(ie.h=U.insertText.value,ie.i|=4);let ge;return U.textEdit?ge=U.textEdit.range:U.range&&(ge=U.range),E.Range.isRange(ge)?ie.j=S.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!re?.isEqual(ge.replacing))&&(ie.j={insert:S.Range.from(ge.inserting),replace:S.Range.from(ge.replacing)}),ie}}class O{constructor(U,K,X){this._documents=U,this._provider=K,this._commands=X,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,K,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(K),ge=await this._provider.provideInlineCompletionItems(q,ie,X,re);if(!ge||re.isCancellationRequested)return;const Re=(0,n.isArray)(ge)?{items:ge}:ge,We=this._cache.add(Re.items);let ve;return{pid:We,items:Re.items.map((Je,z)=>{let Z;return Je.command&&(ve||(ve=new l.DisposableStore,this._disposables.set(We,ve)),Z=this._commands.toInternal(Je.command,ve)),{text:Je.text,range:Je.range?S.Range.from(Je.range):void 0,command:Z,idx:z}})}}disposeCompletions(U){this._cache.delete(U);const K=this._disposables.get(U);K&&K.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,K){const X=this._cache.get(U,K);X&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new T.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let K=G.map.get(U);return K||(K=new G,G.map.set(U,K)),K}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=G,G.map=new WeakMap;class de{constructor(U,K){this._documents=U,this._provider=K,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(U,K,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(K),ge=this.reviveContext(X),Re=await this._provider.provideSignatureHelp(q,ie,re,ge);if(Re){const We=this._cache.add([Re]);return{...S.SignatureHelp.from(Re),id:We}}}reviveContext(U){let K;if(U.activeSignatureHelp){const X=S.SignatureHelp.to(U.activeSignatureHelp),re=this._cache.get(U.activeSignatureHelp.id,0);re?(K=re,K.activeSignature=X.activeSignature,K.activeParameter=X.activeParameter):K=X}return{...U,activeSignatureHelp:K}}releaseSignatureHelp(U){this._cache.delete(U)}}class ${constructor(U,K){this._documents=U,this._provider=K}async provideInlayHints(U,K,X){const re=this._documents.getDocument(U),q=await this._provider.provideInlayHints(re,S.Range.to(K),X);return q?{hints:q.map(S.InlayHint.from)}:void 0}}class ne{constructor(U,K){this._documents=U,this._provider=K,this._cache=new g.Cache("DocumentLink")}async provideLinks(U,K){const X=this._documents.getDocument(U),re=await this._provider.provideDocumentLinks(X,K);if(!(!Array.isArray(re)||re.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(ne._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(re),ie={links:[],id:q};for(let ge=0;ge<re.length;ge++){if(!ne._validateLink(re[ge]))continue;const Re=S.DocumentLink.from(re[ge]);Re.cacheId=[q,ge],ie.links.push(Re)}return ie}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,K){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...U);if(!X)return;const re=await this._provider.resolveDocumentLink(X,K);if(!(!re||!ne._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks(U){this._cache.delete(U)}}class he{constructor(U,K){this._documents=U,this._provider=K}async provideColors(U,K){const X=this._documents.getDocument(U),re=await this._provider.provideDocumentColors(X,K);return Array.isArray(re)?re.map(ie=>({color:S.Color.from(ie.color),range:S.Range.from(ie.range)})):[]}async provideColorPresentations(U,K,X){const re=this._documents.getDocument(U),q=S.Range.to(K.range),ie=S.Color.to(K.color),ge=await this._provider.provideColorPresentations(ie,{document:re,range:q},X);if(!!Array.isArray(ge))return ge.map(S.ColorPresentation.from)}}class ye{constructor(U,K){this._documents=U,this._provider=K}async provideFoldingRanges(U,K,X){const re=this._documents.getDocument(U),q=await this._provider.provideFoldingRanges(re,K,X);if(!!Array.isArray(q))return q.map(S.FoldingRange.from)}}class Ne{constructor(U,K,X){this._documents=U,this._provider=K,this._logService=X}async provideSelectionRanges(U,K,X){const re=this._documents.getDocument(U),q=K.map(S.Position.to),ie=await this._provider.provideSelectionRanges(re,q,X);if(!(0,I.isNonEmptyArray)(ie))return[];if(ie.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Re=0;Re<q.length;Re++){const We=[];ge.push(We);let ve=q[Re],Je=ie[Re];for(;;){if(!Je.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(We.push(S.SelectionRange.from(Je)),!Je.parent)break;ve=Je.range,Je=Je.parent}}return ge}}class Me{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.prepareCallHierarchy(re,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ie)]}async provideCallsTo(U,K,X){const re=this._itemFromCache(U,K);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(re,X);if(!!q)return q.map(ie=>({from:this._cacheAndConvertItem(U,ie.from),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}async provideCallsFrom(U,K,X){const re=this._itemFromCache(U,K);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(re,X);if(!!q)return q.map(ie=>({to:this._cacheAndConvertItem(U,ie.to),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){const X=this._cache.get(U),re=S.CallHierarchyItem.from(K,U,X.size.toString(36));return X.set(re._itemId,K),re}_itemFromCache(U,K){return this._cache.get(U)?.get(K)}}class $e{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,X){const re=this._documents.getDocument(U),q=S.Position.to(K),ie=await this._provider.prepareTypeHierarchy(re,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ie)]}async provideSupertypes(U,K,X){const re=this._itemFromCache(U,K);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(U,ie))}async provideSubtypes(U,K,X){const re=this._itemFromCache(U,K);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(U,ie))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){const X=this._cache.get(U),re=S.TypeHierarchyItem.from(K,U,X.size.toString(36));return X.set(re._itemId,K),re}_itemFromCache(U,K){return this._cache.get(U)?.get(K)}}class Xe{constructor(U,K){this.adapter=U,this.extension=K}}class qe{constructor(U,K,X,re,q,ie,ge){this._adapter=new Map,this._uriTransformer=K,this._proxy=U.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=re,this._diagnostics=q,this._logService=ie,this._apiDeprecation=ge}_transformDocumentSelector(U){return(0,I.coalesce)((0,I.asArray)(U).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:S.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new E.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return qe._handlePool++}_withAdapter(U,K,X,re,q=!1){const ie=this._adapter.get(U);if(!ie)return Promise.resolve(re);if(ie.adapter instanceof K){let ge;ie.extension&&(ge=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Re=X(ie.adapter,ie.extension),We=ie.extension;return We&&Promise.resolve(Re).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-ge}ms`),ve=>{q&&ve instanceof w.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(ve))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,K){const X=this._nextHandle();return this._adapter.set(X,new Xe(U,K)),X}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,K,X,re){const q=this._addNewAdapter(new o(this._documents,X),U),ie=re&&re.label||qe._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),ie),this._createDisposable(q)}$provideDocumentSymbols(U,K,X){return this._withAdapter(U,o,re=>re.provideDocumentSymbols(h.URI.revive(K),X),void 0)}registerCodeLensProvider(U,K,X){const re=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Xe(new m(this._documents,this._commands.converter,X),U)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(K),q);let ie=this._createDisposable(re);if(q!==void 0){const ge=X.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));ie=E.Disposable.from(ie,ge)}return ie}$provideCodeLenses(U,K,X){return this._withAdapter(U,m,re=>re.provideCodeLenses(h.URI.revive(K),X),void 0)}$resolveCodeLens(U,K,X){return this._withAdapter(U,m,re=>re.resolveCodeLens(K,X),void 0)}$releaseCodeLenses(U,K){this._withAdapter(U,m,X=>Promise.resolve(X.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(U,K,X){const re=this._addNewAdapter(new t(this._documents,X),U);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDefinition(U,K,X,re){return this._withAdapter(U,t,q=>q.provideDefinition(h.URI.revive(K),X,re),[])}registerDeclarationProvider(U,K,X){const re=this._addNewAdapter(new r(this._documents,X),U);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDeclaration(U,K,X,re){return this._withAdapter(U,r,q=>q.provideDeclaration(h.URI.revive(K),X,re),[])}registerImplementationProvider(U,K,X){const re=this._addNewAdapter(new a(this._documents,X),U);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideImplementation(U,K,X,re){return this._withAdapter(U,a,q=>q.provideImplementation(h.URI.revive(K),X,re),[])}registerTypeDefinitionProvider(U,K,X){const re=this._addNewAdapter(new i(this._documents,X),U);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideTypeDefinition(U,K,X,re){return this._withAdapter(U,i,q=>q.provideTypeDefinition(h.URI.revive(K),X,re),[])}registerHoverProvider(U,K,X,re){const q=this._addNewAdapter(new c(this._documents,X),U);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover(U,K,X,re){return this._withAdapter(U,c,q=>q.provideHover(h.URI.revive(K),X,re),void 0)}registerEvaluatableExpressionProvider(U,K,X,re){const q=this._addNewAdapter(new p(this._documents,X),U);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression(U,K,X,re){return this._withAdapter(U,p,q=>q.provideEvaluatableExpression(h.URI.revive(K),X,re),void 0)}registerInlineValuesProvider(U,K,X,re){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new d(this._documents,X),U);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),q);let ge=this._createDisposable(ie);if(q!==void 0){const Re=X.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));ge=E.Disposable.from(ge,Re)}return ge}$provideInlineValues(U,K,X,re,q){return this._withAdapter(U,d,ie=>ie.provideInlineValues(h.URI.revive(K),X,re,q),void 0)}registerDocumentHighlightProvider(U,K,X){const re=this._addNewAdapter(new D(this._documents,X),U);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDocumentHighlights(U,K,X,re){return this._withAdapter(U,D,q=>q.provideDocumentHighlights(h.URI.revive(K),X,re),void 0)}registerLinkedEditingRangeProvider(U,K,X){const re=this._addNewAdapter(new k(this._documents,X),U);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideLinkedEditingRanges(U,K,X,re){return this._withAdapter(U,k,async q=>{const ie=await q.provideLinkedEditingRanges(h.URI.revive(K),X,re);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?qe._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(U,K,X){const re=this._addNewAdapter(new s(this._documents,X),U);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideReferences(U,K,X,re,q){return this._withAdapter(U,s,ie=>ie.provideReferences(h.URI.revive(K),X,re,q),void 0)}registerCodeActionProvider(U,K,X,re){const q=new l.DisposableStore,ie=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,X,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:re?.providedCodeActionKinds?.map(ge=>ge.value),documentation:re?.documentation?.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,q)}))},qe._extLabel(U),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ie)),q}$provideCodeActions(U,K,X,re,q){return this._withAdapter(U,P,ie=>ie.provideCodeActions(h.URI.revive(K),X,re,q),void 0)}$resolveCodeAction(U,K,X){return this._withAdapter(U,P,re=>re.resolveCodeAction(K,X),void 0)}$releaseCodeActions(U,K){this._withAdapter(U,P,X=>Promise.resolve(X.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(U,K,X){const re=this._addNewAdapter(new F(this._documents,X),U);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(re)}$provideDocumentFormattingEdits(U,K,X,re){return this._withAdapter(U,F,q=>q.provideDocumentFormattingEdits(h.URI.revive(K),X,re),void 0)}registerDocumentRangeFormattingEditProvider(U,K,X){const re=this._addNewAdapter(new x(this._documents,X),U);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(U,K,X,re,q){return this._withAdapter(U,x,ie=>ie.provideDocumentRangeFormattingEdits(h.URI.revive(K),X,re,q),void 0)}registerOnTypeFormattingEditProvider(U,K,X,re){const q=this._addNewAdapter(new j(this._documents,X),U);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),re,U.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(U,K,X,re,q,ie){return this._withAdapter(U,j,ge=>ge.provideOnTypeFormattingEdits(h.URI.revive(K),X,re,q,ie),void 0)}registerWorkspaceSymbolProvider(U,K){const X=this._addNewAdapter(new ae(K,this._logService),U);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(U,K,X){return this._withAdapter(U,ae,re=>re.provideWorkspaceSymbols(K,X),{symbols:[]})}$resolveWorkspaceSymbol(U,K,X){return this._withAdapter(U,ae,re=>re.resolveWorkspaceSymbol(K,X),void 0)}$releaseWorkspaceSymbols(U,K){this._withAdapter(U,ae,X=>X.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(U,K,X){const re=this._addNewAdapter(new oe(this._documents,X,this._logService),U);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(K),oe.supportsResolving(X)),this._createDisposable(re)}$provideRenameEdits(U,K,X,re,q){return this._withAdapter(U,oe,ie=>ie.provideRenameEdits(h.URI.revive(K),X,re,q),void 0)}$resolveRenameLocation(U,K,X,re){return this._withAdapter(U,oe,q=>q.resolveRenameLocation(h.URI.revive(K),X,re),void 0)}registerDocumentSemanticTokensProvider(U,K,X,re){const q=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Xe(new W(this._documents,X),U)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),re,ie);let ge=this._createDisposable(q);if(ie){const Re=X.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ie));ge=E.Disposable.from(ge,Re)}return ge}$provideDocumentSemanticTokens(U,K,X,re){return this._withAdapter(U,W,q=>q.provideDocumentSemanticTokens(h.URI.revive(K),X,re),null,!0)}$releaseDocumentSemanticTokens(U,K){this._withAdapter(U,W,X=>X.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(U,K,X,re){const q=this._addNewAdapter(new L(this._documents,X),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),re),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(U,K,X,re){return this._withAdapter(U,L,q=>q.provideDocumentRangeSemanticTokens(h.URI.revive(K),X,re),null,!0)}registerCompletionItemProvider(U,K,X,re){const q=this._addNewAdapter(new Q(this._documents,this._commands.converter,X,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),re,Q.supportsResolving(X),`${U.identifier.value}(${re.join("")})`),this._createDisposable(q)}$provideCompletionItems(U,K,X,re,q){return this._withAdapter(U,Q,ie=>ie.provideCompletionItems(h.URI.revive(K),X,re,q),void 0)}$resolveCompletionItem(U,K,X){return this._withAdapter(U,Q,re=>re.resolveCompletionItem(K,X),void 0)}$releaseCompletionItems(U,K){this._withAdapter(U,Q,X=>X.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(U,K,X){const re=this._addNewAdapter(new O(this._documents,X,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideInlineCompletions(U,K,X,re,q){return this._withAdapter(U,O,ie=>ie.provideInlineCompletions(h.URI.revive(K),X,re,q),void 0)}$handleInlineCompletionDidShow(U,K,X){this._withAdapter(U,O,async re=>{re.handleDidShowCompletionItem(K,X)},void 0)}$freeInlineCompletionsList(U,K){this._withAdapter(U,O,async X=>{X.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(U,K,X,re){const q=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,ie=this._addNewAdapter(new de(this._documents,X),U);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),q),this._createDisposable(ie)}$provideSignatureHelp(U,K,X,re,q){return this._withAdapter(U,de,ie=>ie.provideSignatureHelp(h.URI.revive(K),X,re,q),void 0)}$releaseSignatureHelp(U,K){this._withAdapter(U,de,X=>X.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(U,K,X){const re=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new $(this._documents,X),U);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),re);let ie=this._createDisposable(q);if(re!==void 0){const ge=X.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(re));ie=E.Disposable.from(ie,ge)}return ie}$provideInlayHints(U,K,X,re){return this._withAdapter(U,$,q=>q.provideInlayHints(h.URI.revive(K),X,re),void 0)}registerDocumentLinkProvider(U,K,X){const re=this._addNewAdapter(new ne(this._documents,X),U);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(K),typeof X.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(U,K,X){return this._withAdapter(U,ne,re=>re.provideLinks(h.URI.revive(K),X),void 0)}$resolveDocumentLink(U,K,X){return this._withAdapter(U,ne,re=>re.resolveLink(K,X),void 0)}$releaseDocumentLinks(U,K){this._withAdapter(U,ne,X=>X.releaseLinks(K),void 0)}registerColorProvider(U,K,X){const re=this._addNewAdapter(new he(this._documents,X),U);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDocumentColors(U,K,X){return this._withAdapter(U,he,re=>re.provideColors(h.URI.revive(K),X),[])}$provideColorPresentations(U,K,X,re){return this._withAdapter(U,he,q=>q.provideColorPresentations(h.URI.revive(K),X,re),void 0)}registerFoldingRangeProvider(U,K,X){const re=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Xe(new ye(this._documents,X),U)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(K),q);let ie=this._createDisposable(re);if(q!==void 0){const ge=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ie=E.Disposable.from(ie,ge)}return ie}$provideFoldingRanges(U,K,X,re){return this._withAdapter(U,ye,q=>q.provideFoldingRanges(h.URI.revive(K),X,re),void 0)}registerSelectionRangeProvider(U,K,X){const re=this._addNewAdapter(new Ne(this._documents,X,this._logService),U);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideSelectionRanges(U,K,X,re){return this._withAdapter(U,Ne,q=>q.provideSelectionRanges(h.URI.revive(K),X,re),[])}registerCallHierarchyProvider(U,K,X){const re=this._addNewAdapter(new Me(this._documents,X),U);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$prepareCallHierarchy(U,K,X,re){return this._withAdapter(U,Me,q=>Promise.resolve(q.prepareSession(h.URI.revive(K),X,re)),void 0)}$provideCallHierarchyIncomingCalls(U,K,X,re){return this._withAdapter(U,Me,q=>q.provideCallsTo(K,X,re),void 0)}$provideCallHierarchyOutgoingCalls(U,K,X,re){return this._withAdapter(U,Me,q=>q.provideCallsFrom(K,X,re),void 0)}$releaseCallHierarchy(U,K){this._withAdapter(U,Me,X=>Promise.resolve(X.releaseSession(K)),void 0)}registerTypeHierarchyProvider(U,K,X){const re=this._addNewAdapter(new $e(this._documents,X),U);return this._proxy.$registerTypeHierarchyProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$prepareTypeHierarchy(U,K,X,re){return this._withAdapter(U,$e,q=>Promise.resolve(q.prepareSession(h.URI.revive(K),X,re)),void 0)}$provideTypeHierarchySupertypes(U,K,X,re){return this._withAdapter(U,$e,q=>q.provideSupertypes(K,X,re),void 0)}$provideTypeHierarchySubtypes(U,K,X,re){return this._withAdapter(U,$e,q=>q.provideSubtypes(K,X,re),void 0)}$releaseTypeHierarchy(U,K){this._withAdapter(U,$e,X=>Promise.resolve(X.releaseSession(K)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,_.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:qe._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?qe._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?qe._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:qe._serializeRegExp(U.beforeText),afterText:U.afterText?qe._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?qe._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(qe._serializeOnEnterRule)}setLanguageConfiguration(U,K,X){let{wordPattern:re}=X;if(re&&(0,_.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(K,re):this._documents.setWordDefinitionFor(K,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const q=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?qe._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?qe._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?qe._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,ie),this._createDisposable(q)}$setWordDefinitions(U){for(const K of U)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(be[201],Ee([0,1,5,9,7,36,15]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(I,n){this._handlePool=0,this._proxy=I.getProxy(h.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,n){await this._proxy.$changeLanguage(I,n);const C=this._documents.getDocumentData(I);if(!C)throw new Error(`document '${I.toString}' NOT found`);return C.document}async tokenAtPosition(I,n){const C=I.version,l=R.Position.from(n),f=await this._proxy.$tokensAtPosition(I.uri,l),u={type:S.StandardTokenType.Other,range:I.getWordRangeAtPosition(n)??new S.Range(n.line,n.character,n.line,n.character)};if(!f)return u;const g={range:R.Range.to(f.range),type:R.TokenType.to(f.type)};return!g.range.contains(n)||C!==I.version?u:g}createLanguageStatusItem(I){const n=this._handlePool++,C=this._proxy,l={selector:I,text:"",detail:"",severity:S.LanguageStatusSeverity.Information};let f;const u=()=>{f?.dispose(),f=(0,A.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:l.selector,text:l.text,message:typeof l.detail=="string"?l.detail:R.MarkdownString.from(l.detail),severity:l.severity===S.LanguageStatusSeverity.Error?E.default.Error:l.severity===S.LanguageStatusSeverity.Warning?E.default.Warning:E.default.Info})},0)},g={get selector(){return l.selector},set selector(b){l.selector=b,u()},get text(){return l.text},set text(b){l.text=b,u()},get detail(){return l.detail},set detail(b){l.detail=b,u()},get severity(){return l.severity},set severity(b){l.severity=b,u()},dispose(){f?.dispose(),C.$removeLanguageStatus(n)}};return u(),g}}e.ExtHostLanguages=_}),define(be[202],Ee([0,1,5,16,30]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(_){return _&&_.title}let A=class{constructor(y,I){this._logService=I,this._proxy=y.getProxy(h.MainContext.MainThreadMessageService)}showMessage(y,I,n,C,l){const f={extension:y};let u;typeof C=="string"||E(C)?u=[C,...l]:(f.modal=C?.modal,f.useCustom=C?.useCustom,f.detail=C?.detail,u=l),f.useCustom&&(0,S.checkProposedApiEnabled)(y);const g=[];for(let b=0;b<u.length;b++){const w=u[b];if(typeof w=="string")g.push({title:w,handle:b,isCloseAffordance:!1});else if(typeof w=="object"){let{title:T,isCloseAffordance:o}=w;g.push({title:T,isCloseAffordance:!!o,handle:b})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(I,n,f,g).then(b=>{if(typeof b=="number")return u[b]})}};A=ze([Ve(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(be[203],Ee([0,1,24,3,43,6,21,8,10,2,66,5,9,7,179,101]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(T,o,m,v,t){this._textDocumentsAndEditors=m,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=T.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=T.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=T.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const a=r.notebookEditor?.notebookUri,i=r.cell.handle,p=this._documents.get(a)?.getCell(i);if(p)return p.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(T=>T.apiEditor)}getEditorById(T){const o=this._editors.get(T);if(!o)throw new Error(`unknown text editor: ${T}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(T){for(const[o,m]of this._editors)if(m.apiEditor===T)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(T,o){const m=this._documents.get(T);if(!m&&!o)throw new Error(`NO notebook document for '${T}'`);return m}_getProviderData(T){const o=this._notebookContentProviders.get(T);if(!o)throw new Error(`NO provider for '${T}'`);return o}registerNotebookContentProvider(T,o,m,v,t){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:T,provider:m});let r;return m.onDidChangeNotebookContentOptions&&(r=m.onDidChangeNotebookContentOptions(()=>{const a=l.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(o,a)})),this._notebookProxy.$registerNotebookProvider({id:T.identifier,location:T.extensionLocation},o,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(T,t)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(T,o){if(!o)return;const m=o.filenamePattern.map(v=>l.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(o.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:T.identifier,providerDisplayName:T.displayName||T.name,displayName:o.displayName,filenamePattern:m,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(T,o,m){const v=b._notebookStatusBarItemProviderHandlePool++,t=typeof m.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,o);let r;return t!==void 0&&(r=m.onDidChangeCellStatusBarItems(a=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),r&&r.dispose()})}async createNotebookDocument(T){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:T.viewType,content:T.content&&l.NotebookData.from(T.content)});return I.URI.revive(o)}async openNotebookDocument(T){const o=this._documents.get(T);if(o)return o.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(T),v=this._documents.get(I.URI.revive(m));return(0,y.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(T,o){I.URI.isUri(T)&&(T=await this.openNotebookDocument(T));let m;typeof o=="object"?m={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:m={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(T.uri,T.notebookType,m),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(T,o,m,v){const t=this._notebookStatusBarItemProviders.get(T),r=I.URI.revive(o),a=this._documents.get(r);if(!a||!t)return;const i=a.getCellFromIndex(m);if(!i)return;const c=await t.provideCellStatusBarItems(i.apiCell,v);if(!c)return;const p=new E.DisposableStore,d=this._statusBarCache.add([p]),k=(Array.isArray(c)?c:[c]).map(s=>l.NotebookStatusBarItem.from(s,this._commandsConverter,p));return{cacheId:d,items:k}}$releaseNotebookCellStatusBarItems(T){this._statusBarCache.delete(T)}registerNotebookSerializer(T,o,m,v,t){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,m),this._notebookProxy.$registerNotebookSerializer(r,{id:T.identifier,location:T.extensionLocation},o,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(T,t)),(0,E.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(T,o,m){const v=this._notebookSerializer.get(T);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(o.buffer,m);return l.NotebookData.from(t)}async $notebookToData(T,o,m){const v=this._notebookSerializer.get(T);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(l.NotebookData.to(o),m);return h.VSBuffer.wrap(t)}async $openNotebook(T,o,m,v,t){const{provider:r}=this._getProviderData(T),a=await r.openNotebook(I.URI.revive(o),{backupId:m,untitledDocumentData:v?.buffer},t);return{metadata:a.metadata??Object.create(null),cells:a.cells.map(l.NotebookCellData.from)}}async $saveNotebook(T,o,m){const v=this.getNotebookDocument(I.URI.revive(o)),{provider:t}=this._getProviderData(T);return await t.saveNotebook(v.apiNotebook,m),!0}async $saveNotebookAs(T,o,m,v){const t=this.getNotebookDocument(I.URI.revive(o)),{provider:r}=this._getProviderData(T);return await r.saveNotebookAs(I.URI.revive(m),t.apiNotebook,v),!0}async $backupNotebook(T,o,m){const v=this.getNotebookDocument(I.URI.revive(o)),t=this._getProviderData(T),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),a=String((0,S.hash)([v.uri.toString(),this._backupIdPool++])),i=I.URI.joinPath(r,a),c=await t.provider.backupNotebook(v.apiNotebook,{destination:i},m);return v.updateBackup(c),c.id}_createExtHostEditor(T,o,m){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const v=new g.ExtHostNotebookEditor(o,this._notebookEditorsProxy,T,m.visibleRanges.map(l.NotebookRange.to),m.selections.map(l.NotebookRange.to),typeof m.viewColumn=="number"?l.ViewColumn.to(m.viewColumn):void 0);this._editors.set(o,v)}$acceptDocumentAndEditorsDelta(T){if(T.removedDocuments)for(const m of T.removedDocuments){const v=I.URI.revive(m),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===v.toString()&&this._editors.delete(r.id)}if(T.addedDocuments){const m=[];for(const v of T.addedDocuments){const t=I.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,a=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,v);m.push(...v.cells.map(i=>u.ExtHostCell.asModelAddData(a.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(T.addedEditors)for(const m of T.addedEditors){if(this._editors.has(m.id))return;const v=I.URI.revive(m.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,m.id,m)}const o=[];if(T.removedEditors)for(const m of T.removedEditors){const v=this._editors.get(m);v&&(this._editors.delete(m),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),o.push(v))}if(T.visibleEditors){this._visibleNotebookEditors=T.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const m=new Set;this._visibleNotebookEditors.forEach(v=>m.add(v.id));for(const v of this._editors.values()){const t=m.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}T.newActiveEditor===null?this._activeNotebookEditor=void 0:T.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(T.newActiveEditor)),T.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(be[204],Ee([0,1,3,54,16,5,13,9]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(C,l){const f=y._Keys.nextId();C.$registerNotebookEditorDecorationType(f,_.NotebookDecorationRenderOptions.from(l)),this.value={key:f,dispose(){C.$removeNotebookEditorDecorationType(f)}}}}y._Keys=new R.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(C,l,f){this._logService=C,this._extHostRpc=l,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new y(this._extHostRpc.getProxy(E.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,l);const f=this._notebooksAndEditors.getEditorById(C);l.visibleRanges&&f._acceptVisibleRanges(l.visibleRanges.ranges.map(_.NotebookRange.to)),l.selections&&f._acceptSelections(l.selections.selections.map(_.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const l in C)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(_.ViewColumn.to(C[l]))}};I=ze([Ve(0,S.ILogService),Ve(1,A.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(be[205],Ee([0,1,3,6,5,26,2,9,71,21,15,72,20,17,16,7,30]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,a,i){this._initData=r,this._extHostNotebook=a,this._logService=i,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,a,i,c,p){for(let O of this._kernelData.values())if(O.controller.id===r&&E.ExtensionIdentifier.equals(t.identifier,O.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const d=this._handlePool++,D=this;this._logService.trace(`NotebookController[${d}], CREATED by ${t.identifier.value}, ${r}`);const k=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let s=!1;const P=new R.DisposableStore,F=new h.Emitter,x=new h.Emitter,j={id:`${t.identifier.value}/${r}`,notebookType:a,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:p?p.map(_.NotebookRendererScript.from):[]};let ae=c??k,oe;this._proxy.$addKernel(d,j).catch(O=>{console.log(O),s=!0});let V=0;const W=()=>{if(s)return;const O=++V;Promise.resolve().then(()=>{O===V&&this._proxy.$updateKernel(d,j)})},L=new I.ResourceMap,Q={get id(){return r},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return j.label},set label(O){j.label=O??t.displayName??t.name,W()},get detail(){return j.detail??""},set detail(O){j.detail=O,W()},get description(){return j.description??""},set description(O){j.description=O,W()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(O){j.supportedLanguages=O,W()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(O){j.supportsExecutionOrder=O,W()},get rendererScripts(){return j.preloads?j.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return ae},set executeHandler(O){ae=O??k},get interruptHandler(){return oe},set interruptHandler(O){oe=O,j.supportsInterrupt=Boolean(O),W()},createNotebookCellExecution(O){if(s)throw new Error("notebook controller is DISPOSED");if(!L.has(O.notebook.uri))throw D._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(L.keys()).map(G=>G.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return D._createNotebookCellExecution(O)},dispose:()=>{s||(this._logService.trace(`NotebookController[${d}], DISPOSED`),s=!0,this._kernelData.delete(d),P.dispose(),F.dispose(),x.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(O,G){D._proxy.$updateNotebookPriority(d,O.uri,G)},onDidReceiveMessage:x.event,postMessage(O,G){return(0,b.checkProposedApiEnabled)(t),D._proxy.$postMessage(d,G&&D._extHostNotebook.getIdByEditor(G),O)},asWebviewUri(O){return(0,b.checkProposedApiEnabled)(t),(0,y.asWebviewUri)(O,D._initData.remote)}};return this._kernelData.set(d,{extensionId:t.identifier,controller:Q,onDidReceiveMessage:x,onDidChangeSelection:F,associatedNotebooks:L}),Q}$acceptNotebookAssociation(t,r,a){const i=this._kernelData.get(t);if(i){const c=this._extHostNotebook.getNotebookDocument(A.URI.revive(r));a?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),a),i.onDidChangeSelection.fire({selected:a,notebook:c.apiNotebook})}}async $executeCells(t,r,a){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(A.URI.revive(r)),p=[];for(let d of a){const D=c.getCell(d);D&&p.push(D.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),p.length),await i.controller.executeHandler.call(i.controller,p,c.apiNotebook,i.controller)}catch(d){this._logService.error(`NotebookController[${t}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(t,r,a){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(A.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(let p of a){const d=c.getCell(p);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,a){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:a}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const i=new o(a.notebook,a,this._proxy);this._activeExecutions.set(a.uri,i);const c=i.onDidChangeState(()=>{i.state===T.Resolved&&(i.dispose(),c.dispose(),this._activeExecutions.delete(a.uri))});return i.asApiObject()}};w=ze([Ve(3,u.ILogService)],w),e.ExtHostNotebookKernels=w;var T;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(T||(T={}));class o extends R.Disposable{constructor(t,r,a){super();this._document=t,this._cell=r,this._proxy=a,this._onDidChangeState=new h.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=T.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new m(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===T.Init)throw new Error("Must call start before modifying cell output");if(this._state===T.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const a=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return a===r.items?_.NotebookCellOutput.from(r):_.NotebookCellOutput.from({items:a,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,a){const i=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,f.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:a,outputs:c})}async updateOutputItems(t,r,a){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(_.NotebookCellOutputItem.from),outputId:r.id,append:a})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(a){t._executionOrder=a,t.mixinMetadata({executionOrder:a})},start(a){if(t._state===T.Resolved||t._state===T.Started)throw new Error("Cannot call start again");t._state=T.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:a??null})},end(a,i){if(t._state===T.Resolved)throw new Error("Cannot call resolve twice");t._state=T.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:a??null,runEndTime:i??null})},clearOutput(a){return t.verifyStateForOutput(),t.updateOutputs([],a,!1)},appendOutput(a,i){return t.verifyStateForOutput(),t.updateOutputs(a,i,!0)},replaceOutput(a,i){return t.verifyStateForOutput(),t.updateOutputs(a,i,!1)},appendOutputItems(a,i){return t.verifyStateForOutput(),t.updateOutputItems(a,i,!0)},replaceOutputItems(a,i){return t.verifyStateForOutput(),t.updateOutputItems(a,i,!1)}})}}class m{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(be[206],Ee([0,1,3,5,101]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(_,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,y,I){const n=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:I})}createRendererMessaging(_,y){if(!_.contributes?.notebookRenderer?.some(l=>l.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const I=!!_.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(l,f,u)=>{const g=I?l:b=>{const w={};n.set(w,b.editor),l({editor:w,message:b.message})};return this.getOrCreateEmitterFor(y).event(g,f,u)},postMessage:(l,f)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,f]=[f,l]);const u=I?f:n.get(f),g=u&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(g?.id,y,l)}}}getOrCreateEmitterFor(_){let y=this._rendererMessageEmitters.get(_);return y||(y=new h.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,y),y)}}e.ExtHostNotebookRenderers=E}),define(be[105],Ee([0,1,5,3,6,24,4,13]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends S.Disposable{constructor(u,g,b,w,T){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=T,this._id=T.$register(this.name,g,b,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?E.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(g=>this._proxy.$clear(g,u))}show(u,g){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof u=="boolean"?u:g)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class I extends y{constructor(u,g,b){super(u,!1,void 0,g,b)}append(u){super.append(u),this._id.then(g=>this._proxy.$append(g,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class n extends y{constructor(u,g,b){super(u,!0,g,void 0,b)}append(u){throw new Error("Not supported")}}class C{constructor(u,g){this.name=u,this._channel=g}append(u){this._channel.then(g=>g.append(u))}appendLine(u){this._channel.then(g=>g.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,g){this._channel.then(b=>b.show(u,g))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=C;let l=class{constructor(u){this._proxy=u.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new I(u,g.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new n(u,g,this._proxy)}};l=ze([Ve(0,_.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(be[207],Ee([0,1,15,20,3,6,5,2,7,12,17,36]),function(ee,e,h,R,S,E,A,_,y,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(f,u,g){const b=f.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(i,c){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=c}showQuickPick(i,c,p,d=R.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(i),k=++this._instances,s=b.$show(k,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},d),P={},F=s.then(()=>P);return Promise.race([F,D]).then(x=>{if(x!==P)return D.then(j=>{const ae=[];for(let oe=0;oe<j.length;oe++){const V=j[oe];let W,L,Q,O,G;typeof V=="string"?W=V:(W=V.label,L=V.description,Q=V.detail,O=V.picked,G=V.alwaysShow),ae.push({label:W,description:L,handle:oe,detail:Q,picked:O,alwaysShow:G})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=oe=>{p.onDidSelectItem(j[oe])}),b.$setItems(k,ae),s.then(oe=>{if(typeof oe=="number")return j[oe];if(Array.isArray(oe))return oe.map(V=>j[V])})})}).then(void 0,x=>{if(!(0,I.isPromiseCanceledError)(x))return b.$setError(k,x),Promise.reject(x)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,c=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,b.$input(i,typeof this._validateInput=="function",c).then(void 0,p=>{if(!(0,I.isPromiseCanceledError)(p))return Promise.reject(p)})}$validateInput(i){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,c=R.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!p)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(D=>D.uri.toString()===p.uri.toString())}createQuickPick(i,c){const p=new t(i,c,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(i){const c=new r(i,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(i,c){const p=this._sessions.get(i);p&&p._fireDidChangeValue(c)}$onDidAccept(i){const c=this._sessions.get(i);c&&c._fireDidAccept()}$onDidChangeActive(i,c){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeActive(c)}$onDidChangeSelection(i,c){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeSelection(c)}$onDidTriggerButton(i,c){const p=this._sessions.get(i);p&&p._fireDidTriggerButton(c)}$onDidHide(i){const c=this._sessions.get(i);c&&c._fireDidHide()}}class T{constructor(i,c){this._extensionId=i,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((c,p)=>{const d=c===y.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(d,c)}),this.update({buttons:i.map((c,p)=>({iconPath:o(c.iconPath),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const c=this._handlesToButtons.get(i);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,E.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(i){if(!this._disposed){for(const c of Object.keys(i)){const p=i[c];this._pendingUpdate[c]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}T._nextId=1;function o(a){if(a instanceof y.ThemeIcon)return{id:a.id};const i=v(a),c=m(a);return{dark:typeof i=="string"?_.URI.file(i):i,light:typeof c=="string"?_.URI.file(c):c}}function m(a){return typeof a=="object"&&"light"in a?a.light:a}function v(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends T{constructor(i,c,p){super(i,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,p)=>{this._handlesToItems.set(p,c),this._itemsToHandles.set(c,p)}),this.update({items:i.map((c,p)=>({label:c.label,description:c.description,handle:p,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(i){const c=(0,n.coalesce)(i.map(p=>this._handlesToItems.get(p)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(i){const c=(0,n.coalesce)(i.map(p=>this._handlesToItems.get(p)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class r extends T{constructor(i,c){super(i,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(u,g)}e.createExtHostQuickOpen=l}),define(be[208],Ee([0,1,2,3,52,6,15,5,17,116,16,26,30,65,9]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(p){if(p)return typeof p.iconPath=="string"?h.URI.file(p.iconPath):h.URI.isUri(p.iconPath)||f.ThemeIcon.isThemeIcon(p.iconPath)?p.iconPath:void 0}function b(p,d){if(!p.iconPath&&!d.iconPath)return 0;if(p.iconPath){if(!d.iconPath)return 1}else return-1;const D=typeof p.iconPath=="string"?p.iconPath:h.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id,k=typeof d.iconPath=="string"?d.iconPath:h.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,I.comparePaths)(D,k)}function w(p,d){let D=0;if(p.strikeThrough!==d.strikeThrough)return p.strikeThrough?1:-1;if(p.faded!==d.faded)return p.faded?1:-1;if(p.tooltip!==d.tooltip)return(p.tooltip||"").localeCompare(d.tooltip||"");if(D=b(p,d),D!==0)return D;if(p.light&&d.light)D=b(p.light,d.light);else{if(p.light)return 1;if(d.light)return-1}if(D!==0)return D;if(p.dark&&d.dark)D=b(p.dark,d.dark);else{if(p.dark)return 1;if(d.dark)return-1}return D}function T(p,d){if(p.command!==d.command)return p.command<d.command?-1:1;if(p.title!==d.title)return p.title<d.title?-1:1;if(p.tooltip!==d.tooltip){if(p.tooltip!==void 0&&d.tooltip!==void 0)return p.tooltip<d.tooltip?-1:1;if(p.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(p.arguments===d.arguments)return 0;if(p.arguments)if(d.arguments){if(p.arguments.length!==d.arguments.length)return p.arguments.length-d.arguments.length}else return 1;else return-1;for(let D=0;D<p.arguments.length;D++){const k=p.arguments[D],s=d.arguments[D];if(k!==s)return k<s?-1:1}return 0}function o(p,d){let D=(0,I.comparePaths)(p.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(D!==0)return D;if(p.command&&d.command)D=T(p.command,d.command);else{if(p.command)return 1;if(d.command)return-1}if(D!==0)return D;if(p.decorations&&d.decorations)D=w(p.decorations,d.decorations);else{if(p.decorations)return 1;if(d.decorations)return-1}return D}function m(p,d){for(let D=0;D<p.length;D++)if(p[D]!==d[D])return!1;return!0}function v(p,d){return p.command===d.command&&p.title===d.title&&p.tooltip===d.tooltip&&(p.arguments&&d.arguments?m(p.arguments,d.arguments):p.arguments===d.arguments)}function t(p,d){return(0,y.equals)(p,d,v)}class r{constructor(d,D,k){this._extension=d,this._proxy=D,this._sourceControlHandle=k,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,l.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,D){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,D)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=r;class a{constructor(d,D,k,s,P){this._proxy=d,this._commands=D,this._sourceControlHandle=k,this._id=s,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,D){const k=this._resourceStatesCommandsMap.get(d);return k?(0,A.asPromise)(()=>this._commands.executeCommand(k.command,...k.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(o),k=(0,y.sortedDiff)(this._resourceSnapshot,d,o).map(F=>{const x=F.toInsert.map(j=>{const ae=this._resourceHandlePool++;this._resourceStatesMap.set(ae,j);const oe=j.resourceUri;let V;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const ye=new E.DisposableStore;V=this._commands.converter.toInternal(j.command,ye),this._resourceStatesDisposablesMap.set(ae,ye)}else this._resourceStatesCommandsMap.set(ae,j.command);const W=g(j.decorations),L=j.decorations&&g(j.decorations.light)||W,Q=j.decorations&&g(j.decorations.dark)||W,O=[L,Q],G=j.decorations&&j.decorations.tooltip||"",de=j.decorations&&!!j.decorations.strikeThrough,$=j.decorations&&!!j.decorations.faded,ne=j.contextValue||"";return{rawResource:[ae,oe,O,G,de,$,ne,V],handle:ae}});return{start:F.start,deleteCount:F.deleteCount,toInsert:x}}),s=k.map(({start:F,deleteCount:x,toInsert:j})=>[F,x,j.map(ae=>ae.rawResource)]),P=k.reverse();for(const{start:F,deleteCount:x,toInsert:j}of P){const ae=j.map(V=>V.handle),oe=this._handlesSnapshot.splice(F,x,...ae);for(const V of oe)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=d,s}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class i{constructor(d,D,k,s,P,F){this._proxy=D,this._commands=k,this._id=s,this._label=P,this._rootUri=F,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,s,P,F)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=d;const D=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:D})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=d;const D=(d||[]).map(k=>this._commands.converter.toInternal(k,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}createResourceGroup(d,D){const k=new a(this._proxy,this._commands,this.handle,d,D),s=R.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,s),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const d=[],D=[];for(const[k,s]of this.createdResourceGroups){s.dispose();const P=k.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(k),this.eventuallyUpdateResourceStates()});R.Event.once(k.onDidDispose)(()=>{this.updatedResourceGroups.delete(k),P.dispose(),this._groups.delete(k.handle),this._proxy.$unregisterGroup(this.handle,k.handle)}),d.push([k.handle,k.id,k.label,k.features]);const F=k._takeResourceStateSnapshot();F.length>0&&D.push([k.handle,F]),this._groups.set(k.handle,k)}this._proxy.$registerGroups(this.handle,d,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(D=>{const k=D._takeResourceStateSnapshot();k.length!==0&&d.push([D.handle,k])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,ze([(0,S.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let c=class xn{constructor(d,D,k){this._commands=D,this.logService=k,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=d.getProxy(_.MainContext.MainThreadSCM),this._telemetry=d.getProxy(_.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===3){const P=this._sourceControls.get(s.sourceControlHandle);if(!P)return s;const F=P.getResourceGroup(s.groupHandle);return F?F.getResourceState(s.handle):s}else if(s&&s.$mid===4){const P=this._sourceControls.get(s.sourceControlHandle);return P?P.getResourceGroup(s.groupHandle):s}else if(s&&s.$mid===5){const P=this._sourceControls.get(s.handle);return P||s}return s}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,D,k,s){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,D,k,s),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const P=xn._handlePool++,F=new i(d,this._proxy,this._commands,D,k,s);this._sourceControls.set(P,F);const x=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier))||[];return x.push(F),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(d.identifier),x),F}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const D=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier)),k=D&&D[D.length-1];return k&&k.inputBox}$provideOriginalResource(d,D,k){const s=h.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,s.toString());const P=this._sourceControls.get(d);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(s,k)).then(F=>F||null)}$onInputBoxValueChange(d,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const k=this._sourceControls.get(d);return k&&k.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(d,D,k,s){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,D,k);const P=this._sourceControls.get(d);if(!P)return Promise.resolve(void 0);const F=P.getResourceGroup(D);return F?F.$executeResourceCommand(k,s):Promise.resolve(void 0)}$validateInput(d,D,k){this.logService.trace("ExtHostSCM#$validateInput",d);const s=this._sourceControls.get(d);return!s||!s.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>s.inputBox.validateInput(D,k)).then(P=>{if(!P)return Promise.resolve(void 0);const F=u.MarkdownString.fromStrict(P.message);return F?Promise.resolve([F,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};c._handlePool=0,c=ze([Ve(2,n.ILogService)],c),e.ExtHostSCM=c});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[209],Ee([0,1,7,5,136,6,9]),function(ee,e,h,R,S,E,A){"use strict";var _,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class I{constructor(f,u,g,b,w=h.StatusBarAlignment.Left,T){_.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,it(this,_,f,"f"),it(this,y,u,"f"),this._entryId=I.ID_GEN++,this._extension=g,this._id=b,this._alignment=w,this._priority=T}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!I.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Be(this,y,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Be(this,y,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let u;this._name?u=this._name:u=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=I.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,_,"f").$setEntry(this._entryId,f,u,this._text,b,this._command?.internal,g,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=I,_=new WeakMap,y=new WeakMap,I.ID_GEN=0,I.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const u={message:f};return this._messages.unshift(u),this._update(),new h.Disposable(()=>{const g=this._messages.indexOf(u);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class C{constructor(f,u){this._proxy=f.getProxy(R.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(f,u,g,b){return new I(this._proxy,this._commands,f,u,g,b)}setStatusBarMessage(f,u){const g=this._statusMessage.setMessage(f);let b;return typeof u=="number"?b=setTimeout(()=>g.dispose(),u):typeof u!="undefined"&&u.then(()=>g.dispose(),()=>g.dispose()),new h.Disposable(()=>{g.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=C}),define(be[77],Ee([0,1,5,3,4]),function(ee,e,h,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(_){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=_.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(_,y){this._proxy.$registerExtensionStorageKeysToSync(_,y)}getValue(_,y,I){return this._proxy.$getValue(_,y).then(n=>n||I)}setValue(_,y,I){return this._proxy.$setValue(_,y,I)}$acceptValue(_,y,I){this._onDidChangeStorage.fire({shared:_,key:y,value:I})}}e.ExtHostStorage=E,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(be[78],Ee([0,1,4,29,16,76,2]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let _=class{constructor(I,n,C){this._logService=n,this._extHostFileSystem=C,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(I){return A.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,n=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(I){if(this._value)return A.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return A.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};_=ze([Ve(0,R.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,E.IExtHostConsumerFileSystem)],_),e.ExtensionStoragePaths=_}),define(be[39],Ee([0,1,3,5,4,2,13,6,7,137,12,174,20,37,158,65,10]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(c,p,d,D){this._proxy=c,this._id=p,this._creationOptions=d,this._name=D,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(s=>this._pidPromiseComplete=s);const k=this;this.value={get name(){return k._name||""},get processId(){return k._pidPromise},get creationOptions(){return k._creationOptions},get exitStatus(){return k._exitStatus},sendText(s,P=!0){k._checkDisposed(),k._proxy.$sendText(k._id,s,P)},show(s){k._checkDisposed(),k._proxy.$show(k._id,s)},hide(){k._checkDisposed(),k._proxy.$hide(k._id)},dispose(){k._disposed||(k._disposed=!0,k._proxy.$dispose(k._id))},get dimensions(){if(!(k._cols===void 0||k._rows===void 0))return{columns:k._cols,rows:k._rows}}}}async create(c,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,b.withNullAsUndefined)(c.shellPath),shellArgs:(0,b.withNullAsUndefined)(c.shellArgs),cwd:(0,b.withNullAsUndefined)(c.cwd),env:(0,b.withNullAsUndefined)(c.env),icon:(0,b.withNullAsUndefined)(r(c.iconPath)),color:g.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,b.withNullAsUndefined)(c.message),strictEnv:(0,b.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(p?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(p?.useShellEnvironment),isSplitTerminal:p?.isSplitTerminal,target:p?.target})}async createExtensionTerminal(c,p,d,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:g.ThemeColor.isThemeColor(D)?D.id:void 0,isSplitTerminal:c,target:p}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,p){return c===this._cols&&p===this._rows||c===0||p===0?!1:(this._cols=c,this._rows=p,!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(p=>{p!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=w;class T{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,p){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:p})}async processBinary(c){}acknowledgeDataEvent(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(p=>this._onProcessData.fire(p)),this._pty.onDidClose&&this._pty.onDidClose((p=void 0)=>{this._onProcessExit.fire(p===void 0?void 0:p)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(p=>this._onProcessOverrideDimensions.fire(p&&{cols:p.columns,rows:p.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(p=>this._onProcessTitleChanged.fire(p)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=T;let o=1,m=class extends _.Disposable{constructor(c,p){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this._onDidOpenTerminal=new h.Emitter,this._onDidChangeActiveTerminal=new h.Emitter,this._onDidChangeTerminalDimensions=new h.Emitter,this._proxy=p.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[d,D]of this._terminalProcesses)D.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,p){const d=new w(this._proxy,(0,f.generateUuid)(),c,c.name),D=new T(c.pty);return d.createExtensionTerminal(p?.isSplitTerminal,p?.target,r(c.iconPath),a(c.color)).then(k=>{const s=this._setupExtHostProcessListeners(k,D);this._terminalProcessDisposables[k]=s}),this._terminals.push(d),d.value}attachPtyToTerminal(c,p){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const D=new T(p),k=this._setupExtHostProcessListeners(c,D);this._terminalProcessDisposables[c]=k}async $acceptActiveTerminalChanged(c){const p=this._activeTerminal;if(c===null){this._activeTerminal=void 0,p!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(c);d&&(this._activeTerminal=d,p!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,p){const d=this._getTerminalById(c);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:p})}async $acceptTerminalDimensions(c,p,d){const D=this._getTerminalById(c);D&&D.setDimensions(p,d)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(c,p,d){this._terminalProcesses.get(c)?.resize(p,d)}async $acceptTerminalTitleChange(c,p){const d=this._getTerminalById(c);d&&(d.name=p)}async $acceptTerminalClosed(c,p){const d=this._getTerminalObjectIndexById(this._terminals,c);if(d!==null){const D=this._terminals.splice(d,1)[0];D.setExitCode(p),this._onDidCloseTerminal.fire(D.value)}}$acceptTerminalOpened(c,p,d,D){if(p){const P=this._getTerminalObjectIndexById(this._terminals,p);if(P!==null){this._terminals[P]._id=c,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const k={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:E.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},s=new w(this._proxy,c,k,d);this._terminals.push(s),this._onDidOpenTerminal.fire(s.value),s.isOpen=!0}async $acceptTerminalProcessId(c,p){const d=this._getTerminalById(c);d&&d._setProcessId(p)}async $startExtensionTerminal(c,p){const d=this._getTerminalById(c);if(!d)return{message:(0,I.localize)(0,null,c)};d.isOpen||await new Promise(k=>{const s=this.onDidOpenTerminal(async P=>{P===d.value&&(s.dispose(),k())})});const D=this._terminalProcesses.get(c);D?D.startSendingEvents(p):this._extensionTerminalAwaitingStart[c]={initialDimensions:p}}_setupExtHostProcessListeners(c,p){const d=new _.DisposableStore;d.add(p.onProcessReady(k=>this._proxy.$sendProcessReady(c,k.pid,k.cwd))),d.add(p.onProcessTitleChanged(k=>this._proxy.$sendProcessTitle(c,k))),this._bufferer.startBuffering(c,p.onProcessData),d.add(p.onProcessExit(k=>this._onProcessExit(c,k))),p.onProcessOverrideDimensions&&d.add(p.onProcessOverrideDimensions(k=>this._proxy.$sendOverrideDimensions(c,k))),this._terminalProcesses.set(c,p);const D=this._extensionTerminalAwaitingStart[c];return D&&p instanceof T&&(p.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),d}$acceptProcessAckDataEvent(c,p){this._terminalProcesses.get(c)?.acknowledgeDataEvent(p)}$acceptProcessInput(c,p){this._terminalProcesses.get(c)?.input(p)}$acceptProcessResize(c,p,d){try{this._terminalProcesses.get(c)?.resize(p,d)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(c,p){this._terminalProcesses.get(c)?.shutdown(p)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(p=>this._proxy.$sendProcessInitialCwd(c,p))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(p=>this._proxy.$sendProcessCwd(c,p))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,p,d){if(this._profileProviders.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this._profileProviders.set(p,d),this._proxy.$registerProfileProvider(p,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(p),this._proxy.$unregisterProfileProvider(p)})}async $createContributedProfileTerminal(c,p){const d=new l.CancellationTokenSource().token,D=await this._profileProviders.get(c)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,p);return}this.createTerminalFromOptions(D.options,p)}}async $provideLinks(c,p){const d=this._getTerminalById(c);if(!d)return[];this._terminalLinkCache.delete(c);const D=this._terminalLinkCancellationSource.get(c);D&&D.dispose(!0);const k=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,k);const s=[],P={terminal:d.value,line:p},F=[];for(const ae of this._linkProviders)F.push(new Promise(async oe=>{k.token.onCancellationRequested(()=>oe({provider:ae,links:[]}));const V=await ae.provideTerminalLinks(P,k.token)||[];k.token.isCancellationRequested||oe({provider:ae,links:V})}));const x=await Promise.all(F);if(k.token.isCancellationRequested)return[];const j=new Map;for(const ae of x)ae&&ae.links.length>0&&s.push(...ae.links.map(oe=>{const V={id:o++,startIndex:oe.startIndex,length:oe.length,label:oe.tooltip};return j.set(V.id,{provider:ae.provider,link:oe}),V}));return this._terminalLinkCache.set(c,j),s}$activateLink(c,p){const d=this._terminalLinkCache.get(c)?.get(p);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(c,p){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const d=this._terminalProcessDisposables[c];d&&(d.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,p)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,p){const d=this._getTerminalObjectIndexById(c,p);return d!==null?c[d]:null}_getTerminalObjectIndexById(c,p){let d=null;return c.some((D,k)=>D._id===p?(d=k,!0):!1),d}getEnvironmentVariableCollection(c){let p=this._environmentVariableCollections.get(c.identifier.value);return p||(p=new v,this._setEnvironmentVariableCollection(c.identifier.value,p)),p}_syncEnvironmentVariableCollection(c,p){const d=(0,C.serializeEnvironmentVariableCollection)(p.map);this._proxy.$setEnvironmentVariableCollection(c,p.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(c){c.forEach(p=>{const d=p[0],D=new v(p[1]);this._setEnvironmentVariableCollection(d,D)})}$acceptDefaultProfile(c,p){this._defaultProfile=c,this._defaultAutomationProfile=p}_setEnvironmentVariableCollection(c,p){this._environmentVariableCollections.set(c,p),p.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,p)})}};m=ze([Ve(1,A.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class v{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,p){this._setIfDiffers(c,{value:p,type:y.EnvironmentVariableMutatorType.Replace})}append(c,p){this._setIfDiffers(c,{value:p,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,p){this._setIfDiffers(c,{value:p,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,p){const d=this.map.get(c);(!d||d.value!==p.value||d.type!==p.type)&&(this.map.set(c,p),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,p){this.map.forEach((d,D)=>c.call(p,D,d,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends m{constructor(c){super(!1,c)}createTerminal(c,p,d){throw new n.NotSupportedError}createTerminalFromOptions(c,p){throw new n.NotSupportedError}};t=ze([Ve(0,A.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function a(i){return g.ThemeColor.isThemeColor(i)?i:void 0}});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[210],Ee([0,1,24,20,3,53,43,55,6,23,10,37,5,13,68,9,7,182,99,73]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(F,x){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(l.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new r(this.proxy),x.registerArgumentProcessor({processArgument:j=>j?.$mid===13?g.TestItem.toItemFromContext(j):j})}createTestController(F,x){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const j=new y.DisposableStore,ae=j.add(new w.SingleUseTestCollection(F));ae.root.label=x;const oe=new Map,V=this.proxy,W={items:ae.root.children,get label(){return x},set label(Q){x=Q,ae.root.label=Q,V.$updateControllerLabel(F,x)},get id(){return F},createRunProfile:(Q,O,G,de)=>{let $=(0,A.hash)(Q);for(;oe.has($);)$++;const ne=new k(this.proxy,F,$,Q,O,G,de);return oe.set($,ne),ne},createTestItem(Q,O,G){return new u.TestItemImpl(F,Q,O,G)},createTestRun:(Q,O,G=!0)=>this.runTracker.createTestRun(F,ae,Q,O,G),set resolveHandler(Q){ae.resolveHandler=Q},get resolveHandler(){return ae.resolveHandler},dispose:()=>{j.dispose()}};W.createRunConfiguration=W.createRunProfile,V.$registerTestController(F,x),j.add((0,y.toDisposable)(()=>V.$unregisterTestController(F)));const L={controller:W,collection:ae,profiles:oe};return this.controllers.set(F,L),j.add((0,y.toDisposable)(()=>this.controllers.delete(F))),j.add(ae.onDidGenerateDiff(Q=>V.$publishDiff(F,Q))),W}createTestObserver(){return this.observer.checkout()}async runTests(F,x=R.CancellationToken.None){const j=a(F);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ae=this.controllers.get(j.controllerId);if(!ae)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(oe=>oe.id)??[ae.collection.root.id],profileGroup:s[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:F.exclude?.map(oe=>({testId:oe.id,controllerId:j.controllerId}))},x)}$provideFileCoverage(F,x,j){return _.Iterable.find(this.runTracker.trackers,ae=>ae.id===F)?.getCoverage(x)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(F,x,j,ae){return _.Iterable.find(this.runTracker.trackers,oe=>oe.id===F)?.getCoverage(x)?.resolveFileCoverage(j,ae)??Promise.resolve([])}$configureRunProfile(F,x){this.controllers.get(F)?.profiles.get(x)?.configureHandler?.()}$publishTestResults(F){this.results=Object.freeze(F.map(x=>(0,I.deepFreeze)(g.TestResults.to(x))).concat(this.results).sort((x,j)=>j.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:F,testId:x},j){const ae=this.controllers.get(F)?.collection;ae&&(await ae.expand(x,j<0?Infinity:j),ae.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,x){const j=this.controllers.get(F.controllerId);if(!j)return;const{collection:ae,profiles:oe}=j,V=oe.get(F.profileId);if(!V)return;const W=F.testIds.map(G=>ae.tree.get(G)).filter(n.isDefined),L=F.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(n.isDefined).filter(G=>W.some(de=>de.fullId.compare(G.fullId)===2));if(!W.length)return;const Q=new b.TestRunRequest(W.some(G=>G.actual instanceof u.TestItemRootImpl)?void 0:W.map(G=>G.actual),L.map(G=>G.actual),V),O=this.runTracker.prepareForMainThreadTestRun(Q,i.fromInternal(F,j.collection),x);try{await V.runHandler(Q,x)}finally{O.isRunning&&!x.isCancellationRequested&&await S.Event.toPromise(O.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};v=ze([Ve(0,f.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends y.Disposable{constructor(F,x,j){super();this.dto=F,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(j)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ae}of this.tasks.values())ae.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const x=this.dto.id,j=this.dto.controllerId,ae=(0,C.generateUuid)(),oe=new c(this.proxy,x,ae),V=Q=>(O,...G)=>{if(W){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),Q(O,...G))};let W=!1;const L={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return oe.coverageProvider},set coverageProvider(Q){oe.coverageProvider=Q},enqueued:V(Q=>{this.proxy.$updateTestStateInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),1)}),skipped:V(Q=>{this.proxy.$updateTestStateInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),5)}),started:V(Q=>{this.proxy.$updateTestStateInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),2)}),errored:V((Q,O,G)=>{this.proxy.$appendTestMessagesInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)]),this.proxy.$updateTestStateInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),6,G)}),failed:V((Q,O,G)=>{this.proxy.$appendTestMessagesInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)]),this.proxy.$updateTestStateInRun(x,ae,o.TestId.fromExtHostTestItem(Q,j).toString(),4,G)}),passed:V((Q,O)=>{this.proxy.$updateTestStateInRun(x,ae,o.TestId.fromExtHostTestItem(Q,this.dto.controllerId).toString(),3,O)}),appendOutput:Q=>{W||this.proxy.$appendOutputToRun(x,ae,h.VSBuffer.fromString(Q))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(x,ae),this.tasks.delete(ae),this.isRunning||this.dispose())}};return this.tasks.set(ae,{run:L,coverage:oe}),this.proxy.$startedTestRunTask(x,{id:ae,name:F,running:!0}),L}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof u.TestItemImpl))throw new u.InvalidTestItemError(F.id);if(this.sharedTestIds.has(F.id))return;const x=[];for(;x.unshift(g.TestItem.from(F)),!(this.sharedTestIds.has(F.id)||(this.sharedTestIds.add(F.id),!F.parent));)F=F.parent;const j=this.dto.colllection.root;this.sharedTestIds.has(j.id)||(this.sharedTestIds.add(j.id),x.unshift(g.TestItem.from(j))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class r{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,x,j){return this.getTracker(F,x,j)}cancelRunById(F){for(const x of this.tracked.values())if(x.id===F){x.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,x,j,ae,oe){const V=this.tracked.get(j);if(V)return V.createRun(ae);const W=i.fromPublic(F,x,j,oe),L=a(j);this.proxy.$startedExtensionTestRun({controllerId:F,profile:L&&{group:s[L.kind],id:L.profileId},exclude:j.exclude?.map(O=>O.id)??[],id:W.id,include:j.include?.map(O=>O.id)??[x.root.id],persist:oe});const Q=this.getTracker(j,W);return Q.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),Q.createRun(ae)}getTracker(F,x,j){const ae=new t(x,this.proxy,j);return this.tracked.set(F,ae),ae.onEnd(()=>this.tracked.delete(F)),ae}}e.TestRunCoordinator=r;const a=P=>{if(!!P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(F,x,j,ae,oe,V){this.controllerId=F,this.id=x,this.isPersisted=oe,this.colllection=V,this.includePrefix=j.map(W=>W+"\0"),this.excludePrefix=ae.map(W=>W+"\0")}static fromPublic(F,x,j,ae){return new i(F,(0,C.generateUuid)(),j.include?.map(oe=>o.TestId.fromExtHostTestItem(oe,F).toString())??[F],j.exclude?.map(oe=>o.TestId.fromExtHostTestItem(oe,F).toString())??[],ae,x)}static fromInternal(F,x){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,x)}isIncluded(F){const x=o.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const j of this.excludePrefix)if(x===j||x.startsWith(j))return!1;for(const j of this.includePrefix)if(x===j||x.startsWith(j))return!0;return!1}}e.TestRunDto=i;class c{constructor(F,x,j){this.proxy=F,this.runId=x,this.taskId=j}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(F,x){const j=await this.fileCoverage;let ae=j?.[F];return!this._coverageProvider||!j||!ae?[]:(ae.detailedCoverage||(ae=j[F]=await this._coverageProvider.resolveFileCoverage?.(ae,x)??ae),ae.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class p extends T.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,g.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:x,removed:j}=this;return{get added(){return[...F].map(ae=>ae.revived)},get updated(){return[...x].map(ae=>ae.revived)},get removed(){return[...j].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends T.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,x){return{...F,revived:g.TestItem.toPlain(F.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new p(this.changeEmitter)}}e.MirroredTestCollection=d;class D{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(x=>x.revived)},dispose:(0,E.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class k{constructor(F,x,j,ae,oe,V,W=!1){this.controllerId=x,this.profileId=j,this._label=ae,this.kind=oe,this.runHandler=V,this._isDefault=W,m.set(this,void 0),it(this,m,F,"f");const L=s[oe];if(typeof L!="number")throw new Error(`Unknown TestRunProfile.group ${oe}`);Be(this,m,"f").$publishTestRunProfile({profileId:j,controllerId:x,label:ae,group:L,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Be(this,m,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=k,m=new WeakMap;const s={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(be[211],Ee([0,1,3,17,5,102,9,7]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const C=this._extHostDocumentsAndEditors.allEditors();return n?C:C.map(l=>l.value)}async showTextDocument(n,C,l){let f;typeof C=="number"?f={position:A.ViewColumn.from(C),preserveFocus:l}:typeof C=="object"?f={position:A.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?A.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:f={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,f),g=u&&this._extHostDocumentsAndEditors.getEditor(u);if(g)return g.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,C){return new E.TextEditorDecorationType(this._proxy,n,C).value}$acceptEditorPropertiesChanged(n,C){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(C.options&&l._acceptOptions(C.options),C.selections){const f=C.selections.selections.map(A.Selection.to);l._acceptSelections(f)}if(C.visibleRanges){const f=R.coalesce(C.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(f)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...C.options,lineNumbers:A.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const f=_.TextEditorSelectionChangeKind.fromValue(C.selections.source),u=C.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:u,kind:f})}if(C.visibleRanges){const f=R.coalesce(C.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const C in n){const l=this._extHostDocumentsAndEditors.getEditor(C);if(!l)throw new Error("Unknown text editor");const f=A.ViewColumn.to(n[C]);l.value.viewColumn!==f&&(l._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(be[212],Ee([0,1,2,4,5,6,7]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class _{constructor(n,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const f=l.uri===void 0?void 0:h.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(y(f))?.get(l.handle)}return l}})}async $getTimeline(n,C,l,f,u){return this._providers.get(n)?.provideTimeline(h.URI.revive(C),l,f,u)}registerTimelineProvider(n,C,l,f){const u=new E.DisposableStore,g=this.convertTimelineItem(C.id,f,u).bind(this);let b;C.onDidChange&&(b=C.onDidChange(T=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...T,id:C.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:n,onDidChange:void 0,async provideTimeline(T,o,m,v){v?.resetCache&&(u.clear(),w.get(C.id)?.clear());const t=await C.provideTimeline(T,o,m);if(t==null)return;const r=g(T,v);return{...t,source:C.id,items:t.items.map(r)}},dispose(){for(const T of w.values())T.get(C.id)?.clear();b?.dispose(),u.dispose()}})}convertTimelineItem(n,C,l){return(f,u)=>{let g;if(u?.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const w=y(f);g=b.get(w),g===void 0&&(g=new Map,b.set(w,g))}return b=>{const{iconPath:w,...T}=b,o=`${n}|${b.id??b.timestamp}`;g?.set(o,b);let m,v,t;return b.iconPath&&(w instanceof A.ThemeIcon?t={id:w.id,color:w.color}:h.URI.isUri(w)?(m=w,v=w):{light:m,dark:v}=w),{...T,id:T.id??void 0,handle:o,source:n,command:b.command?C.toInternal(b.command,l):void 0,icon:m,iconDark:v,themeIcon:t,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,E.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=_;function y(I){return I?.toString()}}),define(be[213],Ee([0,1,6,11,2,5]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(y){this._openers=new Map,this._proxy=y.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,I,n,C){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const l=C.schemes.find(f=>!A.supportedSchemes.has(f));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,n),this._proxy.$registerUriOpener(I,C.schemes,y,C.label),(0,h.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(y,I,n){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const l=S.URI.revive(I);return C.canOpenExternalUri(l,n)}async $openUri(y,I,n){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(S.URI.revive(I.resolvedUri),{sourceUri:S.URI.revive(I.sourceUri)},n)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[214],Ee([0,1,5,2,6,12,26]),function(ee,e,h,R,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class _{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(I,n){if(this.handles.has(A.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const C=_.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(I)),this.handlers.set(C,n),this._proxy.$registerUriHandler(C,I),(0,S.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(I)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(I,n){const C=this.handlers.get(I);if(!C)return Promise.resolve(void 0);try{C.handleUri(R.URI.revive(n))}catch(l){(0,E.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(I){return R.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=_,_.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[50],Ee([0,1,3,2,147,166,71,5]),function(ee,e,h,R,S,E,A,_){"use strict";var y,I,n,C,l,f,u,g,b,w,T,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(d,D,k,s,P,F,x){y.set(this,void 0),I.set(this,void 0),n.set(this,void 0),C.set(this,void 0),l.set(this,void 0),f.set(this,void 0),u.set(this,""),g.set(this,void 0),b.set(this,!1),w.set(this,!1),T.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new h.Emitter),this._onDidDispose=Be(this,o,"f").event,it(this,y,d,"f"),it(this,I,D,"f"),it(this,g,k,"f"),it(this,C,s,"f"),it(this,l,P,"f"),it(this,f,F,"f"),it(this,T,v(F),"f"),it(this,n,x,"f")}dispose(){it(this,b,!0,"f"),Be(this,o,"f").fire(),Be(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return it(this,w,!0,"f"),(0,A.asWebviewUri)(d,Be(this,C,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,u,"f")}set html(d){this.assertNotDisposed(),Be(this,u,"f")!==d&&(it(this,u,d,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(it(this,w,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,I,"f").$setHtml(Be(this,y,"f"),d))}get options(){return this.assertNotDisposed(),Be(this,g,"f")}set options(d){this.assertNotDisposed(),Be(this,I,"f").$setOptions(Be(this,y,"f"),a(Be(this,f,"f"),Be(this,l,"f"),d)),it(this,g,d,"f")}async postMessage(d){if(Be(this,b,"f"))return!1;const D=(0,E.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Be(this,T,"f")});return Be(this,I,"f").$postMessage(Be(this,y,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Be(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,y=new WeakMap,I=new WeakMap,n=new WeakMap,C=new WeakMap,l=new WeakMap,f=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,T=new WeakMap,o=new WeakMap;function v(p){try{const d=(0,S.normalizeVersion)((0,S.parseVersion)(p.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(d,D,k,s,P){this.initData=D,this.workspace=k,this._logService=s,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=d.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(d,D,...k){const s=this.getWebview(d);if(s){const{message:P}=(0,E.deserializeWebviewMessage)(D,k);s._onMessageEmitter.fire(P)}}$onMissingCsp(d,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,D,k){const s=new m(d,this._webviewProxy,i(D),this.initData,this.workspace,k,this._deprecationService);return this._webviews.set(d,s),s._onDidDispose(()=>{this._webviews.delete(d)}),s}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function r(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=r;function a(p,d,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||c(p,d)}}e.serializeWebviewOptions=a;function i(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(d=>R.URI.from(d))}}e.reviveOptions=i;function c(p,d){return[...(d?.getWorkspaceFolders()||[]).map(D=>D.uri),p.extensionLocation]}}),define(be[215],Ee([0,1,20,43,6,11,25,2,9,50,66,5,7]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=m(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,a){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const c=new f(r,a);return this._documents.set(i,c),c}delete(t,r){const a=this.key(t,r.uri);this._documents.delete(a)}key(t,r){return`${t}@@@${r}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class b{constructor(){this._providers=new Map}addTextProvider(t,r,a){return this.add(0,t,r,a)}addCustomProvider(t,r,a){return this.add(1,t,r,a)}get(t){return this._providers.get(t)}add(t,r,a,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:a,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,a,i,c){this._extHostDocuments=r,this._extensionStoragePaths=a,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new b,this._documents=new u,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,a,i){const c=new S.DisposableStore;return T(a)?(c.add(this._editorProviders.addTextProvider(r,t,a)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(r,t,a)),this.supportEditing(a)&&c.add(a.onDidChangeCustomDocument(p=>{const d=this.getCustomDocumentEntry(r,p.document.uri);if(o(p)){const D=d.addEdit(p);this._proxy.$onDidEdit(p.document.uri,r,D,p.label)}else this._proxy.$onContentChange(p.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,a,i,c){const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${r}'`);const d=_.URI.revive(t),D=await p.provider.openCustomDocument(d,{backupId:a,untitledDocumentData:i?.buffer},c);let k;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(k=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(r,D,k),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=_.URI.revive(t),{document:c}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,c),c.dispose()}async $resolveWebviewEditor(t,r,a,i,c,p){const d=this._editorProviders.get(a);if(!d)throw new Error(`No provider found for '${a}'`);const D=y.ViewColumn.to(c),k=this._extHostWebview.createNewWebview(r,i.webviewOptions,d.extension),s=this._extHostWebviewPanels.createNewWebviewPanel(r,a,i.title,D,i.panelOptions,k),P=_.URI.revive(t);switch(d.type){case 1:{const{document:F}=this.getCustomDocumentEntry(a,P);return d.provider.resolveCustomEditor(F,s,p)}case 0:{const F=this._extHostDocuments.getDocument(P);return d.provider.resolveCustomTextEditor(F,s,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,a){this.getCustomDocumentEntry(r,t).disposeEdits(a)}async $onMoveCustomEditor(t,r,a){const i=this._editorProviders.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const p=_.URI.revive(r),d=this._extHostDocuments.getDocument(p);await i.provider.moveCustomTextEditor(d,c,h.CancellationToken.None)}async $undo(t,r,a,i){return this.getCustomDocumentEntry(r,t).undo(a,i)}async $redo(t,r,a,i){return this.getCustomDocumentEntry(r,t).redo(a,i)}async $revert(t,r,a){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,a),i.disposeBackup()}async $onSave(t,r,a){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,a),i.disposeBackup()}async $onSaveAs(t,r,a,i){const c=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(c.document,_.URI.revive(a),i)}async $backup(t,r,a){const i=this.getCustomDocumentEntry(r,t),p=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},a);return i.updateBackup(p),p.id}getCustomDocumentEntry(t,r){const a=this._documents.get(t,_.URI.revive(r));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const a=this._editorProviders.get(t)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function T(v){return typeof v.resolveCustomTextEditor=="function"}function o(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function m(v){const t=v.scheme===E.Schemas.file||v.scheme===E.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[216],Ee([0,1,3,6,2,37,9,50,5,7]),function(ee,e,h,R,S,E,A,_,y,I){"use strict";var n,C,l,f,u,g,b,w,T,o,m,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(p,d,D,k,s,P,F){super();n.set(this,void 0),C.set(this,void 0),l.set(this,void 0),f.set(this,void 0),u.set(this,void 0),g.set(this,void 0),b.set(this,void 0),w.set(this,void 0),T.set(this,!0),o.set(this,!0),m.set(this,!1),v.set(this,this._register(new h.Emitter)),this.onDidDispose=Be(this,v,"f").event,t.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,n,p,"f"),it(this,C,d,"f"),it(this,l,D,"f"),it(this,u,P,"f"),it(this,w,s,"f"),it(this,g,k,"f"),it(this,f,F,"f")}dispose(){Be(this,m,"f")||(it(this,m,!0,"f"),Be(this,v,"f").fire(),Be(this,C,"f").$disposeWebview(Be(this,n,"f")),Be(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,f,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(p){this.assertNotDisposed(),Be(this,g,"f")!==p&&(it(this,g,p,"f"),Be(this,C,"f").$setTitle(Be(this,n,"f"),p))}get iconPath(){return this.assertNotDisposed(),Be(this,b,"f")}set iconPath(p){this.assertNotDisposed(),Be(this,b,"f")!==p&&(it(this,b,p,"f"),Be(this,C,"f").$setIconPath(Be(this,n,"f"),S.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Be(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,o,"f")}get visible(){return this.assertNotDisposed(),Be(this,T,"f")}_updateViewState(p){Be(this,m,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(it(this,o,p.active,"f"),it(this,T,p.visible,"f"),it(this,w,p.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(p,d){this.assertNotDisposed(),Be(this,C,"f").$reveal(Be(this,n,"f"),{viewColumn:p?A.ViewColumn.from(p):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Be(this,m,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,C=new WeakMap,l=new WeakMap,f=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,T=new WeakMap,o=new WeakMap,m=new WeakMap,v=new WeakMap,t=new WeakMap;class a{constructor(p,d,D){this.webviews=d,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,E.generateUuid)()}createWebviewPanel(p,d,D,k,s={}){const P=typeof k=="object"?k.viewColumn:k,F={viewColumn:A.ViewColumn.from(P),preserveFocus:typeof k=="object"&&!!k.preserveFocus},x=(0,_.shouldSerializeBuffersForPostMessage)(p),j=a.newHandle();this._proxy.$createWebviewPanel((0,_.toExtensionData)(p),j,d,{title:D,panelOptions:i(s),webviewOptions:(0,_.serializeWebviewOptions)(p,this.workspace,s),serializeBuffersForPostMessage:x},F);const ae=this.webviews.createNewWebview(j,s,p);return this.createNewWebviewPanel(j,d,D,P,s,ae)}$onDidChangeWebviewPanelViewStates(p){const d=Object.keys(p);d.sort((D,k)=>{const s=p[D],P=p[k];return s.active?1:P.active?-1:+s.visible-+P.visible});for(const D of d){const k=this.getWebviewPanel(D);if(!k)continue;const s=p[D];k._updateViewState({active:s.active,visible:s.visible,viewColumn:A.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,d,D){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:D,extension:p}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,_.shouldSerializeBuffersForPostMessage)(p)}),new I.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(p,d,D,k){const s=this._serializers.get(d);if(!s)throw new Error(`No serializer found for '${d}'`);const{serializer:P,extension:F}=s,x=this.webviews.createNewWebview(p,D.webviewOptions,F),j=this.createNewWebviewPanel(p,d,D.title,k,D.panelOptions,x);await P.deserializeWebviewPanel(j,D.state)}createNewWebviewPanel(p,d,D,k,s,P){const F=new r(p,this._proxy,d,D,k,s,P);return this._webviewPanels.set(p,F),F}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=a;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[217],Ee([0,1,3,6,50,5,7]),function(ee,e,h,R,S,E,A){"use strict";var _,y,I,n,C,l,f,u,g,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(m,v,t,r,a,i){super();_.set(this,void 0),y.set(this,void 0),I.set(this,void 0),n.set(this,void 0),C.set(this,!1),l.set(this,void 0),f.set(this,void 0),u.set(this,void 0),g.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Be(this,g,"f").event,b.set(this,this._register(new h.Emitter)),this.onDidDispose=Be(this,b,"f").event,it(this,I,t,"f"),it(this,f,r,"f"),it(this,_,m,"f"),it(this,y,v,"f"),it(this,n,a,"f"),it(this,l,i,"f")}dispose(){Be(this,C,"f")||(it(this,C,!0,"f"),Be(this,b,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,f,"f")}set title(m){this.assertNotDisposed(),Be(this,f,"f")!==m&&(it(this,f,m,"f"),Be(this,y,"f").$setWebviewViewTitle(Be(this,_,"f"),m))}get description(){return this.assertNotDisposed(),Be(this,u,"f")}set description(m){this.assertNotDisposed(),Be(this,u,"f")!==m&&(it(this,u,m,"f"),Be(this,y,"f").$setWebviewViewDescription(Be(this,_,"f"),m))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,I,"f")}_setVisible(m){m===Be(this,l,"f")||Be(this,C,"f")||(it(this,l,m,"f"),Be(this,g,"f").fire())}show(m){this.assertNotDisposed(),Be(this,y,"f").$show(Be(this,_,"f"),!!m)}assertNotDisposed(){if(Be(this,C,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,y=new WeakMap,I=new WeakMap,n=new WeakMap,C=new WeakMap,l=new WeakMap,f=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap;class T{constructor(m,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:m}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(m),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(m,v,t,r,a){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:p}=i,d=this._extHostWebview.createNewWebview(m,{},p),D=new w(m,this._proxy,v,t,d,!0);this._webviewViews.set(m,D),await c.resolveWebviewView(D,{state:r},a)}async $onDidChangeWebviewViewVisibility(m,v){this.getWebviewView(m)._setVisible(v)}async $disposeWebviewView(m){const v=this.getWebviewView(m);this._webviewViews.delete(m),v.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const v=this._webviewViews.get(m);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=T}),define(be[106],Ee([0,1,3,5,2,11,8,4,13]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Bn{constructor(C){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=C.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,l){let f;if(typeof C=="string"){f=C;try{C=S.URI.parse(C)}catch(u){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,A.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,f,l)}async asExternalUri(C,l){if((0,A.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(C,l);return S.URI.from(f)}};I.InitialState={focused:!0},I=ze([Ve(0,y.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,_.createDecorator)("IExtHostWindow")}),define(be[218],Ee([0,1,16,5,29,13]),function(ee,e,h,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends h.AbstractLogger{constructor(y,I){super();this._proxy=y.getProxy(R.MainContext.MainThreadLog),this._logFile=I.logFile.toJSON(),this.setLevel(I.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...I){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(y,...I){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(y,...I){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(y,...I){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(y,...I){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(y,...I){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};A=ze([Ve(0,E.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(be[219],Ee([0,1,15,20,12,3,6,117,187,103,24]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,c){try{return JSON.stringify(i,c)}catch(p){return"null"}}function f(i,c){return JSON.stringify(i,c)}function u(i){return i?(c,p)=>p&&p.$mid===1?i.transformOutgoing(p):p:null}var g;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},T=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class m extends A.Disposable{constructor(c,p=null,d=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=p,this._uriTransformer=d,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,k=I.ProxyIdentifier.count;D<k;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,_.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:p,sid:d}=c;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,d)),this._proxies[p]}_createProxy(c,p){let d={get:(D,k)=>(typeof k=="string"&&!D[k]&&k.charCodeAt(0)===36&&(D[k]=(...s)=>this._remoteCall(c,k,s)),k===o?p:D[k])};return new Proxy(Object.create(null),d)}set(c,p){return this._locals[c.nid]=p,p}assertRegistered(c){for(let p=0,d=c.length;p<d;p++){const D=c[p];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const p=c.byteLength,d=v.read(c,0),D=d.readUInt8(),k=d.readUInt32();switch(D){case 1:case 2:{let{rpcId:s,method:P,args:F}=t.deserializeRequestJSONArgs(d);this._uriTransformer&&(F=(0,_.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(p,k,s,P,F,D===2);break}case 3:case 4:{let{rpcId:s,method:P,args:F}=t.deserializeRequestMixedArgs(d);this._uriTransformer&&(F=(0,_.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(p,k,s,P,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(p,k,0,"ack"),this._onDidReceiveAcknowledge(k);break}case 6:{this._receiveCancel(p,k);break}case 7:{this._receiveReply(p,k,void 0);break}case 9:{let s=t.deserializeReplyOKJSON(d);this._uriTransformer&&(s=(0,_.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReply(p,k,s);break}case 8:{let s=t.deserializeReplyOKVSBuffer(d);this._receiveReply(p,k,s);break}case 10:{let s=t.deserializeReplyErrError(d);this._uriTransformer&&(s=(0,_.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReplyErr(p,k,s);break}case 11:{this._receiveReplyErr(p,k,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,p,d,D,k,s){this._logger&&this._logger.logIncoming(c,p,1,`receiveRequest ${(0,I.getStringIdentifierForProxy)(d)}.${D}(`,k);const P=String(p);let F,x;if(s){const ae=new R.CancellationTokenSource;k.push(ae.token),F=this._invokeHandler(d,D,k),x=()=>ae.cancel()}else F=this._invokeHandler(d,D,k),x=w;this._cancelInvokedHandlers[P]=x;const j=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(j.byteLength,p,1,"ack"),this._protocol.send(j),F.then(ae=>{delete this._cancelInvokedHandlers[P];const oe=t.serializeReplyOK(p,ae,this._uriReplacer);this._logger&&this._logger.logOutgoing(oe.byteLength,p,1,"reply:",ae),this._protocol.send(oe)},ae=>{delete this._cancelInvokedHandlers[P];const oe=t.serializeReplyErr(p,ae);this._logger&&this._logger.logOutgoing(oe.byteLength,p,1,"replyErr:",ae),this._protocol.send(oe)})}_receiveCancel(c,p){this._logger&&this._logger.logIncoming(c,p,1,"receiveCancel");const d=String(p);this._cancelInvokedHandlers[d]&&this._cancelInvokedHandlers[d]()}_receiveReply(c,p,d){this._logger&&this._logger.logIncoming(c,p,0,"receiveReply:",d);const D=String(p);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const k=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],k.resolveOk(d)}_receiveReplyErr(c,p,d){this._logger&&this._logger.logIncoming(c,p,0,"receiveReplyErr:",d);const D=String(p);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const k=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let s;d&&(d.$isError?(s=new Error,s.name=d.name,s.message=d.message,s.stack=d.stack):s=d),k.resolveErr(s)}_invokeHandler(c,p,d){try{return Promise.resolve(this._doInvokeHandler(c,p,d))}catch(D){return Promise.reject(D)}}_doInvokeHandler(c,p,d){const D=this._locals[c];if(!D)throw new Error("Unknown actor "+(0,I.getStringIdentifierForProxy)(c));let k=D[p];if(typeof k!="function")throw new Error("Unknown method "+p+" on actor "+(0,I.getStringIdentifierForProxy)(c));return k.apply(D,d)}_remoteCall(c,p,d){if(this._isDisposed)return Promise.reject(S.canceled());let D=null;if(d.length>0&&R.CancellationToken.isCancellationToken(d[d.length-1])&&(D=d.pop()),D&&D.isCancellationRequested)return Promise.reject(S.canceled());const k=t.serializeRequestArguments(d,this._uriReplacer),s=++this._lastMessageId,P=String(s),F=new y.LazyPromise;D&&D.onCancellationRequested(()=>{const j=t.serializeCancel(s);this._logger&&this._logger.logOutgoing(j.byteLength,s,0,"cancel"),this._protocol.send(t.serializeCancel(s))}),this._pendingRPCReplies[P]=F,this._onWillSendRequest(s);const x=t.serializeRequest(s,c,p,k,!!D);return this._logger&&this._logger.logOutgoing(x.byteLength,s,0,`request: ${(0,I.getStringIdentifierForProxy)(c)}.${p}(`,d),this._protocol.send(x),F}}e.RPCProtocol=m,C=T,m.UNRESPONSIVE_TIME=3*1e3;class v{constructor(c,p){this._buff=c,this._offset=p}static alloc(c,p,d){let D=new v(n.VSBuffer.alloc(d+1+4),0);return D.writeUInt8(c),D.writeUInt32(p),D}static read(c,p){return new v(c,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const d=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,d}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,d}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,p}static sizeMixedArray(c,p){let d=0;d+=1;for(let D=0,k=c.length;D<k;D++){const s=c[D],P=p[D];switch(d+=1,P){case 1:d+=this.sizeLongString(s);break;case 2:d+=this.sizeVSBuffer(s);break;case 3:break}}return d}writeMixedArray(c,p){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let d=0,D=c.length;d<D;d++){const k=c[d];switch(p[d]){case 1:this.writeUInt8(1),this.writeLongString(k);break;case 2:this.writeUInt8(2),this.writeVSBuffer(k);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(c);for(let d=0;d<c;d++)switch(this.readUInt8()){case 1:p[d]=this.readLongString();break;case 2:p[d]=this.readVSBuffer();break;case 3:p[d]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(c){for(let p=0,d=c.length;p<d;p++)if(c[p]instanceof n.VSBuffer||typeof c[p]=="undefined")return!0;return!1}static serializeRequestArguments(c,p){if(this._arrayContainsBufferOrUndefined(c)){let d=[],D=[];for(let k=0,s=c.length;k<s;k++){const P=c[k];P instanceof n.VSBuffer?(d[k]=P,D[k]=2):typeof P=="undefined"?(d[k]=n.VSBuffer.alloc(0),D[k]=3):(d[k]=n.VSBuffer.fromString(f(P,p)),D[k]=1)}return{type:"mixed",args:d,argsType:D}}return{type:"simple",args:f(c,p)}}static serializeRequest(c,p,d,D,k){return D.type==="mixed"?this._requestMixedArgs(c,p,d,D.args,D.argsType,k):this._requestJSONArgs(c,p,d,D.args,k)}static _requestJSONArgs(c,p,d,D,k){const s=n.VSBuffer.fromString(d),P=n.VSBuffer.fromString(D);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(s),F+=v.sizeLongString(P);let x=v.alloc(k?2:1,c,F);return x.writeUInt8(p),x.writeShortString(s),x.writeLongString(P),x.buffer}static deserializeRequestJSONArgs(c){const p=c.readUInt8(),d=c.readShortString(),D=c.readLongString();return{rpcId:p,method:d,args:JSON.parse(D)}}static _requestMixedArgs(c,p,d,D,k,s){const P=n.VSBuffer.fromString(d);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(P),F+=v.sizeMixedArray(D,k);let x=v.alloc(s?4:3,c,F);return x.writeUInt8(p),x.writeShortString(P),x.writeMixedArray(D,k),x.buffer}static deserializeRequestMixedArgs(c){const p=c.readUInt8(),d=c.readShortString(),D=c.readMixedArray(),k=new Array(D.length);for(let s=0,P=D.length;s<P;s++){const F=D[s];typeof F=="string"?k[s]=JSON.parse(F):k[s]=F}return{rpcId:p,method:d,args:k}}static serializeAcknowledged(c){return v.alloc(5,c,0).buffer}static serializeCancel(c){return v.alloc(6,c,0).buffer}static serializeReplyOK(c,p,d){return typeof p=="undefined"?this._serializeReplyOKEmpty(c):p instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,p):this._serializeReplyOKJSON(c,l(p,d))}static _serializeReplyOKEmpty(c){return v.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,p){let d=0;d+=v.sizeVSBuffer(p);let D=v.alloc(8,c,d);return D.writeVSBuffer(p),D.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,p){const d=n.VSBuffer.fromString(p);let D=0;D+=v.sizeLongString(d);let k=v.alloc(9,c,D);return k.writeLongString(d),k.buffer}static deserializeReplyOKJSON(c){const p=c.readLongString();return JSON.parse(p)}static serializeReplyErr(c,p){return p?this._serializeReplyErrEror(c,p):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,p){const d=n.VSBuffer.fromString(l(S.transformErrorForSerialization(p),null));let D=0;D+=v.sizeLongString(d);let k=v.alloc(10,c,D);return k.writeLongString(d),k.buffer}static deserializeReplyErrError(c){const p=c.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(c){return v.alloc(11,c,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var a;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(a||(a={}))}),define(be[220],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(E){const A=_=>{self.removeEventListener("message",A);const y=_.data;Object.defineProperties(self,{postMessage:{value(I,n){y.postMessage(I,n)}},onmessage:{get(){return y.onmessage},set(I){y.onmessage=I}}}),y.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(E,A,_){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${h})('${A}'))`,I=new Blob([y],{type:"application/javascript"}),n=URL.createObjectURL(I),C=new MessageChannel,l=n,f={type:"_newWorker",id:l,port:C.port2,url:n,options:_};E(f,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:l};C.port1.postMessage(u),URL.revokeObjectURL(n),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(u){C.port1.onmessage=u}},onmessageerror:{get(){return C.port1.onmessageerror},set(u){C.port1.onmessageerror=u}}}),C.port1.addEventListener("messageerror",u=>{const g=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(g)}),C.port1.addEventListener("message",u=>{const g=new MessageEvent("message",{data:u.data});this.dispatchEvent(g)}),C.port1.start()}}e.NestedWorker=R}),define(be[221],Ee([0,1,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(be[222],Ee([0,1,11,14,22,2,4,96,46,183,221]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let C=class $n{constructor(f,u,g,b){this.localUserHome=f,this.remoteAgentService=u,this.environmentService=g,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||S.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||f})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,u){if(f.remoteAuthority)return h.Schemas.vscodeRemote;const g=(0,_.getVirtualWorkspaceScheme)(u.getWorkspace());if(g)return g;const b=u.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:h.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?R.win32:R.posix)}async fileURI(f){let u="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const b=f.indexOf("/",2);b===-1?(u=f.substring(2),f="/"):(u=f.substring(2,b),f=f.substring(b)||"/")}return E.URI.from({scheme:h.Schemas.file,authority:u,path:f,query:"",fragment:""})}};C=ze([Ve(1,n.IRemoteAgentService),Ve(2,I.IWorkbenchEnvironmentService),Ve(3,y.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(be[107],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(A,_){this.line=A,this.character=_}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,_){return new h(0,0)}with(A){return new h(0,0)}}e.Position=h;class R{constructor(A,_,y,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(A,_),this.end=new h(y,I)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var S;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[40],Ee([0,1,17,27,23,44,8,4,14,12,107]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",l=" characters skipped \u27EB",f=(C.length+l.length+5)*2;e.ISearchService=(0,_.createDecorator)("searchService");var u;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function b(L){return!!L.preview}e.resultIsMatch=b;function w(L){return!!L.resource}e.isFileMatch=w;function T(L){return!!L.message}e.isProgressMessage=T;var o;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=m;class v{constructor(Q,O,G){this.ranges=O;const de=Array.isArray(O)?O:[O];if(G&&G.matchLines===1&&t(de)){Q=(0,A.getNLines)(Q,G.matchLines);let $="",ne=0,he=0;const ye=Math.floor(G.charsPerLine/5),Ne=[];for(const Me of de){const $e=Math.max(Me.startColumn-ye,0),Xe=Me.startColumn+G.charsPerLine;if($e>he+ye+f){const qe=C+($e-he)+l;$+=qe+Q.slice($e,Xe),ne+=$e-(he+qe.length)}else $+=Q.slice(he,Xe);Ne.push(new a(0,Me.startColumn-ne,Me.endColumn-ne)),he=Xe}this.preview={text:$,matches:Array.isArray(this.ranges)?Ne:Ne[0]}}else{const $=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:Q,matches:(0,h.mapArrayOrNot)(O,ne=>new r(ne.startLineNumber-$,ne.startColumn,ne.endLineNumber-$,ne.endColumn))}}}}e.TextSearchMatch=v;function t(L){const Q=L[0].startLineNumber;for(const O of L)if(O.startLineNumber!==Q||O.endLineNumber!==Q)return!1;return!0}class r{constructor(Q,O,G,de){this.startLineNumber=Q,this.startColumn=O,this.endLineNumber=G,this.endColumn=de}}e.SearchRange=r;class a extends r{constructor(Q,O,G){super(Q,O,Q,G)}}e.OneLineRange=a;var i;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(L,Q=!0){const O=L&&L.files&&L.files.exclude,G=Q&&L&&L.search&&L.search.exclude;if(!O&&!G)return;if(!O||!G)return O||G;let de=Object.create(null);return de=S.mixin(de,S.deepClone(O)),de=S.mixin(de,S.deepClone(G),!0),de}e.getExcludes=c;function p(L,Q){return L.excludePattern&&R.match(L.excludePattern,Q)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&R.match(L.includePattern,Q)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(O=>{const G=O.folder.fsPath;if(E.isEqualOrParent(Q,G)){const de=y.relative(G,Q);return!O.includePattern||!!R.match(O.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var d;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(Q,O){super(Q);this.code=O}}e.SearchError=D;function k(L){const Q=L.message;if((0,I.isPromiseCanceledError)(L))return new D(Q,d.canceled);try{const O=JSON.parse(Q);return new D(O.message,O.code)}catch(O){return new D(Q,d.other)}}e.deserializeSearchError=k;function s(L){const Q={message:L.message,code:L.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=s;function P(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=P;function F(L){return L.type==="success"}e.isSerializedSearchSuccess=F;function x(L){return!!L.path}e.isSerializedFileMatch=x;function j(L,Q){const O=L.searchPath?L.searchPath:L.relativePath;return(0,A.fuzzyContains)(O,Q)}e.isFilePatternMatch=j;class ae{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ae;function oe(L,Q){const O={...L||{},...Q||{}};return Object.keys(O).filter(G=>{const de=O[G];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=oe;class V{constructor(Q,O){this._parsedIncludeExpression=null,this._excludeExpression={...Q.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let G=Q.includePattern;O.includePattern&&(G?G={...G,...O.includePattern}:G=O.includePattern),G&&(this._parsedIncludeExpression=R.parse(G))}includedInQuerySync(Q,O,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,O,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Q,O,G))}includedInQuery(Q,O,G){return Promise.resolve(this._parsedExcludeExpression(Q,O,G)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(Q,O,G)).then(ne=>!!ne):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W(L){for(const Q in L)if(typeof L[Q]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,17,15,20,3,21,11,81,25,8,10,2,139,4,16,154,46,47,29,13,7,40,5]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o,m,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(P,F,x){return new I.ExtUri(j=>d(j,x)).isEqual(P,F)}function i(P,F,x){return a(P.uri,F.uri,x)?0:(0,n.compare)(P.uri.toString(),F.uri.toString())}function c(P,F,x){return P.index!==F.index?P.index<F.index?-1:1:a(P.uri,F.uri,x)?(0,n.compare)(P.name,F.name):(0,n.compare)(P.uri.toString(),F.uri.toString())}function p(P,F,x,j){const ae=P.slice(0).sort((V,W)=>x(V,W,j)),oe=F.slice(0).sort((V,W)=>x(V,W,j));return(0,h.delta)(ae,oe,(V,W)=>x(V,W,j))}function d(P,F){const x=F.getCapabilities(P.scheme);return!(x&&x&1024)}class D extends w.Workspace{constructor(F,x,j,ae,oe,V){super(F,j.map(W=>new w.WorkspaceFolder(W)),ae,V);this._name=x,this._isUntitled=oe,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(V),j.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(F,x,j,ae){if(!F)return{workspace:null,added:[],removed:[]};const{id:oe,name:V,folders:W,configuration:L,isUntitled:Q}=F,O=[],G=x;x?W.forEach((he,ye)=>{const Ne=l.URI.revive(he.uri),Me=D._findFolder(j||x,Ne,ae);Me?(Me.name=he.name,Me.index=he.index,O.push(Me)):O.push({uri:Ne,name:he.name,index:ye})}):O.push(...W.map(({uri:he,name:ye,index:Ne})=>({uri:l.URI.revive(he),name:ye,index:Ne}))),O.sort((he,ye)=>he.index<ye.index?-1:1);const de=new D(oe,V,O,L?l.URI.revive(L):null,!!Q,he=>d(he,ae)),{added:$,removed:ne}=p(G?G.workspaceFolders:[],de.workspaceFolders,i,ae);return{workspace:de,added:$,removed:ne}}static _findFolder(F,x,j){for(let ae=0;ae<F.folders.length;ae++){const oe=F.workspaceFolders[ae];if(a(oe.uri,x,j))return oe}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,I.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let k=class{constructor(F,x,j,ae){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ae,this._extHostFileSystemInfo=j,this._requestIdProvider=new y.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const oe=x.workspace;this._confirmedWorkspace=oe?new D(oe.id,oe.name,[],oe.configuration?l.URI.revive(oe.configuration):null,!!oe.isUntitled,V=>d(V,j)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:_.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,j,...ae){const oe=[];if(Array.isArray(ae)&&ae.forEach(O=>{l.URI.isUri(O.uri)&&!oe.some(G=>a(G.uri,O.uri,this._extHostFileSystemInfo))&&oe.push({uri:O.uri,name:O.name||(0,I.basenameOrAuthority)(O.uri)})}),this._unconfirmedWorkspace||[x,j].some(O=>typeof O!="number"||O<0)||j===0&&oe.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+j>V.length)return!1;const W=V.slice(0);W.splice(x,j,...oe.map(O=>({uri:O.uri,name:O.name||(0,I.basenameOrAuthority)(O.uri),index:void 0})));for(let O=0;O<W.length;O++){const G=W[O];if(W.some((de,$)=>$!==O&&a(G.uri,de.uri,this._extHostFileSystemInfo)))return!1}W.forEach((O,G)=>O.index=G);const{added:L,removed:Q}=p(V,W,c,this._extHostFileSystemInfo);if(L.length===0&&Q.length===0)return!1;if(this._proxy){const O=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(O,x,j,oe).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,f.localize)(0,null,O,G.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,x){let j,ae="";if(typeof F=="string"?(j=l.URI.file(F),ae=F):typeof F!="undefined"&&(j=F,ae=F.fsPath),!j)return ae;const oe=this.getWorkspaceFolder(j,!0);if(!oe)return ae;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let V=(0,I.relativePath)(oe.uri,j);return x&&oe.name&&(V=`${oe.name}/${V}`),V}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:j,removed:ae}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:ae}))}findFiles(F,x,j,ae,oe=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ae.value}, entryPoint: findFiles`);let V;if(x===null?V=!1:x&&(typeof x=="string"?V=x:V=x.pattern),oe&&oe.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:L}=s(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(W),(0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)(V),(0,C.withUndefinedAsNull)(j),oe).then(Q=>Array.isArray(Q)?Q.map(O=>l.URI.revive(O)):[])}async findTextInFiles(F,x,j,ae,oe=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ae.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),W=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:L,folder:Q}=s(x.include),O=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,G={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:W,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:L,excludePattern:O},de=!1;if(this._activeSearchCallbacks[V]=$=>{if(de)return;const ne=l.URI.revive($.resource);$.results.forEach(he=>{(0,t.resultIsMatch)(he)?j({uri:ne,preview:{text:he.preview.text,matches:(0,h.mapArrayOrNot)(he.preview.matches,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:(0,h.mapArrayOrNot)(he.ranges,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):j({uri:ne,text:he.text,lineNumber:he.lineNumber})})},oe.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(Q),G,V,oe);return delete this._activeSearchCallbacks[V],$||{}}catch($){throw delete this._activeSearchCallbacks[V],$}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};k=ze([Ve(0,m.IExtHostRpcService),Ve(1,o.IExtHostInitDataService),Ve(2,T.IExtHostFileSystemInfo),Ve(3,g.ILogService)],k),e.ExtHostWorkspace=k,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function s(P){let F,x;return P&&(typeof P=="string"?F=P:(F=P.pattern,x=P.baseFolder||l.URI.file(P.base))),{includePattern:F,folder:x}}}),define(be[33],Ee([0,1,23,3,32,5,7,157,64,10,15,4,13,16,2]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(r,a){if(a){const i=a.split(".");let c=r;for(let p=0;c&&p<i.length;p++)c=c[i[p]];return c}}function b(r){return r instanceof u.URI}function w(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function T(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function m(r){if(b(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(T(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(a,i,c){this._proxy=a.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,i))}};v=ze([Ve(0,l.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,f.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(a,i,c,p){this._onDidChangeConfiguration=new R.Emitter,this._proxy=a,this._logService=p,this._extHostWorkspace=i,this._configuration=_.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=_.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(a,i,c){const p=m(i)||{},d=this._toReadonlyValue(a?g(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,p,c?.identifier);function D(s){if(s==null)return null;if(typeof s=="boolean")return s?1:4;switch(s){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const k={has(s){return typeof g(d,s)!="undefined"},get:(s,P)=>{this._validateConfigurationAccess(a?`${a}.${s}`:s,p,c?.identifier);let F=g(d,s);if(typeof F=="undefined")F=P;else{let x;const j=(ae,oe)=>{let V;const W=()=>{x=x||(0,h.deepClone)(d),V=V||g(x,oe)};return(0,I.isObject)(ae)?new Proxy(ae,{get:(L,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return W(),()=>V;if(x)return V=V||g(x,oe),V[Q];const O=L[Q];return typeof Q=="string"?j(O,`${oe}.${Q}`):O},set:(L,Q,O)=>(W(),V&&(V[Q]=O),!0),deleteProperty:(L,Q)=>(W(),V&&delete V[Q],!0),defineProperty:(L,Q,O)=>(W(),V&&Object.defineProperty(V,Q,O),!0)}):ae};F=j(F,s)}return F},update:(s,P,F,x)=>{s=a?`${a}.${s}`:s;const j=D(F);return P!==void 0?this._proxy.$updateConfigurationOption(j,s,P,p,x):this._proxy.$removeConfigurationOption(j,s,p,x)},inspect:s=>{s=a?`${a}.${s}`:s;const P=(0,h.deepClone)(this._configuration.inspect(s,p,this._extHostWorkspace.workspace));if(P)return{key:s,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof d=="object"&&(0,h.mixin)(k,d,!1),Object.freeze(k)}_toReadonlyValue(a){const i=c=>(0,I.isObject)(c)?new Proxy(c,{get:(p,d)=>i(p[d]),set:(p,d,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(p,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(p,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(a)}_validateConfigurationAccess(a,i,c){const p=y.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),d=c?`[${c.value}] `:"";if(p===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,i){const c=new _.ConfigurationChangeEvent(a,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,d)=>c.affectsConfiguration(p,m(d))})}_toMap(a){return a.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[108],Ee([0,1,2,15,3,5,23,7,32,49,33,20,39,13,29,4,11,22,16,75,173,12]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o,m,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var a;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(a=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(V){function W(O){if(O){const G=O;return G&&!!G.process}else return!1}V.is=W;function L(O){if(O==null)return;const G={process:O.process,args:O.args};return O.options&&(G.options=i.from(O.options)),G}V.from=L;function Q(O){if(O!=null)return new _.ProcessExecution(O.process,O.args,O.options)}V.to=Q})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(V){function W(O){if(O){const G=O;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=W;function L(O){if(O==null)return;const G={};return O.commandLine!==void 0?G.commandLine=O.commandLine:(G.command=O.command,G.args=O.args),O.options&&(G.options=p.from(O.options)),G}V.from=L;function Q(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new _.ShellExecution(O.commandLine,O.options):new _.ShellExecution(O.command,O.args?O.args:[],O.options)}V.to=Q})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var D;(function(V){function W(O){if(O){let G=O;return G&&G.customExecution==="customExecution"}else return!1}V.is=W;function L(O){return{customExecution:"customExecution"}}V.from=L;function Q(O,G){return G.get(O)}V.to=Q})(D=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(V){function W(L,Q){let O;return L.scope!==void 0&&typeof L.scope!="number"?O=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===_.TaskScope.Workspace&&Q&&Q.workspaceFile?O=Q.workspaceFile:O=m.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:O}}V.from=W})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var s;(function(V){function W(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}V.from=W})(s=e.TaskGroupDTO||(e.TaskGroupDTO={}));var P;(function(V){function W(O,G){if(O==null)return[];const de=[];for(let $ of O){const ne=L($,G);ne&&de.push(ne)}return de}V.fromMany=W;function L(O,G){if(O==null)return;let de;O.execution instanceof _.ProcessExecution?de=c.from(O.execution):O.execution instanceof _.ShellExecution?de=d.from(O.execution):O.execution&&O.execution instanceof _.CustomExecution&&(de=D.from(O.execution));const $=r.from(O.definition);let ne;return O.scope?typeof O.scope=="number"?ne=O.scope:ne=O.scope.uri:ne=_.TaskScope.Workspace,!$||!ne?void 0:{_id:O._id,definition:$,name:O.name,source:{extensionId:G.identifier.value,label:O.source,scope:ne},execution:de,isBackground:O.isBackground,group:s.from(O.group),presentationOptions:a.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}V.from=L;async function Q(O,G,de){if(O==null)return;let $;c.is(O.execution)?$=c.to(O.execution):d.is(O.execution)?$=d.to(O.execution):D.is(O.execution)&&($=D.to(O._id,de));const ne=r.to(O.definition);let he;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?he=O.source.scope:he=await G.resolveWorkspaceFolder(h.URI.revive(O.source.scope)):he=_.TaskScope.Workspace),!ne||!he)return;const ye=new _.Task(ne,he,O.name,O.source.label,$,O.problemMatchers);return O.isBackground!==void 0&&(ye.isBackground=O.isBackground),O.group!==void 0&&(ye.group=_.TaskGroup.from(O.group._id),ye.group&&(ye.group=A.deepClone(ye.group),O.group.isDefault&&(ye.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ye.presentationOptions=a.to(O.presentationOptions)),O._id&&(ye._id=O._id),O.detail&&(ye.detail=O.detail),ye}V.to=Q})(P=e.TaskDTO||(e.TaskDTO={}));var F;(function(V){function W(Q){return Q}V.from=W;function L(Q){if(!!Q)return Object.assign(Object.create(null),Q)}V.to=L})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class x{constructor(W,L,Q){this._id=L,this._task=Q,t.set(this,void 0),it(this,t,W,"f")}get task(){return this._task}terminate(){Be(this,t,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}t=new WeakMap;var j;(function(V){function W(L){return{id:L._id,task:void 0}}V.from=W})(j=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let ae=class{constructor(W,L,Q,O,G,de,$,ne){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=W.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=Q,this._editorService=O,this._configurationService=G,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,L,Q){if(!Q)return new _.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:L,provider:Q,extension:W}),this._proxy.$registerTaskProvider(O,L),new _.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(W,L){this._proxy.$registerTaskSystem(W,L)}fetchTasks(W){return this._proxy.$fetchTasks(F.from(W)).then(async L=>{const Q=[];for(let O of L){const G=await P.to(O,this._workspaceProvider,this._providedCustomExecutions2);G&&Q.push(G)}return Q})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(L=>W.push(L)),W}terminateTask(W){if(!(W instanceof x))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,L,Q){const O=this._providedCustomExecutions2.get(W.id);if(O){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,O),this._terminalService.attachPtyToTerminal(L,await O.callback(Q))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const L=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:L})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const L=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:L,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const L=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:L,exitCode:W.exitCode})}$provideTasks(W,L){const Q=this._handlers.get(W);if(!Q)return Promise.reject(new Error("no handler found"));const O=[],G=(0,R.asPromise)(()=>Q.provider.provideTasks(C.CancellationToken.None)).then(de=>this.provideTasksInternal(L,O,Q,de));return new Promise(de=>{G.then($=>{Promise.all(O).then(()=>{de($)})})})}async $resolveTask(W,L){const Q=this._handlers.get(W);if(!Q)return Promise.reject(new Error("no handler found"));if(L.definition.type!==Q.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${Q.type}].`);const O=await P.to(L,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const G=await Q.provider.resolveTask(O,C.CancellationToken.None);if(!G)return;this.checkDeprecation(G,Q);const de=P.from(G,Q.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(de.execution)&&await this.addCustomExecution(de,G,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,L,Q){const O=await this._proxy.$createTaskId(W);!Q&&!this._providedCustomExecutions2.has(O)&&this._notProvidedCustomExecutions.add(O),this._providedCustomExecutions2.set(O,L.execution)}async getTaskExecution(W,L){if(typeof W=="string"){const G=this._taskExecutionPromises.get(W);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let Q=this._taskExecutionPromises.get(W.id);if(Q)return Q;const O=new Promise(async(G,de)=>{const $=L||await P.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);$?G(new x(this,W.id,$)):de("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,O),O.then(G=>(this._taskExecutions.set(W.id,G),G),G=>Promise.reject(G))}checkDeprecation(W,L){W._deprecated&&this._deprecationService.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let Q=this._notProvidedCustomExecutions.values(),O=Q.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=Q.next()}};ae=ze([Ve(0,f.IExtHostRpcService),Ve(1,u.IExtHostInitDataService),Ve(2,y.IExtHostWorkspace),Ve(3,I.IExtHostDocumentsAndEditors),Ve(4,n.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,T.ILogService),Ve(7,o.IExtHostApiDeprecationService)],ae),e.ExtHostTaskBase=ae;let oe=class extends ae{constructor(W,L,Q,O,G,de,$,ne){super(W,L,Q,O,G,de,$,ne);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(W,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const Q=P.from(L,W);if(Q===void 0)throw new Error("Task is not valid");if(D.is(Q.execution))await this.addCustomExecution(Q,L,!1);else throw new v.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(Q),L);return this._proxy.$executeTask(Q).catch(G=>{throw new Error(G)}),O}provideTasksInternal(W,L,Q,O){const G=[];if(O)for(let de of O){this.checkDeprecation(de,Q),(!de.definition||!W[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const $=P.from(de,Q.extension);$&&D.is($.execution)?(G.push($),L.push(this.addCustomExecution($,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:Q.extension}}async resolveTaskInternal(W){if(D.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,L,Q){}};oe=ze([Ve(0,f.IExtHostRpcService),Ve(1,u.IExtHostInitDataService),Ve(2,y.IExtHostWorkspace),Ve(3,I.IExtHostDocumentsAndEditors),Ve(4,n.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,T.ILogService),Ve(7,o.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(be[223],Ee([0,1,17,51,27,84,21,11,14,25,8,10,2,120,143,94,46,100,222,40]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(D,k,s,P){this.configurationService=D,this.workspaceContextService=k,this.editorGroupsService=s,this.pathService=P}text(D,k,s={}){D=this.getContentPattern(D,s);const P=this.configurationService.getValue(),F=k&&k.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep);return{...this.commonQuery(k?.map(b.toWorkspaceFolder),s),type:2,contentPattern:D,previewOptions:s.previewOptions,maxFileSize:s.maxFileSize,usePCRE2:P.search.usePCRE2||F||!1,beforeContext:s.beforeContext,afterContext:s.afterContext,userDisabledExcludesAndIgnoreFiles:s.disregardExcludeSettings&&s.disregardIgnoreFiles}}getContentPattern(D,k){const s=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P={...D,wordSeparators:s.editor.wordSeparators};return this.isCaseSensitive(D,k)&&(P.isCaseSensitive=!0),this.isMultiline(D)&&(P.isMultiline=!0),P}file(D,k={}){return{...this.commonQuery(D,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}handleIncludeExclude(D,k){return D?(D=Array.isArray(D)?D.map(i):i(D),k?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],k={}){const s=this.handleIncludeExclude(k.includePattern,k.expandPatterns),P=this.handleIncludeExclude(k.excludePattern,k.expandPatterns),F=D.length>1,x=(s.searchPaths&&s.searchPaths.length?s.searchPaths.map(oe=>this.getFolderQueryForSearchPath(oe,k,P)):D.map(oe=>this.getFolderQueryForRoot(oe,k,P,F))).filter(oe=>!!oe),j={_reason:k._reason,folderQueries:x,usingSearchPaths:!!(s.searchPaths&&s.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:P.pattern,includePattern:s.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const V=h.coalesce(h.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(Q=>Q.resource)))).filter(L=>(0,o.pathIncludedInQuery)(j,L.fsPath)),W=this.commonQueryFromFileList(V);return{...j,...W}}const ae=k.extraFileResources&&k.extraFileResources.filter(oe=>(0,o.pathIncludedInQuery)(j,oe.fsPath));return j.extraFileResources=ae&&ae.length?ae:void 0,j}commonQueryFromFileList(D){const k=[],s=new A.ResourceMap,P={};let F=!1;return D.forEach(x=>{if(x.scheme===_.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(x)){const ae=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:y.dirname(x.fsPath)});let oe=s.get(ae);oe||(F=!0,oe={folder:ae,includePattern:{}},k.push(oe),s.set(ae,oe));const V=y.relative(ae.fsPath,x.fsPath);(0,C.assertIsDefined)(oe.includePattern)[V.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,P[x.fsPath]=!0)}),{folderQueries:k,includePattern:P,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,k){if(k.isSmartCase){if(D.isRegExp){if(n.containsUppercaseCharacter(D.pattern,!0))return!0}else if(n.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,f.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const k=W=>y.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),P=(Array.isArray(D)?D:r(D)).map(W=>{const L=this.pathService.resolvedUserHome;return L?(0,E.untildify)(W,L.scheme===_.Schemas.file?L.fsPath:L.path):W}),F=R.groupBy(P,W=>k(W)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(W=>n.rtrim(W,"/")).map(W=>n.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),a(W))),j={},ae=this.expandSearchPathPatterns(F.searchPaths||[]);ae&&ae.length&&(j.searchPaths=ae);const oe=h.flatten(x),V=t(...oe);return V&&(j.pattern=V),j}getExcludesForFolder(D,k){return k.disregardExcludeSettings?void 0:(0,o.getExcludes)(D,!k.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const k=h.flatten(D.map(P=>{let{pathPortion:F,globPortion:x}=v(P);x&&(x=c(x));const j=this.expandOneSearchPath(F);return h.flatten(j.map(ae=>this.resolveOneSearchPathPattern(ae,x)))})),s=new Map;return k.forEach(P=>{const F=P.searchPath.toString(),x=s.get(F);x?P.pattern&&(x.pattern=x.pattern||{},x.pattern[P.pattern]=!0):s.set(F,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(s.values())}expandOneSearchPath(D){if(y.isAbsolute(D)){const k=this.workspaceContextService.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==_.Schemas.file?[{searchPath:k[0].uri.with({path:D})}]:[{searchPath:l.URI.file(y.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const k=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=i(D),D.startsWith("../")||D===".."){const P=y.posix.resolve(k.path,D);return[{searchPath:k.with({path:P})}]}const s=c(D);return[{searchPath:k,pattern:s}]}else{if(D==="./"||D===".\\")return[];{const k=D.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(F=>{const x=k.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return x?{match:x,folder:F}:null}).filter(C.isDefined);if(P.length)return P.map(F=>{const x=F.match[1];return{searchPath:F.folder.uri,pattern:x&&c(x)}});{const F=D.match(/\.[\/\\](.+)[\/\\]?/),x=F?F[1]:D,j=u.localize(0,null,x);throw new Error(j)}}}}resolveOneSearchPathPattern(D,k){const s=D.pattern&&k?`${D.pattern}/${k}`:D.pattern||k,P=[{searchPath:D.searchPath,pattern:s}];return s&&!s.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:s+"/**"}),P}getFolderQueryForSearchPath(D,k,s){const P=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(D.searchPath),k,s,!1);return P?{...P,includePattern:D.pattern}:null}getFolderQueryForRoot(D,k,s,P){let F;const x=l.URI.isUri(D)?D:D.uri;if(s.searchPaths){const W=s.searchPaths.filter(L=>(0,I.isEqual)(L.searchPath,x))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const j=this.configurationService.getValue({resource:x}),oe={...this.getExcludesForFolder(j,k)||{},...F||{}},V=l.URI.isUri(D)?(0,I.basename)(D):D.name;return{folder:x,folderName:P?V:void 0,excludePattern:Object.keys(oe).length>0?oe:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!j.search.followSymlinks}}};m=ze([Ve(0,g.IConfigurationService),Ve(1,b.IWorkspaceContextService),Ve(2,w.IEditorGroupsService),Ve(3,T.IPathService)],m),e.QueryBuilder=m;function v(d){const D=d.match(/[\*\{\}\(\)\[\]\?]/);if(D){const k=D.index,s=d.substr(0,k).match(/[/|\\][^/\\]*$/);if(s){let P=d.substr(0,s.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:d.substr((s.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((D,k)=>(D[k]=!0,D),Object.create(null)):void 0}function r(d){return S.splitGlobAware(d,",").map(D=>D.trim()).filter(D=>!!D.length)}function a(d){return[`**/${d}/**`,`**/${d}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function c(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(d,D){d=h.distinct(d,P=>P.toString());const k=[],s=D.getWorkspace();return d&&d.forEach(P=>{let F;if(D.getWorkbenchState()===2)F=(0,I.relativePath)(s.folders[0].uri,P),F&&F!=="."&&(F="./"+F);else{const x=D.getWorkspaceFolder(P);if(x){const j=x.name;if(s.folders.filter(oe=>oe.name===j).length===1){const oe=(0,I.relativePath)(x.uri,P);oe===""?F=`./${x.name}`:F=`./${x.name}/${oe}`}else F=P.fsPath}}F&&k.push(F)}),k}e.resolveResourcesForSearchIncludes=p}),define(be[224],Ee([0,1,25,2,20,12,4,223,40,46]),function(ee,e,h,R,S,E,A,_,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function C(g,b){const w=b.activationEvents;if(!w)return Promise.resolve(void 0);const T=[],o=[];for(const i of w)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||g.forceUsingSearch?o.push(c):T.push(c)}if(T.length===0&&o.length===0)return Promise.resolve(void 0);let m;const v=new Promise((i,c)=>{m=i}),t=i=>m({activationEvent:i}),r=Promise.all(T.map(i=>l(g,i,t))).then(()=>{}),a=f(g,b.identifier,o,t);return Promise.all([r,a]).then(()=>{m(void 0)}),v}e.checkActivateWorkspaceContainsExtension=C;async function l(g,b,w){for(const T of g.folders)if(await g.exists(h.joinPath(R.URI.revive(T),b))){w(`workspaceContains:${b}`);return}}async function f(g,b,w,T){if(w.length===0)return Promise.resolve(void 0);const o=new S.CancellationTokenSource,m=g.checkExists(g.folders,w,o.token),v=setTimeout(async()=>{o.cancel(),T(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await m}catch(r){E.isPromiseCanceledError(r)||E.onUnexpectedError(r)}o.dispose(),clearTimeout(v),t&&T(`workspaceContains:${w.join(",")}`)}function u(g,b,w,T){const o=g.get(A.IInstantiationService),m=g.get(y.ISearchService),t=o.createInstance(_.QueryBuilder).file(b.map(r=>(0,I.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return m.fileSearch(t,T).then(r=>!!r.limitHit,r=>E.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u});var it=this&&this.__classPrivateFieldSet||function(ee,e,h,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,h):S?S.value=h:e.set(ee,h),h},Be=this&&this.__classPrivateFieldGet||function(ee,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[34],Ee([0,1,134,14,79,25,15,6,21,2,16,5,33,186,77,32,30,184,12,26,24,161,7,95,4,29,78,13,63,69,39,3,224,74,163]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o,m,v,t,r,a,i,c,p,d,D,k,s,P,F,x){"use strict";var j,ae,oe;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let V=class Wn extends _.Disposable{constructor(O,G,de,$,ne,he,ye,Ne,Me,$e){super();this._onDidChangeRemoteConnectionData=this._register(new s.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=de,this._initData=ye,this._extHostWorkspace=$,this._extHostConfiguration=ne,this._logService=he,this._extHostTunnelService=Me,this._extHostTerminalService=$e,this._disposables=new _.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Ne,this._instaService=O.createChild(new d.ServiceCollection([u.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(qe=>Xe.add(o.ExtensionIdentifier.toKey(qe))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,je,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,T.transformErrorForSerialization(je),U)},actualActivateExtension:async(qe,je)=>{if(Xe.has(o.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,je),new f.HostExtension;const U=this._registry.getExtensionDescription(qe);return this._activateExtension(U,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){T.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this._deactivate(ne))}catch(G){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,G){return this._activator.activateByEvent(O,G)}_activateById(O,G){return this._activator.activateById(O,G)}activateByIdWithErrors(O,G){return this._activateById(O,G).then(()=>{const de=this._activator.getActivatedExtension(O);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(de=>{if(!!this._getEntryPoint(de))return this._hostUtils.realpath(de.extensionLocation.fsPath).then($=>O.set(I.URI.file($).fsPath,de))});this._extensionPathIndex=Promise.all(G).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return G;const de=this._activator.getActivatedExtension(O);if(!de)return G;try{typeof de.module.deactivate=="function"&&(G=Promise.resolve(de.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,_.dispose)(de.subscriptions)}catch($){this._logService.error($)}return G}async _activateExtension(O,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,G).then(de=>{const $=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,G),this._logExtensionActivationTimes(O,G,"success",$),de},de=>{throw this._logExtensionActivationTimes(O,G,"failure"),de})}_logExtensionActivationTimes(O,G,de,$){const ne=W(O,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ne,...$||{},outcome:de})}_doActivateExtension(O,G){const de=W(O,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const $=this._getEntryPoint(O);if(!$)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const ne=new f.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,E.joinPath)(O.extensionLocation,$),ne),this._loadExtensionContext(O)]).then(he=>(S.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Wn._callActivate(this._logService,O.identifier,he[0],he[1],ne))).then(he=>(S.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),he))}_loadExtensionContext(O){const G=new v.ExtensionGlobalMemento(O,this._storage),de=new v.ExtensionMemento(O.identifier.value,!1,this._storage),$=new x.ExtensionSecrets(O,this._secretState),ne=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([G.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Ne;return Object.freeze({globalState:G,workspaceState:de,secrets:$,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Me){return R.join(O.extensionLocation.fsPath,Me)},get storagePath(){return ye._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(O).fsPath},get logPath(){return R.join(ye._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return I.URI.joinPath(ye._initData.logsLocation,O.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(O)},get globalStorageUri(){return ye._storagePath.globalValue(O)},get extensionMode(){return ne},get extension(){return Ne===void 0&&(Ne=new L(ye,O.identifier,O,he)),Ne},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(O),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,G,de,$,ne){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,G,de,$,ne).then(he=>new f.ActivatedExtension(!1,null,ne.build(),de,he,$.subscriptions))}static _callActivateOptional(O,G,de,$,ne){if(typeof de.activate=="function")try{ne.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${G.value}`);const he=typeof global=="object"?global:self,ye=de.activate.apply(he,[$]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(ye).then(Ne=>(ne.activateResolveStop(),Ne))}catch(he){return Promise.reject(he)}else return Promise.resolve(de)}_activateOneStartupFinished(O,G){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:G}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const G of O.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(O,G)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(G),$=Promise.all([O,de]).then(()=>{});return Promise.race([$,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(O,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,G){if(this.isActivated(G.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:O.map(he=>he.uri),forceUsingSearch:de,exists:he=>this._hostUtils.exists(he.fsPath),checkExists:(he,ye,Ne)=>this._mainThreadWorkspaceProxy.$checkExists(he,ye,Ne)},ne=await(0,P.checkActivateWorkspaceContainsExtension)($,G);if(!!ne)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ne.activationEvent}).then(void 0,he=>this._logService.error(he))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:G}=this._initData.environment;if(!O||!G)throw new Error(h.localize(0,null));const de=await this._loadCommonJSModule(null,G,new f.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(h.localize(1,null,G.toString()));return new Promise(($,ne)=>{const he=(Me,$e)=>{Me?ne(Me):$(typeof $e=="number"&&$e>0?1:0)},ye=(0,E.originalFSPath)(G),Ne=de.run(ye,he);Ne&&Ne.then&&Ne.then(()=>{$(0)}).catch(Me=>{ne(Me.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,G){return this._resolvers[O]=G,(0,_.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const G=O.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const de=O.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(O,G){const{authorityPrefix:de,resolver:$}=await this._activateAndGetResolver(O);if(!$)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),S.mark(`code/extHost/willResolveAuthority/${de}`);const ne=await $.resolve(O,{resolveAttempt:G});S.mark(`code/extHost/didResolveAuthorityOK/${de}`);const he={authority:O,host:ne.host,port:ne.port,connectionToken:ne.connectionToken},ye={extensionHostEnv:ne.extensionHostEnv,isTrusted:ne.isTrusted};return{type:"ok",value:{authority:he,options:ye,tunnelInformation:{environmentTunnels:ne.environmentTunnels}}}}catch(ne){if(S.mark(`code/extHost/didResolveAuthorityError/${de}`),ne instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ne._code,message:ne._message,detail:ne._detail}};throw ne}}async $getCanonicalURI(O,G){const{authorityPrefix:de,resolver:$}=await this._activateAndGetResolver(O);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ne=I.URI.revive(G);if(typeof $.getCanonicalURI=="undefined")return ne;const he=await(0,A.asPromise)(()=>$.getCanonicalURI(ne));return he||ne}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,G){return G===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(O,!1))}async $activate(O,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,G),!0):!1}async $deltaExtensions(O,G){O.forEach($=>$.extensionLocation=I.URI.revive($.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(G.map(async $=>{const ne=this._registry.getExtensionDescription($);if(!ne)return;const he=await this._hostUtils.realpath(ne.extensionLocation.fsPath);de.delete(I.URI.file(he).fsPath)})),await Promise.all(O.map(async $=>{const ne=await this._hostUtils.realpath($.extensionLocation.fsPath);de.set(I.URI.file(ne).fsPath,$)})),this._registry.deltaExtensions(O,G),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let G=m.VSBuffer.alloc(O),de=Math.random()%256;for(let $=0;$<O;$++)G.writeUInt8(de,$);return G}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};V=ze([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,p.IExtHostRpcService),Ve(3,g.IExtHostWorkspace),Ve(4,l.IExtHostConfiguration),Ve(5,n.ILogService),Ve(6,i.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,D.IExtHostTunnelService),Ve(9,k.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(Q,O){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class L{constructor(O,G,de,$){j.set(this,void 0),ae.set(this,void 0),oe.set(this,void 0),it(this,j,O,"f"),it(this,ae,G,"f"),it(this,oe,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=R.normalize((0,E.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=$}get isActive(){return Be(this,j,"f").isActivated(Be(this,oe,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,j,"f").getExtensionExports(Be(this,oe,"f"))}activate(){return Be(this,j,"f").activateByIdWithErrors(Be(this,oe,"f"),{startup:!1,extensionId:Be(this,ae,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,j=new WeakMap,ae=new WeakMap,oe=new WeakMap}),define(be[109],Ee([0,1,14,2,3,15,5,7,171,32,34,49,175,33,172,13,4,10,42,67]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let m=class{constructor(d,D,k,s,P,F){this._workspaceService=D,this._extensionService=k,this._editorsService=s,this._configurationService=P,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=d.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(j=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,D){const k=d;if(typeof k.sourceReference=="number"&&k.sourceReference>0){let s=`debug:${encodeURIComponent(k.path||"")}`,P="?";return D&&(s+=`${P}session=${encodeURIComponent(D.id)}`,P="&"),s+=`${P}ref=${k.sourceReference}`,R.URI.parse(s)}else{if(k.path)return R.URI.file(k.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const D=[];for(const k of d.getAllExtensionDescriptions())if(k.contributes){const s=k.contributes.debuggers;if(s&&s.length>0)for(const P of s)(0,u.isDebuggerMainContribution)(P)&&D.push(P.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(D=>d.push(D)),d}addBreakpoints(d){this.startBreakpoints();const D=d.filter(P=>{const F=P.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,P),!0)});this.fireBreakpointChanges(D,[],[]);const k=[],s=new Map;for(const P of D)if(P instanceof _.SourceBreakpoint){let F=s.get(P.location.uri.toString());F||(F={type:"sourceMulti",uri:P.location.uri,lines:[]},s.set(P.location.uri.toString(),F),k.push(F)),F.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof _.FunctionBreakpoint&&k.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(k)}removeBreakpoints(d){this.startBreakpoints();const D=d.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],D,[]);const k=D.filter(F=>F instanceof _.SourceBreakpoint).map(F=>F.id),s=D.filter(F=>F instanceof _.FunctionBreakpoint).map(F=>F.id),P=D.filter(F=>F instanceof _.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(k,s,P)}startDebugging(d,D,k){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,D,{parentSessionID:k.parentSession?k.parentSession.id:void 0,lifecycleManagedByParent:k.lifecycleManagedByParent,repl:k.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:k.noDebug,compact:k.compact,debugUI:k.debugUI})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,D,k){if(!D)return new _.Disposable(()=>{});const s=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:s,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,k,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,s),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(d,D,k){if(!k)return new _.Disposable(()=>{});if(!this.definesDebugType(d,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:s,factory:k}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,s),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==k),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(d,D){if(!D)return new _.Disposable(()=>{});const k=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:k,factory:D}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(s=>s.factory!==D)})}async $runInTerminal(d,D){return Promise.resolve(void 0)}async $substituteVariables(d,D){if(!this._variableResolver){const[P,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,F)}let k;const s=await this.getFolder(d);return s&&(k={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(k,D)}createDebugAdapter(d,D){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,D){const k=this,s=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(s.type),s).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const F=this.convertToDto(P),x=this.createDebugAdapter(F,s);if(!x)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const j=x;return this._debugAdapters.set(d,j),this.getDebugAdapterTrackers(s).then(ae=>(ae&&this._debugAdaptersTrackers.set(d,ae),j.onMessage(async oe=>{if(oe.type==="request"&&oe.command==="handshake"){const V=oe,W={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(V.arguments.value);W.body={signature:L},j.sendResponse(W)}else throw new Error("no signer")}catch(L){W.success=!1,W.message=L.message,j.sendResponse(W)}}else ae&&ae.onDidSendMessage&&ae.onDidSendMessage(oe),oe=(0,u.convertToVSCPaths)(oe,!0),k._debugServiceProxy.$acceptDAMessage(d,oe)}),j.onError(oe=>{ae&&ae.onError&&ae.onError(oe),this._debugServiceProxy.$acceptDAError(d,oe.name,oe.message,oe.stack)}),j.onExit(oe=>{ae&&ae.onExit&&ae.onExit((0,w.withNullAsUndefined)(oe),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,w.withNullAsUndefined)(oe),void 0)}),ae&&ae.onWillStartSession&&ae.onWillStartSession(),j.startSession()))})}$sendDAMessage(d,D){D=(0,u.convertToDAPaths)(D,!1);const k=this._debugAdaptersTrackers.get(d);k&&k.onWillReceiveMessage&&k.onWillReceiveMessage(D);const s=this._debugAdapters.get(d);s&&s.sendMessage(D)}$stopDASession(d){const D=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),D&&D.onWillStopSession&&D.onWillStopSession();const k=this._debugAdapters.get(d);return this._debugAdapters.delete(d),k?k.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const D=[],k=[],s=[];if(d.added)for(const P of d.added){const F=P.id;if(F&&!this._breakpoints.has(F)){let x;if(P.type==="function")x=new _.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")x=new _.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const j=R.URI.revive(P.uri);x=new _.SourceBreakpoint(new _.Location(j,new _.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}x._id=F,this._breakpoints.set(F,x),D.push(x)}}if(d.removed)for(const P of d.removed){const F=this._breakpoints.get(P);F&&(this._breakpoints.delete(P),k.push(F))}if(d.changed){for(const P of d.changed)if(P.id){const F=this._breakpoints.get(P.id);if(F){if(F instanceof _.FunctionBreakpoint&&P.type==="function"){const x=F;x.enabled=P.enabled,x.condition=P.condition,x.hitCondition=P.hitCondition,x.logMessage=P.logMessage,x.functionName=P.functionName}else if(F instanceof _.SourceBreakpoint&&P.type==="source"){const x=F;x.enabled=P.enabled,x.condition=P.condition,x.hitCondition=P.hitCondition,x.logMessage=P.logMessage,x.location=new _.Location(R.URI.revive(P.uri),new _.Position(P.line,P.character))}s.push(F)}}}this.fireBreakpointChanges(D,k,s)}$provideDebugConfigurations(d,D,k){return(0,E.asPromise)(async()=>{const s=this.getConfigProviderByHandle(d);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(D);return s.provideDebugConfigurations(P,k)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(d,D,k,s){return(0,E.asPromise)(async()=>{const P=this.getConfigProviderByHandle(d);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(D);return P.resolveDebugConfiguration(F,k,s)})}$resolveDebugConfigurationWithSubstitutedVariables(d,D,k,s){return(0,E.asPromise)(async()=>{const P=this.getConfigProviderByHandle(d);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(D);return P.resolveDebugConfigurationWithSubstitutedVariables(F,k,s)})}async $provideDebugAdapter(d,D){const k=this.getAdapterDescriptorFactoryByHandle(d);if(!k)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.getSession(D);return this.getAdapterDescriptor(k,s).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(d){const D=await this.getSession(d);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(d){const D=await this.getSession(d);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,D){const k=await this.getSession(d);k&&k._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(d,D){const s={session:await this.getSession(d),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(s)}convertToDto(d){if(d instanceof _.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof _.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const D=this._adapterFactories.filter(k=>k.type===d);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(d){const D=this._adapterFactories.filter(k=>k.handle===d);if(D.length>0)return D[0].factory}getConfigProviderByHandle(d){const D=this._configProviders.filter(k=>k.handle===d);if(D.length>0)return D[0].provider}definesDebugType(d,D){if(d.contributes){const k=d.contributes.debuggers;if(k&&k.length>0){for(const s of k)if(s.label&&s.type&&s.type===D)return!0}}return!1}getDebugAdapterTrackers(d){const k=d.configuration.type,s=this._trackerFactories.filter(P=>P.type===k||P.type==="*").map(P=>(0,E.asPromise)(()=>P.factory.createDebugAdapterTracker(d)).then(F=>F,F=>null));return Promise.race([Promise.all(s).then(P=>{const F=P.filter(x=>!!x);if(F.length>0)return new a(F)}),new Promise((P,F)=>{const x=setTimeout(()=>{clearTimeout(x),F(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(d,D){const k=D.configuration.debugServer;if(typeof k=="number")return Promise.resolve(new _.DebugAdapterServer(k));if(d){const P=await this._extensionService.getExtensionRegistry();return(0,E.asPromise)(()=>d.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,P))).then(F=>{if(F)return F})}const s=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,s))}daExecutableFromPackage(d,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,D,k){(d.length>0||D.length>0||k.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:D,changed:k}))}async getSession(d){if(d)if(typeof d=="string"){const D=this._debugSessions.get(d);if(D)return D}else{let D=this._debugSessions.get(d.id);if(!D){const k=await this.getFolder(d.folderUri),s=d.parent?this._debugSessions.get(d.parent):void 0;D=new v(this._debugServiceProxy,d.id,d.type,d.name,k,d.configuration,s),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(d){if(d){const D=R.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};m=ze([Ve(0,g.IExtHostRpcService),Ve(1,I.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,f.IExtHostConfiguration),Ve(5,o.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class v{constructor(d,D,k,s,P,F,x){this._debugServiceProxy=d,this._id=D,this._type=k,this._name=s,this._workspaceFolder=P,this._configuration=F,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,D)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=v;class t{constructor(d){this.value=Object.freeze({append(D){d.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(d,D,k,s,P){function F(){if(D){const x=D.activeEditor();if(x)return x.document.uri;const j=s.tabs.filter(ae=>ae.isActive);if(j.length>0)return j[0].resource}}super({getFolderUri:x=>{const j=d.filter(ae=>ae.name===x);if(j&&j.length>0)return j[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(x,j)=>k.getConfiguration(void 0,x).get(j),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=F();if(x)return h.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const x=F();if(x){const j=P.getWorkspaceFolder(x);if(j)return h.normalize(j.uri.fsPath)}}},getSelectedText:()=>{if(D){const x=D.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(D){const x=D.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(T.env))}}e.ExtHostVariableResolverService=r;class a{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(D=>D.onError?D.onError(d):void 0)}onExit(d,D){this.trackers.forEach(k=>k.onExit?k.onExit(d,D):void 0)}}class i extends y.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends m{constructor(d,D,k,s,P,F){super(d,D,k,s,P,F)}createVariableResolver(d,D,k){return new r(d,D,k,this._editorTabs)}};c=ze([Ve(0,g.IExtHostRpcService),Ve(1,I.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,f.IExtHostConfiguration),Ve(5,o.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(be[225],Ee([0,1,79,2,5,33,30,26,13,29,4,34,42,16]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(o,m,v,t,r,a,i){this._apiFactory=o,this._extensionRegistry=m,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=a,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,m,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,m,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let m of o.nodeModuleName)this._factories.set(m,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(m=>o.alternativeModuleName(m))}};u=ze([Ve(2,n.IInstantiationService),Ve(3,E.IExtHostConfiguration),Ve(4,C.IExtHostExtensionService),Ve(5,I.IExtHostInitDataService),Ve(6,f.ILogService)],u),e.RequireInterceptor=u;class g{constructor(o,m,v,t,r){this._apiFactory=o,this._extensionPaths=m,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,m){const v=this._extensionPaths.findSubstr(m.fsPath);if(v){let t=this._extApiImpl.get(_.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(_.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,a)=>t+=`	${a} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(o,m){this.nodeModuleName="keytar";const{environment:v}=m,t=o.getProxy(S.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,a)=>t.$getPassword(r,a),setPassword:(r,a,i)=>t.$setPassword(r,a,i),deletePassword:(r,a)=>t.$deletePassword(r,a),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(o,m){return this._impl}alternativeModuleName(o){const m=o.length;if(m<=7||!this.alternativeNames)return;const v=m-7;if((o.charAt(v)==="/"||o.charAt(v)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};b=ze([Ve(0,y.IExtHostRpcService),Ve(1,I.IExtHostInitDataService)],b);let w=class{constructor(o,m,v){this._extensionPaths=o,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(S.MainContext.MainThreadTelemetry);const t=v.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,a)=>{const i=R.URI.parse(r);return a?this.callOriginal(r,a):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,a)}}load(o,m,v){const t=this._extensionPaths.findSubstr(m.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(o),this._impl}callOriginal(o,m){return this.sendNoForwardTelemetry(),this._original(o,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([Ve(2,y.IExtHostRpcService)],w)}),define(be[226],Ee([0,1,15,12,79,6,2,5,219,16,60,63,29,153,13,70,34,39]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class T{constructor(m,v,t,r){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(m,null,r),v=T._transform(v,this._rpcProtocol);const a=new C.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());a.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),a.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),a.set(g.IURITransformerService,new g.URITransformerService(r)),a.set(b.IHostUtils,t);const i=new f.InstantiationService(a,!0),c=i.invokeFunction(k=>k.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(k=>k.get(I.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(k=>k.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(k=>{Error.prepareStackTrace=(s,P)=>{let F="",x,j;for(const ae of P)F+=`
	at ${ae.toString()}`,j=ae.getFileName(),!x&&j&&(x=k.findSubstr(j));return p.set(s,x),`${s.name||"Error"}: ${s.message||""}${F}`}});const d=this._rpcProtocol.getProxy(_.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(_.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(k=>{const s=R.transformErrorForSerialization(k),P=p.get(k);P?d.$onExtensionRuntimeError(P.identifier,s):D.$onUnexpectedError(s)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,v){m.extensions.forEach(r=>r.extensionLocation=A.URI.revive(v.transformIncomingURIs(r.extensionLocation))),m.environment.appRoot=A.URI.revive(v.transformIncomingURIs(m.environment.appRoot));const t=m.environment.extensionDevelopmentLocationURI;return t&&(m.environment.extensionDevelopmentLocationURI=t.map(r=>A.URI.revive(v.transformIncomingURIs(r)))),m.environment.extensionTestsLocationURI=A.URI.revive(v.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=A.URI.revive(v.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=A.URI.revive(v.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=A.URI.revive(v.transformIncomingURIs(m.logsLocation)),m.logFile=A.URI.revive(v.transformIncomingURIs(m.logFile)),m.workspace=v.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=T}),define(be[227],Ee([0,1,14,20,59,27,25,56,40]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(l,f,u){this.config=l,this.provider=f,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&E.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&E.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const f=this.config.folderQueries||[];return new Promise((u,g)=>{const b=w=>{this.resultCount++,l(w)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const T=w.toString(),o=h.basename(T);this.globalExcludePattern&&this.globalExcludePattern(T,o)||this.matchFile(b,{base:w,basename:o})}),Promise.all(f.map(w=>this.searchInFolder(w,b))).then(w=>{u({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{g(new Error((0,S.toErrorMessage)(w)))})})}async searchInFolder(l,f){const u=new R.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),w=new y.QueryGlobTester(this.config,l),T=!w.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(u),o=_.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,u.token),v=o.elapsed(),t=_.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(r=>{const a=h.posix.relative(l.folder.path,r.path);if(T){const i=h.basename(r.path);this.matchFile(f,{base:l.folder,relativePath:a,basename:i});return}this.addDirectoryEntries(b,l.folder,a,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,w,f),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(l){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),u=(0,y.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:u,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},f,u,g){if(u===this.filePattern){const w=h.basename(this.filePattern);this.matchFile(g,{base:f,relativePath:this.filePattern,basename:w})}function b(w){const T=h.basename(w),o=h.dirname(w);let m=l[o];m||(m=l[o]=[],b(o)),m.push({base:f,relativePath:w,basename:T})}b(u)}matchDirectoryTree({rootEntries:l,pathToEntries:f},u,g){const b=this,w=this.filePattern;function T(o){const m=E.hasSiblingFn(()=>o.map(v=>v.basename));for(let v=0,t=o.length;v<t;v++){const r=o[v],{relativePath:a,basename:i}=r;if(!u.includedInQuerySync(a,i,w!==i?m:void 0))continue;const c=f[a];if(c)T(c);else{if(a===w)continue;b.matchFile(g,r)}if(b.isLimitHit)break}}T(l)}matchFile(l,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(f))}}class n{constructor(){this.sessions=new Map}fileSearch(l,f,u,g){const b=this.getSessionTokenSource(l.cacheKey),w=new I(l,f,b&&b.token);let T=0;const o=m=>{T+=m.length,u(m.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,n.BATCH_SIZE,o,g).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:T,detailStats:m.stats}}))}clearCache(l){const f=this.getSessionTokenSource(l);f&&f.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,f,u,g){g.onCancellationRequested(()=>{l.cancel()});const b=T=>{T&&(w.push(T),f>0&&w.length>=f&&(u(w),w=[]))};let w=[];return l.search(b).then(T=>(w.length&&u(w),T),T=>(w.length&&u(w),Promise.reject(T)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[228],Ee([0,1,14,17,20,59,25,27,2,40,11,10]),function(ee,e,h,R,S,E,A,_,y,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(o,m,v){this.query=o,this.provider=m,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,m){const v=this.query.folderQueries||[],t=new S.CancellationTokenSource;return m.onCancellationRequested(()=>t.cancel()),new Promise((r,a)=>{this.collector=new u(o);let i=!1;const c=(p,d)=>{if(!i&&!this.isLimitHit){const D=this.resultSize(p);b(p)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const k=this.resultSize(p);this.resultCount+=k,(k>0||!b(p))&&this.collector.add(p,d)}};Promise.all(v.map((p,d)=>this.searchInFolder(p,D=>c(D,d),t.token))).then(p=>{t.dispose(),this.collector.flush();const d=p.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||d,messages:(0,R.flatten)(p.map(D=>D?.message?(0,C.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const d=(0,E.toErrorMessage)(p);a(new Error(d))})})}resultSize(o){return b(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,m){const v=Array.isArray(o.ranges)?o.ranges:[o.ranges],t=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:v.slice(0,m),preview:{matches:t.slice(0,m),text:o.preview.text},uri:o.uri}}async searchInFolder(o,m,v){const t=new I.QueryGlobTester(this.query,o),r=[],a={report:p=>{if(!this.validateProviderResult(p))return;const d=o.folder.scheme===n.Schemas.file?_.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(p.uri))):void 0,D=A.relativePath(o.folder,p.uri);D&&r.push(t.includedInQuery(D,h.basename(D),d).then(k=>{k&&m(p)}))}},i=this.getSearchOptionsForFolder(o),c=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,a,v);return await Promise.all(r),c}validateProviderResult(o){if(b(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const m=(0,I.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),v=(0,I.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),t={folder:y.URI.from(o.folder),excludes:v,includes:m,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function f(T){return{isCaseSensitive:T.isCaseSensitive||!1,isRegExp:T.isRegExp||!1,isWordMatch:T.isWordMatch||!1,isMultiline:T.isMultiline||!1,pattern:T.pattern}}class u{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,m=>this.sendItems(m))}add(o,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!A.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(g(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=u;function g(T){return b(T)?{preview:{matches:(0,R.mapArrayOrNot)(T.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:T.preview.text},ranges:(0,R.mapArrayOrNot)(T.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:T.text,lineNumber:T.lineNumber}}function b(T){return!!T.preview}e.extensionResultIsMatch=b;class w{constructor(o,m){this.maxBatchSize=o,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,m){!o||this.addItemToBatch(o,m)}addItems(o,m){!o||this.addItemsToBatch(o,m)}addItemToBatch(o,m){this.batch.push(o),this.batchSize+=m,this.onUpdate()}addItemsToBatch(o,m){this.batch=this.batch.concat(o),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(be[110],Ee([0,1,6,5,4,227,13,70,16,2,228]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let C=class{constructor(g,b,w){this.extHostRpc=g,this._uriTransformer=b,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,b){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const w=this._handlePool++;return this._textSearchProvider.set(w,b),this._proxy.$registerTextSearchProvider(w,this._transformScheme(g)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(g,b){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const w=this._handlePool++;return this._fileSearchProvider.set(w,b),this._proxy.$registerFileSearchProvider(w,this._transformScheme(g)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(g,b,w,T){const o=l(w),m=this._fileSearchProvider.get(g);if(m)return this._fileSearchManager.fileSearch(o,m,v=>{this._proxy.$handleFileMatch(g,b,v.map(t=>t.resource))},T);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,b,w,T){const o=this._textSearchProvider.get(g);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const m=l(w);return this.createTextSearchManager(m,o).search(t=>this._proxy.$handleTextMatch(g,b,t),T)}createTextSearchManager(g,b){return new n.TextSearchManager(g,b,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=ze([Ve(0,A.IExtHostRpcService),Ve(1,_.IURITransformerService),Ve(2,y.ILogService)],C),e.ExtHostSearch=C;function l(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(f),extraFileResources:u.extraFileResources&&u.extraFileResources.map(g=>I.URI.revive(g))}}e.reviveQuery=l;function f(u){return{...u,folder:I.URI.revive(u.folder)}}}),define(be[229],Ee([0,1,20,12,3,36,2,127,87,121,58,62,5,191,190,48,192,33,193,194,195,177,196,49,34,197,178,200,201,202,105,180,207,208,209,77,39,211,181,9,7,214,50,106,32,30,51,168,199,96,104,108,109,110,16,70,13,29,203,165,69,75,188,212,164,78,76,217,215,216,189,47,210,213,74,67,97,205,107,206,11,155,204,162,198]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o,m,v,t,r,a,i,c,p,d,D,k,s,P,F,x,j,ae,oe,V,W,L,Q,O,G,de,$,ne,he,ye,Ne,Me,$e,Xe,qe,je,U,K,X,re,q,ie,ge,Re,We,ve,Je,z,Z,ce,Ue,xe,et,De,Se,Pe,se,le,fe,pe,B,me,we,Ie,Oe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Ke){const Qe=Ke.get(X.IExtHostInitDataService),ut=Ke.get(et.IExtHostFileSystemInfo),mt=Ke.get(z.IExtHostConsumerFileSystem),bt=Ke.get(a.IExtHostExtensionService),ot=Ke.get(de.IExtHostWorkspace),at=Ke.get(le.IExtHostTelemetry),_e=Ke.get(w.IExtHostConfiguration),ke=Ke.get(U.IURITransformerService),Y=Ke.get(K.IExtHostRpcService),H=Ke.get(j.IExtHostStorage),Fe=Ke.get(Je.IExtensionStoragePaths),Te=Ke.get(je.ILogService),tt=Ke.get(ie.IExtHostTunnelService),Ge=Ke.get(ge.IExtHostApiDeprecationService),ct=Ke.get(G.IExtHostWindow),yt=Ke.get(Pe.IExtHostSecretState),kt=Ke.get(se.IExtHostEditorTabs);Y.set(l.ExtHostContext.ExtHostFileSystemInfo,ut),Y.set(l.ExtHostContext.ExtHostLogService,Te),Y.set(l.ExtHostContext.ExtHostWorkspace,ot),Y.set(l.ExtHostContext.ExtHostConfiguration,_e),Y.set(l.ExtHostContext.ExtHostExtensionService,bt),Y.set(l.ExtHostContext.ExtHostStorage,H),Y.set(l.ExtHostContext.ExtHostTunnelService,tt),Y.set(l.ExtHostContext.ExtHostWindow,ct),Y.set(l.ExtHostContext.ExtHostSecretState,yt),Y.set(l.ExtHostContext.ExtHostTelemetry,at),Y.set(l.ExtHostContext.ExtHostEditorTabs,kt);const Dt=Y.set(l.ExtHostContext.ExtHostDecorations,Ke.get(Me.IExtHostDecorations)),ft=Y.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(r.IExtHostDocumentsAndEditors)),dt=Y.set(l.ExtHostContext.ExtHostCommands,Ke.get(g.IExtHostCommands)),vt=Y.set(l.ExtHostContext.ExtHostTerminalService,Ke.get(ae.IExtHostTerminalService)),Et=Y.set(l.ExtHostContext.ExtHostDebugService,Ke.get(Xe.IExtHostDebugService)),Tt=Y.set(l.ExtHostContext.ExtHostSearch,Ke.get(qe.IExtHostSearch)),It=Y.set(l.ExtHostContext.ExtHostTask,Ke.get($e.IExtHostTask)),bn=Y.set(l.ExtHostContext.ExtHostOutputService,Ke.get(k.IExtHostOutputService)),Vt=Y.set(l.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(Y)),_t=Y.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Y,ft)),Yt=Y.set(l.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Y,ft,Te)),Jt=Y.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Te,_t,Y.getProxy(l.MainContext.MainThreadBulkEdits))),gt=Y.set(l.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Y,dt,ft,_t,Fe)),qt=Y.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Te,gt)),Wt=Y.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Te,Y,gt)),Xt=Y.set(l.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(Y,Qe,gt,Te)),Zt=Y.set(l.ExtHostContext.ExtHostNotebookRenderers,new B.ExtHostNotebookRenderers(Y,gt)),Pt=Y.set(l.ExtHostContext.ExtHostEditors,new oe.ExtHostEditors(Y,ft)),dn=Y.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(Y.getProxy(l.MainContext.MainThreadTreeViews),dt,Te)),en=Y.set(l.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Y.getProxy(l.MainContext.MainThreadEditorInsets),Pt,Qe)),xt=Y.set(l.ExtHostContext.ExtHostDiagnostics,new T.ExtHostDiagnostics(Y,Te)),ht=Y.set(l.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(Y,ke,_t,dt,xt,Te,Ge)),tn=Y.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Y,ht)),Mt=Y.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Y,Te,ft)),Nt=Y.set(l.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(Y,ot,dt)),jt=Y.set(l.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Y,dt,Te)),En=Y.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(Y,dt,_t)),hn=Y.set(l.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(Y.getProxy(l.MainContext.MainThreadProgress))),_n=Y.set(l.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(Y)),fn=Y.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Y)),nn=Y.set(l.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Y)),rn=Y.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(Y,dt)),Ht=Y.set(l.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(Y,{remote:Qe.remote},ot,Te,Ge)),sn=Y.set(l.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(Y,Ht,ot)),yn=Y.set(l.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Y,_t,Fe,Ht,sn)),Sn=Y.set(l.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(Y,Ht)),zt=Y.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Y,dt)),Gt=Y.set(l.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(Y));Y.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(Y,gt,ft,dt));const Dn=(0,ne.values)(l.ExtHostContext);Y.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(Y,ft),on=new u.ExtHostClipboard(Y),an=new D.ExtHostMessageService(Y,Te),Bt=new o.ExtHostDialogs(Y),Ft=new x.ExtHostStatusBar(Y,dt.converter),Kt=new d.ExtHostLanguages(Y,_t);return f.ExtHostApiCommands.register(dt),function(Le,$t,mn){const pt=function(){let J=!Le.isUnderDevelopment;function ue(Ae){J||(Te.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")ue(st);else{const wt=st;typeof wt.scheme=="undefined"&&ue(st),!Le.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,$.throwProposedApiError)(Le)}return st}}(),kn={getSession(J,ue,Ae){return Ae?.forceNewSession&&(0,$.checkProposedApiEnabled)(Le),nn.getSession(Le,J,ue,Ae)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(J,ue,Ae,st){return nn.registerAuthenticationProvider(J,ue,Ae,st)}},In={registerCommand(J,ue,Ae){return dt.registerCommand(!0,J,ue,Ae)},registerTextEditorCommand(J,ue,Ae){return dt.registerCommand(!0,J,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Te.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Ct=>{ue.apply(Ae,[wt,Ct,...st])}).then(Ct=>{Ct||Te.warn("Edits from command "+J+" were not applied.")},Ct=>{Te.warn("An error occurred while running command "+J,Ct)})})},registerDiffInformationCommand:(J,ue,Ae)=>((0,$.checkProposedApiEnabled)(Le),dt.registerCommand(!0,J,async(...st)=>{const wt=ft.activeEditor(!0);if(!wt){Te.warn("Cannot execute "+J+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);ue.apply(Ae,[Ct,...st])})),executeCommand(J,...ue){return dt.executeCommand(J,...ue)},getCommands(J=!1){return dt.getCommands(J)}},gn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){return Qe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return Qe.environment.embedderIdentifier},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ue){return ct.openUri(J,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Qe.environment.appUriScheme)return Vt.createAppUri(J);try{return await ct.asExternalUri(J,{allowTunneling:!!Qe.remote.authority})}catch(ue){if((0,we.matchesScheme)(J,me.Schemas.http)||(0,we.matchesScheme)(J,me.Schemas.https))return J;throw ue}},get remoteName(){return(0,Ne.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Qe.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Pn={createTestController(J,ue){return zt.createTestController(J,ue)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Le),zt.createTestObserver()},runTests(J){return(0,$.checkProposedApiEnabled)(Le),zt.runTests(J)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Le),zt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Le),zt.results}},ln={getExtension(J){const ue=$t.getExtensionDescription(J);if(ue)return new a.Extension(bt,Le.identifier,ue,pn)},get all(){return $t.getAllExtensionDescriptions().map(J=>new a.Extension(bt,Le.identifier,J,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(J){return xt.createDiagnosticCollection(Le.identifier,J)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:J=>xt.getDiagnostics(J),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(J,ue){return Kt.changeLanguage(J.uri,ue)},match(J,ue){return(0,n.score)(W.LanguageSelector.from(J),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(J,ue,Ae){return ht.registerCodeActionProvider(Le,pt(J),ue,Ae)},registerCodeLensProvider(J,ue){return ht.registerCodeLensProvider(Le,pt(J),ue)},registerDefinitionProvider(J,ue){return ht.registerDefinitionProvider(Le,pt(J),ue)},registerDeclarationProvider(J,ue){return ht.registerDeclarationProvider(Le,pt(J),ue)},registerImplementationProvider(J,ue){return ht.registerImplementationProvider(Le,pt(J),ue)},registerTypeDefinitionProvider(J,ue){return ht.registerTypeDefinitionProvider(Le,pt(J),ue)},registerHoverProvider(J,ue){return ht.registerHoverProvider(Le,pt(J),ue,Le.identifier)},registerEvaluatableExpressionProvider(J,ue){return ht.registerEvaluatableExpressionProvider(Le,pt(J),ue,Le.identifier)},registerInlineValuesProvider(J,ue){return ht.registerInlineValuesProvider(Le,pt(J),ue,Le.identifier)},registerDocumentHighlightProvider(J,ue){return ht.registerDocumentHighlightProvider(Le,pt(J),ue)},registerLinkedEditingRangeProvider(J,ue){return ht.registerLinkedEditingRangeProvider(Le,pt(J),ue)},registerReferenceProvider(J,ue){return ht.registerReferenceProvider(Le,pt(J),ue)},registerRenameProvider(J,ue){return ht.registerRenameProvider(Le,pt(J),ue)},registerDocumentSymbolProvider(J,ue,Ae){return ht.registerDocumentSymbolProvider(Le,pt(J),ue,Ae)},registerWorkspaceSymbolProvider(J){return ht.registerWorkspaceSymbolProvider(Le,J)},registerDocumentFormattingEditProvider(J,ue){return ht.registerDocumentFormattingEditProvider(Le,pt(J),ue)},registerDocumentRangeFormattingEditProvider(J,ue){return ht.registerDocumentRangeFormattingEditProvider(Le,pt(J),ue)},registerOnTypeFormattingEditProvider(J,ue,Ae,...st){return ht.registerOnTypeFormattingEditProvider(Le,pt(J),ue,[Ae].concat(st))},registerDocumentSemanticTokensProvider(J,ue,Ae){return ht.registerDocumentSemanticTokensProvider(Le,pt(J),ue,Ae)},registerDocumentRangeSemanticTokensProvider(J,ue,Ae){return ht.registerDocumentRangeSemanticTokensProvider(Le,pt(J),ue,Ae)},registerSignatureHelpProvider(J,ue,Ae,...st){return typeof Ae=="object"?ht.registerSignatureHelpProvider(Le,pt(J),ue,Ae):ht.registerSignatureHelpProvider(Le,pt(J),ue,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(J,ue,...Ae){return ht.registerCompletionItemProvider(Le,pt(J),ue,Ae)},registerInlineCompletionItemProvider(J,ue){return(0,$.checkProposedApiEnabled)(Le),ht.registerInlineCompletionsProvider(Le,pt(J),ue)},registerDocumentLinkProvider(J,ue){return ht.registerDocumentLinkProvider(Le,pt(J),ue)},registerColorProvider(J,ue){return ht.registerColorProvider(Le,pt(J),ue)},registerFoldingRangeProvider(J,ue){return ht.registerFoldingRangeProvider(Le,pt(J),ue)},registerSelectionRangeProvider(J,ue){return ht.registerSelectionRangeProvider(Le,J,ue)},registerCallHierarchyProvider(J,ue){return ht.registerCallHierarchyProvider(Le,J,ue)},setLanguageConfiguration:(J,ue)=>ht.setLanguageConfiguration(Le,J,ue),getTokenInformationAtPosition(J,ue){return(0,$.checkProposedApiEnabled)(Le),Kt.tokenAtPosition(J,ue)},registerInlayHintsProvider(J,ue){return(0,$.checkProposedApiEnabled)(Le),ht.registerInlayHintsProvider(Le,J,ue)},registerTypeHierarchyProvider(J,ue){return(0,$.checkProposedApiEnabled)(Le),ht.registerTypeHierarchyProvider(Le,J,ue)},createLanguageStatusItem(J){return(0,$.checkProposedApiEnabled)(Le),Kt.createLanguageStatusItem(J)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(J,ue,Ae){const st=await(A.URI.isUri(J)?Promise.resolve(vn.openTextDocument(J)):Promise.resolve(J));return Pt.showTextDocument(st,ue,Ae)},createTextEditorDecorationType(J){return Pt.createTextEditorDecorationType(Le,J)},onDidChangeActiveTextEditor(J,ue,Ae){return Pt.onDidChangeActiveTextEditor(J,ue,Ae)},onDidChangeVisibleTextEditors(J,ue,Ae){return Pt.onDidChangeVisibleTextEditors(J,ue,Ae)},onDidChangeTextEditorSelection(J,ue,Ae){return Pt.onDidChangeTextEditorSelection(J,ue,Ae)},onDidChangeTextEditorOptions(J,ue,Ae){return Pt.onDidChangeTextEditorOptions(J,ue,Ae)},onDidChangeTextEditorVisibleRanges(J,ue,Ae){return Pt.onDidChangeTextEditorVisibleRanges(J,ue,Ae)},onDidChangeTextEditorViewColumn(J,ue,Ae){return Pt.onDidChangeTextEditorViewColumn(J,ue,Ae)},onDidCloseTerminal(J,ue,Ae){return vt.onDidCloseTerminal(J,ue,Ae)},onDidOpenTerminal(J,ue,Ae){return vt.onDidOpenTerminal(J,ue,Ae)},onDidChangeActiveTerminal(J,ue,Ae){return vt.onDidChangeActiveTerminal(J,ue,Ae)},onDidChangeTerminalDimensions(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),vt.onDidChangeTerminalDimensions(J,ue,Ae)},onDidWriteTerminalData(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),vt.onDidWriteTerminalData(J,ue,Ae)},get state(){return ct.state},onDidChangeWindowState(J,ue,Ae){return ct.onDidChangeWindowState(J,ue,Ae)},showInformationMessage(J,...ue){return an.showMessage(Le,E.default.Info,J,ue[0],ue.slice(1))},showWarningMessage(J,...ue){return an.showMessage(Le,E.default.Warning,J,ue[0],ue.slice(1))},showErrorMessage(J,...ue){return an.showMessage(Le,E.default.Error,J,ue[0],ue.slice(1))},showQuickPick(J,ue,Ae){return Nt.showQuickPick(J,!!Le.enableProposedApi,ue,Ae)},showWorkspaceFolderPick(J){return Nt.showWorkspaceFolderPick(J)},showInputBox(J,ue){return Nt.showInput(J,ue)},showOpenDialog(J){return Bt.showOpenDialog(J)},showSaveDialog(J){return Bt.showSaveDialog(J)},createStatusBarItem(J,ue,Ae){let st,wt,Ct;return typeof J=="string"?(st=J,wt=ue,Ct=Ae):(wt=J,Ct=ue),Ft.createStatusBarEntry(Le,st,wt,Ct)},setStatusBarMessage(J,ue){return Ft.setStatusBarMessage(J,ue)},withScmProgress(J){return Ge.report("window.withScmProgress",Le,"Use 'withProgress' instead."),hn.withProgress(Le,{location:L.ProgressLocation.SourceControl},(ue,Ae)=>J({report(st){}}))},withProgress(J,ue){return hn.withProgress(Le,J,ue)},createOutputChannel(J){return bn.createOutputChannel(J,Le)},createWebviewPanel(J,ue,Ae,st){return sn.createWebviewPanel(Le,J,ue,Ae,st)},createWebviewTextEditorInset(J,ue,Ae,st){return(0,$.checkProposedApiEnabled)(Le),en.createWebviewEditorInset(J,ue,Ae,st,Le)},createTerminal(J,ue,Ae){return typeof J=="object"?(J.color&&(0,$.checkProposedApiEnabled)(Le),"pty"in J?vt.createExtensionTerminal(J):vt.createTerminalFromOptions(J)):vt.createTerminal(J,ue,Ae)},registerTerminalLinkProvider(J){return vt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ue){return vt.registerProfileProvider(Le,J,ue)},registerTreeDataProvider(J,ue){return dn.registerTreeDataProvider(J,ue,Le)},createTreeView(J,ue){return dn.createTreeView(J,ue,Le)},registerWebviewPanelSerializer:(J,ue)=>sn.registerWebviewPanelSerializer(Le,J,ue),registerCustomEditorProvider:(J,ue,Ae={})=>yn.registerCustomEditorProvider(Le,J,ue,Ae),registerFileDecorationProvider(J){return Dt.registerFileDecorationProvider(J,Le.identifier)},registerUriHandler(J){return Vt.registerUriHandler(Le.identifier,J)},createQuickPick(){return Nt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Nt.createInputBox(Le.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(J,ue,Ae){return fn.onDidChangeActiveColorTheme(J,ue,Ae)},registerWebviewViewProvider(J,ue,Ae){return Sn.registerWebviewViewProvider(Le,J,ue,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Le),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeActiveNotebookEditor(J,ue,Ae)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Le),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),Wt.onDidChangeNotebookEditorSelection(J,ue,Ae)},onDidChangeNotebookEditorVisibleRanges(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),Wt.onDidChangeNotebookEditorVisibleRanges(J,ue,Ae)},showNotebookDocument(J,ue){return(0,$.checkProposedApiEnabled)(Le),gt.showNotebookDocument(J,ue)},registerExternalUriOpener(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),Gt.registerExternalUriOpener(Le.identifier,J,ue,Ae)},get openEditors(){return(0,$.checkProposedApiEnabled)(Le),kt.tabs},get onDidChangeOpenEditors(){return(0,$.checkProposedApiEnabled)(Le),kt.onDidChangeTabs},getInlineCompletionItemController(J){return(0,$.checkProposedApiEnabled)(Le),p.InlineCompletionController.get(J)}},vn={get rootPath(){return Ge.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(J){throw R.readonly()},getWorkspaceFolder(J){return ot.getWorkspaceFolder(J)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(J){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(J){throw R.readonly()},updateWorkspaceFolders:(J,ue,...Ae)=>ot.updateWorkspaceFolders(Le,J,ue||0,...Ae),onDidChangeWorkspaceFolders:function(J,ue,Ae){return ot.onDidChangeWorkspace(J,ue,Ae)},asRelativePath:(J,ue)=>ot.getRelativePath(J,ue),findFiles:(J,ue,Ae,st)=>ot.findFiles(W.GlobPattern.from(J),W.GlobPattern.from(ue),Ae,Le.identifier,st),findTextInFiles:(J,ue,Ae,st)=>{let wt,Ct;return typeof ue=="object"?(wt=ue,Ct=Ae):(wt={},Ct=ue,st=Ae),ot.findTextInFiles(J,wt||{},Ct,Le.identifier,st)},saveAll:J=>ot.saveAll(J),applyEdit(J){return Cn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ue,Ae,st)=>Mt.createFileSystemWatcher(W.GlobPattern.from(J),ue,Ae,st),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw R.readonly()},openTextDocument(J){let ue;const Ae=J;if(typeof J=="string")ue=Promise.resolve(A.URI.file(J));else if(A.URI.isUri(J))ue=Promise.resolve(J);else if(!Ae||typeof Ae=="object")ue=_t.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(J,ue,Ae)=>_t.onDidAddDocument(J,ue,Ae),onDidCloseTextDocument:(J,ue,Ae)=>_t.onDidRemoveDocument(J,ue,Ae),onDidChangeTextDocument:(J,ue,Ae)=>_t.onDidChangeDocument(J,ue,Ae),onDidSaveTextDocument:(J,ue,Ae)=>_t.onDidSaveDocument(J,ue,Ae),onWillSaveTextDocument:(J,ue,Ae)=>Jt.getOnWillSaveTextDocumentEvent(Le)(J,ue,Ae),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ue){let Ae;if(A.URI.isUri(J))Ae=J,await gt.openNotebookDocument(J);else if(typeof J=="string")Ae=A.URI.revive(await gt.createNotebookDocument({viewType:J,content:ue}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ue,Ae,st){return gt.registerNotebookSerializer(Le,J,ue,Ae,Le.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,ue,Ae,st)=>((0,$.checkProposedApiEnabled)(Le),gt.registerNotebookContentProvider(Le,J,ue,Ae,Le.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,ue,Ae)=>mn.onDidChangeConfiguration(J,ue,Ae),getConfiguration(J,ue){return ue=arguments.length===1?void 0:ue,mn.getConfiguration(J,ue,Le)},registerTextDocumentContentProvider(J,ue){return Yt.registerTextDocumentContentProvider(J,ue)},registerTaskProvider:(J,ue)=>(Ge.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Le,J,ue)),registerFileSystemProvider(J,ue,Ae){return tn.registerFileSystemProvider(Le.identifier,J,ue,Ae,Le.enableProposedApi)},get fs(){return mt.value},registerFileSearchProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),Tt.registerFileSearchProvider(J,ue)),registerTextSearchProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),Tt.registerTextSearchProvider(J,ue)),registerRemoteAuthorityResolver:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),bt.registerRemoteAuthorityResolver(J,ue)),registerResourceLabelFormatter:J=>((0,$.checkProposedApiEnabled)(Le),_n.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ue,Ae)=>Mt.onDidCreateFile(J,ue,Ae),onDidDeleteFiles:(J,ue,Ae)=>Mt.onDidDeleteFile(J,ue,Ae),onDidRenameFiles:(J,ue,Ae)=>Mt.onDidRenameFile(J,ue,Ae),onWillCreateFiles:(J,ue,Ae)=>Mt.getOnWillCreateFileEvent(Le)(J,ue,Ae),onWillDeleteFiles:(J,ue,Ae)=>Mt.getOnWillDeleteFileEvent(Le)(J,ue,Ae),onWillRenameFiles:(J,ue,Ae)=>Mt.getOnWillRenameFileEvent(Le)(J,ue,Ae),openTunnel:J=>((0,$.checkProposedApiEnabled)(Le),tt.openTunnel(Le,J).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,$.checkProposedApiEnabled)(Le),tt.getTunnels()},onDidChangeTunnels:(J,ue,Ae)=>((0,$.checkProposedApiEnabled)(Le),tt.onDidChangeTunnels(J,ue,Ae)),registerPortAttributesProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),tt.registerPortsAttributesProvider(J,ue)),registerTimelineProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),rn.registerTimelineProvider(J,ue,Le.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:J=>((0,$.checkProposedApiEnabled)(Le),ot.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ue,Ae)=>ot.onDidGrantWorkspaceTrust(J,ue,Ae)},Rn={get inputBox(){return Ge.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Le)},createSourceControl(J,ue,Ae){return jt.createSourceControl(Le,J,ue,Ae)}},Fn={createCommentController(J,ue){return En.createCommentController(Le,J,ue)}},Ln={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(J,ue,Ae){return Et.onDidStartDebugSession(J,ue,Ae)},onDidTerminateDebugSession(J,ue,Ae){return Et.onDidTerminateDebugSession(J,ue,Ae)},onDidChangeActiveDebugSession(J,ue,Ae){return Et.onDidChangeActiveDebugSession(J,ue,Ae)},onDidReceiveDebugSessionCustomEvent(J,ue,Ae){return Et.onDidReceiveDebugSessionCustomEvent(J,ue,Ae)},onDidChangeBreakpoints(J,ue,Ae){return Et.onDidChangeBreakpoints(J,ue,Ae)},registerDebugConfigurationProvider(J,ue,Ae){return Et.registerDebugConfigurationProvider(J,ue,Ae||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ue){return Et.registerDebugAdapterDescriptorFactory(Le,J,ue)},registerDebugAdapterTrackerFactory(J,ue){return Et.registerDebugAdapterTrackerFactory(J,ue)},startDebugging(J,ue,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?Et.startDebugging(J,ue,{parentSession:Ae}):Et.startDebugging(J,ue,Ae||{})},stopDebugging(J){return Et.stopDebugging(J)},addBreakpoints(J){return Et.addBreakpoints(J)},removeBreakpoints(J){return Et.removeBreakpoints(J)},asDebugSourceUri(J,ue){return Et.asDebugSourceUri(J,ue)}},Mn={registerTaskProvider:(J,ue)=>It.registerTaskProvider(Le,J,ue),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Le,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,ue,Ae)=>It.onDidStartTask(J,ue,Ae),onDidEndTask:(J,ue,Ae)=>It.onDidEndTask(J,ue,Ae),onDidStartTaskProcess:(J,ue,Ae)=>It.onDidStartTaskProcess(J,ue,Ae),onDidEndTaskProcess:(J,ue,Ae)=>It.onDidEndTaskProcess(J,ue,Ae)},Nn={createNotebookController(J,ue,Ae,st,wt){return Xt.createNotebookController(Le,J,ue,Ae,st,Le.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ue)=>gt.registerNotebookCellStatusBarItemProvider(Le,J,ue),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Le),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,$.checkProposedApiEnabled)(Le),Wt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return Zt.createRendererMessaging(Le,J)},onDidChangeNotebookDocumentMetadata(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),qt.onDidChangeNotebookDocumentMetadata(J,ue,Ae)},onDidChangeNotebookCells(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeNotebookCells(J,ue,Ae)},onDidChangeNotebookCellExecutionState(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeNotebookCellExecutionState(J,ue,Ae)},onDidChangeCellOutputs(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeCellOutputs(J,ue,Ae)},onDidChangeCellMetadata(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeCellMetadata(J,ue,Ae)},createConcatTextDocument(J,ue){return(0,$.checkProposedApiEnabled)(Le),new ve.ExtHostNotebookConcatDocument(gt,_t,J,ue)}};return{version:Qe.version,authentication:kn,commands:In,comments:Fn,debug:Ln,env:gn,extensions:ln,languages:An,notebooks:Nn,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:I.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,Task2:L.Task,TaskGroup:L.TaskGroup,TaskGroup2:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:_.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:l.UIKind,Uri:A.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(be[230],Ee([0,1,60,105,32,104,33,48,49,39,108,109,110,77,69,75,106,76,47,74,97,67]),function(ee,e,h,R,S,E,A,_,y,I,n,C,l,f,u,g,b,w,T,o,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,h.registerSingleton)(_.IExtHostCommands,_.ExtHostCommands),(0,h.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,h.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,h.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,h.registerSingleton)(E.IExtHostDecorations,E.ExtHostDecorations),(0,h.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(T.IExtHostFileSystemInfo,T.ExtHostFileSystemInfo),(0,h.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,h.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,h.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,h.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,h.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,h.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,h.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,h.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,h.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,h.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry),(0,h.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(be[231],Ee([0,1,229,34,225,7,15,5,11]),function(ee,e,h,R,S,E,A,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var I;(function(u){const g=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...T)=>{T.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const o=T.slice(0,-1).join(","),m=T.pop().toString();return`(function anonymous(${o}) {
${m}
})`}});function b(...w){return g?self.eval(g.createScript("",...w)):new Function(...w)}u.create=b})(I||(I={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(g,b){for(let w of this._alternatives){let T=w(g);if(T){g=T;break}}if(this._factories.has(g))return this._factories.get(g).load(g,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const g=this._extHostContext.getProxy(_.MainContext.MainThreadConsole);f(g,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(g){return g.browser}async _loadCommonJSModule(g,b,w){b=b.with({path:l(b.path,".js")}),g&&performance.mark(`code/extHost/willFetchExtensionCode/${g.value}`);const T=await fetch(y.FileAccess.asBrowserUri(b).toString(!0));if(g&&performance.mark(`code/extHost/didFetchExtensionCode/${g.value}`),T.status!==200)throw new Error(T.statusText);const o=await T.text(),m=`${b.toString(!0)}#vscode-extension`,v=`${o}
//# sourceURL=${m}`;let t;try{t=I.create(C._ttpExtensionScripts?.createScript("module")??"module",C._ttpExtensionScripts?.createScript("exports")??"exports",C._ttpExtensionScripts?.createScript("require")??"require",C._ttpExtensionScripts?.createScript(v)??v)}catch(c){throw console.error(g?`Loading code for extension ${g.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${b.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const r={},a={exports:r},i=c=>{const p=this._fakeModules.getModule(c,b);if(p===void 0)throw new Error(`Cannot load module '${c}'`);return p};try{return w.codeLoadingStart(),g&&performance.mark(`code/extHost/willLoadExtensionCode/${g.value}`),t(a,r,i),a.exports!==r?a.exports:r}finally{g&&performance.mark(`code/extHost/didLoadExtensionCode/${g.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(g){throw new Error("Not supported")}async _waitForDebuggerAttachment(g=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+g;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function l(u,g){return u.endsWith(g)?u:u+g}function f(u,g){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(o,m){const v=console[o];console[o]=function(){u.$logExtensionHostMessage({type:"__$console",severity:m,arguments:T(arguments)}),g&&v.apply(console,arguments)}}const w=1e5;function T(o){const m=[],v=[];if(o.length)for(let t=0;t<o.length;t++){if(typeof o[t]=="undefined")o[t]="undefined";else if(o[t]instanceof Error){const r=o[t];r.stack?o[t]=r.stack:o[t]=r.toString()}v.push(o[t])}try{const t=JSON.stringify(v,function(r,a){if(a&&typeof a=="object"){if(m.indexOf(a)!==-1)return"[Circular]";m.push(a)}return a});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[232],Ee([0,1,60,16,34,78,231,218]),function(ee,e,h,R,S,E,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(S.IExtHostExtensionService,A.ExtHostExtensionService),(0,h.registerSingleton)(R.ILogService,_.ExtHostLogService),(0,h.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(be[234],Ee([0,1,24,3,185,226,220,14,79,11,2,230,232]),function(ee,e,h,R,S,E,A,_,y,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const T=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:m=>m}),o=self.Worker;Worker=function(m,v){/^file:/i.test(m.toString())&&(m=I.FileAccess.asBrowserUri(n.URI.parse(m.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${m}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||_.basename(m.toString());const r=new Blob([t],{type:"application/javascript"}),a=URL.createObjectURL(r);return new o(T?T.createScriptURL(a):a,v)}}else self.Worker=class extends A.NestedWorker{constructor(T,o){super(l,T,{name:_.basename(T.toString()),...o})}};const f=new class{exit(T){C()}async exists(T){return!0}async realpath(T){return T}};class u{constructor(){const o=new MessageChannel,m=new R.Emitter;let v=!1;l(o.port2,[o.port2]),o.port1.onmessage=t=>{const{data:r}=t;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const a=h.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,S.isMessageOfType)(a,2)){v=!0,b("received terminate message from renderer");return}m.fire(a)},this.protocol={onMessage:m.event,send:t=>{if(!v){const r=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);o.port1.postMessage(r,[r])}}}}}function g(T){return new Promise(o=>{const m=T.onMessage(v=>{m.dispose();const t=JSON.parse(v.toString());T.send((0,S.createMessageOfType)(0)),o({protocol:T,initData:t})});T.send((0,S.createMessageOfType)(1))})}let b=T=>C();function w(){const T=new u;y.mark("code/extHost/willConnectToRenderer"),g(T.protocol).then(o=>{y.mark("code/extHost/didWaitForInitData");const m=new E.ExtensionHostMain(o.protocol,o.initData,f,null);b=v=>m.terminate(v)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/49af1cbe00271ac2ea36cfc5f7352fe31a7b0094/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
